/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var le=["require","exports","vs/base/common/lifecycle","vs/base/common/path","vs/base/common/uri","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/base/common/network","vs/nls","vs/nls!vs/server/remoteExtensionHostAgent","vs/base/common/types","vs/base/common/errors","vs/base/common/strings","vs/base/common/async","vs/base/node/pfs","vs/platform/log/common/log","vs/base/common/resources","vs/base/common/buffer","vs/base/common/objects","vs/platform/files/common/files","vs/base/common/arrays","vs/base/common/uuid","vs/base/common/process","os","fs","vs/base/common/map","vs/platform/environment/common/environment","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/base/common/extpath","vs/platform/product/common/product","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","child_process","vs/base/parts/ipc/common/ipc","vs/base/common/json","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetry","vs/server/remoteUriTransformer","vs/base/common/codicons","vs/base/common/stream","vs/base/common/errorMessage","vs/platform/extensions/common/extensions","vs/platform/product/common/productService","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/performance","vs/base/common/semver/semver","vs/base/parts/ipc/node/ipc.net","vs/base/common/iterator","vs/base/common/labels","vs/base/common/uriIpc","vs/editor/common/core/range","vs/base/parts/ipc/node/ipc.cp","vs/platform/environment/node/argv","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/contextkey/common/contextkey","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","crypto","vs/platform/files/node/diskFileSystemProvider","vs/platform/request/common/request","url","vs/platform/telemetry/common/telemetryUtils","vs/server/serverEnvironmentService","vs/workbench/services/editor/common/editorService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/functional","vs/base/common/linkedList","vs/base/common/severity","vs/base/common/htmlContent","vs/base/common/normalization","vs/base/common/mime","vs/base/node/decoder","path","vs/base/node/id","net","vs/base/node/powershell","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/editor/common/core/position","vs/base/node/processes","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/instantiationService","vs/platform/localizations/node/localizations","vs/platform/log/common/logIpc","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/files/common/fileService","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/server/remoteLanguagePacks","vs/workbench/api/common/extHostTypes","vs/workbench/contrib/terminal/common/environmentVariable","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/remote/common/remoteAgentService","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","vs/server/extensionHostConnection","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/processes","vs/base/common/stopwatch","vs/base/common/hash","vs/base/common/console","vs/base/common/filters","vs/base/common/iconLabels","vs/base/node/languagePacks","vs/base/node/macAddress","util","vs/base/node/extpath","vs/base/node/ports","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/editor/common/modes/languageSelector","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/server/remoteAgentEnvironmentImpl","vs/nls!vs/server/serverEnvironmentService","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/node/extensionPoints","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/download/common/downloadIpc","vs/platform/editor/common/editor","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/common/ipcFileSystemProvider","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/editor/common/modes","vs/platform/diagnostics/common/diagnostics","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/argvHelper","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/label/common/label","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/markers/common/markers","vs/platform/notification/common/notification","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/request/common/requestIpc","vs/platform/request/node/proxy","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/errorTelemetry","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/errorTelemetry","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/workspaces/common/workspaces","vs/server/remoteExtensionManagement","vs/server/remoteAgentFileSystemImpl","vs/server/webClientServer","vs/workbench/api/common/extHostRpcService","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/terminal/common/environmentVariableCollection","vs/workbench/contrib/terminal/common/terminalEnvironment","vs/workbench/services/configuration/common/configuration","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/api/common/extHostTypeConverters","vs/workbench/common/editor","vs/workbench/contrib/terminal/common/remoteTerminalChannel","vs/workbench/services/extensions/common/extensionPoints","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostCommands","vs/workbench/services/extensions/node/extensionPoints","vs/server/remoteAgentEnvironmentImpl","vs/workbench/services/remote/common/remoteAgentFileSystemChannel","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","zlib","vs/server/remoteExtensionHostAgentCli","vs/workbench/api/node/extHostCLIServer","vs/server/remoteTerminalChannel","vs/server/remoteExtensionHostAgentServer","perf_hooks","string_decoder","minimist","assert","cookie","vs/base/common/marked/marked","yauzl","yazl","http","vs/server/remoteExtensionHostAgent"],ce=function(x){for(var e=[],E=0,P=x.length;E<P;E++)e[E]=le[x[E]];return e};define(le[110],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoaderStats=void 0;class E{static get(){const p=new Map,D=new Map,I=new Map,_=new Map;function m(b,f){b.has(f.detail)||b.set(f.detail,-f.timestamp)}function y(b,f){let c=b.get(f.detail);!c||c>=0||b.set(f.detail,c+f.timestamp)}const r=x.getStats().slice(0).sort((b,f)=>b.timestamp-f.timestamp);for(const b of r)switch(b.type){case 10:m(p,b);break;case 11:case 12:y(p,b);break;case 21:m(D,b);break;case 22:y(D,b);break;case 33:m(I,b);break;case 34:y(I,b);break;case 31:m(_,b);break;case 32:y(_,b);break}let k=0;I.forEach(b=>k+=b);function d(b){let f=[];return b.forEach((c,S)=>f.push([S,c])),f}return{amdLoad:d(p),amdInvoke:d(D),nodeRequire:d(I),nodeEval:d(_),nodeRequireTotal:k}}static toMarkdownTable(p,D){let I="",_=[];return p.forEach((m,y)=>{_[y]=m.length}),D.forEach(m=>{m.forEach((y,r)=>{typeof y=="undefined"&&(y=m[r]="-");const k=y.toString().length;_[r]=Math.max(k,_[r])})}),p.forEach((m,y)=>{I+=`| ${m+" ".repeat(_[y]-m.toString().length)} `}),I+=`|
`,p.forEach((m,y)=>{I+=`| ${"-".repeat(_[y])} `}),I+=`|
`,D.forEach(m=>{m.forEach((y,r)=>{typeof y!="undefined"&&(I+=`| ${y+" ".repeat(_[r]-y.toString().length)} `)}),I+=`|
`}),I}}e.LoaderStats=E}),define(le[111],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function E(P,p){if(!P)throw new Error(p?`Assertion failed (${p})`:"Assertion Failed")}e.ok=E}),define(le[70],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function E(I){return(_,m,y)=>{let r=null,k=null;if(typeof y.value=="function"?(r="value",k=y.value):typeof y.get=="function"&&(r="get",k=y.get),!k)throw new Error("not supported");y[r]=I(k,m)}}e.createDecorator=E;function P(I,_,m){let y=null,r=null;if(typeof m.value=="function"?(y="value",r=m.value,r.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(y="get",r=m.get),!r)throw new Error("not supported");const k=`$memoize$${_}`;m[y]=function(...d){return this.hasOwnProperty(k)||Object.defineProperty(this,k,{configurable:!1,enumerable:!1,writable:!1,value:r.apply(this,d)}),this[k]}}e.memoize=P;function p(I,_,m){return E((y,r)=>{const k=`$debounce$${r}`,d=`$debounce$result$${r}`;return function(...b){this[d]||(this[d]=m?m():void 0),clearTimeout(this[k]),_&&(this[d]=_(this[d],...b),b=[this[d]]),this[k]=setTimeout(()=>{y.apply(this,b),this[d]=m?m():void 0},I)}})}e.debounce=p;function D(I,_,m){return E((y,r)=>{const k=`$throttle$timer$${r}`,d=`$throttle$result$${r}`,b=`$throttle$lastRun$${r}`,f=`$throttle$pending$${r}`;return function(...c){if(this[d]||(this[d]=m?m():void 0),(this[b]===null||this[b]===void 0)&&(this[b]=-Number.MAX_VALUE),_&&(this[d]=_(this[d],...c)),this[f])return;const S=this[b]+I;S<=Date.now()?(this[b]=Date.now(),y.apply(this,[this[d]]),this[d]=m?m():void 0):(this[f]=!0,this[k]=setTimeout(()=>{this[f]=!1,this[b]=Date.now(),y.apply(this,[this[d]]),this[d]=m?m():void 0},S-Date.now()))}})}e.throttle=D}),define(le[12],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(t){setTimeout(()=>{throw t.stack?new Error(t.message+`

`+t.stack):t},0)}}addListener(t){return this.listeners.push(t),()=>{this._removeListener(t)}}emit(t){this.listeners.forEach(i=>{i(t)})}_removeListener(t){this.listeners.splice(this.listeners.indexOf(t),1)}setUnexpectedErrorHandler(t){this.unexpectedErrorHandler=t}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(t){this.unexpectedErrorHandler(t),this.emit(t)}onUnexpectedExternalError(t){this.unexpectedErrorHandler(t)}}e.ErrorHandler=E,e.errorHandler=new E;function P(a){e.errorHandler.setUnexpectedErrorHandler(a)}e.setUnexpectedErrorHandler=P;function p(a){m(a)||e.errorHandler.onUnexpectedError(a)}e.onUnexpectedError=p;function D(a){m(a)||e.errorHandler.onUnexpectedExternalError(a)}e.onUnexpectedExternalError=D;function I(a){if(a instanceof Error){let{name:t,message:i}=a;const n=a.stacktrace||a.stack;return{$isError:!0,name:t,message:i,stack:n}}return a}e.transformErrorForSerialization=I;const _="Canceled";function m(a){return a instanceof Error&&a.name===_&&a.message===_}e.isPromiseCanceledError=m;class y extends Error{constructor(){super(_);this.name=this.message}}e.CancellationError=y;function r(){const a=new Error(_);return a.name=a.message,a}e.canceled=r;function k(a){return a?new Error(`Illegal argument: ${a}`):new Error("Illegal argument")}e.illegalArgument=k;function d(a){return a?new Error(`Illegal state: ${a}`):new Error("Illegal state")}e.illegalState=d;function b(a){return a?new Error(`readonly property '${a} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=b;function f(a){const t=new Error(`${a} has been disposed`);return t.name="DISPOSED",t}e.disposed=f;function c(a){return a?a.message?a.message:a.stack?a.stack.split(`
`)[0]:String(a):"Error"}e.getErrorMessage=c;class S extends Error{constructor(t){super("NotImplemented");t&&(this.message=t)}}e.NotImplementedError=S;class w extends Error{constructor(t){super("NotSupported");t&&(this.message=t)}}e.NotSupportedError=w;class C extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=C;function h(a){const t=a;return t instanceof Error&&Array.isArray(t.actions)}e.isErrorWithActions=h;function l(a,t=Object.create(null)){const i=new Error(a);return t.actions&&(i.actions=t.actions),i}e.createErrorWithActions=l}),define(le[21],ce([0,1,12]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.maxIndex=e.minIndex=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function P(z,L=0){return z[z.length-(1+L)]}e.tail=P;function p(z){if(z.length===0)throw new Error("Invalid tail call");return[z.slice(0,z.length-1),z[z.length-1]]}e.tail2=p;function D(z,L,A=(N,M)=>N===M){if(z===L)return!0;if(!z||!L||z.length!==L.length)return!1;for(let N=0,M=z.length;N<M;N++)if(!A(z[N],L[N]))return!1;return!0}e.equals=D;function I(z,L,A){let N=0,M=z.length-1;for(;N<=M;){const W=(N+M)/2|0,X=A(z[W],L);if(X<0)N=W+1;else if(X>0)M=W-1;else return W}return-(N+1)}e.binarySearch=I;function _(z,L){let A=0,N=z.length;if(N===0)return 0;for(;A<N;){const M=Math.floor((A+N)/2);L(z[M])?N=M:A=M+1}return A}e.findFirstInSorted=_;function m(z,L,A){if(z=z|0,z>=L.length)throw new TypeError("invalid index");let N=L[Math.floor(L.length*Math.random())],M=[],W=[],X=[];for(let ae of L){const se=A(ae,N);se<0?M.push(ae):se>0?W.push(ae):X.push(ae)}return z<M.length?m(z,M,A):z<M.length+X.length?X[0]:m(z-(M.length+X.length),W,A)}e.quickSelect=m;function y(z,L){const A=[];let N;for(const M of z.slice(0).sort(L))!N||L(N[0],M)!==0?(N=[M],A.push(N)):N.push(M);return A}e.groupBy=y;function r(z,L,A){const N=[];function M(ae,se,be){if(se===0&&be.length===0)return;const ke=N[N.length-1];ke&&ke.start+ke.deleteCount===ae?(ke.deleteCount+=se,ke.toInsert.push(...be)):N.push({start:ae,deleteCount:se,toInsert:be})}let W=0,X=0;for(;;){if(W===z.length){M(W,0,L.slice(X));break}if(X===L.length){M(W,z.length-W,[]);break}const ae=z[W],se=L[X],be=A(ae,se);be===0?(W+=1,X+=1):be<0?(M(W,1,[]),W+=1):be>0&&(M(W,0,[se]),X+=1)}return N}e.sortedDiff=r;function k(z,L,A){const N=r(z,L,A),M=[],W=[];for(const X of N)M.push(...z.slice(X.start,X.start+X.deleteCount)),W.push(...X.toInsert);return{removed:M,added:W}}e.delta=k;function d(z,L,A){if(A===0)return[];const N=z.slice(0,A).sort(L);return f(z,L,N,A,z.length),N}e.top=d;function b(z,L,A,N,M){return A===0?Promise.resolve([]):new Promise((W,X)=>{(async()=>{const ae=z.length,se=z.slice(0,A).sort(L);for(let be=A,ke=Math.min(A+N,ae);be<ae;be=ke,ke=Math.min(ke+N,ae)){if(be>A&&await new Promise(Te=>setTimeout(Te)),M&&M.isCancellationRequested)throw E.canceled();f(z,L,se,be,ke)}return se})().then(W,X)})}e.topAsync=b;function f(z,L,A,N,M){for(const W=A.length;N<M;N++){const X=z[N];if(L(X,A[W-1])<0){A.pop();const ae=_(A,se=>L(X,se)<0);A.splice(ae,0,X)}}}function c(z){return z.filter(L=>!!L)}e.coalesce=c;function S(z){let L=0;for(let A=0;A<z.length;A++)z[A]&&(z[L]=z[A],L+=1);z.length=L}e.coalesceInPlace=S;function w(z,L,A){z.splice(A,0,z.splice(L,1)[0])}e.move=w;function C(z){return!Array.isArray(z)||z.length===0}e.isFalsyOrEmpty=C;function h(z){return Array.isArray(z)&&z.length>0}e.isNonEmptyArray=h;function l(z,L){if(!L)return z.filter((N,M)=>z.indexOf(N)===M);const A=Object.create(null);return z.filter(N=>{const M=L(N);return A[M]?!1:(A[M]=!0,!0)})}e.distinct=l;function a(z){const L=new Set;return z.filter(A=>L.has(A)?!1:(L.add(A),!0))}e.distinctES6=a;function t(z){const L=Object.create(null);return A=>{const N=z(A);return L[N]?!1:(L[N]=!0,!0)}}e.uniqueFilter=t;function i(z,L){for(let A=z.length-1;A>=0;A--){const N=z[A];if(L(N))return A}return-1}e.lastIndex=i;function n(z,L){return z.length>0?z[0]:L}e.firstOrDefault=n;function s(z,L,A=(N,M)=>N===M){let N=0;for(let M=0,W=Math.min(z.length,L.length);M<W&&A(z[M],L[M]);M++)N++;return N}e.commonPrefixLength=s;function u(z){return[].concat(...z)}e.flatten=u;function g(z,L){let A=typeof L=="number"?z:0;typeof L=="number"?A=z:(A=0,L=z);const N=[];if(A<=L)for(let M=A;M<L;M++)N.push(M);else for(let M=A;M>L;M--)N.push(M);return N}e.range=g;function v(z,L,A){return z.reduce((N,M)=>(N[L(M)]=A?A(M):M,N),Object.create(null))}e.index=v;function T(z,L){return z.push(L),()=>R(z,L)}e.insert=T;function R(z,L){const A=z.indexOf(L);if(A>-1)return z.splice(A,1),L}e.remove=R;function o(z,L,A){const N=z.slice(0,L),M=z.slice(L);return N.concat(A,M)}e.arrayInsert=o;function F(z,L){let A;if(typeof L=="number"){let N=L;A=()=>{const M=Math.sin(N++)*179426549;return M-Math.floor(M)}}else A=Math.random;for(let N=z.length-1;N>0;N-=1){const M=Math.floor(A()*(N+1)),W=z[N];z[N]=z[M],z[M]=W}}e.shuffle=F;function B(z,L){const A=z.indexOf(L);A>-1&&(z.splice(A,1),z.unshift(L))}e.pushToStart=B;function Z(z,L){const A=z.indexOf(L);A>-1&&(z.splice(A,1),z.push(L))}e.pushToEnd=Z;function ie(z,L){return Array.isArray(z)?z.map(L):L(z)}e.mapArrayOrNot=ie;function Se(z){return Array.isArray(z)?z:[z]}e.asArray=Se;function oe(z){return z[Math.floor(Math.random()*z.length)]}e.getRandomElement=oe;function q(z,L){for(const A of z){const N=L(A);if(N!==void 0)return N}}e.mapFind=q;function ee(z,L){let A=Number.MAX_SAFE_INTEGER,N=0;return z.forEach((M,W)=>{const X=L(M);X<A&&(A=X,N=W)}),N}e.minIndex=ee;function G(z,L){let A=Number.MIN_SAFE_INTEGER,N=0;return z.forEach((M,W)=>{const X=L(M);X>A&&(A=X,N=W)}),N}e.maxIndex=G}),define(le[71],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function E(P){const p=this;let D=!1,I;return function(){return D||(D=!0,I=P.apply(p,arguments)),I}}e.once=E}),define(le[51],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var E;(function(P){function p(a){return a&&typeof a=="object"&&typeof a[Symbol.iterator]=="function"}P.is=p;const D=Object.freeze([]);function I(){return D}P.empty=I;function*_(a){yield a}P.single=_;function m(a){return a||D}P.from=m;function y(a){return!a||a[Symbol.iterator]().next().done===!0}P.isEmpty=y;function r(a){return a[Symbol.iterator]().next().value}P.first=r;function k(a,t){for(const i of a)if(t(i))return!0;return!1}P.some=k;function d(a,t){for(const i of a)if(t(i))return i}P.find=d;function*b(a,t){for(const i of a)t(i)&&(yield i)}P.filter=b;function*f(a,t){let i=0;for(const n of a)yield t(n,i++)}P.map=f;function*c(...a){for(const t of a)for(const i of t)yield i}P.concat=c;function*S(a){for(const t of a)for(const i of t)yield i}P.concatNested=S;function w(a,t,i){let n=i;for(const s of a)n=t(n,s);return n}P.reduce=w;function*C(a,t,i=a.length){for(t<0&&(t+=a.length),i<0?i+=a.length:i>a.length&&(i=a.length);t<i;t++)yield a[t]}P.slice=C;function h(a,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,a];const n=a[Symbol.iterator]();for(let s=0;s<t;s++){const u=n.next();if(u.done)return[i,P.empty()];i.push(u.value)}return[i,{[Symbol.iterator](){return n}}]}P.consume=h;function l(a,t,i=(n,s)=>n===s){const n=a[Symbol.iterator](),s=t[Symbol.iterator]();for(;;){const u=n.next(),g=s.next();if(u.done!==g.done)return!1;if(u.done)return!0;if(!i(u.value,g.value))return!1}}P.equals=l})(E=e.Iterable||(e.Iterable={}))}),define(le[37],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var E;(function(t){t[t.None=0]="None",t[t.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=2]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",t[t.InvalidUnicode=4]="InvalidUnicode",t[t.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",t[t.InvalidCharacter=6]="InvalidCharacter"})(E=e.ScanError||(e.ScanError={}));var P;(function(t){t[t.OpenBraceToken=1]="OpenBraceToken",t[t.CloseBraceToken=2]="CloseBraceToken",t[t.OpenBracketToken=3]="OpenBracketToken",t[t.CloseBracketToken=4]="CloseBracketToken",t[t.CommaToken=5]="CommaToken",t[t.ColonToken=6]="ColonToken",t[t.NullKeyword=7]="NullKeyword",t[t.TrueKeyword=8]="TrueKeyword",t[t.FalseKeyword=9]="FalseKeyword",t[t.StringLiteral=10]="StringLiteral",t[t.NumericLiteral=11]="NumericLiteral",t[t.LineCommentTrivia=12]="LineCommentTrivia",t[t.BlockCommentTrivia=13]="BlockCommentTrivia",t[t.LineBreakTrivia=14]="LineBreakTrivia",t[t.Trivia=15]="Trivia",t[t.Unknown=16]="Unknown",t[t.EOF=17]="EOF"})(P=e.SyntaxKind||(e.SyntaxKind={}));var p;(function(t){t[t.InvalidSymbol=1]="InvalidSymbol",t[t.InvalidNumberFormat=2]="InvalidNumberFormat",t[t.PropertyNameExpected=3]="PropertyNameExpected",t[t.ValueExpected=4]="ValueExpected",t[t.ColonExpected=5]="ColonExpected",t[t.CommaExpected=6]="CommaExpected",t[t.CloseBraceExpected=7]="CloseBraceExpected",t[t.CloseBracketExpected=8]="CloseBracketExpected",t[t.EndOfFileExpected=9]="EndOfFileExpected",t[t.InvalidCommentToken=10]="InvalidCommentToken",t[t.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",t[t.UnexpectedEndOfString=12]="UnexpectedEndOfString",t[t.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",t[t.InvalidUnicode=14]="InvalidUnicode",t[t.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",t[t.InvalidCharacter=16]="InvalidCharacter"})(p=e.ParseErrorCode||(e.ParseErrorCode={}));var D;(function(t){t.DEFAULT={allowTrailingComma:!0}})(D=e.ParseOptions||(e.ParseOptions={}));function I(t,i=!1){let n=0,s=t.length,u="",g=0,v=16,T=0;function R(oe){let q=0,ee=0;for(;q<oe;){const G=t.charCodeAt(n);if(G>=48&&G<=57)ee=ee*16+G-48;else if(G>=65&&G<=70)ee=ee*16+G-65+10;else if(G>=97&&G<=102)ee=ee*16+G-97+10;else break;n++,q++}return q<oe&&(ee=-1),ee}function o(oe){n=oe,u="",g=0,v=16,T=0}function F(){const oe=n;if(t.charCodeAt(n)===48)n++;else for(n++;n<t.length&&y(t.charCodeAt(n));)n++;if(n<t.length&&t.charCodeAt(n)===46)if(n++,n<t.length&&y(t.charCodeAt(n)))for(n++;n<t.length&&y(t.charCodeAt(n));)n++;else return T=3,t.substring(oe,n);let q=n;if(n<t.length&&(t.charCodeAt(n)===69||t.charCodeAt(n)===101))if(n++,(n<t.length&&t.charCodeAt(n)===43||t.charCodeAt(n)===45)&&n++,n<t.length&&y(t.charCodeAt(n))){for(n++;n<t.length&&y(t.charCodeAt(n));)n++;q=n}else T=3;return t.substring(oe,q)}function B(){let oe="",q=n;for(;;){if(n>=s){oe+=t.substring(q,n),T=2;break}const ee=t.charCodeAt(n);if(ee===34){oe+=t.substring(q,n),n++;break}if(ee===92){if(oe+=t.substring(q,n),n++,n>=s){T=2;break}switch(t.charCodeAt(n++)){case 34:oe+='"';break;case 92:oe+="\\";break;case 47:oe+="/";break;case 98:oe+="\b";break;case 102:oe+="\f";break;case 110:oe+=`
`;break;case 114:oe+="\r";break;case 116:oe+="	";break;case 117:const z=R(4);z>=0?oe+=String.fromCharCode(z):T=4;break;default:T=5}q=n;continue}if(ee>=0&&ee<=31)if(m(ee)){oe+=t.substring(q,n),T=2;break}else T=6;n++}return oe}function Z(){if(u="",T=0,g=n,n>=s)return g=s,v=17;let oe=t.charCodeAt(n);if(_(oe)){do n++,u+=String.fromCharCode(oe),oe=t.charCodeAt(n);while(_(oe));return v=15}if(m(oe))return n++,u+=String.fromCharCode(oe),oe===13&&t.charCodeAt(n)===10&&(n++,u+=`
`),v=14;switch(oe){case 123:return n++,v=1;case 125:return n++,v=2;case 91:return n++,v=3;case 93:return n++,v=4;case 58:return n++,v=6;case 44:return n++,v=5;case 34:return n++,u=B(),v=10;case 47:const q=n-1;if(t.charCodeAt(n+1)===47){for(n+=2;n<s&&!m(t.charCodeAt(n));)n++;return u=t.substring(q,n),v=12}if(t.charCodeAt(n+1)===42){n+=2;const ee=s-1;let G=!1;for(;n<ee;){if(t.charCodeAt(n)===42&&t.charCodeAt(n+1)===47){n+=2,G=!0;break}n++}return G||(n++,T=1),u=t.substring(q,n),v=13}return u+=String.fromCharCode(oe),n++,v=16;case 45:if(u+=String.fromCharCode(oe),n++,n===s||!y(t.charCodeAt(n)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return u+=F(),v=11;default:for(;n<s&&ie(oe);)n++,oe=t.charCodeAt(n);if(g!==n){switch(u=t.substring(g,n),u){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return u+=String.fromCharCode(oe),n++,v=16}}function ie(oe){if(_(oe)||m(oe))return!1;switch(oe){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Se(){let oe;do oe=Z();while(oe>=12&&oe<=15);return oe}return{setPosition:o,getPosition:()=>n,scan:i?Se:Z,getToken:()=>v,getTokenValue:()=>u,getTokenOffset:()=>g,getTokenLength:()=>n-g,getTokenError:()=>T}}e.createScanner=I;function _(t){return t===32||t===9||t===11||t===12||t===160||t===5760||t>=8192&&t<=8203||t===8239||t===8287||t===12288||t===65279}function m(t){return t===10||t===13||t===8232||t===8233}function y(t){return t>=48&&t<=57}var r;(function(t){t[t.nullCharacter=0]="nullCharacter",t[t.maxAsciiCharacter=127]="maxAsciiCharacter",t[t.lineFeed=10]="lineFeed",t[t.carriageReturn=13]="carriageReturn",t[t.lineSeparator=8232]="lineSeparator",t[t.paragraphSeparator=8233]="paragraphSeparator",t[t.nextLine=133]="nextLine",t[t.space=32]="space",t[t.nonBreakingSpace=160]="nonBreakingSpace",t[t.enQuad=8192]="enQuad",t[t.emQuad=8193]="emQuad",t[t.enSpace=8194]="enSpace",t[t.emSpace=8195]="emSpace",t[t.threePerEmSpace=8196]="threePerEmSpace",t[t.fourPerEmSpace=8197]="fourPerEmSpace",t[t.sixPerEmSpace=8198]="sixPerEmSpace",t[t.figureSpace=8199]="figureSpace",t[t.punctuationSpace=8200]="punctuationSpace",t[t.thinSpace=8201]="thinSpace",t[t.hairSpace=8202]="hairSpace",t[t.zeroWidthSpace=8203]="zeroWidthSpace",t[t.narrowNoBreakSpace=8239]="narrowNoBreakSpace",t[t.ideographicSpace=12288]="ideographicSpace",t[t.mathematicalSpace=8287]="mathematicalSpace",t[t.ogham=5760]="ogham",t[t._=95]="_",t[t.$=36]="$",t[t._0=48]="_0",t[t._1=49]="_1",t[t._2=50]="_2",t[t._3=51]="_3",t[t._4=52]="_4",t[t._5=53]="_5",t[t._6=54]="_6",t[t._7=55]="_7",t[t._8=56]="_8",t[t._9=57]="_9",t[t.a=97]="a",t[t.b=98]="b",t[t.c=99]="c",t[t.d=100]="d",t[t.e=101]="e",t[t.f=102]="f",t[t.g=103]="g",t[t.h=104]="h",t[t.i=105]="i",t[t.j=106]="j",t[t.k=107]="k",t[t.l=108]="l",t[t.m=109]="m",t[t.n=110]="n",t[t.o=111]="o",t[t.p=112]="p",t[t.q=113]="q",t[t.r=114]="r",t[t.s=115]="s",t[t.t=116]="t",t[t.u=117]="u",t[t.v=118]="v",t[t.w=119]="w",t[t.x=120]="x",t[t.y=121]="y",t[t.z=122]="z",t[t.A=65]="A",t[t.B=66]="B",t[t.C=67]="C",t[t.D=68]="D",t[t.E=69]="E",t[t.F=70]="F",t[t.G=71]="G",t[t.H=72]="H",t[t.I=73]="I",t[t.J=74]="J",t[t.K=75]="K",t[t.L=76]="L",t[t.M=77]="M",t[t.N=78]="N",t[t.O=79]="O",t[t.P=80]="P",t[t.Q=81]="Q",t[t.R=82]="R",t[t.S=83]="S",t[t.T=84]="T",t[t.U=85]="U",t[t.V=86]="V",t[t.W=87]="W",t[t.X=88]="X",t[t.Y=89]="Y",t[t.Z=90]="Z",t[t.ampersand=38]="ampersand",t[t.asterisk=42]="asterisk",t[t.at=64]="at",t[t.backslash=92]="backslash",t[t.bar=124]="bar",t[t.caret=94]="caret",t[t.closeBrace=125]="closeBrace",t[t.closeBracket=93]="closeBracket",t[t.closeParen=41]="closeParen",t[t.colon=58]="colon",t[t.comma=44]="comma",t[t.dot=46]="dot",t[t.doubleQuote=34]="doubleQuote",t[t.equals=61]="equals",t[t.exclamation=33]="exclamation",t[t.greaterThan=62]="greaterThan",t[t.lessThan=60]="lessThan",t[t.minus=45]="minus",t[t.openBrace=123]="openBrace",t[t.openBracket=91]="openBracket",t[t.openParen=40]="openParen",t[t.percent=37]="percent",t[t.plus=43]="plus",t[t.question=63]="question",t[t.semicolon=59]="semicolon",t[t.singleQuote=39]="singleQuote",t[t.slash=47]="slash",t[t.tilde=126]="tilde",t[t.backspace=8]="backspace",t[t.formFeed=12]="formFeed",t[t.byteOrderMark=65279]="byteOrderMark",t[t.tab=9]="tab",t[t.verticalTab=11]="verticalTab"})(r||(r={}));function k(t,i){const n=[],s=new Object;let u;const g={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function T(R,o,F,B){g.value=R,g.offset=o,g.length=F,g.type=B,g.colonOffset=void 0,u=g}try{h(t,{onObjectBegin:(R,o)=>{if(i<=R)throw s;u=void 0,v=i>R,n.push("")},onObjectProperty:(R,o,F)=>{if(i<o||(T(R,o,F,"property"),n[n.length-1]=R,i<=o+F))throw s},onObjectEnd:(R,o)=>{if(i<=R)throw s;u=void 0,n.pop()},onArrayBegin:(R,o)=>{if(i<=R)throw s;u=void 0,n.push(0)},onArrayEnd:(R,o)=>{if(i<=R)throw s;u=void 0,n.pop()},onLiteralValue:(R,o,F)=>{if(i<o||(T(R,o,F,a(R)),i<=o+F))throw s},onSeparator:(R,o,F)=>{if(i<=o)throw s;if(R===":"&&u&&u.type==="property")u.colonOffset=o,v=!1,u=void 0;else if(R===","){const B=n[n.length-1];typeof B=="number"?n[n.length-1]=B+1:(v=!0,n[n.length-1]=""),u=void 0}}})}catch(R){if(R!==s)throw R}return{path:n,previousNode:u,isAtPropertyKey:v,matches:R=>{let o=0;for(let F=0;o<R.length&&F<n.length;F++)if(R[o]===n[F]||R[o]==="*")o++;else if(R[o]!=="**")return!1;return o===R.length}}}e.getLocation=k;function d(t,i=[],n=D.DEFAULT){let s=null,u=[];const g=[];function v(R){Array.isArray(u)?u.push(R):s!==null&&(u[s]=R)}return h(t,{onObjectBegin:()=>{const R={};v(R),g.push(u),u=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{u=g.pop()},onArrayBegin:()=>{const R=[];v(R),g.push(u),u=R,s=null},onArrayEnd:()=>{u=g.pop()},onLiteralValue:v,onError:(R,o,F)=>{i.push({error:R,offset:o,length:F})}},n),u[0]}e.parse=d;function b(t,i=[],n=D.DEFAULT){let s={type:"array",offset:-1,length:-1,children:[],parent:void 0};function u(R){s.type==="property"&&(s.length=R-s.offset,s=s.parent)}function g(R){return s.children.push(R),R}h(t,{onObjectBegin:R=>{s=g({type:"object",offset:R,length:-1,parent:s,children:[]})},onObjectProperty:(R,o,F)=>{s=g({type:"property",offset:o,length:-1,parent:s,children:[]}),s.children.push({type:"string",value:R,offset:o,length:F,parent:s})},onObjectEnd:(R,o)=>{s.length=R+o-s.offset,s=s.parent,u(R+o)},onArrayBegin:(R,o)=>{s=g({type:"array",offset:R,length:-1,parent:s,children:[]})},onArrayEnd:(R,o)=>{s.length=R+o-s.offset,s=s.parent,u(R+o)},onLiteralValue:(R,o,F)=>{g({type:a(R),offset:o,length:F,parent:s,value:R}),u(o+F)},onSeparator:(R,o,F)=>{s.type==="property"&&(R===":"?s.colonOffset=o:R===","&&u(o))},onError:(R,o,F)=>{i.push({error:R,offset:o,length:F})}},n);const T=s.children[0];return T&&delete T.parent,T}e.parseTree=b;function f(t,i){if(!t)return;let n=t;for(let s of i)if(typeof s=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let u=!1;for(const g of n.children)if(Array.isArray(g.children)&&g.children[0].value===s){n=g.children[1],u=!0;break}if(!u)return}else{const u=s;if(n.type!=="array"||u<0||!Array.isArray(n.children)||u>=n.children.length)return;n=n.children[u]}return n}e.findNodeAtLocation=f;function c(t){if(!t.parent||!t.parent.children)return[];const i=c(t.parent);if(t.parent.type==="property"){const n=t.parent.children[0].value;i.push(n)}else if(t.parent.type==="array"){const n=t.parent.children.indexOf(t);n!==-1&&i.push(n)}return i}e.getNodePath=c;function S(t){switch(t.type){case"array":return t.children.map(S);case"object":const i=Object.create(null);for(let n of t.children){const s=n.children[1];s&&(i[n.children[0].value]=S(s))}return i;case"null":case"string":case"number":case"boolean":return t.value;default:return}}e.getNodeValue=S;function w(t,i,n=!1){return i>=t.offset&&i<t.offset+t.length||n&&i===t.offset+t.length}e.contains=w;function C(t,i,n=!1){if(w(t,i,n)){const s=t.children;if(Array.isArray(s))for(let u=0;u<s.length&&s[u].offset<=i;u++){const g=C(s[u],i,n);if(g)return g}return t}}e.findNodeAtOffset=C;function h(t,i,n=D.DEFAULT){const s=I(t,!1);function u(X){return X?()=>X(s.getTokenOffset(),s.getTokenLength()):()=>!0}function g(X){return X?ae=>X(ae,s.getTokenOffset(),s.getTokenLength()):()=>!0}const v=u(i.onObjectBegin),T=g(i.onObjectProperty),R=u(i.onObjectEnd),o=u(i.onArrayBegin),F=u(i.onArrayEnd),B=g(i.onLiteralValue),Z=g(i.onSeparator),ie=u(i.onComment),Se=g(i.onError),oe=n&&n.disallowComments,q=n&&n.allowTrailingComma;function ee(){for(;;){const X=s.scan();switch(s.getTokenError()){case 4:G(14);break;case 5:G(15);break;case 3:G(13);break;case 1:oe||G(11);break;case 2:G(12);break;case 6:G(16);break}switch(X){case 12:case 13:oe?G(10):ie();break;case 16:G(1);break;case 15:case 14:break;default:return X}}}function G(X,ae=[],se=[]){if(Se(X),ae.length+se.length>0){let be=s.getToken();for(;be!==17;){if(ae.indexOf(be)!==-1){ee();break}else if(se.indexOf(be)!==-1)break;be=ee()}}}function z(X){const ae=s.getTokenValue();return X?B(ae):T(ae),ee(),!0}function L(){switch(s.getToken()){case 11:let X=0;try{X=JSON.parse(s.getTokenValue()),typeof X!="number"&&(G(2),X=0)}catch(ae){G(2)}B(X);break;case 7:B(null);break;case 8:B(!0);break;case 9:B(!1);break;default:return!1}return ee(),!0}function A(){return s.getToken()!==10?(G(3,[],[2,5]),!1):(z(!1),s.getToken()===6?(Z(":"),ee(),W()||G(4,[],[2,5])):G(5,[],[2,5]),!0)}function N(){v(),ee();let X=!1;for(;s.getToken()!==2&&s.getToken()!==17;){if(s.getToken()===5){if(X||G(4,[],[]),Z(","),ee(),s.getToken()===2&&q)break}else X&&G(6,[],[]);A()||G(4,[],[2,5]),X=!0}return R(),s.getToken()!==2?G(7,[2],[]):ee(),!0}function M(){o(),ee();let X=!1;for(;s.getToken()!==4&&s.getToken()!==17;){if(s.getToken()===5){if(X||G(4,[],[]),Z(","),ee(),s.getToken()===4&&q)break}else X&&G(6,[],[]);W()||G(4,[],[4,5]),X=!0}return F(),s.getToken()!==4?G(8,[4],[]):ee(),!0}function W(){switch(s.getToken()){case 3:return M();case 1:return N();case 10:return z(!0);default:return L()}}return ee(),s.getToken()===17?n.allowEmptyContent?!0:(G(4,[],[]),!1):W()?(s.getToken()!==17&&G(9,[],[]),!0):(G(4,[],[]),!1)}e.visit=h;function l(t,i){let n=I(t),s=[],u,g=0,v;do switch(v=n.getPosition(),u=n.scan(),u){case 12:case 13:case 17:g!==v&&s.push(t.substring(g,v)),i!==void 0&&s.push(n.getTokenValue().replace(/[^\r\n]/g,i)),g=n.getPosition();break}while(u!==17);return s.join("")}e.stripComments=l;function a(t){switch(typeof t){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(t){if(Array.isArray(t))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=a}),define(le[112],ce([0,1,37]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function P(m,y,r){let k,d,b,f,c;if(y){for(f=y.offset,c=f+y.length,b=f;b>0&&!_(m,b-1);)b--;let g=c;for(;g<m.length&&!_(m,g);)g++;d=m.substring(b,g),k=D(d,r)}else d=m,k=0,b=0,f=0,c=m.length;const S=I(r,m);let w=!1,C=0,h;r.insertSpaces?h=p(" ",r.tabSize||4):h="	";const l=E.createScanner(d,!1);let a=!1;function t(){return S+p(h,k+C)}function i(){let g=l.scan();for(w=!1;g===15||g===14;)w=w||g===14,g=l.scan();return a=g===16||l.getTokenError()!==0,g}const n=[];function s(g,v,T){!a&&v<c&&T>f&&m.substring(v,T)!==g&&n.push({offset:v,length:T-v,content:g})}let u=i();if(u!==17){const g=l.getTokenOffset()+b,v=p(h,k);s(v,b,g)}for(;u!==17;){let g=l.getTokenOffset()+l.getTokenLength()+b,v=i(),T="";for(;!w&&(v===12||v===13);){const o=l.getTokenOffset()+b;s(" ",g,o),g=l.getTokenOffset()+l.getTokenLength()+b,T=v===12?t():"",v=i()}if(v===2)u!==1&&(C--,T=t());else if(v===4)u!==3&&(C--,T=t());else{switch(u){case 3:case 1:C++,T=t();break;case 5:case 12:T=t();break;case 13:w?T=t():T=" ";break;case 6:T=" ";break;case 10:if(v===6){T="";break}case 7:case 8:case 9:case 11:case 2:case 4:v===12||v===13?T=" ":v!==5&&v!==17&&(a=!0);break;case 16:a=!0;break}w&&(v===12||v===13)&&(T=t())}const R=l.getTokenOffset()+b;s(T,g,R),u=v}return n}e.format=P;function p(m,y){let r="";for(let k=0;k<y;k++)r+=m;return r}function D(m,y){let r=0,k=0;const d=y.tabSize||4;for(;r<m.length;){const b=m.charAt(r);if(b===" ")k++;else if(b==="	")k+=d;else break;r++}return Math.floor(k/d)}function I(m,y){for(let r=0;r<y.length;r++){const k=y.charAt(r);if(k==="\r")return r+1<y.length&&y.charAt(r+1)===`
`?`\r
`:"\r";if(k===`
`)return`
`}return m&&m.eol||`
`}e.getEOL=I;function _(m,y){return`\r
`.indexOf(m.charAt(y))!==-1}e.isEOL=_}),define(le[113],ce([0,1,37,112]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function p(y,r,k){return D(y,r,void 0,k)}e.removeProperty=p;function D(y,r,k,d,b){const f=r.slice(),c=[],S=E.parseTree(y,c);let w,C;for(;f.length>0&&(C=f.pop(),w=E.findNodeAtLocation(S,f),w===void 0&&k!==void 0);)typeof C=="string"?k={[C]:k}:k=[k];if(w)if(w.type==="object"&&typeof C=="string"&&Array.isArray(w.children)){const h=E.findNodeAtLocation(w,[C]);if(h!==void 0)if(k===void 0){if(!h.parent)throw new Error("Malformed AST");const l=w.children.indexOf(h.parent);let a,t=h.parent.offset+h.parent.length;if(l>0){const i=w.children[l-1];a=i.offset+i.length}else a=w.offset+1,w.children.length>1&&(t=w.children[1].offset);return I(y,{offset:a,length:t-a,content:""},d)}else return I(y,{offset:h.offset,length:h.length,content:JSON.stringify(k)},d);else{if(k===void 0)return[];const l=`${JSON.stringify(C)}: ${JSON.stringify(k)}`,a=b?b(w.children.map(i=>i.children[0].value)):w.children.length;let t;if(a>0){const i=w.children[a-1];t={offset:i.offset+i.length,length:0,content:","+l}}else w.children.length===0?t={offset:w.offset+1,length:0,content:l}:t={offset:w.offset+1,length:0,content:l+","};return I(y,t,d)}}else if(w.type==="array"&&typeof C=="number"&&Array.isArray(w.children))if(k!==void 0){const h=`${JSON.stringify(k)}`;let l;if(w.children.length===0||C===0)l={offset:w.offset+1,length:0,content:w.children.length===0?h:h+","};else{const a=C===-1||C>w.children.length?w.children.length:C,t=w.children[a-1];l={offset:t.offset+t.length,length:0,content:","+h}}return I(y,l,d)}else{const h=C,l=w.children[h];let a;if(w.children.length===1)a={offset:w.offset+1,length:w.length-2,content:""};else if(w.children.length-1===h){const t=w.children[h-1],i=t.offset+t.length,n=w.offset+w.length;a={offset:i,length:n-2-i,content:""}}else a={offset:l.offset,length:w.children[h+1].offset-l.offset,content:""};return I(y,a,d)}else throw new Error(`Can not add ${typeof C!="number"?"index":"property"} to parent of type ${w.type}`);else{if(k===void 0)throw new Error("Can not delete in empty document");return I(y,{offset:S?S.offset:0,length:S?S.length:0,content:JSON.stringify(k)},d)}}e.setProperty=D;function I(y,r,k){let d=_(y,r),b=r.offset,f=r.offset+r.content.length;if(r.length===0||r.content.length===0){for(;b>0&&!P.isEOL(d,b-1);)b--;for(;f<d.length&&!P.isEOL(d,f);)f++}const c=P.format(d,{offset:b,length:f-b},k);for(let w=c.length-1;w>=0;w--){const C=c[w];d=_(d,C),b=Math.min(b,C.offset),f=Math.max(f,C.offset+C.length),f+=C.content.length-C.length}const S=y.length-(d.length-f)-b;return[{offset:b,length:S,content:d.substring(b,f)}]}e.withFormatting=I;function _(y,r){return y.substring(0,r.offset)+r.content+y.substring(r.offset+r.length)}e.applyEdit=_;function m(y,r){let k=r.slice(0).sort((b,f)=>{const c=b.offset-f.offset;return c===0?b.length-f.length:c}),d=y.length;for(let b=k.length-1;b>=0;b--){let f=k[b];if(f.offset+f.length<=d)y=_(y,f);else throw new Error("Overlapping edit");d=f.offset}return y}e.applyEdits=m}),define(le[2],ce([0,1,71,51]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ImmortalReference=e.ReferenceCollection=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.trackDisposable=e.setDisposableTracker=void 0;const p=!1;let D=null;function I(h){D=h}if(e.setDisposableTracker=I,p){const h="__is_disposable_tracked__";D=new class{trackDisposable(l){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[h]||console.log(a)},3e3)}markTracked(l){if(l&&l!==c.None)try{l[h]=!0}catch(a){}}}}function _(h){!D||D.markTracked(h)}function m(h){return D&&D.trackDisposable(h),h}e.trackDisposable=m;class y extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=y;function r(h){return typeof h.dispose=="function"&&h.dispose.length===0}e.isDisposable=r;function k(h){if(P.Iterable.is(h)){let l=[];for(const a of h)if(a){_(a);try{a.dispose()}catch(t){l.push(t)}}if(l.length===1)throw l[0];if(l.length>1)throw new y(l);return Array.isArray(h)?[]:h}else if(h)return _(h),h.dispose(),h}e.dispose=k;function d(...h){return h.forEach(_),b(()=>k(h))}e.combinedDisposable=d;function b(h){const l=m({dispose:()=>{_(l),h()}});return l}e.toDisposable=b;class f{constructor(){this._toDispose=new Set,this._isDisposed=!1}dispose(){this._isDisposed||(_(this),this._isDisposed=!0,this.clear())}clear(){try{k(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return _(l),this._isDisposed?f.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=f,f.DISABLE_DISPOSED_WARNING=!1;class c{constructor(){this._store=new f,m(this)}dispose(){_(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=c,c.None=Object.freeze({dispose(){}});class S{constructor(){this._isDisposed=!1,m(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){var a;this._isDisposed||l===this._value||((a=this._value)===null||a===void 0||a.dispose(),l&&_(l),this._value=l)}clear(){this.value=void 0}dispose(){var l;this._isDisposed=!0,_(this),(l=this._value)===null||l===void 0||l.dispose(),this._value=void 0}}e.MutableDisposable=S;class w{constructor(){this.references=new Map}acquire(l,...a){let t=this.references.get(l);t||(t={counter:0,object:this.createReferencedObject(l,...a)},this.references.set(l,t));const{object:i}=t,n=E.once(()=>{--t.counter==0&&(this.destroyReferencedObject(l,t.object),this.references.delete(l))});return t.counter++,{object:i,dispose:n}}}e.ReferenceCollection=w;class C{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=C}),define(le[72],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class E{constructor(D){this.element=D,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class P{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let D=this._first;for(;D!==E.Undefined;){const I=D.next;D.prev=E.Undefined,D.next=E.Undefined,D=I}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(D){return this._insert(D,!1)}push(D){return this._insert(D,!0)}_insert(D,I){const _=new E(D);if(this._first===E.Undefined)this._first=_,this._last=_;else if(I){const y=this._last;this._last=_,_.prev=y,y.next=_}else{const y=this._first;this._first=_,_.next=y,y.prev=_}this._size+=1;let m=!1;return()=>{m||(m=!0,this._remove(_))}}shift(){if(this._first!==E.Undefined){const D=this._first.element;return this._remove(this._first),D}}pop(){if(this._last!==E.Undefined){const D=this._last.element;return this._remove(this._last),D}}_remove(D){if(D.prev!==E.Undefined&&D.next!==E.Undefined){const I=D.prev;I.next=D.next,D.next.prev=I}else D.prev===E.Undefined&&D.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):D.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):D.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let D=this._first;for(;D!==E.Undefined;)yield D.element,D=D.next}}e.LinkedList=P}),function(x,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(x=typeof globalThis!="undefined"?globalThis:x||self,x.marked=e())}(this,function(){"use strict";function x(he,me){for(var fe=0;fe<me.length;fe++){var V=me[fe];V.enumerable=V.enumerable||!1,V.configurable=!0,"value"in V&&(V.writable=!0),Object.defineProperty(he,V.key,V)}}function e(he,me,fe){return me&&x(he.prototype,me),fe&&x(he,fe),he}function E(he,me){if(!!he){if(typeof he=="string")return P(he,me);var fe=Object.prototype.toString.call(he).slice(8,-1);if(fe==="Object"&&he.constructor&&(fe=he.constructor.name),fe==="Map"||fe==="Set")return Array.from(he);if(fe==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(fe))return P(he,me)}}function P(he,me){(me==null||me>he.length)&&(me=he.length);for(var fe=0,V=new Array(me);fe<me;fe++)V[fe]=he[fe];return V}function p(he,me){var fe;if(typeof Symbol=="undefined"||he[Symbol.iterator]==null){if(Array.isArray(he)||(fe=E(he))||me&&he&&typeof he.length=="number"){fe&&(he=fe);var V=0;return function(){return V>=he.length?{done:!0}:{done:!1,value:he[V++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}return fe=he[Symbol.iterator](),fe.next.bind(fe)}function D(he){var me={exports:{}};return he(me,me.exports),me.exports}var I=D(function(he){function me(){return{baseUrl:null,breaks:!1,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function fe(V){he.exports.defaults=V}he.exports={defaults:me(),getDefaults:me,changeDefaults:fe}}),_=/[&<>"']/,m=/[&<>"']/g,y=/[<>"']|&(?!#?\w+;)/,r=/[<>"']|&(?!#?\w+;)/g,k={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(me){return k[me]};function b(he,me){if(me){if(_.test(he))return he.replace(m,d)}else if(y.test(he))return he.replace(r,d);return he}var f=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function c(he){return he.replace(f,function(me,fe){return fe=fe.toLowerCase(),fe==="colon"?":":fe.charAt(0)==="#"?fe.charAt(1)==="x"?String.fromCharCode(parseInt(fe.substring(2),16)):String.fromCharCode(+fe.substring(1)):""})}var S=/(^|[^\[])\^/g;function w(he,me){he=he.source||he,me=me||"";var fe={replace:function(Q,U){return U=U.source||U,U=U.replace(S,"$1"),he=he.replace(Q,U),fe},getRegex:function(){return new RegExp(he,me)}};return fe}var C=/[^\w:]/g,h=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function l(he,me,fe){if(he){var V;try{V=decodeURIComponent(c(fe)).replace(C,"").toLowerCase()}catch(Q){return null}if(V.indexOf("javascript:")===0||V.indexOf("vbscript:")===0||V.indexOf("data:")===0)return null}me&&!h.test(fe)&&(fe=s(me,fe));try{fe=encodeURI(fe).replace(/%25/g,"%")}catch(Q){return null}return fe}var a={},t=/^[^:]+:\/*[^/]*$/,i=/^([^:]+:)[\s\S]*$/,n=/^([^:]+:\/*[^/]*)[\s\S]*$/;function s(he,me){a[" "+he]||(t.test(he)?a[" "+he]=he+"/":a[" "+he]=T(he,"/",!0)),he=a[" "+he];var fe=he.indexOf(":")===-1;return me.substring(0,2)==="//"?fe?me:he.replace(i,"$1")+me:me.charAt(0)==="/"?fe?me:he.replace(n,"$1")+me:he+me}var u={exec:function(){}};function g(he){for(var me=1,fe,V;me<arguments.length;me++){fe=arguments[me];for(V in fe)Object.prototype.hasOwnProperty.call(fe,V)&&(he[V]=fe[V])}return he}function v(he,me){var fe=he.replace(/\|/g,function(U,H,Y){for(var pe=!1,Ee=H;--Ee>=0&&Y[Ee]==="\\";)pe=!pe;return pe?"|":" |"}),V=fe.split(/ \|/),Q=0;if(V.length>me)V.splice(me);else for(;V.length<me;)V.push("");for(;Q<V.length;Q++)V[Q]=V[Q].trim().replace(/\\\|/g,"|");return V}function T(he,me,fe){var V=he.length;if(V===0)return"";for(var Q=0;Q<V;){var U=he.charAt(V-Q-1);if(U===me&&!fe)Q++;else if(U!==me&&fe)Q++;else break}return he.substr(0,V-Q)}function R(he,me){if(he.indexOf(me[1])===-1)return-1;for(var fe=he.length,V=0,Q=0;Q<fe;Q++)if(he[Q]==="\\")Q++;else if(he[Q]===me[0])V++;else if(he[Q]===me[1]&&(V--,V<0))return Q;return-1}function o(he){he&&he.sanitize&&!he.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function F(he,me){if(me<1)return"";for(var fe="";me>1;)me&1&&(fe+=he),me>>=1,he+=he;return fe+he}var B={escape:b,unescape:c,edit:w,cleanUrl:l,resolveUrl:s,noopTest:u,merge:g,splitCells:v,rtrim:T,findClosingBracket:R,checkSanitizeDeprecation:o,repeatString:F},Z=I.defaults,ie=B.rtrim,Se=B.splitCells,oe=B.escape,q=B.findClosingBracket;function ee(he,me,fe){var V=me.href,Q=me.title?oe(me.title):null,U=he[1].replace(/\\([\[\]])/g,"$1");return he[0].charAt(0)!=="!"?{type:"link",raw:fe,href:V,title:Q,text:U}:{type:"image",raw:fe,href:V,title:Q,text:oe(U)}}function G(he,me){var fe=he.match(/^(\s+)(?:```)/);if(fe===null)return me;var V=fe[1];return me.split(`
`).map(function(Q){var U=Q.match(/^\s+/);if(U===null)return Q;var H=U[0];return H.length>=V.length?Q.slice(V.length):Q}).join(`
`)}var z=function(){function he(fe){this.options=fe||Z}var me=he.prototype;return me.space=function(V){var Q=this.rules.block.newline.exec(V);if(Q)return Q[0].length>1?{type:"space",raw:Q[0]}:{raw:`
`}},me.code=function(V){var Q=this.rules.block.code.exec(V);if(Q){var U=Q[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Q[0],codeBlockStyle:"indented",text:this.options.pedantic?U:ie(U,`
`)}}},me.fences=function(V){var Q=this.rules.block.fences.exec(V);if(Q){var U=Q[0],H=G(U,Q[3]||"");return{type:"code",raw:U,lang:Q[2]?Q[2].trim():Q[2],text:H}}},me.heading=function(V){var Q=this.rules.block.heading.exec(V);if(Q){var U=Q[2].trim();if(/#$/.test(U)){var H=ie(U,"#");(this.options.pedantic||!H||/ $/.test(H))&&(U=H.trim())}return{type:"heading",raw:Q[0],depth:Q[1].length,text:U}}},me.nptable=function(V){var Q=this.rules.block.nptable.exec(V);if(Q){var U={type:"table",header:Se(Q[1].replace(/^ *| *\| *$/g,"")),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Q[3]?Q[3].replace(/\n$/,"").split(`
`):[],raw:Q[0]};if(U.header.length===U.align.length){var H=U.align.length,Y;for(Y=0;Y<H;Y++)/^ *-+: *$/.test(U.align[Y])?U.align[Y]="right":/^ *:-+: *$/.test(U.align[Y])?U.align[Y]="center":/^ *:-+ *$/.test(U.align[Y])?U.align[Y]="left":U.align[Y]=null;for(H=U.cells.length,Y=0;Y<H;Y++)U.cells[Y]=Se(U.cells[Y],U.header.length);return U}}},me.hr=function(V){var Q=this.rules.block.hr.exec(V);if(Q)return{type:"hr",raw:Q[0]}},me.blockquote=function(V){var Q=this.rules.block.blockquote.exec(V);if(Q){var U=Q[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:Q[0],text:U}}},me.list=function(V){var Q=this.rules.block.list.exec(V);if(Q){var U=Q[0],H=Q[2],Y=H.length>1,pe={type:"list",raw:U,ordered:Y,start:Y?+H.slice(0,-1):"",loose:!1,items:[]},Ee=Q[0].match(this.rules.block.item),Ce=!1,ne,De,Ae,Fe,Oe,Ge,re,ue,J=Ee.length;Ae=this.rules.block.listItemStart.exec(Ee[0]);for(var $=0;$<J;$++){if(ne=Ee[$],U=ne,$!==J-1){if(Fe=this.rules.block.listItemStart.exec(Ee[$+1]),this.options.pedantic?Fe[1].length>Ae[1].length:Fe[1].length>Ae[0].length||Fe[1].length>3){Ee.splice($,2,Ee[$]+`
`+Ee[$+1]),$--,J--;continue}else(!this.options.pedantic||this.options.smartLists?Fe[2][Fe[2].length-1]!==H[H.length-1]:Y===(Fe[2].length===1))&&(Oe=Ee.slice($+1).join(`
`),pe.raw=pe.raw.substring(0,pe.raw.length-Oe.length),$=J-1);Ae=Fe}De=ne.length,ne=ne.replace(/^ *([*+-]|\d+[.)]) ?/,""),~ne.indexOf(`
 `)&&(De-=ne.length,ne=this.options.pedantic?ne.replace(/^ {1,4}/gm,""):ne.replace(new RegExp("^ {1,"+De+"}","gm"),"")),Ge=Ce||/\n\n(?!\s*$)/.test(ne),$!==J-1&&(Ce=ne.charAt(ne.length-1)===`
`,Ge||(Ge=Ce)),Ge&&(pe.loose=!0),this.options.gfm&&(re=/^\[[ xX]\] /.test(ne),ue=void 0,re&&(ue=ne[1]!==" ",ne=ne.replace(/^\[[ xX]\] +/,""))),pe.items.push({type:"list_item",raw:U,task:re,checked:ue,loose:Ge,text:ne})}return pe}},me.html=function(V){var Q=this.rules.block.html.exec(V);if(Q)return{type:this.options.sanitize?"paragraph":"html",raw:Q[0],pre:!this.options.sanitizer&&(Q[1]==="pre"||Q[1]==="script"||Q[1]==="style"),text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Q[0]):oe(Q[0]):Q[0]}},me.def=function(V){var Q=this.rules.block.def.exec(V);if(Q){Q[3]&&(Q[3]=Q[3].substring(1,Q[3].length-1));var U=Q[1].toLowerCase().replace(/\s+/g," ");return{tag:U,raw:Q[0],href:Q[2],title:Q[3]}}},me.table=function(V){var Q=this.rules.block.table.exec(V);if(Q){var U={type:"table",header:Se(Q[1].replace(/^ *| *\| *$/g,"")),align:Q[2].replace(/^ *|\| *$/g,"").split(/ *\| */),cells:Q[3]?Q[3].replace(/\n$/,"").split(`
`):[]};if(U.header.length===U.align.length){U.raw=Q[0];var H=U.align.length,Y;for(Y=0;Y<H;Y++)/^ *-+: *$/.test(U.align[Y])?U.align[Y]="right":/^ *:-+: *$/.test(U.align[Y])?U.align[Y]="center":/^ *:-+ *$/.test(U.align[Y])?U.align[Y]="left":U.align[Y]=null;for(H=U.cells.length,Y=0;Y<H;Y++)U.cells[Y]=Se(U.cells[Y].replace(/^ *\| *| *\| *$/g,""),U.header.length);return U}}},me.lheading=function(V){var Q=this.rules.block.lheading.exec(V);if(Q)return{type:"heading",raw:Q[0],depth:Q[2].charAt(0)==="="?1:2,text:Q[1]}},me.paragraph=function(V){var Q=this.rules.block.paragraph.exec(V);if(Q)return{type:"paragraph",raw:Q[0],text:Q[1].charAt(Q[1].length-1)===`
`?Q[1].slice(0,-1):Q[1]}},me.text=function(V){var Q=this.rules.block.text.exec(V);if(Q)return{type:"text",raw:Q[0],text:Q[0]}},me.escape=function(V){var Q=this.rules.inline.escape.exec(V);if(Q)return{type:"escape",raw:Q[0],text:oe(Q[1])}},me.tag=function(V,Q,U){var H=this.rules.inline.tag.exec(V);if(H)return!Q&&/^<a /i.test(H[0])?Q=!0:Q&&/^<\/a>/i.test(H[0])&&(Q=!1),!U&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?U=!0:U&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(U=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:Q,inRawBlock:U,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):oe(H[0]):H[0]}},me.link=function(V){var Q=this.rules.inline.link.exec(V);if(Q){var U=Q[2].trim();if(!this.options.pedantic&&/^</.test(U)){if(!/>$/.test(U))return;var H=ie(U.slice(0,-1),"\\");if((U.length-H.length)%2==0)return}else{var Y=q(Q[2],"()");if(Y>-1){var pe=Q[0].indexOf("!")===0?5:4,Ee=pe+Q[1].length+Y;Q[2]=Q[2].substring(0,Y),Q[0]=Q[0].substring(0,Ee).trim(),Q[3]=""}}var Ce=Q[2],ne="";if(this.options.pedantic){var De=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Ce);De&&(Ce=De[1],ne=De[3])}else ne=Q[3]?Q[3].slice(1,-1):"";return Ce=Ce.trim(),/^</.test(Ce)&&(this.options.pedantic&&!/>$/.test(U)?Ce=Ce.slice(1):Ce=Ce.slice(1,-1)),ee(Q,{href:Ce&&Ce.replace(this.rules.inline._escapes,"$1"),title:ne&&ne.replace(this.rules.inline._escapes,"$1")},Q[0])}},me.reflink=function(V,Q){var U;if((U=this.rules.inline.reflink.exec(V))||(U=this.rules.inline.nolink.exec(V))){var H=(U[2]||U[1]).replace(/\s+/g," ");if(H=Q[H.toLowerCase()],!H||!H.href){var Y=U[0].charAt(0);return{type:"text",raw:Y,text:Y}}return ee(U,H,U[0])}},me.emStrong=function(V,Q,U){U===void 0&&(U="");var H=this.rules.inline.emStrong.lDelim.exec(V);if(!!H&&!(H[3]&&U.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Y=H[1]||H[2]||"";if(!Y||Y&&(U===""||this.rules.inline.punctuation.exec(U))){var pe=H[0].length-1,Ee,Ce,ne=pe,De=0,Ae=H[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Ae.lastIndex=0,Q=Q.slice(-1*V.length+pe);(H=Ae.exec(Q))!=null;)if(Ee=H[1]||H[2]||H[3]||H[4]||H[5]||H[6],!!Ee){if(Ce=Ee.length,H[3]||H[4]){ne+=Ce;continue}else if((H[5]||H[6])&&pe%3&&!((pe+Ce)%3)){De+=Ce;continue}if(ne-=Ce,!(ne>0)){if(ne+De-Ce<=0&&!Q.slice(Ae.lastIndex).match(Ae)&&(Ce=Math.min(Ce,Ce+ne+De)),Math.min(pe,Ce)%2)return{type:"em",raw:V.slice(0,pe+H.index+Ce+1),text:V.slice(1,pe+H.index+Ce)};if(Math.min(pe,Ce)%2==0)return{type:"strong",raw:V.slice(0,pe+H.index+Ce+1),text:V.slice(2,pe+H.index+Ce-1)}}}}}},me.codespan=function(V){var Q=this.rules.inline.code.exec(V);if(Q){var U=Q[2].replace(/\n/g," "),H=/[^ ]/.test(U),Y=/^ /.test(U)&&/ $/.test(U);return H&&Y&&(U=U.substring(1,U.length-1)),U=oe(U,!0),{type:"codespan",raw:Q[0],text:U}}},me.br=function(V){var Q=this.rules.inline.br.exec(V);if(Q)return{type:"br",raw:Q[0]}},me.del=function(V){var Q=this.rules.inline.del.exec(V);if(Q)return{type:"del",raw:Q[0],text:Q[2]}},me.autolink=function(V,Q){var U=this.rules.inline.autolink.exec(V);if(U){var H,Y;return U[2]==="@"?(H=oe(this.options.mangle?Q(U[1]):U[1]),Y="mailto:"+H):(H=oe(U[1]),Y=H),{type:"link",raw:U[0],text:H,href:Y,tokens:[{type:"text",raw:H,text:H}]}}},me.url=function(V,Q){var U;if(U=this.rules.inline.url.exec(V)){var H,Y;if(U[2]==="@")H=oe(this.options.mangle?Q(U[0]):U[0]),Y="mailto:"+H;else{var pe;do pe=U[0],U[0]=this.rules.inline._backpedal.exec(U[0])[0];while(pe!==U[0]);H=oe(U[0]),U[1]==="www."?Y="http://"+H:Y=H}return{type:"link",raw:U[0],text:H,href:Y,tokens:[{type:"text",raw:H,text:H}]}}},me.inlineText=function(V,Q,U){var H=this.rules.inline.text.exec(V);if(H){var Y;return Q?Y=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):oe(H[0]):H[0]:Y=oe(this.options.smartypants?U(H[0]):H[0]),{type:"text",raw:H[0],text:Y}}},he}(),L=B.noopTest,A=B.edit,N=B.merge,M={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?:\n+|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3})(bull) [\s\S]+?(?:hr|def|\n{2,}(?! )(?! {0,3}bull )\n*|\s*$)/,html:"^ {0,3}(?:<(script|pre|style)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:\\n{2,}|$)|<(?!script|pre|style)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$)|</(?!script|pre|style)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:\\n{2,}|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,nptable:L,table:L,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};M._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,M._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,M.def=A(M.def).replace("label",M._label).replace("title",M._title).getRegex(),M.bullet=/(?:[*+-]|\d{1,9}[.)])/,M.item=/^( *)(bull) ?[^\n]*(?:\n(?! *bull ?)[^\n]*)*/,M.item=A(M.item,"gm").replace(/bull/g,M.bullet).getRegex(),M.listItemStart=A(/^( *)(bull)/).replace("bull",M.bullet).getRegex(),M.list=A(M.list).replace(/bull/g,M.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+M.def.source+")").getRegex(),M._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",M._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,M.html=A(M.html,"i").replace("comment",M._comment).replace("tag",M._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),M.paragraph=A(M._paragraph).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",M._tag).getRegex(),M.blockquote=A(M.blockquote).replace("paragraph",M.paragraph).getRegex(),M.normal=N({},M),M.gfm=N({},M.normal,{nptable:"^ *([^|\\n ].*\\|.*)\\n {0,3}([-:]+ *\\|[-| :]*)(?:\\n((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)",table:"^ *\\|(.+)\\n {0,3}\\|?( *[-:]+[-| :]*)(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),M.gfm.nptable=A(M.gfm.nptable).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",M._tag).getRegex(),M.gfm.table=A(M.gfm.table).replace("hr",M.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|!--)").replace("tag",M._tag).getRegex(),M.pedantic=N({},M.normal,{html:A(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",M._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:L,paragraph:A(M.normal._paragraph).replace("hr",M.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",M.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var W={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:L,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_]*?\*[^_]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^*]*?\_[^*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:L,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};W._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",W.punctuation=A(W.punctuation).replace(/punctuation/g,W._punctuation).getRegex(),W.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,W.escapedEmSt=/\\\*|\\_/g,W._comment=A(M._comment).replace("(?:-->|$)","-->").getRegex(),W.emStrong.lDelim=A(W.emStrong.lDelim).replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimAst=A(W.emStrong.rDelimAst,"g").replace(/punct/g,W._punctuation).getRegex(),W.emStrong.rDelimUnd=A(W.emStrong.rDelimUnd,"g").replace(/punct/g,W._punctuation).getRegex(),W._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,W._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,W._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,W.autolink=A(W.autolink).replace("scheme",W._scheme).replace("email",W._email).getRegex(),W._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,W.tag=A(W.tag).replace("comment",W._comment).replace("attribute",W._attribute).getRegex(),W._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,W._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,W._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,W.link=A(W.link).replace("label",W._label).replace("href",W._href).replace("title",W._title).getRegex(),W.reflink=A(W.reflink).replace("label",W._label).getRegex(),W.reflinkSearch=A(W.reflinkSearch,"g").replace("reflink",W.reflink).replace("nolink",W.nolink).getRegex(),W.normal=N({},W),W.pedantic=N({},W.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:A(/^!?\[(label)\]\((.*?)\)/).replace("label",W._label).getRegex(),reflink:A(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",W._label).getRegex()}),W.gfm=N({},W.normal,{escape:A(W.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@))/}),W.gfm.url=A(W.gfm.url,"i").replace("email",W.gfm._extended_email).getRegex(),W.breaks=N({},W.gfm,{br:A(W.br).replace("{2,}","*").getRegex(),text:A(W.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var X={block:M,inline:W},ae=I.defaults,se=X.block,be=X.inline,ke=B.repeatString;function Te(he){return he.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function Le(he){var me="",fe,V,Q=he.length;for(fe=0;fe<Q;fe++)V=he.charCodeAt(fe),Math.random()>.5&&(V="x"+V.toString(16)),me+="&#"+V+";";return me}var je=function(){function he(fe){this.tokens=[],this.tokens.links=Object.create(null),this.options=fe||ae,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options;var V={block:se.normal,inline:be.normal};this.options.pedantic?(V.block=se.pedantic,V.inline=be.pedantic):this.options.gfm&&(V.block=se.gfm,this.options.breaks?V.inline=be.breaks:V.inline=be.gfm),this.tokenizer.rules=V}he.lex=function(V,Q){var U=new he(Q);return U.lex(V)},he.lexInline=function(V,Q){var U=new he(Q);return U.inlineTokens(V)};var me=he.prototype;return me.lex=function(V){return V=V.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(V,this.tokens,!0),this.inline(this.tokens),this.tokens},me.blockTokens=function(V,Q,U){Q===void 0&&(Q=[]),U===void 0&&(U=!0),this.options.pedantic&&(V=V.replace(/^ +$/gm,""));for(var H,Y,pe,Ee;V;){if(H=this.tokenizer.space(V)){V=V.substring(H.raw.length),H.type&&Q.push(H);continue}if(H=this.tokenizer.code(V)){V=V.substring(H.raw.length),Ee=Q[Q.length-1],Ee&&Ee.type==="paragraph"?(Ee.raw+=`
`+H.raw,Ee.text+=`
`+H.text):Q.push(H);continue}if(H=this.tokenizer.fences(V)){V=V.substring(H.raw.length),Q.push(H);continue}if(H=this.tokenizer.heading(V)){V=V.substring(H.raw.length),Q.push(H);continue}if(H=this.tokenizer.nptable(V)){V=V.substring(H.raw.length),Q.push(H);continue}if(H=this.tokenizer.hr(V)){V=V.substring(H.raw.length),Q.push(H);continue}if(H=this.tokenizer.blockquote(V)){V=V.substring(H.raw.length),H.tokens=this.blockTokens(H.text,[],U),Q.push(H);continue}if(H=this.tokenizer.list(V)){for(V=V.substring(H.raw.length),pe=H.items.length,Y=0;Y<pe;Y++)H.items[Y].tokens=this.blockTokens(H.items[Y].text,[],!1);Q.push(H);continue}if(H=this.tokenizer.html(V)){V=V.substring(H.raw.length),Q.push(H);continue}if(U&&(H=this.tokenizer.def(V))){V=V.substring(H.raw.length),this.tokens.links[H.tag]||(this.tokens.links[H.tag]={href:H.href,title:H.title});continue}if(H=this.tokenizer.table(V)){V=V.substring(H.raw.length),Q.push(H);continue}if(H=this.tokenizer.lheading(V)){V=V.substring(H.raw.length),Q.push(H);continue}if(U&&(H=this.tokenizer.paragraph(V))){V=V.substring(H.raw.length),Q.push(H);continue}if(H=this.tokenizer.text(V)){V=V.substring(H.raw.length),Ee=Q[Q.length-1],Ee&&Ee.type==="text"?(Ee.raw+=`
`+H.raw,Ee.text+=`
`+H.text):Q.push(H);continue}if(V){var Ce="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Ce);break}else throw new Error(Ce)}}return Q},me.inline=function(V){var Q,U,H,Y,pe,Ee,Ce=V.length;for(Q=0;Q<Ce;Q++)switch(Ee=V[Q],Ee.type){case"paragraph":case"text":case"heading":{Ee.tokens=[],this.inlineTokens(Ee.text,Ee.tokens);break}case"table":{for(Ee.tokens={header:[],cells:[]},Y=Ee.header.length,U=0;U<Y;U++)Ee.tokens.header[U]=[],this.inlineTokens(Ee.header[U],Ee.tokens.header[U]);for(Y=Ee.cells.length,U=0;U<Y;U++)for(pe=Ee.cells[U],Ee.tokens.cells[U]=[],H=0;H<pe.length;H++)Ee.tokens.cells[U][H]=[],this.inlineTokens(pe[H],Ee.tokens.cells[U][H]);break}case"blockquote":{this.inline(Ee.tokens);break}case"list":{for(Y=Ee.items.length,U=0;U<Y;U++)this.inline(Ee.items[U].tokens);break}}return V},me.inlineTokens=function(V,Q,U,H){Q===void 0&&(Q=[]),U===void 0&&(U=!1),H===void 0&&(H=!1);var Y,pe,Ee=V,Ce,ne,De;if(this.tokens.links){var Ae=Object.keys(this.tokens.links);if(Ae.length>0)for(;(Ce=this.tokenizer.rules.inline.reflinkSearch.exec(Ee))!=null;)Ae.includes(Ce[0].slice(Ce[0].lastIndexOf("[")+1,-1))&&(Ee=Ee.slice(0,Ce.index)+"["+ke("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Ce=this.tokenizer.rules.inline.blockSkip.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"["+ke("a",Ce[0].length-2)+"]"+Ee.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Ce=this.tokenizer.rules.inline.escapedEmSt.exec(Ee))!=null;)Ee=Ee.slice(0,Ce.index)+"++"+Ee.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;V;){if(ne||(De=""),ne=!1,Y=this.tokenizer.escape(V)){V=V.substring(Y.raw.length),Q.push(Y);continue}if(Y=this.tokenizer.tag(V,U,H)){V=V.substring(Y.raw.length),U=Y.inLink,H=Y.inRawBlock;var Fe=Q[Q.length-1];Fe&&Y.type==="text"&&Fe.type==="text"?(Fe.raw+=Y.raw,Fe.text+=Y.text):Q.push(Y);continue}if(Y=this.tokenizer.link(V)){V=V.substring(Y.raw.length),Y.type==="link"&&(Y.tokens=this.inlineTokens(Y.text,[],!0,H)),Q.push(Y);continue}if(Y=this.tokenizer.reflink(V,this.tokens.links)){V=V.substring(Y.raw.length);var Oe=Q[Q.length-1];Y.type==="link"?(Y.tokens=this.inlineTokens(Y.text,[],!0,H),Q.push(Y)):Oe&&Y.type==="text"&&Oe.type==="text"?(Oe.raw+=Y.raw,Oe.text+=Y.text):Q.push(Y);continue}if(Y=this.tokenizer.emStrong(V,Ee,De)){V=V.substring(Y.raw.length),Y.tokens=this.inlineTokens(Y.text,[],U,H),Q.push(Y);continue}if(Y=this.tokenizer.codespan(V)){V=V.substring(Y.raw.length),Q.push(Y);continue}if(Y=this.tokenizer.br(V)){V=V.substring(Y.raw.length),Q.push(Y);continue}if(Y=this.tokenizer.del(V)){V=V.substring(Y.raw.length),Y.tokens=this.inlineTokens(Y.text,[],U,H),Q.push(Y);continue}if(Y=this.tokenizer.autolink(V,Le)){V=V.substring(Y.raw.length),Q.push(Y);continue}if(!U&&(Y=this.tokenizer.url(V,Le))){V=V.substring(Y.raw.length),Q.push(Y);continue}if(Y=this.tokenizer.inlineText(V,H,Te)){V=V.substring(Y.raw.length),Y.raw.slice(-1)!=="_"&&(De=Y.raw.slice(-1)),ne=!0,pe=Q[Q.length-1],pe&&pe.type==="text"?(pe.raw+=Y.raw,pe.text+=Y.text):Q.push(Y);continue}if(V){var Ge="Infinite loop on byte: "+V.charCodeAt(0);if(this.options.silent){console.error(Ge);break}else throw new Error(Ge)}}return Q},e(he,null,[{key:"rules",get:function(){return{block:se,inline:be}}}]),he}(),Xe=I.defaults,Ze=B.cleanUrl,it=B.escape,Ye=function(){function he(fe){this.options=fe||Xe}var me=he.prototype;return me.code=function(V,Q,U){var H=(Q||"").match(/\S*/)[0];if(this.options.highlight){var Y=this.options.highlight(V,H);Y!=null&&Y!==V&&(U=!0,V=Y)}return V=V.replace(/\n$/,"")+`
`,H?'<pre><code class="'+this.options.langPrefix+it(H,!0)+'">'+(U?V:it(V,!0))+`</code></pre>
`:"<pre><code>"+(U?V:it(V,!0))+`</code></pre>
`},me.blockquote=function(V){return`<blockquote>
`+V+`</blockquote>
`},me.html=function(V){return V},me.heading=function(V,Q,U,H){return this.options.headerIds?"<h"+Q+' id="'+this.options.headerPrefix+H.slug(U)+'">'+V+"</h"+Q+`>
`:"<h"+Q+">"+V+"</h"+Q+`>
`},me.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},me.list=function(V,Q,U){var H=Q?"ol":"ul",Y=Q&&U!==1?' start="'+U+'"':"";return"<"+H+Y+`>
`+V+"</"+H+`>
`},me.listitem=function(V){return"<li>"+V+`</li>
`},me.checkbox=function(V){return"<input "+(V?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},me.paragraph=function(V){return"<p>"+V+`</p>
`},me.table=function(V,Q){return Q&&(Q="<tbody>"+Q+"</tbody>"),`<table>
<thead>
`+V+`</thead>
`+Q+`</table>
`},me.tablerow=function(V){return`<tr>
`+V+`</tr>
`},me.tablecell=function(V,Q){var U=Q.header?"th":"td",H=Q.align?"<"+U+' align="'+Q.align+'">':"<"+U+">";return H+V+"</"+U+`>
`},me.strong=function(V){return"<strong>"+V+"</strong>"},me.em=function(V){return"<em>"+V+"</em>"},me.codespan=function(V){return"<code>"+V+"</code>"},me.br=function(){return this.options.xhtml?"<br/>":"<br>"},me.del=function(V){return"<del>"+V+"</del>"},me.link=function(V,Q,U){if(V=Ze(this.options.sanitize,this.options.baseUrl,V),V===null)return U;var H='<a href="'+it(V)+'"';return Q&&(H+=' title="'+Q+'"'),H+=">"+U+"</a>",H},me.image=function(V,Q,U){if(V=Ze(this.options.sanitize,this.options.baseUrl,V),V===null)return U;var H='<img src="'+V+'" alt="'+U+'"';return Q&&(H+=' title="'+Q+'"'),H+=this.options.xhtml?"/>":">",H},me.text=function(V){return V},he}(),ge=function(){function he(){}var me=he.prototype;return me.strong=function(V){return V},me.em=function(V){return V},me.codespan=function(V){return V},me.del=function(V){return V},me.html=function(V){return V},me.text=function(V){return V},me.link=function(V,Q,U){return""+U},me.image=function(V,Q,U){return""+U},me.br=function(){return""},he}(),Ie=function(){function he(){this.seen={}}var me=he.prototype;return me.serialize=function(V){return V.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},me.getNextSafeSlug=function(V,Q){var U=V,H=0;if(this.seen.hasOwnProperty(U)){H=this.seen[V];do H++,U=V+"-"+H;while(this.seen.hasOwnProperty(U))}return Q||(this.seen[V]=H,this.seen[U]=0),U},me.slug=function(V,Q){Q===void 0&&(Q={});var U=this.serialize(V);return this.getNextSafeSlug(U,Q.dryrun)},he}(),_e=I.defaults,Re=B.unescape,Me=function(){function he(fe){this.options=fe||_e,this.options.renderer=this.options.renderer||new Ye,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ge,this.slugger=new Ie}he.parse=function(V,Q){var U=new he(Q);return U.parse(V)},he.parseInline=function(V,Q){var U=new he(Q);return U.parseInline(V)};var me=he.prototype;return me.parse=function(V,Q){Q===void 0&&(Q=!0);var U="",H,Y,pe,Ee,Ce,ne,De,Ae,Fe,Oe,Ge,re,ue,J,$,Pe,ye,$e,We=V.length;for(H=0;H<We;H++)switch(Oe=V[H],Oe.type){case"space":continue;case"hr":{U+=this.renderer.hr();continue}case"heading":{U+=this.renderer.heading(this.parseInline(Oe.tokens),Oe.depth,Re(this.parseInline(Oe.tokens,this.textRenderer)),this.slugger);continue}case"code":{U+=this.renderer.code(Oe.text,Oe.lang,Oe.escaped);continue}case"table":{for(Ae="",De="",Ee=Oe.header.length,Y=0;Y<Ee;Y++)De+=this.renderer.tablecell(this.parseInline(Oe.tokens.header[Y]),{header:!0,align:Oe.align[Y]});for(Ae+=this.renderer.tablerow(De),Fe="",Ee=Oe.cells.length,Y=0;Y<Ee;Y++){for(ne=Oe.tokens.cells[Y],De="",Ce=ne.length,pe=0;pe<Ce;pe++)De+=this.renderer.tablecell(this.parseInline(ne[pe]),{header:!1,align:Oe.align[pe]});Fe+=this.renderer.tablerow(De)}U+=this.renderer.table(Ae,Fe);continue}case"blockquote":{Fe=this.parse(Oe.tokens),U+=this.renderer.blockquote(Fe);continue}case"list":{for(Ge=Oe.ordered,re=Oe.start,ue=Oe.loose,Ee=Oe.items.length,Fe="",Y=0;Y<Ee;Y++)$=Oe.items[Y],Pe=$.checked,ye=$.task,J="",$.task&&($e=this.renderer.checkbox(Pe),ue?$.tokens.length>0&&$.tokens[0].type==="text"?($.tokens[0].text=$e+" "+$.tokens[0].text,$.tokens[0].tokens&&$.tokens[0].tokens.length>0&&$.tokens[0].tokens[0].type==="text"&&($.tokens[0].tokens[0].text=$e+" "+$.tokens[0].tokens[0].text)):$.tokens.unshift({type:"text",text:$e}):J+=$e),J+=this.parse($.tokens,ue),Fe+=this.renderer.listitem(J,ye,Pe);U+=this.renderer.list(Fe,Ge,re);continue}case"html":{U+=this.renderer.html(Oe.text);continue}case"paragraph":{U+=this.renderer.paragraph(this.parseInline(Oe.tokens));continue}case"text":{for(Fe=Oe.tokens?this.parseInline(Oe.tokens):Oe.text;H+1<We&&V[H+1].type==="text";)Oe=V[++H],Fe+=`
`+(Oe.tokens?this.parseInline(Oe.tokens):Oe.text);U+=Q?this.renderer.paragraph(Fe):Fe;continue}default:{var et='Token with "'+Oe.type+'" type was not found.';if(this.options.silent){console.error(et);return}else throw new Error(et)}}return U},me.parseInline=function(V,Q){Q=Q||this.renderer;var U="",H,Y,pe=V.length;for(H=0;H<pe;H++)switch(Y=V[H],Y.type){case"escape":{U+=Q.text(Y.text);break}case"html":{U+=Q.html(Y.text);break}case"link":{U+=Q.link(Y.href,Y.title,this.parseInline(Y.tokens,Q));break}case"image":{U+=Q.image(Y.href,Y.title,Y.text);break}case"strong":{U+=Q.strong(this.parseInline(Y.tokens,Q));break}case"em":{U+=Q.em(this.parseInline(Y.tokens,Q));break}case"codespan":{U+=Q.codespan(Y.text);break}case"br":{U+=Q.br();break}case"del":{U+=Q.del(this.parseInline(Y.tokens,Q));break}case"text":{U+=Q.text(Y.text);break}default:{var Ee='Token with "'+Y.type+'" type was not found.';if(this.options.silent){console.error(Ee);return}else throw new Error(Ee)}}return U},he}(),ze=B.merge,He=B.checkSanitizeDeprecation,xe=B.escape,tt=I.getDefaults,te=I.changeDefaults,ve=I.defaults;function de(he,me,fe){if(typeof he=="undefined"||he===null)throw new Error("marked(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");if(typeof me=="function"&&(fe=me,me=null),me=ze({},de.defaults,me||{}),He(me),fe){var V=me.highlight,Q;try{Q=je.lex(he,me)}catch(pe){return fe(pe)}var U=function(Ee){var Ce;if(!Ee)try{Ce=Me.parse(Q,me)}catch(ne){Ee=ne}return me.highlight=V,Ee?fe(Ee):fe(null,Ce)};if(!V||V.length<3||(delete me.highlight,!Q.length))return U();var H=0;de.walkTokens(Q,function(pe){pe.type==="code"&&(H++,setTimeout(function(){V(pe.text,pe.lang,function(Ee,Ce){if(Ee)return U(Ee);Ce!=null&&Ce!==pe.text&&(pe.text=Ce,pe.escaped=!0),H--,H===0&&U()})},0))}),H===0&&U();return}try{var Y=je.lex(he,me);return me.walkTokens&&de.walkTokens(Y,me.walkTokens),Me.parse(Y,me)}catch(pe){if(pe.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+xe(pe.message+"",!0)+"</pre>";throw pe}}de.options=de.setOptions=function(he){return ze(de.defaults,he),te(de.defaults),de},de.getDefaults=tt,de.defaults=ve,de.use=function(he){var me=ze({},he);if(he.renderer&&function(){var V=de.defaults.renderer||new Ye,Q=function(Y){var pe=V[Y];V[Y]=function(){for(var Ee=arguments.length,Ce=new Array(Ee),ne=0;ne<Ee;ne++)Ce[ne]=arguments[ne];var De=he.renderer[Y].apply(V,Ce);return De===!1&&(De=pe.apply(V,Ce)),De}};for(var U in he.renderer)Q(U);me.renderer=V}(),he.tokenizer&&function(){var V=de.defaults.tokenizer||new z,Q=function(Y){var pe=V[Y];V[Y]=function(){for(var Ee=arguments.length,Ce=new Array(Ee),ne=0;ne<Ee;ne++)Ce[ne]=arguments[ne];var De=he.tokenizer[Y].apply(V,Ce);return De===!1&&(De=pe.apply(V,Ce)),De}};for(var U in he.tokenizer)Q(U);me.tokenizer=V}(),he.walkTokens){var fe=de.defaults.walkTokens;me.walkTokens=function(V){he.walkTokens(V),fe&&fe(V)}}de.setOptions(me)},de.walkTokens=function(he,me){for(var fe=p(he),V;!(V=fe()).done;){var Q=V.value;switch(me(Q),Q.type){case"table":{for(var U=p(Q.tokens.header),H;!(H=U()).done;){var Y=H.value;de.walkTokens(Y,me)}for(var pe=p(Q.tokens.cells),Ee;!(Ee=pe()).done;)for(var Ce=Ee.value,ne=p(Ce),De;!(De=ne()).done;){var Ae=De.value;de.walkTokens(Ae,me)}break}case"list":{de.walkTokens(Q.items,me);break}default:Q.tokens&&de.walkTokens(Q.tokens,me)}}},de.parseInline=function(he,me){if(typeof he=="undefined"||he===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof he!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(he)+", string expected");me=ze({},de.defaults,me||{}),He(me);try{var fe=je.lexInline(he,me);return me.walkTokens&&de.walkTokens(fe,me.walkTokens),Me.parseInline(fe,me)}catch(V){if(V.message+=`
Please report this to https://github.com/markedjs/marked.`,me.silent)return"<p>An error occurred:</p><pre>"+xe(V.message+"",!0)+"</pre>";throw V}},de.Parser=Me,de.parser=Me.parse,de.Renderer=Ye,de.TextRenderer=ge,de.Lexer=je,de.lexer=je.lex,de.Tokenizer=z,de.Slugger=Ie,de.parse=de;var Ue=de;return Ue}),define(le[114],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function E(I,_,m){return Math.min(Math.max(I,_),m)}e.clamp=E;function P(I,_){return(_+I%_)%_}e.rot=P;class p{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=p;class D{constructor(){this._n=1,this._val=0}update(_){return this._val=this._val+(_-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=D}),function(){function x(p){const D=[];typeof p=="number"&&D.push("code/timeOrigin",p);function I(m){D.push(m,Date.now())}function _(){const m=[];for(let y=0;y<D.length;y+=2)m.push({name:D[y],startTime:D[y+1]});return m}return{mark:I,getMarks:_}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?x():{mark(p){performance.mark(p)},getMarks(){let p=performance.timeOrigin;typeof p!="number"&&(p=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const D=[{name:"code/timeOrigin",startTime:Math.round(p)}];for(const I of performance.getEntriesByType("mark"))D.push({name:I.name,startTime:Math.round(p+I.startTime)});return D}};if(typeof process=="object"){const p=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return x(p)}else return console.trace("perf-util loaded in UNKNOWN environment"),x()}function E(p){return p.MonacoPerformanceMarks||(p.MonacoPerformanceMarks=e()),p.MonacoPerformanceMarks}var P;typeof global=="object"?P=global:typeof self=="object"?P=self:P={},typeof define=="function"?define("vs/base/common/performance",[],function(){return E(P)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=E(P):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),P.perf=E(P))}(),define(le[5],ce([0,1]),function(x,e){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isPreferringBrowserCodeLoad=e.browserCodeLoadingCacheStrategy=e.isElectronSandboxed=e.globals=void 0;const P="en";let p=!1,D=!1,I=!1,_=!1,m=!1,y=!1,r=!1,k,d=P,b,f;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let c;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?c=e.globals.vscode.process:typeof process!="undefined"&&(c=process);const S=typeof((E=c==null?void 0:c.versions)===null||E===void 0?void 0:E.electron)=="string"&&c.type==="renderer";if(e.isElectronSandboxed=S&&(c==null?void 0:c.sandboxed),e.browserCodeLoadingCacheStrategy=(()=>{if(e.isElectronSandboxed)return"bypassHeatCheck";const s=c==null?void 0:c.env.VSCODE_BROWSER_CODE_LOADING;if(typeof s=="string")return s==="none"||s==="code"||s==="bypassHeatCheck"||s==="bypassHeatCheckAndEagerCompile"?s:"bypassHeatCheck"})(),e.isPreferringBrowserCodeLoad=typeof e.browserCodeLoadingCacheStrategy=="string",typeof navigator=="object"&&!S)f=navigator.userAgent,p=f.indexOf("Windows")>=0,D=f.indexOf("Macintosh")>=0,r=(f.indexOf("Macintosh")>=0||f.indexOf("iPad")>=0||f.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,I=f.indexOf("Linux")>=0,y=!0,k=navigator.language,d=k;else if(typeof c=="object"){p=c.platform==="win32",D=c.platform==="darwin",I=c.platform==="linux",_=I&&!!c.env.SNAP&&!!c.env.SNAP_REVISION,k=P,d=P;const s=c.env.VSCODE_NLS_CONFIG;if(s)try{const u=JSON.parse(s),g=u.availableLanguages["*"];k=u.locale,d=g||P,b=u._translationsConfigFile}catch(u){}m=!0}else console.error("Unable to resolve platform.");var w;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(w=e.Platform||(e.Platform={}));function C(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=C;let h=0;D?h=1:p?h=3:I&&(h=2),e.isWindows=p,e.isMacintosh=D,e.isLinux=I,e.isLinuxSnap=_,e.isNative=m,e.isWeb=y,e.isIOS=r,e.platform=h,e.userAgent=f,e.language=d;var l;(function(s){function u(){return e.language}s.value=u;function g(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=g;function v(){return e.language==="en"}s.isDefault=v})(l=e.Language||(e.Language={})),e.locale=k,e.translationsConfigFile=b,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let g=[];e.globals.addEventListener("message",T=>{if(T.data&&T.data.vscodeSetImmediateId)for(let R=0,o=g.length;R<o;R++){const F=g[R];if(F.id===T.data.vscodeSetImmediateId){g.splice(R,1),F.callback();return}}});let v=0;return T=>{const R=++v;g.push({id:R,callback:T}),e.globals.postMessage({vscodeSetImmediateId:R},"*")}}if(typeof(c==null?void 0:c.nextTick)=="function")return c.nextTick.bind(c);const u=Promise.resolve();return g=>u.then(g)}();var a;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(a=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||r?2:p?1:3;let t=!0,i=!1;function n(){if(!i){i=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,t=new Uint16Array(s.buffer)[0]===(2<<8)+1}return t}e.isLittleEndian=n}),define(le[23],ce([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nextTick=e.platform=e.env=e.cwd=void 0;let P;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const p=E.globals.vscode.process;P={get platform(){return p.platform},get env(){return p.env},cwd(){return p.cwd()},nextTick(D){return E.setImmediate(D)}}}else typeof process!="undefined"?P={get platform(){return process.platform},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(p){return process.nextTick(p)}}:P={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},nextTick(p){return E.setImmediate(p)},get env(){return{}},cwd(){return"/"}};e.cwd=P.cwd,e.env=P.env,e.platform=P.platform,e.nextTick=P.nextTick}),define(le[3],ce([0,1,23]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const P=65,p=97,D=90,I=122,_=46,m=47,y=92,r=58,k=63;class d extends Error{constructor(l,a,t){let i;typeof a=="string"&&a.indexOf("not ")===0?(i="must not be",a=a.replace(/^not /,"")):i="must be";const n=l.indexOf(".")!==-1?"property":"argument";let s=`The "${l}" ${n} ${i} of type ${a}`;s+=`. Received type ${typeof t}`,super(s),this.code="ERR_INVALID_ARG_TYPE"}}function b(h,l){if(typeof h!="string")throw new d(l,"string",h)}function f(h){return h===m||h===y}function c(h){return h===m}function S(h){return h>=P&&h<=D||h>=p&&h<=I}function w(h,l,a,t){let i="",n=0,s=-1,u=0,g=0;for(let v=0;v<=h.length;++v){if(v<h.length)g=h.charCodeAt(v);else{if(t(g))break;g=m}if(t(g)){if(!(s===v-1||u===1))if(u===2){if(i.length<2||n!==2||i.charCodeAt(i.length-1)!==_||i.charCodeAt(i.length-2)!==_){if(i.length>2){const T=i.lastIndexOf(a);T===-1?(i="",n=0):(i=i.slice(0,T),n=i.length-1-i.lastIndexOf(a)),s=v,u=0;continue}else if(i.length!==0){i="",n=0,s=v,u=0;continue}}l&&(i+=i.length>0?`${a}..`:"..",n=2)}else i.length>0?i+=`${a}${h.slice(s+1,v)}`:i=h.slice(s+1,v),n=v-s-1;s=v,u=0}else g===_&&u!==-1?++u:u=-1}return i}function C(h,l){if(l===null||typeof l!="object")throw new d("pathObject","Object",l);const a=l.dir||l.root,t=l.base||`${l.name||""}${l.ext||""}`;return a?a===l.root?`${a}${t}`:`${a}${h}${t}`:t}e.win32={resolve(...h){let l="",a="",t=!1;for(let i=h.length-1;i>=-1;i--){let n;if(i>=0){if(n=h[i],b(n,"path"),n.length===0)continue}else l.length===0?n=E.cwd():(n=E.env[`=${l}`]||E.cwd(),(n===void 0||n.slice(0,2).toLowerCase()!==l.toLowerCase()&&n.charCodeAt(2)===y)&&(n=`${l}\\`));const s=n.length;let u=0,g="",v=!1;const T=n.charCodeAt(0);if(s===1)f(T)&&(u=1,v=!0);else if(f(T))if(v=!0,f(n.charCodeAt(1))){let R=2,o=R;for(;R<s&&!f(n.charCodeAt(R));)R++;if(R<s&&R!==o){const F=n.slice(o,R);for(o=R;R<s&&f(n.charCodeAt(R));)R++;if(R<s&&R!==o){for(o=R;R<s&&!f(n.charCodeAt(R));)R++;(R===s||R!==o)&&(g=`\\\\${F}\\${n.slice(o,R)}`,u=R)}}}else u=1;else S(T)&&n.charCodeAt(1)===r&&(g=n.slice(0,2),u=2,s>2&&f(n.charCodeAt(2))&&(v=!0,u=3));if(g.length>0)if(l.length>0){if(g.toLowerCase()!==l.toLowerCase())continue}else l=g;if(t){if(l.length>0)break}else if(a=`${n.slice(u)}\\${a}`,t=v,v&&l.length>0)break}return a=w(a,!t,"\\",f),t?`${l}\\${a}`:`${l}${a}`||"."},normalize(h){b(h,"path");const l=h.length;if(l===0)return".";let a=0,t,i=!1;const n=h.charCodeAt(0);if(l===1)return c(n)?"\\":h;if(f(n))if(i=!0,f(h.charCodeAt(1))){let u=2,g=u;for(;u<l&&!f(h.charCodeAt(u));)u++;if(u<l&&u!==g){const v=h.slice(g,u);for(g=u;u<l&&f(h.charCodeAt(u));)u++;if(u<l&&u!==g){for(g=u;u<l&&!f(h.charCodeAt(u));)u++;if(u===l)return`\\\\${v}\\${h.slice(g)}\\`;u!==g&&(t=`\\\\${v}\\${h.slice(g,u)}`,a=u)}}}else a=1;else S(n)&&h.charCodeAt(1)===r&&(t=h.slice(0,2),a=2,l>2&&f(h.charCodeAt(2))&&(i=!0,a=3));let s=a<l?w(h.slice(a),!i,"\\",f):"";return s.length===0&&!i&&(s="."),s.length>0&&f(h.charCodeAt(l-1))&&(s+="\\"),t===void 0?i?`\\${s}`:s:i?`${t}\\${s}`:`${t}${s}`},isAbsolute(h){b(h,"path");const l=h.length;if(l===0)return!1;const a=h.charCodeAt(0);return f(a)||l>2&&S(a)&&h.charCodeAt(1)===r&&f(h.charCodeAt(2))},join(...h){if(h.length===0)return".";let l,a;for(let n=0;n<h.length;++n){const s=h[n];b(s,"path"),s.length>0&&(l===void 0?l=a=s:l+=`\\${s}`)}if(l===void 0)return".";let t=!0,i=0;if(typeof a=="string"&&f(a.charCodeAt(0))){++i;const n=a.length;n>1&&f(a.charCodeAt(1))&&(++i,n>2&&(f(a.charCodeAt(2))?++i:t=!1))}if(t){for(;i<l.length&&f(l.charCodeAt(i));)i++;i>=2&&(l=`\\${l.slice(i)}`)}return e.win32.normalize(l)},relative(h,l){if(b(h,"from"),b(l,"to"),h===l)return"";const a=e.win32.resolve(h),t=e.win32.resolve(l);if(a===t||(h=a.toLowerCase(),l=t.toLowerCase(),h===l))return"";let i=0;for(;i<h.length&&h.charCodeAt(i)===y;)i++;let n=h.length;for(;n-1>i&&h.charCodeAt(n-1)===y;)n--;const s=n-i;let u=0;for(;u<l.length&&l.charCodeAt(u)===y;)u++;let g=l.length;for(;g-1>u&&l.charCodeAt(g-1)===y;)g--;const v=g-u,T=s<v?s:v;let R=-1,o=0;for(;o<T;o++){const B=h.charCodeAt(i+o);if(B!==l.charCodeAt(u+o))break;B===y&&(R=o)}if(o!==T){if(R===-1)return t}else{if(v>T){if(l.charCodeAt(u+o)===y)return t.slice(u+o+1);if(o===2)return t.slice(u+o)}s>T&&(h.charCodeAt(i+o)===y?R=o:o===2&&(R=3)),R===-1&&(R=0)}let F="";for(o=i+R+1;o<=n;++o)(o===n||h.charCodeAt(o)===y)&&(F+=F.length===0?"..":"\\..");return u+=R,F.length>0?`${F}${t.slice(u,g)}`:(t.charCodeAt(u)===y&&++u,t.slice(u,g))},toNamespacedPath(h){if(typeof h!="string")return h;if(h.length===0)return"";const l=e.win32.resolve(h);if(l.length<=2)return h;if(l.charCodeAt(0)===y){if(l.charCodeAt(1)===y){const a=l.charCodeAt(2);if(a!==k&&a!==_)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(S(l.charCodeAt(0))&&l.charCodeAt(1)===r&&l.charCodeAt(2)===y)return`\\\\?\\${l}`;return h},dirname(h){b(h,"path");const l=h.length;if(l===0)return".";let a=-1,t=0;const i=h.charCodeAt(0);if(l===1)return f(i)?h:".";if(f(i)){if(a=t=1,f(h.charCodeAt(1))){let u=2,g=u;for(;u<l&&!f(h.charCodeAt(u));)u++;if(u<l&&u!==g){for(g=u;u<l&&f(h.charCodeAt(u));)u++;if(u<l&&u!==g){for(g=u;u<l&&!f(h.charCodeAt(u));)u++;if(u===l)return h;u!==g&&(a=t=u+1)}}}}else S(i)&&h.charCodeAt(1)===r&&(a=l>2&&f(h.charCodeAt(2))?3:2,t=a);let n=-1,s=!0;for(let u=l-1;u>=t;--u)if(f(h.charCodeAt(u))){if(!s){n=u;break}}else s=!1;if(n===-1){if(a===-1)return".";n=a}return h.slice(0,n)},basename(h,l){l!==void 0&&b(l,"ext"),b(h,"path");let a=0,t=-1,i=!0,n;if(h.length>=2&&S(h.charCodeAt(0))&&h.charCodeAt(1)===r&&(a=2),l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let s=l.length-1,u=-1;for(n=h.length-1;n>=a;--n){const g=h.charCodeAt(n);if(f(g)){if(!i){a=n+1;break}}else u===-1&&(i=!1,u=n+1),s>=0&&(g===l.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=u))}return a===t?t=u:t===-1&&(t=h.length),h.slice(a,t)}for(n=h.length-1;n>=a;--n)if(f(h.charCodeAt(n))){if(!i){a=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":h.slice(a,t)},extname(h){b(h,"path");let l=0,a=-1,t=0,i=-1,n=!0,s=0;h.length>=2&&h.charCodeAt(1)===r&&S(h.charCodeAt(0))&&(l=t=2);for(let u=h.length-1;u>=l;--u){const g=h.charCodeAt(u);if(f(g)){if(!n){t=u+1;break}continue}i===-1&&(n=!1,i=u+1),g===_?a===-1?a=u:s!==1&&(s=1):a!==-1&&(s=-1)}return a===-1||i===-1||s===0||s===1&&a===i-1&&a===t+1?"":h.slice(a,i)},format:C.bind(null,"\\"),parse(h){b(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const a=h.length;let t=0,i=h.charCodeAt(0);if(a===1)return f(i)?(l.root=l.dir=h,l):(l.base=l.name=h,l);if(f(i)){if(t=1,f(h.charCodeAt(1))){let R=2,o=R;for(;R<a&&!f(h.charCodeAt(R));)R++;if(R<a&&R!==o){for(o=R;R<a&&f(h.charCodeAt(R));)R++;if(R<a&&R!==o){for(o=R;R<a&&!f(h.charCodeAt(R));)R++;R===a?t=R:R!==o&&(t=R+1)}}}}else if(S(i)&&h.charCodeAt(1)===r){if(a<=2)return l.root=l.dir=h,l;if(t=2,f(h.charCodeAt(2))){if(a===3)return l.root=l.dir=h,l;t=3}}t>0&&(l.root=h.slice(0,t));let n=-1,s=t,u=-1,g=!0,v=h.length-1,T=0;for(;v>=t;--v){if(i=h.charCodeAt(v),f(i)){if(!g){s=v+1;break}continue}u===-1&&(g=!1,u=v+1),i===_?n===-1?n=v:T!==1&&(T=1):n!==-1&&(T=-1)}return u!==-1&&(n===-1||T===0||T===1&&n===u-1&&n===s+1?l.base=l.name=h.slice(s,u):(l.name=h.slice(s,n),l.base=h.slice(s,u),l.ext=h.slice(n,u))),s>0&&s!==t?l.dir=h.slice(0,s-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...h){let l="",a=!1;for(let t=h.length-1;t>=-1&&!a;t--){const i=t>=0?h[t]:E.cwd();b(i,"path"),i.length!==0&&(l=`${i}/${l}`,a=i.charCodeAt(0)===m)}return l=w(l,!a,"/",c),a?`/${l}`:l.length>0?l:"."},normalize(h){if(b(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===m,a=h.charCodeAt(h.length-1)===m;return h=w(h,!l,"/",c),h.length===0?l?"/":a?"./":".":(a&&(h+="/"),l?`/${h}`:h)},isAbsolute(h){return b(h,"path"),h.length>0&&h.charCodeAt(0)===m},join(...h){if(h.length===0)return".";let l;for(let a=0;a<h.length;++a){const t=h[a];b(t,"path"),t.length>0&&(l===void 0?l=t:l+=`/${t}`)}return l===void 0?".":e.posix.normalize(l)},relative(h,l){if(b(h,"from"),b(l,"to"),h===l||(h=e.posix.resolve(h),l=e.posix.resolve(l),h===l))return"";const a=1,t=h.length,i=t-a,n=1,s=l.length-n,u=i<s?i:s;let g=-1,v=0;for(;v<u;v++){const R=h.charCodeAt(a+v);if(R!==l.charCodeAt(n+v))break;R===m&&(g=v)}if(v===u)if(s>u){if(l.charCodeAt(n+v)===m)return l.slice(n+v+1);if(v===0)return l.slice(n+v)}else i>u&&(h.charCodeAt(a+v)===m?g=v:v===0&&(g=0));let T="";for(v=a+g+1;v<=t;++v)(v===t||h.charCodeAt(v)===m)&&(T+=T.length===0?"..":"/..");return`${T}${l.slice(n+g)}`},toNamespacedPath(h){return h},dirname(h){if(b(h,"path"),h.length===0)return".";const l=h.charCodeAt(0)===m;let a=-1,t=!0;for(let i=h.length-1;i>=1;--i)if(h.charCodeAt(i)===m){if(!t){a=i;break}}else t=!1;return a===-1?l?"/":".":l&&a===1?"//":h.slice(0,a)},basename(h,l){l!==void 0&&b(l,"ext"),b(h,"path");let a=0,t=-1,i=!0,n;if(l!==void 0&&l.length>0&&l.length<=h.length){if(l===h)return"";let s=l.length-1,u=-1;for(n=h.length-1;n>=0;--n){const g=h.charCodeAt(n);if(g===m){if(!i){a=n+1;break}}else u===-1&&(i=!1,u=n+1),s>=0&&(g===l.charCodeAt(s)?--s==-1&&(t=n):(s=-1,t=u))}return a===t?t=u:t===-1&&(t=h.length),h.slice(a,t)}for(n=h.length-1;n>=0;--n)if(h.charCodeAt(n)===m){if(!i){a=n+1;break}}else t===-1&&(i=!1,t=n+1);return t===-1?"":h.slice(a,t)},extname(h){b(h,"path");let l=-1,a=0,t=-1,i=!0,n=0;for(let s=h.length-1;s>=0;--s){const u=h.charCodeAt(s);if(u===m){if(!i){a=s+1;break}continue}t===-1&&(i=!1,t=s+1),u===_?l===-1?l=s:n!==1&&(n=1):l!==-1&&(n=-1)}return l===-1||t===-1||n===0||n===1&&l===t-1&&l===a+1?"":h.slice(l,t)},format:C.bind(null,"/"),parse(h){b(h,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(h.length===0)return l;const a=h.charCodeAt(0)===m;let t;a?(l.root="/",t=1):t=0;let i=-1,n=0,s=-1,u=!0,g=h.length-1,v=0;for(;g>=t;--g){const T=h.charCodeAt(g);if(T===m){if(!u){n=g+1;break}continue}s===-1&&(u=!1,s=g+1),T===_?i===-1?i=g:v!==1&&(v=1):i!==-1&&(v=-1)}if(s!==-1){const T=n===0&&a?1:n;i===-1||v===0||v===1&&i===s-1&&i===n+1?l.base=l.name=h.slice(T,s):(l.name=h.slice(T,i),l.base=h.slice(T,s),l.ext=h.slice(i,s))}return n>0?l.dir=h.slice(0,n-1):a&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=E.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=E.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=E.platform==="win32"?e.win32.join:e.posix.join,e.resolve=E.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=E.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=E.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=E.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=E.platform==="win32"?e.win32.extname:e.posix.extname,e.format=E.platform==="win32"?e.win32.format:e.posix.format,e.parse=E.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=E.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=E.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=E.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(le[115],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var E;(function(D){D[D.stdout=0]="stdout",D[D.stderr=1]="stderr"})(E=e.Source||(e.Source={}));var P;(function(D){D[D.Success=0]="Success",D[D.Unknown=1]="Unknown",D[D.AccessDenied=2]="AccessDenied",D[D.ProcessNotFound=3]="ProcessNotFound"})(P=e.TerminateResponseCode||(e.TerminateResponseCode={}));function p(D,...I){const _=I.reduce((r,k)=>(r[k]=!0,r),{}),m=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(D).filter(r=>!_[r]).forEach(r=>{for(let k=0;k<m.length;k++)if(r.search(m[k])!==-1){delete D[r];break}})}e.sanitizeProcessEnvironment=p}),function(x,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var E=e();for(var P in E)(typeof exports=="object"?exports:x)[P]=E[P]}}(typeof self!="undefined"?self:this,function(){return function(x){var e={};function E(P){if(e[P])return e[P].exports;var p=e[P]={i:P,l:!1,exports:{}};return x[P].call(p.exports,p,p.exports,E),p.l=!0,p.exports}return E.m=x,E.c=e,E.d=function(P,p,D){E.o(P,p)||Object.defineProperty(P,p,{enumerable:!0,get:D})},E.r=function(P){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(P,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(P,"__esModule",{value:!0})},E.t=function(P,p){if(1&p&&(P=E(P)),8&p||4&p&&typeof P=="object"&&P&&P.__esModule)return P;var D=Object.create(null);if(E.r(D),Object.defineProperty(D,"default",{enumerable:!0,value:P}),2&p&&typeof P!="string")for(var I in P)E.d(D,I,function(_){return P[_]}.bind(null,I));return D},E.n=function(P){var p=P&&P.__esModule?function(){return P.default}:function(){return P};return E.d(p,"a",p),p},E.o=function(P,p){return Object.prototype.hasOwnProperty.call(P,p)},E.p="",E(E.s=0)}([function(x,e,E){(function(P){var p;e=x.exports=se,p=typeof P=="object"&&P.env&&P.env.NODE_DEBUG&&/\bsemver\b/i.test(P.env.NODE_DEBUG)?function(){var te=Array.prototype.slice.call(arguments,0);te.unshift("SEMVER"),console.log.apply(console,te)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var D=256,I=Number.MAX_SAFE_INTEGER||9007199254740991,_=e.re=[],m=e.src=[],y=0,r=y++;m[r]="0|[1-9]\\d*";var k=y++;m[k]="[0-9]+";var d=y++;m[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var b=y++;m[b]="("+m[r]+")\\.("+m[r]+")\\.("+m[r]+")";var f=y++;m[f]="("+m[k]+")\\.("+m[k]+")\\.("+m[k]+")";var c=y++;m[c]="(?:"+m[r]+"|"+m[d]+")";var S=y++;m[S]="(?:"+m[k]+"|"+m[d]+")";var w=y++;m[w]="(?:-("+m[c]+"(?:\\."+m[c]+")*))";var C=y++;m[C]="(?:-?("+m[S]+"(?:\\."+m[S]+")*))";var h=y++;m[h]="[0-9A-Za-z-]+";var l=y++;m[l]="(?:\\+("+m[h]+"(?:\\."+m[h]+")*))";var a=y++,t="v?"+m[b]+m[w]+"?"+m[l]+"?";m[a]="^"+t+"$";var i="[v=\\s]*"+m[f]+m[C]+"?"+m[l]+"?",n=y++;m[n]="^"+i+"$";var s=y++;m[s]="((?:<|>)?=?)";var u=y++;m[u]=m[k]+"|x|X|\\*";var g=y++;m[g]=m[r]+"|x|X|\\*";var v=y++;m[v]="[v=\\s]*("+m[g]+")(?:\\.("+m[g]+")(?:\\.("+m[g]+")(?:"+m[w]+")?"+m[l]+"?)?)?";var T=y++;m[T]="[v=\\s]*("+m[u]+")(?:\\.("+m[u]+")(?:\\.("+m[u]+")(?:"+m[C]+")?"+m[l]+"?)?)?";var R=y++;m[R]="^"+m[s]+"\\s*"+m[v]+"$";var o=y++;m[o]="^"+m[s]+"\\s*"+m[T]+"$";var F=y++;m[F]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var B=y++;m[B]="(?:~>?)";var Z=y++;m[Z]="(\\s*)"+m[B]+"\\s+",_[Z]=new RegExp(m[Z],"g");var ie=y++;m[ie]="^"+m[B]+m[v]+"$";var Se=y++;m[Se]="^"+m[B]+m[T]+"$";var oe=y++;m[oe]="(?:\\^)";var q=y++;m[q]="(\\s*)"+m[oe]+"\\s+",_[q]=new RegExp(m[q],"g");var ee=y++;m[ee]="^"+m[oe]+m[v]+"$";var G=y++;m[G]="^"+m[oe]+m[T]+"$";var z=y++;m[z]="^"+m[s]+"\\s*("+i+")$|^$";var L=y++;m[L]="^"+m[s]+"\\s*("+t+")$|^$";var A=y++;m[A]="(\\s*)"+m[s]+"\\s*("+i+"|"+m[v]+")",_[A]=new RegExp(m[A],"g");var N=y++;m[N]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var M=y++;m[M]="^\\s*("+m[T]+")\\s+-\\s+("+m[T]+")\\s*$";var W=y++;m[W]="(<|>)?=?\\s*\\*";for(var X=0;X<35;X++)p(X,m[X]),_[X]||(_[X]=new RegExp(m[X]));function ae(te,ve){if(te instanceof se)return te;if(typeof te!="string"||te.length>D||!(ve?_[n]:_[a]).test(te))return null;try{return new se(te,ve)}catch(de){return null}}function se(te,ve){if(te instanceof se){if(te.loose===ve)return te;te=te.version}else if(typeof te!="string")throw new TypeError("Invalid Version: "+te);if(te.length>D)throw new TypeError("version is longer than "+D+" characters");if(!(this instanceof se))return new se(te,ve);p("SemVer",te,ve),this.loose=ve;var de=te.trim().match(ve?_[n]:_[a]);if(!de)throw new TypeError("Invalid Version: "+te);if(this.raw=te,this.major=+de[1],this.minor=+de[2],this.patch=+de[3],this.major>I||this.major<0)throw new TypeError("Invalid major version");if(this.minor>I||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>I||this.patch<0)throw new TypeError("Invalid patch version");de[4]?this.prerelease=de[4].split(".").map(function(Ue){if(/^[0-9]+$/.test(Ue)){var he=+Ue;if(he>=0&&he<I)return he}return Ue}):this.prerelease=[],this.build=de[5]?de[5].split("."):[],this.format()}e.parse=ae,e.valid=function(te,ve){var de=ae(te,ve);return de?de.version:null},e.clean=function(te,ve){var de=ae(te.trim().replace(/^[=v]+/,""),ve);return de?de.version:null},e.SemVer=se,se.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},se.prototype.toString=function(){return this.version},se.prototype.compare=function(te){return p("SemVer.compare",this.version,this.loose,te),te instanceof se||(te=new se(te,this.loose)),this.compareMain(te)||this.comparePre(te)},se.prototype.compareMain=function(te){return te instanceof se||(te=new se(te,this.loose)),ke(this.major,te.major)||ke(this.minor,te.minor)||ke(this.patch,te.patch)},se.prototype.comparePre=function(te){if(te instanceof se||(te=new se(te,this.loose)),this.prerelease.length&&!te.prerelease.length)return-1;if(!this.prerelease.length&&te.prerelease.length)return 1;if(!this.prerelease.length&&!te.prerelease.length)return 0;var ve=0;do{var de=this.prerelease[ve],Ue=te.prerelease[ve];if(p("prerelease compare",ve,de,Ue),de===void 0&&Ue===void 0)return 0;if(Ue===void 0)return 1;if(de===void 0)return-1;if(de!==Ue)return ke(de,Ue)}while(++ve)},se.prototype.inc=function(te,ve){switch(te){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",ve);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",ve);break;case"prepatch":this.prerelease.length=0,this.inc("patch",ve),this.inc("pre",ve);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",ve),this.inc("pre",ve);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var de=this.prerelease.length;--de>=0;)typeof this.prerelease[de]=="number"&&(this.prerelease[de]++,de=-2);de===-1&&this.prerelease.push(0)}ve&&(this.prerelease[0]===ve?isNaN(this.prerelease[1])&&(this.prerelease=[ve,0]):this.prerelease=[ve,0]);break;default:throw new Error("invalid increment argument: "+te)}return this.format(),this.raw=this.version,this},e.inc=function(te,ve,de,Ue){typeof de=="string"&&(Ue=de,de=void 0);try{return new se(te,de).inc(ve,Ue).version}catch(he){return null}},e.diff=function(te,ve){if(Xe(te,ve))return null;var de=ae(te),Ue=ae(ve);if(de.prerelease.length||Ue.prerelease.length){for(var he in de)if((he==="major"||he==="minor"||he==="patch")&&de[he]!==Ue[he])return"pre"+he;return"prerelease"}for(var he in de)if((he==="major"||he==="minor"||he==="patch")&&de[he]!==Ue[he])return he},e.compareIdentifiers=ke;var be=/^[0-9]+$/;function ke(te,ve){var de=be.test(te),Ue=be.test(ve);return de&&Ue&&(te=+te,ve=+ve),de&&!Ue?-1:Ue&&!de?1:te<ve?-1:te>ve?1:0}function Te(te,ve,de){return new se(te,de).compare(new se(ve,de))}function Le(te,ve,de){return Te(te,ve,de)>0}function je(te,ve,de){return Te(te,ve,de)<0}function Xe(te,ve,de){return Te(te,ve,de)===0}function Ze(te,ve,de){return Te(te,ve,de)!==0}function it(te,ve,de){return Te(te,ve,de)>=0}function Ye(te,ve,de){return Te(te,ve,de)<=0}function ge(te,ve,de,Ue){var he;switch(ve){case"===":typeof te=="object"&&(te=te.version),typeof de=="object"&&(de=de.version),he=te===de;break;case"!==":typeof te=="object"&&(te=te.version),typeof de=="object"&&(de=de.version),he=te!==de;break;case"":case"=":case"==":he=Xe(te,de,Ue);break;case"!=":he=Ze(te,de,Ue);break;case">":he=Le(te,de,Ue);break;case">=":he=it(te,de,Ue);break;case"<":he=je(te,de,Ue);break;case"<=":he=Ye(te,de,Ue);break;default:throw new TypeError("Invalid operator: "+ve)}return he}function Ie(te,ve){if(te instanceof Ie){if(te.loose===ve)return te;te=te.value}if(!(this instanceof Ie))return new Ie(te,ve);p("comparator",te,ve),this.loose=ve,this.parse(te),this.semver===_e?this.value="":this.value=this.operator+this.semver.version,p("comp",this)}e.rcompareIdentifiers=function(te,ve){return ke(ve,te)},e.major=function(te,ve){return new se(te,ve).major},e.minor=function(te,ve){return new se(te,ve).minor},e.patch=function(te,ve){return new se(te,ve).patch},e.compare=Te,e.compareLoose=function(te,ve){return Te(te,ve,!0)},e.rcompare=function(te,ve,de){return Te(ve,te,de)},e.sort=function(te,ve){return te.sort(function(de,Ue){return e.compare(de,Ue,ve)})},e.rsort=function(te,ve){return te.sort(function(de,Ue){return e.rcompare(de,Ue,ve)})},e.gt=Le,e.lt=je,e.eq=Xe,e.neq=Ze,e.gte=it,e.lte=Ye,e.cmp=ge,e.Comparator=Ie;var _e={};function Re(te,ve){if(te instanceof Re)return te.loose===ve?te:new Re(te.raw,ve);if(te instanceof Ie)return new Re(te.value,ve);if(!(this instanceof Re))return new Re(te,ve);if(this.loose=ve,this.raw=te,this.set=te.split(/\s*\|\|\s*/).map(function(de){return this.parseRange(de.trim())},this).filter(function(de){return de.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+te);this.format()}function Me(te){return!te||te.toLowerCase()==="x"||te==="*"}function ze(te,ve,de,Ue,he,me,fe,V,Q,U,H,Y,pe){return((ve=Me(de)?"":Me(Ue)?">="+de+".0.0":Me(he)?">="+de+"."+Ue+".0":">="+ve)+" "+(V=Me(Q)?"":Me(U)?"<"+(+Q+1)+".0.0":Me(H)?"<"+Q+"."+(+U+1)+".0":Y?"<="+Q+"."+U+"."+H+"-"+Y:"<="+V)).trim()}function He(te,ve){for(var de=0;de<te.length;de++)if(!te[de].test(ve))return!1;if(ve.prerelease.length){for(de=0;de<te.length;de++)if(p(te[de].semver),te[de].semver!==_e&&te[de].semver.prerelease.length>0){var Ue=te[de].semver;if(Ue.major===ve.major&&Ue.minor===ve.minor&&Ue.patch===ve.patch)return!0}return!1}return!0}function xe(te,ve,de){try{ve=new Re(ve,de)}catch(Ue){return!1}return ve.test(te)}function tt(te,ve,de,Ue){var he,me,fe,V,Q;switch(te=new se(te,Ue),ve=new Re(ve,Ue),de){case">":he=Le,me=Ye,fe=je,V=">",Q=">=";break;case"<":he=je,me=it,fe=Le,V="<",Q="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(te,ve,Ue))return!1;for(var U=0;U<ve.set.length;++U){var H=ve.set[U],Y=null,pe=null;if(H.forEach(function(Ee){Ee.semver===_e&&(Ee=new Ie(">=0.0.0")),Y=Y||Ee,pe=pe||Ee,he(Ee.semver,Y.semver,Ue)?Y=Ee:fe(Ee.semver,pe.semver,Ue)&&(pe=Ee)}),Y.operator===V||Y.operator===Q||(!pe.operator||pe.operator===V)&&me(te,pe.semver)||pe.operator===Q&&fe(te,pe.semver))return!1}return!0}Ie.prototype.parse=function(te){var ve=this.loose?_[z]:_[L],de=te.match(ve);if(!de)throw new TypeError("Invalid comparator: "+te);this.operator=de[1],this.operator==="="&&(this.operator=""),de[2]?this.semver=new se(de[2],this.loose):this.semver=_e},Ie.prototype.toString=function(){return this.value},Ie.prototype.test=function(te){return p("Comparator.test",te,this.loose),this.semver===_e||(typeof te=="string"&&(te=new se(te,this.loose)),ge(te,this.operator,this.semver,this.loose))},Ie.prototype.intersects=function(te,ve){if(!(te instanceof Ie))throw new TypeError("a Comparator is required");var de;if(this.operator==="")return de=new Re(te.value,ve),xe(this.value,de,ve);if(te.operator==="")return de=new Re(this.value,ve),xe(te.semver,de,ve);var Ue=!(this.operator!==">="&&this.operator!==">"||te.operator!==">="&&te.operator!==">"),he=!(this.operator!=="<="&&this.operator!=="<"||te.operator!=="<="&&te.operator!=="<"),me=this.semver.version===te.semver.version,fe=!(this.operator!==">="&&this.operator!=="<="||te.operator!==">="&&te.operator!=="<="),V=ge(this.semver,"<",te.semver,ve)&&(this.operator===">="||this.operator===">")&&(te.operator==="<="||te.operator==="<"),Q=ge(this.semver,">",te.semver,ve)&&(this.operator==="<="||this.operator==="<")&&(te.operator===">="||te.operator===">");return Ue||he||me&&fe||V||Q},e.Range=Re,Re.prototype.format=function(){return this.range=this.set.map(function(te){return te.join(" ").trim()}).join("||").trim(),this.range},Re.prototype.toString=function(){return this.range},Re.prototype.parseRange=function(te){var ve=this.loose;te=te.trim(),p("range",te,ve);var de=ve?_[M]:_[N];te=te.replace(de,ze),p("hyphen replace",te),te=te.replace(_[A],"$1$2$3"),p("comparator trim",te,_[A]),te=(te=(te=te.replace(_[Z],"$1~")).replace(_[q],"$1^")).split(/\s+/).join(" ");var Ue=ve?_[z]:_[L],he=te.split(" ").map(function(me){return function(fe,V){return p("comp",fe),fe=function(Q,U){return Q.trim().split(/\s+/).map(function(H){return function(Y,pe){p("caret",Y,pe);var Ee=pe?_[G]:_[ee];return Y.replace(Ee,function(Ce,ne,De,Ae,Fe){var Oe;return p("caret",Y,Ce,ne,De,Ae,Fe),Me(ne)?Oe="":Me(De)?Oe=">="+ne+".0.0 <"+(+ne+1)+".0.0":Me(Ae)?Oe=ne==="0"?">="+ne+"."+De+".0 <"+ne+"."+(+De+1)+".0":">="+ne+"."+De+".0 <"+(+ne+1)+".0.0":Fe?(p("replaceCaret pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Oe=ne==="0"?De==="0"?">="+ne+"."+De+"."+Ae+Fe+" <"+ne+"."+De+"."+(+Ae+1):">="+ne+"."+De+"."+Ae+Fe+" <"+ne+"."+(+De+1)+".0":">="+ne+"."+De+"."+Ae+Fe+" <"+(+ne+1)+".0.0"):(p("no pr"),Oe=ne==="0"?De==="0"?">="+ne+"."+De+"."+Ae+" <"+ne+"."+De+"."+(+Ae+1):">="+ne+"."+De+"."+Ae+" <"+ne+"."+(+De+1)+".0":">="+ne+"."+De+"."+Ae+" <"+(+ne+1)+".0.0"),p("caret return",Oe),Oe})}(H,U)}).join(" ")}(fe,V),p("caret",fe),fe=function(Q,U){return Q.trim().split(/\s+/).map(function(H){return function(Y,pe){var Ee=pe?_[Se]:_[ie];return Y.replace(Ee,function(Ce,ne,De,Ae,Fe){var Oe;return p("tilde",Y,Ce,ne,De,Ae,Fe),Me(ne)?Oe="":Me(De)?Oe=">="+ne+".0.0 <"+(+ne+1)+".0.0":Me(Ae)?Oe=">="+ne+"."+De+".0 <"+ne+"."+(+De+1)+".0":Fe?(p("replaceTilde pr",Fe),Fe.charAt(0)!=="-"&&(Fe="-"+Fe),Oe=">="+ne+"."+De+"."+Ae+Fe+" <"+ne+"."+(+De+1)+".0"):Oe=">="+ne+"."+De+"."+Ae+" <"+ne+"."+(+De+1)+".0",p("tilde return",Oe),Oe})}(H,U)}).join(" ")}(fe,V),p("tildes",fe),fe=function(Q,U){return p("replaceXRanges",Q,U),Q.split(/\s+/).map(function(H){return function(Y,pe){Y=Y.trim();var Ee=pe?_[o]:_[R];return Y.replace(Ee,function(Ce,ne,De,Ae,Fe,Oe){p("xRange",Y,Ce,ne,De,Ae,Fe,Oe);var Ge=Me(De),re=Ge||Me(Ae),ue=re||Me(Fe);return ne==="="&&ue&&(ne=""),Ge?Ce=ne===">"||ne==="<"?"<0.0.0":"*":ne&&ue?(re&&(Ae=0),ue&&(Fe=0),ne===">"?(ne=">=",re?(De=+De+1,Ae=0,Fe=0):ue&&(Ae=+Ae+1,Fe=0)):ne==="<="&&(ne="<",re?De=+De+1:Ae=+Ae+1),Ce=ne+De+"."+Ae+"."+Fe):re?Ce=">="+De+".0.0 <"+(+De+1)+".0.0":ue&&(Ce=">="+De+"."+Ae+".0 <"+De+"."+(+Ae+1)+".0"),p("xRange return",Ce),Ce})}(H,U)}).join(" ")}(fe,V),p("xrange",fe),fe=function(Q,U){return p("replaceStars",Q,U),Q.trim().replace(_[W],"")}(fe,V),p("stars",fe),fe}(me,ve)}).join(" ").split(/\s+/);return this.loose&&(he=he.filter(function(me){return!!me.match(Ue)})),he=he.map(function(me){return new Ie(me,ve)})},Re.prototype.intersects=function(te,ve){if(!(te instanceof Re))throw new TypeError("a Range is required");return this.set.some(function(de){return de.every(function(Ue){return te.set.some(function(he){return he.every(function(me){return Ue.intersects(me,ve)})})})})},e.toComparators=function(te,ve){return new Re(te,ve).set.map(function(de){return de.map(function(Ue){return Ue.value}).join(" ").trim().split(" ")})},Re.prototype.test=function(te){if(!te)return!1;typeof te=="string"&&(te=new se(te,this.loose));for(var ve=0;ve<this.set.length;ve++)if(He(this.set[ve],te))return!0;return!1},e.satisfies=xe,e.maxSatisfying=function(te,ve,de){var Ue=null,he=null;try{var me=new Re(ve,de)}catch(fe){return null}return te.forEach(function(fe){me.test(fe)&&(Ue&&he.compare(fe)!==-1||(he=new se(Ue=fe,de)))}),Ue},e.minSatisfying=function(te,ve,de){var Ue=null,he=null;try{var me=new Re(ve,de)}catch(fe){return null}return te.forEach(function(fe){me.test(fe)&&(Ue&&he.compare(fe)!==1||(he=new se(Ue=fe,de)))}),Ue},e.validRange=function(te,ve){try{return new Re(te,ve).range||"*"}catch(de){return null}},e.ltr=function(te,ve,de){return tt(te,ve,"<",de)},e.gtr=function(te,ve,de){return tt(te,ve,">",de)},e.outside=tt,e.prerelease=function(te,ve){var de=ae(te,ve);return de&&de.prerelease.length?de.prerelease:null},e.intersects=function(te,ve,de){return te=new Re(te,de),ve=new Re(ve,de),te.intersects(ve)},e.coerce=function(te){if(te instanceof se)return te;if(typeof te!="string")return null;var ve=te.match(_[F]);return ve==null?null:ae((ve[1]||"0")+"."+(ve[2]||"0")+"."+(ve[3]||"0"))}}).call(this,E(1))},function(x,e){var E,P,p=x.exports={};function D(){throw new Error("setTimeout has not been defined")}function I(){throw new Error("clearTimeout has not been defined")}function _(S){if(E===setTimeout)return setTimeout(S,0);if((E===D||!E)&&setTimeout)return E=setTimeout,setTimeout(S,0);try{return E(S,0)}catch(w){try{return E.call(null,S,0)}catch(C){return E.call(this,S,0)}}}(function(){try{E=typeof setTimeout=="function"?setTimeout:D}catch(S){E=D}try{P=typeof clearTimeout=="function"?clearTimeout:I}catch(S){P=I}})();var m,y=[],r=!1,k=-1;function d(){r&&m&&(r=!1,m.length?y=m.concat(y):k=-1,y.length&&b())}function b(){if(!r){var S=_(d);r=!0;for(var w=y.length;w;){for(m=y,y=[];++k<w;)m&&m[k].run();k=-1,w=y.length}m=null,r=!1,function(C){if(P===clearTimeout)return clearTimeout(C);if((P===I||!P)&&clearTimeout)return P=clearTimeout,clearTimeout(C);try{P(C)}catch(h){try{return P.call(null,C)}catch(l){return P.call(this,C)}}}(S)}}function f(S,w){this.fun=S,this.array=w}function c(){}p.nextTick=function(S){var w=new Array(arguments.length-1);if(arguments.length>1)for(var C=1;C<arguments.length;C++)w[C-1]=arguments[C];y.push(new f(S,w)),y.length!==1||r||_(b)},f.prototype.run=function(){this.fun.apply(null,this.array)},p.title="browser",p.browser=!0,p.env={},p.argv=[],p.version="",p.versions={},p.on=c,p.addListener=c,p.once=c,p.off=c,p.removeListener=c,p.removeAllListeners=c,p.emit=c,p.prependListener=c,p.prependOnceListener=c,p.listeners=function(S){return[]},p.binding=function(S){throw new Error("process.binding is not supported")},p.cwd=function(){return"/"},p.chdir=function(S){throw new Error("process.chdir is not supported")},p.umask=function(){return 0}}])}),define(le[116],ce([0,1,5]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const P=E.globals.performance&&typeof E.globals.performance.now=="function";class p{constructor(I){this._highResolution=P&&I,this._startTime=this._now(),this._stopTime=-1}static create(I=!0){return new p(I)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}e.StopWatch=p}),define(le[7],ce([0,1,12,71,2,72,116]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.PauseableEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var _;(function(w){w.None=()=>p.Disposable.None;function C(oe){return(q,ee=null,G)=>{let z=!1,L;return L=oe(A=>{if(!z)return L?L.dispose():z=!0,q.call(ee,A)},null,G),z&&L.dispose(),L}}w.once=C;function h(oe,q){return s((ee,G=null,z)=>oe(L=>ee.call(G,q(L)),null,z))}w.map=h;function l(oe,q){return s((ee,G=null,z)=>oe(L=>{q(L),ee.call(G,L)},null,z))}w.forEach=l;function a(oe,q){return s((ee,G=null,z)=>oe(L=>q(L)&&ee.call(G,L),null,z))}w.filter=a;function t(oe){return oe}w.signal=t;function i(...oe){return(q,ee=null,G)=>p.combinedDisposable(...oe.map(z=>z(L=>q.call(ee,L),null,G)))}w.any=i;function n(oe,q,ee){let G=ee;return h(oe,z=>(G=q(G,z),G))}w.reduce=n;function s(oe){let q;const ee=new d({onFirstListenerAdd(){q=oe(ee.fire,ee)},onLastListenerRemove(){q.dispose()}});return ee.event}w.snapshot=s;function u(oe,q,ee=100,G=!1,z){let L,A,N,M=0;const W=new d({leakWarningThreshold:z,onFirstListenerAdd(){L=oe(X=>{M++,A=q(A,X),G&&!N&&(W.fire(A),A=void 0),clearTimeout(N),N=setTimeout(()=>{const ae=A;A=void 0,N=void 0,(!G||M>1)&&W.fire(ae),M=0},ee)})},onLastListenerRemove(){L.dispose()}});return W.event}w.debounce=u;function g(oe){const q=new Date().getTime();return h(C(oe),ee=>new Date().getTime()-q)}w.stopwatch=g;function v(oe,q=(ee,G)=>ee===G){let ee=!0,G;return a(oe,z=>{const L=ee||!q(z,G);return ee=!1,G=z,L})}w.latch=v;function T(oe,q){return[w.filter(oe,q),w.filter(oe,ee=>!q(ee))]}w.split=T;function R(oe,q=!1,ee=[]){let G=ee.slice(),z=oe(N=>{G?G.push(N):A.fire(N)});const L=()=>{G&&G.forEach(N=>A.fire(N)),G=null},A=new d({onFirstListenerAdd(){z||(z=oe(N=>A.fire(N)))},onFirstListenerDidAdd(){G&&(q?setTimeout(L):L())},onLastListenerRemove(){z&&z.dispose(),z=null}});return A.event}w.buffer=R;class o{constructor(q){this.event=q}map(q){return new o(h(this.event,q))}forEach(q){return new o(l(this.event,q))}filter(q){return new o(a(this.event,q))}reduce(q,ee){return new o(n(this.event,q,ee))}latch(){return new o(v(this.event))}debounce(q,ee=100,G=!1,z){return new o(u(this.event,q,ee,G,z))}on(q,ee,G){return this.event(q,ee,G)}once(q,ee,G){return C(this.event)(q,ee,G)}}function F(oe){return new o(oe)}w.chain=F;function B(oe,q,ee=G=>G){const G=(...N)=>A.fire(ee(...N)),z=()=>oe.on(q,G),L=()=>oe.removeListener(q,G),A=new d({onFirstListenerAdd:z,onLastListenerRemove:L});return A.event}w.fromNodeEventEmitter=B;function Z(oe,q,ee=G=>G){const G=(...N)=>A.fire(ee(...N)),z=()=>oe.addEventListener(q,G),L=()=>oe.removeEventListener(q,G),A=new d({onFirstListenerAdd:z,onLastListenerRemove:L});return A.event}w.fromDOMEventEmitter=Z;function ie(oe){const q=new d;let ee=!1;return oe.then(void 0,()=>null).then(()=>{ee?q.fire(void 0):setTimeout(()=>q.fire(void 0),0)}),ee=!0,q.event}w.fromPromise=ie;function Se(oe){return new Promise(q=>C(oe)(q))}w.toPromise=Se})(_=e.Event||(e.Event={}));class m{constructor(C){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${C}_${m._idPool++}`}start(C){this._stopWatch=new I.StopWatch(!0),this._listenerCount=C}stop(){if(this._stopWatch){const C=this._stopWatch.elapsed();this._elapsedOverall+=C,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${C.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}m._idPool=0;let y=-1;function r(w){const C=y;return y=w,{dispose(){y=C}}}e.setGlobalLeakWarningThreshold=r;class k{constructor(C,h=Math.random().toString(18).slice(2,5)){this.customThreshold=C,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(C){let h=y;if(typeof this.customThreshold=="number"&&(h=this.customThreshold),h<=0||C<h)return;this._stacks||(this._stacks=new Map);const l=new Error().stack.split(`
`).slice(3).join(`
`),a=this._stacks.get(l)||0;if(this._stacks.set(l,a+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=h*.5;let t,i=0;for(const[n,s]of this._stacks)(!t||i<s)&&(t=n,i=s);console.warn(`[${this.name}] potential listener LEAK detected, having ${C} listeners already. MOST frequent listener (${i}):`),console.warn(t)}return()=>{const t=this._stacks.get(l)||0;this._stacks.set(l,t-1)}}}class d{constructor(C){var h;this._disposed=!1,this._options=C,this._leakageMon=y>0?new k(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=((h=this._options)===null||h===void 0?void 0:h._profName)?new m(this._options._profName):void 0}get event(){return this._event||(this._event=(C,h,l)=>{var a;this._listeners||(this._listeners=new D.LinkedList);const t=this._listeners.isEmpty();t&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const i=this._listeners.push(h?[C,h]:C);t&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,C,h);const n=(a=this._leakageMon)===null||a===void 0?void 0:a.check(this._listeners.size);let s;return s={dispose:()=>{n&&n(),s.dispose=d._noop,this._disposed||(i(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))}},l instanceof p.DisposableStore?l.add(s):Array.isArray(l)&&l.push(s),s}),this._event}fire(C){var h,l;if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new D.LinkedList);for(let a of this._listeners)this._deliveryQueue.push([a,C]);for((h=this._perfMon)===null||h===void 0||h.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[a,t]=this._deliveryQueue.shift();try{typeof a=="function"?a.call(void 0,t):a[0].call(a[1],t)}catch(i){E.onUnexpectedError(i)}}(l=this._perfMon)===null||l===void 0||l.stop()}}dispose(){var C,h,l,a,t;this._disposed||(this._disposed=!0,(C=this._listeners)===null||C===void 0||C.clear(),(h=this._deliveryQueue)===null||h===void 0||h.clear(),(a=(l=this._options)===null||l===void 0?void 0:l.onLastListenerRemove)===null||a===void 0||a.call(l),(t=this._leakageMon)===null||t===void 0||t.dispose())}}e.Emitter=d,d._noop=function(){};class b extends d{constructor(C){super(C);this._isPaused=0,this._eventQueue=new D.LinkedList,this._mergeFn=C==null?void 0:C.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const C=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(C))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(C){this._listeners&&(this._isPaused!==0?this._eventQueue.push(C):super.fire(C))}}e.PauseableEmitter=b;class f{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new d({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(C){const h={event:C,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const l=()=>{this.hasListeners&&this.unhook(h);const a=this.events.indexOf(h);this.events.splice(a,1)};return p.toDisposable(P.once(l))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(C=>this.hook(C))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(C=>this.unhook(C))}hook(C){C.listener=C.event(h=>this.emitter.fire(h))}unhook(C){C.listener&&C.listener.dispose(),C.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=f;class c{constructor(){this.buffers=[]}wrapEvent(C){return(h,l,a)=>C(t=>{const i=this.buffers[this.buffers.length-1];i?i.push(()=>h.call(l,t)):h.call(l,t)},void 0,a)}bufferEvents(C){const h=[];this.buffers.push(h);const l=C();return this.buffers.pop(),h.forEach(a=>a()),l}}e.EventBufferer=c;class S{constructor(){this.listening=!1,this.inputEvent=_.None,this.inputEventListener=p.Disposable.None,this.emitter=new d({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(C){this.inputEvent=C,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=C(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=S}),define(le[29],ce([0,1,7]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const P=Object.freeze(function(_,m){const y=setTimeout(_.bind(m),0);return{dispose(){clearTimeout(y)}}});var p;(function(_){function m(y){return y===_.None||y===_.Cancelled||y instanceof D?!0:!y||typeof y!="object"?!1:typeof y.isCancellationRequested=="boolean"&&typeof y.onCancellationRequested=="function"}_.isCancellationToken=m,_.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),_.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:P})})(p=e.CancellationToken||(e.CancellationToken={}));class D{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?P:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class I{constructor(m){this._token=void 0,this._parentListener=void 0,this._parentListener=m&&m.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new D),this._token}cancel(){this._token?this._token instanceof D&&this._token.cancel():this._token=p.Cancelled}dispose(m=!1){m&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof D&&this._token.dispose():this._token=p.None}}e.CancellationTokenSource=I}),define(le[41],ce([0,1,7]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class P{constructor(){this._icons=new Map,this._onDidRegister=new E.Emitter}add(k){const d=this._icons.get(k.id);d?k.description?d.description=k.description:console.error(`Duplicate registration of codicon ${k.id}`):(this._icons.set(k.id,k),this._onDidRegister.fire(k))}get(k){return this._icons.get(k)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const p=new P;e.iconRegistry=p;function D(r,k){return new _(r,k)}e.registerCodicon=D;function I(r){return r?r.replace(/\$\((.*?)\)/g,(k,d)=>` ${d} `).trim():""}e.getCodiconAriaLabel=I;class _{constructor(k,d,b){this.id=k,this.definition=d,this.description=b,p.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=_;function m(r,k){const d=["codicon","codicon-"+r];return k&&d.push("codicon-modifier-"+k),d}e.getClassNamesArray=m;var y;(function(r){r.iconNameSegment="[A-Za-z0-9]+",r.iconNameExpression="[A-Za-z0-9\\-]+",r.iconModifierExpression="~[A-Za-z]+";const k=new RegExp(`^(${r.iconNameExpression})(${r.iconModifierExpression})?$`);function d(c){if(c instanceof _)return["codicon","codicon-"+c.id];const S=k.exec(c.id);if(!S)return d(_.error);let[,w,C]=S;const h=["codicon","codicon-"+w];return C&&h.push("codicon-modifier-"+C.substr(1)),h}r.asClassNameArray=d;function b(c){return d(c).join(" ")}r.asClassName=b;function f(c){return"."+d(c).join(".")}r.asCSSSelector=f})(y=e.CSSIcon||(e.CSSIcon={})),function(r){r.add=new r("add",{fontCharacter:"\\ea60"}),r.plus=new r("plus",{fontCharacter:"\\ea60"}),r.gistNew=new r("gist-new",{fontCharacter:"\\ea60"}),r.repoCreate=new r("repo-create",{fontCharacter:"\\ea60"}),r.lightbulb=new r("lightbulb",{fontCharacter:"\\ea61"}),r.lightBulb=new r("light-bulb",{fontCharacter:"\\ea61"}),r.repo=new r("repo",{fontCharacter:"\\ea62"}),r.repoDelete=new r("repo-delete",{fontCharacter:"\\ea62"}),r.gistFork=new r("gist-fork",{fontCharacter:"\\ea63"}),r.repoForked=new r("repo-forked",{fontCharacter:"\\ea63"}),r.gitPullRequest=new r("git-pull-request",{fontCharacter:"\\ea64"}),r.gitPullRequestAbandoned=new r("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),r.recordKeys=new r("record-keys",{fontCharacter:"\\ea65"}),r.keyboard=new r("keyboard",{fontCharacter:"\\ea65"}),r.tag=new r("tag",{fontCharacter:"\\ea66"}),r.tagAdd=new r("tag-add",{fontCharacter:"\\ea66"}),r.tagRemove=new r("tag-remove",{fontCharacter:"\\ea66"}),r.person=new r("person",{fontCharacter:"\\ea67"}),r.personFollow=new r("person-follow",{fontCharacter:"\\ea67"}),r.personOutline=new r("person-outline",{fontCharacter:"\\ea67"}),r.personFilled=new r("person-filled",{fontCharacter:"\\ea67"}),r.gitBranch=new r("git-branch",{fontCharacter:"\\ea68"}),r.gitBranchCreate=new r("git-branch-create",{fontCharacter:"\\ea68"}),r.gitBranchDelete=new r("git-branch-delete",{fontCharacter:"\\ea68"}),r.sourceControl=new r("source-control",{fontCharacter:"\\ea68"}),r.mirror=new r("mirror",{fontCharacter:"\\ea69"}),r.mirrorPublic=new r("mirror-public",{fontCharacter:"\\ea69"}),r.star=new r("star",{fontCharacter:"\\ea6a"}),r.starAdd=new r("star-add",{fontCharacter:"\\ea6a"}),r.starDelete=new r("star-delete",{fontCharacter:"\\ea6a"}),r.starEmpty=new r("star-empty",{fontCharacter:"\\ea6a"}),r.comment=new r("comment",{fontCharacter:"\\ea6b"}),r.commentAdd=new r("comment-add",{fontCharacter:"\\ea6b"}),r.alert=new r("alert",{fontCharacter:"\\ea6c"}),r.warning=new r("warning",{fontCharacter:"\\ea6c"}),r.search=new r("search",{fontCharacter:"\\ea6d"}),r.searchSave=new r("search-save",{fontCharacter:"\\ea6d"}),r.logOut=new r("log-out",{fontCharacter:"\\ea6e"}),r.signOut=new r("sign-out",{fontCharacter:"\\ea6e"}),r.logIn=new r("log-in",{fontCharacter:"\\ea6f"}),r.signIn=new r("sign-in",{fontCharacter:"\\ea6f"}),r.eye=new r("eye",{fontCharacter:"\\ea70"}),r.eyeUnwatch=new r("eye-unwatch",{fontCharacter:"\\ea70"}),r.eyeWatch=new r("eye-watch",{fontCharacter:"\\ea70"}),r.circleFilled=new r("circle-filled",{fontCharacter:"\\ea71"}),r.primitiveDot=new r("primitive-dot",{fontCharacter:"\\ea71"}),r.closeDirty=new r("close-dirty",{fontCharacter:"\\ea71"}),r.debugBreakpoint=new r("debug-breakpoint",{fontCharacter:"\\ea71"}),r.debugBreakpointDisabled=new r("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),r.debugHint=new r("debug-hint",{fontCharacter:"\\ea71"}),r.primitiveSquare=new r("primitive-square",{fontCharacter:"\\ea72"}),r.edit=new r("edit",{fontCharacter:"\\ea73"}),r.pencil=new r("pencil",{fontCharacter:"\\ea73"}),r.info=new r("info",{fontCharacter:"\\ea74"}),r.issueOpened=new r("issue-opened",{fontCharacter:"\\ea74"}),r.gistPrivate=new r("gist-private",{fontCharacter:"\\ea75"}),r.gitForkPrivate=new r("git-fork-private",{fontCharacter:"\\ea75"}),r.lock=new r("lock",{fontCharacter:"\\ea75"}),r.mirrorPrivate=new r("mirror-private",{fontCharacter:"\\ea75"}),r.close=new r("close",{fontCharacter:"\\ea76"}),r.removeClose=new r("remove-close",{fontCharacter:"\\ea76"}),r.x=new r("x",{fontCharacter:"\\ea76"}),r.repoSync=new r("repo-sync",{fontCharacter:"\\ea77"}),r.sync=new r("sync",{fontCharacter:"\\ea77"}),r.clone=new r("clone",{fontCharacter:"\\ea78"}),r.desktopDownload=new r("desktop-download",{fontCharacter:"\\ea78"}),r.beaker=new r("beaker",{fontCharacter:"\\ea79"}),r.microscope=new r("microscope",{fontCharacter:"\\ea79"}),r.vm=new r("vm",{fontCharacter:"\\ea7a"}),r.deviceDesktop=new r("device-desktop",{fontCharacter:"\\ea7a"}),r.file=new r("file",{fontCharacter:"\\ea7b"}),r.fileText=new r("file-text",{fontCharacter:"\\ea7b"}),r.more=new r("more",{fontCharacter:"\\ea7c"}),r.ellipsis=new r("ellipsis",{fontCharacter:"\\ea7c"}),r.kebabHorizontal=new r("kebab-horizontal",{fontCharacter:"\\ea7c"}),r.mailReply=new r("mail-reply",{fontCharacter:"\\ea7d"}),r.reply=new r("reply",{fontCharacter:"\\ea7d"}),r.organization=new r("organization",{fontCharacter:"\\ea7e"}),r.organizationFilled=new r("organization-filled",{fontCharacter:"\\ea7e"}),r.organizationOutline=new r("organization-outline",{fontCharacter:"\\ea7e"}),r.newFile=new r("new-file",{fontCharacter:"\\ea7f"}),r.fileAdd=new r("file-add",{fontCharacter:"\\ea7f"}),r.newFolder=new r("new-folder",{fontCharacter:"\\ea80"}),r.fileDirectoryCreate=new r("file-directory-create",{fontCharacter:"\\ea80"}),r.trash=new r("trash",{fontCharacter:"\\ea81"}),r.trashcan=new r("trashcan",{fontCharacter:"\\ea81"}),r.history=new r("history",{fontCharacter:"\\ea82"}),r.clock=new r("clock",{fontCharacter:"\\ea82"}),r.folder=new r("folder",{fontCharacter:"\\ea83"}),r.fileDirectory=new r("file-directory",{fontCharacter:"\\ea83"}),r.symbolFolder=new r("symbol-folder",{fontCharacter:"\\ea83"}),r.logoGithub=new r("logo-github",{fontCharacter:"\\ea84"}),r.markGithub=new r("mark-github",{fontCharacter:"\\ea84"}),r.github=new r("github",{fontCharacter:"\\ea84"}),r.terminal=new r("terminal",{fontCharacter:"\\ea85"}),r.console=new r("console",{fontCharacter:"\\ea85"}),r.repl=new r("repl",{fontCharacter:"\\ea85"}),r.zap=new r("zap",{fontCharacter:"\\ea86"}),r.symbolEvent=new r("symbol-event",{fontCharacter:"\\ea86"}),r.error=new r("error",{fontCharacter:"\\ea87"}),r.stop=new r("stop",{fontCharacter:"\\ea87"}),r.variable=new r("variable",{fontCharacter:"\\ea88"}),r.symbolVariable=new r("symbol-variable",{fontCharacter:"\\ea88"}),r.array=new r("array",{fontCharacter:"\\ea8a"}),r.symbolArray=new r("symbol-array",{fontCharacter:"\\ea8a"}),r.symbolModule=new r("symbol-module",{fontCharacter:"\\ea8b"}),r.symbolPackage=new r("symbol-package",{fontCharacter:"\\ea8b"}),r.symbolNamespace=new r("symbol-namespace",{fontCharacter:"\\ea8b"}),r.symbolObject=new r("symbol-object",{fontCharacter:"\\ea8b"}),r.symbolMethod=new r("symbol-method",{fontCharacter:"\\ea8c"}),r.symbolFunction=new r("symbol-function",{fontCharacter:"\\ea8c"}),r.symbolConstructor=new r("symbol-constructor",{fontCharacter:"\\ea8c"}),r.symbolBoolean=new r("symbol-boolean",{fontCharacter:"\\ea8f"}),r.symbolNull=new r("symbol-null",{fontCharacter:"\\ea8f"}),r.symbolNumeric=new r("symbol-numeric",{fontCharacter:"\\ea90"}),r.symbolNumber=new r("symbol-number",{fontCharacter:"\\ea90"}),r.symbolStructure=new r("symbol-structure",{fontCharacter:"\\ea91"}),r.symbolStruct=new r("symbol-struct",{fontCharacter:"\\ea91"}),r.symbolParameter=new r("symbol-parameter",{fontCharacter:"\\ea92"}),r.symbolTypeParameter=new r("symbol-type-parameter",{fontCharacter:"\\ea92"}),r.symbolKey=new r("symbol-key",{fontCharacter:"\\ea93"}),r.symbolText=new r("symbol-text",{fontCharacter:"\\ea93"}),r.symbolReference=new r("symbol-reference",{fontCharacter:"\\ea94"}),r.goToFile=new r("go-to-file",{fontCharacter:"\\ea94"}),r.symbolEnum=new r("symbol-enum",{fontCharacter:"\\ea95"}),r.symbolValue=new r("symbol-value",{fontCharacter:"\\ea95"}),r.symbolRuler=new r("symbol-ruler",{fontCharacter:"\\ea96"}),r.symbolUnit=new r("symbol-unit",{fontCharacter:"\\ea96"}),r.activateBreakpoints=new r("activate-breakpoints",{fontCharacter:"\\ea97"}),r.archive=new r("archive",{fontCharacter:"\\ea98"}),r.arrowBoth=new r("arrow-both",{fontCharacter:"\\ea99"}),r.arrowDown=new r("arrow-down",{fontCharacter:"\\ea9a"}),r.arrowLeft=new r("arrow-left",{fontCharacter:"\\ea9b"}),r.arrowRight=new r("arrow-right",{fontCharacter:"\\ea9c"}),r.arrowSmallDown=new r("arrow-small-down",{fontCharacter:"\\ea9d"}),r.arrowSmallLeft=new r("arrow-small-left",{fontCharacter:"\\ea9e"}),r.arrowSmallRight=new r("arrow-small-right",{fontCharacter:"\\ea9f"}),r.arrowSmallUp=new r("arrow-small-up",{fontCharacter:"\\eaa0"}),r.arrowUp=new r("arrow-up",{fontCharacter:"\\eaa1"}),r.bell=new r("bell",{fontCharacter:"\\eaa2"}),r.bold=new r("bold",{fontCharacter:"\\eaa3"}),r.book=new r("book",{fontCharacter:"\\eaa4"}),r.bookmark=new r("bookmark",{fontCharacter:"\\eaa5"}),r.debugBreakpointConditionalUnverified=new r("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),r.debugBreakpointConditional=new r("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),r.debugBreakpointConditionalDisabled=new r("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),r.debugBreakpointDataUnverified=new r("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),r.debugBreakpointData=new r("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),r.debugBreakpointDataDisabled=new r("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),r.debugBreakpointLogUnverified=new r("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),r.debugBreakpointLog=new r("debug-breakpoint-log",{fontCharacter:"\\eaab"}),r.debugBreakpointLogDisabled=new r("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),r.briefcase=new r("briefcase",{fontCharacter:"\\eaac"}),r.broadcast=new r("broadcast",{fontCharacter:"\\eaad"}),r.browser=new r("browser",{fontCharacter:"\\eaae"}),r.bug=new r("bug",{fontCharacter:"\\eaaf"}),r.calendar=new r("calendar",{fontCharacter:"\\eab0"}),r.caseSensitive=new r("case-sensitive",{fontCharacter:"\\eab1"}),r.check=new r("check",{fontCharacter:"\\eab2"}),r.checklist=new r("checklist",{fontCharacter:"\\eab3"}),r.chevronDown=new r("chevron-down",{fontCharacter:"\\eab4"}),r.chevronLeft=new r("chevron-left",{fontCharacter:"\\eab5"}),r.chevronRight=new r("chevron-right",{fontCharacter:"\\eab6"}),r.chevronUp=new r("chevron-up",{fontCharacter:"\\eab7"}),r.chromeClose=new r("chrome-close",{fontCharacter:"\\eab8"}),r.chromeMaximize=new r("chrome-maximize",{fontCharacter:"\\eab9"}),r.chromeMinimize=new r("chrome-minimize",{fontCharacter:"\\eaba"}),r.chromeRestore=new r("chrome-restore",{fontCharacter:"\\eabb"}),r.circleOutline=new r("circle-outline",{fontCharacter:"\\eabc"}),r.debugBreakpointUnverified=new r("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),r.circleSlash=new r("circle-slash",{fontCharacter:"\\eabd"}),r.circuitBoard=new r("circuit-board",{fontCharacter:"\\eabe"}),r.clearAll=new r("clear-all",{fontCharacter:"\\eabf"}),r.clippy=new r("clippy",{fontCharacter:"\\eac0"}),r.closeAll=new r("close-all",{fontCharacter:"\\eac1"}),r.cloudDownload=new r("cloud-download",{fontCharacter:"\\eac2"}),r.cloudUpload=new r("cloud-upload",{fontCharacter:"\\eac3"}),r.code=new r("code",{fontCharacter:"\\eac4"}),r.collapseAll=new r("collapse-all",{fontCharacter:"\\eac5"}),r.colorMode=new r("color-mode",{fontCharacter:"\\eac6"}),r.commentDiscussion=new r("comment-discussion",{fontCharacter:"\\eac7"}),r.compareChanges=new r("compare-changes",{fontCharacter:"\\eafd"}),r.creditCard=new r("credit-card",{fontCharacter:"\\eac9"}),r.dash=new r("dash",{fontCharacter:"\\eacc"}),r.dashboard=new r("dashboard",{fontCharacter:"\\eacd"}),r.database=new r("database",{fontCharacter:"\\eace"}),r.debugContinue=new r("debug-continue",{fontCharacter:"\\eacf"}),r.debugDisconnect=new r("debug-disconnect",{fontCharacter:"\\ead0"}),r.debugPause=new r("debug-pause",{fontCharacter:"\\ead1"}),r.debugRestart=new r("debug-restart",{fontCharacter:"\\ead2"}),r.debugStart=new r("debug-start",{fontCharacter:"\\ead3"}),r.debugStepInto=new r("debug-step-into",{fontCharacter:"\\ead4"}),r.debugStepOut=new r("debug-step-out",{fontCharacter:"\\ead5"}),r.debugStepOver=new r("debug-step-over",{fontCharacter:"\\ead6"}),r.debugStop=new r("debug-stop",{fontCharacter:"\\ead7"}),r.debug=new r("debug",{fontCharacter:"\\ead8"}),r.deviceCameraVideo=new r("device-camera-video",{fontCharacter:"\\ead9"}),r.deviceCamera=new r("device-camera",{fontCharacter:"\\eada"}),r.deviceMobile=new r("device-mobile",{fontCharacter:"\\eadb"}),r.diffAdded=new r("diff-added",{fontCharacter:"\\eadc"}),r.diffIgnored=new r("diff-ignored",{fontCharacter:"\\eadd"}),r.diffModified=new r("diff-modified",{fontCharacter:"\\eade"}),r.diffRemoved=new r("diff-removed",{fontCharacter:"\\eadf"}),r.diffRenamed=new r("diff-renamed",{fontCharacter:"\\eae0"}),r.diff=new r("diff",{fontCharacter:"\\eae1"}),r.discard=new r("discard",{fontCharacter:"\\eae2"}),r.editorLayout=new r("editor-layout",{fontCharacter:"\\eae3"}),r.emptyWindow=new r("empty-window",{fontCharacter:"\\eae4"}),r.exclude=new r("exclude",{fontCharacter:"\\eae5"}),r.extensions=new r("extensions",{fontCharacter:"\\eae6"}),r.eyeClosed=new r("eye-closed",{fontCharacter:"\\eae7"}),r.fileBinary=new r("file-binary",{fontCharacter:"\\eae8"}),r.fileCode=new r("file-code",{fontCharacter:"\\eae9"}),r.fileMedia=new r("file-media",{fontCharacter:"\\eaea"}),r.filePdf=new r("file-pdf",{fontCharacter:"\\eaeb"}),r.fileSubmodule=new r("file-submodule",{fontCharacter:"\\eaec"}),r.fileSymlinkDirectory=new r("file-symlink-directory",{fontCharacter:"\\eaed"}),r.fileSymlinkFile=new r("file-symlink-file",{fontCharacter:"\\eaee"}),r.fileZip=new r("file-zip",{fontCharacter:"\\eaef"}),r.files=new r("files",{fontCharacter:"\\eaf0"}),r.filter=new r("filter",{fontCharacter:"\\eaf1"}),r.flame=new r("flame",{fontCharacter:"\\eaf2"}),r.foldDown=new r("fold-down",{fontCharacter:"\\eaf3"}),r.foldUp=new r("fold-up",{fontCharacter:"\\eaf4"}),r.fold=new r("fold",{fontCharacter:"\\eaf5"}),r.folderActive=new r("folder-active",{fontCharacter:"\\eaf6"}),r.folderOpened=new r("folder-opened",{fontCharacter:"\\eaf7"}),r.gear=new r("gear",{fontCharacter:"\\eaf8"}),r.gift=new r("gift",{fontCharacter:"\\eaf9"}),r.gistSecret=new r("gist-secret",{fontCharacter:"\\eafa"}),r.gist=new r("gist",{fontCharacter:"\\eafb"}),r.gitCommit=new r("git-commit",{fontCharacter:"\\eafc"}),r.gitCompare=new r("git-compare",{fontCharacter:"\\eafd"}),r.gitMerge=new r("git-merge",{fontCharacter:"\\eafe"}),r.githubAction=new r("github-action",{fontCharacter:"\\eaff"}),r.githubAlt=new r("github-alt",{fontCharacter:"\\eb00"}),r.globe=new r("globe",{fontCharacter:"\\eb01"}),r.grabber=new r("grabber",{fontCharacter:"\\eb02"}),r.graph=new r("graph",{fontCharacter:"\\eb03"}),r.gripper=new r("gripper",{fontCharacter:"\\eb04"}),r.heart=new r("heart",{fontCharacter:"\\eb05"}),r.home=new r("home",{fontCharacter:"\\eb06"}),r.horizontalRule=new r("horizontal-rule",{fontCharacter:"\\eb07"}),r.hubot=new r("hubot",{fontCharacter:"\\eb08"}),r.inbox=new r("inbox",{fontCharacter:"\\eb09"}),r.issueClosed=new r("issue-closed",{fontCharacter:"\\eb0a"}),r.issueReopened=new r("issue-reopened",{fontCharacter:"\\eb0b"}),r.issues=new r("issues",{fontCharacter:"\\eb0c"}),r.italic=new r("italic",{fontCharacter:"\\eb0d"}),r.jersey=new r("jersey",{fontCharacter:"\\eb0e"}),r.json=new r("json",{fontCharacter:"\\eb0f"}),r.kebabVertical=new r("kebab-vertical",{fontCharacter:"\\eb10"}),r.key=new r("key",{fontCharacter:"\\eb11"}),r.law=new r("law",{fontCharacter:"\\eb12"}),r.lightbulbAutofix=new r("lightbulb-autofix",{fontCharacter:"\\eb13"}),r.linkExternal=new r("link-external",{fontCharacter:"\\eb14"}),r.link=new r("link",{fontCharacter:"\\eb15"}),r.listOrdered=new r("list-ordered",{fontCharacter:"\\eb16"}),r.listUnordered=new r("list-unordered",{fontCharacter:"\\eb17"}),r.liveShare=new r("live-share",{fontCharacter:"\\eb18"}),r.loading=new r("loading",{fontCharacter:"\\eb19"}),r.location=new r("location",{fontCharacter:"\\eb1a"}),r.mailRead=new r("mail-read",{fontCharacter:"\\eb1b"}),r.mail=new r("mail",{fontCharacter:"\\eb1c"}),r.markdown=new r("markdown",{fontCharacter:"\\eb1d"}),r.megaphone=new r("megaphone",{fontCharacter:"\\eb1e"}),r.mention=new r("mention",{fontCharacter:"\\eb1f"}),r.milestone=new r("milestone",{fontCharacter:"\\eb20"}),r.mortarBoard=new r("mortar-board",{fontCharacter:"\\eb21"}),r.move=new r("move",{fontCharacter:"\\eb22"}),r.multipleWindows=new r("multiple-windows",{fontCharacter:"\\eb23"}),r.mute=new r("mute",{fontCharacter:"\\eb24"}),r.noNewline=new r("no-newline",{fontCharacter:"\\eb25"}),r.note=new r("note",{fontCharacter:"\\eb26"}),r.octoface=new r("octoface",{fontCharacter:"\\eb27"}),r.openPreview=new r("open-preview",{fontCharacter:"\\eb28"}),r.package_=new r("package",{fontCharacter:"\\eb29"}),r.paintcan=new r("paintcan",{fontCharacter:"\\eb2a"}),r.pin=new r("pin",{fontCharacter:"\\eb2b"}),r.play=new r("play",{fontCharacter:"\\eb2c"}),r.run=new r("run",{fontCharacter:"\\eb2c"}),r.plug=new r("plug",{fontCharacter:"\\eb2d"}),r.preserveCase=new r("preserve-case",{fontCharacter:"\\eb2e"}),r.preview=new r("preview",{fontCharacter:"\\eb2f"}),r.project=new r("project",{fontCharacter:"\\eb30"}),r.pulse=new r("pulse",{fontCharacter:"\\eb31"}),r.question=new r("question",{fontCharacter:"\\eb32"}),r.quote=new r("quote",{fontCharacter:"\\eb33"}),r.radioTower=new r("radio-tower",{fontCharacter:"\\eb34"}),r.reactions=new r("reactions",{fontCharacter:"\\eb35"}),r.references=new r("references",{fontCharacter:"\\eb36"}),r.refresh=new r("refresh",{fontCharacter:"\\eb37"}),r.regex=new r("regex",{fontCharacter:"\\eb38"}),r.remoteExplorer=new r("remote-explorer",{fontCharacter:"\\eb39"}),r.remote=new r("remote",{fontCharacter:"\\eb3a"}),r.remove=new r("remove",{fontCharacter:"\\eb3b"}),r.replaceAll=new r("replace-all",{fontCharacter:"\\eb3c"}),r.replace=new r("replace",{fontCharacter:"\\eb3d"}),r.repoClone=new r("repo-clone",{fontCharacter:"\\eb3e"}),r.repoForcePush=new r("repo-force-push",{fontCharacter:"\\eb3f"}),r.repoPull=new r("repo-pull",{fontCharacter:"\\eb40"}),r.repoPush=new r("repo-push",{fontCharacter:"\\eb41"}),r.report=new r("report",{fontCharacter:"\\eb42"}),r.requestChanges=new r("request-changes",{fontCharacter:"\\eb43"}),r.rocket=new r("rocket",{fontCharacter:"\\eb44"}),r.rootFolderOpened=new r("root-folder-opened",{fontCharacter:"\\eb45"}),r.rootFolder=new r("root-folder",{fontCharacter:"\\eb46"}),r.rss=new r("rss",{fontCharacter:"\\eb47"}),r.ruby=new r("ruby",{fontCharacter:"\\eb48"}),r.saveAll=new r("save-all",{fontCharacter:"\\eb49"}),r.saveAs=new r("save-as",{fontCharacter:"\\eb4a"}),r.save=new r("save",{fontCharacter:"\\eb4b"}),r.screenFull=new r("screen-full",{fontCharacter:"\\eb4c"}),r.screenNormal=new r("screen-normal",{fontCharacter:"\\eb4d"}),r.searchStop=new r("search-stop",{fontCharacter:"\\eb4e"}),r.server=new r("server",{fontCharacter:"\\eb50"}),r.settingsGear=new r("settings-gear",{fontCharacter:"\\eb51"}),r.settings=new r("settings",{fontCharacter:"\\eb52"}),r.shield=new r("shield",{fontCharacter:"\\eb53"}),r.smiley=new r("smiley",{fontCharacter:"\\eb54"}),r.sortPrecedence=new r("sort-precedence",{fontCharacter:"\\eb55"}),r.splitHorizontal=new r("split-horizontal",{fontCharacter:"\\eb56"}),r.splitVertical=new r("split-vertical",{fontCharacter:"\\eb57"}),r.squirrel=new r("squirrel",{fontCharacter:"\\eb58"}),r.starFull=new r("star-full",{fontCharacter:"\\eb59"}),r.starHalf=new r("star-half",{fontCharacter:"\\eb5a"}),r.symbolClass=new r("symbol-class",{fontCharacter:"\\eb5b"}),r.symbolColor=new r("symbol-color",{fontCharacter:"\\eb5c"}),r.symbolConstant=new r("symbol-constant",{fontCharacter:"\\eb5d"}),r.symbolEnumMember=new r("symbol-enum-member",{fontCharacter:"\\eb5e"}),r.symbolField=new r("symbol-field",{fontCharacter:"\\eb5f"}),r.symbolFile=new r("symbol-file",{fontCharacter:"\\eb60"}),r.symbolInterface=new r("symbol-interface",{fontCharacter:"\\eb61"}),r.symbolKeyword=new r("symbol-keyword",{fontCharacter:"\\eb62"}),r.symbolMisc=new r("symbol-misc",{fontCharacter:"\\eb63"}),r.symbolOperator=new r("symbol-operator",{fontCharacter:"\\eb64"}),r.symbolProperty=new r("symbol-property",{fontCharacter:"\\eb65"}),r.wrench=new r("wrench",{fontCharacter:"\\eb65"}),r.wrenchSubaction=new r("wrench-subaction",{fontCharacter:"\\eb65"}),r.symbolSnippet=new r("symbol-snippet",{fontCharacter:"\\eb66"}),r.tasklist=new r("tasklist",{fontCharacter:"\\eb67"}),r.telescope=new r("telescope",{fontCharacter:"\\eb68"}),r.textSize=new r("text-size",{fontCharacter:"\\eb69"}),r.threeBars=new r("three-bars",{fontCharacter:"\\eb6a"}),r.thumbsdown=new r("thumbsdown",{fontCharacter:"\\eb6b"}),r.thumbsup=new r("thumbsup",{fontCharacter:"\\eb6c"}),r.tools=new r("tools",{fontCharacter:"\\eb6d"}),r.triangleDown=new r("triangle-down",{fontCharacter:"\\eb6e"}),r.triangleLeft=new r("triangle-left",{fontCharacter:"\\eb6f"}),r.triangleRight=new r("triangle-right",{fontCharacter:"\\eb70"}),r.triangleUp=new r("triangle-up",{fontCharacter:"\\eb71"}),r.twitter=new r("twitter",{fontCharacter:"\\eb72"}),r.unfold=new r("unfold",{fontCharacter:"\\eb73"}),r.unlock=new r("unlock",{fontCharacter:"\\eb74"}),r.unmute=new r("unmute",{fontCharacter:"\\eb75"}),r.unverified=new r("unverified",{fontCharacter:"\\eb76"}),r.verified=new r("verified",{fontCharacter:"\\eb77"}),r.versions=new r("versions",{fontCharacter:"\\eb78"}),r.vmActive=new r("vm-active",{fontCharacter:"\\eb79"}),r.vmOutline=new r("vm-outline",{fontCharacter:"\\eb7a"}),r.vmRunning=new r("vm-running",{fontCharacter:"\\eb7b"}),r.watch=new r("watch",{fontCharacter:"\\eb7c"}),r.whitespace=new r("whitespace",{fontCharacter:"\\eb7d"}),r.wholeWord=new r("whole-word",{fontCharacter:"\\eb7e"}),r.window=new r("window",{fontCharacter:"\\eb7f"}),r.wordWrap=new r("word-wrap",{fontCharacter:"\\eb80"}),r.zoomIn=new r("zoom-in",{fontCharacter:"\\eb81"}),r.zoomOut=new r("zoom-out",{fontCharacter:"\\eb82"}),r.listFilter=new r("list-filter",{fontCharacter:"\\eb83"}),r.listFlat=new r("list-flat",{fontCharacter:"\\eb84"}),r.listSelection=new r("list-selection",{fontCharacter:"\\eb85"}),r.selection=new r("selection",{fontCharacter:"\\eb85"}),r.listTree=new r("list-tree",{fontCharacter:"\\eb86"}),r.debugBreakpointFunctionUnverified=new r("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),r.debugBreakpointFunction=new r("debug-breakpoint-function",{fontCharacter:"\\eb88"}),r.debugBreakpointFunctionDisabled=new r("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),r.debugStackframeActive=new r("debug-stackframe-active",{fontCharacter:"\\eb89"}),r.debugStackframeDot=new r("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),r.debugStackframe=new r("debug-stackframe",{fontCharacter:"\\eb8b"}),r.debugStackframeFocused=new r("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),r.debugBreakpointUnsupported=new r("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),r.symbolString=new r("symbol-string",{fontCharacter:"\\eb8d"}),r.debugReverseContinue=new r("debug-reverse-continue",{fontCharacter:"\\eb8e"}),r.debugStepBack=new r("debug-step-back",{fontCharacter:"\\eb8f"}),r.debugRestartFrame=new r("debug-restart-frame",{fontCharacter:"\\eb90"}),r.callIncoming=new r("call-incoming",{fontCharacter:"\\eb92"}),r.callOutgoing=new r("call-outgoing",{fontCharacter:"\\eb93"}),r.menu=new r("menu",{fontCharacter:"\\eb94"}),r.expandAll=new r("expand-all",{fontCharacter:"\\eb95"}),r.feedback=new r("feedback",{fontCharacter:"\\eb96"}),r.groupByRefType=new r("group-by-ref-type",{fontCharacter:"\\eb97"}),r.ungroupByRefType=new r("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),r.account=new r("account",{fontCharacter:"\\eb99"}),r.bellDot=new r("bell-dot",{fontCharacter:"\\eb9a"}),r.debugConsole=new r("debug-console",{fontCharacter:"\\eb9b"}),r.library=new r("library",{fontCharacter:"\\eb9c"}),r.output=new r("output",{fontCharacter:"\\eb9d"}),r.runAll=new r("run-all",{fontCharacter:"\\eb9e"}),r.syncIgnored=new r("sync-ignored",{fontCharacter:"\\eb9f"}),r.pinned=new r("pinned",{fontCharacter:"\\eba0"}),r.githubInverted=new r("github-inverted",{fontCharacter:"\\eba1"}),r.debugAlt=new r("debug-alt",{fontCharacter:"\\eb91"}),r.serverProcess=new r("server-process",{fontCharacter:"\\eba2"}),r.serverEnvironment=new r("server-environment",{fontCharacter:"\\eba3"}),r.pass=new r("pass",{fontCharacter:"\\eba4"}),r.stopCircle=new r("stop-circle",{fontCharacter:"\\eba5"}),r.playCircle=new r("play-circle",{fontCharacter:"\\eba6"}),r.record=new r("record",{fontCharacter:"\\eba7"}),r.debugAltSmall=new r("debug-alt-small",{fontCharacter:"\\eba8"}),r.vmConnect=new r("vm-connect",{fontCharacter:"\\eba9"}),r.cloud=new r("cloud",{fontCharacter:"\\ebaa"}),r.merge=new r("merge",{fontCharacter:"\\ebab"}),r.exportIcon=new r("export",{fontCharacter:"\\ebac"}),r.graphLeft=new r("graph-left",{fontCharacter:"\\ebad"}),r.magnet=new r("magnet",{fontCharacter:"\\ebae"}),r.notebook=new r("notebook",{fontCharacter:"\\ebaf"}),r.redo=new r("redo",{fontCharacter:"\\ebb0"}),r.checkAll=new r("check-all",{fontCharacter:"\\ebb1"}),r.pinnedDirty=new r("pinned-dirty",{fontCharacter:"\\ebb2"}),r.passFilled=new r("pass-filled",{fontCharacter:"\\ebb3"}),r.circleLargeFilled=new r("circle-large-filled",{fontCharacter:"\\ebb4"}),r.circleLargeOutline=new r("circle-large-outline",{fontCharacter:"\\ebb5"}),r.combine=new r("combine",{fontCharacter:"\\ebb6"}),r.gather=new r("gather",{fontCharacter:"\\ebb6"}),r.table=new r("table",{fontCharacter:"\\ebb7"}),r.variableGroup=new r("variable-group",{fontCharacter:"\\ebb8"}),r.typeHierarchy=new r("type-hierarchy",{fontCharacter:"\\ebb9"}),r.typeHierarchySub=new r("type-hierarchy-sub",{fontCharacter:"\\ebba"}),r.typeHierarchySuper=new r("type-hierarchy-super",{fontCharacter:"\\ebbb"}),r.gitPullRequestCreate=new r("git-pull-request-create",{fontCharacter:"\\ebbc"}),r.runAbove=new r("run-above",{fontCharacter:"\\ebbd"}),r.runBelow=new r("run-below",{fontCharacter:"\\ebbe"}),r.notebookTemplate=new r("notebook-template",{fontCharacter:"\\ebbf"}),r.debugRerun=new r("debug-rerun",{fontCharacter:"\\ebc0"}),r.workspaceTrusted=new r("workspace-trusted",{fontCharacter:"\\ebc1"}),r.workspaceUntrusted=new r("workspace-untrusted",{fontCharacter:"\\ebc2"}),r.workspaceUnspecified=new r("workspace-unspecified",{fontCharacter:"\\ebc3"}),r.terminalCmd=new r("terminal-cmd",{fontCharacter:"\\ebc4"}),r.terminalDebian=new r("terminal-debian",{fontCharacter:"\\ebc5"}),r.terminalLinux=new r("terminal-linux",{fontCharacter:"\\ebc6"}),r.terminalPowershell=new r("terminal-powershell",{fontCharacter:"\\ebc7"}),r.terminalTmux=new r("terminal-tmux",{fontCharacter:"\\ebc8"}),r.terminalUbuntu=new r("terminal-ubuntu",{fontCharacter:"\\ebc9"}),r.terminalBash=new r("terminal-bash",{fontCharacter:"\\ebca"}),r.arrowSwap=new r("arrow-swap",{fontCharacter:"\\ebcb"}),r.copy=new r("copy",{fontCharacter:"\\ebcc"}),r.personAdd=new r("person-add",{fontCharacter:"\\ebcd"}),r.filterFilled=new r("filter-filled",{fontCharacter:"\\ebce"}),r.wand=new r("wand",{fontCharacter:"\\ebcf"}),r.debugLineByLine=new r("debug-line-by-line",{fontCharacter:"\\ebd0"}),r.inspect=new r("inspect",{fontCharacter:"\\ebd1"}),r.dropDownButton=new r("drop-down-button",r.chevronDown.definition)}(_=e.Codicon||(e.Codicon={}))}),define(le[42],ce([0,1,12,2]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function p(h){const l=h;return l?[l.on,l.pause,l.resume,l.destroy].every(a=>typeof a=="function"):!1}e.isReadableStream=p;function D(h){const l=h;return l?p(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=D;function I(h,l){return new _(h,l)}e.newWriteableStream=I;class _{constructor(l,a){this.reducer=l,this.options=a,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){var a;if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof((a=this.options)===null||a===void 0?void 0:a.highWaterMark)=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(t=>this.pendingWritePromises.push(t))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(a=>a(l))}emitError(l){this.listeners.error.length===0?E.onUnexpectedError(l):this.listeners.error.slice(0).forEach(a=>a(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,a){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(a),this.resume();break;case"end":this.listeners.end.push(a),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(a),this.state.flowing&&this.flowErrors();break}}removeListener(l,a){if(this.state.destroyed)return;let t;switch(l){case"data":t=this.listeners.data;break;case"end":t=this.listeners.end;break;case"error":t=this.listeners.error;break}if(t){const i=t.indexOf(a);i>=0&&t.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const a=[...this.pendingWritePromises];this.pendingWritePromises.length=0,a.forEach(t=>t())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function m(h,l){const a=[];let t;for(;(t=h.read())!==null;)a.push(t);return l(a)}e.consumeReadable=m;function y(h,l,a){const t=[];let i;for(;(i=h.read())!==null&&t.length<a;)t.push(i);return i===null&&t.length>0?l(t):{read:()=>{if(t.length>0)return t.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return h.read()}}}e.peekReadable=y;function r(h,l){return new Promise((a,t)=>{const i=[];k(h,{onData:n=>{l&&i.push(n)},onError:n=>{l?t(n):a(void 0)},onEnd:()=>{a(l?l(i):void 0)}})})}e.consumeStream=r;function k(h,l){h.on("error",a=>l.onError(a)),h.on("end",()=>l.onEnd()),h.on("data",a=>l.onData(a))}e.listenStream=k;function d(h,l){return new Promise((a,t)=>{const i=new P.DisposableStore,n=[],s=v=>{if(n.push(v),n.length>l)return i.dispose(),h.pause(),a({stream:h,buffer:n,ended:!1})},u=v=>t(v),g=()=>a({stream:h,buffer:n,ended:!0});i.add(P.toDisposable(()=>h.removeListener("error",u))),h.on("error",u),i.add(P.toDisposable(()=>h.removeListener("end",g))),h.on("end",g),i.add(P.toDisposable(()=>h.removeListener("data",s))),h.on("data",s)})}e.peekStream=d;function b(h,l){const a=I(l);return a.end(h),a}e.toStream=b;function f(){const h=I(()=>{throw new Error("not supported")});return h.end(),h}e.emptyStream=f;function c(h){let l=!1;return{read:()=>l?null:(l=!0,h)}}e.toReadable=c;function S(h,l,a){const t=I(a);return k(h,{onData:i=>t.write(l.data(i)),onError:i=>t.error(l.error?l.error(i):i),onEnd:()=>t.end()}),t}e.transform=S;function w(h,l,a){let t=!1;return{read:()=>{const i=l.read();return t?i:(t=!0,i!==null?a([h,i]):h)}}}e.prefixedReadable=w;function C(h,l,a){let t=!1;const i=I(a);return k(l,{onData:n=>t?i.write(n):(t=!0,i.write(a([h,n]))),onError:n=>i.error(n),onEnd:()=>{t||(t=!0,i.write(h)),i.end()}}),i}e.prefixedStream=C}),define(le[13],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.decodeUTF8=e.encodeUTF8=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format=e.isFalsyOrWhitespace=void 0;function E(U){return!U||typeof U!="string"?!0:U.trim().length===0}e.isFalsyOrWhitespace=E;const P=/{(\d+)}/g;function p(U,...H){return H.length===0?U:U.replace(P,function(Y,pe){const Ee=parseInt(pe,10);return isNaN(Ee)||Ee<0||Ee>=H.length?Y:H[Ee]})}e.format=p;function D(U){return U.replace(/[<>&]/g,function(H){switch(H){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return H}})}e.escape=D;function I(U){return U.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=I;function _(U,H){let Y=0;const pe=H.charCodeAt(0);for(let Ee=U.length-1;Ee>=0;Ee--)U.charCodeAt(Ee)===pe&&Y++;return Y}e.count=_;function m(U,H,Y="\u2026"){return U.length<=H?U:`${U.substr(0,H)}${Y}`}e.truncate=m;function y(U,H=" "){const Y=r(U,H);return k(Y,H)}e.trim=y;function r(U,H){if(!U||!H)return U;const Y=H.length;if(Y===0||U.length===0)return U;let pe=0;for(;U.indexOf(H,pe)===pe;)pe=pe+Y;return U.substring(pe)}e.ltrim=r;function k(U,H){if(!U||!H)return U;const Y=H.length,pe=U.length;if(Y===0||pe===0)return U;let Ee=pe,Ce=-1;for(;Ce=U.lastIndexOf(H,Ee-1),!(Ce===-1||Ce+Y!==Ee);){if(Ce===0)return"";Ee=Ce}return U.substring(0,Ee)}e.rtrim=k;function d(U){return U.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=d;function b(U){return U.replace(/\*/g,"")}e.stripWildcards=b;function f(U,H,Y={}){if(!U)throw new Error("Cannot create regex from empty string");H||(U=I(U)),Y.wholeWord&&(/\B/.test(U.charAt(0))||(U="\\b"+U),/\B/.test(U.charAt(U.length-1))||(U=U+"\\b"));let pe="";return Y.global&&(pe+="g"),Y.matchCase||(pe+="i"),Y.multiline&&(pe+="m"),Y.unicode&&(pe+="u"),new RegExp(U,pe)}e.createRegExp=f;function c(U){return U.source==="^"||U.source==="^$"||U.source==="$"||U.source==="^\\s*$"?!1:!!(U.exec("")&&U.lastIndex===0)}e.regExpLeadsToEndlessLoop=c;function S(U){return!!U.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=S;function w(U){return(U.global?"g":"")+(U.ignoreCase?"i":"")+(U.multiline?"m":"")+(U.unicode?"u":"")}e.regExpFlags=w;function C(U){return U.split(/\r\n|\r|\n/)}e.splitLines=C;function h(U){for(let H=0,Y=U.length;H<Y;H++){const pe=U.charCodeAt(H);if(pe!==32&&pe!==9)return H}return-1}e.firstNonWhitespaceIndex=h;function l(U,H=0,Y=U.length){for(let pe=H;pe<Y;pe++){const Ee=U.charCodeAt(pe);if(Ee!==32&&Ee!==9)return U.substring(H,pe)}return U.substring(H,Y)}e.getLeadingWhitespace=l;function a(U,H=U.length-1){for(let Y=H;Y>=0;Y--){const pe=U.charCodeAt(Y);if(pe!==32&&pe!==9)return Y}return-1}e.lastNonWhitespaceIndex=a;function t(U,H){return U<H?-1:U>H?1:0}e.compare=t;function i(U,H,Y=0,pe=U.length,Ee=0,Ce=H.length){for(;Y<pe&&Ee<Ce;Y++,Ee++){let Ae=U.charCodeAt(Y),Fe=H.charCodeAt(Ee);if(Ae<Fe)return-1;if(Ae>Fe)return 1}const ne=pe-Y,De=Ce-Ee;return ne<De?-1:ne>De?1:0}e.compareSubstring=i;function n(U,H){return s(U,H,0,U.length,0,H.length)}e.compareIgnoreCase=n;function s(U,H,Y=0,pe=U.length,Ee=0,Ce=H.length){for(;Y<pe&&Ee<Ce;Y++,Ee++){let Ae=U.charCodeAt(Y),Fe=H.charCodeAt(Ee);if(Ae===Fe)continue;const Oe=Ae-Fe;if(!(Oe===32&&g(Fe))&&!(Oe===-32&&g(Ae)))return u(Ae)&&u(Fe)?Oe:i(U.toLowerCase(),H.toLowerCase(),Y,pe,Ee,Ce)}const ne=pe-Y,De=Ce-Ee;return ne<De?-1:ne>De?1:0}e.compareSubstringIgnoreCase=s;function u(U){return U>=97&&U<=122}e.isLowerAsciiLetter=u;function g(U){return U>=65&&U<=90}e.isUpperAsciiLetter=g;function v(U){return u(U)||g(U)}function T(U,H){return U.length===H.length&&R(U,H)}e.equalsIgnoreCase=T;function R(U,H,Y=U.length){for(let pe=0;pe<Y;pe++){const Ee=U.charCodeAt(pe),Ce=H.charCodeAt(pe);if(Ee!==Ce){if(v(Ee)&&v(Ce)){const ne=Math.abs(Ee-Ce);if(ne!==0&&ne!==32)return!1}else if(String.fromCharCode(Ee).toLowerCase()!==String.fromCharCode(Ce).toLowerCase())return!1}}return!0}function o(U,H){const Y=H.length;return H.length>U.length?!1:R(U,H,Y)}e.startsWithIgnoreCase=o;function F(U,H){let Y,pe=Math.min(U.length,H.length);for(Y=0;Y<pe;Y++)if(U.charCodeAt(Y)!==H.charCodeAt(Y))return Y;return pe}e.commonPrefixLength=F;function B(U,H){let Y,pe=Math.min(U.length,H.length);const Ee=U.length-1,Ce=H.length-1;for(Y=0;Y<pe;Y++)if(U.charCodeAt(Ee-Y)!==H.charCodeAt(Ce-Y))return Y;return pe}e.commonSuffixLength=B;function Z(U){return 55296<=U&&U<=56319}e.isHighSurrogate=Z;function ie(U){return 56320<=U&&U<=57343}e.isLowSurrogate=ie;function Se(U,H){return(U-55296<<10)+(H-56320)+65536}e.computeCodePoint=Se;function oe(U,H,Y){const pe=U.charCodeAt(Y);if(Z(pe)&&Y+1<H){const Ee=U.charCodeAt(Y+1);if(ie(Ee))return Se(pe,Ee)}return pe}e.getNextCodePoint=oe;function q(U,H){const Y=U.charCodeAt(H-1);if(ie(Y)&&H>1){const pe=U.charCodeAt(H-2);if(Z(pe))return Se(pe,Y)}return Y}function ee(U,H){const Y=de.getInstance(),pe=H,Ee=U.length,Ce=oe(U,Ee,H);H+=Ce>=65536?2:1;let ne=Y.getGraphemeBreakType(Ce);for(;H<Ee;){const De=oe(U,Ee,H),Ae=Y.getGraphemeBreakType(De);if(te(ne,Ae))break;H+=De>=65536?2:1,ne=Ae}return H-pe}e.nextCharLength=ee;function G(U,H){const Y=de.getInstance(),pe=H,Ee=q(U,H);H-=Ee>=65536?2:1;let Ce=Y.getGraphemeBreakType(Ee);for(;H>0;){const ne=q(U,H),De=Y.getGraphemeBreakType(ne);if(te(De,Ce))break;H-=ne>=65536?2:1,Ce=De}return pe-H}e.prevCharLength=G;function z(U,H){const Y=de.getInstance(),pe=U.length,Ee=H,Ce=oe(U,pe,H),ne=Y.getGraphemeBreakType(Ce);H+=Ce>=65536?2:1;let De=ne;for(;H<pe;){const Fe=oe(U,pe,H),Oe=Y.getGraphemeBreakType(Fe);if(te(De,Oe))break;H+=Fe>=65536?2:1,De=Oe}const Ae=H;for(H=Ee,De=ne;H>0;){const Fe=q(U,H),Oe=Y.getGraphemeBreakType(Fe);if(te(Oe,De))break;H-=Fe>=65536?2:1,De=Oe}return[H,Ae]}function L(U,H){return H>0&&ie(U.charCodeAt(H))?z(U,H-1):z(U,H)}e.getCharContainingOffset=L;function A(U){const H=U.length;let Y=0,pe=0;for(;pe<H;){const ne=oe(U,H,pe);pe+=ne>=65536?2:1,ne<128?Y+=1:ne<2048?Y+=2:ne<65536?Y+=3:Y+=4}const Ee=new Uint8Array(Y);pe=0;let Ce=0;for(;pe<H;){const ne=oe(U,H,pe);pe+=ne>=65536?2:1,ne<128?Ee[Ce++]=ne:ne<2048?(Ee[Ce++]=192|(ne&1984)>>>6,Ee[Ce++]=128|(ne&63)>>>0):ne<65536?(Ee[Ce++]=224|(ne&61440)>>>12,Ee[Ce++]=128|(ne&4032)>>>6,Ee[Ce++]=128|(ne&63)>>>0):(Ee[Ce++]=240|(ne&1835008)>>>18,Ee[Ce++]=128|(ne&258048)>>>12,Ee[Ce++]=128|(ne&4032)>>>6,Ee[Ce++]=128|(ne&63)>>>0)}return Ee}e.encodeUTF8=A;function N(U){const H=U.byteLength,Y=[];let pe=0;for(;pe<H;){const Ee=U[pe];let Ce;if(Ee>=240&&pe+3<H?Ce=(U[pe++]&7)<<18>>>0|(U[pe++]&63)<<12>>>0|(U[pe++]&63)<<6>>>0|(U[pe++]&63)<<0>>>0:Ee>=224&&pe+2<H?Ce=(U[pe++]&15)<<12>>>0|(U[pe++]&63)<<6>>>0|(U[pe++]&63)<<0>>>0:Ee>=192&&pe+1<H?Ce=(U[pe++]&31)<<6>>>0|(U[pe++]&63)<<0>>>0:Ce=U[pe++],Ce>=0&&Ce<=55295||Ce>=57344&&Ce<=65535)Y.push(String.fromCharCode(Ce));else if(Ce>=65536&&Ce<=1114111){const ne=Ce-65536,De=55296+((ne&1047552)>>>10),Ae=56320+((ne&1023)>>>0);Y.push(String.fromCharCode(De)),Y.push(String.fromCharCode(Ae))}else Y.push(String.fromCharCode(65533))}return Y.join("")}e.decodeUTF8=N;const M=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function W(U){return M.test(U)}e.containsRTL=W;const X=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function ae(U){return X.test(U)}e.containsEmoji=ae;const se=/^[\t\n\r\x20-\x7E]*$/;function be(U){return se.test(U)}e.isBasicASCII=be,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function ke(U){return e.UNUSUAL_LINE_TERMINATORS.test(U)}e.containsUnusualLineTerminators=ke;function Te(U){for(let H=0,Y=U.length;H<Y;H++)if(Le(U.charCodeAt(H)))return!0;return!1}e.containsFullWidthCharacter=Te;function Le(U){return U=+U,U>=11904&&U<=55215||U>=63744&&U<=64255||U>=65281&&U<=65374}e.isFullWidthCharacter=Le;function je(U){return U>=127462&&U<=127487||U===8986||U===8987||U===9200||U===9203||U>=9728&&U<=10175||U===11088||U===11093||U>=127744&&U<=128591||U>=128640&&U<=128764||U>=128992&&U<=129003||U>=129280&&U<=129535||U>=129648&&U<=129750}e.isEmojiImprecise=je;function Xe(U,H){if(U.length<H)return U;const Y=/\b/g;let pe=0;for(;Y.test(U)&&!(U.length-Y.lastIndex<H);)pe=Y.lastIndex,Y.lastIndex+=1;return U.substring(pe).replace(/^\s/,"")}e.lcut=Xe;const Ze=/\x1B\x5B[12]?K/g,it=/\x1b\[\d+m/g,Ye=/\x1b\[0?m/g;function ge(U){return U&&(U=U.replace(Ze,""),U=U.replace(it,""),U=U.replace(Ye,"")),U}e.removeAnsiEscapeCodes=ge,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function Ie(U){return!!(U&&U.length>0&&U.charCodeAt(0)===65279)}e.startsWithUTF8BOM=Ie;function _e(U){return Ie(U)?U.substr(1):U}e.stripUTF8BOM=_e;function Re(U,H){if(!U||!H||U.length<H.length)return!1;const Y=H.length,pe=U.toLowerCase();let Ee=0,Ce=-1;for(;Ee<Y;){const ne=pe.indexOf(H[Ee],Ce+1);if(ne<0)return!1;Ce=ne,Ee++}return!0}e.fuzzyContains=Re;function Me(U,H=!1){return U?(H&&(U=U.replace(/\\./g,"")),U.toLowerCase()!==U):!1}e.containsUppercaseCharacter=Me;function ze(U){return U.charAt(0).toUpperCase()+U.slice(1)}e.uppercaseFirstLetter=ze;function He(U,H=1){if(H===0)return"";let Y=-1;do Y=U.indexOf(`
`,Y+1),H--;while(H>0&&Y>=0);return Y===-1?U:(U[Y-1]==="\r"&&Y--,U.substr(0,Y))}e.getNLines=He;function xe(U){const H=90-65+1;return U=U%(2*H),U<H?String.fromCharCode(97+U):String.fromCharCode(65+U-H)}e.singleLetterHash=xe;function tt(U){return de.getInstance().getGraphemeBreakType(U)}e.getGraphemeBreakType=tt;function te(U,H){return U===0?H!==5&&H!==7:U===2&&H===3?!1:U===4||U===2||U===3||H===4||H===2||H===3?!0:!(U===8&&(H===8||H===9||H===11||H===12)||(U===11||U===9)&&(H===9||H===10)||(U===12||U===10)&&H===10||H===5||H===13||H===7||U===1||U===13&&H===14||U===6&&H===6)}e.breakBetweenGraphemeBreakType=te;var ve;(function(U){U[U.Other=0]="Other",U[U.Prepend=1]="Prepend",U[U.CR=2]="CR",U[U.LF=3]="LF",U[U.Control=4]="Control",U[U.Extend=5]="Extend",U[U.Regional_Indicator=6]="Regional_Indicator",U[U.SpacingMark=7]="SpacingMark",U[U.L=8]="L",U[U.V=9]="V",U[U.T=10]="T",U[U.LV=11]="LV",U[U.LVT=12]="LVT",U[U.ZWJ=13]="ZWJ",U[U.Extended_Pictographic=14]="Extended_Pictographic"})(ve=e.GraphemeBreakType||(e.GraphemeBreakType={}));class de{constructor(){this._data=Ue()}static getInstance(){return de._INSTANCE||(de._INSTANCE=new de),de._INSTANCE}getGraphemeBreakType(H){if(H<32)return H===10?3:H===13?2:4;if(H<127)return 0;const Y=this._data,pe=Y.length/3;let Ee=1;for(;Ee<=pe;)if(H<Y[3*Ee])Ee=2*Ee;else if(H>Y[3*Ee+1])Ee=2*Ee+1;else return Y[3*Ee+2];return 0}}de._INSTANCE=null;function Ue(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function he(U,H){if(U===0)return 0;const Y=me(U,H);if(Y!==void 0)return Y;const pe=q(H,U);return U-=fe(pe),U}e.getLeftDeleteOffset=he;function me(U,H){let Y=q(H,U);for(U-=fe(Y);V(Y)||Y===65039||Y===8419;){if(U===0)return;Y=q(H,U),U-=fe(Y)}if(!!je(Y)){if(U>=0){const pe=q(H,U);pe===8205&&(U-=fe(pe))}return U}}function fe(U){return U>=65536?2:1}function V(U){return 127995<=U&&U<=127999}var Q;(function(U){U[U.zwj=8205]="zwj",U[U.emojiVariantSelector=65039]="emojiVariantSelector",U[U.enclosingKeyCap=8419]="enclosingKeyCap"})(Q||(Q={}))}),define(le[18],ce([0,1,13,42]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const p=typeof Buffer!="undefined",D=typeof TextEncoder!="undefined",I=typeof TextDecoder!="undefined";let _,m;class y{constructor(v){this.buffer=v,this.byteLength=this.buffer.byteLength}static alloc(v){return p?new y(Buffer.allocUnsafe(v)):new y(new Uint8Array(v))}static wrap(v){return p&&!Buffer.isBuffer(v)&&(v=Buffer.from(v.buffer,v.byteOffset,v.byteLength)),new y(v)}static fromString(v,T){return!((T==null?void 0:T.dontUseNodeBuffer)||!1)&&p?new y(Buffer.from(v)):D?(_||(_=new TextEncoder),new y(_.encode(v))):new y(E.encodeUTF8(v))}static concat(v,T){if(typeof T=="undefined"){T=0;for(let F=0,B=v.length;F<B;F++)T+=v[F].byteLength}const R=y.alloc(T);let o=0;for(let F=0,B=v.length;F<B;F++){const Z=v[F];R.set(Z,o),o+=Z.byteLength}return R}toString(){return p?this.buffer.toString():I?(m||(m=new TextDecoder),m.decode(this.buffer)):E.decodeUTF8(this.buffer)}slice(v,T){return new y(this.buffer.subarray(v,T))}set(v,T){v instanceof y?this.buffer.set(v.buffer,T):this.buffer.set(v,T)}readUInt32BE(v){return d(this.buffer,v)}writeUInt32BE(v,T){b(this.buffer,v,T)}readUInt32LE(v){return f(this.buffer,v)}writeUInt32LE(v,T){c(this.buffer,v,T)}readUInt8(v){return S(this.buffer,v)}writeUInt8(v,T){w(this.buffer,v,T)}}e.VSBuffer=y;function r(g,v){return g[v+0]<<0>>>0|g[v+1]<<8>>>0}e.readUInt16LE=r;function k(g,v,T){g[T+0]=v&255,v=v>>>8,g[T+1]=v&255}e.writeUInt16LE=k;function d(g,v){return g[v]*2**24+g[v+1]*2**16+g[v+2]*2**8+g[v+3]}e.readUInt32BE=d;function b(g,v,T){g[T+3]=v,v=v>>>8,g[T+2]=v,v=v>>>8,g[T+1]=v,v=v>>>8,g[T]=v}e.writeUInt32BE=b;function f(g,v){return g[v+0]<<0>>>0|g[v+1]<<8>>>0|g[v+2]<<16>>>0|g[v+3]<<24>>>0}e.readUInt32LE=f;function c(g,v,T){g[T+0]=v&255,v=v>>>8,g[T+1]=v&255,v=v>>>8,g[T+2]=v&255,v=v>>>8,g[T+3]=v&255}e.writeUInt32LE=c;function S(g,v){return g[v]}e.readUInt8=S;function w(g,v,T){g[T]=v}e.writeUInt8=w;function C(g){return P.consumeReadable(g,v=>y.concat(v))}e.readableToBuffer=C;function h(g){return P.toReadable(g)}e.bufferToReadable=h;function l(g){return P.consumeStream(g,v=>y.concat(v))}e.streamToBuffer=l;async function a(g){return g.ended?y.concat(g.buffer):y.concat([...g.buffer,await l(g.stream)])}e.bufferedStreamToBuffer=a;function t(g){return P.toStream(g,v=>y.concat(v))}e.bufferToStream=t;function i(g){return P.transform(g,{data:v=>typeof v=="string"?y.fromString(v):y.wrap(v)},v=>y.concat(v))}e.streamToBufferReadableStream=i;function n(g){return P.newWriteableStream(v=>y.concat(v),g)}e.newWriteableBufferStream=n;function s(g,v){return P.prefixedReadable(g,v,T=>y.concat(T))}e.prefixedBufferReadable=s;function u(g,v){return P.prefixedStream(g,v,T=>y.concat(T))}e.prefixedBufferStream=u}),define(le[117],ce([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.doHash=e.hash=void 0;function P(w){return p(w,0)}e.hash=P;function p(w,C){switch(typeof w){case"object":return w===null?D(349,C):Array.isArray(w)?m(w,C):y(w,C);case"string":return _(w,C);case"boolean":return I(w,C);case"number":return D(w,C);case"undefined":return D(937,C);default:return D(617,C)}}e.doHash=p;function D(w,C){return(C<<5)-C+w|0}function I(w,C){return D(w?433:863,C)}function _(w,C){C=D(149417,C);for(let h=0,l=w.length;h<l;h++)C=D(w.charCodeAt(h),C);return C}e.stringHash=_;function m(w,C){return C=D(104579,C),w.reduce((h,l)=>p(l,h),C)}function y(w,C){return C=D(181387,C),Object.keys(w).sort().reduce((h,l)=>(h=_(l,h),p(w[l],h)),C)}class r{constructor(){this._value=0}get value(){return this._value}hash(C){return this._value=p(C,this._value),this._value}}e.Hasher=r;var k;(function(w){w[w.BLOCK_SIZE=64]="BLOCK_SIZE",w[w.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(k||(k={}));function d(w,C,h=32){const l=h-C,a=~((1<<l)-1);return(w<<C|(a&w)>>>l)>>>0}function b(w,C=0,h=w.byteLength,l=0){for(let a=0;a<h;a++)w[C+a]=l}function f(w,C,h="0"){for(;w.length<C;)w=h+w;return w}function c(w,C=32){return w instanceof ArrayBuffer?Array.from(new Uint8Array(w)).map(h=>h.toString(16).padStart(2,"0")).join(""):f((w>>>0).toString(16),C/4)}e.toHexString=c;class S{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(C){const h=C.length;if(h===0)return;const l=this._buff;let a=this._buffLen,t=this._leftoverHighSurrogate,i,n;for(t!==0?(i=t,n=-1,t=0):(i=C.charCodeAt(0),n=0);;){let s=i;if(E.isHighSurrogate(i))if(n+1<h){const u=C.charCodeAt(n+1);E.isLowSurrogate(u)?(n++,s=E.computeCodePoint(i,u)):s=65533}else{t=i;break}else E.isLowSurrogate(i)&&(s=65533);if(a=this._push(l,a,s),n++,n<h)i=C.charCodeAt(n);else break}this._buffLen=a,this._leftoverHighSurrogate=t}_push(C,h,l){return l<128?C[h++]=l:l<2048?(C[h++]=192|(l&1984)>>>6,C[h++]=128|(l&63)>>>0):l<65536?(C[h++]=224|(l&61440)>>>12,C[h++]=128|(l&4032)>>>6,C[h++]=128|(l&63)>>>0):(C[h++]=240|(l&1835008)>>>18,C[h++]=128|(l&258048)>>>12,C[h++]=128|(l&4032)>>>6,C[h++]=128|(l&63)>>>0),h>=64&&(this._step(),h-=64,this._totalLen+=64,C[0]=C[64+0],C[1]=C[64+1],C[2]=C[64+2]),h}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),c(this._h0)+c(this._h1)+c(this._h2)+c(this._h3)+c(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,b(this._buff,this._buffLen),this._buffLen>56&&(this._step(),b(this._buff));const C=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(C/4294967296),!1),this._buffDV.setUint32(60,C%4294967296,!1),this._step()}_step(){const C=S._bigBlock32,h=this._buffDV;for(let v=0;v<64;v+=4)C.setUint32(v,h.getUint32(v,!1),!1);for(let v=64;v<320;v+=4)C.setUint32(v,d(C.getUint32(v-12,!1)^C.getUint32(v-32,!1)^C.getUint32(v-56,!1)^C.getUint32(v-64,!1),1),!1);let l=this._h0,a=this._h1,t=this._h2,i=this._h3,n=this._h4,s,u,g;for(let v=0;v<80;v++)v<20?(s=a&t|~a&i,u=1518500249):v<40?(s=a^t^i,u=1859775393):v<60?(s=a&t|a&i|t&i,u=2400959708):(s=a^t^i,u=3395469782),g=d(l,5)+s+n+u+C.getUint32(v*4,!1)&4294967295,n=i,i=t,t=d(a,30),a=l,l=g;this._h0=this._h0+l&4294967295,this._h1=this._h1+a&4294967295,this._h2=this._h2+t&4294967295,this._h3=this._h3+i&4294967295,this._h4=this._h4+n&4294967295}}e.StringSHA1=S,S._bigBlock32=new DataView(new ArrayBuffer(320))}),define(le[73],ce([0,1,13]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var P;(function(p){p[p.Ignore=0]="Ignore",p[p.Info=1]="Info",p[p.Warning=2]="Warning",p[p.Error=3]="Error"})(P||(P={})),function(p){const D="error",I="warning",_="warn",m="info",y="ignore";function r(d){return d?E.equalsIgnoreCase(D,d)?p.Error:E.equalsIgnoreCase(I,d)||E.equalsIgnoreCase(_,d)?p.Warning:E.equalsIgnoreCase(m,d)?p.Info:p.Ignore:p.Ignore}p.fromValue=r;function k(d){switch(d){case p.Error:return D;case p.Warning:return I;case p.Info:return m;default:return y}}p.toString=k}(P||(P={})),e.default=P}),define(le[11],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function E(v){return Array.isArray(v)}e.isArray=E;function P(v){return typeof v=="string"}e.isString=P;function p(v){return Array.isArray(v)&&v.every(T=>P(T))}e.isStringArray=p;function D(v){return typeof v=="object"&&v!==null&&!Array.isArray(v)&&!(v instanceof RegExp)&&!(v instanceof Date)}e.isObject=D;function I(v){return typeof v=="number"&&!isNaN(v)}e.isNumber=I;function _(v){return!!v&&typeof v[Symbol.iterator]=="function"}e.isIterable=_;function m(v){return v===!0||v===!1}e.isBoolean=m;function y(v){return typeof v=="undefined"}e.isUndefined=y;function r(v){return!k(v)}e.isDefined=r;function k(v){return y(v)||v===null}e.isUndefinedOrNull=k;function d(v,T){if(!v)throw new Error(T?`Unexpected type, expected '${T}'`:"Unexpected type")}e.assertType=d;function b(v){if(k(v))throw new Error("Assertion Failed: argument is undefined or null");return v}e.assertIsDefined=b;function f(...v){const T=[];for(let R=0;R<v.length;R++){const o=v[R];if(k(o))throw new Error(`Assertion Failed: argument at index ${R} is undefined or null`);T.push(o)}return T}e.assertAllDefined=f;const c=Object.prototype.hasOwnProperty;function S(v){if(!D(v))return!1;for(let T in v)if(c.call(v,T))return!1;return!0}e.isEmptyObject=S;function w(v){return typeof v=="function"}e.isFunction=w;function C(...v){return v.length>0&&v.every(w)}e.areFunctions=C;function h(v,T){const R=Math.min(v.length,T.length);for(let o=0;o<R;o++)l(v[o],T[o])}e.validateConstraints=h;function l(v,T){if(P(T)){if(typeof v!==T)throw new Error(`argument does not match constraint: typeof ${T}`)}else if(w(T)){try{if(v instanceof T)return}catch(R){}if(!k(v)&&v.constructor===T||T.length===1&&T.call(void 0,v)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function a(v){let T=[],R=Object.getPrototypeOf(v);for(;Object.prototype!==R;)T=T.concat(Object.getOwnPropertyNames(R)),R=Object.getPrototypeOf(R);return T}e.getAllPropertyNames=a;function t(v){const T=[];for(const R of a(v))typeof v[R]=="function"&&T.push(R);return T}e.getAllMethodNames=t;function i(v,T){const R=F=>function(){const B=Array.prototype.slice.call(arguments,0);return T(F,B)};let o={};for(const F of v)o[F]=R(F);return o}e.createProxyObject=i;function n(v){return v===null?void 0:v}e.withNullAsUndefined=n;function s(v){return typeof v=="undefined"?null:v}e.withUndefinedAsNull=s;function u(v){return class{constructor(){return new Proxy({},{get(T,R){if(T[R])return T[R];throw new Error(`Not Implemented: ${v}->${String(R)}`)}})}}}e.NotImplementedProxy=u;function g(v){throw new Error("Unreachable")}e.assertNever=g}),define(le[30],ce([0,1,5,13,3,11]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function I(n){return n===47||n===92}e.isPathSeparator=I;function _(n){return n.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=_;function m(n){return n.indexOf("/")===-1&&(n=_(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}e.toPosixPath=m;function y(n,s=p.posix.sep){if(!n)return"";const u=n.length,g=n.charCodeAt(0);if(I(g)){if(I(n.charCodeAt(1))&&!I(n.charCodeAt(2))){let T=3;const R=T;for(;T<u&&!I(n.charCodeAt(T));T++);if(R!==T&&!I(n.charCodeAt(T+1))){for(T+=1;T<u;T++)if(I(n.charCodeAt(T)))return n.slice(0,T+1).replace(/[\\/]/g,s)}}return s}else if(w(g)&&n.charCodeAt(1)===58)return I(n.charCodeAt(2))?n.slice(0,2)+s:n.slice(0,2);let v=n.indexOf("://");if(v!==-1){for(v+=3;v<u;v++)if(I(n.charCodeAt(v)))return n.slice(0,v+1)}return""}e.getRoot=y;function r(n){if(!E.isWindows||!n||n.length<5)return!1;let s=n.charCodeAt(0);if(s!==92||(s=n.charCodeAt(1),s!==92))return!1;let u=2;const g=u;for(;u<n.length&&(s=n.charCodeAt(u),s!==92);u++);return!(g===u||(s=n.charCodeAt(u+1),isNaN(s)||s===92))}e.isUNC=r;const k=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,b=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(n,s=E.isWindows){const u=s?k:d;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||s&&b.test(n)||n==="."||n===".."||s&&n[n.length-1]==="."||s&&n.length!==n.trim().length||n.length>255)}e.isValidBasename=f;function c(n,s,u){const g=n===s;return!u||g?g:!n||!s?!1:P.equalsIgnoreCase(n,s)}e.isEqual=c;function S(n,s,u,g=p.sep){if(n===s)return!0;if(!n||!s||s.length>n.length)return!1;if(u){if(!P.startsWithIgnoreCase(n,s))return!1;if(s.length===n.length)return!0;let T=s.length;return s.charAt(s.length-1)===g&&T--,n.charAt(T)===g}return s.charAt(s.length-1)!==g&&(s+=g),n.indexOf(s)===0}e.isEqualOrParent=S;function w(n){return n>=65&&n<=90||n>=97&&n<=122}e.isWindowsDriveLetter=w;function C(n,s){return E.isWindows&&n.endsWith(":")&&(n+=p.sep),p.isAbsolute(n)||(n=p.join(s,n)),n=p.normalize(n),E.isWindows?(n=P.rtrim(n,p.sep),n.endsWith(":")&&(n+=p.sep)):(n=P.rtrim(n,p.sep),n||(n=p.sep)),n}e.sanitizeFilePath=C;function h(n){const s=p.normalize(n);return E.isWindows?n.length>3?!1:l(s)&&(n.length===2||s.charCodeAt(2)===92):s===p.posix.sep}e.isRootOrDriveLetter=h;function l(n){return E.isWindows?w(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function a(n){return l(n)?n[0]:void 0}e.getDriveLetter=a;function t(n,s,u){return s.length>n.length?-1:n===s?0:(u&&(n=n.toLowerCase(),s=s.toLowerCase()),n.indexOf(s))}e.indexOfPath=t;function i(n){const s=n.split(":");let u,g,v;if(s.forEach(T=>{const R=Number(T);D.isNumber(R)?g===void 0?g=R:v===void 0&&(v=R):u=u?[u,T].join(":"):T}),!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:g!==void 0?g:void 0,column:v!==void 0?v:g!==void 0?1:void 0}}e.parseLineAndColumnAware=i}),define(le[19],ce([0,1,11]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function P(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const S=Array.isArray(c)?[]:{};return Object.keys(c).forEach(w=>{c[w]&&typeof c[w]=="object"?S[w]=P(c[w]):S[w]=c[w]}),S}e.deepClone=P;function p(c){if(!c||typeof c!="object")return c;const S=[c];for(;S.length>0;){const w=S.shift();Object.freeze(w);for(const C in w)if(D.call(w,C)){const h=w[C];typeof h=="object"&&!Object.isFrozen(h)&&S.push(h)}}return c}e.deepFreeze=p;const D=Object.prototype.hasOwnProperty;function I(c,S){return _(c,S,new Set)}e.cloneAndChange=I;function _(c,S,w){if(E.isUndefinedOrNull(c))return c;const C=S(c);if(typeof C!="undefined")return C;if(E.isArray(c)){const h=[];for(const l of c)h.push(_(l,S,w));return h}if(E.isObject(c)){if(w.has(c))throw new Error("Cannot clone recursive data-structure");w.add(c);const h={};for(let l in c)D.call(c,l)&&(h[l]=_(c[l],S,w));return w.delete(c),h}return c}function m(c,S,w=!0){return E.isObject(c)?(E.isObject(S)&&Object.keys(S).forEach(C=>{C in c?w&&(E.isObject(c[C])&&E.isObject(S[C])?m(c[C],S[C],w):c[C]=S[C]):c[C]=S[C]}),c):S}e.mixin=m;function y(c,S){if(c===S)return!0;if(c==null||S===null||S===void 0||typeof c!=typeof S||typeof c!="object"||Array.isArray(c)!==Array.isArray(S))return!1;let w,C;if(Array.isArray(c)){if(c.length!==S.length)return!1;for(w=0;w<c.length;w++)if(!y(c[w],S[w]))return!1}else{const h=[];for(C in c)h.push(C);h.sort();const l=[];for(C in S)l.push(C);if(l.sort(),!y(h,l))return!1;for(w=0;w<h.length;w++)if(!y(c[h[w]],S[h[w]]))return!1}return!0}e.equals=y;function r(c){const S=new Set;return JSON.stringify(c,(w,C)=>{if(E.isObject(C)||Array.isArray(C)){if(S.has(C))return"[Circular]";S.add(C)}return C})}e.safeStringify=r;function k(c,S,w){const C=S(c);return typeof C=="undefined"?w:C}e.getOrDefault=k;function d(c,S){const w=Object.create(null);return!c||!S||Object.keys(S).forEach(h=>{const l=c[h],a=S[h];y(l,a)||(w[h]=a)}),w}e.distinct=d;function b(c,S){const w=S.toLowerCase(),C=Object.keys(c).find(h=>h.toLowerCase()===w);return C?c[C]:c[S]}e.getCaseInsensitive=b;function f(c,S){const w=Object.create(null);for(const C of Object.keys(c))S(C,c[C])&&(w[C]=c[C]);return w}e.filter=f}),define(le[4],ce([0,1,5,3]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const p=/^\w[\w\d+.-]*$/,D=/^\//,I=/^\/\//;function _(n,s){if(!n.scheme&&s)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${n.authority}", path: "${n.path}", query: "${n.query}", fragment: "${n.fragment}"}`);if(n.scheme&&!p.test(n.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(n.path){if(n.authority){if(!D.test(n.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(I.test(n.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function m(n,s){return!n&&!s?"file":n}function y(n,s){switch(n){case"https":case"http":case"file":s?s[0]!==k&&(s=k+s):s=k;break}return s}const r="",k="/",d=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class b{constructor(s,u,g,v,T,R=!1){typeof s=="object"?(this.scheme=s.scheme||r,this.authority=s.authority||r,this.path=s.path||r,this.query=s.query||r,this.fragment=s.fragment||r):(this.scheme=m(s,R),this.authority=u||r,this.path=y(this.scheme,g||r),this.query=v||r,this.fragment=T||r,_(this,R))}static isUri(s){return s instanceof b?!0:s?typeof s.authority=="string"&&typeof s.fragment=="string"&&typeof s.path=="string"&&typeof s.query=="string"&&typeof s.scheme=="string"&&typeof s.fsPath=="string"&&typeof s.with=="function"&&typeof s.toString=="function":!1}get fsPath(){return h(this,!1)}with(s){if(!s)return this;let{scheme:u,authority:g,path:v,query:T,fragment:R}=s;return u===void 0?u=this.scheme:u===null&&(u=r),g===void 0?g=this.authority:g===null&&(g=r),v===void 0?v=this.path:v===null&&(v=r),T===void 0?T=this.query:T===null&&(T=r),R===void 0?R=this.fragment:R===null&&(R=r),u===this.scheme&&g===this.authority&&v===this.path&&T===this.query&&R===this.fragment?this:new c(u,g,v,T,R)}static parse(s,u=!1){const g=d.exec(s);return g?new c(g[2]||r,i(g[4]||r),i(g[5]||r),i(g[7]||r),i(g[9]||r),u):new c(r,r,r,r,r)}static file(s){let u=r;if(E.isWindows&&(s=s.replace(/\\/g,k)),s[0]===k&&s[1]===k){const g=s.indexOf(k,2);g===-1?(u=s.substring(2),s=k):(u=s.substring(2,g),s=s.substring(g)||k)}return new c("file",u,s,r,r)}static from(s){const u=new c(s.scheme,s.authority,s.path,s.query,s.fragment);return _(u,!0),u}static joinPath(s,...u){if(!s.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let g;return E.isWindows&&s.scheme==="file"?g=b.file(P.win32.join(h(s,!0),...u)).path:g=P.posix.join(s.path,...u),s.with({path:g})}toString(s=!1){return l(this,s)}toJSON(){return this}static revive(s){if(s){if(s instanceof b)return s;{const u=new c(s);return u._formatted=s.external,u._fsPath=s._sep===f?s.fsPath:null,u}}else return s}}e.URI=b;const f=E.isWindows?1:void 0;class c extends b{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=h(this,!1)),this._fsPath}toString(s=!1){return s?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const s={$mid:1};return this._fsPath&&(s.fsPath=this._fsPath,s._sep=f),this._formatted&&(s.external=this._formatted),this.path&&(s.path=this.path),this.scheme&&(s.scheme=this.scheme),this.authority&&(s.authority=this.authority),this.query&&(s.query=this.query),this.fragment&&(s.fragment=this.fragment),s}}const S={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function w(n,s){let u,g=-1;for(let v=0;v<n.length;v++){const T=n.charCodeAt(v);if(T>=97&&T<=122||T>=65&&T<=90||T>=48&&T<=57||T===45||T===46||T===95||T===126||s&&T===47)g!==-1&&(u+=encodeURIComponent(n.substring(g,v)),g=-1),u!==void 0&&(u+=n.charAt(v));else{u===void 0&&(u=n.substr(0,v));const R=S[T];R!==void 0?(g!==-1&&(u+=encodeURIComponent(n.substring(g,v)),g=-1),u+=R):g===-1&&(g=v)}}return g!==-1&&(u+=encodeURIComponent(n.substring(g))),u!==void 0?u:n}function C(n){let s;for(let u=0;u<n.length;u++){const g=n.charCodeAt(u);g===35||g===63?(s===void 0&&(s=n.substr(0,u)),s+=S[g]):s!==void 0&&(s+=n[u])}return s!==void 0?s:n}function h(n,s){let u;return n.authority&&n.path.length>1&&n.scheme==="file"?u=`//${n.authority}${n.path}`:n.path.charCodeAt(0)===47&&(n.path.charCodeAt(1)>=65&&n.path.charCodeAt(1)<=90||n.path.charCodeAt(1)>=97&&n.path.charCodeAt(1)<=122)&&n.path.charCodeAt(2)===58?s?u=n.path.substr(1):u=n.path[1].toLowerCase()+n.path.substr(2):u=n.path,E.isWindows&&(u=u.replace(/\//g,"\\")),u}e.uriToFsPath=h;function l(n,s){const u=s?C:w;let g="",{scheme:v,authority:T,path:R,query:o,fragment:F}=n;if(v&&(g+=v,g+=":"),(T||v==="file")&&(g+=k,g+=k),T){let B=T.indexOf("@");if(B!==-1){const Z=T.substr(0,B);T=T.substr(B+1),B=Z.indexOf(":"),B===-1?g+=u(Z,!1):(g+=u(Z.substr(0,B),!1),g+=":",g+=u(Z.substr(B+1),!1)),g+="@"}T=T.toLowerCase(),B=T.indexOf(":"),B===-1?g+=u(T,!1):(g+=u(T.substr(0,B),!1),g+=T.substr(B))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const B=R.charCodeAt(1);B>=65&&B<=90&&(R=`/${String.fromCharCode(B+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const B=R.charCodeAt(0);B>=65&&B<=90&&(R=`${String.fromCharCode(B+32)}:${R.substr(2)}`)}g+=u(R,!0)}return o&&(g+="?",g+=u(o,!1)),F&&(g+="#",g+=s?F:w(F,!1)),g}function a(n){try{return decodeURIComponent(n)}catch(s){return n.length>3?n.substr(0,3)+a(n.substr(3)):n}}const t=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function i(n){return n.match(t)?n.replace(t,s=>a(s)):n}}),define(le[118],ce([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function P(y){const r=y;return r&&typeof r.type=="string"&&typeof r.severity=="string"}e.isRemoteConsoleLog=P;function p(y){const r=[];let k;try{const d=JSON.parse(y.arguments),b=d[d.length-1];b&&b.__$stack&&(d.pop(),k=b.__$stack),r.push(...d)}catch(d){r.push("Unable to log remote console arguments",y.arguments)}return{args:r,stack:k}}e.parse=p;function D(y){if(typeof y!="string")return D(p(y).stack);const r=y;if(r){const k=I(r),d=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(k||"");if(d&&d.length===4)return{uri:E.URI.file(d[1]),line:Number(d[2]),column:Number(d[3])}}}e.getFirstFrame=D;function I(y){if(!y)return y;const r=y.indexOf(`
`);return r===-1?y:y.substring(0,r)}function _(y,r){const{args:k,stack:d}=p(y),b=typeof k[0]=="string"&&k.length===1;let f=I(d);f&&(f=`(${f.trim()})`);let c=[];if(typeof k[0]=="string"?f&&b?c=[`%c[${r}] %c${k[0]} %c${f}`,m("blue"),m(""),m("grey")]:c=[`%c[${r}] %c${k[0]}`,m("blue"),m(""),...k.slice(1)]:c=[`%c[${r}]%`,m("blue"),...k],f&&!b&&c.push(f),typeof console[y.severity]!="function")throw new Error("Unknown console method");console[y.severity].apply(console,c)}e.log=_;function m(y){return`color: ${y}`}});var wt=this&&this.__classPrivateFieldSet||function(x,e,E,P,p){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!p:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?p.call(x,E):p?p.value=E:e.set(x,E),E},ot=this&&this.__classPrivateFieldGet||function(x,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(x):P?P.value:e.get(x)};define(le[26],ce([0,1,4,13]),function(x,e,E,P){"use strict";var p,D,I;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function _(t,i,n){let s=t.get(i);return s===void 0&&(s=n,t.set(i,s)),s}e.getOrSet=_;function m(t){const i=[];return t.forEach((n,s)=>{i.push(`${s} => ${n}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=m;function y(t){const i=[];return t.forEach(n=>{i.push(n)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=y;class r{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const n=i.charCodeAt(0),s=this._value.charCodeAt(this._pos);return n-s}value(){return this._value[this._pos]}}e.StringIterator=r;class k{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?P.compareSubstring(i,this._value,0,i.length,this._from,this._to):P.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=k;class d{constructor(i=!0,n=!0){this._splitOnBackslash=i,this._caseSensitive=n}reset(i){return this._value=i.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?P.compareSubstring(i,this._value,0,i.length,this._from,this._to):P.compareSubstringIgnoreCase(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=d;var b;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(b||(b={}));class f{constructor(i){this._ignorePathCasing=i,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new d(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return P.compareIgnoreCase(i,this._value.scheme);if(this._states[this._stateIdx]===2)return P.compareIgnoreCase(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return P.compare(i,this._value.query);if(this._states[this._stateIdx]===5)return P.compare(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class c{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class S{constructor(i){this._iter=i}static forUris(i=()=>!1){return new S(new f(i))}static forPaths(){return new S(new d)}static forStrings(){return new S(new r)}static forConfigKeys(){return new S(new k)}clear(){this._root=void 0}set(i,n){const s=this._iter.reset(i);let u;for(this._root||(this._root=new c,this._root.segment=s.value()),u=this._root;;){const v=s.cmp(u.segment);if(v>0)u.left||(u.left=new c,u.left.segment=s.value()),u=u.left;else if(v<0)u.right||(u.right=new c,u.right.segment=s.value()),u=u.right;else if(s.hasNext())s.next(),u.mid||(u.mid=new c,u.mid.segment=s.value()),u=u.mid;else break}const g=u.value;return u.value=n,u.key=i,g}get(i){var n;return(n=this._getNode(i))===null||n===void 0?void 0:n.value}_getNode(i){const n=this._iter.reset(i);let s=this._root;for(;s;){const u=n.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else break}return s}has(i){const n=this._getNode(i);return!((n==null?void 0:n.value)===void 0&&(n==null?void 0:n.mid)===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,n){const s=this._iter.reset(i),u=[];let g=this._root;for(;g;){const v=s.cmp(g.segment);if(v>0)u.push([1,g]),g=g.left;else if(v<0)u.push([-1,g]),g=g.right;else if(s.hasNext())s.next(),u.push([0,g]),g=g.mid;else{for(n?(g.left=void 0,g.mid=void 0,g.right=void 0):g.value=void 0;u.length>0&&g.isEmpty();){let[T,R]=u.pop();switch(T){case 1:R.left=void 0;break;case 0:R.mid=void 0;break;case-1:R.right=void 0;break}g=R}break}}}findSubstr(i){const n=this._iter.reset(i);let s=this._root,u;for(;s;){const g=n.cmp(s.segment);if(g>0)s=s.left;else if(g<0)s=s.right;else if(n.hasNext())n.next(),u=s.value||u,s=s.mid;else break}return s&&s.value||u}findSuperstr(i){const n=this._iter.reset(i);let s=this._root;for(;s;){const u=n.cmp(s.segment);if(u>0)s=s.left;else if(u<0)s=s.right;else if(n.hasNext())n.next(),s=s.mid;else return s.mid?this._entries(s.mid):void 0}}forEach(i){for(const[n,s]of this)i(s,n)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(i,n=0){if(n>5e3){console.log("potential CYCLE detected",new Error().stack);return}i&&(yield*this._entries(i.left,n++),i.value&&(yield[i.key,i.value]),yield*this._entries(i.mid,n++),yield*this._entries(i.right,n++))}}e.TernarySearchTree=S;class w{constructor(i,n){this[p]="ResourceMap",i instanceof w?(this.map=new Map(i.map),this.toKey=n??w.defaultToKey):(this.map=new Map,this.toKey=i??w.defaultToKey)}set(i,n){return this.map.set(this.toKey(i),n),this}get(i){return this.map.get(this.toKey(i))}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,n){typeof n!="undefined"&&(i=i.bind(n));for(let[s,u]of this.map)i(u,E.URI.parse(s),this)}values(){return this.map.values()}*keys(){for(let i of this.map.keys())yield E.URI.parse(i)}*entries(){for(let i of this.map.entries())yield[E.URI.parse(i[0]),i[1]]}*[(p=Symbol.toStringTag,Symbol.iterator)](){for(let i of this.map)yield[E.URI.parse(i[0]),i[1]]}}e.ResourceMap=w,w.defaultToKey=t=>t.toString();var C;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(C=e.Touch||(e.Touch={}));class h{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){var i;return(i=this._head)===null||i===void 0?void 0:i.value}get last(){var i;return(i=this._tail)===null||i===void 0?void 0:i.value}has(i){return this._map.has(i)}get(i,n=0){const s=this._map.get(i);if(!!s)return n!==0&&this.touch(s,n),s.value}set(i,n,s=0){let u=this._map.get(i);if(u)u.value=n,s!==0&&this.touch(u,s);else{switch(u={key:i,value:n,next:void 0,previous:void 0},s){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(i,u),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const n=this._map.get(i);if(!!n)return this._map.delete(i),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,n){const s=this._state;let u=this._head;for(;u;){if(n?i.bind(n)(u.value,u.key,this):i(u.value,u.key,this),this._state!==s)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const i=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:s.key,done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return u}values(){const i=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:s.value,done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return u}entries(){const i=this,n=this._state;let s=this._head;const u={[Symbol.iterator](){return u},next(){if(i._state!==n)throw new Error("LinkedMap got modified during iteration.");if(s){const g={value:[s.key,s.value],done:!1};return s=s.next,g}else return{value:void 0,done:!0}}};return u}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let n=this._head,s=this.size;for(;n&&s>i;)this._map.delete(n.key),n=n.next,s--;this._head=n,this._size=s,n&&(n.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const n=i.next,s=i.previous;if(!n||!s)throw new Error("Invalid list");n.previous=s,s.next=n}i.next=void 0,i.previous=void 0,this._state++}touch(i,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(i===this._head)return;const s=i.next,u=i.previous;i===this._tail?(u.next=void 0,this._tail=u):(s.previous=u,u.next=s),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(n===2){if(i===this._tail)return;const s=i.next,u=i.previous;i===this._head?(s.previous=void 0,this._head=s):(s.previous=u,u.next=s),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((n,s)=>{i.push([s,n])}),i}fromJSON(i){this.clear();for(const[n,s]of i)this.set(n,s)}}e.LinkedMap=h;class l extends h{constructor(i,n=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,n=2){return super.get(i,n)}peek(i){return super.get(i,0)}set(i,n){return super.set(i,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=l;class a{constructor(i){I.set(this,void 0),wt(this,I,i,"f")}get size(){return ot(this,I,"f").size}forEach(i,n){ot(this,I,"f").forEach(i,n)}get(i){return ot(this,I,"f").get(i)}has(i){return ot(this,I,"f").has(i)}entries(){return ot(this,I,"f").entries()}keys(){return ot(this,I,"f").keys()}values(){return ot(this,I,"f").values()}[(I=new WeakMap,Symbol.iterator)](){return ot(this,I,"f").entries()}}e.ReadonlyMapView=a}),define(le[119],ce([0,1,26,13]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function p(...ge){return function(Ie,_e){for(let Re=0,Me=ge.length;Re<Me;Re++){const ze=ge[Re](Ie,_e);if(ze)return ze}return null}}e.or=p,e.matchesStrictPrefix=D.bind(void 0,!1),e.matchesPrefix=D.bind(void 0,!0);function D(ge,Ie,_e){if(!_e||_e.length<Ie.length)return null;let Re;return ge?Re=P.startsWithIgnoreCase(_e,Ie):Re=_e.indexOf(Ie)===0,Re?Ie.length>0?[{start:0,end:Ie.length}]:[]:null}function I(ge,Ie){const _e=Ie.toLowerCase().indexOf(ge.toLowerCase());return _e===-1?null:[{start:_e,end:_e+ge.length}]}e.matchesContiguousSubString=I;function _(ge,Ie){return m(ge.toLowerCase(),Ie.toLowerCase(),0,0)}e.matchesSubString=_;function m(ge,Ie,_e,Re){if(_e===ge.length)return[];if(Re===Ie.length)return null;if(ge[_e]===Ie[Re]){let Me=null;return(Me=m(ge,Ie,_e+1,Re+1))?w({start:Re,end:Re+1},Me):null}return m(ge,Ie,_e,Re+1)}function y(ge){return 97<=ge&&ge<=122}function r(ge){return 65<=ge&&ge<=90}e.isUpper=r;function k(ge){return 48<=ge&&ge<=57}function d(ge){return ge===32||ge===9||ge===10||ge===13}const b=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(ge=>b.add(ge.charCodeAt(0)));function f(ge){return d(ge)||b.has(ge)}function c(ge,Ie){return ge===Ie||f(ge)&&f(Ie)}function S(ge){return y(ge)||r(ge)||k(ge)}function w(ge,Ie){return Ie.length===0?Ie=[ge]:ge.end===Ie[0].start?Ie[0].start=ge.start:Ie.unshift(ge),Ie}function C(ge,Ie){for(let _e=Ie;_e<ge.length;_e++){const Re=ge.charCodeAt(_e);if(r(Re)||k(Re)||_e>0&&!S(ge.charCodeAt(_e-1)))return _e}return ge.length}function h(ge,Ie,_e,Re){if(_e===ge.length)return[];if(Re===Ie.length)return null;if(ge[_e]!==Ie[Re].toLowerCase())return null;{let Me=null,ze=Re+1;for(Me=h(ge,Ie,_e+1,Re+1);!Me&&(ze=C(Ie,ze))<Ie.length;)Me=h(ge,Ie,_e+1,ze),ze++;return Me===null?null:w({start:Re,end:Re+1},Me)}}function l(ge){let Ie=0,_e=0,Re=0,Me=0,ze=0;for(let ve=0;ve<ge.length;ve++)ze=ge.charCodeAt(ve),r(ze)&&Ie++,y(ze)&&_e++,S(ze)&&Re++,k(ze)&&Me++;const He=Ie/ge.length,xe=_e/ge.length,tt=Re/ge.length,te=Me/ge.length;return{upperPercent:He,lowerPercent:xe,alphaPercent:tt,numericPercent:te}}function a(ge){const{upperPercent:Ie,lowerPercent:_e}=ge;return _e===0&&Ie>.6}function t(ge){const{upperPercent:Ie,lowerPercent:_e,alphaPercent:Re,numericPercent:Me}=ge;return _e>.2&&Ie<.8&&Re>.6&&Me<.2}function i(ge){let Ie=0,_e=0,Re=0,Me=0;for(let ze=0;ze<ge.length;ze++)Re=ge.charCodeAt(ze),r(Re)&&Ie++,y(Re)&&_e++,d(Re)&&Me++;return(Ie===0||_e===0)&&Me===0?ge.length<=30:Ie<=5}function n(ge,Ie){if(!Ie||(Ie=Ie.trim(),Ie.length===0)||!i(ge)||Ie.length>60)return null;const _e=l(Ie);if(!t(_e)){if(!a(_e))return null;Ie=Ie.toLowerCase()}let Re=null,Me=0;for(ge=ge.toLowerCase();Me<Ie.length&&(Re=h(ge,Ie,0,Me))===null;)Me=C(Ie,Me+1);return Re}e.matchesCamelCase=n;function s(ge,Ie,_e=!1){if(!Ie||Ie.length===0)return null;let Re=null,Me=0;for(ge=ge.toLowerCase(),Ie=Ie.toLowerCase();Me<Ie.length&&(Re=u(ge,Ie,0,Me,_e))===null;)Me=g(Ie,Me+1);return Re}e.matchesWords=s;function u(ge,Ie,_e,Re,Me){if(_e===ge.length)return[];if(Re===Ie.length)return null;if(c(ge.charCodeAt(_e),Ie.charCodeAt(Re))){let ze=null,He=Re+1;if(ze=u(ge,Ie,_e+1,Re+1,Me),!Me)for(;!ze&&(He=g(Ie,He))<Ie.length;)ze=u(ge,Ie,_e+1,He,Me),He++;return ze===null?null:w({start:Re,end:Re+1},ze)}else return null}function g(ge,Ie){for(let _e=Ie;_e<ge.length;_e++)if(f(ge.charCodeAt(_e))||_e>0&&f(ge.charCodeAt(_e-1)))return _e;return ge.length}const v=p(e.matchesPrefix,n,I),T=p(e.matchesPrefix,n,_),R=new E.LRUCache(1e4);function o(ge,Ie,_e=!1){if(typeof ge!="string"||typeof Ie!="string")return null;let Re=R.get(ge);Re||(Re=new RegExp(P.convertSimple2RegExpPattern(ge),"i"),R.set(ge,Re));const Me=Re.exec(Ie);return Me?[{start:Me.index,end:Me.index+Me[0].length}]:_e?T(ge,Ie):v(ge,Ie)}e.matchesFuzzy=o;function F(ge,Ie){const _e=Te(ge,ge.toLowerCase(),0,Ie,Ie.toLowerCase(),0,!0);return _e?Z(_e):null}e.matchesFuzzy2=F;function B(ge,Ie,_e,Re,Me,ze){const He=Math.min(13,ge.length);for(;_e<He;_e++){const xe=Te(ge,Ie,_e,Re,Me,ze,!1);if(xe)return xe}return[0,ze]}e.anyScore=B;function Z(ge){if(typeof ge=="undefined")return[];const Ie=[],_e=ge[1];for(let Re=ge.length-1;Re>1;Re--){const Me=ge[Re]+_e,ze=Ie[Ie.length-1];ze&&ze.end===Me?ze.end=Me+1:Ie.push({start:Me,end:Me+1})}return Ie}e.createMatches=Z;const ie=128;function Se(){const ge=[],Ie=[];for(let _e=0;_e<=ie;_e++)Ie[_e]=0;for(let _e=0;_e<=ie;_e++)ge.push(Ie.slice(0));return ge}function oe(ge){const Ie=[];for(let _e=0;_e<=ge;_e++)Ie[_e]=0;return Ie}const q=oe(2*ie),ee=oe(2*ie),G=Se(),z=Se(),L=Se(),A=!1;function N(ge,Ie,_e,Re,Me){function ze(xe,tt,te=" "){for(;xe.length<tt;)xe=te+xe;return xe}let He=` |   |${Re.split("").map(xe=>ze(xe,3)).join("|")}
`;for(let xe=0;xe<=_e;xe++)xe===0?He+=" |":He+=`${Ie[xe-1]}|`,He+=ge[xe].slice(0,Me+1).map(tt=>ze(tt.toString(),3)).join("|")+`
`;return He}function M(ge,Ie,_e,Re){ge=ge.substr(Ie),_e=_e.substr(Re),console.log(N(z,ge,ge.length,_e,_e.length)),console.log(N(L,ge,ge.length,_e,_e.length)),console.log(N(G,ge,ge.length,_e,_e.length))}function W(ge,Ie){if(Ie<0||Ie>=ge.length)return!1;const _e=ge.codePointAt(Ie);switch(_e){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!P.isEmojiImprecise(_e)}}function X(ge,Ie){if(Ie<0||Ie>=ge.length)return!1;switch(ge.charCodeAt(Ie)){case 32:case 9:return!0;default:return!1}}function ae(ge,Ie,_e){return Ie[ge]!==_e[ge]}function se(ge,Ie,_e,Re,Me,ze,He=!1){for(;Ie<_e&&Me<ze;)ge[Ie]===Re[Me]&&(He&&(q[Ie]=Me),Ie+=1),Me+=1;return Ie===_e}e.isPatternInWord=se;var be;(function(ge){ge[ge.Diag=1]="Diag",ge[ge.Left=2]="Left",ge[ge.LeftLeft=3]="LeftLeft"})(be||(be={}));var ke;(function(ge){ge.Default=[-100,0];function Ie(_e){return!_e||_e.length===2&&_e[0]===-100&&_e[1]===0}ge.isDefault=Ie})(ke=e.FuzzyScore||(e.FuzzyScore={}));function Te(ge,Ie,_e,Re,Me,ze,He){const xe=ge.length>ie?ie:ge.length,tt=Re.length>ie?ie:Re.length;if(_e>=xe||ze>=tt||xe-_e>tt-ze||!se(Ie,_e,xe,Me,ze,tt,!0))return;Le(xe,tt,_e,ze,Ie,Me);let te=1,ve=1,de=_e,Ue=ze;const he=[!1];for(te=1,de=_e;de<xe;te++,de++){const U=q[de],H=ee[de],Y=de+1<xe?ee[de+1]:tt;for(ve=U-ze+1,Ue=U;Ue<Y;ve++,Ue++){let pe=Number.MIN_SAFE_INTEGER,Ee=!1;Ue<=H&&(pe=je(ge,Ie,de,_e,Re,Me,Ue,tt,ze,G[te-1][ve-1]===0,he));let Ce=0;pe!==Number.MAX_SAFE_INTEGER&&(Ee=!0,Ce=pe+z[te-1][ve-1]);const ne=Ue>U,De=ne?z[te][ve-1]+(G[te][ve-1]>0?-5:0):0,Ae=Ue>U+1&&G[te][ve-1]>0,Fe=Ae?z[te][ve-2]+(G[te][ve-2]>0?-5:0):0;if(Ae&&(!ne||Fe>=De)&&(!Ee||Fe>=Ce))z[te][ve]=Fe,L[te][ve]=3,G[te][ve]=0;else if(ne&&(!Ee||De>=Ce))z[te][ve]=De,L[te][ve]=2,G[te][ve]=0;else if(Ee)z[te][ve]=Ce,L[te][ve]=1,G[te][ve]=G[te-1][ve-1]+1;else throw new Error("not possible")}}if(A&&M(ge,_e,Re,ze),!he[0]&&!He)return;te--,ve--;const me=[z[te][ve],ze];let fe=0,V=0;for(;te>=1;){let U=ve;do{const H=L[te][U];if(H===3)U=U-2;else if(H===2)U=U-1;else break}while(U>=1);fe>1&&Ie[_e+te-1]===Me[ze+ve-1]&&!ae(U+ze-1,Re,Me)&&fe+1>G[te][U]&&(U=ve),U===ve?fe++:fe=1,V||(V=U),te--,ve=U-1,me.push(ve)}tt===xe&&(me[0]+=2);const Q=V-xe;return me[0]-=Q,me}e.fuzzyScore=Te;function Le(ge,Ie,_e,Re,Me,ze){let He=ge-1,xe=Ie-1;for(;He>=_e&&xe>=Re;)Me[He]===ze[xe]&&(ee[He]=xe,He--),xe--}function je(ge,Ie,_e,Re,Me,ze,He,xe,tt,te,ve){if(Ie[_e]!==ze[He])return Number.MIN_SAFE_INTEGER;let de=1,Ue=!1;return He===_e-Re?de=ge[_e]===Me[He]?7:5:ae(He,Me,ze)&&(He===0||!ae(He-1,Me,ze))?(de=ge[_e]===Me[He]?7:5,Ue=!0):W(ze,He)&&(He===0||!W(ze,He-1))?de=5:(W(ze,He-1)||X(ze,He-1))&&(de=5,Ue=!0),de>1&&_e===Re&&(ve[0]=!0),Ue||(Ue=ae(He,Me,ze)||W(ze,He-1)||X(ze,He-1)),_e===Re?He>tt&&(de-=Ue?3:5):te?de+=Ue?2:0:de+=Ue?0:1,He+1===xe&&(de-=Ue?3:5),de}function Xe(ge,Ie,_e,Re,Me,ze,He){return it(ge,Ie,_e,Re,Me,ze,!0,He)}e.fuzzyScoreGracefulAggressive=Xe;function Ze(ge,Ie,_e,Re,Me,ze,He){return it(ge,Ie,_e,Re,Me,ze,!1,He)}e.fuzzyScoreGraceful=Ze;function it(ge,Ie,_e,Re,Me,ze,He,xe){let tt=Te(ge,Ie,_e,Re,Me,ze,xe);if(tt&&!He)return tt;if(ge.length>=3){const te=Math.min(7,ge.length-1);for(let ve=_e+1;ve<te;ve++){const de=Ye(ge,ve);if(de){const Ue=Te(de,de.toLowerCase(),_e,Re,Me,ze,xe);Ue&&(Ue[0]-=3,(!tt||Ue[0]>tt[0])&&(tt=Ue))}}}return tt}function Ye(ge,Ie){if(Ie+1>=ge.length)return;const _e=ge[Ie],Re=ge[Ie+1];if(_e!==Re)return ge.slice(0,Ie)+Re+_e+ge.slice(Ie+2)}}),define(le[120],ce([0,1,41,119,13]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const D=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),I=new RegExp(`(\\\\)?${D.source}`,"g");function _(c){return c.replace(I,(S,w)=>w?S:`\\${S}`)}e.escapeIcons=_;const m=new RegExp(`\\\\${D.source}`,"g");function y(c){return c.replace(m,S=>`\\${S}`)}e.markdownEscapeEscapedIcons=y;const r=new RegExp(`(\\s)?(\\\\)?${D.source}(\\s)?`,"g");function k(c){return c.indexOf(e.iconStartMarker)===-1?c:c.replace(r,(S,w,C,h)=>C?S:w||h||"")}e.stripIcons=k;function d(c){const S=c.indexOf(e.iconStartMarker);return S===-1?{text:c}:b(c,S)}e.parseLabelWithIcons=d;function b(c,S){const w=[];let C="";function h(g){if(g){C+=g;for(const v of g)w.push(t)}}let l=-1,a="",t=0,i,n,s=S;const u=c.length;for(h(c.substr(0,S));s<u;)i=c[s],n=c[s+1],i===e.iconStartMarker[0]&&n===e.iconStartMarker[1]?(l=s,h(a),a=e.iconStartMarker,s++):i===")"&&l!==-1?(t+=s-l+1,l=-1,a=""):l!==-1?/^[a-z0-9\-]$/i.test(i)?a+=i:(h(a),l=-1,a=""):h(i),s++;return h(a),{text:C,iconOffsets:w}}function f(c,S,w=!1){const{text:C,iconOffsets:h}=S;if(!h||h.length===0)return P.matchesFuzzy(c,C,w);const l=p.ltrim(C," "),a=C.length-l.length,t=P.matchesFuzzy(c,l,w);if(t)for(const i of t){const n=h[i.start+a]+a;i.start+=n,i.end+=n}return t}e.matchesFuzzyIconAware=f}),define(le[74],ce([0,1,120,12]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var p;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(p=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class D{constructor(b="",f=!1){var c,S;if(this.value=b,typeof this.value!="string")throw P.illegalArgument("value");typeof f=="boolean"?(this.isTrusted=f,this.supportThemeIcons=!1):(this.isTrusted=(c=f.isTrusted)!==null&&c!==void 0?c:void 0,this.supportThemeIcons=(S=f.supportThemeIcons)!==null&&S!==void 0?S:!1)}appendText(b,f=0){return this.value+=y(this.supportThemeIcons?E.escapeIcons(b):b).replace(/([ \t]+)/g,(c,S)=>"&nbsp;".repeat(S.length)).replace(/^>/gm,"\\>").replace(/\n/g,f===1?`\\
`:`

`),this}appendMarkdown(b){return this.value+=b,this}appendCodeblock(b,f){return this.value+="\n```",this.value+=b,this.value+=`
`,this.value+=f,this.value+="\n```\n",this}}e.MarkdownString=D;function I(d){return _(d)?!d.value:Array.isArray(d)?d.every(I):!0}e.isEmptyMarkdownString=I;function _(d){return d instanceof D?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=_;function m(d,b){return d===b?!0:!d||!b?!1:d.value===b.value&&d.isTrusted===b.isTrusted&&d.supportThemeIcons===b.supportThemeIcons}e.markdownStringEqual=m;function y(d){return d.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=y;function r(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=r;function k(d){const b=[],f=d.split("|").map(S=>S.trim());d=f[0];const c=f[1];if(c){const S=/height=(\d+)/.exec(c),w=/width=(\d+)/.exec(c),C=S?S[1]:"",h=w?w[1]:"",l=isFinite(parseInt(h)),a=isFinite(parseInt(C));l&&b.push(`width="${h}"`),a&&b.push(`height="${C}"`)}return{href:d,dimensions:b}}e.parseHrefAndDimensions=k}),define(le[46],ce([0,1,18,13,4]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function D(y){return JSON.stringify(y,_)}e.stringify=D;function I(y){let r=JSON.parse(y);return r=m(r),r}e.parse=I;function _(y,r){return r instanceof RegExp?{$mid:2,source:r.source,flags:P.regExpFlags(r)}:r}function m(y,r=0){if(!y||r>200)return y;if(typeof y=="object"){switch(y.$mid){case 1:return p.URI.revive(y);case 2:return new RegExp(y.source,y.flags)}if(y instanceof E.VSBuffer||y instanceof Uint8Array)return y;if(Array.isArray(y))for(let k=0;k<y.length;++k)y[k]=m(y[k],r+1);else for(const k in y)Object.hasOwnProperty.call(y,k)&&(y[k]=m(y[k],r+1))}return y}e.revive=m}),define(le[8],ce([0,1,4,5]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var p;(function(_){_.inMemory="inmemory",_.vscode="vscode",_.internal="private",_.walkThrough="walkThrough",_.walkThroughSnippet="walkThroughSnippet",_.http="http",_.https="https",_.file="file",_.mailto="mailto",_.untitled="untitled",_.data="data",_.command="command",_.vscodeRemote="vscode-remote",_.vscodeRemoteResource="vscode-remote-resource",_.userData="vscode-userdata",_.vscodeCustomEditor="vscode-custom-editor",_.vscodeNotebook="vscode-notebook",_.vscodeNotebookCell="vscode-notebook-cell",_.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",_.vscodeNotebookCellOutput="vscode-notebook-cell-output",_.vscodeSettings="vscode-settings",_.vscodeWorkspaceTrust="vscode-workspace-trust",_.vscodeTerminal="vscode-terminal",_.webviewPanel="webview-panel",_.vscodeWebview="vscode-webview",_.extension="extension",_.vscodeFileResource="vscode-file",_.tmp="tmp"})(p=e.Schemas||(e.Schemas={}));class D{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(m){this._preferredWebSchema=m}setDelegate(m){this._delegate=m}set(m,y,r){this._hosts[m]=y,this._ports[m]=r}setConnectionToken(m,y){this._connectionTokens[m]=y}rewrite(m){if(this._delegate)return this._delegate(m);const y=m.authority;let r=this._hosts[y];r&&r.indexOf(":")!==-1&&(r=`[${r}]`);const k=this._ports[y],d=this._connectionTokens[y];let b=`path=${encodeURIComponent(m.path)}`;return typeof d=="string"&&(b+=`&tkn=${encodeURIComponent(d)}`),E.URI.from({scheme:P.isWeb?this._preferredWebSchema:p.vscodeRemoteResource,authority:`${r}:${k}`,path:"/vscode-remote-resource",query:b})}}e.RemoteAuthorities=new D;class I{constructor(){this.FALLBACK_AUTHORITY="vscode-app"}asBrowserUri(m,y,r){const k=this.toUri(m,y);return k.scheme===p.vscodeRemote?e.RemoteAuthorities.rewrite(k):P.isNative&&(r||P.isPreferringBrowserCodeLoad)&&k.scheme===p.file?k.with({scheme:p.vscodeFileResource,authority:k.authority||this.FALLBACK_AUTHORITY,query:null,fragment:null}):k}asFileUri(m,y){const r=this.toUri(m,y);return r.scheme===p.vscodeFileResource?r.with({scheme:p.file,authority:r.authority!==this.FALLBACK_AUTHORITY?r.authority:null,query:null,fragment:null}):r}toUri(m,y){return E.URI.isUri(m)?m:E.URI.parse(y.toUrl(m))}}e.FileAccess=new I}),define(le[75],ce([0,1,26]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=e.canNormalize=void 0,e.canNormalize=typeof String.prototype.normalize=="function";const P=new E.LRUCache(1e4);function p(y){return m(y,"NFC",P)}e.normalizeNFC=p;const D=new E.LRUCache(1e4);function I(y){return m(y,"NFD",D)}e.normalizeNFD=I;const _=/[^\u0000-\u0080]/;function m(y,r,k){if(!e.canNormalize||!y)return y;const d=k.get(y);if(d)return d;let b;return _.test(y)?b=y.normalize(r):b=y,k.set(y,b),b}e.removeAccents=function(){if(e.canNormalize){const y=/[\u0300-\u036f]/g;return function(r){return I(r).replace(y,"")}}else return function(y){return y}}()}),define(le[17],ce([0,1,30,3,4,13,8,5]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function m(b){return p.uriToFsPath(b,!0)}e.originalFSPath=m;class y{constructor(f){this._ignorePathCasing=f}compare(f,c,S=!1){return f===c?0:D.compare(this.getComparisonKey(f,S),this.getComparisonKey(c,S))}isEqual(f,c,S=!1){return f===c?!0:!f||!c?!1:this.getComparisonKey(f,S)===this.getComparisonKey(c,S)}getComparisonKey(f,c=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:c?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,c,S=!1){if(f.scheme===c.scheme){if(f.scheme===I.Schemas.file)return E.isEqualOrParent(m(f),m(c),this._ignorePathCasing(f))&&f.query===c.query&&(S||f.fragment===c.fragment);if(e.isEqualAuthority(f.authority,c.authority))return E.isEqualOrParent(f.path,c.path,this._ignorePathCasing(f),"/")&&f.query===c.query&&(S||f.fragment===c.fragment)}return!1}joinPath(f,...c){return p.URI.joinPath(f,...c)}basenameOrAuthority(f){return e.basename(f)||f.authority}basename(f){return P.posix.basename(f.path)}extname(f){return P.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let c;return f.scheme===I.Schemas.file?c=p.URI.file(P.dirname(m(f))).path:(c=P.posix.dirname(f.path),f.authority&&c.length&&c.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),c="/")),f.with({path:c})}normalizePath(f){if(!f.path.length)return f;let c;return f.scheme===I.Schemas.file?c=p.URI.file(P.normalize(m(f))).path:c=P.posix.normalize(f.path),f.with({path:c})}relativePath(f,c){if(f.scheme!==c.scheme||!e.isEqualAuthority(f.authority,c.authority))return;if(f.scheme===I.Schemas.file){const C=P.relative(m(f),m(c));return _.isWindows?E.toSlashes(C):C}let S=f.path||"/",w=c.path||"/";if(this._ignorePathCasing(f)){let C=0;for(const h=Math.min(S.length,w.length);C<h&&!(S.charCodeAt(C)!==w.charCodeAt(C)&&S.charAt(C).toLowerCase()!==w.charAt(C).toLowerCase());C++);S=w.substr(0,C)+S.substr(C)}return P.posix.relative(S,w)}resolvePath(f,c){if(f.scheme===I.Schemas.file){const S=p.URI.file(P.resolve(m(f),c));return f.with({authority:S.authority,path:S.path})}return c=E.toPosixPath(c),f.with({path:P.posix.resolve(f.path,c)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,c){return f===c||D.equalsIgnoreCase(f,c)}hasTrailingPathSeparator(f,c=P.sep){if(f.scheme===I.Schemas.file){const S=m(f);return S.length>E.getRoot(S).length&&S[S.length-1]===c}else{const S=f.path;return S.length>1&&S.charCodeAt(S.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,c=P.sep){return e.hasTrailingPathSeparator(f,c)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,c=P.sep){let S=!1;if(f.scheme===I.Schemas.file){const w=m(f);S=w!==void 0&&w.length===E.getRoot(w).length&&w[w.length-1]===c}else{c="/";const w=f.path;S=w.length===1&&w.charCodeAt(w.length-1)===47}return!S&&!e.hasTrailingPathSeparator(f,c)?f.with({path:f.path+"/"}):f}}e.ExtUri=y,e.extUri=new y(()=>!1),e.extUriBiasedIgnorePathCase=new y(b=>b.scheme===I.Schemas.file?!_.isLinux:!0),e.extUriIgnorePathCase=new y(b=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function r(b,f){const c=[];for(let S=0;S<b.length;S++){const w=f(b[S]);b.some((C,h)=>h===S?!1:e.isEqualOrParent(w,f(C)))||c.push(b[S])}return c}e.distinctParents=r;var k;(function(b){b.META_DATA_LABEL="label",b.META_DATA_DESCRIPTION="description",b.META_DATA_SIZE="size",b.META_DATA_MIME="mime";function f(c){const S=new Map;c.path.substring(c.path.indexOf(";")+1,c.path.lastIndexOf(";")).split(";").forEach(h=>{const[l,a]=h.split(":");l&&a&&S.set(l,a)});const C=c.path.substring(0,c.path.indexOf(";"));return C&&S.set(b.META_DATA_MIME,C),S}b.parseMetaData=f})(k=e.DataUri||(e.DataUri={}));function d(b,f,c){if(f){let S=b.path;return S&&S[0]!==P.posix.sep&&(S=P.posix.sep+S),b.with({scheme:c,authority:f,path:S})}return b.with({scheme:c})}e.toLocalResource=d}),define(le[14],ce([0,1,29,12,7,2,72,17]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.AsyncEmitter=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.ignoreErrors=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function m(z){return!!z&&typeof z.then=="function"}e.isThenable=m;function y(z){const L=new E.CancellationTokenSource,A=z(L.token),N=new Promise((M,W)=>{L.token.onCancellationRequested(()=>{W(P.canceled())}),Promise.resolve(A).then(X=>{L.dispose(),M(X)},X=>{L.dispose(),W(X)})});return new class{cancel(){L.cancel()}then(M,W){return N.then(M,W)}catch(M){return this.then(void 0,M)}finally(M){return N.finally(M)}}}e.createCancelablePromise=y;function r(z,L,A){return Promise.race([z,new Promise(N=>L.onCancellationRequested(()=>N(A)))])}e.raceCancellation=r;async function k(z){let L=-1;const A=z.map((M,W)=>M.then(X=>(L=W,X))),N=await Promise.race(A);return z.forEach((M,W)=>{W!==L&&M.cancel()}),N}e.raceCancellablePromises=k;function d(z,L,A){let N;const M=setTimeout(()=>{N==null||N(void 0),A==null||A()},L);return Promise.race([z.finally(()=>clearTimeout(M)),new Promise(W=>N=W)])}e.raceTimeout=d;function b(z){return new Promise((L,A)=>{const N=z();m(N)?N.then(L,A):L(N)})}e.asPromise=b;class f{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const A=()=>{this.queuedPromise=null;const N=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,N};this.queuedPromise=new Promise(N=>{this.activePromise.then(A,A).then(N)})}return new Promise((A,N)=>{this.queuedPromise.then(A,N)})}return this.activePromise=L(),new Promise((A,N)=>{this.activePromise.then(M=>{this.activePromise=null,A(M)},M=>{this.activePromise=null,N(M)})})}}e.Throttler=f;class c{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=c;class S{constructor(){this.promiseMap=new Map}queue(L,A){var N;const W=((N=this.promiseMap.get(L))!==null&&N!==void 0?N:Promise.resolve()).catch(()=>{}).then(A).finally(()=>{this.promiseMap.get(L)===W&&this.promiseMap.delete(L)});return this.promiseMap.set(L,W),W}}e.SequencerByKey=S;class w{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,A=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((N,M)=>{this.doResolve=N,this.doReject=M}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const N=this.task;return this.task=null,N()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},A),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject(P.canceled()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancelTimeout()}}e.Delayer=w;class C{constructor(L){this.delayer=new w(L),this.throttler=new f}trigger(L,A){return this.delayer.trigger(()=>this.throttler.queue(L),A)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=C;class h{constructor(){this._isOpen=!1,this._promise=new Promise((L,A)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=h;class l extends h{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=l;function a(z,L){return L?new Promise((A,N)=>{const M=setTimeout(A,z);L.onCancellationRequested(()=>{clearTimeout(M),N(P.canceled())})}):y(A=>a(z,A))}e.timeout=a;function t(z,L=0){const A=setTimeout(z,L);return D.toDisposable(()=>clearTimeout(A))}e.disposableTimeout=t;function i(z){return z.then(void 0,L=>{})}e.ignoreErrors=i;function n(z){const L=[];let A=0;const N=z.length;function M(){return A<N?z[A++]():null}function W(X){X!=null&&L.push(X);const ae=M();return ae?ae.then(W):Promise.resolve(L)}return Promise.resolve(null).then(W)}e.sequence=n;function s(z,L=N=>!!N,A=null){let N=0;const M=z.length,W=()=>{if(N>=M)return Promise.resolve(A);const X=z[N++];return Promise.resolve(X()).then(se=>L(se)?Promise.resolve(se):W())};return W()}e.first=s;function u(z,L=N=>!!N,A=null){if(z.length===0)return Promise.resolve(A);let N=z.length;const M=()=>{var W,X;N=-1;for(const ae of z)(X=(W=ae).cancel)===null||X===void 0||X.call(W)};return new Promise((W,X)=>{for(const ae of z)ae.then(se=>{--N>=0&&L(se)?(M(),W(se)):N===0&&W(A)}).catch(se=>{--N>=0&&(M(),X(se))})})}e.firstParallel=u;class g{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new p.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((A,N)=>{this.outstandingPromises.push({factory:L,c:A,e:N}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const A=L.factory();A.then(L.c,L.e),A.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=g;class v extends g{constructor(){super(1)}}e.Queue=v;class T{constructor(){this.queues=new Map}queueFor(L,A=_.extUri){const N=A.getComparisonKey(L);let M=this.queues.get(N);return M||(M=new v,p.Event.once(M.onFinished)(()=>{M==null||M.dispose(),this.queues.delete(N)}),this.queues.set(N,M)),M}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=T;class R{constructor(L,A){this._token=-1,typeof L=="function"&&typeof A=="number"&&this.setIfNotSet(L,A)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,A){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},A)}setIfNotSet(L,A){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},A))}}e.TimeoutTimer=R;class o{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,A){this.cancel(),this._token=setInterval(()=>{L()},A)}}e.IntervalTimer=o;class F{constructor(L,A){this.timeoutToken=-1,this.runner=L,this.timeout=A,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=F;class B extends F{constructor(L,A){super(L,A);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=B,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const z=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const A=setTimeout(()=>L(z));let N=!1;return{dispose(){N||(N=!0,clearTimeout(A))}}}}else e.runWhenIdle=(z,L)=>{const A=requestIdleCallback(z,typeof L=="number"?{timeout:L}:void 0);let N=!1;return{dispose(){N||(N=!0,cancelIdleCallback(A))}}}}();class Z{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(A){this._error=A}finally{this._didRun=!0}},this._handle=e.runWhenIdle(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}}e.IdleValue=Z;async function ie(z,L,A){let N;for(let M=0;M<A;M++)try{return await z()}catch(W){N=W,await a(L)}throw N}e.retry=ie;class Se{hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){var L;(L=this._pending)===null||L===void 0||L.cancel()}setPending(L,A,N){return this._pending={taskId:L,cancel:()=>N==null?void 0:N(),promise:A},A.then(()=>this.donePending(L),()=>this.donePending(L)),A}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let A,N;const M=new Promise((W,X)=>{A=W,N=X});this._next={run:L,promise:M,promiseResolve:A,promiseReject:N}}return this._next.promise}}e.TaskSequentializer=Se;class oe{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=oe;class q{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,A)=>{this.completeCallback=L,this.errorCallback=A})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(A=>{this.completeCallback(L),this.resolved=!0,A()})}error(L){return new Promise(A=>{this.errorCallback(L),this.rejected=!0,A()})}cancel(){new Promise(L=>{this.errorCallback(P.canceled()),this.rejected=!0,L()})}}e.DeferredPromise=q;class ee extends p.Emitter{async fireAsync(L,A,N){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new I.LinkedList);for(const M of this._listeners)this._asyncDeliveryQueue.push([M,L]);for(;this._asyncDeliveryQueue.size>0&&!A.isCancellationRequested;){const[M,W]=this._asyncDeliveryQueue.shift(),X=[],ae=Object.assign(Object.assign({},W),{waitUntil:se=>{if(Object.isFrozen(X))throw new Error("waitUntil can NOT be called asynchronous");N&&(se=N(se,typeof M=="function"?M:M[0])),X.push(se)}});try{typeof M=="function"?M.call(void 0,ae):M[0].call(M[1],ae)}catch(se){P.onUnexpectedError(se);continue}Object.freeze(X),await G.settled(X).catch(se=>P.onUnexpectedError(se))}}}}e.AsyncEmitter=ee;var G;(function(z){async function L(W){return typeof Promise.allSettled=="function"?A(W):N(W)}z.allSettled=L;async function A(W){return Promise.allSettled(W)}async function N(W){return Promise.all(W.map(X=>X.then(ae=>({status:"fulfilled",value:ae}),ae=>({status:"rejected",reason:ae}))))}async function M(W){let X;const ae=await Promise.all(W.map(se=>se.then(be=>be,be=>{X||(X=be)})));if(typeof X!="undefined")throw X;return ae}z.settled=M})(G=e.Promises||(e.Promises={}))}),define(le[47],ce([0,1,13,30,3,26,14]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function _(){return Object.create(null)}e.getEmptyExpression=_;const m="**",y="/",r="[/\\\\]",k="[^/\\\\]",d=/\//g;function b(A){switch(A){case 0:return"";case 1:return`${k}*?`;default:return`(?:${r}|${k}+${r}|${r}${k}+)*?`}}function f(A,N){if(!A)return[];const M=[];let W=!1,X=!1,ae="";for(const se of A){switch(se){case N:if(!W&&!X){M.push(ae),ae="";continue}break;case"{":W=!0;break;case"}":W=!1;break;case"[":X=!0;break;case"]":X=!1;break}ae+=se}return ae&&M.push(ae),M}e.splitGlobAware=f;function c(A){if(!A)return"";let N="";const M=f(A,y);if(M.every(W=>W===m))N=".*";else{let W=!1;M.forEach((X,ae)=>{if(X===m){W||(N+=b(2),W=!0);return}let se=!1,be="",ke=!1,Te="";for(const Le of X){if(Le!=="}"&&se){be+=Le;continue}if(ke&&(Le!=="]"||!Te)){let je;Le==="-"?je=Le:(Le==="^"||Le==="!")&&!Te?je="^":Le===y?je="":je=E.escapeRegExpCharacters(Le),Te+=je;continue}switch(Le){case"{":se=!0;continue;case"[":ke=!0;continue;case"}":N+=`(?:${f(be,",").map(Ze=>c(Ze)).join("|")})`,se=!1,be="";break;case"]":N+="["+Te+"]",ke=!1,Te="";break;case"?":N+=k;continue;case"*":N+=b(1);continue;default:N+=E.escapeRegExpCharacters(Le)}}ae<M.length-1&&(M[ae+1]!==m||ae+2<M.length)&&(N+=r),W=!1})}return N}const S=/^\*\*\/\*\.[\w\.-]+$/,w=/^\*\*\/([\w\.-]+)\/?$/,C=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,h=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,a=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,t=new D.LRUCache(1e4),i=function(){return!1},n=function(){return null};function s(A,N){if(!A)return n;let M;typeof A!="string"?M=A.pattern:M=A,M=M.trim();const W=`${M}_${!!N.trimForExclusions}`;let X=t.get(W);if(X)return u(X,A);let ae;if(S.test(M)){const se=M.substr(4);X=function(be,ke){return typeof be=="string"&&be.endsWith(se)?M:null}}else(ae=w.exec(g(M,N)))?X=v(ae[1],M):(N.trimForExclusions?h:C).test(M)?X=T(M,N):(ae=l.exec(g(M,N)))?X=R(ae[1].substr(1),M,!0):(ae=a.exec(g(M,N)))?X=R(ae[1],M,!1):X=o(M);return t.set(W,X),u(X,A)}function u(A,N){return typeof N=="string"?A:function(M,W){return P.isEqualOrParent(M,N.base)?A(p.relative(N.base,M),W):null}}function g(A,N){return N.trimForExclusions&&A.endsWith("/**")?A.substr(0,A.length-2):A}function v(A,N){const M=`/${A}`,W=`\\${A}`,X=function(se,be){return typeof se!="string"?null:be?be===A?N:null:se===A||se.endsWith(M)||se.endsWith(W)?N:null},ae=[A];return X.basenames=ae,X.patterns=[N],X.allBasenames=ae,X}function T(A,N){const M=L(A.slice(1,-1).split(",").map(be=>s(be,N)).filter(be=>be!==n),A),W=M.length;if(!W)return n;if(W===1)return M[0];const X=function(be,ke){for(let Te=0,Le=M.length;Te<Le;Te++)if(M[Te](be,ke))return A;return null},ae=M.find(be=>!!be.allBasenames);ae&&(X.allBasenames=ae.allBasenames);const se=M.reduce((be,ke)=>ke.allPaths?be.concat(ke.allPaths):be,[]);return se.length&&(X.allPaths=se),X}function R(A,N,M){const W=p.sep===p.posix.sep,X=W?A:A.replace(d,p.sep),ae=p.sep+X,se=p.posix.sep+A,be=M?function(ke,Te){return typeof ke=="string"&&(ke===X||ke.endsWith(ae)||!W&&(ke===A||ke.endsWith(se)))?N:null}:function(ke,Te){return typeof ke=="string"&&(ke===X||!W&&ke===A)?N:null};return be.allPaths=[(M?"*/":"./")+A],be}function o(A){try{const N=new RegExp(`^${c(A)}$`);return function(M){return N.lastIndex=0,typeof M=="string"&&N.test(M)?A:null}}catch(N){return n}}function F(A,N,M){return!A||typeof N!="string"?!1:B(A)(N,void 0,M)}e.match=F;function B(A,N={}){if(!A)return i;if(typeof A=="string"||oe(A)){const M=s(A,N);if(M===n)return i;const W=function(X,ae){return!!M(X,ae)};return M.allBasenames&&(W.allBasenames=M.allBasenames),M.allPaths&&(W.allPaths=M.allPaths),W}return G(A,N)}e.parse=B;function Z(A){if(!A)return;let N;return M=>(N||(N=(A()||Promise.resolve([])).then(W=>W?Se(W):{})),N.then(W=>!!W[M]))}e.hasSiblingPromiseFn=Z;function ie(A){if(!A)return;let N;return M=>{if(!N){const W=A();N=W?Se(W):{}}return!!N[M]}}e.hasSiblingFn=ie;function Se(A){const N={};for(const M of A)N[M]=!0;return N}function oe(A){const N=A;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}e.isRelativePattern=oe;function q(A){return A.allBasenames||[]}e.getBasenameTerms=q;function ee(A){return A.allPaths||[]}e.getPathTerms=ee;function G(A,N){const M=L(Object.getOwnPropertyNames(A).map(be=>z(be,A[be],N)).filter(be=>be!==n)),W=M.length;if(!W)return n;if(!M.some(be=>!!be.requiresSiblings)){if(W===1)return M[0];const be=function(Le,je){for(let Xe=0,Ze=M.length;Xe<Ze;Xe++){const it=M[Xe](Le,je);if(it)return it}return null},ke=M.find(Le=>!!Le.allBasenames);ke&&(be.allBasenames=ke.allBasenames);const Te=M.reduce((Le,je)=>je.allPaths?Le.concat(je.allPaths):Le,[]);return Te.length&&(be.allPaths=Te),be}const X=function(be,ke,Te){let Le;for(let je=0,Xe=M.length;je<Xe;je++){const Ze=M[je];Ze.requiresSiblings&&Te&&(ke||(ke=p.basename(be)),Le||(Le=ke.substr(0,ke.length-p.extname(be).length)));const it=Ze(be,ke,Le,Te);if(it)return it}return null},ae=M.find(be=>!!be.allBasenames);ae&&(X.allBasenames=ae.allBasenames);const se=M.reduce((be,ke)=>ke.allPaths?be.concat(ke.allPaths):be,[]);return se.length&&(X.allPaths=se),X}function z(A,N,M){if(N===!1)return n;const W=s(A,M);if(W===n)return n;if(typeof N=="boolean")return W;if(N){const X=N.when;if(typeof X=="string"){const ae=(se,be,ke,Te)=>{if(!Te||!W(se,be))return null;const Le=X.replace("$(basename)",ke),je=Te(Le);return I.isThenable(je)?je.then(Xe=>Xe?A:null):je?A:null};return ae.requiresSiblings=!0,ae}}return W}function L(A,N){const M=A.filter(be=>!!be.basenames);if(M.length<2)return A;const W=M.reduce((be,ke)=>{const Te=ke.basenames;return Te?be.concat(Te):be},[]);let X;if(N){X=[];for(let be=0,ke=W.length;be<ke;be++)X.push(N)}else X=M.reduce((be,ke)=>{const Te=ke.patterns;return Te?be.concat(Te):be},[]);const ae=function(be,ke){if(typeof be!="string")return null;if(!ke){let Le;for(Le=be.length;Le>0;Le--){const je=be.charCodeAt(Le-1);if(je===47||je===92)break}ke=be.substr(Le)}const Te=W.indexOf(ke);return Te!==-1?X[Te]:null};ae.basenames=W,ae.patterns=X,ae.allBasenames=W;const se=A.filter(be=>!be.basenames);return se.push(ae),se}}),define(le[52],ce([0,1,4,3,13,8,5,17,30]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function y(s,u,g){if(typeof s=="string"&&(s=E.URI.file(s)),g){const T=g.getWorkspaceFolder(s);if(T){const R=g.getWorkspace().folders.length>1;let o;if(_.isEqual(T.uri,s)?o="":o=_.relativePath(T.uri,s),R){const F=T.name?T.name:_.basename(T.uri);o=o?F+" \u2022 "+o:F}return o}}if(s.scheme!==D.Schemas.file&&s.scheme!==D.Schemas.untitled)return s.with({query:null,fragment:null}).toString(!0);if(m.hasDriveLetter(s.fsPath))return P.normalize(k(s.fsPath));let v=P.normalize(s.fsPath);return!I.isWindows&&(u==null?void 0:u.userHome)&&(v=b(v,u.userHome.fsPath)),v}e.getPathLabel=y;function r(s){if(!s)return;typeof s=="string"&&(s=E.URI.file(s));const u=_.basename(s)||(s.scheme===D.Schemas.file?s.fsPath:s.path);return I.isWindows&&m.isRootOrDriveLetter(u)?k(u):u}e.getBaseLabel=r;function k(s){return m.hasDriveLetter(s)?s.charAt(0).toUpperCase()+s.slice(1):s}e.normalizeDriveLetter=k;let d=Object.create(null);function b(s,u){if(I.isWindows||!s||!u)return s;let g=d.original===u?d.normalized:void 0;return g||(g=`${p.rtrim(u,P.posix.sep)}${P.posix.sep}`,d={original:u,normalized:g}),(I.isLinux?s.startsWith(g):p.startsWithIgnoreCase(s,g))&&(s=`~/${s.substr(g.length)}`),s}e.tildify=b;function f(s,u){return s.replace(/^~($|\/|\\)/,`${u}$1`)}e.untildify=f;const c="\u2026",S="\\\\",w="~";function C(s,u=P.sep){const g=new Array(s.length);let v=!1;for(let T=0;T<s.length;T++){let R=s[T];if(R===""){g[T]=`.${u}`;continue}if(!R){g[T]=R;continue}v=!0;let o="";R.indexOf(S)===0?(o=R.substr(0,R.indexOf(S)+S.length),R=R.substr(R.indexOf(S)+S.length)):R.indexOf(u)===0?(o=R.substr(0,R.indexOf(u)+u.length),R=R.substr(R.indexOf(u)+u.length)):R.indexOf(w)===0&&(o=R.substr(0,R.indexOf(w)+w.length),R=R.substr(R.indexOf(w)+w.length));const F=R.split(u);for(let B=1;v&&B<=F.length;B++)for(let Z=F.length-B;v&&Z>=0;Z--){v=!1;let ie=F.slice(Z,Z+B).join(u);for(let Se=0;!v&&Se<s.length;Se++)if(Se!==T&&s[Se]&&s[Se].indexOf(ie)>-1){const oe=Z+B===F.length,q=Z>0&&s[Se].indexOf(u)>-1?u+ie:ie,ee=s[Se].endsWith(q);v=!oe||ee}if(!v){let Se="";(F[0].endsWith(":")||o!=="")&&(Z===1&&(Z=0,B++,ie=F[0]+u+ie),Z>0&&(Se=F[0]+u),Se=o+Se),Z>0&&(Se=Se+c+u),Se=Se+ie,Z+B<F.length&&(Se=Se+u+c),g[T]=Se}}v&&(g[T]=R)}return g}e.shorten=C;var h;(function(s){s[s.TEXT=0]="TEXT",s[s.VARIABLE=1]="VARIABLE",s[s.SEPARATOR=2]="SEPARATOR"})(h||(h={}));function l(s,u=Object.create(null)){const g=[];let v=!1,T="";for(const R of s)if(R==="$"||v&&R==="{")T&&g.push({value:T,type:h.TEXT}),T="",v=!0;else if(R==="}"&&v){const o=u[T];if(typeof o=="string")o.length&&g.push({value:o,type:h.VARIABLE});else if(o){const F=g[g.length-1];(!F||F.type!==h.SEPARATOR)&&g.push({value:o.label,type:h.SEPARATOR})}T="",v=!1}else T+=R;return T&&!v&&g.push({value:T,type:h.TEXT}),g.filter((R,o)=>{if(R.type===h.SEPARATOR){const F=g[o-1],B=g[o+1];return[F,B].every(Z=>Z&&(Z.type===h.VARIABLE||Z.type===h.TEXT)&&Z.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=l;function a(s,u){return I.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,"").replace(/&/g,I.isMacintosh?"&":"&&"):s.replace(/&&|&/g,g=>g==="&"?"&&":"&")}e.mnemonicMenuLabel=a;function t(s,u){return I.isMacintosh||u?s.replace(/\(&&\w\)|&&/g,""):I.isWindows?s.replace(/&&|&/g,g=>g==="&"?"&&":"&"):s.replace(/&&/g,"_")}e.mnemonicButtonLabel=t;function i(s){return s.replace(/&/g,"&&")}e.unmnemonicLabel=i;function n(s){const u=s.indexOf("/")!==-1?P.posix:P.win32,g=u.basename(s),v=u.dirname(s);return g.length?{name:g,parentPath:v}:{name:v,parentPath:""}}e.splitName=n}),define(le[76],ce([0,1,3,13,47,8,17]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.MIME_UNKNOWN=e.MIME_BINARY=e.MIME_TEXT=void 0,e.MIME_TEXT="text/plain",e.MIME_BINARY="application/octet-stream",e.MIME_UNKNOWN="application/unknown";let _=[],m=[],y=[];function r(t,i=!1){const n=k(t);_.push(n),n.userConfigured?y.push(n):m.push(n),i&&!n.userConfigured&&_.forEach(s=>{s.mime===n.mime||s.userConfigured||(n.extension&&s.extension===n.extension&&console.warn(`Overwriting extension <<${n.extension}>> to now point to mime <<${n.mime}>>`),n.filename&&s.filename===n.filename&&console.warn(`Overwriting filename <<${n.filename}>> to now point to mime <<${n.mime}>>`),n.filepattern&&s.filepattern===n.filepattern&&console.warn(`Overwriting filepattern <<${n.filepattern}>> to now point to mime <<${n.mime}>>`),n.firstline&&s.firstline===n.firstline&&console.warn(`Overwriting firstline <<${n.firstline}>> to now point to mime <<${n.mime}>>`))})}e.registerTextMime=r;function k(t){return{id:t.id,mime:t.mime,filename:t.filename,extension:t.extension,filepattern:t.filepattern,firstline:t.firstline,userConfigured:t.userConfigured,filenameLowercase:t.filename?t.filename.toLowerCase():void 0,extensionLowercase:t.extension?t.extension.toLowerCase():void 0,filepatternLowercase:t.filepattern?t.filepattern.toLowerCase():void 0,filepatternOnPath:t.filepattern?t.filepattern.indexOf(E.posix.sep)>=0:!1}}function d(t){t?(_=_.filter(i=>!i.userConfigured),y=[]):(_=[],m=[],y=[])}e.clearTextMimes=d;function b(t,i){let n;if(t)switch(t.scheme){case D.Schemas.file:n=t.fsPath;break;case D.Schemas.data:n=I.DataUri.parseMetaData(t).get(I.DataUri.META_DATA_LABEL);break;default:n=t.path}if(!n)return[e.MIME_UNKNOWN];n=n.toLowerCase();const s=E.basename(n),u=f(n,s,y);if(u)return[u,e.MIME_TEXT];const g=f(n,s,m);if(g)return[g,e.MIME_TEXT];if(i){const v=c(i);if(v)return[v,e.MIME_TEXT]}return[e.MIME_UNKNOWN]}e.guessMimeTypes=b;function f(t,i,n){let s=null,u=null,g=null;for(let v=n.length-1;v>=0;v--){const T=n[v];if(i===T.filenameLowercase){s=T;break}if(T.filepattern&&(!u||T.filepattern.length>u.filepattern.length)){const R=T.filepatternOnPath?t:i;p.match(T.filepatternLowercase,R)&&(u=T)}T.extension&&(!g||T.extension.length>g.extension.length)&&i.endsWith(T.extensionLowercase)&&(g=T)}return s?s.mime:u?u.mime:g?g.mime:null}function c(t){if(P.startsWithUTF8BOM(t)&&(t=t.substr(1)),t.length>0)for(let i=_.length-1;i>=0;i--){const n=_[i];if(!n.firstline)continue;const s=t.match(n.firstline);if(s&&s.length>0)return n.mime}return null}function S(t){return t?typeof t=="string"?t===e.MIME_BINARY||t===e.MIME_TEXT||t===e.MIME_UNKNOWN:t.length===1&&S(t[0]):!0}e.isUnspecific=S;const w={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function C(t){const i=E.extname(t);return w[i.toLowerCase()]}e.getMediaMime=C;function h(t){for(const i in w)if(w[i]===t)return i}e.getExtensionForMimeType=h;const l=/^(.+)\/(.+?)(;.+)?$/;function a(t,i){var n;const s=l.exec(t);return s?`${s[1].toLowerCase()}/${s[2].toLowerCase()}${(n=s[3])!==null&&n!==void 0?n:""}`:i?void 0:t}e.normalizeMimeType=a}),define(le[53],ce([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function P(r){return r.toJSON()}class p{constructor(k){this._uriTransformer=k}transformIncoming(k){const d=this._uriTransformer.transformIncoming(k);return d===k?k:P(E.URI.from(d))}transformOutgoing(k){const d=this._uriTransformer.transformOutgoing(k);return d===k?k:P(E.URI.from(d))}transformOutgoingURI(k){const d=this._uriTransformer.transformOutgoing(k);return d===k?k:E.URI.from(d)}transformOutgoingScheme(k){return this._uriTransformer.transformOutgoingScheme(k)}}e.URITransformer=p,e.DefaultURITransformer=new class{transformIncoming(r){return r}transformOutgoing(r){return r}transformOutgoingURI(r){return r}transformOutgoingScheme(r){return r}};function D(r,k,d){if(!r||d>200)return null;if(typeof r=="object"){if(r instanceof E.URI)return k.transformOutgoing(r);for(let b in r)if(Object.hasOwnProperty.call(r,b)){const f=D(r[b],k,d+1);f!==null&&(r[b]=f)}}return null}function I(r,k){const d=D(r,k,0);return d===null?r:d}e.transformOutgoingURIs=I;function _(r,k,d,b){if(!r||b>200)return null;if(typeof r=="object"){if(r.$mid===1)return d?E.URI.revive(k.transformIncoming(r)):k.transformIncoming(r);for(let f in r)if(Object.hasOwnProperty.call(r,f)){const c=_(r[f],k,d,b+1);c!==null&&(r[f]=c)}}return null}function m(r,k){const d=_(r,k,!1,0);return d===null?r:d}e.transformIncomingURIs=m;function y(r,k){const d=_(r,k,!0,0);return d===null?r:d}e.transformAndReviveIncomingURIs=y}),define(le[22],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const E=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function P(m){return E.test(m)}e.isUUID=P;const p=new Uint8Array(16),D=[];for(let m=0;m<256;m++)D.push(m.toString(16).padStart(2,"0"));let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(m){for(let y=0;y<m.length;y++)m[y]=Math.floor(Math.random()*256);return m};function _(){I(p),p[6]=p[6]&15|64,p[8]=p[8]&63|128;let m=0,y="";return y+=D[p[m++]],y+=D[p[m++]],y+=D[p[m++]],y+=D[p[m++]],y+="-",y+=D[p[m++]],y+=D[p[m++]],y+="-",y+=D[p[m++]],y+=D[p[m++]],y+="-",y+=D[p[m++]],y+=D[p[m++]],y+="-",y+=D[p[m++]],y+=D[p[m++]],y+=D[p[m++]],y+=D[p[m++]],y+=D[p[m++]],y+=D[p[m++]],y}e.generateUuid=_}),define(le[77],ce([0,1,236]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class P{constructor(D="utf8"){this.stringDecoder=new E.StringDecoder(D),this.remaining=null}write(D){const I=[],_=this.remaining?this.remaining+this.stringDecoder.write(D):this.stringDecoder.write(D);if(_.length<1)return I;let m=0,y,r=m;for(;r<_.length;)if(y=_.charCodeAt(r),y===13||y===10){if(I.push(_.substring(m,r)),r++,r<_.length){const k=y;y=_.charCodeAt(r),(k===13&&y===10||k===10&&y===13)&&r++}m=r}else r++;return this.remaining=m<_.length?_.substr(m):null,I}end(){return this.remaining}}e.LineDecoder=P}),function(){"use strict";function x(e,E,P,p){function D(f){return new Promise(c=>P.exists(f,c))}function I(f){return new Promise((c,S)=>{const w=new Date;P.utimes(f,w,w,C=>C?S(C):c())})}function _(f){return new Promise((c,S)=>P.mkdir(f,{recursive:!0},w=>w&&w.code!=="EEXIST"?S(w):c(f)))}function m(f){return new Promise((c,S)=>P.rmdir(f,{recursive:!0},w=>w&&w.code!=="ENOENT"?S(w):c()))}function y(f){return new Promise((c,S)=>P.readFile(f,"utf8",(w,C)=>w?S(w):c(C)))}function r(f,c){return new Promise((S,w)=>P.writeFile(f,c,"utf8",C=>C?w(C):S()))}function k(f){const c=E.join(f,"languagepacks.json");try{return e(c)}catch(S){}}function d(f,c){try{for(;c;){if(f[c])return c;{const S=c.lastIndexOf("-");if(S>0)c=c.substring(0,S);else return}}}catch(S){console.error("Resolving language pack configuration failed.",S)}}function b(f,c,S,w){if(w==="pseudo")return Promise.resolve({locale:w,availableLanguages:{},pseudo:!0});if(process.env.VSCODE_DEV)return Promise.resolve({locale:w,availableLanguages:{}});if(w&&(w==="en"||w==="en-us"))return Promise.resolve({locale:w,availableLanguages:{}});const C=w;p.mark("code/willGenerateNls");const h=function(l){return p.mark("code/didGenerateNls"),Promise.resolve({locale:l,availableLanguages:{}})};try{if(!f)return h(C);const l=k(c);if(!l||(w=d(l,w),!w))return h(C);const a=l[w];let t;return!a||typeof a.hash!="string"||!a.translations||typeof(t=a.translations.vscode)!="string"?h(C):D(t).then(i=>{if(!i)return h(C);const n=a.hash+"."+w,s=E.join(c,"clp",n),u=E.join(s,f),g=E.join(s,"tcf.json"),v=E.join(s,"corrupted.info"),T={locale:C,availableLanguages:{"*":w},_languagePackId:n,_translationsConfigFile:g,_cacheRoot:s,_resolvedLanguagePackCoreLocation:u,_corruptedFile:v};return D(v).then(R=>{let o;return R?o=m(s):o=Promise.resolve(void 0),o.then(()=>D(u).then(F=>F?(I(u).catch(()=>{}),p.mark("code/didGenerateNls"),T):_(u).then(()=>Promise.all([y(S),y(t)])).then(B=>{const Z=JSON.parse(B[0]),ie=JSON.parse(B[1]).contents,Se=Object.keys(Z.bundles),oe=[];for(const q of Se){const ee=Z.bundles[q],G=Object.create(null);for(const z of ee){const L=Z.keys[z],A=Z.messages[z],N=ie[z];let M;if(N){M=[];for(let W=0;W<L.length;W++){const X=L[W],ae=typeof X=="string"?X:X.key;let se=N[ae];se===void 0&&(se=A[W]),M.push(se)}}else M=A;G[z]=M}oe.push(r(E.join(u,q.replace(/\//g,"!")+".nls.json"),JSON.stringify(G)))}return oe.push(r(g,JSON.stringify(a.translations))),Promise.all(oe)}).then(()=>(p.mark("code/didGenerateNls"),T)).catch(B=>(console.error("Generating translation files failed.",B),h(w)))))})})}catch(l){return console.error("Generating translation files failed.",l),h(w)}}return{getNLSConfiguration:b}}if(typeof define=="function")define(le[121],ce([0,78,25,48]),function(e,E,P,p){return x(e.__$__nodeRequire,E,P,p)});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),E=require("fs"),P=require("../common/performance");module.exports=x(require,e,E,P)}else throw new Error("Unknown context")}(),define(le[122],ce([0,1,24]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const P=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function p(_){const m=_.replace(/\-/g,":").toLowerCase();return!P.has(m)}function D(){return new Promise(async(_,m)=>{const y=setTimeout(()=>m("Unable to retrieve mac address (timeout after 10s)"),1e4);try{_(await I())}catch(r){m(r)}finally{clearTimeout(y)}})}e.getMac=D;function I(){return new Promise((_,m)=>{try{const y=E.networkInterfaces();for(let r in y){const k=y[r];if(k){for(const{mac:d}of k)if(p(d))return _(d)}}m("Unable to retrieve mac address (unexpected format)")}catch(y){m(y)}})}}),define(le[79],ce([0,1,12,22,24,26,122]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAdress(r){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(r)}value(){if(this._value===void 0){let r=0,k=0;const d=p.networkInterfaces();for(let b in d){const f=d[b];if(f)for(const{mac:c,internal:S}of f)S||(k+=1,this._isVirtualMachineMacAdress(c.toUpperCase())&&(r+=1))}this._value=k>0?r/k:0}return this._value}};let _;async function m(){return _||(_=(async()=>await y()||P.generateUuid())()),_}e.getMachineId=m;async function y(){try{const r=await new Promise((d,b)=>{x(["crypto"],d,b)}),k=await I.getMac();return r.createHash("sha256").update(k,"utf8").digest("hex")}catch(r){E.onUnexpectedError(r);return}}}),define(le[15],ce([0,1,25,24,123,3,14,5,30,22,75,17,4]),function(x,e,E,P,p,D,I,_,m,y,r,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.exists=e.copy=e.move=e.writeFileSync=e.writeFile=e.SymlinkSupport=e.whenDeleted=e.readDirsInDir=e.readdirSync=e.readdir=e.rimrafSync=e.rimraf=e.RimRafMode=void 0;var b;(function(G){G[G.UNLINK=0]="UNLINK",G[G.MOVE=1]="MOVE"})(b=e.RimRafMode||(e.RimRafMode={}));async function f(G,z=b.UNLINK){if(m.isRootOrDriveLetter(G))throw new Error("rimraf - will refuse to recursively delete root");return z===b.UNLINK?S(G):c(G)}e.rimraf=f;async function c(G){try{const z=D.join(P.tmpdir(),y.generateUuid());try{await ee.rename(G,z)}catch(L){return S(G)}S(z).catch(L=>{})}catch(z){if(z.code!=="ENOENT")throw z}}async function S(G){return ee.rmdir(G,{recursive:!0,maxRetries:3})}function w(G){if(m.isRootOrDriveLetter(G))throw new Error("rimraf - will refuse to recursively delete root");E.rmdirSync(G,{recursive:!0})}e.rimrafSync=w;async function C(G,z){return a(await(z?h(G):ee.readdir(G)))}e.readdir=C;async function h(G){try{return await ee.readdir(G,{withFileTypes:!0})}catch(A){console.warn("[node.js fs] readdir with filetypes failed with error: ",A)}const z=[],L=await C(G);for(const A of L){let N=!1,M=!1,W=!1;try{const X=await ee.lstat(D.join(G,A));N=X.isFile(),M=X.isDirectory(),W=X.isSymbolicLink()}catch(X){console.warn("[node.js fs] unexpected error from lstat after readdir: ",X)}z.push({name:A,isFile:()=>N,isDirectory:()=>M,isSymbolicLink:()=>W})}return z}function l(G){return a(E.readdirSync(G))}e.readdirSync=l;function a(G){return G.map(z=>typeof z=="string"?_.isMacintosh?r.normalizeNFC(z):z:(z.name=_.isMacintosh?r.normalizeNFC(z.name):z.name,z))}async function t(G){const z=await C(G),L=[];for(const A of z)await n.existsDirectory(D.join(G,A))&&L.push(A);return L}e.readDirsInDir=t;function i(G,z=1e3){return new Promise(L=>{let A=!1;const N=setInterval(()=>{A||(A=!0,E.access(G,M=>{A=!1,M&&(clearInterval(N),L(void 0))}))},z)})}e.whenDeleted=i;var n;(function(G){async function z(N){let M;try{if(M=await ee.lstat(N),!M.isSymbolicLink())return{stat:M}}catch(W){}try{return{stat:await ee.stat(N),symbolicLink:(M==null?void 0:M.isSymbolicLink())?{dangling:!1}:void 0}}catch(W){if(W.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};if(_.isWindows&&W.code==="EACCES")try{return{stat:await ee.stat(await ee.readlink(N)),symbolicLink:{dangling:!1}}}catch(X){if(X.code==="ENOENT"&&M)return{stat:M,symbolicLink:{dangling:!0}};throw X}throw W}}G.stat=z;async function L(N){try{const{stat:M,symbolicLink:W}=await G.stat(N);return M.isFile()&&(W==null?void 0:W.dangling)!==!0}catch(M){}return!1}G.existsFile=L;async function A(N){try{const{stat:M,symbolicLink:W}=await G.stat(N);return M.isDirectory()&&(W==null?void 0:W.dangling)!==!0}catch(M){}return!1}G.existsDirectory=A})(n=e.SymlinkSupport||(e.SymlinkSupport={}));const s=new I.ResourceQueue;function u(G,z,L){return s.queueFor(d.URI.file(G),k.extUriBiasedIgnorePathCase).queue(()=>{const A=R(L);return new Promise((N,M)=>v(G,z,A,W=>W?M(W):N()))})}e.writeFile=u;let g=!0;function v(G,z,L,A){if(!g)return E.writeFile(G,z,{mode:L.mode,flag:L.flag},A);E.open(G,L.flag,L.mode,(N,M)=>{if(N)return A(N);E.writeFile(M,z,W=>{if(W)return E.close(M,()=>A(W));E.fdatasync(M,X=>(X&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",X),g=!1),E.close(M,ae=>A(ae))))})})}function T(G,z,L){const A=R(L);if(!g)return E.writeFileSync(G,z,{mode:A.mode,flag:A.flag});const N=E.openSync(G,A.flag,A.mode);try{E.writeFileSync(N,z);try{E.fdatasyncSync(N)}catch(M){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",M),g=!1}}finally{E.closeSync(N)}}e.writeFileSync=T;function R(G){return G?{mode:typeof G.mode=="number"?G.mode:438,flag:typeof G.flag=="string"?G.flag:"w"}:{mode:438,flag:"w"}}async function o(G,z){if(G===z)return;async function L(A){try{const N=await ee.lstat(A);if(N.isDirectory()||N.isSymbolicLink())return;await ee.utimes(A,N.atime,new Date)}catch(N){}}try{await ee.rename(G,z),await L(z)}catch(A){if(G.toLowerCase()!==z.toLowerCase()&&A.code==="EXDEV"||G.endsWith("."))await F(G,z,{preserveSymlinks:!1}),await f(G,b.MOVE),await L(z);else throw A}}e.move=o;async function F(G,z,L){return Z(G,z,{root:{source:G,target:z},options:L,handledSourcePaths:new Set})}e.copy=F;const B=511;async function Z(G,z,L){if(L.handledSourcePaths.has(G))return;L.handledSourcePaths.add(G);const{stat:A,symbolicLink:N}=await n.stat(G);if(N){if(L.options.preserveSymlinks)try{return await oe(G,z,L)}catch(M){console.warn("[node.js fs] copy of symlink failed: ",M)}if(N.dangling)return}return A.isDirectory()?ie(G,z,A.mode&B,L):Se(G,z,A.mode&B)}async function ie(G,z,L,A){await ee.mkdir(z,{recursive:!0,mode:L});const N=await C(G);for(const M of N)await Z(D.join(G,M),D.join(z,M),A)}async function Se(G,z,L){await ee.copyFile(G,z),await ee.chmod(z,L)}async function oe(G,z,L){let A=await ee.readlink(G);m.isEqualOrParent(A,L.root.source,!_.isLinux)&&(A=D.join(L.root.target,A.substr(L.root.source.length+1))),await ee.symlink(A,z)}async function q(G){try{return await ee.access(G),!0}catch(z){return!1}}e.exists=q;var ee;(function(G){G.access=p.promisify(E.access),G.stat=p.promisify(E.stat),G.lstat=p.promisify(E.lstat),G.utimes=p.promisify(E.utimes),G.read=p.promisify(E.read),G.readFile=p.promisify(E.readFile),G.write=p.promisify(E.write),G.writeFile=p.promisify(E.writeFile),G.appendFile=p.promisify(E.appendFile),G.fdatasync=p.promisify(E.fdatasync),G.truncate=p.promisify(E.truncate),G.rename=p.promisify(E.rename),G.copyFile=p.promisify(E.copyFile),G.open=p.promisify(E.open),G.close=p.promisify(E.close),G.symlink=p.promisify(E.symlink),G.readlink=p.promisify(E.readlink),G.chmod=p.promisify(E.chmod),G.readdir=p.promisify(E.readdir),G.mkdir=p.promisify(E.mkdir),G.unlink=p.promisify(E.unlink),G.rmdir=p.promisify(E.rmdir),G.realpath=p.promisify(E.realpath)})(ee=e.Promises||(e.Promises={}))}),define(le[124],ce([0,1,25,13,3,15]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function I(r){const k=p.dirname(r);if(r===k)return r;const d=(p.basename(r)||r).toLowerCase();try{const f=D.readdirSync(k).filter(c=>c.toLowerCase()===d);if(f.length===1){const c=I(k);if(c)return p.join(c,f[0])}else if(f.length>1){const c=f.indexOf(d);if(c>=0){const S=I(k);if(S)return p.join(S,f[c])}}}catch(b){}return null}e.realcaseSync=I;async function _(r){try{return await D.Promises.realpath(r)}catch(k){const d=y(r);return await D.Promises.access(d,E.constants.R_OK),d}}e.realpath=_;function m(r){try{return E.realpathSync(r)}catch(k){const d=y(r);return E.accessSync(d,E.constants.R_OK),d}}e.realpathSync=m;function y(r){return P.rtrim(p.normalize(r),p.sep)}}),define(le[125],ce([0,1,80]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function P(_,m,y){let r=!1;return new Promise(k=>{const d=setTimeout(()=>{if(!r)return r=!0,k(0)},y);p(_,m,b=>{if(!r)return r=!0,clearTimeout(d),k(b)})})}e.findFreePort=P;function p(_,m,y){if(m===0)return y(0);const r=new E.Socket;r.once("connect",()=>(I(r),p(_+1,m-1,y))),r.once("data",()=>{}),r.once("error",k=>(I(r),k.code!=="ECONNREFUSED"?p(_+1,m-1,y):y(_))),r.connect(_,"127.0.0.1")}function D(_,m,y){let r=!1,k,d=1;const b=E.createServer({pauseOnConnect:!0});function f(c,S){r||(r=!0,b.removeAllListeners(),b.close(),k&&clearTimeout(k),S(c))}return new Promise(c=>{k=setTimeout(()=>{f(0,c)},y),b.on("listening",()=>{f(_,c)}),b.on("error",S=>{S&&(S.code==="EADDRINUSE"||S.code==="EACCES")&&d<m?(_++,d++,b.listen(_,"127.0.0.1")):f(0,c)}),b.on("close",()=>{f(0,c)}),b.listen(_,"127.0.0.1")})}e.findFreePortFaster=D;function I(_){try{_.removeAllListeners("connect"),_.removeAllListeners("error"),_.end(),_.destroy(),_.unref()}catch(m){console.error(m)}}});var st=this&&this.__await||function(x){return this instanceof st?(this.v=x,this):new st(x)},Xt=this&&this.__asyncGenerator||function(x,e,E){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var P=E.apply(x,e||[]),p,D=[];return p={},I("next"),I("throw"),I("return"),p[Symbol.asyncIterator]=function(){return this},p;function I(d){P[d]&&(p[d]=function(b){return new Promise(function(f,c){D.push([d,b,f,c])>1||_(d,b)})})}function _(d,b){try{m(P[d](b))}catch(f){k(D[0][3],f)}}function m(d){d.value instanceof st?Promise.resolve(d.value.v).then(y,r):k(D[0][2],d)}function y(d){_("next",d)}function r(d){_("throw",d)}function k(d,b){d(b),D.shift(),D.length&&_(D[0][0],D[0][1])}},Ct=this&&this.__asyncValues||function(x){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=x[Symbol.asyncIterator],E;return e?e.call(x):(x=typeof __values=="function"?__values(x):x[Symbol.iterator](),E={},P("next"),P("throw"),P("return"),E[Symbol.asyncIterator]=function(){return this},E);function P(D){E[D]=x[D]&&function(I){return new Promise(function(_,m){I=x[D](I),p(_,m,I.done,I.value)})}}function p(D,I,_,m){Promise.resolve(m).then(function(y){D({value:y,done:_})},I)}};define(le[81],ce([0,1,15,24,3]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const D=/^\d+$/,I=/^Microsoft.PowerShell_.*/,_=/^Microsoft.PowerShellPreview_.*/;var m;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(m||(m={}));let y;switch(process.arch){case"ia32":case"x32":y=1;break;case"arm":case"arm64":y=2;break;default:y=0;break}let r;process.env.PROCESSOR_ARCHITEW6432?r=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?r=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?r=1:r=0;class k{constructor(a,t,i){this.exePath=a,this.displayName=t,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await E.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function d({useAlternateBitness:l=!1}={}){return l?y===0?process.env["ProgramFiles(x86)"]||null:r===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function b({useAlternateBitness:l=!1,findPreview:a=!1}={}){const t=d({useAlternateBitness:l});if(!t)return null;const i=p.join(t,"PowerShell");if(!await E.SymlinkSupport.existsDirectory(i))return null;let n=-1,s=null;for(const v of await E.readdir(i)){let T=-1;if(a){const o=v.indexOf("-");if(o<0)continue;const F=v.substring(0,o);if(!D.test(F)||v.substring(o+1)!=="preview")continue;T=parseInt(F,10)}else{if(!D.test(v))continue;T=parseInt(v,10)}if(T<=n)continue;const R=p.join(i,v,"pwsh.exe");!await E.SymlinkSupport.existsFile(R)||(s=R,n=T)}if(!s)return null;const u=t.includes("x86")?" (x86)":"",g=a?" Preview":"";return new k(s,`PowerShell${g}${u}`,!0)}async function f({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const a=p.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await E.SymlinkSupport.existsDirectory(a))return null;const{pwshMsixDirRegex:t,pwshMsixName:i}=l?{pwshMsixDirRegex:_,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:I,pwshMsixName:"PowerShell (Store)"};for(const n of await E.readdir(a))if(t.test(n)){const s=p.join(a,n,"pwsh.exe");return new k(s,i)}return null}function c(){const l=p.join(P.homedir(),".dotnet","tools","pwsh.exe");return new k(l,".NET Core PowerShell Global Tool")}function S(){const l=p.join(process.env.windir,y===1&&r!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new k(l,"Windows PowerShell",!0)}function w(){return Xt(this,arguments,function*(){let a=yield st(b());a&&(yield yield st(a)),a=yield st(b({useAlternateBitness:!0})),a&&(yield yield st(a)),a=yield st(f()),a&&(yield yield st(a)),a=c(),a&&(yield yield st(a)),a=yield st(b({findPreview:!0})),a&&(yield yield st(a)),a=yield st(f({findPreview:!0})),a&&(yield yield st(a)),a=yield st(b({useAlternateBitness:!0,findPreview:!0})),a&&(yield yield st(a)),a=S(),a&&(yield yield st(a))})}function C(){return Xt(this,arguments,function*(){var a,t;try{for(var i=Ct(w()),n;n=yield st(i.next()),!n.done;){const s=n.value;(yield st(s.exists()))&&(yield yield st(s))}}catch(s){a={error:s}}finally{try{n&&!n.done&&(t=i.return)&&(yield st(t.call(i)))}finally{if(a)throw a.error}}})}e.enumeratePowerShellInstallations=C;async function h(){var l,a;try{for(var t=Ct(C()),i;i=await t.next(),!i.done;)return i.value}catch(n){l={error:n}}finally{try{i&&!i.done&&(a=t.return)&&await a.call(t)}finally{if(l)throw l.error}}return null}e.getFirstAvailablePowerShellInstallation=h}),define(le[82],ce([0,1,35,8]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function p(I){return new Promise((_,m)=>{let y;const r=new Map;function k(b,f,c,S,w){const C=r.get(f);if(b===I||C){const h={name:d(c),cmd:c,pid:b,ppid:f,load:S,mem:w};r.set(b,h),b===I&&(y=h),C&&(C.children||(C.children=[]),C.children.push(h),C.children.length>1&&(C.children=C.children.sort((l,a)=>l.pid-a.pid)))}}function d(b){const f=/--disable-blink-features=Auxclick/,c=/\\watcher\\win32\\CodeHelper\.exe/,S=/--crashes-directory/,w=/\\pipe\\winpty-control/,C=/conhost\.exe/,h=/--type=([a-zA-Z-]+)/;if(c.exec(b))return"watcherService ";if(S.exec(b))return"electron-crash-reporter";if(w.exec(b))return"winpty-process";if(C.exec(b))return"console-window-host (Windows internal process)";let l=h.exec(b);if(l&&l.length===2)return l[1]==="renderer"?f.exec(b)?"shared-process":"window":l[1];const a=/[a-zA-Z-]+\.js/g;let t="";do l=a.exec(b),l&&(t+=l+" ");while(l);return t&&b.indexOf("node ")<0&&b.indexOf("node.exe")<0?`electron_node ${t}`:b}if(process.platform==="win32"){const b=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,c)=>{x(["windows-process-tree"],f,c)}).then(f=>{f.getProcessList(I,c=>{f.getProcessCpuUsage(c,S=>{const w=new Map;S.forEach(C=>{const h=b(C.commandLine||"");w.set(C.pid,{name:d(h),cmd:h,pid:C.pid,ppid:C.ppid,load:C.cpu||0,mem:C.memory||0})}),y=w.get(I),y?(w.forEach(C=>{const h=w.get(C.ppid);h&&(h.children||(h.children=[]),h.children.push(C))}),w.forEach(C=>{C.children&&(C.children=C.children.sort((h,l)=>h.pid-l.pid))}),_(y)):m(new Error(`Root process ${I} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let b=function(){let f=[y];const c=[];for(;f.length;){const w=f.shift();w&&(c.push(w.pid),w.children&&(f=f.concat(w.children)))}let S=JSON.stringify(P.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",x).fsPath);S+=" "+c.join(" "),E.exec(S,{},(w,C,h)=>{if(w||h)m(w||new Error(h.toString()));else{const l=C.toString().split(`
`);for(let a=0;a<c.length;a++){const t=r.get(c[a]);t.load=parseFloat(l[a])}if(!y){m(new Error(`Root process ${I} not found`));return}_(y)}})};E.exec("which ps",{},(f,c,S)=>{if(f||S)if(process.platform!=="linux")m(f||new Error(S.toString()));else{const w=JSON.stringify(P.FileAccess.asFileUri("vs/base/node/ps.sh",x).fsPath);E.exec(w,{},(C,h,l)=>{C||l?m(C||new Error(l.toString())):(D(h,k),b())})}else{const w=c.toString().trim(),C="-ax -o pid=,ppid=,pcpu=,pmem=,command=";E.exec(`${w} ${C}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(h,l,a)=>{h||a&&!a.includes("screen size is bogus")?m(h||new Error(a.toString())):(D(l,k),process.platform==="linux"?b():y?_(y):m(new Error(`Root process ${I} not found`)))})}})}})}e.listProcesses=p;function D(I,_){const m=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,y=I.toString().split(`
`);for(const r of y){const k=m.exec(r.trim());k&&k.length===6&&_(parseInt(k[1]),parseInt(k[2]),k[5],parseFloat(k[3]),parseFloat(k[4]))}}}),define(le[126],ce([0,1,3,25,5,75,2,15]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function m(k,d,b){return r({path:k,isDirectory:!1},d,b)}e.watchFile=m;function y(k,d,b){return r({path:k,isDirectory:!0},d,b)}e.watchFolder=y,e.CHANGE_BUFFER_DELAY=100;function r(k,d,b){const f=E.basename(k.path),c=new Map;let S=!1,w=[I.toDisposable(()=>{c.forEach(C=>I.dispose(C)),c.clear()})];try{const C=P.watch(k.path);w.push(I.toDisposable(()=>{C.removeAllListeners(),C.close()}));const h=new Set;k.isDirectory&&_.readdir(k.path).then(l=>l.forEach(a=>h.add(a))),C.on("error",(l,a)=>{S||b(`Failed to watch ${k.path} for changes using fs.watch() (${l}, ${a})`)}),C.on("change",(l,a)=>{if(S)return;let t="";if(a&&(t=a.toString(),p.isMacintosh&&(t=D.normalizeNFC(t))),!t||l!=="change"&&l!=="rename")return;const i=k.isDirectory?E.join(k.path,t):k.path;if(k.isDirectory)if(l==="rename"){const n=c.get(i);n&&I.dispose(n);const s=setTimeout(async()=>{c.delete(i);const u=await _.exists(i);if(S)return;let g;u?h.has(t)?g="changed":(g="added",h.add(t)):(h.delete(t),g="deleted"),d(g,i)},e.CHANGE_BUFFER_DELAY);c.set(i,I.toDisposable(()=>clearTimeout(s)))}else{let n;h.has(t)?n="changed":(n="added",h.add(t)),d(n,i)}else if(l==="rename"||t!==f){const n=setTimeout(async()=>{const s=await _.exists(i);S||(s?(d("changed",i),w=[r(k,d,b)]):d("deleted",i))},e.CHANGE_BUFFER_DELAY);I.dispose(w),w=[I.toDisposable(()=>clearTimeout(n))]}else d("changed",i)})}catch(C){_.exists(k.path).then(h=>{h&&!S&&b(`Failed to watch ${k.path} for changes using fs.watch() (${C.toString()})`)})}return I.toDisposable(()=>{S=!0,w=I.dispose(w)})}});var Ne=this&&this.__decorate||function(x,e,E,P){var p=arguments.length,D=p<3?e:P===null?P=Object.getOwnPropertyDescriptor(e,E):P,I;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")D=Reflect.decorate(x,e,E,P);else for(var _=x.length-1;_>=0;_--)(I=x[_])&&(D=(p<3?I(D):p>3?I(e,E,D):I(e,E))||D);return p>3&&D&&Object.defineProperty(e,E,D),D};define(le[36],ce([0,1,7,2,14,29,12,18,21,11,46,13,70]),function(x,e,E,P,p,D,I,_,m,y,r,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var b;(function(L){L[L.Promise=100]="Promise",L[L.PromiseCancel=101]="PromiseCancel",L[L.EventListen=102]="EventListen",L[L.EventDispose=103]="EventDispose"})(b=e.RequestType||(e.RequestType={}));function f(L){switch(L){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(L){L[L.Initialize=200]="Initialize",L[L.PromiseSuccess=201]="PromiseSuccess",L[L.PromiseError=202]="PromiseError",L[L.PromiseErrorObj=203]="PromiseErrorObj",L[L.EventFire=204]="EventFire"})(c=e.ResponseType||(e.ResponseType={}));function S(L){switch(L){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var w;(function(L){L[L.Uninitialized=0]="Uninitialized",L[L.Idle=1]="Idle"})(w||(w={}));class C{constructor(A){this.buffer=A,this.pos=0}read(A){const N=this.buffer.slice(this.pos,this.pos+A);return this.pos+=N.byteLength,N}}class h{constructor(){this.buffers=[]}get buffer(){return _.VSBuffer.concat(this.buffers)}write(A){this.buffers.push(A)}}var l;(function(L){L[L.Undefined=0]="Undefined",L[L.String=1]="String",L[L.Buffer=2]="Buffer",L[L.VSBuffer=3]="VSBuffer",L[L.Array=4]="Array",L[L.Object=5]="Object"})(l||(l={}));function a(L){const A=_.VSBuffer.alloc(4);return A.writeUInt32BE(L,0),A}function t(L){return L.read(4).readUInt32BE(0)}function i(L){const A=_.VSBuffer.alloc(1);return A.writeUInt8(L,0),A}const n={Undefined:i(l.Undefined),String:i(l.String),Buffer:i(l.Buffer),VSBuffer:i(l.VSBuffer),Array:i(l.Array),Object:i(l.Object)},s=typeof Buffer!="undefined";function u(L,A){if(typeof A=="undefined")L.write(n.Undefined);else if(typeof A=="string"){const N=_.VSBuffer.fromString(A);L.write(n.String),L.write(a(N.byteLength)),L.write(N)}else if(s&&Buffer.isBuffer(A)){const N=_.VSBuffer.wrap(A);L.write(n.Buffer),L.write(a(N.byteLength)),L.write(N)}else if(A instanceof _.VSBuffer)L.write(n.VSBuffer),L.write(a(A.byteLength)),L.write(A);else if(Array.isArray(A)){L.write(n.Array),L.write(a(A.length));for(const N of A)u(L,N)}else{const N=_.VSBuffer.fromString(JSON.stringify(A));L.write(n.Object),L.write(a(N.byteLength)),L.write(N)}}function g(L){switch(L.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return L.read(t(L)).toString();case l.Buffer:return L.read(t(L)).buffer;case l.VSBuffer:return L.read(t(L));case l.Array:{const N=t(L),M=[];for(let W=0;W<N;W++)M.push(g(L));return M}case l.Object:return JSON.parse(L.read(t(L)).toString())}}class v{constructor(A,N,M=null,W=1e3){this.protocol=A,this.ctx=N,this.logger=M,this.timeoutDelay=W,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(X=>this.onRawMessage(X)),this.sendResponse({type:200})}registerChannel(A,N){this.channels.set(A,N),setTimeout(()=>this.flushPendingRequests(A),0)}sendResponse(A){switch(A.type){case 200:{const N=this.send([A.type]);this.logger&&this.logger.logOutgoing(N,0,1,S(A.type));return}case 201:case 202:case 204:case 203:{const N=this.send([A.type,A.id],A.data);this.logger&&this.logger.logOutgoing(N,A.id,1,S(A.type),A.data);return}}}send(A,N=void 0){const M=new h;return u(M,A),u(M,N),this.sendBuffer(M.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(N){return 0}}onRawMessage(A){const N=new C(A),M=g(N),W=g(N),X=M[0];switch(X){case 100:return this.logger&&this.logger.logIncoming(A.byteLength,M[1],1,`${f(X)}: ${M[2]}.${M[3]}`,W),this.onPromise({type:X,id:M[1],channelName:M[2],name:M[3],arg:W});case 102:return this.logger&&this.logger.logIncoming(A.byteLength,M[1],1,`${f(X)}: ${M[2]}.${M[3]}`,W),this.onEventListen({type:X,id:M[1],channelName:M[2],name:M[3],arg:W});case 101:return this.logger&&this.logger.logIncoming(A.byteLength,M[1],1,`${f(X)}`),this.disposeActiveRequest({type:X,id:M[1]});case 103:return this.logger&&this.logger.logIncoming(A.byteLength,M[1],1,`${f(X)}`),this.disposeActiveRequest({type:X,id:M[1]})}}onPromise(A){const N=this.channels.get(A.channelName);if(!N){this.collectPendingRequest(A);return}const M=new D.CancellationTokenSource;let W;try{W=N.call(this.ctx,A.name,A.arg,M.token)}catch(se){W=Promise.reject(se)}const X=A.id;W.then(se=>{this.sendResponse({id:X,data:se,type:201}),this.activeRequests.delete(A.id)},se=>{se instanceof Error?this.sendResponse({id:X,data:{message:se.message,name:se.name,stack:se.stack?se.stack.split?se.stack.split(`
`):se.stack:void 0},type:202}):this.sendResponse({id:X,data:se,type:203}),this.activeRequests.delete(A.id)});const ae=P.toDisposable(()=>M.cancel());this.activeRequests.set(A.id,ae)}onEventListen(A){const N=this.channels.get(A.channelName);if(!N){this.collectPendingRequest(A);return}const M=A.id,X=N.listen(this.ctx,A.name,A.arg)(ae=>this.sendResponse({id:M,data:ae,type:204}));this.activeRequests.set(A.id,X)}disposeActiveRequest(A){const N=this.activeRequests.get(A.id);N&&(N.dispose(),this.activeRequests.delete(A.id))}collectPendingRequest(A){let N=this.pendingRequests.get(A.channelName);N||(N=[],this.pendingRequests.set(A.channelName,N));const M=setTimeout(()=>{console.error(`Unknown channel: ${A.channelName}`),A.type===100&&this.sendResponse({id:A.id,data:{name:"Unknown channel",message:`Channel name '${A.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:A,timeoutTimer:M})}flushPendingRequests(A){const N=this.pendingRequests.get(A);if(N){for(const M of N)switch(clearTimeout(M.timeoutTimer),M.request.type){case 100:this.onPromise(M.request);break;case 102:this.onEventListen(M.request);break}this.pendingRequests.delete(A)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}e.ChannelServer=v;var T;(function(L){L[L.LocalSide=0]="LocalSide",L[L.OtherSide=1]="OtherSide"})(T=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(A,N=null){this.protocol=A,this.isDisposed=!1,this.state=w.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new E.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(M=>this.onBuffer(M)),this.logger=N}getChannel(A){const N=this;return{call(M,W,X){return N.isDisposed?Promise.reject(I.canceled()):N.requestPromise(A,M,W,X)},listen(M,W){return N.isDisposed?Promise.reject(I.canceled()):N.requestEvent(A,M,W)}}}requestPromise(A,N,M,W=D.CancellationToken.None){const X=this.lastRequestId++,se={id:X,type:100,channelName:A,name:N,arg:M};if(W.isCancellationRequested)return Promise.reject(I.canceled());let be;return new Promise((Te,Le)=>{if(W.isCancellationRequested)return Le(I.canceled());const je=()=>{const Ye=ge=>{switch(ge.type){case 201:this.handlers.delete(X),Te(ge.data);break;case 202:this.handlers.delete(X);const Ie=new Error(ge.data.message);Ie.stack=ge.data.stack,Ie.name=ge.data.name,Le(Ie);break;case 203:this.handlers.delete(X),Le(ge.data);break}};this.handlers.set(X,Ye),this.sendRequest(se)};let Xe=null;this.state===w.Idle?je():(Xe=p.createCancelablePromise(Ye=>this.whenInitialized()),Xe.then(()=>{Xe=null,je()}));const Ze=()=>{Xe?(Xe.cancel(),Xe=null):this.sendRequest({id:X,type:101}),Le(I.canceled())},it=W.onCancellationRequested(Ze);be=P.combinedDisposable(P.toDisposable(Ze),it),this.activeRequests.add(be)}).finally(()=>{this.activeRequests.delete(be)})}requestEvent(A,N,M){const W=this.lastRequestId++,ae={id:W,type:102,channelName:A,name:N,arg:M};let se=null;const be=new E.Emitter({onFirstListenerAdd:()=>{se=p.createCancelablePromise(Te=>this.whenInitialized()),se.then(()=>{se=null,this.activeRequests.add(be),this.sendRequest(ae)})},onLastListenerRemove:()=>{se?(se.cancel(),se=null):(this.activeRequests.delete(be),this.sendRequest({id:W,type:103}))}}),ke=Te=>be.fire(Te.data);return this.handlers.set(W,ke),be.event}sendRequest(A){switch(A.type){case 100:case 102:{const N=this.send([A.type,A.id,A.channelName,A.name],A.arg);this.logger&&this.logger.logOutgoing(N,A.id,0,`${f(A.type)}: ${A.channelName}.${A.name}`,A.arg);return}case 101:case 103:{const N=this.send([A.type,A.id]);this.logger&&this.logger.logOutgoing(N,A.id,0,f(A.type));return}}}send(A,N=void 0){const M=new h;return u(M,A),u(M,N),this.sendBuffer(M.buffer)}sendBuffer(A){try{return this.protocol.send(A),A.byteLength}catch(N){return 0}}onBuffer(A){const N=new C(A),M=g(N),W=g(N),X=M[0];switch(X){case 200:return this.logger&&this.logger.logIncoming(A.byteLength,0,0,S(X)),this.onResponse({type:M[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(A.byteLength,M[1],0,S(X),W),this.onResponse({type:M[0],id:M[1],data:W})}}onResponse(A){if(A.type===200){this.state=w.Idle,this._onDidInitialize.fire();return}const N=this.handlers.get(A.id);N&&N(A)}get onDidInitializePromise(){return E.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===w.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(A=>A.dispose()),this.activeRequests.clear()}}Ne([d.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class o{constructor(A){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new E.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new E.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,A(({protocol:N,onDidClientDisconnect:M})=>{E.Event.once(N.onMessage)(X=>{const ae=new C(X),se=g(ae),be=new v(N,se),ke=new R(N);this.channels.forEach((Le,je)=>be.registerChannel(je,Le));const Te={channelServer:be,channelClient:ke,ctx:se};this._connections.add(Te),this._onDidAddConnection.fire(Te),M(()=>{be.dispose(),ke.dispose(),this._connections.delete(Te),this._onDidRemoveConnection.fire(Te)})})})}get connections(){const A=[];return this._connections.forEach(N=>A.push(N)),A}getChannel(A,N){const M=this;return{call(W,X,ae){let se;if(y.isFunction(N)){let ke=m.getRandomElement(M.connections.filter(N));se=ke?Promise.resolve(ke):E.Event.toPromise(E.Event.filter(M.onDidAddConnection,N))}else se=N.routeCall(M,W,X);const be=se.then(ke=>ke.channelClient.getChannel(A));return B(be).call(W,X,ae)},listen(W,X){if(y.isFunction(N))return M.getMulticastEvent(A,N,W,X);const ae=N.routeEvent(M,W,X).then(se=>se.channelClient.getChannel(A));return B(ae).listen(W,X)}}}getMulticastEvent(A,N,M,W){const X=this;let ae=new P.DisposableStore;const se=new E.Emitter({onFirstListenerAdd:()=>{ae=new P.DisposableStore;const be=new E.EventMultiplexer,ke=new Map,Te=je=>{const Ze=je.channelClient.getChannel(A).listen(M,W),it=be.add(Ze);ke.set(je,it)},Le=je=>{const Xe=ke.get(je);!Xe||(Xe.dispose(),ke.delete(je))};X.connections.filter(N).forEach(Te),E.Event.filter(X.onDidAddConnection,N)(Te,void 0,ae),X.onDidRemoveConnection(Le,void 0,ae),be.event(se.fire,se,ae),ae.add(be)},onLastListenerRemove:()=>{ae.dispose()}});return se.event}registerChannel(A,N){this.channels.set(A,N),this._connections.forEach(M=>{M.channelServer.registerChannel(A,N)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=o;class F{constructor(A,N,M=null){const W=new h;u(W,N),A.send(W.buffer),this.channelClient=new R(A,M),this.channelServer=new v(A,N,M)}getChannel(A){return this.channelClient.getChannel(A)}registerChannel(A,N){this.channelServer.registerChannel(A,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=F;function B(L){return{call(A,N,M){return L.then(W=>W.call(A,N,M))},listen(A,N){const M=new E.Relay;return L.then(W=>M.input=W.listen(A,N)),M.event}}}e.getDelayedChannel=B;function Z(L){let A=!1;return{call(N,M,W){return A?L.call(N,M,W):p.timeout(0).then(()=>A=!0).then(()=>L.call(N,M,W))},listen(N,M){if(A)return L.listen(N,M);const W=new E.Relay;return p.timeout(0).then(()=>A=!0).then(()=>W.input=L.listen(N,M)),W.event}}}e.getNextTickChannel=Z;class ie{constructor(A){this.fn=A}routeCall(A){return this.route(A)}routeEvent(A){return this.route(A)}async route(A){for(const N of A.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await E.Event.toPromise(A.onDidAddConnection),await this.route(A)}}e.StaticRouter=ie;var Se;(function(L){function A(W,X){const ae=W,se=X&&X.disableMarshalling,be=new Map;for(const ke in ae)M(ke)&&be.set(ke,E.Event.buffer(ae[ke],!0));return new class{listen(ke,Te){const Le=be.get(Te);if(Le)return Le;throw new Error(`Event not found: ${Te}`)}call(ke,Te,Le){const je=ae[Te];if(typeof je=="function"){if(!se&&Array.isArray(Le))for(let Xe=0;Xe<Le.length;Xe++)Le[Xe]=r.revive(Le[Xe]);return je.apply(ae,Le)}throw new Error(`Method not found: ${Te}`)}}}L.fromService=A;function N(W,X){const ae=X&&X.disableMarshalling;return new Proxy({},{get(se,be){var ke;if(typeof be=="string")return((ke=X==null?void 0:X.properties)===null||ke===void 0?void 0:ke.has(be))?X.properties.get(be):M(be)?W.listen(be):async function(...Te){let Le;X&&!y.isUndefinedOrNull(X.context)?Le=[X.context,...Te]:Le=Te;const je=await W.call(be,Le);return ae?je:r.revive(je)};throw new Error(`Property not found: ${String(be)}`)}})}L.toService=N;function M(W){return W[0]==="o"&&W[1]==="n"&&k.isUpperAsciiLetter(W.charCodeAt(2))}})(Se=e.ProxyChannel||(e.ProxyChannel={}));const oe=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function q(L){if(Array.isArray(L))return L;if(L&&typeof L=="object"&&typeof L.toString=="function"){let A=L.toString();if(A!=="[object Object]")return A}return L}function ee(L){return Array.isArray(L)?L.map(q):q(L)}function G(L,A,N,M,W,X,ae){ae=ee(ae);const se=oe[W],be=se[M%se.length];let ke=[`%c[${L}]%c[${String(A).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(M).padStart(5," ")} - ${X}`,"color: darkgreen","color: grey","color: grey",`color: ${be}`];/\($/.test(X)?(ke=ke.concat(ae),ke.push(")")):ke.push(ae),console.log.apply(console,ke)}e.logWithColors=G;class z{constructor(A,N){this._outgoingPrefix=A,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(A,N,M,W,X){this._totalOutgoing+=A,G(this._outgoingPrefix,this._totalOutgoing,A,N,M,W,X)}logIncoming(A,N,M,W,X){this._totalIncoming+=A,G(this._incomingPrefix,this._totalIncoming,A,N,M,W,X)}}e.IPCLogger=z}),define(le[83],ce([0,1,7,36,2,18,5,23]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=void 0;let m=null;function y(){return m||(m=D.VSBuffer.alloc(0)),m}class r{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(n){this._chunks.push(n),this._totalLength+=n.byteLength}read(n){return this._read(n,!0)}peek(n){return this._read(n,!1)}_read(n,s){if(n===0)return y();if(n>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===n){const T=this._chunks[0];return s&&(this._chunks.shift(),this._totalLength-=n),T}if(this._chunks[0].byteLength>n){const T=this._chunks[0].slice(0,n);return s&&(this._chunks[0]=this._chunks[0].slice(n),this._totalLength-=n),T}let u=D.VSBuffer.alloc(n),g=0,v=0;for(;n>0;){const T=this._chunks[v];if(T.byteLength>n){const R=T.slice(0,n);u.set(R,g),g+=n,s&&(this._chunks[v]=T.slice(n),this._totalLength-=n),n-=n}else u.set(T,g),g+=T.byteLength,s?(this._chunks.shift(),this._totalLength-=T.byteLength):v++,n-=T.byteLength}return u}}e.ChunkStream=r;var k;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.KeepAlive=4]="KeepAlive",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest"})(k||(k={}));var d;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",i[i.KeepAliveTime=5e3]="KeepAliveTime",i[i.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(d=e.ProtocolConstants||(e.ProtocolConstants={}));class b{constructor(n,s,u,g){this.type=n,this.id=s,this.ack=u,this.data=g,this.writtenTime=0}get size(){return this.data.byteLength}}class f extends p.Disposable{constructor(n){super();this._onMessage=this._register(new E.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=n,this._isDisposed=!1,this._incomingData=new r,this._register(this._socket.onData(s=>this.acceptChunk(s))),this.lastReadTime=Date.now()}acceptChunk(n){if(!(!n||n.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(n);this._incomingData.byteLength>=this._state.readLen;){const s=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=s.readUInt32BE(9),this._state.messageType=s.readUInt8(0),this._state.id=s.readUInt32BE(1),this._state.ack=s.readUInt32BE(5);else{const u=this._state.messageType,g=this._state.id,v=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new b(u,g,v,s)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class c{constructor(n){this._isDisposed=!1,this._socket=n,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(n){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(n){if(this._isDisposed)return;n.writtenTime=Date.now(),this.lastWriteTime=Date.now();const s=D.VSBuffer.alloc(13);s.writeUInt8(n.type,0),s.writeUInt32BE(n.id,1),s.writeUInt32BE(n.ack,5),s.writeUInt32BE(n.data.byteLength,9),this._writeSoon(s,n.data)}_bufferAdd(n,s){const u=this._totalLength===0;return this._data.push(n,s),this._totalLength+=n.byteLength+s.byteLength,u}_bufferTake(){const n=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,n}_writeSoon(n,s){this._bufferAdd(n,s)&&I.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class S extends p.Disposable{constructor(n){super();this._onMessage=new E.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new E.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=n,this._socketWriter=this._register(new c(this._socket)),this._socketReader=this._register(new f(this._socket)),this._register(this._socketReader.onMessage(s=>{s.type===1&&this._onMessage.fire(s.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(n){this._socketWriter.write(new b(1,0,0,n))}}e.Protocol=S;class w extends P.IPCClient{constructor(n,s,u=null){super(n,s,u);this.protocol=n}static fromSocket(n,s){return new w(new S(n),s)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const n=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),n.end()}}e.Client=w;class C{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new E.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,_.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(n){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(n):this._emitter.fire(n):this._bufferedMessages.push(n)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=C;class h{constructor(n){this.data=n,this.next=null}}class l{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let n=[],s=0,u=this._first;for(;u;)n[s++]=u.data,u=u.next;return n}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(n){const s=new h(n);if(!this._first){this._first=s,this._last=s;return}this._last.next=s,this._last=s}}class a{constructor(){this.lastRuns=[];const n=Date.now();for(let s=0;s<a._HISTORY_LENGTH;s++)this.lastRuns[s]=n-1e3*s;setInterval(()=>{for(let s=a._HISTORY_LENGTH;s>=1;s--)this.lastRuns[s]=this.lastRuns[s-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return a._INSTANCE||(a._INSTANCE=new a),a._INSTANCE}load(){const n=Date.now(),s=(1+a._HISTORY_LENGTH)*1e3;let u=0;for(let g=0;g<a._HISTORY_LENGTH;g++)n-this.lastRuns[g]<=s&&u++;return 1-u/a._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}a._HISTORY_LENGTH=10,a._INSTANCE=null;class t{constructor(n,s=null){this._loadEstimator=a.getInstance(),this._onControlMessage=new C,this.onControlMessage=this._onControlMessage.event,this._onMessage=new C,this.onMessage=this._onMessage.event,this._onDidDispose=new C,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new C,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new C,this.onSocketTimeout=this._onSocketTimeout.event,this._isReconnecting=!1,this._outgoingUnackMsg=new l,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=n,this._socketWriter=new c(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),s&&this._socketReader.acceptChunk(s),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=p.dispose(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const n=new b(5,0,0,y());this._socketWriter.write(n),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const n=Date.now()-this._socketWriter.lastWriteTime;if(n>=5e3){const s=new b(4,0,0,y());this._socketWriter.write(s),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-n+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const n=Date.now()-this._socketReader.lastReadTime;if(n>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-n,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(n,s){this._isReconnecting=!0,this._socketDisposables=p.dispose(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=n,this._socketWriter=new c(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new f(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(u=>this._receiveMessage(u))),this._socketDisposables.push(this._socket.onClose(()=>this._onSocketClose.fire())),this._socketReader.acceptChunk(s)}endAcceptReconnection(){this._isReconnecting=!1;const n=this._outgoingUnackMsg.toArray();for(let s=0,u=n.length;s<u;s++)this._socketWriter.write(n[s]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(n){if(n.ack>this._outgoingAckId){this._outgoingAckId=n.ack;do{const s=this._outgoingUnackMsg.peek();if(s&&s.id<=n.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(n.type===1){if(n.id>this._incomingMsgId)if(n.id!==this._incomingMsgId+1){const s=Date.now();s-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=s,this._socketWriter.write(new b(6,0,0,y())))}else this._incomingMsgId=n.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(n.data)}else if(n.type===2)this._onControlMessage.fire(n.data);else if(n.type===5)this._onDidDispose.fire();else if(n.type===6){const s=this._outgoingUnackMsg.toArray();for(let u=0,g=s.length;u<g;u++)this._socketWriter.write(s[u]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(n){const s=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const u=new b(1,s,this._incomingAckId,n);this._outgoingUnackMsg.push(u),this._isReconnecting||(this._socketWriter.write(u),this._recvAckCheck())}sendControl(n){const s=new b(2,0,0,n);this._socketWriter.write(s)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const n=Date.now()-this._incomingMsgLastTime;if(n>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-n+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout)return;const n=this._outgoingUnackMsg.peek(),s=Date.now()-n.writtenTime;if(s>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-s,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const n=new b(3,0,this._incomingAckId,y());this._socketWriter.write(n)}}e.PersistentProtocol=t}),define(le[127],ce([0,1,2,7,14,11]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageHint=void 0;var I;(function(r){r[r.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(I=e.StorageHint||(e.StorageHint={}));var _;(function(r){r[r.None=0]="None",r[r.Initialized=1]="Initialized",r[r.Closed=2]="Closed"})(_||(_={}));class m extends E.Disposable{constructor(k,d=Object.create(null)){super();this.database=k,this.options=d,this._onDidChangeStorage=this._register(new P.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=_.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(m.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(k=>this.onDidChangeItemsExternal(k)))}onDidChangeItemsExternal(k){var d,b;(d=k.changed)===null||d===void 0||d.forEach((f,c)=>this.accept(c,f)),(b=k.deleted)===null||b===void 0||b.forEach(f=>this.accept(f,void 0))}accept(k,d){if(this.state===_.Closed)return;let b=!1;D.isUndefinedOrNull(d)?b=this.cache.delete(k):this.cache.get(k)!==d&&(this.cache.set(k,d),b=!0),b&&this._onDidChangeStorage.fire(k)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===_.None&&(this.state=_.Initialized,this.options.hint!==I.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(k,d){const b=this.cache.get(k);return D.isUndefinedOrNull(b)?d:b}getBoolean(k,d){const b=this.get(k);return D.isUndefinedOrNull(b)?d:b==="true"}getNumber(k,d){const b=this.get(k);return D.isUndefinedOrNull(b)?d:parseInt(b,10)}async set(k,d){if(this.state===_.Closed)return;if(D.isUndefinedOrNull(d))return this.delete(k);const b=String(d);if(this.cache.get(k)!==b)return this.cache.set(k,b),this.pendingInserts.set(k,b),this.pendingDeletes.delete(k),this._onDidChangeStorage.fire(k),this.flushDelayer.trigger(()=>this.flushPending())}async delete(k){if(!(this.state===_.Closed||!this.cache.delete(k)))return this.pendingDeletes.has(k)||this.pendingDeletes.add(k),this.pendingInserts.delete(k),this._onDidChangeStorage.fire(k),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=_.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(k){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const k={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(k).finally(()=>{var d;if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)(d=this.whenFlushedCallbacks.pop())===null||d===void 0||d()})}async whenFlushed(){if(!!this.hasPending)return new Promise(k=>this.whenFlushedCallbacks.push(k))}dispose(){this.flushDelayer.cancel(),this.flushDelayer.dispose(),super.dispose()}}e.Storage=m,m.DEFAULT_FLUSH_DELAY=100;class y{constructor(){this.onDidChangeItemsExternal=P.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(k){k.insert&&k.insert.forEach((d,b)=>this.items.set(b,d)),k.delete&&k.delete.forEach(d=>this.items.delete(d))}async close(){}}e.InMemoryStorageDatabase=y}),define(le[84],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Position=void 0;class E{constructor(p,D){this.lineNumber=p,this.column=D}with(p=this.lineNumber,D=this.column){return p===this.lineNumber&&D===this.column?this:new E(p,D)}delta(p=0,D=0){return this.with(this.lineNumber+p,this.column+D)}equals(p){return E.equals(this,p)}static equals(p,D){return!p&&!D?!0:!!p&&!!D&&p.lineNumber===D.lineNumber&&p.column===D.column}isBefore(p){return E.isBefore(this,p)}static isBefore(p,D){return p.lineNumber<D.lineNumber?!0:D.lineNumber<p.lineNumber?!1:p.column<D.column}isBeforeOrEqual(p){return E.isBeforeOrEqual(this,p)}static isBeforeOrEqual(p,D){return p.lineNumber<D.lineNumber?!0:D.lineNumber<p.lineNumber?!1:p.column<=D.column}static compare(p,D){let I=p.lineNumber|0,_=D.lineNumber|0;if(I===_){let m=p.column|0,y=D.column|0;return m-y}return I-_}clone(){return new E(this.lineNumber,this.column)}toString(){return"("+this.lineNumber+","+this.column+")"}static lift(p){return new E(p.lineNumber,p.column)}static isIPosition(p){return p&&typeof p.lineNumber=="number"&&typeof p.column=="number"}}e.Position=E}),define(le[54],ce([0,1,84]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Range=void 0;class P{constructor(D,I,_,m){D>_||D===_&&I>m?(this.startLineNumber=_,this.startColumn=m,this.endLineNumber=D,this.endColumn=I):(this.startLineNumber=D,this.startColumn=I,this.endLineNumber=_,this.endColumn=m)}isEmpty(){return P.isEmpty(this)}static isEmpty(D){return D.startLineNumber===D.endLineNumber&&D.startColumn===D.endColumn}containsPosition(D){return P.containsPosition(this,D)}static containsPosition(D,I){return!(I.lineNumber<D.startLineNumber||I.lineNumber>D.endLineNumber||I.lineNumber===D.startLineNumber&&I.column<D.startColumn||I.lineNumber===D.endLineNumber&&I.column>D.endColumn)}containsRange(D){return P.containsRange(this,D)}static containsRange(D,I){return!(I.startLineNumber<D.startLineNumber||I.endLineNumber<D.startLineNumber||I.startLineNumber>D.endLineNumber||I.endLineNumber>D.endLineNumber||I.startLineNumber===D.startLineNumber&&I.startColumn<D.startColumn||I.endLineNumber===D.endLineNumber&&I.endColumn>D.endColumn)}strictContainsRange(D){return P.strictContainsRange(this,D)}static strictContainsRange(D,I){return!(I.startLineNumber<D.startLineNumber||I.endLineNumber<D.startLineNumber||I.startLineNumber>D.endLineNumber||I.endLineNumber>D.endLineNumber||I.startLineNumber===D.startLineNumber&&I.startColumn<=D.startColumn||I.endLineNumber===D.endLineNumber&&I.endColumn>=D.endColumn)}plusRange(D){return P.plusRange(this,D)}static plusRange(D,I){let _,m,y,r;return I.startLineNumber<D.startLineNumber?(_=I.startLineNumber,m=I.startColumn):I.startLineNumber===D.startLineNumber?(_=I.startLineNumber,m=Math.min(I.startColumn,D.startColumn)):(_=D.startLineNumber,m=D.startColumn),I.endLineNumber>D.endLineNumber?(y=I.endLineNumber,r=I.endColumn):I.endLineNumber===D.endLineNumber?(y=I.endLineNumber,r=Math.max(I.endColumn,D.endColumn)):(y=D.endLineNumber,r=D.endColumn),new P(_,m,y,r)}intersectRanges(D){return P.intersectRanges(this,D)}static intersectRanges(D,I){let _=D.startLineNumber,m=D.startColumn,y=D.endLineNumber,r=D.endColumn,k=I.startLineNumber,d=I.startColumn,b=I.endLineNumber,f=I.endColumn;return _<k?(_=k,m=d):_===k&&(m=Math.max(m,d)),y>b?(y=b,r=f):y===b&&(r=Math.min(r,f)),_>y||_===y&&m>r?null:new P(_,m,y,r)}equalsRange(D){return P.equalsRange(this,D)}static equalsRange(D,I){return!!D&&!!I&&D.startLineNumber===I.startLineNumber&&D.startColumn===I.startColumn&&D.endLineNumber===I.endLineNumber&&D.endColumn===I.endColumn}getEndPosition(){return P.getEndPosition(this)}static getEndPosition(D){return new E.Position(D.endLineNumber,D.endColumn)}getStartPosition(){return P.getStartPosition(this)}static getStartPosition(D){return new E.Position(D.startLineNumber,D.startColumn)}toString(){return"["+this.startLineNumber+","+this.startColumn+" -> "+this.endLineNumber+","+this.endColumn+"]"}setEndPosition(D,I){return new P(this.startLineNumber,this.startColumn,D,I)}setStartPosition(D,I){return new P(D,I,this.endLineNumber,this.endColumn)}collapseToStart(){return P.collapseToStart(this)}static collapseToStart(D){return new P(D.startLineNumber,D.startColumn,D.startLineNumber,D.startColumn)}static fromPositions(D,I=D){return new P(D.lineNumber,D.column,I.lineNumber,I.column)}static lift(D){return D?new P(D.startLineNumber,D.startColumn,D.endLineNumber,D.endColumn):null}static isIRange(D){return D&&typeof D.startLineNumber=="number"&&typeof D.startColumn=="number"&&typeof D.endLineNumber=="number"&&typeof D.endColumn=="number"}static areIntersectingOrTouching(D,I){return!(D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<I.startColumn||I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<D.startColumn)}static areIntersecting(D,I){return!(D.endLineNumber<I.startLineNumber||D.endLineNumber===I.startLineNumber&&D.endColumn<=I.startColumn||I.endLineNumber<D.startLineNumber||I.endLineNumber===D.startLineNumber&&I.endColumn<=D.startColumn)}static compareRangesUsingStarts(D,I){if(D&&I){const y=D.startLineNumber|0,r=I.startLineNumber|0;if(y===r){const k=D.startColumn|0,d=I.startColumn|0;if(k===d){const b=D.endLineNumber|0,f=I.endLineNumber|0;if(b===f){const c=D.endColumn|0,S=I.endColumn|0;return c-S}return b-f}return k-d}return y-r}return(D?1:0)-(I?1:0)}static compareRangesUsingEnds(D,I){return D.endLineNumber===I.endLineNumber?D.endColumn===I.endColumn?D.startLineNumber===I.startLineNumber?D.startColumn-I.startColumn:D.startLineNumber-I.startLineNumber:D.endColumn-I.endColumn:D.endLineNumber-I.endLineNumber}static spansMultipleLines(D){return D.endLineNumber>D.startLineNumber}}e.Range=P}),define(le[128],ce([0,1,47,3]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function p(D,I,_,m){if(Array.isArray(D)){let y=0;for(const r of D){const k=p(r,I,_,m);if(k===10)return k;k>y&&(y=k)}return y}else{if(typeof D=="string")return m?D==="*"?5:D===_?10:0:0;if(D){const{language:y,pattern:r,scheme:k,hasAccessToAllModels:d}=D;if(!m&&!d)return 0;let b=0;if(k)if(k===I.scheme)b=10;else if(k==="*")b=5;else return 0;if(y)if(y===_)b=10;else if(y==="*")b=Math.max(b,5);else return 0;if(r){let f;if(typeof r=="string"?f=r:f=Object.assign(Object.assign({},r),{base:P.normalize(r.base)}),f===I.fsPath||E.match(f,I.fsPath))b=10;else return 0}return b}else return 0}}e.score=p}),define(le[129],ce([0,1,7,2]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class p{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(I){this._onDidChange.fire({changedLanguages:I,changedColorMap:!1})}register(I,_){return this._map.set(I,_),this.fire([I]),P.toDisposable(()=>{this._map.get(I)===_&&(this._map.delete(I),this.fire([I]))})}registerPromise(I,_){let m=null,y=!1;return this._promises.set(I,_.then(r=>{this._promises.delete(I),!(y||!r)&&(m=this.register(I,r))})),P.toDisposable(()=>{y=!0,m&&m.dispose()})}getPromise(I){const _=this.get(I);if(_)return Promise.resolve(_);const m=this._promises.get(I);return m?m.then(y=>this.get(I)):null}get(I){return this._map.get(I)||null}setColorMap(I){this._colorMap=I,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=p}),define(le[130],ce([9,10]),function(x,e){return x.create("vs/base/common/date",e)}),define(le[131],ce([0,1,130]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const P=60,p=P*60,D=p*24,I=D*7,_=D*30,m=D*365;function y(k,d){typeof k!="number"&&(k=k.getTime());const b=Math.round((new Date().getTime()-k)/1e3);if(b<-30)return E.localize(0,null,y(new Date().getTime()+b*1e3,!1));if(b<30)return E.localize(1,null);let f;return b<P?(f=b,d?f===1?E.localize(2,null,f):E.localize(3,null,f):f===1?E.localize(4,null,f):E.localize(5,null,f)):b<p?(f=Math.floor(b/P),d?f===1?E.localize(6,null,f):E.localize(7,null,f):f===1?E.localize(8,null,f):E.localize(9,null,f)):b<D?(f=Math.floor(b/p),d?f===1?E.localize(10,null,f):E.localize(11,null,f):f===1?E.localize(12,null,f):E.localize(13,null,f)):b<I?(f=Math.floor(b/D),d?f===1?E.localize(14,null,f):E.localize(15,null,f):f===1?E.localize(16,null,f):E.localize(17,null,f)):b<_?(f=Math.floor(b/I),d?f===1?E.localize(18,null,f):E.localize(19,null,f):f===1?E.localize(20,null,f):E.localize(21,null,f)):b<m?(f=Math.floor(b/_),d?f===1?E.localize(22,null,f):E.localize(23,null,f):f===1?E.localize(24,null,f):E.localize(25,null,f)):(f=Math.floor(b/m),d?f===1?E.localize(26,null,f):E.localize(27,null,f):f===1?E.localize(28,null,f):E.localize(29,null,f))}e.fromNow=y;function r(k){return k.getFullYear()+"-"+String(k.getMonth()+1).padStart(2,"0")+"-"+String(k.getDate()).padStart(2,"0")+"T"+String(k.getHours()).padStart(2,"0")+":"+String(k.getMinutes()).padStart(2,"0")+":"+String(k.getSeconds()).padStart(2,"0")+"."+(k.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=r}),define(le[132],ce([9,10]),function(x,e){return x.create("vs/base/common/errorMessage",e)}),define(le[43],ce([0,1,132,11,21]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function D(y,r){return r&&(y.stack||y.stacktrace)?E.localize(0,null,_(y),I(y.stack)||I(y.stacktrace)):_(y)}function I(y){return Array.isArray(y)?y.join(`
`):y}function _(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?E.localize(1,null,y.message):y.message||E.localize(2,null)}function m(y=null,r=!1){if(!y)return E.localize(3,null);if(Array.isArray(y)){const k=p.coalesce(y),d=m(k[0],r);return k.length>1?E.localize(4,null,d,k.length):d}if(P.isString(y))return y;if(y.detail){const k=y.detail;if(k.error)return D(k.error,r);if(k.exception)return D(k.exception,r)}return y.stack?D(y,r):y.message?y.message:E.localize(5,null)}e.toErrorMessage=m}),define(le[133],ce([9,10]),function(x,e){return x.create("vs/base/common/jsonErrorMessages",e)}),define(le[134],ce([0,1,133]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function P(p){switch(p){case 1:return E.localize(0,null);case 2:return E.localize(1,null);case 3:return E.localize(2,null);case 4:return E.localize(3,null);case 5:return E.localize(4,null);case 6:return E.localize(5,null);case 7:return E.localize(6,null);case 8:return E.localize(7,null);case 9:return E.localize(8,null);default:return""}}e.getParseErrorMessage=P}),define(le[135],ce([9,10]),function(x,e){return x.create("vs/base/node/processes",e)}),define(le[85],ce([0,1,3,15,35,135,23,11,19,30,5,77,8]),function(x,e,E,P,p,D,I,_,m,y,r,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0;function b(l){switch(l){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function f(l,a){if(r.isWindows)try{const t={stdio:["pipe","pipe","ignore"]};a&&(t.cwd=a);const i=p.execFile("taskkill",["/T","/F","/PID",l.pid.toString()],t);return new Promise(n=>{i.once("error",s=>{n({success:!1,error:s})}),i.once("exit",(s,u)=>{n(s===0?{success:!0}:{success:!1,code:s!==null?s:1})})})}catch(t){return Promise.resolve({success:!1,error:t,code:t.status?b(t.status):1})}else if(r.isLinux||r.isMacintosh)try{const t=d.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",x).fsPath;return new Promise(i=>{p.execFile(t,[l.pid.toString()],{encoding:"utf8",shell:!0},(n,s,u)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(t){return Promise.resolve({success:!1,error:t})}else l.kill("SIGKILL");return Promise.resolve({success:!0})}function c(l=I.env){return l.comspec||"cmd.exe"}e.getWindowsShell=c;class S{constructor(a,t,i,n){if(t!==void 0&&i!==void 0&&n!==void 0)this.cmd=a,this.args=t,this.shell=i,this.options=n;else{const s=a;this.cmd=s.command,this.shell=s.isShellCommand,this.args=s.args.slice(0),this.options=s.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const s=Object.create(null);Object.keys(I.env).forEach(u=>{s[u]=I.env[u]}),Object.keys(this.options.env).forEach(u=>{s[u]=this.options.env[u]}),this.options.env=s}}getSanitizedCommand(){let a=this.cmd.toLowerCase();const t=a.lastIndexOf(E.sep);return t!==-1&&(a=a.substring(t+1)),S.WellKnowCommands[a]?a:"other"}start(a){return r.isWindows&&(this.options&&this.options.cwd&&y.isUNC(this.options.cwd)||!this.options&&y.isUNC(I.cwd()))?Promise.reject(new Error(D.localize(0,null))):this.useExec().then(t=>{let i,n;const s=new Promise((u,g)=>{i=u,n=g});if(t){let u=this.cmd;this.args&&(u=u+" "+this.args.join(" ")),this.childProcess=p.exec(u,this.options,(g,v,T)=>{this.childProcess=null;const R=g;R&&R.killed?n({killed:this.terminateRequested,stdout:v.toString(),stderr:T.toString()}):this.handleExec(i,a,g,v,T)})}else{let u=null;const g=v=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(v,i,a,n);const T={terminated:this.terminateRequested};_.isNumber(v)&&(T.cmdCode=v),i(T)};if(this.shell&&r.isWindows){const v=m.deepClone(this.options);v.windowsVerbatimArguments=!0,v.detached=!1;let T=!1,R=!1;const o=[];let F=this.ensureQuotes(this.cmd);o.push(F.value),T=F.quoted,this.args&&this.args.forEach(Z=>{F=this.ensureQuotes(Z),o.push(F.value),R=R&&F.quoted});const B=["/s","/c"];T?R?B.push('"'+o.join(" ")+'"'):o.length>1?B.push('"'+o[0]+'" '+o.slice(1).join(" ")):B.push('"'+o[0]+'"'):B.push(o.join(" ")),u=p.spawn(c(),B,v)}else this.cmd&&(u=p.spawn(this.cmd,this.args,this.options));u&&(this.childProcess=u,this.childProcessPromise=Promise.resolve(u),this.pidResolve&&(this.pidResolve(_.isNumber(u.pid)?u.pid:-1),this.pidResolve=void 0),u.on("error",v=>{this.childProcess=null,n({terminated:this.terminateRequested,error:v})}),u.pid&&(this.childProcess.on("close",g),this.handleSpawn(u,i,a,n,!0)))}return s})}handleClose(a,t,i,n){}ensureQuotes(a){return S.regexp.test(a)?{value:'"'+a+'"',quoted:!0}:{value:a,quoted:a.length>0&&a[0]==='"'&&a[a.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(a=>a.pid,a=>-1):new Promise(a=>{this.pidResolve=a})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(a=>(this.terminateRequested=!0,f(a,this.options.cwd).then(t=>(t.success&&(this.childProcess=null),t))),a=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(a=>{if(!this.shell||!r.isWindows)return a(!1);const t=p.spawn(c(),["/s","/c"]);t.on("error",i=>a(!0)),t.on("exit",i=>a(!1))})}}e.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class w extends S{constructor(a,t,i,n){super(a,t,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(a,t,i,n,s){[n,s].forEach((u,g)=>{const v=new k.LineDecoder;v.write(u).forEach(o=>{t({line:o,source:g===0?0:1})});const R=v.end();R&&t({line:R,source:g===0?0:1})}),a({terminated:this.terminateRequested,error:i})}handleSpawn(a,t,i,n,s){const u=new k.LineDecoder,g=new k.LineDecoder;a.stdout.on("data",v=>{u.write(v).forEach(R=>i({line:R,source:0}))}),a.stderr.on("data",v=>{g.write(v).forEach(R=>i({line:R,source:1}))}),this.stdoutLineDecoder=u,this.stderrLineDecoder=g}handleClose(a,t,i,n){const s=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;s&&i({line:s,source:0});const u=this.stderrLineDecoder?this.stderrLineDecoder.end():null;u&&i({line:u,source:1})}}e.LineProcess=w;function C(l){let a=[],t=!1;const i=function(n){if(t){a.push(n);return}(!l.send(n,u=>{if(u&&console.error(u),t=!1,a.length>0){const g=a.slice(0);a=[],g.forEach(v=>i(v))}})||r.isWindows)&&(t=!0)};return{send:i}}e.createQueuedSender=C;var h;(function(l){async function a(t,i,n){if(E.isAbsolute(t))return t;if(i===void 0&&(i=I.cwd()),E.dirname(t)!=="."||(n===void 0&&_.isString(I.env.PATH)&&(n=I.env.PATH.split(E.delimiter)),n===void 0||n.length===0))return E.join(i,t);async function u(g){return await P.exists(g)?!(await P.Promises.stat(g)).isDirectory():!1}for(let g of n){let v;if(E.isAbsolute(g)?v=E.join(g,t):v=E.join(i,g,t),await u(v))return v;let T=v+".com";if(await u(T)||(T=v+".exe",await u(T)))return T}return E.join(i,t)}l.findExecutable=a})(h=e.win32||(e.win32={}))}),define(le[136],ce([0,1,24,5,81,85]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function I(b,f){return b===1?P.isWindows?k():D.getWindowsShell(f):y(b,f)}e.getSystemShell=I;function _(b,f){return b===1?P.isWindows?d(f):D.getWindowsShell(f):y(b,f)}e.getSystemShellSync=_;let m=null;function y(b,f){if(P.isLinux&&b===2||P.isMacintosh&&b===3)return"/bin/bash";if(!m){let c;if(P.isWindows)c="/bin/bash";else{if(c=f.SHELL,!c)try{c=E.userInfo().shell}catch(S){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}m=c}return m}let r=null;async function k(){return r||(r=(await p.getFirstAvailablePowerShellInstallation()).exePath),r}function d(b){if(r)return r;const f=P.isWindows&&parseFloat(E.release())>=10,c=b.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${b.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?S:D.getWindowsShell(b)}}),define(le[55],ce([0,1,35,2,14,19,7,85,36,118,29,12,18,5]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends m.ChannelServer{constructor(w){super({send:C=>{try{process.send&&process.send(C.buffer.toString("base64"))}catch(h){}},onMessage:I.Event.fromNodeEventEmitter(process,"message",C=>d.VSBuffer.wrap(Buffer.from(C,"base64")))},w);process.once("disconnect",()=>this.dispose())}}e.Server=f;class c{constructor(w,C){this.modulePath=w,this.options=C,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new I.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const h=C&&C.timeout?C.timeout:6e4;this.disposeDelayer=new p.Delayer(h),this.child=null,this._client=null}getChannel(w){const C=this;return{call(h,l,a){return C.requestPromise(w,h,l,a)},listen(h,l){return C.requestEvent(w,h,l)}}}requestPromise(w,C,h,l=r.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(l.isCancellationRequested)return Promise.reject(k.canceled());this.disposeDelayer.cancel();const a=this.getCachedChannel(w),t=p.createCancelablePromise(s=>a.call(C,h,s)),i=l.onCancellationRequested(()=>t.cancel()),n=P.toDisposable(()=>t.cancel());return this.activeRequests.add(n),t.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),t}requestEvent(w,C,h){if(!this.disposeDelayer)return I.Event.None;this.disposeDelayer.cancel();let l;const a=new I.Emitter({onFirstListenerAdd:()=>{l=this.getCachedChannel(w).listen(C,h)(a.fire,a),this.activeRequests.add(l)},onLastListenerRemove:()=>{this.activeRequests.delete(l),l.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return a.event}get client(){if(!this._client){const w=this.options&&this.options.args?this.options.args:[],C=Object.create(null);C.env=Object.assign(Object.assign({},D.deepClone(process.env)),{VSCODE_PARENT_PID:String(process.pid)}),this.options&&this.options.env&&(C.env=Object.assign(Object.assign({},C.env),this.options.env)),this.options&&this.options.freshExecArgv&&(C.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(C.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(C.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),C.execArgv===void 0&&(C.execArgv=process.execArgv.filter(u=>!/^--inspect(-brk)?=/.test(u))),b.isMacintosh&&C.env&&delete C.env.DYLD_LIBRARY_PATH,this.child=E.fork(this.modulePath,w,C);const h=new I.Emitter;I.Event.fromNodeEventEmitter(this.child,"message",u=>u)(u=>{if(y.isRemoteConsoleLog(u)){y.log(u,`IPC Library: ${this.options.serverName}`);return}h.fire(d.VSBuffer.wrap(Buffer.from(u,"base64")))});const a=this.options.useQueue?_.createQueuedSender(this.child):this.child,t=u=>this.child&&this.child.connected&&a.send(u.buffer.toString("base64")),i=h.event,n={send:t,onMessage:i};this._client=new m.ChannelClient(n);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",u=>console.warn('IPC "'+this.options.serverName+'" errored with '+u)),this.child.on("exit",(u,g)=>{process.removeListener("exit",s),this.activeRequests.forEach(v=>P.dispose(v)),this.activeRequests.clear(),u!==0&&g!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+u+" and signal "+g),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:u,signal:g})})}return this._client}getCachedChannel(w){let C=this.channels.get(w);return C||(C=this.client.getChannel(w),this.channels.set(w,C)),C}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=c}),define(le[137],ce([9,10]),function(x,e){return x.create("vs/base/node/zip",e)}),define(le[138],ce([9,10]),function(x,e){return x.create("vs/platform/configuration/common/configurationRegistry",e)}),define(le[139],ce([9,10]),function(x,e){return x.create("vs/platform/environment/node/argv",e)}),define(le[140],ce([9,10]),function(x,e){return x.create("vs/platform/environment/node/argvHelper",e)}),define(le[141],ce([9,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(le[142],ce([9,10]),function(x,e){return x.create("vs/platform/extensionManagement/common/extensionManagementCLIService",e)}),define(le[143],ce([9,10]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(le[144],ce([9,10]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(le[145],ce([9,10]),function(x,e){return x.create("vs/platform/extensionManagement/node/extensionsScanner",e)}),define(le[146],ce([9,10]),function(x,e){return x.create("vs/platform/extensions/common/extensionValidator",e)}),define(le[147],ce([9,10]),function(x,e){return x.create("vs/platform/files/common/fileService",e)}),define(le[148],ce([9,10]),function(x,e){return x.create("vs/platform/files/common/files",e)}),define(le[149],ce([9,10]),function(x,e){return x.create("vs/platform/files/common/io",e)}),define(le[150],ce([9,10]),function(x,e){return x.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(le[151],ce([9,10]),function(x,e){return x.create("vs/platform/markers/common/markers",e)}),define(le[152],ce([9,10]),function(x,e){return x.create("vs/platform/request/common/request",e)}),define(le[153],ce([9,10]),function(x,e){return x.create("vs/platform/telemetry/common/telemetryService",e)}),define(le[154],ce([9,10]),function(x,e){return x.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(le[155],ce([9,10]),function(x,e){return x.create("vs/platform/workspaces/common/workspaces",e)}),define(le[156],ce([9,10]),function(x,e){return x.create("vs/server/remoteAgentEnvironmentImpl",e)}),define(le[157],ce([9,10]),function(x,e){return x.create("vs/server/serverEnvironmentService",e)}),define(le[158],ce([9,10]),function(x,e){return x.create("vs/workbench/common/editor",e)}),define(le[159],ce([9,10]),function(x,e){return x.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(le[160],ce([9,10]),function(x,e){return x.create("vs/workbench/services/extensions/node/extensionPoints",e)}),define(le[161],ce([0,1,7,2]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class p{constructor(){this._onCloseEmitter=new E.Emitter,this._onReloadEmitter=new E.Emitter,this._onTerminateEmitter=new E.Emitter,this._onAttachEmitter=new E.Emitter}call(_,m,y){switch(m){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:y[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:y[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:y[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:y[0],port:y[1],subId:y[2]}))}throw new Error("Method not implemented.")}listen(_,m,y){switch(m){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=p,p.ChannelName="extensionhostdebugservice";class D extends P.Disposable{constructor(_){super();this.channel=_}reload(_){this.channel.call("reload",[_])}get onReload(){return this.channel.listen("reload")}close(_){this.channel.call("close",[_])}get onClose(){return this.channel.listen("close")}attachSession(_,m,y){this.channel.call("attach",[_,m,y])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(_,m){this.channel.call("terminate",[_,m])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(_,m,y){return this.channel.call("openExtensionDevelopmentHostWindow",[_,m||{},y])}}e.ExtensionHostDebugChannelClient=D}),define(le[162],ce([0,1,4]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadServiceChannelClient=e.DownloadServiceChannel=void 0;class P{constructor(I){this.service=I}listen(I,_,m){throw new Error("Invalid listen")}call(I,_,m){switch(_){case"download":return this.service.download(E.URI.revive(m[0]),E.URI.revive(m[1]))}throw new Error("Invalid call")}}e.DownloadServiceChannel=P;class p{constructor(I,_){this.channel=I,this.getUriTransformer=_}async download(I,_){const m=this.getUriTransformer();m&&(I=m.transformOutgoingURI(I),_=m.transformOutgoingURI(_)),await this.channel.call("download",[I,_])}}e.DownloadServiceChannelClient=p}),define(le[163],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorOverride=e.EditorActivation=void 0;var E;(function(I){I[I.ACTIVATE=0]="ACTIVATE",I[I.RESTORE=1]="RESTORE",I[I.PRESERVE=2]="PRESERVE"})(E=e.EditorActivation||(e.EditorActivation={}));var P;(function(I){I[I.PICK=1]="PICK",I[I.DISABLED=2]="DISABLED"})(P=e.EditorOverride||(e.EditorOverride={}));var p;(function(I){I[I.API=0]="API",I[I.USER=1]="USER"})(p=e.EditorOpenContext||(e.EditorOpenContext={}));var D;(function(I){I[I.Center=0]="Center",I[I.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",I[I.NearTop=2]="NearTop",I[I.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(D=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(le[164],ce([0,1,3,17,70,131,8,4,23]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class y{constructor(f,c,S){this._args=f,this.paths=c,this.productService=S}get appRoot(){return E.dirname(I.FileAccess.asFileUri("",x).fsPath)}get userHome(){return _.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return _.URI.file(E.join(this.userDataPath,"User"))}get tmpDir(){return _.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return P.joinPath(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return P.joinPath(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const f=D.toLocalISOString(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=E.join(this.userDataPath,"logs",f)}return this.args.logsPath}get userDataSyncLogResource(){return _.URI.file(E.join(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return P.joinPath(_.URI.file(E.join(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return _.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return _.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return P.joinPath(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return P.joinPath(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const f=m.env.VSCODE_PORTABLE;return f?_.URI.file(E.join(f,"argv.json")):P.joinPath(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return P.joinPath(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return _.URI.file(E.join(this.userDataPath,"Workspaces"))}get installSourcePath(){return E.join(this.userDataPath,"installSource")}get builtinExtensionsPath(){const f=this.args["builtin-extensions-dir"];return f?E.resolve(f):E.normalize(E.join(I.FileAccess.asFileUri("",x).fsPath,"..","extensions"))}get extensionsDownloadPath(){const f=this.args["extensions-download-dir"];return f?E.resolve(f):E.join(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const f=this.args["extensions-dir"];if(f)return E.resolve(f);const c=m.env.VSCODE_EXTENSIONS;if(c)return c;const S=m.env.VSCODE_PORTABLE;return S?E.join(S,"extensions"):P.joinPath(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const f=this.args.extensionDevelopmentPath;if(Array.isArray(f))return f.map(c=>/^[^:/?#]+?:\/\//.test(c)?_.URI.parse(c):_.URI.file(E.normalize(c)))}get extensionDevelopmentKind(){var f;return(f=this.args.extensionDevelopmentKind)===null||f===void 0?void 0:f.map(c=>c==="ui"||c==="workspace"||c==="web"?c:"workspace")}get extensionTestsLocationURI(){const f=this.args.extensionTestsPath;if(f)return/^[^:/?#]+?:\/\//.test(f)?_.URI.parse(f):_.URI.file(E.normalize(f))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const f=this.args["disable-extension"];if(f){if(typeof f=="string")return[f];if(Array.isArray(f)&&f.length>0)return f}return!1}get debugExtensionHost(){return r(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!m.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return P.joinPath(_.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return _.URI.file(E.join(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}Ne([p.memoize],y.prototype,"appRoot",null),Ne([p.memoize],y.prototype,"userHome",null),Ne([p.memoize],y.prototype,"userDataPath",null),Ne([p.memoize],y.prototype,"appSettingsHome",null),Ne([p.memoize],y.prototype,"tmpDir",null),Ne([p.memoize],y.prototype,"userRoamingDataHome",null),Ne([p.memoize],y.prototype,"settingsResource",null),Ne([p.memoize],y.prototype,"userDataSyncHome",null),Ne([p.memoize],y.prototype,"userDataSyncLogResource",null),Ne([p.memoize],y.prototype,"sync",null),Ne([p.memoize],y.prototype,"machineSettingsResource",null),Ne([p.memoize],y.prototype,"globalStorageHome",null),Ne([p.memoize],y.prototype,"workspaceStorageHome",null),Ne([p.memoize],y.prototype,"keybindingsResource",null),Ne([p.memoize],y.prototype,"keyboardLayoutResource",null),Ne([p.memoize],y.prototype,"argvResource",null),Ne([p.memoize],y.prototype,"snippetsHome",null),Ne([p.memoize],y.prototype,"isExtensionDevelopment",null),Ne([p.memoize],y.prototype,"untitledWorkspacesHome",null),Ne([p.memoize],y.prototype,"installSourcePath",null),Ne([p.memoize],y.prototype,"builtinExtensionsPath",null),Ne([p.memoize],y.prototype,"extensionsPath",null),Ne([p.memoize],y.prototype,"extensionDevelopmentLocationURI",null),Ne([p.memoize],y.prototype,"extensionDevelopmentKind",null),Ne([p.memoize],y.prototype,"extensionTestsLocationURI",null),Ne([p.memoize],y.prototype,"debugExtensionHost",null),Ne([p.memoize],y.prototype,"serviceMachineIdResource",null),Ne([p.memoize],y.prototype,"telemetryLogResource",null),Ne([p.memoize],y.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=y;function r(b,f){return d(b["inspect-extensions"],b["inspect-brk-extensions"],5870,f,b.debugId)}e.parseExtensionHostPort=r;function k(b,f){return d(b["inspect-search"],b["inspect-brk-search"],5876,f)}e.parseSearchPort=k;function d(b,f,c,S,w){const h=Number(f||b)||(S?null:c),l=h?Boolean(!!f):!1;return{port:h,break:l,debugId:w}}}),define(le[56],ce([0,1,237,139,5]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const D={o:P.localize(0,null),e:P.localize(1,null),t:P.localize(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:P.localize(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:P.localize(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:P.localize(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:P.localize(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:P.localize(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:P.localize(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:P.localize(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:P.localize(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:P.localize(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:P.localize(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:P.localize(13,null)},"show-versions":{type:"boolean",cat:"e",description:P.localize(14,null)},category:{type:"string",cat:"e",description:P.localize(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:P.localize(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:P.localize(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:P.localize(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:P.localize(19,null)},verbose:{type:"boolean",cat:"t",description:P.localize(20,null)},log:{type:"string",cat:"t",args:"level",description:P.localize(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:P.localize(22,null)},"prof-startup":{type:"boolean",cat:"t",description:P.localize(23,null)},"prof-append-timers":{type:"string"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:P.localize(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:P.localize(25,null)},sync:{type:"string",cat:"t",description:P.localize(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:P.localize(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:P.localize(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:P.localize(29,null)},"max-memory":{type:"string",cat:"t",description:P.localize(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:P.localize(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const I={onUnknownOption:()=>{},onMultipleValues:()=>{}};function _(f,c,S=I){const w={},C=[],h=[];for(let i in c){const n=c[i];n.alias&&(w[i]=n.alias),n.type==="string"||n.type==="string[]"?(C.push(i),n.deprecates&&C.push(n.deprecates)):n.type==="boolean"&&(h.push(i),n.deprecates&&h.push(n.deprecates))}const l=E(f,{string:C,boolean:h,alias:w}),a={},t=l;a._=l._.map(i=>String(i)).filter(i=>i.length>0),delete t._;for(let i in c){const n=c[i];n.alias&&delete t[n.alias];let s=t[i];n.deprecates&&t.hasOwnProperty(n.deprecates)&&(s||(s=t[n.deprecates]),delete t[n.deprecates]),typeof s!="undefined"&&(n.type==="string[]"?s&&!Array.isArray(s)&&(s=[s]):n.type==="string"&&Array.isArray(s)&&(s=s.pop(),S.onMultipleValues(i,s)),a[i]=s),delete t[i]}for(let i in t)S.onUnknownOption(i);return a}e.parseArgs=_;function m(f,c){let S="";return c.args&&(Array.isArray(c.args)?S=` <${c.args.join("> <")}>`:S=` <${c.args}>`),c.alias?`-${c.alias} --${f}${S}`:`--${f}${S}`}function y(f,c){let S=0,w=[];for(const a in f){const t=f[a],i=m(a,t);S=Math.max(S,i.length),w.push([i,t.description])}let C=S+2+1;if(c-C<25)return w.reduce((a,t)=>a.concat([`  ${t[0]}`,`      ${t[1]}`]),[]);let h=c-C-1,l=[];for(const a of w){let t=a[0],i=k(a[1],h),n=r(C-t.length-2);l.push("  "+t+n+i[0]);for(let s=1;s<i.length;s++)l.push(r(C)+i[s])}return l}e.formatOptions=y;function r(f){return" ".repeat(f)}function k(f,c){let S=[];for(;f.length;){let w=f.length<c?f.length:f.lastIndexOf(" ",c),C=f.slice(0,w).trim();f=f.slice(w),S.push(C)}return S}function d(f,c,S,w,C=!0){const h=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${f} ${S}`];l.push(""),l.push(`${P.localize(32,null)}: ${c} [${P.localize(33,null)}][${P.localize(34,null)}...]`),l.push(""),C&&(p.isWindows?l.push(P.localize(35,null,c)):l.push(P.localize(36,null,c)),l.push(""));const a={};for(const t in w){const i=w[t];if(i.description&&i.cat){let n=a[i.cat];n||(a[i.cat]=n={}),n[t]=i}}for(let t in a){const i=t;let n=a[i];n&&(l.push(D[i]),l.push(...y(n,h)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=d;function b(f,c){return`${f||P.localize(37,null)}
${c||P.localize(38,null)}
${process.arch}`}e.buildVersionMessage=b}),function(){"use strict";function x(e,E,P,p){function D(_){const m=I(_),y=[m];return e.isAbsolute(m)||y.unshift(p),e.resolve(...y)}function I(_){const m=process.env.VSCODE_PORTABLE;if(m)return e.join(m,"user-data");const y=_["user-data-dir"];if(y)return y;let r=process.env.VSCODE_APPDATA;if(!r)switch(process.platform){case"win32":if(r=process.env.APPDATA,!r){const k=process.env.USERPROFILE;if(typeof k!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");r=e.join(k,"AppData","Roaming")}break;case"darwin":r=e.join(E.homedir(),"Library","Application Support");break;case"linux":r=process.env.XDG_CONFIG_HOME||e.join(E.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(r,P)}return{getUserDataPath:D}}if(typeof define=="function")define(le[165],ce([0,78,24,8,17,23]),function(e,E,P,p,D,I){const _=D.dirname(p.FileAccess.asFileUri("",e)),m=e.__$__nodeRequire(D.joinPath(_,"package.json").fsPath);return x(E,P,m.name,I.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),E=require("path"),P=require("os");module.exports=x(E,P,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(le[166],ce([0,1,24,165,164]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class D extends p.AbstractNativeEnvironmentService{constructor(_,m){super(_,{homeDir:E.homedir(),tmpDir:E.tmpdir(),userDataDir:P.getUserDataPath(_)},m)}}e.NativeEnvironmentService=D}),define(le[167],ce([0,1,7,4,53,19,2]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function _(f,c){return P.URI.revive(c?c.transformIncoming(f):f)}function m(f,c){return c?c.transformOutgoingURI(f):f}function y(f,c){c=c||p.DefaultURITransformer;const S=f.manifest,w=p.transformAndReviveIncomingURIs(Object.assign(Object.assign({},f),{manifest:void 0}),c);return Object.assign(Object.assign({},w),{manifest:S})}function r(f,c){return c?D.cloneAndChange(f,S=>S instanceof P.URI?c.transformOutgoingURI(S):void 0):f}class k{constructor(c,S){this.service=c,this.getUriTransformer=S,this.onInstallExtension=E.Event.buffer(c.onInstallExtension,!0),this.onDidInstallExtension=E.Event.buffer(c.onDidInstallExtension,!0),this.onUninstallExtension=E.Event.buffer(c.onUninstallExtension,!0),this.onDidUninstallExtension=E.Event.buffer(c.onDidUninstallExtension,!0)}listen(c,S){const w=this.getUriTransformer(c);switch(S){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtension":return E.Event.map(this.onDidInstallExtension,C=>Object.assign(Object.assign({},C),{local:C.local?r(C.local,w):C.local}));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(c,S,w){const C=this.getUriTransformer(c);switch(S){case"zip":return this.service.zip(y(w[0],C)).then(h=>m(h,C));case"unzip":return this.service.unzip(_(w[0],C));case"install":return this.service.install(_(w[0],C),w[1]);case"getManifest":return this.service.getManifest(_(w[0],C));case"canInstall":return this.service.canInstall(w[0]);case"installFromGallery":return this.service.installFromGallery(w[0],w[1]);case"uninstall":return this.service.uninstall(y(w[0],C),w[1]);case"reinstallFromGallery":return this.service.reinstallFromGallery(y(w[0],C));case"getInstalled":return this.service.getInstalled(w[0]).then(h=>h.map(l=>r(l,C)));case"updateMetadata":return this.service.updateMetadata(y(w[0],C),w[1]).then(h=>r(h,C));case"updateExtensionScope":return this.service.updateExtensionScope(y(w[0],C),w[1]).then(h=>r(h,C));case"getExtensionsReport":return this.service.getExtensionsReport()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=k;class d extends I.Disposable{constructor(c){super();this.channel=c,this._onInstallExtension=this._register(new E.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new E.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new E.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new E.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this._register(this.channel.listen("onInstallExtension")(S=>this._onInstallExtension.fire(S))),this._register(this.channel.listen("onDidInstallExtension")(S=>this._onDidInstallExtension.fire(Object.assign(Object.assign({},S),{local:S.local?y(S.local,null):S.local})))),this._register(this.channel.listen("onUninstallExtension")(S=>this._onUninstallExtension.fire(S))),this._register(this.channel.listen("onDidUninstallExtension")(S=>this._onDidUninstallExtension.fire(S)))}zip(c){return Promise.resolve(this.channel.call("zip",[c]).then(S=>P.URI.revive(S)))}unzip(c){return Promise.resolve(this.channel.call("unzip",[c]))}install(c,S){return Promise.resolve(this.channel.call("install",[c,S])).then(w=>y(w,null))}getManifest(c){return Promise.resolve(this.channel.call("getManifest",[c]))}async canInstall(c){return!0}installFromGallery(c,S){return Promise.resolve(this.channel.call("installFromGallery",[c,S])).then(w=>y(w,null))}uninstall(c,S){return Promise.resolve(this.channel.call("uninstall",[c,S]))}reinstallFromGallery(c){return Promise.resolve(this.channel.call("reinstallFromGallery",[c]))}getInstalled(c=null){return Promise.resolve(this.channel.call("getInstalled",[c])).then(S=>S.map(w=>y(w,null)))}updateMetadata(c,S){return Promise.resolve(this.channel.call("updateMetadata",[c,S])).then(w=>y(w,null))}updateExtensionScope(c,S){return Promise.resolve(this.channel.call("updateExtensionScope",[c,S])).then(w=>y(w,null))}getExtensionsReport(){return Promise.resolve(this.channel.call("getExtensionsReport"))}}e.ExtensionManagementChannelClient=d;class b{constructor(c){this.service=c}listen(c,S){throw new Error("Invalid listen")}call(c,S,w){switch(S){case"getConfigBasedTips":return this.service.getConfigBasedTips(P.URI.revive(w[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=b}),define(le[168],ce([0,1,19]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.localizeManifest=void 0;const P=/^%([\w\d.-]+)%$/i;function p(D,I){const _=m=>{if(typeof m!="string")return;const y=P.exec(m);if(!!y)return I[y[1]]||m};return E.cloneAndChange(D,_)}e.localizeManifest=p}),define(le[57],ce([0,1,146]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const P=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function D(d){return d=d.trim(),d==="*"||P.test(d)}e.isValidVersionStr=D;function I(d){if(!D(d))return null;if(d=d.trim(),d==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let b=d.match(P);return b?{hasCaret:b[1]==="^",hasGreaterEquals:b[1]===">=",majorBase:b[2]==="x"?0:parseInt(b[2],10),majorMustEqual:b[2]!=="x",minorBase:b[4]==="x"?0:parseInt(b[4],10),minorMustEqual:b[4]!=="x",patchBase:b[6]==="x"?0:parseInt(b[6],10),patchMustEqual:b[6]!=="x",preRelease:b[8]||null}:null}e.parseVersion=I;function _(d){if(!d)return null;let b=d.majorBase,f=d.majorMustEqual,c=d.minorBase,S=d.minorMustEqual,w=d.patchBase,C=d.patchMustEqual;d.hasCaret&&(b===0||(S=!1),C=!1);let h=0;if(d.preRelease){const l=p.exec(d.preRelease);if(l){const[,a,t,i]=l;h=Date.UTC(Number(a),Number(t)-1,Number(i))}}return{majorBase:b,majorMustEqual:f,minorBase:c,minorMustEqual:S,patchBase:w,patchMustEqual:C,isMinimum:d.hasGreaterEquals,notBefore:h}}e.normalizeVersion=_;function m(d,b,f){let c;typeof d=="string"?c=_(I(d)):c=d;let S;b instanceof Date?S=b.getTime():typeof b=="string"&&(S=new Date(b).getTime());let w;if(typeof f=="string"?w=_(I(f)):w=f,!c||!w)return!1;let C=c.majorBase,h=c.minorBase,l=c.patchBase,a=w.majorBase,t=w.minorBase,i=w.patchBase,n=w.notBefore,s=w.majorMustEqual,u=w.minorMustEqual,g=w.patchMustEqual;return w.isMinimum?C>a?!0:C<a?!1:h>t?!0:h<t||S&&S<n?!1:l>=i:(C===1&&a===0&&(!s||!u||!g)&&(a=1,t=0,i=0,s=!0,u=!1,g=!1),C<a?!1:C>a?!s:h<t?!1:h>t?!u:l<i?!1:l>i?!g:!(S&&S<n))}e.isValidVersion=m;function y(d,b,f,c){return f.isBuiltin||typeof f.main=="undefined"?!0:k(d,b,f.engines.vscode,c)}e.isValidExtensionVersion=y;function r(d,b,f){return d==="*"||k(b,f,d)}e.isEngineValid=r;function k(d,b,f,c=[]){let S=_(I(f));if(!S)return c.push(E.localize(0,null,f)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return c.push(E.localize(1,null,f)),!1}else if(!S.majorMustEqual)return c.push(E.localize(2,null,f)),!1;return m(d,b,S)?!0:(c.push(E.localize(3,null,d,f)),!1)}}),define(le[169],ce([0,1,7,2,4,22,18,42,12,43]),function(x,e,E,P,p,D,I,_,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCFileSystemProvider=void 0;class r extends P.Disposable{constructor(d){super();this.channel=d,this.session=D.generateUuid(),this._onDidChange=this._register(new E.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchErrorOccur=this._register(new E.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeCapabilities=this._register(new E.Emitter),this.onDidChangeCapabilities=this._onDidChangeCapabilities.event,this._capabilities=2|4|16|8|8192,this.registerListeners()}get capabilities(){return this._capabilities}registerListeners(){this._register(this.channel.listen("filechange",[this.session])(d=>{if(Array.isArray(d)){const b=d;this._onDidChange.fire(b.map(f=>({resource:p.URI.revive(f.resource),type:f.type})))}else{const b=d;this._onDidWatchErrorOccur.fire(b)}}))}setCaseSensitive(d){d?this._capabilities|=1024:this._capabilities&=~1024,this._onDidChangeCapabilities.fire(void 0)}stat(d){return this.channel.call("stat",[d])}open(d,b){return this.channel.call("open",[d,b])}close(d){return this.channel.call("close",[d])}async read(d,b,f,c,S){const[w,C]=await this.channel.call("read",[d,b,S]);return f.set(w.buffer.slice(0,C),c),C}async readFile(d){return(await this.channel.call("readFile",[d])).buffer}readFileStream(d,b,f){const c=_.newWriteableStream(w=>I.VSBuffer.concat(w.map(C=>I.VSBuffer.wrap(C))).buffer),S=this.channel.listen("readFileStream",[d,b])(w=>{if(w instanceof I.VSBuffer)c.write(w.buffer);else{if(w==="end")c.end();else{let C=w;C instanceof Error||(C=new Error(y.toErrorMessage(C))),c.error(C),c.end()}S.dispose()}});return f.onCancellationRequested(()=>{c.error(m.canceled()),c.end(),S.dispose()}),c}write(d,b,f,c,S){return this.channel.call("write",[d,b,I.VSBuffer.wrap(f),c,S])}writeFile(d,b,f){return this.channel.call("writeFile",[d,I.VSBuffer.wrap(b),f])}delete(d,b){return this.channel.call("delete",[d,b])}mkdir(d){return this.channel.call("mkdir",[d])}readdir(d){return this.channel.call("readdir",[d])}rename(d,b,f){return this.channel.call("rename",[d,b,f])}copy(d,b,f){return this.channel.call("copy",[d,b,f])}watch(d,b){const f=Math.random();return this.channel.call("watch",[this.session,f,d,b]),P.toDisposable(()=>this.channel.call("unwatch",[this.session,f]))}}e.IPCFileSystemProvider=r}),define(le[170],ce([0,1,36,55,2,8]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends p.Disposable{constructor(m,y,r,k){super();this.folders=m,this.onDidFilesChange=y,this.onLogMessage=r,this.verboseLogging=k,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService(E.getNextTickChannel(m.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.setFolders(this.folders)}setVerboseLogging(m){this.verboseLogging=m,!this.isDisposed&&this.service&&this.service.setVerboseLogging(m)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${m}`})}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(le[171],ce([0,1,36,55,2,8]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class I extends p.Disposable{constructor(m,y,r,k,d={}){super();this.folders=m,this.onDidFilesChange=y,this.onLogMessage=r,this.verboseLogging=k,this.watcherOptions=d,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const m=this._register(new P.Client(D.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(m.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=I.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=E.ProxyChannel.toService(E.getNextTickChannel(m.getChannel("watcher"))),this.service.init(Object.assign(Object.assign({},this.watcherOptions),{verboseLogging:this.verboseLogging})),this._register(this.service.onDidChangeFile(y=>!this.isDisposed&&this.onDidFilesChange(y))),this._register(this.service.onDidLogMessage(y=>this.onLogMessage(y))),this.service.setRoots(this.folders)}error(m){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${m}`})}setVerboseLogging(m){this.verboseLogging=m,this.service&&this.service.setVerboseLogging(m)}setFolders(m){this.folders=m,this.service&&this.service.setRoots(m)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=I,I.MAX_RESTARTS=5}),define(le[172],ce([0,1,35,77,47,8]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OutOfProcessWin32FolderWatcher=void 0;class I{constructor(m,y,r,k,d){this.watchedFolder=m,this.eventCallback=r,this.logCallback=k,this.verboseLogging=d,this.restartCounter=0,Array.isArray(y)?this.ignored=y.map(b=>p.parse(b)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${m}`),this.startWatcher()}startWatcher(){const m=[this.watchedFolder];this.verboseLogging&&m.push("-verbose"),this.handle=E.spawn(D.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",x).fsPath,m);const y=new P.LineDecoder;this.handle.stdout.on("data",r=>{const k=[];y.write(r).forEach(d=>{const b=d.split("|");if(b.length===2){const f=Number(b[0]),c=b[1];if(f>=0&&f<3){if(this.ignored&&this.ignored.some(S=>S(c))){this.verboseLogging&&this.log(c);return}k.push({type:I.changeTypeMap[f],path:c})}else this.log(b[1])}}),k.length>0&&this.eventCallback(k)}),this.handle.on("error",r=>this.onError(r)),this.handle.stderr.on("data",r=>this.onError(r)),this.handle.on("exit",(r,k)=>this.onExit(r,k))}onError(m){this.error("process error: "+m.toString())}onExit(m,y){this.handle&&(this.error(`terminated unexpectedly (code: ${m}, signal: ${y})`),this.restartCounter<=I.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(m){this.logCallback({type:"error",message:`[File Watcher (C#)] ${m}`})}log(m){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${m}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}e.OutOfProcessWin32FolderWatcher=I,I.MAX_RESTARTS=5,I.changeTypeMap=[0,1,2]}),define(le[173],ce([0,1,172,3,13]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class D{constructor(_,m,y,r){this.onDidFilesChange=m,this.onLogMessage=y,this.verboseLogging=r,this.service=void 0,this.folder=_[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(P.posix.sep)&&(this.folder.path=p.rtrim(this.folder.path,P.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new E.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,_=>this.onFileEvents(_),_=>this.onLogMessage(_),this.verboseLogging)}setVerboseLogging(_){this.verboseLogging=_,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(_){this.isDisposed||_.length>0&&this.onDidFilesChange(_)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}e.FileWatcher=D}),define(le[58],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createSyncDescriptor=e.SyncDescriptor=void 0;class E{constructor(D,I=[],_=!1){this.ctor=D,this.staticArguments=I,this.supportsDelayedInstantiation=_}}e.SyncDescriptor=E;const P=(p,...D)=>new E(p,D);e.createSyncDescriptor=P}),define(le[174],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class E{constructor(D){this.incoming=new Map,this.outgoing=new Map,this.data=D}}e.Node=E;class P{constructor(D){this._hashFn=D,this._nodes=new Map}roots(){const D=[];for(let I of this._nodes.values())I.outgoing.size===0&&D.push(I);return D}insertEdge(D,I){const _=this.lookupOrInsertNode(D),m=this.lookupOrInsertNode(I);_.outgoing.set(this._hashFn(I),m),m.incoming.set(this._hashFn(D),_)}removeNode(D){const I=this._hashFn(D);this._nodes.delete(I);for(let _ of this._nodes.values())_.outgoing.delete(I),_.incoming.delete(I)}lookupOrInsertNode(D){const I=this._hashFn(D);let _=this._nodes.get(I);return _||(_=new E(D),this._nodes.set(I,_)),_}lookup(D){return this._nodes.get(this._hashFn(D))}isEmpty(){return this._nodes.size===0}toString(){let D=[];for(let[I,_]of this._nodes)D.push(`${I}, (incoming)[${[..._.incoming.keys()].join(", ")}], (outgoing)[${[..._.outgoing.keys()].join(",")}]`);return D.join(`
`)}findCycleSlow(){for(let[D,I]of this._nodes){const _=new Set([D]),m=this._findCycle(I,_);if(m)return m}}_findCycle(D,I){for(let[_,m]of D.outgoing){if(I.has(_))return[...I,_].join(" -> ");I.add(_);const y=this._findCycle(m,I);if(y)return y;I.delete(_)}}}e.Graph=P}),define(le[6],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var E;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function m(y){return y[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=m})(E=e._util||(e._util={})),e.IInstantiationService=p("instantiationService");function P(_,m,y,r){m[E.DI_TARGET]===m?m[E.DI_DEPENDENCIES].push({id:_,index:y,optional:r}):(m[E.DI_DEPENDENCIES]=[{id:_,index:y,optional:r}],m[E.DI_TARGET]=m)}function p(_){if(E.serviceIds.has(_))return E.serviceIds.get(_);const m=function(y,r,k){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");P(m,y,k,!1)};return m.toString=()=>_,E.serviceIds.set(_,m),m}e.createDecorator=p;function D(_){return _}e.refineServiceDecorator=D;function I(_){return function(m,y,r){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");P(_,m,r,!0)}}e.optional=I}),define(le[175],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=E.createDecorator("modelService");function P(p){return!p.isTooLargeForSyncing()&&!p.isForSimpleWidget}e.shouldSynchronizeModel=P}),define(le[176],ce([0,1,7,117,2,26,114,128,175]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function y(d){return typeof d=="string"?!1:Array.isArray(d)?d.every(y):!!d.exclusive}class r{constructor(){this._clock=0,this._entries=[],this._onDidChange=new E.Emitter}get onDidChange(){return this._onDidChange.event}register(b,f){let c={selector:b,provider:f,_score:-1,_time:this._clock++};return this._entries.push(c),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),p.toDisposable(()=>{if(c){let S=this._entries.indexOf(c);S>=0&&(this._entries.splice(S,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),c=void 0)}})}has(b){return this.all(b).length>0}all(b){if(!b)return[];this._updateScores(b);const f=[];for(let c of this._entries)c._score>0&&f.push(c.provider);return f}ordered(b){const f=[];return this._orderedForEach(b,c=>f.push(c.provider)),f}orderedGroups(b){const f=[];let c,S;return this._orderedForEach(b,w=>{c&&S===w._score?c.push(w.provider):(S=w._score,c=[w.provider],f.push(c))}),f}_orderedForEach(b,f){if(!!b){this._updateScores(b);for(const c of this._entries)c._score>0&&f(c)}}_updateScores(b){let f={uri:b.uri.toString(),language:b.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===f.language&&this._lastCandidate.uri===f.uri)){this._lastCandidate=f;for(let c of this._entries)if(c._score=_.score(c.selector,b.uri,b.getLanguageIdentifier().language,m.shouldSynchronizeModel(b)),y(c.selector)&&c._score>0){for(let S of this._entries)S._score=0;c._score=1e3;break}this._entries.sort(r._compareByScoreAndTime)}}static _compareByScoreAndTime(b,f){return b._score<f._score?1:b._score>f._score?-1:b._time<f._time?1:b._time>f._time?-1:0}}e.LanguageFeatureRegistry=r;class k{constructor(b,f,c=Number.MAX_SAFE_INTEGER){this._registry=b,this.min=f,this.max=c,this._cache=new D.LRUCache(50,.7)}_key(b){return b.id+P.hash(this._registry.all(b))}_clamp(b){return b===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(b*1.3)))}get(b){const f=this._key(b),c=this._cache.get(f);return this._clamp(c==null?void 0:c.value)}update(b,f){const c=this._key(b);let S=this._cache.get(c);return S||(S=new I.MovingAverage,this._cache.set(c,S)),S.update(f),this.get(b)}}e.LanguageFeatureRequestDelays=k}),define(le[177],ce([0,1,4,54,176,129,41]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var _;(function(o){o[o.Null=0]="Null",o[o.PlainText=1]="PlainText"})(_=e.LanguageId||(e.LanguageId={}));class m{constructor(F,B){this.language=F,this.id=B}}e.LanguageIdentifier=m;var y;(function(o){o[o.NotSet=-1]="NotSet",o[o.None=0]="None",o[o.Italic=1]="Italic",o[o.Bold=2]="Bold",o[o.Underline=4]="Underline"})(y=e.FontStyle||(e.FontStyle={}));var r;(function(o){o[o.None=0]="None",o[o.DefaultForeground=1]="DefaultForeground",o[o.DefaultBackground=2]="DefaultBackground"})(r=e.ColorId||(e.ColorId={}));var k;(function(o){o[o.Other=0]="Other",o[o.Comment=1]="Comment",o[o.String=2]="String",o[o.RegEx=4]="RegEx"})(k=e.StandardTokenType||(e.StandardTokenType={}));var d;(function(o){o[o.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",o[o.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",o[o.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",o[o.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",o[o.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",o[o.ITALIC_MASK=2048]="ITALIC_MASK",o[o.BOLD_MASK=4096]="BOLD_MASK",o[o.UNDERLINE_MASK=8192]="UNDERLINE_MASK",o[o.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",o[o.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",o[o.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",o[o.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",o[o.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",o[o.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",o[o.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",o[o.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",o[o.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",o[o.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(d=e.MetadataConsts||(e.MetadataConsts={}));class b{static getLanguageId(F){return(F&255)>>>0}static getTokenType(F){return(F&1792)>>>8}static getFontStyle(F){return(F&14336)>>>11}static getForeground(F){return(F&8372224)>>>14}static getBackground(F){return(F&4286578688)>>>23}static getClassNameFromMetadata(F){let B=this.getForeground(F),Z="mtk"+B,ie=this.getFontStyle(F);return ie&1&&(Z+=" mtki"),ie&2&&(Z+=" mtkb"),ie&4&&(Z+=" mtku"),Z}static getInlineStyleFromMetadata(F,B){const Z=this.getForeground(F),ie=this.getFontStyle(F);let Se=`color: ${B[Z]};`;return ie&1&&(Se+="font-style: italic;"),ie&2&&(Se+="font-weight: bold;"),ie&4&&(Se+="text-decoration: underline;"),Se}}e.TokenMetadata=b;var f;(function(o){o[o.Method=0]="Method",o[o.Function=1]="Function",o[o.Constructor=2]="Constructor",o[o.Field=3]="Field",o[o.Variable=4]="Variable",o[o.Class=5]="Class",o[o.Struct=6]="Struct",o[o.Interface=7]="Interface",o[o.Module=8]="Module",o[o.Property=9]="Property",o[o.Event=10]="Event",o[o.Operator=11]="Operator",o[o.Unit=12]="Unit",o[o.Value=13]="Value",o[o.Constant=14]="Constant",o[o.Enum=15]="Enum",o[o.EnumMember=16]="EnumMember",o[o.Keyword=17]="Keyword",o[o.Text=18]="Text",o[o.Color=19]="Color",o[o.File=20]="File",o[o.Reference=21]="Reference",o[o.Customcolor=22]="Customcolor",o[o.Folder=23]="Folder",o[o.TypeParameter=24]="TypeParameter",o[o.User=25]="User",o[o.Issue=26]="Issue",o[o.Snippet=27]="Snippet"})(f=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let o=Object.create(null);return o[0]="symbol-method",o[1]="symbol-function",o[2]="symbol-constructor",o[3]="symbol-field",o[4]="symbol-variable",o[5]="symbol-class",o[6]="symbol-struct",o[7]="symbol-interface",o[8]="symbol-module",o[9]="symbol-property",o[10]="symbol-event",o[11]="symbol-operator",o[12]="symbol-unit",o[13]="symbol-value",o[14]="symbol-constant",o[15]="symbol-enum",o[16]="symbol-enum-member",o[17]="symbol-keyword",o[27]="symbol-snippet",o[18]="symbol-text",o[19]="symbol-color",o[20]="symbol-file",o[21]="symbol-reference",o[22]="symbol-customcolor",o[23]="symbol-folder",o[24]="symbol-type-parameter",o[25]="account",o[26]="issues",function(F){const B=o[F];let Z=B&&I.iconRegistry.get(B);return Z||(console.info("No codicon found for CompletionItemKind "+F),Z=I.Codicon.symbolProperty),Z.classNames}}(),e.completionKindFromString=function(){let o=Object.create(null);return o.method=0,o.function=1,o.constructor=2,o.field=3,o.variable=4,o.class=5,o.struct=6,o.interface=7,o.module=8,o.property=9,o.event=10,o.operator=11,o.unit=12,o.value=13,o.constant=14,o.enum=15,o["enum-member"]=16,o.enumMember=16,o.keyword=17,o.snippet=27,o.text=18,o.color=19,o.file=20,o.reference=21,o.customcolor=22,o.folder=23,o["type-parameter"]=24,o.typeParameter=24,o.account=25,o.issue=26,function(F,B){let Z=o[F];return typeof Z=="undefined"&&!B&&(Z=9),Z}}();var c;(function(o){o[o.Deprecated=1]="Deprecated"})(c=e.CompletionItemTag||(e.CompletionItemTag={}));var S;(function(o){o[o.KeepWhitespace=1]="KeepWhitespace",o[o.InsertAsSnippet=4]="InsertAsSnippet"})(S=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var w;(function(o){o[o.Invoke=0]="Invoke",o[o.TriggerCharacter=1]="TriggerCharacter",o[o.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(w=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var C;(function(o){o[o.Automatic=0]="Automatic",o[o.Explicit=1]="Explicit"})(C=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var h;(function(o){o[o.Invoke=1]="Invoke",o[o.Auto=2]="Auto"})(h=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var l;(function(o){o[o.Invoke=1]="Invoke",o[o.TriggerCharacter=2]="TriggerCharacter",o[o.ContentChange=3]="ContentChange"})(l=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var a;(function(o){o[o.Text=0]="Text",o[o.Read=1]="Read",o[o.Write=2]="Write"})(a=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function t(o){return o&&E.URI.isUri(o.uri)&&P.Range.isIRange(o.range)&&(P.Range.isIRange(o.originSelectionRange)||P.Range.isIRange(o.targetSelectionRange))}e.isLocationLink=t;var i;(function(o){o[o.File=0]="File",o[o.Module=1]="Module",o[o.Namespace=2]="Namespace",o[o.Package=3]="Package",o[o.Class=4]="Class",o[o.Method=5]="Method",o[o.Property=6]="Property",o[o.Field=7]="Field",o[o.Constructor=8]="Constructor",o[o.Enum=9]="Enum",o[o.Interface=10]="Interface",o[o.Function=11]="Function",o[o.Variable=12]="Variable",o[o.Constant=13]="Constant",o[o.String=14]="String",o[o.Number=15]="Number",o[o.Boolean=16]="Boolean",o[o.Array=17]="Array",o[o.Object=18]="Object",o[o.Key=19]="Key",o[o.Null=20]="Null",o[o.EnumMember=21]="EnumMember",o[o.Struct=22]="Struct",o[o.Event=23]="Event",o[o.Operator=24]="Operator",o[o.TypeParameter=25]="TypeParameter"})(i=e.SymbolKind||(e.SymbolKind={}));var n;(function(o){o[o.Deprecated=1]="Deprecated"})(n=e.SymbolTag||(e.SymbolTag={}));var s;(function(o){const F=new Map;F.set("file",0),F.set("module",1),F.set("namespace",2),F.set("package",3),F.set("class",4),F.set("method",5),F.set("property",6),F.set("field",7),F.set("constructor",8),F.set("enum",9),F.set("interface",10),F.set("function",11),F.set("variable",12),F.set("constant",13),F.set("string",14),F.set("number",15),F.set("boolean",16),F.set("array",17),F.set("object",18),F.set("key",19),F.set("null",20),F.set("enum-member",21),F.set("struct",22),F.set("event",23),F.set("operator",24),F.set("type-parameter",25);const B=new Map;B.set(0,"file"),B.set(1,"module"),B.set(2,"namespace"),B.set(3,"package"),B.set(4,"class"),B.set(5,"method"),B.set(6,"property"),B.set(7,"field"),B.set(8,"constructor"),B.set(9,"enum"),B.set(10,"interface"),B.set(11,"function"),B.set(12,"variable"),B.set(13,"constant"),B.set(14,"string"),B.set(15,"number"),B.set(16,"boolean"),B.set(17,"array"),B.set(18,"object"),B.set(19,"key"),B.set(20,"null"),B.set(21,"enum-member"),B.set(22,"struct"),B.set(23,"event"),B.set(24,"operator"),B.set(25,"type-parameter");function Z(oe){return F.get(oe)}o.fromString=Z;function ie(oe){return B.get(oe)}o.toString=ie;function Se(oe,q){const ee=B.get(oe);let G=ee&&I.iconRegistry.get("symbol-"+ee);return G||(console.info("No codicon found for SymbolKind "+oe),G=I.Codicon.symbolProperty),`${q?"inline":"block"} ${G.classNames}`}o.toCssClassName=Se})(s=e.SymbolKinds||(e.SymbolKinds={}));class u{constructor(F){this.value=F}}e.FoldingRangeKind=u,u.Comment=new u("comment"),u.Imports=new u("imports"),u.Region=new u("region");var g;(function(o){o[o.Collapsed=0]="Collapsed",o[o.Expanded=1]="Expanded"})(g=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var v;(function(o){o[o.Editing=0]="Editing",o[o.Preview=1]="Preview"})(v=e.CommentMode||(e.CommentMode={}));var T;(function(o){o[o.Other=0]="Other",o[o.Type=1]="Type",o[o.Parameter=2]="Parameter"})(T=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new p.LanguageFeatureRegistry,e.RenameProviderRegistry=new p.LanguageFeatureRegistry,e.CompletionProviderRegistry=new p.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new p.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new p.LanguageFeatureRegistry,e.HoverProviderRegistry=new p.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new p.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new p.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new p.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new p.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new p.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new p.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new p.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new p.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new p.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new p.LanguageFeatureRegistry,e.LinkProviderRegistry=new p.LanguageFeatureRegistry,e.ColorProviderRegistry=new p.LanguageFeatureRegistry,e.SelectionRangeRegistry=new p.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new p.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new p.LanguageFeatureRegistry,e.TokenizationRegistry=new D.TokenizationRegistryImpl;var R;(function(o){o[o.None=0]="None",o[o.Option=1]="Option",o[o.Default=2]="Default",o[o.Preferred=3]="Preferred"})(R=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(le[59],ce([0,1,13,6,5]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let D=p.userAgent||"";const I=new Map;I.set("false",!1),I.set("true",!0),I.set("isMac",p.isMacintosh),I.set("isLinux",p.isLinux),I.set("isWindows",p.isWindows),I.set("isWeb",p.isWeb),I.set("isMacNative",p.isMacintosh&&!p.isWeb),I.set("isEdge",D.indexOf("Edg/")>=0),I.set("isFirefox",D.indexOf("Firefox")>=0),I.set("isChrome",D.indexOf("Chrome")>=0),I.set("isSafari",D.indexOf("Safari")>=0);const _=Object.prototype.hasOwnProperty;var m;(function(R){R[R.False=0]="False",R[R.True=1]="True",R[R.Defined=2]="Defined",R[R.Not=3]="Not",R[R.Equals=4]="Equals",R[R.NotEquals=5]="NotEquals",R[R.And=6]="And",R[R.Regex=7]="Regex",R[R.NotRegex=8]="NotRegex",R[R.Or=9]="Or",R[R.In=10]="In",R[R.NotIn=11]="NotIn",R[R.Greater=12]="Greater",R[R.GreaterEquals=13]="GreaterEquals",R[R.Smaller=14]="Smaller",R[R.SmallerEquals=15]="SmallerEquals"})(m=e.ContextKeyExprType||(e.ContextKeyExprType={}));class y{static false(){return k.INSTANCE}static true(){return d.INSTANCE}static has(o){return b.create(o)}static equals(o,F){return f.create(o,F)}static notEquals(o,F){return w.create(o,F)}static regex(o,F){return i.create(o,F)}static in(o,F){return c.create(o,F)}static not(o){return C.create(o)}static and(...o){return s.create(o)}static or(...o){return u.create(o)}static greater(o,F){return h.create(o,F)}static less(o,F){return a.create(o,F)}static deserialize(o,F=!1){if(!!o)return this._deserializeOrExpression(o,F)}static _deserializeOrExpression(o,F){let B=o.split("||");return u.create(B.map(Z=>this._deserializeAndExpression(Z,F)))}static _deserializeAndExpression(o,F){let B=o.split("&&");return s.create(B.map(Z=>this._deserializeOne(Z,F)))}static _deserializeOne(o,F){if(o=o.trim(),o.indexOf("!=")>=0){let B=o.split("!=");return w.create(B[0].trim(),this._deserializeValue(B[1],F))}if(o.indexOf("==")>=0){let B=o.split("==");return f.create(B[0].trim(),this._deserializeValue(B[1],F))}if(o.indexOf("=~")>=0){let B=o.split("=~");return i.create(B[0].trim(),this._deserializeRegexValue(B[1],F))}if(o.indexOf(" in ")>=0){let B=o.split(" in ");return c.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(o)){const B=o.split(">=");return l.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(o)){const B=o.split(">");return h.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(o)){const B=o.split("<=");return t.create(B[0].trim(),B[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(o)){const B=o.split("<");return a.create(B[0].trim(),B[1].trim())}return/^\!\s*/.test(o)?C.create(o.substr(1).trim()):b.create(o)}static _deserializeValue(o,F){if(o=o.trim(),o==="true")return!0;if(o==="false")return!1;let B=/^'([^']*)'$/.exec(o);return B?B[1].trim():o}static _deserializeRegexValue(o,F){if(E.isFalsyOrWhitespace(o)){if(F)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let B=o.indexOf("/"),Z=o.lastIndexOf("/");if(B===Z||B<0){if(F)throw new Error(`bad regexp-value '${o}', missing /-enclosure`);return console.warn(`bad regexp-value '${o}', missing /-enclosure`),null}let ie=o.slice(B+1,Z),Se=o[Z+1]==="i"?"i":"";try{return new RegExp(ie,Se)}catch(oe){if(F)throw new Error(`bad regexp-value '${o}', parse error: ${oe}`);return console.warn(`bad regexp-value '${o}', parse error: ${oe}`),null}}}e.ContextKeyExpr=y;function r(R,o){return R.cmp(o)}class k{constructor(){this.type=0}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!1}serialize(){return"false"}keys(){return[]}map(o){return this}negate(){return d.INSTANCE}}e.ContextKeyFalseExpr=k,k.INSTANCE=new k;class d{constructor(){this.type=1}cmp(o){return this.type-o.type}equals(o){return o.type===this.type}evaluate(o){return!0}serialize(){return"true"}keys(){return[]}map(o){return this}negate(){return k.INSTANCE}}e.ContextKeyTrueExpr=d,d.INSTANCE=new d;class b{constructor(o){this.key=o,this.type=2}static create(o){const F=I.get(o);return typeof F=="boolean"?F?d.INSTANCE:k.INSTANCE:new b(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!!o.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(o){return o.mapDefined(this.key)}negate(){return C.create(this.key)}}e.ContextKeyDefinedExpr=b;class f{constructor(o,F){this.key=o,this.value=F,this.type=4}static create(o,F){if(typeof F=="boolean")return F?b.create(o):C.create(o);const B=I.get(o);return typeof B=="boolean"?F===(B?"true":"false")?d.INSTANCE:k.INSTANCE:new f(o,F)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(o){return o.mapEquals(this.key,this.value)}negate(){return w.create(this.key,this.value)}}e.ContextKeyEqualsExpr=f;class c{constructor(o,F){this.key=o,this.valueKey=F,this.type=10}static create(o,F){return new c(o,F)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.valueKey,o.key,o.valueKey)}equals(o){return o.type===this.type?this.key===o.key&&this.valueKey===o.valueKey:!1}evaluate(o){const F=o.getValue(this.valueKey),B=o.getValue(this.key);return Array.isArray(F)?F.indexOf(B)>=0:typeof B=="string"&&typeof F=="object"&&F!==null?_.call(F,B):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(o){return o.mapIn(this.key,this.valueKey)}negate(){return S.create(this)}}e.ContextKeyInExpr=c;class S{constructor(o){this._actual=o,this.type=11}static create(o){return new S(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new S(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotInExpr=S;class w{constructor(o,F){this.key=o,this.value=F,this.type=5}static create(o,F){if(typeof F=="boolean")return F?C.create(o):b.create(o);const B=I.get(o);return typeof B=="boolean"?F===(B?"true":"false")?k.INSTANCE:d.INSTANCE:new w(o,F)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return o.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(o){return o.mapNotEquals(this.key,this.value)}negate(){return f.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=w;class C{constructor(o){this.key=o,this.type=3}static create(o){const F=I.get(o);return typeof F=="boolean"?F?k.INSTANCE:d.INSTANCE:new C(o)}cmp(o){return o.type!==this.type?this.type-o.type:v(this.key,o.key)}equals(o){return o.type===this.type?this.key===o.key:!1}evaluate(o){return!o.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(o){return o.mapNot(this.key)}negate(){return b.create(this.key)}}e.ContextKeyNotExpr=C;class h{constructor(o,F){this.key=o,this.value=F,this.type=12}static create(o,F){return new h(o,F)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreater(this.key,this.value)}negate(){return t.create(this.key,this.value)}}e.ContextKeyGreaterExpr=h;class l{constructor(o,F){this.key=o,this.value=F,this.type=13}static create(o,F){return new l(o,F)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(o){return o.mapGreaterEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=l;class a{constructor(o,F){this.key=o,this.value=F,this.type=14}static create(o,F){return new a(o,F)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmaller(this.key,this.value)}negate(){return l.create(this.key,this.value)}}e.ContextKeySmallerExpr=a;class t{constructor(o,F){this.key=o,this.value=F,this.type=15}static create(o,F){return new t(o,F)}cmp(o){return o.type!==this.type?this.type-o.type:T(this.key,this.value,o.key,o.value)}equals(o){return o.type===this.type?this.key===o.key&&this.value===o.value:!1}evaluate(o){return parseFloat(o.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(o){return o.mapSmallerEquals(this.key,this.value)}negate(){return h.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=t;class i{constructor(o,F){this.key=o,this.regexp=F,this.type=7}static create(o,F){return new i(o,F)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.key<o.key)return-1;if(this.key>o.key)return 1;const F=this.regexp?this.regexp.source:"",B=o.regexp?o.regexp.source:"";return F<B?-1:F>B?1:0}equals(o){if(o.type===this.type){const F=this.regexp?this.regexp.source:"",B=o.regexp?o.regexp.source:"";return this.key===o.key&&F===B}return!1}evaluate(o){let F=o.getValue(this.key);return this.regexp?this.regexp.test(F):!1}serialize(){const o=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${o}`}keys(){return[this.key]}map(o){return o.mapRegex(this.key,this.regexp)}negate(){return n.create(this)}}e.ContextKeyRegexExpr=i;class n{constructor(o){this._actual=o,this.type=8}static create(o){return new n(o)}cmp(o){return o.type!==this.type?this.type-o.type:this._actual.cmp(o._actual)}equals(o){return o.type===this.type?this._actual.equals(o._actual):!1}evaluate(o){return!this._actual.evaluate(o)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(o){return new n(this._actual.map(o))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=n;class s{constructor(o){this.expr=o,this.type=6}static create(o){return s._normalizeArr(o)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Z=r(this.expr[F],o.expr[F]);if(Z!==0)return Z}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(o.expr[F]))return!1;return!0}return!1}evaluate(o){for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].evaluate(o))return!1;return!0}static _normalizeArr(o){const F=[];let B=!1;for(const Z of o)if(!!Z){if(Z.type===1){B=!0;continue}if(Z.type===0)return k.INSTANCE;if(Z.type===6){F.push(...Z.expr);continue}F.push(Z)}if(F.length===0&&B)return d.INSTANCE;if(F.length!==0){if(F.length===1)return F[0];for(F.sort(r);F.length>1;){const Z=F[F.length-1];if(Z.type!==9)break;F.pop();const ie=F.pop(),Se=u.create(Z.expr.map(oe=>s.create([oe,ie])));Se&&(F.push(Se),F.sort(r))}return F.length===1?F[0]:new s(F)}}serialize(){return this.expr.map(o=>o.serialize()).join(" && ")}keys(){const o=[];for(let F of this.expr)o.push(...F.keys());return o}map(o){return new s(this.expr.map(F=>F.map(o)))}negate(){let o=[];for(let F of this.expr)o.push(F.negate());return u.create(o)}}e.ContextKeyAndExpr=s;class u{constructor(o){this.expr=o,this.type=9}static create(o){const F=u._normalizeArr(o);if(F.length!==0)return F.length===1?F[0]:new u(F)}cmp(o){if(o.type!==this.type)return this.type-o.type;if(this.expr.length<o.expr.length)return-1;if(this.expr.length>o.expr.length)return 1;for(let F=0,B=this.expr.length;F<B;F++){const Z=r(this.expr[F],o.expr[F]);if(Z!==0)return Z}return 0}equals(o){if(o.type===this.type){if(this.expr.length!==o.expr.length)return!1;for(let F=0,B=this.expr.length;F<B;F++)if(!this.expr[F].equals(o.expr[F]))return!1;return!0}return!1}evaluate(o){for(let F=0,B=this.expr.length;F<B;F++)if(this.expr[F].evaluate(o))return!0;return!1}static _normalizeArr(o){let F=[],B=!1;if(o){for(let Z=0,ie=o.length;Z<ie;Z++){const Se=o[Z];if(!!Se){if(Se.type===0){B=!0;continue}if(Se.type===1)return[d.INSTANCE];if(Se.type===9){F=F.concat(Se.expr);continue}F.push(Se)}}if(F.length===0&&B)return[k.INSTANCE];F.sort(r)}return F}serialize(){return this.expr.map(o=>o.serialize()).join(" || ")}keys(){const o=[];for(let F of this.expr)o.push(...F.keys());return o}map(o){return new u(this.expr.map(F=>F.map(o)))}negate(){let o=[];for(let B of this.expr)o.push(B.negate());const F=B=>B.type===9?B.expr:[B];for(;o.length>1;){const B=o.shift(),Z=o.shift(),ie=[];for(const Se of F(B))for(const oe of F(Z))ie.push(y.and(Se,oe));o.unshift(y.or(...ie))}return o[0]}}e.ContextKeyOrExpr=u;class g extends b{constructor(o,F,B){super(o);this._defaultValue=F,typeof B=="object"?g._info.push(Object.assign(Object.assign({},B),{key:o})):B!==!0&&g._info.push({key:o,description:B,type:F!=null?typeof F:void 0})}static all(){return g._info.values()}bindTo(o){return o.createKey(this.key,this._defaultValue)}getValue(o){return o.getContextKeyValue(this.key)}toNegated(){return y.not(this.key)}isEqualTo(o){return y.equals(this.key,o)}notEqualsTo(o){return y.notEquals(this.key,o)}}e.RawContextKey=g,g._info=[],e.IContextKeyService=P.createDecorator("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function v(R,o){return R<o?-1:R>o?1:0}function T(R,o,F,B){return R<F?-1:R>F?1:o<B?-1:o>B?1:0}}),define(le[178],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=E.createDecorator(e.ID);function P(p){return!!p.hostName&&!!p.errorMessage}e.isRemoteDiagnosticError=P}),define(le[86],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=E.createDecorator("downloadService")}),define(le[27],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=E.createDecorator("environmentService"),e.INativeEnvironmentService=E.refineServiceDecorator(e.IEnvironmentService)}),define(le[33],ce([0,1,141,6,8]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN);function D(k){return k&&typeof k=="object"&&typeof k.id=="string"&&(!k.uuid||typeof k.uuid=="string")}e.isIExtensionIdentifier=D;var I;(function(k){k[k.NoneOrRelevance=0]="NoneOrRelevance",k[k.LastUpdatedDate=1]="LastUpdatedDate",k[k.Title=2]="Title",k[k.PublisherName=3]="PublisherName",k[k.InstallCount=4]="InstallCount",k[k.PublishedDate=5]="PublishedDate",k[k.AverageRating=6]="AverageRating",k[k.WeightedRating=12]="WeightedRating"})(I=e.SortBy||(e.SortBy={}));var _;(function(k){k[k.Default=0]="Default",k[k.Ascending=1]="Ascending",k[k.Descending=2]="Descending"})(_=e.SortOrder||(e.SortOrder={}));var m;(function(k){k.Uninstall="uninstall"})(m=e.StatisticType||(e.StatisticType={}));var y;(function(k){k[k.None=0]="None",k[k.Install=1]="Install",k[k.Update=2]="Update"})(y=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=P.createDecorator("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class r extends Error{constructor(d,b){super(d);this.code=b}}e.ExtensionManagementError=r,e.IExtensionManagementService=P.createDecorator("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=P.createDecorator("IGlobalExtensionEnablementService"),e.IExtensionTipsService=P.createDecorator("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",x).toString(!0),e.ExtensionsLabel=E.localize(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=E.localize(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=P.createDecorator("IExtensionManagementCLIService")}),define(le[44],ce([0,1,13,6]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkpaceSupportTypeMessage=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin";function p(r){if(typeof r=="object"&&r!==null&&r.supported!==!0)return r.description}e.getWorkpaceSupportTypeMessage=p;function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(!r.uuid||typeof r.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var I;(function(r){r[r.System=0]="System",r[r.User=1]="User"})(I=e.ExtensionType||(e.ExtensionType={}));class _{constructor(k){this.value=k,this._lower=k.toLowerCase()}static equals(k,d){if(typeof k=="undefined"||k===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof k=="string"||typeof d=="string"){let b=typeof k=="string"?k:k.value,f=typeof d=="string"?d:d.value;return E.equalsIgnoreCase(b,f)}return k._lower===d._lower}static toKey(k){return typeof k=="string"?k.toLowerCase():k._lower}}e.ExtensionIdentifier=_;function m(r){return r.contributes&&r.contributes.localizations?r.contributes.localizations.length>0:!1}e.isLanguagePackExtension=m;function y(r){return r.contributes&&r.contributes.authentication?r.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=y,e.IBuiltinExtensionsScannerService=P.createDecorator("IBuiltinExtensionsScannerService")}),define(le[34],ce([0,1,13,44]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function p(b,f){return b.uuid&&f.uuid?b.uuid===f.uuid:b.id===f.id?!0:E.compareIgnoreCase(b.id,f.id)===0}e.areSameExtensions=p;class D{constructor(f,c){this.version=c,this.id=f.id,this.uuid=f.uuid}key(){return`${this.id}-${this.version}`}equals(f){return f instanceof D?p(this,f)&&this.version===f.version:!1}}e.ExtensionIdentifierWithVersion=D;function I(b,f){return`${b}.${f}`}e.getExtensionId=I;function _(b){return b.toLocaleLowerCase()}e.adoptToGalleryExtensionId=_;function m(b,f){return _(I(b,f))}e.getGalleryExtensionId=m;function y(b,f){const c=[],S=w=>{for(const C of c)if(C.some(h=>p(f(h),f(w))))return C;return null};for(const w of b){const C=S(w);C?C.push(w):c.push([w])}return c}e.groupByExtension=y;function r(b){return{id:b.identifier.id,name:b.manifest.name,galleryId:null,publisherId:b.publisherId,publisherName:b.manifest.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:b.manifest.extensionDependencies&&b.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=r;function k(b){return Object.assign({id:b.identifier.id,name:b.name,galleryId:b.identifier.uuid,publisherId:b.publisherId,publisherName:b.publisher,publisherDisplayName:b.publisherDisplayName,dependencies:!!(b.properties.dependencies&&b.properties.dependencies.length>0)},b.telemetryData)}e.getGalleryExtensionTelemetryData=k,e.BetterMergeId=new P.ExtensionIdentifier("pprice.better-merge");function d(b){const f=new Set;for(const c of b)c.malicious&&f.add(c.id.id);return f}e.getMaliciousExtensionsSet=d});var Ke=this&&this.__param||function(x,e){return function(E,P){e(E,P,x)}};define(le[87],ce([0,1,142,12,4,49,33,34,44,52,29,8]),function(x,e,E,P,p,D,I,_,m,y,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementCLIService=e.getIdAndVersion=void 0;const d=C=>E.localize(0,null,C),b=E.localize(1,null,"ms-dotnettools.csharp");function f(C,h){return h?`${C.publisher}.${C.name}@${C.version}`:`${C.publisher}.${C.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(C){const h=c.exec(C);return h&&h[1]?[_.adoptToGalleryExtensionId(h[1]),h[2]]:[_.adoptToGalleryExtensionId(C),void 0]}e.getIdAndVersion=S;let w=class{constructor(h,l){this.extensionManagementService=h,this.extensionGalleryService=l}get location(){}async listExtensions(h,l,a=console){let t=await this.extensionManagementService.getInstalled(1);const i=m.EXTENSION_CATEGORIES.map(s=>s.toLowerCase());if(l&&l!==""){if(i.indexOf(l.toLowerCase())<0){a.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}t=t.filter(s=>s.manifest.categories?s.manifest.categories.map(g=>g.toLowerCase()).indexOf(l.toLowerCase())>-1:!1)}else if(l===""){a.log("Possible Categories: "),i.forEach(s=>{a.log(s)});return}this.location&&a.log(E.localize(2,null,this.location)),t=t.sort((s,u)=>s.identifier.id.localeCompare(u.identifier.id));let n;for(let s of t)n!==s.identifier.id&&(n=s.identifier.id,a.log(f(s.manifest,h)))}async installExtensions(h,l,a,t,i=console){const n=[],s=[];h.length&&i.log(this.location?E.localize(3,null,this.location):E.localize(4,null));const u=await this.extensionManagementService.getInstalled(1),g=(R,o)=>{const F=u.find(B=>_.areSameExtensions(B.identifier,{id:R}));if(F){if(!o&&!t)return i.log(E.localize(5,null,R,F.manifest.version,R)),!1;if(o&&F.manifest.version===o)return i.log(E.localize(6,null,`${R}@${o}`)),!1}return!0},v=[],T=[];for(const R of h)if(R instanceof p.URI)v.push(R);else{const[o,F]=S(R);g(o,F)&&T.push({id:o,version:F,installOptions:{isBuiltin:!1,isMachineScoped:a}})}for(const R of l){const[o,F]=S(R);g(o,F)&&T.push({id:o,version:F,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(v.length&&await Promise.all(v.map(async R=>{try{const o=await this.installVSIX(R,{isBuiltin:!1,isMachineScoped:a},t,i);o&&s.push(o)}catch(o){i.error(o.message||o.stack||o),n.push(R.toString())}})),T.length){const R=await this.getGalleryExtensions(T);await Promise.all(T.map(async o=>{const F=R.get(o.id.toLowerCase());if(F)try{const B=await this.installFromGallery(o,F,u,t,i);B&&s.push(B)}catch(B){i.error(B.message||B.stack||B),n.push(o.id)}else i.error(`${d(o.version?`${o.id}@${o.version}`:o.id)}
${b}`),n.push(o.id)}))}if(n.length)throw new Error(E.localize(7,null,n.join(", ")))}async installVSIX(h,l,a,t){const i=await this.extensionManagementService.getManifest(h);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,a,t))try{return await this.extensionManagementService.install(h,l),t.log(E.localize(8,null,y.getBaseLabel(h))),i}catch(s){if(P.isPromiseCanceledError(s))return t.log(E.localize(9,null,y.getBaseLabel(h))),null;throw s}return null}async getGalleryExtensions(h){const l=h.filter(({version:i})=>i===void 0).map(({id:i})=>i),a=h.filter(({version:i})=>i!==void 0),t=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(l,r.CancellationToken.None)).forEach(n=>t.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(a.map(async({id:i,version:n})=>{const s=await this.extensionGalleryService.getCompatibleExtension({id:i},n);s&&t.set(s.identifier.id.toLowerCase(),s)}))]),t}async installFromGallery({id:h,version:l,installOptions:a},t,i,n,s){const u=await this.extensionGalleryService.getManifest(t,r.CancellationToken.None);if(u&&!this.validateExtensionKind(u,s))return null;const g=i.find(v=>_.areSameExtensions(v.identifier,t.identifier));if(g){if(t.version===g.manifest.version)return s.log(E.localize(10,null,l?`${h}@${l}`:h)),null;s.log(E.localize(11,null,h,t.version))}try{return a.isBuiltin?s.log(E.localize(12,null,h,t.version)):s.log(E.localize(13,null,h,t.version)),await this.extensionManagementService.installFromGallery(t,a),s.log(E.localize(14,null,h,t.version)),u}catch(v){if(P.isPromiseCanceledError(v))return s.log(E.localize(15,null,h)),null;throw v}}validateExtensionKind(h,l){return!0}async validateVSIX(h,l,a){const t={id:_.getGalleryExtensionId(h.publisher,h.name)},n=(await this.extensionManagementService.getInstalled(1)).find(s=>_.areSameExtensions(t,s.identifier)&&D.gt(s.manifest.version,h.version));return n&&!l?(a.log(E.localize(16,null,n.identifier.id,n.manifest.version,h.version)),!1):this.validateExtensionKind(h,a)}async uninstallExtensions(h,l,a=console){const t=async n=>{if(n instanceof p.URI){const s=await this.extensionManagementService.getManifest(n);return f(s)}return n},i=[];for(const n of h){const s=await t(n),g=(await this.extensionManagementService.getInstalled()).filter(v=>_.areSameExtensions(v.identifier,{id:s}));if(!g.length)throw new Error(`${this.notInstalled(s)}
${b}`);if(g.some(v=>v.type===0)){a.log(E.localize(17,null,s));return}if(!l&&g.some(v=>v.isBuiltin)){a.log(E.localize(18,null,s));return}a.log(E.localize(19,null,s));for(const v of g)await this.extensionManagementService.uninstall(v),i.push(v);this.location?a.log(E.localize(20,null,s,this.location)):a.log(E.localize(21,null,s))}}async locateExtension(h,l=console){const a=await this.extensionManagementService.getInstalled();h.forEach(t=>{a.forEach(i=>{if(i.identifier.id===t&&i.location.scheme===k.Schemas.file){l.log(i.location.fsPath);return}})})}notInstalled(h){return this.location?E.localize(22,null,h,this.location):E.localize(23,null,h)}};w=Ne([Ke(0,I.IExtensionManagementService),Ke(1,I.IExtensionGalleryService)],w),e.ExtensionManagementCLIService=w}),define(le[179],ce([0,1,2,3,44,15]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class I extends E.Disposable{constructor(m,y){super();this.environmentService=m,this.extensionsManifestCache=P.join(this.environmentService.userDataPath,p.MANIFEST_CACHE_FOLDER,p.USER_MANIFEST_CACHE_FILE),this._register(y.onDidInstallExtension(r=>this.onDidInstallExtension(r))),this._register(y.onDidUninstallExtension(r=>this.onDidUnInstallExtension(r)))}onDidInstallExtension(m){m.error||this.invalidate()}onDidUnInstallExtension(m){m.error||this.invalidate()}invalidate(){D.rimraf(this.extensionsManifestCache,D.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=I}),define(le[20],ce([0,1,148,3,4,6,13,11,26]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=D.createDecorator("fileService");function y(q){return q.create===!0}e.isFileOpenForWriteOptions=y;var r;(function(q){q[q.Unknown=0]="Unknown",q[q.File=1]="File",q[q.Directory=2]="Directory",q[q.SymbolicLink=64]="SymbolicLink"})(r=e.FileType||(e.FileType={}));var k;(function(q){q[q.Readonly=1]="Readonly"})(k=e.FilePermission||(e.FilePermission={}));var d;(function(q){q[q.FileReadWrite=2]="FileReadWrite",q[q.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",q[q.FileReadStream=16]="FileReadStream",q[q.FileFolderCopy=8]="FileFolderCopy",q[q.PathCaseSensitive=1024]="PathCaseSensitive",q[q.Readonly=2048]="Readonly",q[q.Trash=4096]="Trash",q[q.FileWriteUnlock=8192]="FileWriteUnlock"})(d=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function b(q){return!!(q.capabilities&2)}e.hasReadWriteCapability=b;function f(q){return!!(q.capabilities&8)}e.hasFileFolderCopyCapability=f;function c(q){return!!(q.capabilities&4)}e.hasOpenReadWriteCloseCapability=c;function S(q){return!!(q.capabilities&16)}e.hasFileReadStreamCapability=S;var w;(function(q){q.FileExists="EntryExists",q.FileNotFound="EntryNotFound",q.FileNotADirectory="EntryNotADirectory",q.FileIsADirectory="EntryIsADirectory",q.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",q.FileTooLarge="EntryTooLarge",q.FileWriteLocked="EntryWriteLocked",q.NoPermissions="NoPermissions",q.Unavailable="Unavailable",q.Unknown="Unknown"})(w=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class C extends Error{constructor(ee,G){super(ee);this.code=G}}e.FileSystemProviderError=C;function h(q,ee){const G=new C(q.toString(),ee);return a(G,ee),G}e.createFileSystemProviderError=h;function l(q){return q||h(E.localize(0,null),w.Unknown)}e.ensureFileSystemProviderError=l;function a(q,ee){return q.name=ee?`${ee} (FileSystemError)`:"FileSystemError",q}e.markAsFileSystemProviderError=a;function t(q){if(!q)return w.Unknown;if(q instanceof C)return q.code;const ee=/^(.+) \(FileSystemError\)$/.exec(q.name);if(!ee)return w.Unknown;switch(ee[1]){case w.FileExists:return w.FileExists;case w.FileIsADirectory:return w.FileIsADirectory;case w.FileNotADirectory:return w.FileNotADirectory;case w.FileNotFound:return w.FileNotFound;case w.FileExceedsMemoryLimit:return w.FileExceedsMemoryLimit;case w.FileTooLarge:return w.FileTooLarge;case w.FileWriteLocked:return w.FileWriteLocked;case w.NoPermissions:return w.NoPermissions;case w.Unavailable:return w.Unavailable}return w.Unknown}e.toFileSystemProviderErrorCode=t;function i(q){if(q instanceof T)return q.fileOperationResult;switch(t(q)){case w.FileNotFound:return 1;case w.FileIsADirectory:return 0;case w.FileNotADirectory:return 10;case w.FileWriteLocked:return 5;case w.NoPermissions:return 6;case w.FileExists:return 4;case w.FileExceedsMemoryLimit:return 9;case w.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var n;(function(q){q[q.CREATE=0]="CREATE",q[q.DELETE=1]="DELETE",q[q.MOVE=2]="MOVE",q[q.COPY=3]="COPY"})(n=e.FileOperation||(e.FileOperation={}));class s{constructor(ee,G,z){this.resource=ee,this.operation=G,this.target=z}isOperation(ee){return this.operation===ee}}e.FileOperationEvent=s;var u;(function(q){q[q.UPDATED=0]="UPDATED",q[q.ADDED=1]="ADDED",q[q.DELETED=2]="DELETED"})(u=e.FileChangeType||(e.FileChangeType={}));class g{constructor(ee,G){this.ignorePathCasing=G,this.added=void 0,this.updated=void 0,this.deleted=void 0,this.changes=ee;for(const z of ee)switch(z.type){case 1:this.added||(this.added=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.added.set(z.resource,z);break;case 0:this.updated||(this.updated=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.updated.set(z.resource,z);break;case 2:this.deleted||(this.deleted=m.TernarySearchTree.forUris(()=>this.ignorePathCasing)),this.deleted.set(z.resource,z);break}}contains(ee,...G){return this.doContains(ee,{includeChildren:!1},...G)}affects(ee,...G){return this.doContains(ee,{includeChildren:!0},...G)}doContains(ee,G,...z){var L,A,N,M,W,X;if(!ee)return!1;const ae=z.length>0;return!!((!ae||z.includes(1))&&(((L=this.added)===null||L===void 0?void 0:L.get(ee))||G.includeChildren&&((A=this.added)===null||A===void 0?void 0:A.findSuperstr(ee)))||(!ae||z.includes(0))&&(((N=this.updated)===null||N===void 0?void 0:N.get(ee))||G.includeChildren&&((M=this.updated)===null||M===void 0?void 0:M.findSuperstr(ee)))||(!ae||z.includes(2))&&(((W=this.deleted)===null||W===void 0?void 0:W.findSubstr(ee))||G.includeChildren&&((X=this.deleted)===null||X===void 0?void 0:X.findSuperstr(ee))))}getAdded(){return this.getOfType(1)}gotAdded(){return!!this.added}getDeleted(){return this.getOfType(2)}gotDeleted(){return!!this.deleted}getUpdated(){return this.getOfType(0)}gotUpdated(){return!!this.updated}getOfType(ee){const G=[],z=ee===1?this.added:ee===0?this.updated:this.deleted;if(z)for(const[,L]of z)G.push(L);return G}filter(ee){return new g(this.changes.filter(G=>ee(G)),this.ignorePathCasing)}}e.FileChangesEvent=g;function v(q,ee,G){return!q||!ee||q===ee||ee.length>q.length?!1:(ee.charAt(ee.length-1)!==P.sep&&(ee+=P.sep),G?I.startsWithIgnoreCase(q,ee):q.indexOf(ee)===0)}e.isParent=v;class T extends Error{constructor(ee,G,z){super(ee);this.fileOperationResult=G,this.options=z}}e.FileOperationError=T;class R extends T{constructor(ee,G,z){super(ee,2,z);this.stat=G}}e.NotModifiedSinceFileOperationError=R;var o;(function(q){q[q.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",q[q.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",q[q.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",q[q.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",q[q.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",q[q.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",q[q.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",q[q.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",q[q.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",q[q.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",q[q.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",q[q.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(o=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function(q){q[q.FILE=0]="FILE",q[q.FOLDER=1]="FOLDER",q[q.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function B(q){if(!(typeof q.size!="number"||typeof q.mtime!="number"))return q.mtime.toString(29)+q.size.toString(31)}e.etag=B;async function Z(q,ee){if(!ee.canHandleResource(p.URI.from({scheme:q.scheme})))return new Promise(G=>{const z=ee.onDidChangeFileSystemProviderRegistrations(L=>{L.scheme===q.scheme&&L.added&&(z.dispose(),G())})})}e.whenProviderRegistered=Z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ie{static formatSize(ee){return _.isNumber(ee)||(ee=0),ee<ie.KB?E.localize(1,null,ee.toFixed(0)):ee<ie.MB?E.localize(2,null,(ee/ie.KB).toFixed(2)):ee<ie.GB?E.localize(3,null,(ee/ie.MB).toFixed(2)):ee<ie.TB?E.localize(4,null,(ee/ie.GB).toFixed(2)):E.localize(5,null,(ee/ie.TB).toFixed(2))}}e.ByteSize=ie,ie.KB=1024,ie.MB=ie.KB*ie.KB,ie.GB=ie.MB*ie.KB,ie.TB=ie.GB*ie.KB;var Se;(function(q){q[q.IA32=0]="IA32",q[q.OTHER=1]="OTHER"})(Se=e.Arch||(e.Arch={}));function oe(q){return{maxFileSize:q===0?300*ie.MB:16*ie.GB,maxHeapSize:q===0?700*ie.MB:2*700*ie.MB}}e.getPlatformLimits=oe}),define(le[180],ce([0,1,238,140,20,56]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function I(d,b){const f={onUnknownOption:S=>{console.warn(P.localize(0,null,S))},onMultipleValues:(S,w)=>{console.warn(P.localize(1,null,S,w))}},c=D.parseArgs(d,D.OPTIONS,b?f:void 0);return c.goto&&c._.forEach(S=>E(/^(\w:)?[^:]+(:\d*){0,2}$/.test(S),P.localize(2,null))),c["max-memory"]&&E(parseInt(c["max-memory"])>=p.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${p.MIN_MAX_MEMORY_SIZE_MB} MB.`),c}function _(d){const b=d.findIndex(f=>!/^-/.test(f));if(b>-1)return[...d.slice(0,b),...d.slice(b+1)]}function m(d){let[,...b]=d;process.env.VSCODE_DEV&&(b=_(b)||[]);const f=!k(process.env);return I(b,f)}e.parseMainProcessArgv=m;function y(d){const[,,...b]=d;return I(b,!0)}e.parseCLIProcessArgv=y;function r(d,...b){const f=d.indexOf("--");return f===-1?d.push(...b):d.splice(f,0,...b),d}e.addArg=r;function k(d){return d.VSCODE_CLI==="1"}e.isLaunchedFromCli=k}),define(le[88],ce([0,1,78,35,22,5,180,43,136]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;async function y(d,b,f){return b["force-disable-user-env"]?(d.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):D.isWindows?(d.trace("resolveShellEnv(): skipped (Windows)"),{}):I.isLaunchedFromCli(f)&&!b["force-user-env"]?(d.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):(I.isLaunchedFromCli(f)?d.trace("resolveShellEnv(): running (--force-user-env)"):d.trace("resolveShellEnv(): running (macOS/Linux)"),r||(r=k(d)),r)}e.resolveShellEnv=y;let r;async function k(d){const b=new Promise(async(f,c)=>{const S=process.env.ELECTRON_RUN_AS_NODE;d.trace("getUnixShellEnvironment#runAsNode",S);const w=process.env.ELECTRON_NO_ATTACH_CONSOLE;d.trace("getUnixShellEnvironment#noAttach",w);const C=p.generateUuid().replace(/-/g,"").substr(0,12),h=new RegExp(C+"(.*)"+C),l=Object.assign(Object.assign({},process.env),{ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"});d.trace("getUnixShellEnvironment#env",l);const a=await m.getSystemShell(D.OS,l);d.trace("getUnixShellEnvironment#shell",a);const t=E.basename(a);let i,n;/^pwsh(-preview)?$/.test(t)?(i=`& '${process.execPath}' -p '''${C}'' + JSON.stringify(process.env) + ''${C}'''`,n=["-Login","-Command"]):(i=`'${process.execPath}' -p '"${C}" + JSON.stringify(process.env) + "${C}"'`,n=["-ilc"]),d.trace("getUnixShellEnvironment#spawn",JSON.stringify(n),i);const s=P.spawn(a,[...n,i],{detached:!0,stdio:["ignore","pipe","pipe"],env:l});s.on("error",v=>{d.error("getUnixShellEnvironment#errorChildProcess",_.toErrorMessage(v)),f({})});const u=[];s.stdout.on("data",v=>u.push(v));const g=[];s.stderr.on("data",v=>g.push(v)),s.on("close",(v,T)=>{const R=Buffer.concat(u).toString("utf8");d.trace("getUnixShellEnvironment#raw",R);const o=Buffer.concat(g).toString("utf8");if(o.trim()&&d.trace("getUnixShellEnvironment#stderr",o),v||T)return c(new Error(`Failed to get environment (code ${v}, signal ${T})`));const F=h.exec(R),B=F?F[1]:"{}";try{const Z=JSON.parse(B);S?Z.ELECTRON_RUN_AS_NODE=S:delete Z.ELECTRON_RUN_AS_NODE,w?Z.ELECTRON_NO_ATTACH_CONSOLE=w:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,d.trace("getUnixShellEnvironment#result",Z),f(Z)}catch(Z){d.error("getUnixShellEnvironment#errorCaught",_.toErrorMessage(Z)),c(Z)}})});try{return await b}catch(f){return d.error("getUnixShellEnvironment#error",_.toErrorMessage(f)),{}}}}),define(le[89],ce([0,1,4,20,5]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=void 0;function D(m){return m.map(y=>({type:y.type,resource:E.URI.file(y.path)}))}e.toFileChanges=D;function I(m){const y=new _;for(const r of m)y.processEvent(r);return y.normalize()}e.normalizeFileChanges=I;class _{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(y){const r=this.mapPathToChange.get(y.path);if(r){const k=r.type,d=y.type;k===1&&d===2?(this.mapPathToChange.delete(y.path),this.normalized.splice(this.normalized.indexOf(r),1)):k===2&&d===1?r.type=0:k===1&&d===0||(r.type=d)}else this.normalized.push(y),this.mapPathToChange.set(y.path,y)}normalize(){const y=[],r=[];return this.normalized.filter(k=>k.type!==2?(y.push(k),!1):!0).sort((k,d)=>k.path.length-d.path.length).filter(k=>r.some(d=>P.isParent(k.path,d,!p.isLinux))?!1:(r.push(k.path),!0)).concat(y)}}}),define(le[181],ce([0,1,89,2,15,124,126,14,3]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class y extends P.Disposable{constructor(k,d,b,f){super();this.path=k,this.onDidFilesChange=d,this.onLogMessage=b,this.verboseLogging=f,this.fileChangesDelayer=this._register(new _.ThrottledDelayer(I.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(k){this.verboseLogging=k}async startWatching(){try{const{stat:k,symbolicLink:d}=await p.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let b=this.path;if(d)try{b=await D.realpath(b)}catch(f){if(this.onError(f),d.dangling)return}k.isDirectory()?this._register(I.watchFolder(b,(f,c)=>{this.onFileChange({type:f==="changed"?0:f==="added"?1:2,path:m.join(this.path,m.basename(c))})},f=>this.onError(f))):this._register(I.watchFile(b,f=>{this.onFileChange({type:f==="changed"?0:2,path:this.path})},f=>this.onError(f)))}catch(k){k.code!=="ENOENT"&&this.onError(k)}}onFileChange(k){this.fileChangesBuffer.push(k),this.verboseLogging&&this.onVerbose(`${k.type===1?"[ADDED]":k.type===2?"[DELETED]":"[CHANGED]"} ${k.path}`),this.fileChangesDelayer.trigger(async()=>{const d=this.fileChangesBuffer;this.fileChangesBuffer=[];const b=E.normalizeFileChanges(d);this.verboseLogging&&b.forEach(f=>{this.onVerbose(`>> normalized ${f.type===1?"[ADDED]":f.type===2?"[DELETED]":"[CHANGED]"} ${f.path}`)}),b.length>0&&this.onDidFilesChange(b)})}onError(k){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${k}`})}onVerbose(k){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${k}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=y}),define(le[60],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class E{constructor(...p){this._entries=new Map;for(let[D,I]of p)this.set(D,I)}set(p,D){const I=this._entries.get(p);return this._entries.set(p,D),I}has(p){return this._entries.has(p)}get(p){return this._entries.get(p)}}e.ServiceCollection=E}),define(le[90],ce([0,1,12,174,58,6,60,14]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const m=!1;class y extends Error{constructor(f){var c;super("cyclic dependency between services");this.message=(c=f.findCycleSlow())!==null&&c!==void 0?c:`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class r{constructor(f=new I.ServiceCollection,c=!1,S){this._activeInstantiations=new Set,this._services=f,this._strict=c,this._parent=S,this._services.set(D.IInstantiationService,this)}createChild(f){return new r(f,this._strict,this)}invokeFunction(f,...c){let S=d.traceInvocation(f),w=!1;try{return f({get:(h,l)=>{if(w)throw E.illegalState("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(h,S);if(!a&&l!==D.optional)throw new Error(`[invokeFunction] unknown service '${h}'`);return a}},...c)}finally{w=!0,S.stop()}}createInstance(f,...c){let S,w;return f instanceof p.SyncDescriptor?(S=d.traceCreation(f.ctor),w=this._createInstance(f.ctor,f.staticArguments.concat(c),S)):(S=d.traceCreation(f),w=this._createInstance(f,c,S)),S.stop(),w}_createInstance(f,c=[],S){let w=D._util.getServiceDependencies(f).sort((l,a)=>l.index-a.index),C=[];for(const l of w){let a=this._getOrCreateServiceInstance(l.id,S);if(!a&&this._strict&&!l.optional)throw new Error(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`);C.push(a)}let h=w.length>0?w[0].index:c.length;if(c.length!==h){console.warn(`[createInstance] First service dependency of ${f.name} at position ${h+1} conflicts with ${c.length} static arguments`);let l=h-c.length;l>0?c=c.concat(new Array(l)):c=c.slice(0,h)}return new f(...[...c,...C])}_setServiceInstance(f,c){if(this._services.get(f)instanceof p.SyncDescriptor)this._services.set(f,c);else if(this._parent)this._parent._setServiceInstance(f,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){let c=this._services.get(f);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):c}_getOrCreateServiceInstance(f,c){let S=this._getServiceInstanceOrDescriptor(f);return S instanceof p.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,S,c.branch(f,!0)):(c.branch(f,!1),S)}_safeCreateAndCacheServiceInstance(f,c,S){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,c,S)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,c,S){const w=new P.Graph(l=>l.id.toString());let C=0;const h=[{id:f,desc:c,_trace:S}];for(;h.length;){const l=h.pop();if(w.lookupOrInsertNode(l),C++>1e3)throw new y(w);for(let a of D._util.getServiceDependencies(l.desc.ctor)){let t=this._getServiceInstanceOrDescriptor(a.id);if(!t&&!a.optional&&console.warn(`[createInstance] ${f} depends on ${a.id} which is NOT registered.`),t instanceof p.SyncDescriptor){const i={id:a.id,desc:t,_trace:l._trace.branch(a.id,!0)};w.insertEdge(l,i),h.push(i)}}}for(;;){const l=w.roots();if(l.length===0){if(!w.isEmpty())throw new y(w);break}for(const{data:a}of l){if(this._getServiceInstanceOrDescriptor(a.id)instanceof p.SyncDescriptor){const i=this._createServiceInstanceWithOwner(a.id,a.desc.ctor,a.desc.staticArguments,a.desc.supportsDelayedInstantiation,a._trace);this._setServiceInstance(a.id,i)}w.removeNode(a)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,c,S=[],w,C){if(this._services.get(f)instanceof p.SyncDescriptor)return this._createServiceInstance(c,S,w,C);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,c,S,w,C);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(f,c=[],S,w){if(S){const C=new _.IdleValue(()=>this._createInstance(f,c,w));return new Proxy(Object.create(null),{get(h,l){if(l in h)return h[l];let a=C.value,t=a[l];return typeof t!="function"||(t=t.bind(a),h[l]=t),t},set(h,l,a){return C.value[l]=a,!0}})}else return this._createInstance(f,c,w)}}e.InstantiationService=r;var k;(function(b){b[b.Creation=0]="Creation",b[b.Invocation=1]="Invocation",b[b.Branch=2]="Branch"})(k||(k={}));class d{constructor(f,c){this.type=f,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return m?new d(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):d._None}static traceCreation(f){return m?new d(0,f.name):d._None}branch(f,c){let S=new d(2,f.toString());return this._dep.push([f,c,S]),S}stop(){let f=Date.now()-this._start;d._totals+=f;let c=!1;function S(C,h){let l=[],a=new Array(C+1).join("	");for(const[t,i,n]of h._dep)if(i&&n){c=!0,l.push(`${a}CREATES -> ${t}`);let s=S(C+1,n);s&&l.push(s)}else l.push(`${a}uses -> ${t}`);return l.join(`
`)}let w=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${d._totals.toFixed(2)}ms)`];(f>2||c)&&console.log(w.join(`
`))}}d._None=new class extends d{constructor(){super(-1,null)}stop(){}branch(){return this}},d._totals=0}),define(le[182],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILabelService=void 0,e.ILabelService=E.createDecorator("labelService")}),define(le[61],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isValidLocalization=e.ILocalizationsService=void 0,e.ILocalizationsService=E.createDecorator("localizationsService");function P(p){if(typeof p.languageId!="string"||!Array.isArray(p.translations)||p.translations.length===0)return!1;for(const D of p.translations)if(typeof D.id!="string"||typeof D.path!="string")return!1;return!(p.languageName&&typeof p.languageName!="string"||p.localizedLanguageName&&typeof p.localizedLanguageName!="string")}e.isValidLocalization=P}),define(le[16],ce([0,1,6,2,5,7,43]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=E.createDecorator("logService"),e.ILoggerService=E.createDecorator("loggerService");function _(){return new Date().toISOString()}var m;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(m=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=m.Info;class y extends P.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class r extends y{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(m.Trace)&&this.log(m.Trace,this.format([t,...i]))}debug(t,...i){this.checkLogLevel(m.Debug)&&this.log(m.Debug,this.format([t,...i]))}info(t,...i){this.checkLogLevel(m.Info)&&this.log(m.Info,this.format([t,...i]))}warn(t,...i){this.checkLogLevel(m.Warning)&&this.log(m.Warning,this.format([t,...i]))}error(t,...i){if(this.checkLogLevel(m.Error))if(t instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=t.stack,this.log(m.Error,this.format(n))}else this.log(m.Error,this.format([t,...i]))}critical(t,...i){this.checkLogLevel(m.Critical)&&this.log(m.Critical,this.format([t,...i]))}flush(){}format(t){let i="";for(let n=0;n<t.length;n++){let s=t[n];if(typeof s=="object")try{s=JSON.stringify(s)}catch(u){}i+=(n>0?" ":"")+s}return i}}e.AbstractMessageLogger=r;class k extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!p.isWindows}trace(t,...i){this.getLevel()<=m.Trace&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...i):console.log(`[main ${_()}]`,t,...i))}debug(t,...i){this.getLevel()<=m.Debug&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...i):console.log(`[main ${_()}]`,t,...i))}info(t,...i){this.getLevel()<=m.Info&&(this.useColors?console.log(`[90m[main ${_()}][0m`,t,...i):console.log(`[main ${_()}]`,t,...i))}warn(t,...i){this.getLevel()<=m.Warning&&(this.useColors?console.warn(`[93m[main ${_()}][0m`,t,...i):console.warn(`[main ${_()}]`,t,...i))}error(t,...i){this.getLevel()<=m.Error&&(this.useColors?console.error(`[91m[main ${_()}][0m`,t,...i):console.error(`[main ${_()}]`,t,...i))}critical(t,...i){this.getLevel()<=m.Critical&&(this.useColors?console.error(`[90m[main ${_()}][0m`,t,...i):console.error(`[main ${_()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=k;class d extends y{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=m.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=m.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=m.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=m.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=m.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=m.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=d;class b extends y{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=m.Trace&&this.adapter.log(m.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=m.Debug&&this.adapter.log(m.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=m.Info&&this.adapter.log(m.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=m.Warning&&this.adapter.log(m.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=m.Error&&this.adapter.log(m.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=m.Critical&&this.adapter.log(m.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:I.toErrorMessage(t,this.getLevel()<=m.Trace)}dispose(){}flush(){}}e.AdapterLogger=b;class f extends y{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const n of this.logServices)n.trace(t,...i)}debug(t,...i){for(const n of this.logServices)n.debug(t,...i)}info(t,...i){for(const n of this.logServices)n.info(t,...i)}warn(t,...i){for(const n of this.logServices)n.warn(t,...i)}error(t,...i){for(const n of this.logServices)n.error(t,...i)}critical(t,...i){for(const n of this.logServices)n.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=f;class c extends P.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=c;class S extends P.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(s=>s.setLevel(n))}))}createLogger(t,i){let n=this.loggers.get(t.toString());return n||(n=this.doCreateLogger(t,(i==null?void 0:i.always)?m.Trace:this.logLevel,i),this.loggers.set(t.toString(),n),(i==null?void 0:i.always)||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=S;class w{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(t){}getLevel(){return m.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=w;function C(a){if(a.verbose)return m.Trace;if(typeof a.logLevel=="string"){const t=h(a.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=C;function h(a){switch(a){case"trace":return m.Trace;case"debug":return m.Debug;case"info":return m.Info;case"warn":return m.Warning;case"error":return m.Error;case"critical":return m.Critical;case"off":return m.Off}}e.parseLogLevel=h;function l(a){switch(a){case m.Trace:return"trace";case m.Debug:return"debug";case m.Info:return"info";case m.Warning:return"warn";case m.Error:return"error";case m.Critical:return"critical";case m.Off:return"off"}}e.LogLevelToString=l}),define(le[183],ce([0,1,15,2,20,33,27,4,17,34,16,22,49,5,14,12]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let w=class extends P.Disposable{constructor(h,l,a,t){super();this.fileService=l,this.extensionGalleryService=a,this.logService=t,this.extensionsDownloadDir=_.URI.file(h.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(h,l){await this.cleanUpPromise;const a=this.getName(h),t=m.joinPath(this.extensionsDownloadDir,a);if(!await this.fileService.exists(t)){const i=m.joinPath(this.extensionsDownloadDir,`.${k.generateUuid()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(h,i,l);try{await this.rename(i,t,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(s){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",h.identifier.id);else throw this.logService.info(`Rename failed because of ${c.getErrorMessage(n)}. Deleted the vsix from downloaded location`,i.path),n}}return t}async delete(h){}async rename(h,l,a){try{await E.Promises.rename(h.fsPath,l.fsPath)}catch(t){if(b.isWindows&&t&&t.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${h} to ${l} with 'EPERM' error. Trying again...`),this.rename(h,l,a);throw t}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const h=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(h.children){const l=[],a=[];for(const n of h.children){const s=this.parse(n.name);s&&a.push([s,n])}const t=y.groupByExtension(a,([n])=>n),i=[];for(const n of t)n.sort((s,u)=>d.rcompare(s[0].version,u[0].version)),l.push(...n.slice(1).map(s=>s[1].resource)),i.push(n[0][1]);i.sort((n,s)=>n.mtime-s.mtime),l.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await f.Promises.settled(l.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(h){this.logService.error(h)}}getName(h){return this.cache?new y.ExtensionIdentifierWithVersion(h.identifier,h.version).key().toLowerCase():k.generateUuid()}parse(h){const l=S.exec(h);return l&&l[1]&&l[2]?new y.ExtensionIdentifierWithVersion({id:l[1]},l[2]):null}};w=Ne([Ke(0,I.INativeEnvironmentService),Ke(1,p.IFileService),Ke(2,D.IExtensionGalleryService),Ke(3,r.ILogService)],w),e.ExtensionsDownloader=w}),define(le[184],ce([0,1,2,16,35,43,3,14,7,8,15,27]),function(x,e,E,P,p,D,I,_,m,y,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let d=class extends E.Disposable{constructor(f,c){super();this.environmentService=f,this.logService=c,this.processesLimiter=new _.Limiter(5)}async postUninstall(f){const c=this.parseScript(f,"uninstall");return c&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${S}`)))),r.rimraf(this.getExtensionStoragePath(f)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(f,c){const S=`vscode:${c}`;if(f.location.scheme===y.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[S]=="string"){const w=f.manifest.scripts[S].split(" ");return w.length<2||w[0]!=="node"||!w[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${S} should be a node script`),null):{script:I.join(f.location.fsPath,w[1]),args:w.slice(2)||[]}}return null}runLifecycleHook(f,c,S,w,C){return new Promise((h,l)=>{const a=this.start(f,c,S,C);let t;const i=n=>{t&&(clearTimeout(t),t=null),n?l(n):h(void 0)};a.on("error",n=>{i(D.toErrorMessage(n)||"Unknown")}),a.on("exit",(n,s)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),w&&(t=setTimeout(()=>{t=null,a.kill(),l("timed out")},5e3))})}start(f,c,S,w){const C={silent:!0,execArgv:void 0},h=p.fork(f,[`--type=extension-post-${c}`,...S],C);h.stdout.setEncoding("utf8"),h.stderr.setEncoding("utf8");const l=m.Event.fromNodeEventEmitter(h.stdout,"data"),a=m.Event.fromNodeEventEmitter(h.stderr,"data");l(n=>this.logService.info(w.identifier.id,w.manifest.version,`post-${c}`,n)),a(n=>this.logService.error(w.identifier.id,w.manifest.version,`post-${c}`,n));const t=m.Event.any(m.Event.map(l,n=>({data:`%c${n}`,format:[""]})),m.Event.map(a,n=>({data:`%c${n}`,format:["color: red"]})));return m.Event.debounce(t,(n,s)=>n?{data:n.data+s.data,format:[...n.format,...s.format]}:{data:s.data,format:s.format},100)(n=>{console.group(w.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),h}getExtensionStoragePath(f){return I.join(this.environmentService.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};d=Ne([Ke(0,k.IEnvironmentService),Ke(1,P.ILogService)],d),e.ExtensionsLifecycle=d}),define(le[185],ce([0,1,2,27,7,20,4,34,17,16]),function(x,e,E,P,p,D,I,_,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let r=class extends E.Disposable{constructor(d,b,f,c){super();this.extensionsManagementService=d,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new p.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(C=>{this.installedExtensions=C.map(h=>h.identifier),this.startTimestamp=Date.now()}),this._register(d.onInstallExtension(C=>this.onInstallExtension(C))),this._register(d.onDidInstallExtension(C=>this.onDidInstallExtension(C))),this._register(d.onDidUninstallExtension(C=>this.onDidUninstallExtension(C)));const S=I.URI.file(f.extensionsPath),w=new m.ExtUri(C=>!b.hasCapability(C,1024));this._register(b.watch(S)),this._register(p.Event.filter(b.onDidFilesChange,C=>C.changes.some(h=>this.doesChangeAffects(h,S,w)))(()=>this.onDidChange()))}doesChangeAffects(d,b,f){return f.isEqual(f.dirname(d.resource),b)?f.isEqual(d.resource,f.joinPath(b,".obsolete"))?!0:!(d.type!==1&&d.type!==2||f.basename(d.resource).startsWith(".")):!1}onInstallExtension(d){this.addInstallingExtension(d.identifier)}onDidInstallExtension(d){this.removeInstallingExtension(d.identifier),d.error||this.addInstalledExtension(d.identifier)}onDidUninstallExtension(d){d.error||this.removeInstalledExtension(d.identifier)}addInstallingExtension(d){this.removeInstallingExtension(d),this.installingExtensions.push(d)}removeInstallingExtension(d){this.installingExtensions=this.installingExtensions.filter(b=>!_.areSameExtensions(b,d))}addInstalledExtension(d){this.installedExtensions&&(this.removeInstalledExtension(d),this.installedExtensions.push(d))}removeInstalledExtension(d){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(b=>!_.areSameExtensions(b,d)))}async onDidChange(){if(this.installedExtensions){const d=await this.extensionsManagementService.getInstalled(1),b=d.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(S=>_.areSameExtensions(S,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),f=this.installedExtensions.filter(c=>this.installingExtensions.some(S=>_.areSameExtensions(S,c))?!1:d.every(S=>!_.areSameExtensions(S.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=d.map(c=>c.identifier),(b.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:b,removed:f})}}};r=Ne([Ke(1,D.IFileService),Ke(2,P.INativeEnvironmentService),Ke(3,y.ILogService)],r),e.ExtensionsWatcher=r}),define(le[91],ce([0,1,15,62,33,2,27,14,34,16,61,21,7,8,3]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsService=void 0;let c=class extends D.Disposable{constructor(C,h,l){super();this.extensionManagementService=C,this.logService=l,this._onDidLanguagesChange=this._register(new d.Emitter),this.onDidLanguagesChange=this._onDidLanguagesChange.event,this.cache=this._register(new S(h,l)),this._register(C.onDidInstallExtension(({local:a})=>this.onDidInstallExtension(a))),this._register(C.onDidUninstallExtension(({identifier:a})=>this.onDidUninstallExtension(a)))}getLanguageIds(){return this.cache.getLanguagePacks().then(C=>{const h=["en",...Object.keys(C)];return k.distinct(h)})}onDidInstallExtension(C){C&&C.manifest&&C.manifest.contributes&&C.manifest.contributes.localizations&&C.manifest.contributes.localizations.length&&(this.logService.debug("Adding language packs from the extension",C.identifier.id),this.update().then(h=>{h&&this._onDidLanguagesChange.fire()}))}onDidUninstallExtension(C){this.cache.getLanguagePacks().then(h=>{Object.keys(h).some(l=>h[l]&&h[l].extensions.some(a=>m.areSameExtensions(a.extensionIdentifier,C)))&&(this.logService.debug("Removing language packs from the extension",C.id),this.update().then(l=>{l&&this._onDidLanguagesChange.fire()}))})}async update(){const[C,h]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),l=await this.cache.update(h);return!k.equals(Object.keys(C),Object.keys(l))}};c=Ne([Ke(0,p.IExtensionManagementService),Ke(1,I.INativeEnvironmentService),Ke(2,y.ILogService)],c),e.LocalizationsService=c;let S=class extends D.Disposable{constructor(C,h){super();this.logService=h,this.languagePacks={},this.languagePacksFilePath=f.join(C.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new _.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(C){return this.withLanguagePacks(h=>{Object.keys(h).forEach(l=>delete h[l]),this.createLanguagePacksFromExtensions(h,...C)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(C,...h){for(const l of h)l&&l.manifest&&l.manifest.contributes&&l.manifest.contributes.localizations&&l.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(C,l);Object.keys(C).forEach(l=>this.updateHash(C[l]))}createLanguagePacksFromExtension(C,h){const l=h.identifier,a=h.manifest.contributes&&h.manifest.contributes.localizations?h.manifest.contributes.localizations:[];for(const t of a)if(h.location.scheme===b.Schemas.file&&r.isValidLocalization(t)){let i=C[t.languageId];i||(i={hash:"",extensions:[],translations:{}},C[t.languageId]=i);let n=i.extensions.filter(s=>m.areSameExtensions(s.extensionIdentifier,l))[0];n?n.version=h.manifest.version:i.extensions.push({extensionIdentifier:l,version:h.manifest.version});for(const s of t.translations)i.translations[s.id]=f.join(h.location.fsPath,s.path)}}updateHash(C){if(C){const h=P.createHash("md5");for(const l of C.extensions)h.update(l.extensionIdentifier.uuid||l.extensionIdentifier.id).update(l.version);C.hash=h.digest("hex")}}withLanguagePacks(C=()=>null){return this.languagePacksFileLimiter.queue(()=>{let h=null;return E.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,l=>l.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(l)).then(l=>{try{return JSON.parse(l)}catch(a){return{}}}).then(l=>(h=C(l),l)).then(l=>{for(const t of Object.keys(l))l[t]||delete l[t];this.languagePacks=l,this.initializedCache=!0;const a=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",a),E.writeFile(this.languagePacksFilePath,a)}).then(()=>h,l=>this.logService.error(l))})}};S=Ne([Ke(0,I.INativeEnvironmentService),Ke(1,y.ILogService)],S)}),define(le[92],ce([0,1,16,7,4]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class D{constructor(d){this.service=d,this.onDidChangeLogLevel=P.Event.buffer(d.onDidChangeLogLevel,!0)}listen(d,b){switch(b){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${b}`)}async call(d,b,f){switch(b){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${b}`)}}e.LogLevelChannel=D;class I{constructor(d){this.channel=d}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(d){I.setLevel(this.channel,d)}static setLevel(d,b){return d.call("setLevel",b)}}e.LogLevelChannelClient=I;class _{constructor(d){this.loggerService=d,this.loggers=new Map}listen(d,b){throw new Error(`Event not found: ${b}`)}async call(d,b,f){switch(b){case"createLogger":this.createLogger(p.URI.revive(f[0]),f[1]);return;case"log":return this.log(p.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${b}`)}createLogger(d,b){this.loggers.set(d.toString(),this.loggerService.createLogger(d,b))}consoleLog(d,b){let f=console.log;switch(d){case E.LogLevel.Error:f=console.error;break;case E.LogLevel.Warning:f=console.warn;break;case E.LogLevel.Info:f=console.info;break}f.call(console,...b)}log(d,b){const f=this.loggers.get(d.toString());if(!f)throw new Error("Create the logger before logging");for(const[c,S]of b)switch(c){case E.LogLevel.Trace:f.trace(S);break;case E.LogLevel.Debug:f.debug(S);break;case E.LogLevel.Info:f.info(S);break;case E.LogLevel.Warning:f.warn(S);break;case E.LogLevel.Error:f.error(S);break;case E.LogLevel.Critical:f.critical(S);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=_;class m extends E.AbstractLoggerService{constructor(d,b,f){super(d,b);this.channel=f}createConsoleMainLogger(){return new E.AdapterLogger({log:(d,b)=>{this.channel.call("consoleLog",[d,b])}})}doCreateLogger(d,b,f){return new y(this.channel,d,b,f)}}e.LoggerChannelClient=m;class y extends E.AbstractMessageLogger{constructor(d,b,f,c){super(c==null?void 0:c.always);this.channel=d,this.file=b,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[b,c]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(d,b){const f=[[d,b]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(d){this.channel.call("log",[this.file,d])}}class r extends E.LogService{constructor(d,b){super(b);this.parent=d,this._register(d.onDidChangeLogLevel(f=>b.setLevel(f)))}setLevel(d){super.setLevel(d),this.parent.setLevel(d)}}e.FollowerLogService=r}),define(le[93],ce([0,1,16,20]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function p(m,y,r,k){try{const d=await new Promise((b,f)=>{x(["spdlog"],b,f)});return d.setFlushOn(E.LogLevel.Trace),d.createAsyncRotatingLogger(m,y,r,k)}catch(d){console.error(d)}return null}function D(m,y,r,k){const d=x.__$__nodeRequire("spdlog");return d.setFlushOn(E.LogLevel.Trace),d.createRotatingLogger(m,y,r,k)}e.createRotatingLogger=D;function I(m,y,r){switch(y){case E.LogLevel.Trace:m.trace(r);break;case E.LogLevel.Debug:m.debug(r);break;case E.LogLevel.Info:m.info(r);break;case E.LogLevel.Warning:m.warn(r);break;case E.LogLevel.Error:m.error(r);break;case E.LogLevel.Critical:m.critical(r);break;default:throw new Error("Invalid log level")}}class _ extends E.AbstractMessageLogger{constructor(y,r,k,d){super();this.name=y,this.filepath=r,this.rotating=k,this.buffer=[],this.setLevel(d),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}_createSpdLogLogger(){const y=this.rotating?6:1,r=30/y*P.ByteSize.MB;return p(this.name,this.filepath,r,y).then(k=>{if(k){this._logger=k,this._logger.setLevel(this.getLevel());for(const{level:d,message:b}of this.buffer)I(this._logger,d,b);this.buffer=[]}})}log(y,r){this._logger?I(this._logger,y,r):this.getLevel()<=y&&this.buffer.push({level:y,message:r})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=_}),define(le[186],ce([0,1,6,151,73]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var D;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(D=e.MarkerTag||(e.MarkerTag={}));var I;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(I=e.MarkerSeverity||(e.MarkerSeverity={})),function(m){function y(f,c){return c-f}m.compare=y;const r=Object.create(null);r[m.Error]=P.localize(0,null),r[m.Warning]=P.localize(1,null),r[m.Info]=P.localize(2,null);function k(f){return r[f]||""}m.toString=k;function d(f){switch(f){case p.default.Error:return m.Error;case p.default.Warning:return m.Warning;case p.default.Info:return m.Info;case p.default.Ignore:return m.Hint}}m.fromSeverity=d;function b(f){switch(f){case m.Error:return p.default.Error;case m.Warning:return p.default.Warning;case m.Info:return p.default.Info;case m.Hint:return p.default.Ignore}}m.toSeverity=b}(I=e.MarkerSeverity||(e.MarkerSeverity={}));var _;(function(m){const y="";function r(d){return k(d,!0)}m.makeKey=r;function k(d,b){let f=[y];return d.source?f.push(d.source.replace("\xA6","\\\xA6")):f.push(y),d.code?typeof d.code=="string"?f.push(d.code.replace("\xA6","\\\xA6")):f.push(d.code.value.replace("\xA6","\\\xA6")):f.push(y),d.severity!==void 0&&d.severity!==null?f.push(I.toString(d.severity)):f.push(y),d.message&&b?f.push(d.message.replace("\xA6","\\\xA6")):f.push(y),d.startLineNumber!==void 0&&d.startLineNumber!==null?f.push(d.startLineNumber.toString()):f.push(y),d.startColumn!==void 0&&d.startColumn!==null?f.push(d.startColumn.toString()):f.push(y),d.endLineNumber!==void 0&&d.endLineNumber!==null?f.push(d.endLineNumber.toString()):f.push(y),d.endColumn!==void 0&&d.endColumn!==null?f.push(d.endColumn.toString()):f.push(y),f.push(y),f.join("\xA6")}m.makeKeyOptionalMessage=k})(_=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=E.createDecorator("markerService")}),define(le[187],ce([0,1,73,6,7]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=E.default,e.INotificationService=P.createDecorator("notificationService");var D;(function(y){y[y.WORKSPACE=0]="WORKSPACE",y[y.GLOBAL=1]="GLOBAL"})(D=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var I;(function(y){y[y.OFF=0]="OFF",y[y.SILENT=1]="SILENT",y[y.ERROR=2]="ERROR"})(I=e.NotificationsFilter||(e.NotificationsFilter={}));class _{constructor(){this.progress=new m,this.onDidClose=p.Event.None,this.onDidChangeVisibility=p.Event.None}updateSeverity(r){}updateMessage(r){}updateActions(r){}close(){}}e.NoOpNotification=_;class m{infinite(){}done(){}total(r){}worked(r){}}e.NoOpProgress=m}),define(le[31],ce([0,1,8,5,23,17]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let I;if(typeof P.globals.vscode!="undefined"&&typeof P.globals.vscode.context!="undefined"){const _=P.globals.vscode.context.configuration();if(_)I=_.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof(x==null?void 0:x.__$__nodeRequire)=="function"){const _=D.dirname(E.FileAccess.asFileUri("",x));I=x.__$__nodeRequire(D.joinPath(_,"product.json").fsPath);const m=x.__$__nodeRequire(D.joinPath(_,"package.json").fsPath);p.env.VSCODE_DEV&&Object.assign(I,{nameShort:`${I.nameShort} Dev`,nameLong:`${I.nameLong} Dev`,dataFolderName:`${I.dataFolderName}-dev`}),Object.assign(I,{version:m.version})}else I={nameShort:"Code",nameLong:"Visual Studio Code",applicationName:"code",win32AppId:"{{F8A2A208-72B3-4D61-95FC-8A65D340689B}",win32x64AppId:"{{EA457B21-F73E-494C-ACAB-524FDE069978}",win32arm64AppId:"{{A5270FC5-65AD-483E-AC30-2C276B63D0AC}",win32UserAppId:"{{D628A17A-9713-46BF-8D57-E671B46A741E}",win32x64UserAppId:"{{771FD6B0-FA20-440A-A002-3B3BAC16DC50}",win32arm64UserAppId:"{{D9E514E7-1A56-452D-9337-2990C0DC4310}",win32NameVersion:"Microsoft Visual Studio Code",win32DirName:"Microsoft VS Code",win32SetupExeBasename:"VSCodeSetup",win32AppUserModelId:"Microsoft.VisualStudioCode",win32ShellNameShort:"Code",win32MutexName:"vscode",win32RegValueName:"VSCode",darwinCredits:"resources/darwin/Credits.rtf",darwinBundleIdentifier:"com.microsoft.VSCode",darwinExecutable:"VSCode",linuxIconName:"com.visualstudio.code",licenseFileName:"LICENSE.rtf",licenseName:"Multiple, see https://code.visualstudio.com/license",urlProtocol:"vscode",dataFolderName:".vscode",serverDataFolderName:".vscode-server",downloadUrl:"https://code.visualstudio.com",updateUrl:"https://update.code.visualstudio.com",webEndpointUrl:"https://vscodeweb.azureedge.net",quality:"stable",extensionsGallery:{serviceUrl:"https://marketplace.visualstudio.com/_apis/public/gallery",cacheUrl:"https://vscode.blob.core.windows.net/gallery/index",itemUrl:"https://marketplace.visualstudio.com/items",controlUrl:"https://az764295.vo.msecnd.net/extensions/marketplace.json",recommendationsUrl:"https://az764295.vo.msecnd.net/extensions/workspaceRecommendations.json.gz"},extensionTips:{"ms-dotnettools.csharp":"{**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json}","msjsdiag.debugger-for-chrome":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","firefox-devtools.vscode-firefox-debug":"{**/*.ts,**/*.tsx,**/*.js,**/*.jsx,**/*.es6,**/.babelrc}","golang.Go":"**/*.go","ms-vscode.PowerShell":"{**/*.ps1,**/*.psd1,**/*.psm1,**/*.ps.config,**/*.ps1.config}","austin.code-gnu-global":"{**/*.c,**/*.cpp,**/*.h}","Ionide.Ionide-fsharp":"{**/*.fsx,**/*.fsi,**/*.fs,**/*.ml,**/*.mli}","dbaeumer.vscode-eslint":"{**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.eslintrc,**/.babelrc,**/jsconfig.json}","dbaeumer.jshint":"{**/*.js,**/*.jsx,**/*.es6,**/.babelrc,**/jsconfig.json,**/.jshintrc,**/.jshintignore}","ms-vscode.vscode-typescript-tslint-plugin":"{**/tslint.json}","bmewburn.vscode-intelephense-client":"{**/*.php,**/php.ini}","felixfbecker.php-intellisense":"{**/*.php,**/php.ini}","felixfbecker.php-debug":"{**/*.php,**/php.ini}","ikappas.phpcs":"{**/*.php,**/php.ini}","rust-lang.rust":"{**/*.rs,**/*.rslib}","ms-vscode.cpptools-extension-pack":"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}","DavidAnson.vscode-markdownlint":"{**/*.md}","ms-azuretools.vscode-docker":"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml,**/*.cs,**/project.json,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln,**/appsettings.json,**/*.py,**/*.ipynb,**/*.js,**/*.ts,**/package.json}","EditorConfig.EditorConfig":"{**/.editorconfig}","HookyQR.beautify":"{**/.jsbeautifyrc,**/*.js,**/*.jsx,**/*.es6,**/.eslintrc.*,**/.babelrc,**/jsconfig.json}","donjayamanne.githistory":"{**/.gitignore,**/.git}","felipecaputo.git-project-manager":"{**/.gitignore,**/.git}","eamodio.gitlens":"{**/.gitignore,**/.git}","rebornix.Ruby":"{**/*.rb,**/*.erb,**/*.reek,**/.fasterer.yml,**/ruby-lint.yml,**/.rubocop.yml}","DotJoshJohnson.xml":"{**/*.xml}","shinnn.stylelint":"{**/.stylelintrc,**/stylelint.config.js}","eg2.vscode-npm-script":"{**/package.json}","ms-mssql.mssql":"{**/*.sql}","bajdzis.vscode-database":"{**/*.sql}","mtxr.sqltools":"{**/*.sql}","usqlextpublisher.usql-vscode-ext":"{**/*.usql}","ms-vscode.sublime-keybindings":"{**/.sublime-project,**/.sublime-workspace}","k--kato.intellij-idea-keybindings":"{**/.idea}","christian-kohler.npm-intellisense":"{**/package.json}","octref.vetur":"{**/*.vue}","ms-python.python":"{**/*.py,**/*.ipynb}","ms-toolsai.jupyter":"{**/*.ipynb}","cake-build.cake-vscode":"{**/build.cake}","Angular.ng-template":"{**/.angular-cli.json,**/angular.json,**/*.ng.html,**/*.ng,**/*.ngml}","vscjava.vscode-maven":"**/pom.xml","ms-azuretools.vscode-azureterraform":"**/*.tf","HashiCorp.terraform":"**/*.tf","vsciot-vscode.vscode-arduino":"**/*.ino","ms-kubernetes-tools.vscode-kubernetes-tools":"{**/Chart.yaml}","GoogleCloudTools.cloudcode":"{**/skaffold.yaml}","Oracle.oracledevtools":"{**/*.sql}"},extensionImportantTips:{"ms-dotnettools.csharp":{name:"C#",languages:["csharp"],pattern:"{**/*.cs,**/global.json,**/*.csproj,**/*.cshtml,**/*.sln}"},"ms-python.python":{name:"Python",languages:["python"],pattern:"{**/*.py}"},"ms-toolsai.jupyter":{name:"Jupyter",pattern:"{**/*.ipynb}"},"golang.Go":{name:"Go",languages:["go"],pattern:"**/*.go"},"vscjava.vscode-java-pack":{name:"Java",languages:["java"],pattern:"{**/*.java}",isExtensionPack:!0},"ms-vscode.PowerShell":{name:"PowerShell",languages:["powershell"],pattern:"{**/*.ps1,**/*.psd1,**/*.psm1}"},"ms-vscode.cpptools":{name:"C/C++",languages:["c","cpp"],pattern:"{**/*.c,**/*.cpp,**/*.cc,**/.cxx,**/*.hh,**/*.hpp,**/*.hxx,**/*.h}"},"ms-azuretools.vscode-docker":{name:"Docker",languages:["dockerfile"],pattern:"{**/dockerfile,**/Dockerfile,**/docker-compose.yml,**/docker-compose.*.yml}"},"octref.vetur":{name:"Vetur",languages:["vue"],pattern:"{**/*.vue}"},"ms-vscode.cmake-tools":{name:"CMake Tools",pattern:"{**/CMakeLists.txt}"},"msazurermtools.azurerm-vscode-tools":{name:"Azure Resource Manager",pattern:"{**/azuredeploy.json}"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",pattern:"{**/devcontainer.json}"},"ms-azuretools.vscode-bicep":{name:"Bicep",pattern:"{**/*.bicep}"},"svelte.svelte-vscode":{name:"Svelte",pattern:"{**/*.svelte}"}},keymapExtensionTips:["vscodevim.vim","ms-vscode.sublime-keybindings","ms-vscode.atom-keybindings","ms-vscode.brackets-keybindings","ms-vscode.vs-keybindings","ms-vscode.notepadplusplus-keybindings","k--kato.intellij-idea-keybindings","hiro-sun.vscode-emacs","alphabotsec.vscode-eclipse-keybindings","alefragnani.delphi-keybindings"],languageExtensionTips:["ms-python.python","ms-vscode.cpptools","ms-dotnettools.csharp","ms-toolsai.jupyter","vscjava.vscode-java-pack","ecmel.vscode-html-css","octref.vetur","bmewburn.vscode-intelephense-client","dsznajder.es7-react-js-snippets","golang.go","ms-vscode.powershell","dart-code.dart-code","rust-lang.rust","rebornix.ruby"],configBasedExtensionTips:{git:{configPath:".git/config",configName:"Git",recommendations:{"github.vscode-pull-request-github":{name:"GitHub Pull Request",remotes:["github.com"]},"eamodio.gitlens":{name:"GitLens"}}},devContainer:{configPath:".devcontainer/devcontainer.json",configName:"Dev Container",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0}}},maven:{configPath:"pom.xml",configName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0},"Pivotal.vscode-boot-dev-pack":{name:"Spring Boot Extension Pack",isExtensionPack:!0}}},gradle:{configPath:"build.gradle",configName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}}},exeBasedExtensionTips:{az:{friendlyName:"Azure CLI",windowsPath:"%ProgramFiles(x86)%\\Microsoft SDKs\\Azure\\CLI2\\wbin\\az.cmd",recommendations:{"ms-vscode.azurecli":{name:"Azure CLI Tools"}}},heroku:{friendlyName:"Heroku CLI",windowsPath:"%ProgramFiles%\\Heroku\\bin\\heroku.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"pkosta2005.heroku-command":{name:"heroku-cli"}}},mongo:{friendlyName:"Mongo",windowsPath:"%ProgramFiles%\\MongoDB\\Server\\3.6\\bin\\mongod.exe",recommendations:{"ms-azuretools.vscode-cosmosdb":{name:"Azure Databases"}}},serverless:{friendlyName:"Serverless framework",windowsPath:"%APPDATA%\\npm\\serverless.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},func:{friendlyName:"Azure Function SDK",windowsPath:"%APPDATA%\\npm\\func.cmd",recommendations:{"ms-azuretools.vscode-azurefunctions":{name:"Azure Functions"}}},mysql:{friendlyName:"MySQL",windowsPath:"%ProgramFiles%\\MySQL\\MySQL Server 8.0\\bin\\mysqld.exe",recommendations:{"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},postgres:{friendlyName:"PostgreSQL",windowsPath:"%ProgramFiles%\\PostgreSQL\\11\\bin\\psql.exe",recommendations:{"ms-ossdata.vscode-postgresql":{name:"PostgreSQL"},"bajdzis.vscode-database":{name:"vscode-database"},"mtxr.sqltools":{name:"SQLTools"}}},sqlcmd:{friendlyName:"SQL CLI",recommendations:{"ms-mssql.mssql":{name:"SQL Server (mssql)"}}},now:{friendlyName:"Now CLI",windowsPath:"%APPDATA%\\npm\\now.cmd",recommendations:{"ms-azuretools.vscode-azureappservice":{name:"Azure App Service"},"ms-azuretools.vscode-docker":{name:"Docker"}}},docker:{friendlyName:"Docker",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\docker.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker",important:!0},"ms-vscode-remote.remote-containers":{name:"Remote - Containers",important:!0},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},kubectl:{friendlyName:"Kubernetes",windowsPath:"%ProgramFiles%\\Docker\\Docker\\Resources\\bin\\kubectl.exe",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},ng:{friendlyName:"Angular CLI",windowsPath:"%APPDATA%\\npmexit\\ng.cmd",recommendations:{"johnpapa.Angular2":{name:"Angular Snippets"}}},"create-react-app":{friendlyName:"Create React App",windowsPath:"%APPDATA%\\npm\\create-react-app.cmd",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},"react-native":{friendlyName:"React Native",windowsPath:"%APPDATA%\\npm\\react-native-cli",recommendations:{"msjsdiag.vscode-react-native":{name:"React Native Tools"}}},p4:{friendlyName:"Perforce",recommendations:{"slevesque.perforce":{name:"Perforce for VS Code"}}},hg:{friendlyName:"Mercurial",recommendations:{"mrcrowl.hg":{name:"Hg"}}},subl:{friendlyName:"Sublime",windowsPath:"%ProgramFiles%\\Sublime Text3\\sublime_text.exe",recommendations:{"ms-vscode.sublime-keybindings":{name:"Sublime Text Keymap and Settings Importer"}}},atom:{friendlyName:"Atom",windowsPath:"%USERPROFILE%\\AppData\\Local\\atom\\bin\\atom.cmd",recommendations:{"ms-vscode.atom-keybindings":{name:"Atom Keymap"}}},brackets:{friendlyName:"Brackets",windowsPath:"%ProgramFiles(x86)%\\Brackets\\Brackets.exe",recommendations:{"ms-vscode.brackets-keybindings":{name:"Brackets Keymap"}}},notepadplusplus:{friendlyName:"Notepad++",windowsPath:"%ProgramFiles%\\Notepad++\\Notepad++.exe",recommendations:{"ms-vscode.notepadplusplus-keybindings":{name:"Notepad++ keymap"}}},vi:{friendlyName:"VIM",windowsPath:"%ProgramFiles(x86)%\\Vim\\vim80\\gvim.exe",recommendations:{"vscodevim.vim":{name:"Vim"}}},mvn:{friendlyName:"Maven",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},gradle:{friendlyName:"Gradle",recommendations:{"vscjava.vscode-java-pack":{name:"Java",important:!0,isExtensionPack:!0}}},"Microsoft Edge":{friendlyName:"Microsoft Edge",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Dev":{friendlyName:"Microsoft Edge Dev",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Dev\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Beta":{friendlyName:"Microsoft Edge Beta",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge Beta\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Microsoft Edge Canary":{friendlyName:"Microsoft Edge Canary",windowsPath:"%USERPROFILE%\\AppData\\Local\\Microsoft\\Edge SxS\\Application\\msedge.exe",recommendations:{"msjsdiag.debugger-for-edge":{name:"Debugger for Microsoft Edge"},"ms-edgedevtools.vscode-edge-devtools":{name:"Elements for Microsoft Edge (Chromium)"}}},"Mozilla Firefox (x86)":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles(x86)%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition (x86)":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles(x86)%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox":{friendlyName:"Mozilla Firefox",windowsPath:"%ProgramFiles%\\Mozilla Firefox\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},"Mozilla Firefox Developer Edition":{friendlyName:"Mozilla Firefox Developer Edition",windowsPath:"%ProgramFiles%\\Firefox Developer Edition\\firefox.exe",recommendations:{"firefox-devtools.vscode-firefox-debug":{name:"Debugger for Firefox"}}},cordova:{friendlyName:"Cordova",windowsPath:"%APPDATA%\\npm\\cordova",recommendations:{"msjsdiag.cordova-tools":{name:"Cordova Tools"}}},gcloud:{friendlyName:"Google GCloud CLI",windowsPath:"%ProgramFiles(x86)%\\Google\\Cloud SDK\\google-cloud-sdk\\bin\\gcloud.cmd",recommendations:{"GoogleCloudTools.cloudcode":{name:"Cloud Code"}}},skaffold:{friendlyName:"Skaffold Code to Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},minikube:{friendlyName:"MiniKube Local Kubernetes Cluster",recommendations:{"ms-azuretools.vscode-docker":{name:"Docker"},"ms-kubernetes-tools.vscode-kubernetes-tools":{name:"Kubernetes"},"GoogleCloudTools.cloudcode":{name:"Cloud Code"},"ms-vscode-remote.remote-containers":{name:"Remote - Containers"},"mindaro.mindaro":{name:"Local Process with Kubernetes"}}},podman:{friendlyName:"Podman",recommendations:{"ms-vscode-remote.remote-containers":{name:"Remote - Containers"}}},wsl:{friendlyName:"Windows Subsystem for Linux (WSL)",windowsPath:"%WINDIR%\\system32\\lxss\\LxssManager.dll",important:!0,recommendations:{"ms-vscode-remote.remote-wsl":{name:"Remote - WSL",important:!0}}}},remoteExtensionTips:{wsl:{friendlyName:"Remote - WSL",extensionId:"ms-vscode-remote.remote-wsl"},"ssh-remote":{friendlyName:"Remote - SSH",extensionId:"ms-vscode-remote.remote-ssh"},"dev-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},"attached-container":{friendlyName:"Remote - Containers",extensionId:"ms-vscode-remote.remote-containers"},vsonline:{friendlyName:"Visual Studio Online",extensionId:"ms-vsonline.vsonline"}},extensionKeywords:{md:["Markdown"],js:["JavaScript"],jsx:["JavaScript"],es6:["JavaScript"],html:["Html"],ts:["TypeScript"],tsx:["TypeScript"],css:["CSS"],scss:["SASS"],txt:["Text"],php:["PHP"],php3:["PHP"],php4:["PHP"],ph3:["PHP"],ph4:["PHP"],xml:["XML"],py:["Python"],pyc:["Python"],pyd:["Python"],pyo:["Python"],pyw:["Python"],pyz:["Python"],java:["Java"],class:["Java"],jar:["Java"],c:["c","objective c","objective-c"],m:["objective c","objective-c"],mm:["objective c","objective-c"],cpp:["cpp","c plus plus","c","c++"],cc:["cpp","c plus plus","c","c++"],cxx:["cpp","c plus plus","c++"],hh:["cpp","c plus plus","c++"],hpp:["cpp","c++"],h:["cpp","c plus plus","c++","c","objective c","objective-c"],sql:["sql"],sh:["bash"],bash:["bash"],zsh:["bash","zshell"],cs:["c#","csharp"],csproj:["c#","csharp"],sln:["c#","csharp"],go:["go"],sty:["latex"],tex:["latex"],ps:["powershell"],ps1:["powershell"],rs:["rust"],rslib:["rust"],hs:["haskell"],lhs:["haskell"],scm:["scheme"],ss:["scheme"],clj:["clojure"],cljs:["clojure"],cljc:["clojure"],edn:["clojure"],erl:["erlang"],hrl:["erlang"],scala:["scala"],sc:["scala"],pl:["perl"],pm:["perl"],t:["perl"],pod:["perl"],groovy:["groovy"],swift:["swift"],rb:["ruby"],rbw:["ruby"],jl:["julia"],f:["fortran"],for:["fortran"],f90:["fortran"],f95:["fortran"],coffee:["CoffeeScript"],litcoffee:["CoffeeScript"],yaml:["yaml"],yml:["yaml"],dart:["dart"],json:["json"]},extensionAllowedBadgeProviders:["api.bintray.com","api.travis-ci.com","api.travis-ci.org","app.fossa.io","badge.buildkite.com","badge.fury.io","badge.waffle.io","badgen.net","badges.frapsoft.com","badges.gitter.im","badges.greenkeeper.io","cdn.travis-ci.com","cdn.travis-ci.org","ci.appveyor.com","circleci.com","cla.opensource.microsoft.com","codacy.com","codeclimate.com","codecov.io","coveralls.io","david-dm.org","deepscan.io","dev.azure.com","docs.rs","flat.badgen.net","gemnasium.com","githost.io","gitlab.com","godoc.org","goreportcard.com","img.shields.io","isitmaintained.com","marketplace.visualstudio.com","nodesecurity.io","opencollective.com","snyk.io","travis-ci.com","travis-ci.org","visualstudio.com","vsmarketplacebadge.apphb.com","www.bithound.io","www.versioneye.com"],extensionAllowedBadgeProvidersRegex:["^https:\\/\\/github\\.com\\/[^/]+\\/[^/]+\\/workflows\\/.*badge\\.svg"],crashReporter:{productName:"VSCode",companyName:"Microsoft"},appCenter:{"win32-ia32":"appcenter://code?aid=f4289815-a66e-4ad9-b74f-d8e5bc093e41","win32-x64":"appcenter://code?aid=a4e3233c-699c-46ec-b4f4-9c2a77254662","win32-arm64":"appcenter://code?aid=3712d786-7cc8-4f11-8b08-cc12eab6d4f7","linux-x64":"appcenter://code?aid=fba07a4d-84bd-4fc8-a125-9640fc8ce171",darwin:"appcenter://code?aid=860d6632-f65b-490b-85a8-3e72944f7774","darwin-arm64":"appcenter://code?aid=be71415d-3893-4ae5-b453-e537b9668a10","darwin-universal":"appcenter://code?aid=de75e3cc-e22f-4f42-a03f-1409c21d8af8"},enableTelemetry:!0,aiConfig:{asimovKey:"AIF-444c3af9-8e69-4462-ab49-4191e6ad1916"},msftInternalDomains:["redmond.corp.microsoft.com","northamerica.corp.microsoft.com","fareast.corp.microsoft.com","ntdev.corp.microsoft.com","wingroup.corp.microsoft.com","southpacific.corp.microsoft.com","wingroup.windeploy.ntdev.microsoft.com","ddnet.microsoft.com","europe.corp.microsoft.com"],sendASmile:{reportIssueUrl:"https://go.microsoft.com/fwlink/?LinkId=534872",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482"},documentationUrl:"https://go.microsoft.com/fwlink/?LinkID=533484#vscode",releaseNotesUrl:"https://go.microsoft.com/fwlink/?LinkID=533483#vscode",keyboardShortcutsUrlMac:"https://go.microsoft.com/fwlink/?linkid=832143",keyboardShortcutsUrlLinux:"https://go.microsoft.com/fwlink/?linkid=832144",keyboardShortcutsUrlWin:"https://go.microsoft.com/fwlink/?linkid=832145",introductoryVideosUrl:"https://go.microsoft.com/fwlink/?linkid=832146",tipsAndTricksUrl:"https://go.microsoft.com/fwlink/?linkid=852118",newsletterSignupUrl:"https://www.research.net/r/vsc-newsletter",twitterUrl:"https://go.microsoft.com/fwlink/?LinkID=533687",requestFeatureUrl:"https://go.microsoft.com/fwlink/?LinkID=533482",reportIssueUrl:"https://github.com/Microsoft/vscode/issues/new",reportMarketplaceIssueUrl:"https://github.com/microsoft/vsmarketplace/issues/new",licenseUrl:"https://go.microsoft.com/fwlink/?LinkID=533485",privacyStatementUrl:"https://go.microsoft.com/fwlink/?LinkId=786907",telemetryOptOutUrl:"https://go.microsoft.com/fwlink/?linkid=870136",npsSurveyUrl:"https://aka.ms/vscode-nps",cesSurveyUrl:"https://aka.ms/new-to-vscode-feedback",checksumFailMoreInfoUrl:"https://go.microsoft.com/fwlink/?LinkId=828886",electronRepository:"Microsoft/vscode-electron-prebuilt",settingsSearchUrl:"https://bingsettingssearch.trafficmanager.net/api/Search",surveys:[{surveyId:"cpp.1",surveyUrl:"https://www.research.net/r/VBVV6C6",languageId:"cpp",editCount:10,userProbability:.15},{surveyId:"java.2",surveyUrl:"https://www.research.net/r/vscodejava",languageId:"java",editCount:10,userProbability:.3},{surveyId:"javascript.1",surveyUrl:"https://www.research.net/r/vscode-js",languageId:"javascript",editCount:10,userProbability:.05},{surveyId:"typescript.1",surveyUrl:"https://www.research.net/r/vscode-ts",languageId:"typescript",editCount:10,userProbability:.05}],extensionAllowedProposedApi:["GitHub.codespaces","GitHub.copilot-nightly","GitHub.copilot","GitHub.vscode-pull-request-github-insiders","GitHub.vscode-pull-request-github","GitHub.remotehub","GitHub.remotehub-insiders","Microsoft.vscode-nmake-tools","ms-ai-tools.notebook-renderers","ms-dotnettools.dotnet-interactive-vscode","ms-python.gather","ms-python.python","ms-toolsai.jupyter","ms-toolsai.vscode-ai","ms-toolsai.vscode-ai-remote","ms-vscode-remote.remote-containers-nightly","ms-vscode-remote.remote-containers","ms-vscode-remote.remote-ssh-edit-nightly","ms-vscode-remote.remote-ssh-edit","ms-vscode-remote.remote-ssh-nightly","ms-vscode-remote.remote-ssh","ms-vscode-remote.remote-wsl-nightly","ms-vscode-remote.remote-wsl","ms-vscode-remote.remote-wsl-recommender","ms-vscode-remote.vscode-remote-extensionpack-nightly","ms-vscode-remote.vscode-remote-extensionpack","ms-vscode.azure-account","ms-vscode.azure-sphere-tools-ui","ms-vscode.azure-sphere-tools","ms-vscode.remotehub","ms-vscode.remotehub-insiders","ms-vscode.js-debug-nightly","ms-vscode.js-debug","ms-vscode.lsif-browser","ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.vscode-selfhost-test-provider","ms-vscode.test-adapter-converter","ms-vsliveshare.cloudenv-explorer","ms-vsliveshare.cloudenv","ms-vsliveshare.vsliveshare","ms-vsonline.vsonline","dbaeumer.vscode-eslint","sandy081.999-test-github-issue-notebooks"],tasConfig:{endpoint:"https://default.exp-tas.com/vscode/ab",telemetryEventName:"query-expfeature",featuresTelemetryPropertyName:"VSCode.ABExp.Features",assignmentContextTelemetryPropertyName:"abexp.assignmentcontext"},experimentsUrl:"https://vscodeexperiments.azureedge.net/experiments/vscode-experiments.json",extensionKind:{"Shan.code-settings-sync":["ui"],"shalldie.background":["ui"],"techer.open-in-browser":["ui"],"manasxx.background-cover":["ui"],"CoenraadS.bracket-pair-colorizer":["ui","workspace"],"CoenraadS.bracket-pair-colorizer-2":["ui"],"hiro-sun.vscode-emacs":["ui","workspace"],"hnw.vscode-auto-open-markdown-preview":["ui","workspace"],"wayou.vscode-todo-highlight":["ui","workspace"],"aaron-bond.better-comments":["ui","workspace"]},extensionSyncedKeys:{"ritwickdey.liveserver":["liveServer.setup.version"]},extensionVirtualWorkspacesSupport:{"ms-python.python":{default:!1},"ms-vscode.cpptools":{default:!1},"dbaeumer.vscode-eslint":{default:!1},"esbenp.prettier-vscode":{default:!1},"msjsdiag.debugger-for-chrome":{default:!1},"redhat.java":{default:!1},"eamodio.gitlens":{default:!1},"HookyQR.beautify":{default:!1},"ritwickdey.LiveServer":{default:!1},"VisualStudioExptTeam.vscodeintellicode":{default:!1},"vscjava.vscode-java-debug":{default:!1},"octref.vetur":{default:!1},"ms-azuretools.vscode-docker":{default:!1},"vscjava.vscode-maven":{default:!1},"vscjava.vscode-java-test":{default:!1},"vscjava.vscode-java-pack":{default:!1},"formulahendry.code-runner":{default:!1},"felixfbecker.php-intellisense":{default:!1},"vscjava.vscode-java-dependency":{default:!1},"redhat.vscode-yaml":{default:!1},"felixfbecker.php-debug":{default:!1},"ms-mssql.mssql":{default:!1},"christian-kohler.path-intellisense":{default:!1},"eg2.tslint":{default:!1},"eg2.vscode-npm-script":{default:!1},"donjayamanne.githistory":{default:!1},"Zignd.html-css-class-completion":{default:!1},"christian-kohler.npm-intellisense":{default:!1},"EditorConfig.EditorConfig":{default:!1},"austin.code-gnu-global":{default:!1},"ms-vscode-remote.remote-wsl":{default:!1},"johnpapa.Angular2":{default:!1},"ms-vscode.vscode-typescript-tslint-plugin":{default:!1},"DotJoshJohnson.xml":{default:!1},"techer.open-in-browser":{default:!1},"DavidAnson.vscode-markdownlint":{default:!1},"tht13.python":{default:!1},"bmewburn.vscode-intelephense-client":{default:!1},"Angular.ng-template":{default:!1},"felixfbecker.php-pack":{default:!1},"dbaeumer.jshint":{default:!1},"msjsdiag.vscode-react-native":{default:!1},"Dart-Code.dart-code":{default:!1},"yzhang.markdown-all-in-one":{default:!1},"Dart-Code.flutter":{default:!1},"streetsidesoftware.code-spell-checker":{default:!1},"rebornix.Ruby":{default:!1},"ms-vscode.sublime-keybindings":{default:!1},"batisteo.vscode-django":{default:!1},"alefragnani.project-manager":{default:!1},"mitaki28.vscode-clang":{default:!1},"steoates.autoimport":{default:!1},"donjayamanne.python-extension-pack":{default:!1},"shd101wyy.markdown-preview-enhanced":{default:!1},"mikestead.dotenv":{default:!1},"GrapeCity.gc-excelviewer":{default:!1},"pranaygp.vscode-css-peek":{default:!1},"ikappas.phpcs":{default:!1},"platformio.platformio-ide":{default:!1},"jchannon.csharpextensions":{default:!1},"gruntfuggly.todo-tree":{default:!1}},linkProtectionTrustedDomains:["https://*.visualstudio.com","https://*.microsoft.com","https://aka.ms","https://vscode-auth.github.com","https://client-auth-staging-14a768b.herokuapp.com","https://*.gallerycdn.vsassets.io","https://github.com/microsoft/","https://github.com/MicrosoftDocs/","https://login.microsoftonline.com"],auth:{loginUrl:"https://login.microsoftonline.com/common/oauth2/authorize",tokenUrl:"https://login.microsoftonline.com/common/oauth2/token",redirectUrl:"https://vscode-redirect.azurewebsites.net/",clientId:"aebc6443-996d-45c2-90f0-388ff96faa56"},"configurationSync.store":{url:"https://vscode-sync.trafficmanager.net/",stableUrl:"https://vscode-sync.trafficmanager.net/",insidersUrl:"https://vscode-sync-insiders.trafficmanager.net/",canSwitch:!1,authenticationProviders:{microsoft:{scopes:["https://management.core.windows.net/.default","offline_access"]},github:{scopes:["user:email"]}}},builtInExtensions:[{name:"ms-vscode.node-debug",version:"1.44.28",repo:"https://github.com/microsoft/vscode-node-debug",metadata:{id:"b6ded8fb-a0a0-4c1c-acbd-ab2a3bc995a6",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.node-debug2",version:"1.42.7",repo:"https://github.com/microsoft/vscode-node-debug2",metadata:{id:"36d19e17-7569-4841-a001-947eb18602b2",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.references-view",version:"0.0.80",repo:"https://github.com/microsoft/vscode-references-view",metadata:{id:"dc489f46-520d-4556-ae85-1f9eab3c412d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug-companion",version:"1.0.13",repo:"https://github.com/microsoft/vscode-js-debug-companion",metadata:{id:"99cb0b7f-7354-4278-b8da-6cc79972169d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.js-debug",version:"1.57.0",repo:"https://github.com/microsoft/vscode-js-debug",metadata:{id:"25629058-ddac-4e17-abba-74678e126c5d",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode.vscode-js-profile-table",version:"0.0.18",repo:"https://github.com/microsoft/vscode-js-profile-visualizer",metadata:{id:"7e52b41b-71ad-457b-ab7e-0620f1fc4feb",publisherId:{publisherId:"5f5636e7-69ed-4afe-b5d6-8d231fb3d3ee",publisherName:"ms-vscode",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"}},{name:"ms-vscode-remote.remote-wsl-recommender",version:"0.0.10",repo:"https://github.com/microsoft/vscode-remote-wsl-recommender",metadata:{id:"cb296d3c-017a-4dee-83af-ebb5a5a16e9a",publisherId:{publisherId:"ac9410a2-0d75-40ec-90de-b59bb705801d",publisherName:"ms-vscode-remote",displayName:"Microsoft",flags:"verified"},publisherDisplayName:"Microsoft"},platforms:["win32"],clientOnly:!0}],version:"1.57.1",commit:"507ce72a4466fbb27b715c3722558bb15afa9f48",date:"2021-06-17T13:16:11.629Z"},Object.keys(I).length===0&&Object.assign(I,{version:"1.57.0-dev",nameShort:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",nameLong:P.isWeb?"Code Web - OSS Dev":"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=I}),define(le[94],ce([0,1,149,18,20,12,31]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function _(k,d,b,f,c,S){let w;try{await m(k,d,b,f,c,S)}catch(C){w=C}finally{w&&c.errorTransformer&&(w=c.errorTransformer(w)),typeof w!="undefined"&&b.error(w),b.end()}}e.readFileIntoStream=_;async function m(k,d,b,f,c,S){y(S);const w=await k.open(d,{create:!1});try{y(S);let C=0,h=0,l=c&&typeof c.length=="number"?c.length:void 0,a=P.VSBuffer.alloc(Math.min(c.bufferSize,typeof l=="number"?l:c.bufferSize)),t=c&&typeof c.position=="number"?c.position:0,i=0;do h=await k.read(w,t,a.buffer,i,a.byteLength-i),t+=h,i+=h,C+=h,typeof l=="number"&&(l-=h),i===a.byteLength&&(await b.write(f(a)),a=P.VSBuffer.alloc(Math.min(c.bufferSize,typeof l=="number"?l:c.bufferSize)),i=0);while(h>0&&(typeof l!="number"||l>0)&&y(S)&&r(C,c));if(i>0){let n=i;typeof l=="number"&&(n=Math.min(i,l)),b.write(f(a.slice(0,n)))}}catch(C){throw p.ensureFileSystemProviderError(C)}finally{await k.close(w)}}function y(k){if(k.isCancellationRequested)throw D.canceled();return!0}function r(k,d){if(d==null?void 0:d.limits){if(typeof d.limits.memory=="number"&&k>d.limits.memory)throw p.createFileSystemProviderError(E.localize(0,null,I.default.nameShort),p.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof d.limits.size=="number"&&k>d.limits.size)throw p.createFileSystemProviderError(E.localize(1,null),p.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(le[95],ce([0,1,147,48,2,20,7,17,26,21,16,18,42,14,29,8,94,51]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let C=class extends p.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new I.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new I.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new I.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new I.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new I.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new I.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(l,a){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);P.mark(`code/registerFilesystem/${l}`),this.provider.set(l,a),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:a});const t=new p.DisposableStore;return t.add(a.onDidChangeFile(i=>this._onDidFilesChange.fire(new D.FileChangesEvent(i,!this.isPathCaseSensitive(a))))),t.add(a.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:a,scheme:l}))),typeof a.onDidErrorOccur=="function"&&t.add(a.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),p.toDisposable(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:a}),this.provider.delete(l),p.dispose(t)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const a=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(t){a.push(t)}}),!this.provider.has(l)&&await b.Promises.settled(a)}canHandleResource(l){return this.provider.has(l.scheme)}hasCapability(l,a){const t=this.provider.get(l.scheme);return!!(t&&t.capabilities&a)}listCapabilities(){return w.Iterable.map(this.provider,([l,a])=>({scheme:l,capabilities:a.capabilities}))}async withProvider(l){if(!_.isAbsolutePath(l))throw new D.FileOperationError(E.localize(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const a=this.provider.get(l.scheme);if(!a){const t=new Error;throw t.name="ENOPRO",t.message=E.localize(1,null,l.toString()),t}return a}async withReadProvider(l){const a=await this.withProvider(l);if(D.hasOpenReadWriteCloseCapability(a)||D.hasReadWriteCapability(a)||D.hasFileReadStreamCapability(a))return a;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const a=await this.withProvider(l);if(D.hasOpenReadWriteCloseCapability(a)||D.hasReadWriteCapability(a))return a;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,a){try{return await this.doResolveFile(l,a)}catch(t){throw D.toFileSystemProviderErrorCode(t)===D.FileSystemProviderErrorCode.FileNotFound?new D.FileOperationError(E.localize(2,null,this.resourceForError(l)),1):D.ensureFileSystemProviderError(t)}}async doResolveFile(l,a){const t=await this.withProvider(l),i=this.isPathCaseSensitive(t),n=a==null?void 0:a.resolveTo,s=a==null?void 0:a.resolveSingleChildDescendants,u=a==null?void 0:a.resolveMetadata,g=await t.stat(l);let v;return this.toFileStat(t,l,g,void 0,!!u,(T,R)=>(v||(v=m.TernarySearchTree.forUris(()=>!i),v.set(l,!0),y.isNonEmptyArray(n)&&n.forEach(o=>v.set(o,!0))),Boolean(v.findSuperstr(T.resource)||v.get(T.resource))?!0:T.isDirectory&&s?R===1:!1))}async toFileStat(l,a,t,i,n,s){var u;const{providerExtUri:g}=this.getExtUri(l),v={resource:a,name:g.basename(a),isFile:(t.type&D.FileType.File)!=0,isDirectory:(t.type&D.FileType.Directory)!=0,isSymbolicLink:(t.type&D.FileType.SymbolicLink)!=0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:Boolean(((u=t.permissions)!==null&&u!==void 0?u:0)&D.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:D.etag({mtime:t.mtime,size:t.size})};if(v.isDirectory&&s(v,i)){try{const T=await l.readdir(a),R=await b.Promises.settled(T.map(async([o,F])=>{try{const B=g.joinPath(a,o),Z=n?await l.stat(B):{type:F};return await this.toFileStat(l,B,Z,T.length,n,s)}catch(B){return this.logService.trace(B),null}}));v.children=y.coalesce(R)}catch(T){this.logService.trace(T),v.children=[]}return v}return v}async resolveAll(l){return b.Promises.settled(l.map(async a=>{try{return{stat:await this.doResolveFile(a.resource,a.options),success:!0}}catch(t){return this.logService.trace(t),{stat:void 0,success:!1}}}))}async exists(l){const a=await this.withProvider(l);try{return!!await a.stat(l)}catch(t){return!1}}async canCreateFile(l,a){try{await this.doValidateCreateFile(l,a)}catch(t){return t}return!0}async doValidateCreateFile(l,a){if(!(a==null?void 0:a.overwrite)&&await this.exists(l))throw new D.FileOperationError(E.localize(3,null,this.resourceForError(l)),3,a)}async createFile(l,a=k.VSBuffer.fromString(""),t){await this.doValidateCreateFile(l,t);const i=await this.writeFile(l,a);return this._onDidRunOperation.fire(new D.FileOperationEvent(l,0,i)),i}async writeFile(l,a,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,l,t)||await this.mkdirp(i,n.dirname(l));let u;if(D.hasReadWriteCapability(i)&&!(a instanceof k.VSBuffer))if(d.isReadableStream(a)){const g=await d.peekStream(a,3);g.ended?u=k.VSBuffer.concat(g.buffer):u=g}else u=d.peekReadable(a,g=>k.VSBuffer.concat(g),3);else u=a;!D.hasOpenReadWriteCloseCapability(i)||D.hasReadWriteCapability(i)&&u instanceof k.VSBuffer?await this.doWriteUnbuffered(i,l,t,u):await this.doWriteBuffered(i,l,t,u instanceof k.VSBuffer?k.bufferToReadable(u):u)}catch(s){throw new D.FileOperationError(E.localize(4,null,this.resourceForError(l),D.ensureFileSystemProviderError(s).toString()),D.toFileOperationResult(s),t)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,a,t){if(!!(t==null?void 0:t.unlock)&&!(l.capabilities&8192))throw new Error(E.localize(5,null,this.resourceForError(a)));let n;try{n=await l.stat(a)}catch(s){return}if((n.type&D.FileType.Directory)!=0)throw new D.FileOperationError(E.localize(6,null,this.resourceForError(a)),0,t);if(this.throwIfFileIsReadonly(a,n),t&&typeof t.mtime=="number"&&typeof t.etag=="string"&&t.etag!==D.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&t.mtime<n.mtime&&t.etag!==D.etag({mtime:t.mtime,size:n.size}))throw new D.FileOperationError(E.localize(7,null),3,t);return n}async readFile(l,a){const t=await this.withReadProvider(l);return(a==null?void 0:a.atomic)?this.doReadFileAtomic(t,l,a):this.doReadFile(t,l,a)}async doReadFileAtomic(l,a,t){return new Promise((i,n)=>{this.writeQueue.queueFor(a,this.getExtUri(l).providerExtUri).queue(async()=>{try{const s=await this.doReadFile(l,a,t);i(s)}catch(s){n(s)}})})}async doReadFile(l,a,t){const i=await this.doReadFileStream(l,a,Object.assign(Object.assign({},t),{preferUnbuffered:!0}));return Object.assign(Object.assign({},i),{value:await k.streamToBuffer(i.value)})}async readFileStream(l,a){const t=await this.withReadProvider(l);return this.doReadFileStream(t,l,a)}async doReadFileStream(l,a,t){const i=new f.CancellationTokenSource,n=this.validateReadFile(a,t).then(u=>u,u=>{throw i.cancel(),u});let s;try{t&&typeof t.etag=="string"&&t.etag!==D.ETAG_DISABLED&&await n,!(D.hasOpenReadWriteCloseCapability(l)||D.hasFileReadStreamCapability(l))||D.hasReadWriteCapability(l)&&(t==null?void 0:t.preferUnbuffered)?s=this.readFileUnbuffered(l,a,t):D.hasFileReadStreamCapability(l)?s=this.readFileStreamed(l,a,i.token,t):s=this.readFileBuffered(l,a,i.token,t);const u=await n;return Object.assign(Object.assign({},u),{value:s})}catch(u){s&&await d.consumeStream(s);const g=E.localize(8,null,this.resourceForError(a),D.ensureFileSystemProviderError(u).toString());throw u instanceof D.NotModifiedSinceFileOperationError?new D.NotModifiedSinceFileOperationError(g,u.stat,t):new D.FileOperationError(g,D.toFileOperationResult(u),t)}}readFileStreamed(l,a,t,i=Object.create(null)){const n=l.readFileStream(a,i,t);return d.transform(n,{data:s=>s instanceof k.VSBuffer?s:k.VSBuffer.wrap(s),error:s=>new D.FileOperationError(E.localize(9,null,this.resourceForError(a),D.ensureFileSystemProviderError(s).toString()),D.toFileOperationResult(s),i)},s=>k.VSBuffer.concat(s))}readFileBuffered(l,a,t,i=Object.create(null)){const n=k.newWriteableBufferStream();return S.readFileIntoStream(l,a,n,s=>s,Object.assign(Object.assign({},i),{bufferSize:this.BUFFER_SIZE,errorTransformer:s=>new D.FileOperationError(E.localize(10,null,this.resourceForError(a),D.ensureFileSystemProviderError(s).toString()),D.toFileOperationResult(s),i)}),t),n}readFileUnbuffered(l,a,t){const i=d.newWriteableStream(n=>k.VSBuffer.concat(n));return(async()=>{try{let n=await l.readFile(a);t&&typeof t.position=="number"&&(n=n.slice(t.position)),t&&typeof t.length=="number"&&(n=n.slice(0,t.length)),this.validateReadFileLimits(a,n.byteLength,t),i.end(k.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(l,a){const t=await this.resolve(l,{resolveMetadata:!0});if(t.isDirectory)throw new D.FileOperationError(E.localize(11,null,this.resourceForError(l)),0,a);if(a&&typeof a.etag=="string"&&a.etag!==D.ETAG_DISABLED&&a.etag===t.etag)throw new D.NotModifiedSinceFileOperationError(E.localize(12,null),t,a);return this.validateReadFileLimits(l,t.size,a),t}validateReadFileLimits(l,a,t){if(t==null?void 0:t.limits){let i;if(typeof t.limits.memory=="number"&&a>t.limits.memory&&(i=9),typeof t.limits.size=="number"&&a>t.limits.size&&(i=7),typeof i=="number")throw new D.FileOperationError(E.localize(13,null,this.resourceForError(l)),i)}}async canMove(l,a,t){return this.doCanMoveCopy(l,a,"move",t)}async canCopy(l,a,t){return this.doCanMoveCopy(l,a,"copy",t)}async doCanMoveCopy(l,a,t,i){if(l.toString()!==a.toString())try{const n=t==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a);await this.doValidateMoveCopy(n,l,s,a,t,i)}catch(n){return n}return!0}async move(l,a,t){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(i,l,n,a,"move",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new D.FileOperationEvent(l,s==="move"?2:3,u)),u}async copy(l,a,t){const i=await this.withReadProvider(l),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(a),a),s=await this.doMoveCopy(i,l,n,a,"copy",!!t),u=await this.resolve(a,{resolveMetadata:!0});return this._onDidRunOperation.fire(new D.FileOperationEvent(l,s==="copy"?3:2,u)),u}async doMoveCopy(l,a,t,i,n,s){if(a.toString()===i.toString())return n;const{exists:u,isSameResourceWithDifferentPathCase:g}=await this.doValidateMoveCopy(l,a,t,i,n,s);if(u&&!g&&s&&await this.del(i,{recursive:!0}),await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(i)),n==="copy"){if(l===t&&D.hasFileFolderCopyCapability(l))await l.copy(a,i,{overwrite:s});else{const v=await this.resolve(a);v.isDirectory?await this.doCopyFolder(l,v,t,i):await this.doCopyFile(l,a,t,i)}return n}else return l===t?(await l.rename(a,i,{overwrite:s}),n):(await this.doMoveCopy(l,a,t,i,"copy",s),await this.del(a,{recursive:!0}),"copy")}async doCopyFile(l,a,t,i){if(D.hasOpenReadWriteCloseCapability(l)&&D.hasOpenReadWriteCloseCapability(t))return this.doPipeBuffered(l,a,t,i);if(D.hasOpenReadWriteCloseCapability(l)&&D.hasReadWriteCapability(t))return this.doPipeBufferedToUnbuffered(l,a,t,i);if(D.hasReadWriteCapability(l)&&D.hasOpenReadWriteCloseCapability(t))return this.doPipeUnbufferedToBuffered(l,a,t,i);if(D.hasReadWriteCapability(l)&&D.hasReadWriteCapability(t))return this.doPipeUnbuffered(l,a,t,i)}async doCopyFolder(l,a,t,i){await t.mkdir(i),Array.isArray(a.children)&&await b.Promises.settled(a.children.map(async n=>{const s=this.getExtUri(t).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(l,await this.resolve(n.resource),t,s):this.doCopyFile(l,n.resource,t,s)}))}async doValidateMoveCopy(l,a,t,i,n,s){let u=!1;if(l===t){const{providerExtUri:v,isPathCaseSensitive:T}=this.getExtUri(l);if(T||(u=v.isEqual(a,i)),u&&n==="copy")throw new Error(E.localize(14,null,this.resourceForError(a),this.resourceForError(i)));if(!u&&v.isEqualOrParent(i,a))throw new Error(E.localize(15,null,this.resourceForError(a),this.resourceForError(i)))}const g=await this.exists(i);if(g&&!u){if(!s)throw new D.FileOperationError(E.localize(16,null,this.resourceForError(a),this.resourceForError(i)),4);if(l===t){const{providerExtUri:v}=this.getExtUri(l);if(v.isEqualOrParent(a,i))throw new Error(E.localize(17,null,this.resourceForError(a),this.resourceForError(i)))}}return{exists:g,isSameResourceWithDifferentPathCase:u}}getExtUri(l){const a=this.isPathCaseSensitive(l);return{providerExtUri:a?_.extUri:_.extUriIgnorePathCase,isPathCaseSensitive:a}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const a=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(a,l);const t=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new D.FileOperationEvent(l,0,t)),t}async mkdirp(l,a){const t=[],{providerExtUri:i}=this.getExtUri(l);for(;!i.isEqual(a,i.dirname(a));)try{if(((await l.stat(a)).type&D.FileType.Directory)==0)throw new Error(E.localize(18,null,this.resourceForError(a)));break}catch(n){if(D.toFileSystemProviderErrorCode(n)!==D.FileSystemProviderErrorCode.FileNotFound)throw n;t.push(i.basename(a)),a=i.dirname(a)}for(let n=t.length-1;n>=0;n--){a=i.joinPath(a,t[n]);try{await l.mkdir(a)}catch(s){if(D.toFileSystemProviderErrorCode(s)!==D.FileSystemProviderErrorCode.FileExists)throw s}}}async canDelete(l,a){try{await this.doValidateDelete(l,a)}catch(t){return t}return!0}async doValidateDelete(l,a){const t=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!(a==null?void 0:a.useTrash)&&!(t.capabilities&4096))throw new Error(E.localize(19,null,this.resourceForError(l)));let n;try{n=await t.stat(l)}catch(u){}if(n)this.throwIfFileIsReadonly(l,n);else throw new D.FileOperationError(E.localize(20,null,this.resourceForError(l)),1);if(!!!(a==null?void 0:a.recursive)){const u=await this.resolve(l);if(u.isDirectory&&Array.isArray(u.children)&&u.children.length>0)throw new Error(E.localize(21,null,this.resourceForError(l)))}return t}async del(l,a){const t=await this.doValidateDelete(l,a),i=!!(a==null?void 0:a.useTrash),n=!!(a==null?void 0:a.recursive);await t.delete(l,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new D.FileOperationEvent(l,1))}watch(l,a={recursive:!1,excludes:[]}){let t=!1,i=()=>{t=!0};return this.doWatch(l,a).then(n=>{t?p.dispose(n):i=()=>p.dispose(n)},n=>this.logService.error(n)),p.toDisposable(()=>i())}async doWatch(l,a){const t=await this.withProvider(l),i=this.toWatchKey(t,l,a),n=this.activeWatchers.get(i)||{count:0,disposable:t.watch(l,a)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,p.toDisposable(()=>{n.count--,n.count===0&&(p.dispose(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(l,a,t){const{providerExtUri:i}=this.getExtUri(l);return[i.getComparisonKey(a),String(t.recursive),t.excludes.join()].join()}dispose(){super.dispose(),this.activeWatchers.forEach(l=>p.dispose(l.disposable)),this.activeWatchers.clear()}async doWriteBuffered(l,a,t,i){return this.writeQueue.queueFor(a,this.getExtUri(l).providerExtUri).queue(async()=>{var n;const s=await l.open(a,{create:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1});try{d.isReadableStream(i)||d.isReadableBufferedStream(i)?await this.doWriteStreamBufferedQueued(l,s,i):await this.doWriteReadableBufferedQueued(l,s,i)}catch(u){throw D.ensureFileSystemProviderError(u)}finally{await l.close(s)}})}async doWriteStreamBufferedQueued(l,a,t){let i=0,n;if(d.isReadableBufferedStream(t)){if(t.buffer.length>0){const s=k.VSBuffer.concat(t.buffer);await this.doWriteBuffer(l,a,s,s.byteLength,i,0),i+=s.byteLength}if(t.ended)return;n=t.stream}else n=t;return new Promise(async(s,u)=>{d.listenStream(n,{onData:async g=>{n.pause();try{await this.doWriteBuffer(l,a,g,g.byteLength,i,0)}catch(v){return u(v)}i+=g.byteLength,setTimeout(()=>n.resume())},onError:g=>u(g),onEnd:()=>s()})})}async doWriteReadableBufferedQueued(l,a,t){let i=0,n;for(;(n=t.read())!==null;)await this.doWriteBuffer(l,a,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(l,a,t,i,n,s){let u=0;for(;u<i;)u+=await l.write(a,n+u,t.buffer,s+u,i-u)}async doWriteUnbuffered(l,a,t,i){return this.writeQueue.queueFor(a,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,a,t,i))}async doWriteUnbufferedQueued(l,a,t,i){var n;let s;i instanceof k.VSBuffer?s=i:d.isReadableStream(i)?s=await k.streamToBuffer(i):d.isReadableBufferedStream(i)?s=await k.bufferedStreamToBuffer(i):s=k.readableToBuffer(i),await l.writeFile(a,s.buffer,{create:!0,overwrite:!0,unlock:(n=t==null?void 0:t.unlock)!==null&&n!==void 0?n:!1})}async doPipeBuffered(l,a,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,a,t,i))}async doPipeBufferedQueued(l,a,t,i){let n,s;try{n=await l.open(a,{create:!1}),s=await t.open(i,{create:!0,unlock:!1});const u=k.VSBuffer.alloc(this.BUFFER_SIZE);let g=0,v=0,T=0;do T=await l.read(n,g,u.buffer,v,u.byteLength-v),await this.doWriteBuffer(t,s,u,T,g,v),g+=T,v+=T,v===u.byteLength&&(v=0);while(T>0)}catch(u){throw D.ensureFileSystemProviderError(u)}finally{await b.Promises.settled([typeof n=="number"?l.close(n):Promise.resolve(),typeof s=="number"?t.close(s):Promise.resolve()])}}async doPipeUnbuffered(l,a,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,a,t,i))}async doPipeUnbufferedQueued(l,a,t,i){return t.writeFile(i,await l.readFile(a),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,a,t,i){return this.writeQueue.queueFor(i,this.getExtUri(t).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,a,t,i))}async doPipeUnbufferedToBufferedQueued(l,a,t,i){const n=await t.open(i,{create:!0,unlock:!1});try{const s=await l.readFile(a);await this.doWriteBuffer(t,n,k.VSBuffer.wrap(s),s.byteLength,0,0)}catch(s){throw D.ensureFileSystemProviderError(s)}finally{await t.close(n)}}async doPipeBufferedToUnbuffered(l,a,t,i){const n=await k.streamToBuffer(this.readFileBuffered(l,a,f.CancellationToken.None));await this.doWriteUnbuffered(t,i,void 0,n)}throwIfFileSystemIsReadonly(l,a){if(l.capabilities&2048)throw new D.FileOperationError(E.localize(22,null,this.resourceForError(a)),6);return l}throwIfFileIsReadonly(l,a){var t;if(((t=a.permissions)!==null&&t!==void 0?t:0)&D.FilePermission.Readonly)throw new D.FileOperationError(E.localize(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===c.Schemas.file?l.fsPath:l.toString(!0)}};C=Ne([Ke(0,r.ILogService)],C),e.FileService=C}),define(le[63],ce([0,1,2,20,7,5,15,3,17,30,14,16,150,89,171,173,170,181,42,94,21,18]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w,C,h,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class t extends E.Disposable{constructor(n,s){var u;super();this.logService=n,this.options=s,this.BUFFER_SIZE=((u=this.options)===null||u===void 0?void 0:u.bufferSize)||64*1024,this.onDidChangeCapabilities=p.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new p.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new p.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new r.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,D.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:s,symbolicLink:u}=await I.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(s,u),ctime:s.birthtime.getTime(),mtime:s.mtime.getTime(),size:s.size}}catch(s){throw this.toFileSystemProviderError(s)}}async readdir(n){try{const s=await I.readdir(this.toFilePath(n),{withFileTypes:!0}),u=[];return await Promise.all(s.map(async g=>{try{let v;g.isSymbolicLink()?v=(await this.stat(m.joinPath(n,g.name))).type:v=this.toType(g),u.push([g.name,v])}catch(v){this.logService.trace(v)}})),u}catch(s){throw this.toFileSystemProviderError(s)}}toType(n,s){let u;return(s==null?void 0:s.dangling)?u=P.FileType.Unknown:n.isFile()?u=P.FileType.File:n.isDirectory()?u=P.FileType.Directory:u=P.FileType.Unknown,s&&(u|=P.FileType.SymbolicLink),u}async readFile(n){try{const s=this.toFilePath(n);return await I.Promises.readFile(s)}catch(s){throw this.toFileSystemProviderError(s)}}readFileStream(n,s,u){const g=C.newWriteableStream(v=>a.VSBuffer.concat(v.map(T=>a.VSBuffer.wrap(T))).buffer);return h.readFileIntoStream(this,n,g,v=>v.buffer,Object.assign(Object.assign({},s),{bufferSize:this.BUFFER_SIZE}),u),g}async writeFile(n,s,u){let g;try{const v=this.toFilePath(n);if(!u.create||!u.overwrite){if(await I.exists(v)){if(!u.overwrite)throw P.createFileSystemProviderError(d.localize(0,null),P.FileSystemProviderErrorCode.FileExists)}else if(!u.create)throw P.createFileSystemProviderError(d.localize(1,null),P.FileSystemProviderErrorCode.FileNotFound)}g=await this.open(n,{create:!0,unlock:u.unlock}),await this.write(g,0,s,0,s.byteLength)}catch(v){throw await this.toFileSystemProviderWriteError(n,v)}finally{typeof g=="number"&&await this.close(g)}}async open(n,s){try{const u=this.toFilePath(n);if(P.isFileOpenForWriteOptions(s)&&s.unlock)try{const{stat:T}=await I.SymlinkSupport.stat(u);T.mode&128||await I.Promises.chmod(u,T.mode|128)}catch(T){this.logService.trace(T)}let g;if(P.isFileOpenForWriteOptions(s)){if(D.isWindows)try{await I.Promises.truncate(u,0),g="r+"}catch(T){T.code!=="ENOENT"&&this.logService.trace(T)}g||(g="w")}else g="r";const v=await I.Promises.open(u,g);return this.mapHandleToPos.set(v,0),P.isFileOpenForWriteOptions(s)&&this.writeHandles.set(v,n),v}catch(u){throw P.isFileOpenForWriteOptions(s)?await this.toFileSystemProviderWriteError(n,u):this.toFileSystemProviderError(u)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await I.Promises.fdatasync(n)}catch(s){this.canFlush=!1,this.logService.error(s)}return await I.Promises.close(n)}catch(s){throw this.toFileSystemProviderError(s)}}async read(n,s,u,g,v){const T=this.normalizePos(n,s);let R=null;try{const o=await I.Promises.read(n,u,g,v,T);return typeof o=="number"?R=o:R=o.bytesRead,R}catch(o){throw this.toFileSystemProviderError(o)}finally{this.updatePos(n,T,R)}}normalizePos(n,s){return s===this.mapHandleToPos.get(n)?null:s}updatePos(n,s,u){const g=this.mapHandleToPos.get(n);typeof g=="number"&&(typeof s=="number"||(typeof u=="number"?this.mapHandleToPos.set(n,g+u):this.mapHandleToPos.delete(n)))}async write(n,s,u,g,v){return r.retry(()=>this.doWrite(n,s,u,g,v),100,3)}async doWrite(n,s,u,g,v){const T=this.normalizePos(n,s);let R=null;try{const o=await I.Promises.write(n,u,g,v,T);return typeof o=="number"?R=o:R=o.bytesWritten,R}catch(o){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),o)}finally{this.updatePos(n,T,R)}}async mkdir(n){try{await I.Promises.mkdir(this.toFilePath(n))}catch(s){throw this.toFileSystemProviderError(s)}}async delete(n,s){try{const u=this.toFilePath(n);await this.doDelete(u,s)}catch(u){throw this.toFileSystemProviderError(u)}}async doDelete(n,s){s.recursive?await I.rimraf(n,I.RimRafMode.MOVE):await I.Promises.unlink(n)}async rename(n,s,u){const g=this.toFilePath(n),v=this.toFilePath(s);if(g!==v)try{await this.validateTargetDeleted(n,s,"move",u.overwrite),await I.move(g,v)}catch(T){throw(T.code==="EINVAL"||T.code==="EBUSY"||T.code==="ENAMETOOLONG")&&(T=new Error(d.localize(2,null,_.basename(g),_.basename(_.dirname(v)),T.toString()))),this.toFileSystemProviderError(T)}}async copy(n,s,u){const g=this.toFilePath(n),v=this.toFilePath(s);if(g!==v)try{await this.validateTargetDeleted(n,s,"copy",u.overwrite),await I.copy(g,v,{preserveSymlinks:!0})}catch(T){throw(T.code==="EINVAL"||T.code==="EBUSY"||T.code==="ENAMETOOLONG")&&(T=new Error(d.localize(3,null,_.basename(g),_.basename(_.dirname(v)),T.toString()))),this.toFileSystemProviderError(T)}}async validateTargetDeleted(n,s,u,g){const v=this.toFilePath(n),T=this.toFilePath(s);let R=!1;if(!!(this.capabilities&1024)||(R=y.isEqual(v,T,!0)),R&&u==="copy")throw P.createFileSystemProviderError(d.localize(4,null),P.FileSystemProviderErrorCode.FileExists);if(!R&&await I.exists(T)){if(!g)throw P.createFileSystemProviderError(d.localize(5,null),P.FileSystemProviderErrorCode.FileExists);await this.delete(s,{recursive:!0,useTrash:!1})}}watch(n,s){return s.recursive?this.watchRecursive(n,s.excludes):this.watchNonRecursive(n)}watchRecursive(n,s){const u={path:this.toFilePath(n),excludes:s},g=l.insert(this.recursiveFoldersToWatch,u);return this.refreshRecursiveWatchers(),E.toDisposable(()=>{g(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){var n,s,u;if(this.recursiveWatcher instanceof S.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if(E.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let g,v;((s=(n=this.options)===null||n===void 0?void 0:n.watcher)===null||s===void 0?void 0:s.usePolling)?(g=f.FileWatcher,v=(u=this.options)===null||u===void 0?void 0:u.watcher):this.recursiveFoldersToWatch.length===1?D.isWindows?g=c.FileWatcher:g=f.FileWatcher:g=S.FileWatcher,this.recursiveWatcher=new g(this.recursiveFoldersToWatch,T=>this._onDidChangeFile.fire(b.toFileChanges(T)),T=>{T.type==="error"&&this._onDidWatchErrorOccur.fire(T.message),this.logService[T.type](T.message)},this.logService.getLevel()===k.LogLevel.Trace,v),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===k.LogLevel.Trace)}))}}watchNonRecursive(n){const s=new w.FileWatcher(this.toFilePath(n),g=>this._onDidChangeFile.fire(b.toFileChanges(g)),g=>{g.type==="error"&&this._onDidWatchErrorOccur.fire(g.message),this.logService[g.type](g.message)},this.logService.getLevel()===k.LogLevel.Trace),u=this.logService.onDidChangeLogLevel(()=>{s.setVerboseLogging(this.logService.getLevel()===k.LogLevel.Trace)});return E.combinedDisposable(s,u)}toFilePath(n){return _.normalize(n.fsPath)}toFileSystemProviderError(n){if(n instanceof P.FileSystemProviderError)return n;let s;switch(n.code){case"ENOENT":s=P.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=P.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=P.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=P.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=P.FileSystemProviderErrorCode.NoPermissions;break;default:s=P.FileSystemProviderErrorCode.Unknown}return P.createFileSystemProviderError(n,s)}async toFileSystemProviderWriteError(n,s){let u=this.toFileSystemProviderError(s);if(n&&u.code===P.FileSystemProviderErrorCode.NoPermissions)try{const{stat:g}=await I.SymlinkSupport.stat(this.toFilePath(n));g.mode&128||(u=P.createFileSystemProviderError(s,P.FileSystemProviderErrorCode.FileWriteLocked))}catch(g){this.logService.trace(g)}return u}dispose(){super.dispose(),E.dispose(this.recursiveWatcher),this.recursiveWatcher=void 0,E.dispose(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}e.DiskFileSystemProvider=t}),define(le[45],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=E.createDecorator("productService")}),define(le[28],ce([0,1,11,111]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class p{constructor(){this.data=new Map}add(I,_){P.ok(E.isString(I)),P.ok(E.isObject(_)),P.ok(!this.data.has(I),"There is already an extension with this id"),this.data.set(I,_)}knows(I){return this.data.has(I)}as(I){return this.data.get(I)||null}}e.Registry=new p}),define(le[188],ce([0,1,28,7]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function p(_){return _.length>0&&_.charAt(_.length-1)==="#"?_.substring(0,_.length-1):_}class D{constructor(){this._onDidChangeSchema=new P.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(m,y){this.schemasById[p(m)]=y,this._onDidChangeSchema.fire(m)}notifySchemaChanged(m){this._onDidChangeSchema.fire(m)}getSchemaContributions(){return{schemas:this.schemasById}}}const I=new D;E.Registry.add(e.Extensions.JSONContribution,I)}),define(le[38],ce([0,1,138,7,28,11,188]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=void 0,e.Extensions={Configuration:"base.contributions.configuration"};var _;(function(S){S[S.APPLICATION=1]="APPLICATION",S[S.MACHINE=2]="MACHINE",S[S.WINDOW=3]="WINDOW",S[S.RESOURCE=4]="RESOURCE",S[S.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",S[S.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(_=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const m=p.Registry.as(I.Extensions.JSONContribution);class y{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new P.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new P.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(w,C=!0){this.registerConfigurations([w],C)}registerConfigurations(w,C=!0){const h=[];w.forEach(l=>{h.push(...this.validateAndRegisterProperties(l,C,l.extensionInfo)),this.configurationContributors.push(l),this.registerJSONConfiguration(l)}),m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(h)}deregisterConfigurations(w){const C=[],h=l=>{if(l.properties)for(const a in l.properties)C.push(a),delete this.configurationProperties[a],this.removeFromSchema(a,l.properties[a]);l.allOf&&l.allOf.forEach(a=>h(a))};for(const l of w){h(l);const a=this.configurationContributors.indexOf(l);a!==-1&&this.configurationContributors.splice(a,1)}m.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}registerDefaultConfigurations(w){const C=[],h=[];for(const l of w)for(const a in l)if(C.push(a),e.OVERRIDE_PROPERTY_PATTERN.test(a)){this.defaultValues[a]=Object.assign(Object.assign({},this.defaultValues[a]||{}),l[a]);const t={type:"object",default:this.defaultValues[a],description:E.localize(1,null,a),$ref:e.resourceLanguageSettingsSchemaId};h.push(k(a)),this.configurationProperties[a]=t,this.defaultLanguageConfigurationOverridesNode.properties[a]=t}else{this.defaultValues[a]=l[a];const t=this.configurationProperties[a];t&&(this.updatePropertyDefaultValue(a,t),this.updateSchema(a,t))}this.registerOverrideIdentifiers(h),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}deregisterDefaultConfigurations(w){const C=[];for(const h of w)for(const l in h)if(C.push(l),delete this.defaultValues[l],e.OVERRIDE_PROPERTY_PATTERN.test(l))delete this.configurationProperties[l],delete this.defaultLanguageConfigurationOverridesNode.properties[l];else{const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(C)}notifyConfigurationSchemaUpdated(...w){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(w){for(const C of w)this.overrideIdentifiers.add(C);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(w,C=!0,h,l=3){var a;l=D.isUndefinedOrNull(w.scope)?l:w.scope;let t=[],i=w.properties;if(i)for(let s in i){if(C&&f(s)){delete i[s];continue}const u=i[s];if(this.updatePropertyDefaultValue(s,u),e.OVERRIDE_PROPERTY_PATTERN.test(s)?u.scope=void 0:(u.scope=D.isUndefinedOrNull(u.scope)?l:u.scope,u.restricted=D.isUndefinedOrNull(u.restricted)?!!((a=h==null?void 0:h.restrictedConfigurations)===null||a===void 0?void 0:a.includes(s)):u.restricted),i[s].hasOwnProperty("included")&&!i[s].included){this.excludedConfigurationProperties[s]=i[s],delete i[s];continue}else this.configurationProperties[s]=i[s];!i[s].deprecationMessage&&i[s].markdownDeprecationMessage&&(i[s].deprecationMessage=i[s].markdownDeprecationMessage),t.push(s)}let n=w.allOf;if(n)for(let s of n)t.push(...this.validateAndRegisterProperties(s,C,h,l));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(w){const C=h=>{let l=h.properties;if(l)for(const t in l)this.updateSchema(t,l[t]);let a=h.allOf;a&&a.forEach(C)};C(w)}updateSchema(w,C){switch(e.allSettings.properties[w]=C,C.scope){case 1:e.applicationSettings.properties[w]=C;break;case 2:e.machineSettings.properties[w]=C;break;case 6:e.machineOverridableSettings.properties[w]=C;break;case 3:e.windowSettings.properties[w]=C;break;case 4:e.resourceSettings.properties[w]=C;break;case 5:e.resourceSettings.properties[w]=C,this.resourceLanguageSettingsSchema.properties[w]=C;break}}removeFromSchema(w,C){switch(delete e.allSettings.properties[w],C.scope){case 1:delete e.applicationSettings.properties[w];break;case 2:delete e.machineSettings.properties[w];break;case 6:delete e.machineOverridableSettings.properties[w];break;case 3:delete e.windowSettings.properties[w];break;case 4:case 5:delete e.resourceSettings.properties[w];break}}updateOverridePropertyPatternKey(){for(const w of this.overrideIdentifiers.values()){const C=`[${w}]`,h={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(C,h),e.allSettings.properties[C]=h,e.applicationSettings.properties[C]=h,e.machineSettings.properties[C]=h,e.machineOverridableSettings.properties[C]=h,e.windowSettings.properties[C]=h,e.resourceSettings.properties[C]=h}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(w,C){let h=this.defaultValues[w];D.isUndefined(h)&&(h=C.default),D.isUndefined(h)&&(h=d(C.type)),C.default=h}}const r="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(r);function k(S){return S.substring(1,S.length-1)}e.overrideIdentifierFromKey=k;function d(S){switch(Array.isArray(S)?S[0]:S){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const b=new y;p.Registry.add(e.Extensions.Configuration,b);function f(S){return S.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(S)?E.localize(5,null,S):b.getConfigurationProperties()[S]!==void 0?E.localize(6,null,S):null:E.localize(4,null)}e.validateProperty=f;function c(){const S=[],w=b.getConfigurationProperties();for(const C of Object.keys(w))S.push([C,w[C].scope]);return S.push(["launch",4]),S.push(["task",4]),S}e.getScopes=c}),define(le[32],ce([0,1,19,11,4,28,6,38]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=I.createDecorator("configurationService");function m(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof p.URI)}e.isConfigurationOverrides=m;var y;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(y=e.ConfigurationTarget||(e.ConfigurationTarget={}));function r(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=r;function k(i,n){const s=n?i?n.keys.filter(F=>i.keys.indexOf(F)===-1):[...n.keys]:[],u=i?n?i.keys.filter(F=>n.keys.indexOf(F)===-1):[...i.keys]:[],g=[];if(n&&i){for(const F of i.keys)if(n.keys.indexOf(F)!==-1){const B=w(i.contents,F),Z=w(n.contents,F);E.equals(B,Z)||g.push(F)}}const v=[],T=F=>{const B={};for(const Z of F)for(const ie of Z.identifiers)B[a(ie)]=Z;return B},R=n?T(n.overrides):{},o=i?T(i.overrides):{};if(Object.keys(R).length)for(const F of s){const B=R[F];B&&v.push([_.overrideIdentifierFromKey(F),B.keys])}if(Object.keys(o).length)for(const F of u){const B=o[F];B&&v.push([_.overrideIdentifierFromKey(F),B.keys])}if(Object.keys(R).length&&Object.keys(o).length)for(const F of g){const B=o[F],Z=R[F];if(B&&Z){const ie=k({contents:B.contents,keys:B.keys,overrides:[]},{contents:Z.contents,keys:Z.keys,overrides:[]});v.push([_.overrideIdentifierFromKey(F),[...ie.added,...ie.removed,...ie.updated]])}}return{added:s,removed:u,updated:g,overrides:v}}e.compare=k;function d(i,n){const s=[];for(const u of Object.keys(i))if(_.OVERRIDE_PROPERTY_PATTERN.test(u)){const g={};for(const v in i[u])g[v]=i[u][v];s.push({identifiers:[_.overrideIdentifierFromKey(u).trim()],keys:Object.keys(g),contents:b(g,n)})}return s}e.toOverrides=d;function b(i,n){const s=Object.create(null);for(let u in i)f(s,u,i[u],n);return s}e.toValuesTree=b;function f(i,n,s,u){const g=n.split("."),v=g.pop();let T=i;for(let R=0;R<g.length;R++){let o=g[R],F=T[o];switch(typeof F){case"undefined":F=T[o]=Object.create(null);break;case"object":break;default:u(`Ignoring ${n} as ${g.slice(0,R+1).join(".")} is ${JSON.stringify(F)}`);return}T=F}if(typeof T=="object"&&T!==null)try{T[v]=s}catch(R){u(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(T)}`)}else u(`Ignoring ${n} as ${g.join(".")} is ${JSON.stringify(T)}`)}e.addToValueTree=f;function c(i,n){const s=n.split(".");S(i,s)}e.removeFromValueTree=c;function S(i,n){const s=n.shift();if(n.length===0){delete i[s];return}if(Object.keys(i).indexOf(s)!==-1){const u=i[s];typeof u=="object"&&!Array.isArray(u)&&(S(u,n),Object.keys(u).length===0&&delete i[s])}}function w(i,n,s){function u(T,R){let o=T;for(const F of R){if(typeof o!="object"||o===null)return;o=o[F]}return o}const g=n.split("."),v=u(i,g);return typeof v=="undefined"?s:v}e.getConfigurationValue=w;function C(i,n,s){Object.keys(n).forEach(u=>{u!=="__proto__"&&(u in i?P.isObject(i[u])&&P.isObject(n[u])?C(i[u],n[u],s):s&&(i[u]=n[u]):i[u]=n[u])})}e.merge=C;function h(){const i=D.Registry.as(_.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}e.getConfigurationKeys=h;function l(){const i=Object.create(null),n=D.Registry.as(_.Extensions.Configuration).getConfigurationProperties();for(let s in n){let u=n[s].default;f(i,s,u,g=>console.error(`Conflict in default settings: ${g}`))}return i}e.getDefaultValues=l;function a(i){return`[${i}]`}e.keyFromOverrideIdentifier=a;function t(i,n,s){const u=i.inspect(n),g=i.inspect(s);return typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:typeof g.userValue!="undefined"||typeof g.workspaceValue!="undefined"||typeof g.workspaceFolderValue!="undefined"?g.value:u.defaultValue}e.getMigratedSettingValue=t}),define(le[189],ce([0,1,37,26,21,11,19,4,38,32,28,2,7]),function(x,e,E,P,p,D,I,_,m,y,r,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class b{constructor(t={},i=[],n=[]){this._contents=t,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(t){return t?y.getConfigurationValue(this.contents,t):this.contents}getOverrideValue(t,i){const n=this.getContentsForOverrideIdentifer(i);return n?t?y.getConfigurationValue(n,t):n:void 0}getKeysForOverrideIdentifier(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.keys;return[]}override(t){const i=this.getContentsForOverrideIdentifer(t);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const s of p.distinct([...Object.keys(this.contents),...Object.keys(i)])){let u=this.contents[s],g=i[s];g&&(typeof u=="object"&&typeof g=="object"?(u=I.deepClone(u),this.mergeContents(u,g)):u=g),n[s]=u}return new b(n,this.keys,this.overrides)}merge(...t){const i=I.deepClone(this.contents),n=I.deepClone(this.overrides),s=[...this.keys];for(const u of t){this.mergeContents(i,u.contents);for(const g of u.overrides){const[v]=n.filter(T=>p.equals(T.identifiers,g.identifiers));v?this.mergeContents(v.contents,g.contents):n.push(I.deepClone(g))}for(const g of u.keys)s.indexOf(g)===-1&&s.push(g)}return new b(i,s,n)}freeze(){return this.isFrozen=!0,this}mergeContents(t,i){for(const n of Object.keys(i)){if(n in t&&D.isObject(t[n])&&D.isObject(i[n])){this.mergeContents(t[n],i[n]);continue}t[n]=I.deepClone(i[n])}}checkAndFreeze(t){return this.isFrozen&&!Object.isFrozen(t)?I.deepFreeze(t):t}getContentsForOverrideIdentifer(t){for(const i of this.overrides)if(i.identifiers.indexOf(t)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(t,i){this.addKey(t),y.addToValueTree(this.contents,t,i,n=>{throw new Error(n)})}removeValue(t){this.removeKey(t)&&y.removeFromValueTree(this.contents,t)}addKey(t){let i=this.keys.length;for(let n=0;n<i;n++)t.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,t)}removeKey(t){let i=this.keys.indexOf(t);return i!==-1?(this.keys.splice(i,1),!0):!1}}e.ConfigurationModel=b;class f extends b{constructor(){const t=y.getDefaultValues(),i=y.getConfigurationKeys(),n=[];for(const s of Object.keys(t))m.OVERRIDE_PROPERTY_PATTERN.test(s)&&n.push({identifiers:[m.overrideIdentifierFromKey(s).trim()],keys:Object.keys(t[s]),contents:y.toValuesTree(t[s],u=>console.error(`Conflict in default settings file: ${u}`))});super(t,i,n)}}e.DefaultConfigurationModel=f;class c{constructor(t){this._name=t,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new b}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(t,i){if(!D.isUndefinedOrNull(t)){const n=this.doParseContent(t);this.parseRaw(n,i)}}reparse(t){this._raw&&this.parseRaw(this._raw,t)}parseRaw(t,i){this._raw=t;const{contents:n,keys:s,overrides:u,restricted:g}=this.doParseRaw(t,i);this._configurationModel=new b(n,s,u),this._restrictedConfigurations=g||[]}doParseContent(t){let i={},n=null,s=[],u=[],g=[];function v(R){Array.isArray(s)?s.push(R):n&&(s[n]=R)}let T={onObjectBegin:()=>{let R={};v(R),u.push(s),s=R,n=null},onObjectProperty:R=>{n=R},onObjectEnd:()=>{s=u.pop()},onArrayBegin:()=>{let R=[];v(R),u.push(s),s=R,n=null},onArrayEnd:()=>{s=u.pop()},onLiteralValue:v,onError:(R,o,F)=>{g.push({error:R,offset:o,length:F})}};if(t)try{E.visit(t,T),i=s[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return i}doParseRaw(t,i){const n=r.Registry.as(m.Extensions.Configuration).getConfigurationProperties(),s=this.filter(t,n,!0,i);t=s.raw;const u=y.toValuesTree(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`)),g=Object.keys(t),v=y.toOverrides(t,T=>console.error(`Conflict in settings file ${this._name}: ${T}`));return{contents:u,keys:g,overrides:v,restricted:s.restricted}}filter(t,i,n,s){if(!(s==null?void 0:s.scopes)&&!(s==null?void 0:s.skipRestricted))return{raw:t,restricted:[]};const u={},g=[];for(let v in t)if(m.OVERRIDE_PROPERTY_PATTERN.test(v)&&n){const T=this.filter(t[v],i,!1,s);u[v]=T.raw,g.push(...T.restricted)}else{const T=i[v],R=T?typeof T.scope!="undefined"?T.scope:3:void 0;(T==null?void 0:T.restricted)&&g.push(v),(R===void 0||s.scopes===void 0||s.scopes.includes(R))&&(s.skipRestricted&&(T==null?void 0:T.restricted)||(u[v]=t[v]))}return{raw:u,restricted:g}}}e.ConfigurationModelParser=c;class S extends k.Disposable{constructor(t,i,n,s){super();this.userSettingsResource=t,this.scopes=i,this.fileService=s,this._onDidChange=this._register(new d.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(d.Event.filter(this.fileService.onDidFilesChange,u=>u.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const t=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(t.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(t){return new b}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class w{constructor(t,i,n=new b,s=new b,u=new P.ResourceMap,g=new b,v=new P.ResourceMap,T=!0){this._defaultConfiguration=t,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=s,this._folderConfigurations=u,this._memoryConfiguration=g,this._memoryConfigurationByResource=v,this._freeze=T,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(t,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(t)}updateValue(t,i,n={}){let s;n.resource?(s=this._memoryConfigurationByResource.get(n.resource),s||(s=new b,this._memoryConfigurationByResource.set(n.resource,s))):s=this._memoryConfiguration,i===void 0?s.removeValue(t):s.setValue(t,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(t,i,n){const s=this.getConsolidateConfigurationModel(i,n),u=this.getFolderConfigurationModelForResource(i.resource,n),g=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,v=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._defaultConfiguration.freeze().getValue(t),T=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.userConfiguration.freeze().getValue(t),R=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.localUserConfiguration.freeze().getValue(t),o=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this.remoteUserConfiguration.freeze().getValue(t),F=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(t):this._workspaceConfiguration.freeze().getValue(t):void 0,B=u?i.overrideIdentifier?u.freeze().override(i.overrideIdentifier).getValue(t):u.freeze().getValue(t):void 0,Z=i.overrideIdentifier?g.override(i.overrideIdentifier).getValue(t):g.getValue(t),ie=s.getValue(t),Se=p.distinct(p.flatten(s.overrides.map(oe=>oe.identifiers))).filter(oe=>s.getOverrideValue(t,oe)!==void 0);return{defaultValue:v,userValue:T,userLocalValue:R,userRemoteValue:o,workspaceValue:F,workspaceFolderValue:B,memoryValue:Z,value:ie,default:v!==void 0?{value:this._defaultConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,user:T!==void 0?{value:this.userConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,userRemote:o!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspace:F!==void 0?{value:this._workspaceConfiguration.freeze().getValue(t),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,workspaceFolder:B!==void 0?{value:u==null?void 0:u.freeze().getValue(t),override:i.overrideIdentifier?u==null?void 0:u.freeze().getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,memory:Z!==void 0?{value:g.getValue(t),override:i.overrideIdentifier?g.getOverrideValue(t,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Se.length?Se:void 0}}keys(t){const i=this.getFolderConfigurationModelForResource(void 0,t);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(t){this._defaultConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(t){this._localUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(t){this._remoteUserConfiguration=t,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(t){this._workspaceConfiguration=t,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(t,i){this._folderConfigurations.set(t,i),this._foldersConsolidatedConfigurations.delete(t)}deleteFolderConfiguration(t){this.folderConfigurations.delete(t),this._foldersConsolidatedConfigurations.delete(t)}compareAndUpdateDefaultConfiguration(t,i){const n=i.filter(s=>m.OVERRIDE_PROPERTY_PATTERN.test(s)).map(s=>{const u=m.overrideIdentifierFromKey(s),g=this._defaultConfiguration.getKeysForOverrideIdentifier(u),v=t.getKeysForOverrideIdentifier(u),T=[...v.filter(R=>g.indexOf(R)===-1),...g.filter(R=>v.indexOf(R)===-1),...g.filter(R=>!I.equals(this._defaultConfiguration.override(u).getValue(R),t.override(u).getValue(R)))];return[u,T]});return this.updateDefaultConfiguration(t),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(t){const{added:i,updated:n,removed:s,overrides:u}=y.compare(this.localUserConfiguration,t),g=[...i,...n,...s];return g.length&&this.updateLocalUserConfiguration(t),{keys:g,overrides:u}}compareAndUpdateRemoteUserConfiguration(t){const{added:i,updated:n,removed:s,overrides:u}=y.compare(this.remoteUserConfiguration,t);let g=[...i,...n,...s];return g.length&&this.updateRemoteUserConfiguration(t),{keys:g,overrides:u}}compareAndUpdateWorkspaceConfiguration(t){const{added:i,updated:n,removed:s,overrides:u}=y.compare(this.workspaceConfiguration,t);let g=[...i,...n,...s];return g.length&&this.updateWorkspaceConfiguration(t),{keys:g,overrides:u}}compareAndUpdateFolderConfiguration(t,i){const n=this.folderConfigurations.get(t),{added:s,updated:u,removed:g,overrides:v}=y.compare(n,i);let T=[...s,...u,...g];return(T.length||!n)&&this.updateFolderConfiguration(t,i),{keys:T,overrides:v}}compareAndDeleteFolderConfiguration(t){const i=this.folderConfigurations.get(t);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(t);const{added:n,updated:s,removed:u,overrides:g}=y.compare(i,void 0);return{keys:[...n,...s,...u],overrides:g}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(t,i){let n=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier?n.override(t.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:t},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&t){const s=i.getFolder(t);s&&(n=this.getFolderConsolidatedConfiguration(s.uri)||n);const u=this._memoryConfigurationByResource.get(t);u&&(n=n.merge(u))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(t){let i=this._foldersConsolidatedConfigurations.get(t);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),s=this._folderConfigurations.get(t);s?(i=n.merge(s),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(t,i)):i=n}return i}getFolderConfigurationModelForResource(t,i){if(i&&t){const n=i.getFolder(t);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((t,i)=>{const{contents:n,overrides:s,keys:u}=this._folderConfigurations.get(i);return t.push([i,{contents:n,overrides:s,keys:u}]),t},[])}}allKeys(){const t=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>t.add(i)),this.userConfiguration.freeze().keys.forEach(i=>t.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>t.add(n))),[...t.values()]}getAllKeysForOverrideIdentifier(t){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(t).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(t).forEach(s=>i.add(s))),[...i.values()]}static parse(t){const i=this.parseConfigurationModel(t.defaults),n=this.parseConfigurationModel(t.user),s=this.parseConfigurationModel(t.workspace),u=t.folders.reduce((g,v)=>(g.set(_.URI.revive(v[0]),this.parseConfigurationModel(v[1])),g),new P.ResourceMap);return new w(i,n,new b,s,u,new b,new P.ResourceMap,!1)}static parseConfigurationModel(t){return new b(t.contents,t.keys,t.overrides).freeze()}}e.Configuration=w;function C(...a){if(a.length===0)return{keys:[],overrides:[]};if(a.length===1)return a[0];const t=new Set,i=new Map;for(const s of a)s.keys.forEach(u=>t.add(u)),s.overrides.forEach(([u,g])=>{const v=P.getOrSet(i,u,new Set);g.forEach(T=>v.add(T))});const n=[];return i.forEach((s,u)=>n.push([u,[...s.values()]])),{keys:[...t.values()],overrides:n}}e.mergeChanges=C;class h{constructor(t,i,n,s){this.change=t,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=s,this._previousConfiguration=void 0;const u=new Set;t.keys.forEach(v=>u.add(v)),t.overrides.forEach(([,v])=>v.forEach(T=>u.add(T))),this.affectedKeys=[...u.values()];const g=new b;this.affectedKeys.forEach(v=>g.setValue(v,{})),this.affectedKeysTree=g.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=w.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(t,i){var n;if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,t)){if(i){const s=this.previousConfiguration?this.previousConfiguration.getValue(t,i,(n=this.previous)===null||n===void 0?void 0:n.workspace):void 0,u=this.currentConfiguraiton.getValue(t,i,this.currentWorkspace);return!I.equals(s,u)}return!0}return!1}doesAffectedKeysTreeContains(t,i){let n=y.toValuesTree({[i]:!0},()=>{}),s;for(;typeof n=="object"&&(s=Object.keys(n)[0]);){if(t=t[s],!t)return!1;n=n[s]}return!0}}e.ConfigurationChangeEvent=h;class l extends h{constructor(t,i,n,s){super({keys:t.allKeys(),overrides:[]},void 0,t,i);this.source=n,this.sourceConfig=s}}e.AllKeysConfigurationChangeEvent=l}),define(le[96],ce([0,1,28,38,2,32,189,7,14,17]),function(x,e,E,P,p,D,I,_,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class r extends p.Disposable{constructor(d,b){super();this.settingsResource=d,this._onDidChangeConfiguration=this._register(new _.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new I.UserSettings(this.settingsResource,void 0,y.extUriBiasedIgnorePathCase,b)),this.configuration=new I.Configuration(new I.DefaultConfigurationModel,new I.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new m.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(E.Registry.as(P.Extensions.Configuration).onDidUpdateConfiguration(f=>this.onDidDefaultConfigurationChange(f))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const d=await this.userConfiguration.loadConfiguration();this.configuration=new I.Configuration(new I.DefaultConfigurationModel,d)}getConfigurationData(){return this.configuration.toData()}getValue(d,b){const f=typeof d=="string"?d:void 0,c=D.isConfigurationOverrides(d)?d:D.isConfigurationOverrides(b)?b:{};return this.configuration.getValue(f,c,void 0)}updateValue(d,b,f,c){return Promise.reject(new Error("not supported"))}inspect(d){return this.configuration.inspect(d,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const d=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(d)}onDidChangeUserConfiguration(d){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(d);this.trigger(f,b,1)}onDidDefaultConfigurationChange(d){const b=this.configuration.toData(),f=this.configuration.compareAndUpdateDefaultConfiguration(new I.DefaultConfigurationModel,d);this.trigger(f,b,6)}trigger(d,b,f){const c=new I.ConfigurationChangeEvent(d,{data:b},this.configuration);c.source=f,c.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(d){switch(d){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=r}),define(le[97],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=E.createDecorator("remoteAuthorityResolverService");var P;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(P=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class p extends Error{constructor(I,_=P.Unknown,m){super(I);this._message=I,this._code=_,this._detail=m,this.isHandled=_===P.NotAvailable&&m===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,p.prototype)}static isTemporarilyNotAvailable(I){return I instanceof p&&I._code===P.TemporarilyNotAvailable}static isNoResolverFound(I){return I instanceof p&&I._code===P.NoResolverFound}static isHandled(I){return I instanceof p&&I.isHandled}}e.RemoteAuthorityResolverError=p}),define(le[190],ce([0,1,8]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function P(y){return y.scheme===E.Schemas.vscodeRemote?y.authority:void 0}e.getRemoteAuthority=P;function p(y){if(!y)return;const r=y.indexOf("+");return r<0?y:y.substr(0,r)}e.getRemoteName=p;function D(y){return y.scheme!==E.Schemas.file&&y.scheme!==E.Schemas.vscodeRemote}e.isVirtualResource=D;function I(y){if(y.folders.length)return y.folders.every(r=>D(r.uri))?y.folders[0].uri:void 0;if(y.configuration&&D(y.configuration))return y.configuration}e.getVirtualWorkspaceLocation=I;function _(y){var r;return(r=I(y))===null||r===void 0?void 0:r.scheme}e.getVirtualWorkspaceScheme=_;function m(y){return I(y)!==void 0}e.isVirtualWorkspace=m}),define(le[64],ce([0,1,152,6,38,28,18]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=P.createDecorator("requestService");function _(f){return f.res.statusCode&&f.res.statusCode>=200&&f.res.statusCode<300||f.res.statusCode===1223}e.isSuccess=_;function m(f){return f.res.statusCode===204}async function y(f){if(!_(f))throw new Error("Server returned "+f.res.statusCode);return m(f)?null:(await I.streamToBuffer(f.stream)).toString()}e.asText=y;async function r(f){if(!_(f))throw new Error("Server returned "+f.res.statusCode);if(m(f))return null;const S=(await I.streamToBuffer(f.stream)).toString();try{return JSON.parse(S)}catch(w){throw w.message+=`:
`+S,w}}e.asJson=r;function k(f){b(f)}e.updateProxyConfigurationsScope=k;let d;function b(f){const c=D.Registry.as(p.Extensions.Configuration);d&&c.deregisterConfigurations([d]),d={id:"http",order:15,title:E.localize(0,null),type:"object",scope:f,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:E.localize(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:E.localize(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:E.localize(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[E.localize(4,null),E.localize(5,null),E.localize(6,null),E.localize(7,null)],default:"override",description:E.localize(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:E.localize(9,null),restricted:!0}}},c.registerConfiguration(d)}b(2)}),define(le[191],ce([0,1,29,18]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class p{constructor(_){this.service=_}listen(_,m){throw new Error("Invalid listen")}call(_,m,y){switch(m){case"request":return this.service.request(y[0],E.CancellationToken.None).then(async({res:r,stream:k})=>{const d=await P.streamToBuffer(k);return[{statusCode:r.statusCode,headers:r.headers},d]})}throw new Error("Invalid call")}}e.RequestChannel=p;class D{constructor(_){this.channel=_}async request(_,m){return D.request(this.channel,_,m)}static async request(_,m,y){const[r,k]=await _.call("request",[m]);return{res:r,stream:P.bufferToStream(k)}}}e.RequestChannelClient=D}),define(le[192],ce([0,1,65,11]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function p(I,_){return I.protocol==="http:"?_.HTTP_PROXY||_.http_proxy||null:I.protocol==="https:"&&(_.HTTPS_PROXY||_.https_proxy||_.HTTP_PROXY||_.http_proxy)||null}async function D(I,_,m={}){const y=E.parse(I),r=m.proxyUrl||p(y,_);if(!r)return null;const k=E.parse(r);if(!/^https?:$/.test(k.protocol||""))return null;const d={host:k.hostname||"",port:k.port||(k.protocol==="https"?"443":"80"),auth:k.auth,rejectUnauthorized:P.isBoolean(m.strictSSL)?m.strictSSL:!0};return y.protocol==="http:"?new(await new Promise((b,f)=>{x(["http-proxy-agent"],b,f)}))(d):new(await new Promise((b,f)=>{x(["https-proxy-agent"],b,f)}))(d)}e.getProxyAgent=D}),define(le[193],ce([0,1,22,18]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function p(D,I,_){let m=_&&_.get("storage.serviceMachineId",0)||null;if(m)return m;try{const r=(await I.readFile(D.serviceMachineIdResource)).value.toString();m=E.isUUID(r)?r:null}catch(y){m=null}if(!m){m=E.generateUuid();try{await I.writeFile(D.serviceMachineIdResource,P.VSBuffer.fromString(m))}catch(y){}}return _&&_.store("storage.serviceMachineId",m,0,1),m}e.getServiceMachineId=p}),define(le[194],ce([0,1,6,7,2,11,127,14]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const m="__$__targetStorageMarker";e.IStorageService=E.createDecorator("storageService");var y;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(y=e.WillSaveStateReason||(e.WillSaveStateReason={}));var r;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(r=e.StorageScope||(e.StorageScope={}));var k;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(k=e.StorageTarget||(e.StorageTarget={}));class d extends p.Disposable{constructor(S={flushInterval:d.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new P.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new P.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new P.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new _.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new p.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=_.runWhenIdle(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){p.dispose([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,w){w===m?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:w,target:this.getKeyTargets(S)[w]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,w,C){var h;return(h=this.getStorage(w))===null||h===void 0?void 0:h.get(S,C)}getBoolean(S,w,C){var h;return(h=this.getStorage(w))===null||h===void 0?void 0:h.getBoolean(S,C)}getNumber(S,w,C){var h;return(h=this.getStorage(w))===null||h===void 0?void 0:h.getNumber(S,C)}store(S,w,C,h){if(D.isUndefinedOrNull(w)){this.remove(S,C);return}this.withPausedEmitters(()=>{var l;this.updateKeyTarget(S,C,h),(l=this.getStorage(C))===null||l===void 0||l.set(S,w)})}remove(S,w){this.withPausedEmitters(()=>{var C;this.updateKeyTarget(S,w,void 0),(C=this.getStorage(w))===null||C===void 0||C.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,w){const C=[],h=this.getKeyTargets(S);for(const l of Object.keys(h))h[l]===w&&C.push(l);return C}updateKeyTarget(S,w,C){var h,l;const a=this.getKeyTargets(w);typeof C=="number"?a[S]!==C&&(a[S]=C,(h=this.getStorage(w))===null||h===void 0||h.set(m,JSON.stringify(a))):typeof a[S]=="number"&&(delete a[S],(l=this.getStorage(w))===null||l===void 0||l.set(m,JSON.stringify(a)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const w=this.get(m,S);if(w)try{return JSON.parse(w)}catch(C){}return Object.create(null)}isNew(S){return this.getBoolean(e.IS_NEW_KEY,S)===!0}async flush(){var S,w,C,h;this._onWillSaveState.fire({reason:y.NONE}),await _.Promises.settled([(w=(S=this.getStorage(0))===null||S===void 0?void 0:S.whenFlushed())!==null&&w!==void 0?w:Promise.resolve(),(h=(C=this.getStorage(1))===null||C===void 0?void 0:C.whenFlushed())!==null&&h!==void 0?h:Promise.resolve()])}async logStorage(){var S,w,C,h,l,a;const t=(w=(S=this.getStorage(0))===null||S===void 0?void 0:S.items)!==null&&w!==void 0?w:new Map,i=(h=(C=this.getStorage(1))===null||C===void 0?void 0:C.items)!==null&&h!==void 0?h:new Map;return f(t,i,(l=this.getLogDetails(0))!==null&&l!==void 0?l:"",(a=this.getLogDetails(1))!==null&&a!==void 0?a:"")}}e.AbstractStorageService=d,d.DEFAULT_FLUSH_INTERVAL=60*1e3;class b extends d{constructor(){super();this.globalStorage=new I.Storage(new I.InMemoryStorageDatabase),this.workspaceStorage=new I.Storage(new I.InMemoryStorageDatabase),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}e.InMemoryStorageService=b;async function f(c,S,w,C){const h=u=>{try{return JSON.parse(u)}catch(g){return u}},l=new Map,a=new Map;c.forEach((u,g)=>{l.set(g,u),a.set(g,h(u))});const t=new Map,i=new Map;S.forEach((u,g)=>{t.set(g,u),i.set(g,h(u))}),console.group(`Storage: Global (path: ${w})`);let n=[];l.forEach((u,g)=>{n.push({key:g,value:u})}),console.table(n),console.groupEnd(),console.log(a),console.group(`Storage: Workspace (path: ${C})`);let s=[];t.forEach((u,g)=>{s.push({key:g,value:u})}),console.table(s),console.groupEnd(),console.log(i)}e.logStorage=f}),define(le[195],ce([0,1,5,23,22,4]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function I(y){if(E.platform===2&&/^penguin(\.|$)/i.test(y))return"chromebook"}async function _(y,r,k,d,b,f,c,S,w,C){const h=Object.create(null);h["common.machineId"]=c,h.sessionID=p.generateUuid()+Date.now(),h.commitHash=b,h.version=f,h["common.platformVersion"]=(r||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),h["common.platform"]=E.PlatformToString(E.platform),h["common.nodePlatform"]=P.platform,h["common.nodeArch"]=d,h["common.product"]=C||"desktop";const l=m(S||[]);l&&(h["common.msftInternal"]=l);let a=0;const t=Date.now();Object.defineProperties(h,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),E.isLinuxSnap&&(h["common.snap"]="true");const i=I(k);i&&(h["common.platformDetail"]=i);try{const n=await y.readFile(D.URI.file(w));h["common.source"]=n.value.toString().slice(0,30)}catch(n){}return h}e.resolveCommonProperties=_;function m(y){const r=P.env.USERDNSDOMAIN;if(!r)return!1;const k=r.toLowerCase();return y.some(d=>k===d)}e.verifyMicrosoftInternalDomain=m}),define(le[196],ce([0,1,21,12,2,19]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ErrorEvent=void 0;var I;(function(m){function y(r,k){return r.callstack<k.callstack?-1:r.callstack>k.callstack?1:0}m.compare=y})(I=e.ErrorEvent||(e.ErrorEvent={}));class _{constructor(y,r=_.ERROR_FLUSH_TIMEOUT){this._flushHandle=-1,this._buffer=[],this._disposables=new p.DisposableStore,this._telemetryService=y,this._flushDelay=r;const k=P.errorHandler.addListener(d=>this._onErrorEvent(d));this._disposables.add(p.toDisposable(k)),this.installErrorListeners()}dispose(){clearTimeout(this._flushHandle),this._flushBuffer(),this._disposables.dispose()}installErrorListeners(){}_onErrorEvent(y){if(!y)return;y.detail&&y.detail.stack&&(y=y.detail);let r=Array.isArray(y.stack)?y.stack.join(`
`):y.stack,k=y.message?y.message:D.safeStringify(y);!r||this._enqueue({msg:k,callstack:r})}_enqueue(y){const r=E.binarySearch(this._buffer,y,I.compare);r<0?(y.count=1,this._buffer.splice(~r,0,y)):(this._buffer[r].count||(this._buffer[r].count=0),this._buffer[r].count+=1),this._flushHandle===-1&&(this._flushHandle=setTimeout(()=>{this._flushBuffer(),this._flushHandle=-1},this._flushDelay))}_flushBuffer(){for(let y of this._buffer)this._telemetryService.publicLogError2("UnhandledError",y);this._buffer.length=0}}e.default=_,_.ERROR_FLUSH_TIMEOUT=5*1e3}),define(le[39],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=E.createDecorator("telemetryService"),e.ICustomEndpointTelemetryService=E.createDecorator("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId"}),define(le[197],ce([0,1,24,79,178,25,3,37,82,45,5,4,39,51,8,20,15]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function w(t,i){const n=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],s=new Map,u=new Map,g=2e4;function v(o,F,B,Z){const ie=F.substring(o.length+1);return new Promise(async Se=>{var oe,q,ee;let G;try{G=await S.readdir(F,{withFileTypes:!0})}catch(A){Se();return}if(Z.count>=g){Z.count+=G.length,Z.maxReached=!0,Se();return}let z=G.length;if(z===0){Se();return}let L=G;Z.count+G.length>g&&(Z.maxReached=!0,z=g-Z.count,L=G.slice(0,z)),Z.count+=G.length;for(const A of L)if(A.isDirectory()){if(B.includes(A.name)||await v(o,I.join(F,A.name),B,Z),--z==0){Se();return}}else{const N=A.name.lastIndexOf(".");if(N>=0){const M=A.name.substring(N+1);M&&s.set(M,((oe=s.get(M))!==null&&oe!==void 0?oe:0)+1)}for(const M of n)((q=M.relativePathPattern)===null||q===void 0?void 0:q.test(ie))!==!1&&M.filePattern.test(A.name)&&u.set(M.tag,((ee=u.get(M.tag))!==null&&ee!==void 0?ee:0)+1);if(--z==0){Se();return}}})}const T={count:0,maxReached:!1};await v(t,t,i,T);const R=await l(t);return{configFiles:C(u),fileTypes:C(s),fileCount:T.count,maxFilesReached:T.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=w;function C(t){return[...b.Iterable.map(t.entries(),([i,n])=>({name:i,count:n}))].sort((i,n)=>n.count-i.count)}function h(){const t={os:`${E.type()} ${E.arch()} ${E.release()}`,memory:`${(E.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(P.virtualMachineHint.value()*100)}%`},i=E.cpus();return i&&i.length>0&&(t.cpus=`${i[0].model} (${i.length} x ${i[0].speed})`),t}e.getMachineInfo=h;function l(t){let i=new Map,n=I.join(t,".vscode","launch.json");return new Promise((s,u)=>{D.exists(n,g=>{if(g)D.readFile(n,(v,T)=>{if(v)return s([]);const R=[],o=_.parse(T.toString(),R);if(R.length)return console.log(`Unable to parse ${n}`),s([]);if(_.getNodeType(o)==="object"&&o.configurations)for(const F of o.configurations){const B=F.type;B&&(i.has(B)?i.set(B,i.get(B)+1):i.set(B,1))}return s(C(i))});else return s([])})})}e.collectLaunchConfigs=l;let a=class{constructor(i,n){this.telemetryService=i,this.productService=n}formatMachineInfo(i){const n=[];return n.push(`OS Version:       ${i.os}`),n.push(`CPUs:             ${i.cpus}`),n.push(`Memory (System):  ${i.memory}`),n.push(`VM:               ${i.vmHint}`),n.join(`
`)}formatEnvironment(i){const n=[];n.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),n.push(`OS Version:       ${E.type()} ${E.arch()} ${E.release()}`);const s=E.cpus();return s&&s.length>0&&n.push(`CPUs:             ${s[0].model} (${s.length} x ${s[0].speed})`),n.push(`Memory (System):  ${(E.totalmem()/c.ByteSize.GB).toFixed(2)}GB (${(E.freemem()/c.ByteSize.GB).toFixed(2)}GB free)`),r.isWindows||n.push(`Load (avg):       ${E.loadavg().map(u=>Math.round(u)).join(", ")}`),n.push(`VM:               ${Math.round(P.virtualMachineHint.value()*100)}%`),n.push(`Screen Reader:    ${i.screenReader?"yes":"no"}`),n.push(`Process Argv:     ${i.mainArguments.join(" ")}`),n.push(`GPU Status:       ${this.expandGPUFeatures(i.gpuFeatureStatus)}`),n.join(`
`)}async getPerformanceInfo(i,n){return Promise.all([m.listProcesses(i.mainPID),this.formatWorkspaceMetadata(i)]).then(async s=>{let[u,g]=s,v=this.formatProcessList(i,u);return n.forEach(T=>{if(p.isRemoteDiagnosticError(T))v+=`
${T.errorMessage}`,g+=`
${T.errorMessage}`;else if(v+=`

Remote: ${T.hostName}`,T.processes&&(v+=`
${this.formatProcessList(i,T.processes)}`),T.workspaceMetadata){g+=`
|  Remote: ${T.hostName}`;for(const R of Object.keys(T.workspaceMetadata)){const o=T.workspaceMetadata[R];let F=`${o.fileCount} files`;o.maxFilesReached&&(F=`more than ${F}`),g+=`|    Folder (${R}): ${F}`,g+=this.formatWorkspaceStats(o)}}}),{processInfo:v,workspaceInfo:g}})}async getSystemInfo(i,n){const{memory:s,vmHint:u,os:g,cpus:v}=h(),T={os:g,memory:s,cpus:v,vmHint:u,processArgs:`${i.mainArguments.join(" ")}`,gpuStatus:i.gpuFeatureStatus,screenReader:`${i.screenReader?"yes":"no"}`,remoteData:n};return r.isWindows||(T.load=`${E.loadavg().map(R=>Math.round(R)).join(", ")}`),r.isLinux&&(T.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(T)}async getDiagnostics(i,n){const s=[];return m.listProcesses(i.mainPID).then(async u=>(s.push(""),s.push(this.formatEnvironment(i)),s.push(""),s.push(this.formatProcessList(i,u)),i.windows.some(g=>g.folderURIs&&g.folderURIs.length>0&&!g.remoteAuthority)&&(s.push(""),s.push("Workspace Stats: "),s.push(await this.formatWorkspaceMetadata(i))),n.forEach(g=>{if(p.isRemoteDiagnosticError(g))s.push(`
${g.errorMessage}`);else if(s.push(`

`),s.push(`Remote:           ${g.hostName}`),s.push(this.formatMachineInfo(g.machineInfo)),g.processes&&s.push(this.formatProcessList(i,g.processes)),g.workspaceMetadata)for(const v of Object.keys(g.workspaceMetadata)){const T=g.workspaceMetadata[v];let R=`${T.fileCount} files`;T.maxFilesReached&&(R=`more than ${R}`),s.push(`Folder (${v}): ${R}`),s.push(this.formatWorkspaceStats(T))}}),s.push(""),s.push(""),s.join(`
`)))}formatWorkspaceStats(i){const n=[],s=60;let u=0;const g=(o,F)=>{const B=` ${o}(${F})`;u+B.length>s?(n.push(v),v="|                 ",u=v.length):u+=B.length,v+=B};let v="|      File types:";const T=10;let R=i.fileTypes.length>T?T:i.fileTypes.length;for(let o=0;o<R;o++){const F=i.fileTypes[o];g(F.name,F.count)}if(n.push(v),i.configFiles.length>=0&&(v="|      Conf files:",u=0,i.configFiles.forEach(o=>{g(o.name,o.count)}),n.push(v)),i.launchConfigFiles.length>0){let o="|      Launch Configs:";i.launchConfigFiles.forEach(F=>{o+=F.count>1?` ${F.name}(${F.count})`:` ${F.name}`}),n.push(o)}return n.join(`
`)}expandGPUFeatures(i){const n=Math.max(...Object.keys(i).map(s=>s.length));return Object.keys(i).map(s=>`${s}:  ${" ".repeat(n-s.length)}  ${i[s]}`).join(`
                  `)}formatWorkspaceMetadata(i){const n=[],s=[];return i.windows.forEach(u=>{u.folderURIs.length===0||!!u.remoteAuthority||(n.push(`|  Window (${u.title})`),u.folderURIs.forEach(g=>{const v=k.URI.revive(g);if(v.scheme===f.Schemas.file){const T=v.fsPath;s.push(w(T,["node_modules",".git"]).then(R=>{let o=`${R.fileCount} files`;R.maxFilesReached&&(o=`more than ${o}`),n.push(`|    Folder (${I.basename(T)}): ${o}`),n.push(this.formatWorkspaceStats(R))}).catch(R=>{n.push(`|      Error: Unable to collect workspace stats for folder ${T} (${R.toString()})`)}))}else n.push(`|    Folder (${v.toString()}): Workspace stats not available.`)}))}),Promise.all(s).then(u=>n.join(`
`)).catch(u=>`Unable to collect workspace stats: ${u}`)}formatProcessList(i,n){const s=new Map;i.windows.forEach(g=>s.set(g.pid,g.title));const u=[];return u.push("CPU %	Mem MB	   PID	Process"),n&&this.formatProcessItem(i.mainPID,s,u,n,0),u.join(`
`)}formatProcessItem(i,n,s,u,g){const v=g===0;let T;v?T=u.pid===i?`${this.productService.applicationName} main`:"remote agent":(T=`${"  ".repeat(g)} ${u.name}`,u.name==="window"&&(T=`${T} (${n.get(u.pid)})`));const R=process.platform==="win32"?u.mem:E.totalmem()*(u.mem/100);s.push(`${u.load.toFixed(0).padStart(5," ")}	${(R/c.ByteSize.MB).toFixed(0).padStart(6," ")}	${u.pid.toFixed(0).padStart(6," ")}	${T}`),Array.isArray(u.children)&&u.children.forEach(o=>this.formatProcessItem(i,n,s,o,g+1))}async reportWorkspaceStats(i){for(const{uri:n}of i.folders){const s=k.URI.revive(n);if(s.scheme!==f.Schemas.file)continue;const u=s.fsPath;try{const g=await w(u,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":i.telemetryId,rendererSessionId:i.rendererSessionId}),g.fileTypes.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),g.launchConfigFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})}),g.configFiles.forEach(v=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:i.rendererSessionId,type:v.name,count:v.count})})}catch(g){}}}};a=Ne([Ke(0,d.ITelemetryService),Ke(1,y.IProductService)],a),e.DiagnosticsService=a}),define(le[98],ce([0,1,12,33,34,19,39,64,57,27,29,16,20,4,45,194,193,6,17]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryService=void 0;var h;(function(L){L[L.None=0]="None",L[L.IncludeVersions=1]="IncludeVersions",L[L.IncludeFiles=2]="IncludeFiles",L[L.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",L[L.IncludeSharedAccounts=8]="IncludeSharedAccounts",L[L.IncludeVersionProperties=16]="IncludeVersionProperties",L[L.ExcludeNonValidated=32]="ExcludeNonValidated",L[L.IncludeInstallationTargets=64]="IncludeInstallationTargets",L[L.IncludeAssetUri=128]="IncludeAssetUri",L[L.IncludeStatistics=256]="IncludeStatistics",L[L.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",L[L.Unpublished=4096]="Unpublished"})(h||(h={}));function l(...L){return String(L.reduce((A,N)=>A|N,0))}var a;(function(L){L[L.Tag=1]="Tag",L[L.ExtensionId=4]="ExtensionId",L[L.Category=5]="Category",L[L.ExtensionName=7]="ExtensionName",L[L.Target=8]="Target",L[L.Featured=9]="Featured",L[L.SearchText=10]="SearchText",L[L.ExcludeWithFlags=12]="ExcludeWithFlags"})(a||(a={}));const t={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},i={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},s={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:h.None,criteria:[],assetTypes:[]};class u{constructor(A=s){this.state=A}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(A,N=this.state.pageSize){return new u(Object.assign(Object.assign({},this.state),{pageNumber:A,pageSize:N}))}withFilter(A,...N){const M=[...this.state.criteria,...N.length?N.map(W=>({filterType:A,value:W})):[{filterType:A}]];return new u(Object.assign(Object.assign({},this.state),{criteria:M}))}withSortBy(A){return new u(Object.assign(Object.assign({},this.state),{sortBy:A}))}withSortOrder(A){return new u(Object.assign(Object.assign({},this.state),{sortOrder:A}))}withFlags(...A){return new u(Object.assign(Object.assign({},this.state),{flags:A.reduce((N,M)=>N|M,0)}))}withAssetTypes(...A){return new u(Object.assign(Object.assign({},this.state),{assetTypes:A}))}get raw(){const{criteria:A,pageNumber:N,pageSize:M,sortBy:W,sortOrder:X,flags:ae,assetTypes:se}=this.state;return{filters:[{criteria:A,pageNumber:N,pageSize:M,sortBy:W,sortOrder:X}],assetTypes:se,flags:ae}}get searchText(){const A=this.state.criteria.filter(N=>N.filterType===a.SearchText)[0];return A&&A.value?A.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(A=>String(A.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function g(L,A){const N=(L||[]).filter(M=>M.statisticName===A)[0];return N?N.value:0}function v(L){const A="Microsoft.VisualStudio.Code.Translation.";return L.files.filter(M=>M.assetType.indexOf(A)===0).reduce((M,W)=>{const X=F(L,W.assetType);return X&&M.push([W.assetType.substring(A.length),X]),M},[])}function T(L){if(L.properties){const A=L.properties.filter(W=>W.key===t.Repository),N=new RegExp("((git|ssh|http(s)?)|(git@[w.]+))(:(//)?)([w.@:/-~]+)(.git)(/)?"),M=A.filter(W=>N.test(W.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return F(L,t.Repository)}function R(L){return{uri:`${L.fallbackAssetUri}/${t.VSIX}?redirect=true`,fallbackUri:`${L.fallbackAssetUri}/${t.VSIX}`}}function o(L){const A=F(L,t.Icon);if(A)return A;const N=P.DefaultIconPath;return{uri:N,fallbackUri:N}}function F(L,A){return L.files.filter(M=>M.assetType===A)[0]?{uri:`${L.assetUri}/${A}`,fallbackUri:`${L.fallbackAssetUri}/${A}`}:null}function B(L,A){const N=L.properties?L.properties.filter(W=>W.key===A):[],M=N.length>0&&N[0].value;return M?M.split(",").map(W=>p.adoptToGalleryExtensionId(W)):[]}function Z(L){const A=L.properties?L.properties.filter(N=>N.key===i.Engine):[];return A.length>0&&A[0].value||""}function ie(L){const A=L.properties?L.properties.filter(M=>M.key===i.LocalizedLanguages):[],N=A.length>0&&A[0].value||"";return N?N.split(","):[]}function Se(L){return L.indexOf("preview")!==-1}function oe(L){const A=L.properties?L.properties.find(N=>N.key===i.WebExtension):void 0;return!!A&&A.value==="true"}function q(L){return L.files.some(A=>A.assetType.startsWith("Microsoft.VisualStudio.Code.WebResources"))?C.joinPath(b.URI.parse(L.assetUri),"Microsoft.VisualStudio.Code.WebResources","extension"):void 0}function ee(L,A,N,M,W){const X={manifest:F(A,t.Manifest),readme:F(A,t.Details),changelog:F(A,t.Changelog),license:F(A,t.License),repository:T(A),download:R(A),icon:o(A),coreTranslations:v(A)};return{identifier:{id:p.getGalleryExtensionId(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},name:L.extensionName,version:A.version,date:A.lastUpdated,displayName:L.displayName,publisherId:L.publisher.publisherId,publisher:L.publisher.publisherName,publisherDisplayName:L.publisher.displayName,description:L.shortDescription||"",installCount:g(L.statistics,"install"),rating:g(L.statistics,"averagerating"),ratingCount:g(L.statistics,"ratingcount"),assetUri:b.URI.parse(A.assetUri),webResource:q(A),assetTypes:A.files.map(({assetType:ae})=>ae),assets:X,properties:{dependencies:B(A,i.Dependency),extensionPack:B(A,i.ExtensionPack),engine:Z(A),localizedLanguages:ie(A),webExtension:oe(A)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+N,querySource:W},preview:Se(L.flags)}}let G=class{constructor(A,N,M,W,X,ae,se){this.requestService=A,this.logService=N,this.environmentService=M,this.telemetryService=W,this.fileService=X,this.productService=ae;const be=ae.extensionsGallery;this.extensionsGalleryUrl=be&&be.serviceUrl,this.extensionsControlUrl=be&&be.controlUrl,this.commonHeadersPromise=z(ae.version,this.environmentService,this.fileService,se)}api(A=""){return`${this.extensionsGalleryUrl}${A}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(A,N){const M=[];let{total:W,firstPage:X,getPage:ae}=await this.query({names:A,pageSize:A.length},N);M.push(...X);for(let se=1;M.length<W&&(X=await ae(se,N),X.length);se++)M.push(...X);return M}async getCompatibleExtension(A,N){const M=await this.getCompatibleExtensionByEngine(A,N);return(M==null?void 0:M.properties.webExtension)?M.webResource?M:null:M}async getCompatibleExtensionByEngine(A,N){const M=P.isIExtensionIdentifier(A)?null:A;if(M&&M.properties.engine&&m.isEngineValid(M.properties.engine,this.productService.version,this.productService.date))return M;const{id:W,uuid:X}=M?M.identifier:A;let ae=new u().withFlags(h.IncludeAssetUri,h.IncludeStatistics,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");X?ae=ae.withFilter(a.ExtensionId,X):ae=ae.withFilter(a.ExtensionName,W);const{galleryExtensions:se}=await this.queryGallery(ae,r.CancellationToken.None),[be]=se;if(!be||!be.versions.length)return null;if(N){const Te=be.versions.filter(Le=>Le.version===N)[0];if(Te){const Le=ee(be,Te,0,ae);if(Le.properties.engine&&m.isEngineValid(Le.properties.engine,this.productService.version,this.productService.date))return Le}return null}const ke=await this.getLastValidExtensionVersion(be,be.versions);return ke?ee(be,ke,0,ae):null}async query(A,N){const M=r.CancellationToken.isCancellationToken(A)?{}:A,W=r.CancellationToken.isCancellationToken(A)?A:N;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let X=M.text||"";const ae=D.getOrDefault(M,je=>je.pageSize,50);let se=new u().withFlags(h.IncludeLatestVersionOnly,h.IncludeAssetUri,h.IncludeStatistics,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,ae).withFilter(a.Target,"Microsoft.VisualStudio.Code");X?(X=X.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(je,Xe,Ze)=>(se=se.withFilter(a.Category,Ze||Xe),"")),X=X.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(je,Xe,Ze)=>(se=se.withFilter(a.Tag,Ze||Xe),"")),X=X.replace(/\bfeatured(\s+|\b|$)/g,()=>(se=se.withFilter(a.Featured),"")),X=X.trim(),X&&(X=X.length<200?X:X.substring(0,200),se=se.withFilter(a.SearchText,X)),se=se.withSortBy(0)):M.ids?se=se.withFilter(a.ExtensionId,...M.ids):M.names?se=se.withFilter(a.ExtensionName,...M.names):se=se.withSortBy(4),typeof M.sortBy=="number"&&(se=se.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(se=se.withSortOrder(M.sortOrder));const{galleryExtensions:be,total:ke}=await this.queryGallery(se,W),Te=be.map((je,Xe)=>ee(je,je.versions[0],Xe,se,M.source)),Le=async(je,Xe)=>{if(Xe.isCancellationRequested)throw E.canceled();const Ze=se.withPage(je+1),{galleryExtensions:it}=await this.queryGallery(Ze,Xe);return it.map((Ye,ge)=>ee(Ye,Ye.versions[0],ge,Ze,M.source))};return{firstPage:Te,total:ke,pageSize:se.pageSize,getPage:Le}}async queryGallery(A,N){if(!this.isEnabled())throw new Error("No extension gallery service configured.");A=A.withFlags(A.flags,h.ExcludeNonValidated).withFilter(a.ExcludeWithFlags,l(h.Unpublished));const M=await this.commonHeadersPromise,W=JSON.stringify(A.raw),X=Object.assign(Object.assign({},M),{"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)}),ae=new Date().getTime();let se,be,ke=0;try{if(se=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:W,headers:X},N),se.res.statusCode&&se.res.statusCode>=400&&se.res.statusCode<500)return{galleryExtensions:[],total:ke};const Te=await _.asJson(se);if(Te){const Le=Te.results[0],je=Le.extensions,Xe=Le.resultMetadata&&Le.resultMetadata.filter(Ze=>Ze.metadataType==="ResultCount")[0];return ke=Xe&&Xe.metadataItems.filter(Ze=>Ze.name==="TotalCount")[0].count||0,{galleryExtensions:je,total:ke}}return{galleryExtensions:[],total:ke}}catch(Te){throw be=Te,Te}finally{this.telemetryService.publicLog2("galleryService:query",Object.assign(Object.assign({},A.telemetryData),{requestBodySize:String(W.length),duration:new Date().getTime()-ae,success:!!se&&_.isSuccess(se),responseBodySize:se==null?void 0:se.res.headers["Content-Length"],statusCode:se?String(se.res.statusCode):void 0,errorCode:be?E.isPromiseCanceledError(be)?"canceled":E.getErrorMessage(be).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ke)}))}}async reportStatistic(A,N,M,W){if(!this.isEnabled())return;const X=await this.commonHeadersPromise,ae=Object.assign(Object.assign({},X),{Accept:"*/*;api-version=4.0-preview.1"});try{await this.requestService.request({type:"POST",url:this.api(`/publishers/${A}/extensions/${N}/${M}/stats?statType=${W}`),headers:ae},r.CancellationToken.None)}catch(se){}}async download(A,N,M){this.logService.trace("ExtensionGalleryService#download",A.identifier.id);const W=p.getGalleryExtensionTelemetryData(A),X=new Date().getTime(),ae=Te=>this.telemetryService.publicLog("galleryService:downloadVSIX",Object.assign(Object.assign({},W),{duration:Te})),se=M===1?"install":M===2?"update":"",be=se?{uri:`${A.assets.download.uri}&${se}=true`,fallbackUri:`${A.assets.download.fallbackUri}?${se}=true`}:A.assets.download,ke=await this.getAsset(be);await this.fileService.writeFile(N,ke.stream),ae(new Date().getTime()-X)}async getReadme(A,N){if(A.assets.readme){const M=await this.getAsset(A.assets.readme,{},N);return await _.asText(M)||""}return""}async getManifest(A,N){if(A.assets.manifest){const M=await this.getAsset(A.assets.manifest,{},N),W=await _.asText(M);return W?JSON.parse(W):null}return null}async getCoreTranslation(A,N){const M=A.assets.coreTranslations.filter(W=>W[0]===N.toUpperCase())[0];if(M){const W=await this.getAsset(M[1]),X=await _.asText(W);return X?JSON.parse(X):null}return null}async getChangelog(A,N){if(A.assets.changelog){const M=await this.getAsset(A.assets.changelog,{},N);return await _.asText(M)||""}return""}async getAllVersions(A,N){let M=new u().withFlags(h.IncludeVersions,h.IncludeFiles,h.IncludeVersionProperties).withPage(1,1).withFilter(a.Target,"Microsoft.VisualStudio.Code");A.identifier.uuid?M=M.withFilter(a.ExtensionId,A.identifier.uuid):M=M.withFilter(a.ExtensionName,A.identifier.id);const W=[],{galleryExtensions:X}=await this.queryGallery(M,r.CancellationToken.None);return X.length&&(N?await Promise.all(X[0].versions.map(async ae=>{let se;try{se=await this.getEngine(ae)}catch(be){}se&&m.isEngineValid(se,this.productService.version,this.productService.date)&&W.push({version:ae.version,date:ae.lastUpdated})})):W.push(...X[0].versions.map(ae=>({version:ae.version,date:ae.lastUpdated})))),W}async getAsset(A,N={},M=r.CancellationToken.None){const W=await this.commonHeadersPromise,X={type:"GET"},ae=Object.assign(Object.assign({},W),N.headers||{});N=Object.assign(Object.assign(Object.assign({},N),X),{headers:ae});const se=A.uri,be=A.fallbackUri,ke=Object.assign(Object.assign({},N),{url:se});try{const Te=await this.requestService.request(ke,M);if(Te.res.statusCode===200)return Te;const Le=await _.asText(Te);throw new Error(`Expected 200, got back ${Te.res.statusCode} instead.

${Le}`)}catch(Te){if(E.isPromiseCanceledError(Te))throw Te;const Le=E.getErrorMessage(Te);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:se,message:Le});const je=Object.assign(Object.assign({},N),{url:be});return this.requestService.request(je,M)}}async getLastValidExtensionVersion(A,N){const M=this.getLastValidExtensionVersionFromProperties(A,N);return M||this.getLastValidExtensionVersionRecursively(A,N)}getLastValidExtensionVersionFromProperties(A,N){for(const M of N){const W=Z(M);if(!W)return null;if(m.isEngineValid(W,this.productService.version,this.productService.date))return M}return null}async getEngine(A){const N=Z(A);if(N)return N;const M=F(A,t.Manifest);if(!M)throw new Error("Manifest was not found");const W={"Accept-Encoding":"gzip"},X=await this.getAsset(M,{headers:W}),ae=await _.asJson(X);if(ae)return ae.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(A,N){if(!N.length)return null;const M=N[0],W=await this.getEngine(M);return m.isEngineValid(W,this.productService.version,this.productService.date)?Object.assign(Object.assign({},M),{properties:[...M.properties||[],{key:i.Engine,value:W}]}):this.getLastValidExtensionVersionRecursively(A,N.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const A=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},r.CancellationToken.None);if(A.res.statusCode!==200)throw new Error("Could not get extensions report.");const N=await _.asJson(A),M=new Map;if(N)for(const W of N.malicious){const X=M.get(W)||{id:{id:W},malicious:!0,slow:!1};X.malicious=!0,M.set(W,X)}return[...M.values()]}};G=Ne([Ke(0,_.IRequestService),Ke(1,k.ILogService),Ke(2,y.IEnvironmentService),Ke(3,I.ITelemetryService),Ke(4,d.IFileService),Ke(5,f.IProductService),Ke(6,w.optional(c.IStorageService))],G),e.ExtensionGalleryService=G;async function z(L,A,N,M){const W={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L}`},X=await S.getServiceMachineId(A,N,M);return W["X-Market-User-Id"]=X,W}e.resolveMarketplaceHeaders=z}),define(le[198],ce([0,1,31,153,13,6,32,38,2,19,28]),function(x,e,E,P,p,D,I,_,m,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let k=class{constructor(f,c){this._configurationService=c,this._experimentProperties={},this._disposables=new m.DisposableStore,this._cleanupPatterns=[],this._appender=f.appender,this._commonProperties=f.commonProperties||Promise.resolve({}),this._piiPaths=f.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!f.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp(p.escapeRegExpCharacters(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const w=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!w})}))}setExperimentProperty(f,c){this._experimentProperties[f]=c}setEnabled(f){this._enabled=f}_updateUserOptIn(){var f;const c=(f=this._configurationService)===null||f===void 0?void 0:f.getValue(d);this._userOptIn=c?c.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const f=await this._commonProperties;let c=f.sessionID,S=f["common.instanceId"],w=f["common.machineId"],C=f["common.firstSessionDate"],h=f["common.msftInternal"];return{sessionId:c,instanceId:S,machineId:w,firstSessionDate:C,msftInternal:h}}dispose(){this._disposables.dispose()}publicLog(f,c,S){return this.isOptedIn?this._commonProperties.then(w=>{c=y.mixin(c,w),c=y.mixin(c,this._experimentProperties),c=y.cloneAndChange(c,C=>{if(typeof C=="string")return this._cleanupInfo(C,S)}),this._appender.log(f,c)},w=>{console.error(w)}):Promise.resolve(void 0)}publicLog2(f,c,S){return this.publicLog(f,c,S)}publicLogError(f,c){return this.sendErrorTelemetry?this.publicLog(f,c,!0):Promise.resolve(void 0)}publicLogError2(f,c){return this.publicLogError(f,c)}_cleanupInfo(f,c){let S=f;if(c){const w=[];for(let a of this._cleanupPatterns)for(;;){const t=a.exec(f);if(!t)break;w.push([t.index,a.lastIndex])}const C=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,h=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let l=0;for(S="";;){const a=h.exec(f);if(!a)break;!C.test(a[0])&&w.every(([t,i])=>a.index<t||a.index>=i)&&(S+=f.substring(l,a.index)+"<REDACTED: user-file-path>",l=h.lastIndex)}l<f.length&&(S+=f.substr(l))}for(let w of this._cleanupPatterns)S=S.replace(w,"");return S}};k.IDLE_START_EVENT_NAME="UserIdleStart",k.IDLE_STOP_EVENT_NAME="UserIdleStop",k=Ne([Ke(1,D.optional(I.IConfigurationService))],k),e.TelemetryService=k;const d="telemetry";r.Registry.as(_.Extensions.Configuration).registerConfiguration({id:d,order:110,type:"object",title:P.localize(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:E.default.privacyStatementUrl?P.localize(2,null,E.default.privacyStatementUrl):P.localize(1,null),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices"]}}})}),define(le[66],ce([0,1,32,19,11,14]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.configurationTelemetry=e.NullAppender=e.combinedAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=void 0,e.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(f,c){return Promise.resolve(void 0)}publicLog2(f,c){return this.publicLog(f,c)}publicLogError(f,c){return Promise.resolve(void 0)}publicLogError2(f,c){return this.publicLogError(f,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class I{async publicLog(c,S,w){}async publicLogError(c,S,w){}}e.NullEndpointTelemetryService=I;function _(...f){return{log:(c,S)=>f.forEach(w=>w.log(c,S)),flush:()=>D.Promises.settled(f.map(c=>c.flush()))}}e.combinedAppender=_,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function m(f,c){return c.onDidChangeConfiguration(S=>{S.source!==6&&f.publicLog2("updateConfiguration",{configurationSource:E.ConfigurationTargetToString(S.source),configurationKeys:d(S.sourceConfig)})})}e.configurationTelemetry=m;function y(f){const c=Object.create(null),S=Object.create(null),w=Object.create(null);k(f,w);for(let C in w){C=C.length>150?C.substr(C.length-149):C;const h=w[C];typeof h=="number"?S[C]=h:typeof h=="boolean"?S[C]=h?1:0:typeof h=="string"?c[C]=h.substring(0,1023):typeof h!="undefined"&&h!==null&&(c[C]=h)}return{properties:c,measurements:S}}e.validateTelemetryData=y;function r(f){if(!f)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(w=>{f.indexOf(`${w}+`)===0&&(c=w)}),c}e.cleanRemoteAuthority=r;function k(f,c,S=0,w){if(!!f)for(let C of Object.getOwnPropertyNames(f)){const h=f[C],l=w?w+C:C;Array.isArray(h)?c[l]=P.safeStringify(h):h instanceof Date?c[l]=h.toISOString():p.isObject(h)?S<2?k(h,c,S+1,l+"."):c[l]=P.safeStringify(h):c[l]=h}}function d(f){if(!f)return[];const c=[];return b(c,"",f),c}function b(f,c,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(w=>b(f,c?`${c}.${w}`:w,S[w])):f.push(c)}}),define(le[199],ce([0,1,12,19,66]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AppInsightsAppender=void 0;async function D(_){const m=await new Promise((r,k)=>{x(["applicationinsights"],r,k)});let y;return m.defaultClient?(y=new m.TelemetryClient(_),y.channel.setUseDiskRetryCaching(!0)):(m.setup(_).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),y=m.defaultClient),_.indexOf("AIF-")===0&&(y.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),y}class I{constructor(m,y,r){this._eventPrefix=m,this._defaultData=y,this._defaultData||(this._defaultData=Object.create(null)),typeof r=="function"?this._aiClient=r():this._aiClient=r,this._asyncAIClient=null}_withAIClient(m){if(!!this._aiClient){if(typeof this._aiClient!="string"){m(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=D(this._aiClient)),this._asyncAIClient.then(y=>{m(y)},y=>{E.onUnexpectedError(y),console.error(y)})}}log(m,y){!this._aiClient||(y=P.mixin(y,this._defaultData),y=p.validateTelemetryData(y),this._withAIClient(r=>r.trackEvent({name:this._eventPrefix+"/"+m,properties:y.properties,measurements:y.measurements})))}flush(){return this._aiClient?new Promise(m=>{this._withAIClient(y=>{y.flush({callback:()=>{this._aiClient=void 0,m(void 0)}})})}):Promise.resolve(void 0)}}e.AppInsightsAppender=I}),define(le[200],ce([0,1,12,196]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class p extends P.default{installErrorListeners(){E.setUnexpectedErrorHandler(_=>console.error(_));const I=[];process.on("unhandledRejection",(_,m)=>{I.push(m),setTimeout(()=>{const y=I.indexOf(m);y>=0&&m.catch(r=>{I.splice(y,1),console.warn(`rejected promise not handled within 1 second: ${r}`),r.stack&&console.warn(`stack trace: ${r.stack}`),E.onUnexpectedError(_)})},1e3)}),process.on("rejectionHandled",_=>{const m=I.indexOf(_);m>=0&&I.splice(m,1)}),process.on("uncaughtException",_=>{E.onUnexpectedError(_)})}}e.default=p}),define(le[99],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.HeartbeatConstants=e.IPtyService=e.ILocalTerminalService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var P;(function(d){d.Shell="terminal.integrated.shell.",d.ShellArgs="terminal.integrated.shellArgs.",d.DefaultProfile="terminal.integrated.defaultProfile.",d.Profiles="terminal.integrated.profiles."})(P=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var p;(function(d){d.ShellLinux="terminal.integrated.shell.linux",d.ShellMacOs="terminal.integrated.shell.osx",d.ShellWindows="terminal.integrated.shell.windows",d.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",d.AutomationShellLinux="terminal.integrated.automationShell.linux",d.AutomationShellMacOs="terminal.integrated.automationShell.osx",d.AutomationShellWindows="terminal.integrated.automationShell.windows",d.ShellArgsLinux="terminal.integrated.shellArgs.linux",d.ShellArgsMacOs="terminal.integrated.shellArgs.osx",d.ShellArgsWindows="terminal.integrated.shellArgs.windows",d.ProfilesWindows="terminal.integrated.profiles.windows",d.ProfilesMacOs="terminal.integrated.profiles.osx",d.ProfilesLinux="terminal.integrated.profiles.linux",d.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",d.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",d.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",d.UseWslProfiles="terminal.integrated.useWslProfiles",d.TabsEnabled="terminal.integrated.tabs.enabled",d.TabsHideCondition="terminal.integrated.tabs.hideCondition",d.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",d.TabsLocation="terminal.integrated.tabs.location",d.TabsFocusMode="terminal.integrated.tabs.focusMode",d.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",d.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",d.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",d.CopyOnSelection="terminal.integrated.copyOnSelection",d.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",d.FontFamily="terminal.integrated.fontFamily",d.FontSize="terminal.integrated.fontSize",d.LetterSpacing="terminal.integrated.letterSpacing",d.LineHeight="terminal.integrated.lineHeight",d.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",d.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",d.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",d.BellDuration="terminal.integrated.bellDuration",d.FontWeight="terminal.integrated.fontWeight",d.FontWeightBold="terminal.integrated.fontWeightBold",d.CursorBlinking="terminal.integrated.cursorBlinking",d.CursorStyle="terminal.integrated.cursorStyle",d.CursorWidth="terminal.integrated.cursorWidth",d.Scrollback="terminal.integrated.scrollback",d.DetectLocale="terminal.integrated.detectLocale",d.GpuAcceleration="terminal.integrated.gpuAcceleration",d.RightClickBehavior="terminal.integrated.rightClickBehavior",d.Cwd="terminal.integrated.cwd",d.ConfirmOnExit="terminal.integrated.confirmOnExit",d.EnableBell="terminal.integrated.enableBell",d.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",d.AllowChords="terminal.integrated.allowChords",d.AllowMnemonics="terminal.integrated.allowMnemonics",d.EnvMacOs="terminal.integrated.env.osx",d.EnvLinux="terminal.integrated.env.linux",d.EnvWindows="terminal.integrated.env.windows",d.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",d.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",d.ShowExitAlert="terminal.integrated.showExitAlert",d.SplitCwd="terminal.integrated.splitCwd",d.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",d.WordSeparators="terminal.integrated.wordSeparators",d.TitleMode="terminal.integrated.titleMode",d.EnableFileLinks="terminal.integrated.enableFileLinks",d.UnicodeVersion="terminal.integrated.unicodeVersion",d.ExperimentalLinkProvider="terminal.integrated.experimentalLinkProvider",d.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",d.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",d.LocalEchoStyle="terminal.integrated.localEchoStyle",d.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",d.InheritEnv="terminal.integrated.inheritEnv"})(p=e.TerminalSettingId||(e.TerminalSettingId={}));var D;(function(d){d.CommandPrompt="cmd",d.PowerShell="pwsh",d.Wsl="wsl",d.GitBash="gitbash"})(D=e.WindowsShellType||(e.WindowsShellType={}));var I;(function(d){d[d.Api=0]="Api",d[d.Process=1]="Process",d[d.Sequence=2]="Sequence"})(I=e.TitleEventSource||(e.TitleEventSource={}));var _;(function(d){d.LocalPty="localPty",d.PtyHost="ptyHost",d.Log="log",d.Heartbeat="heartbeat"})(_=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.ILocalTerminalService=E.createDecorator("localTerminalService"),e.IPtyService=E.createDecorator("ptyService");var m;(function(d){d[d.BeatInterval=5e3]="BeatInterval",d[d.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",d[d.SecondWaitMultiplier=1]="SecondWaitMultiplier",d[d.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(m=e.HeartbeatConstants||(e.HeartbeatConstants={}));var y;(function(d){d[d.GraceTime=6e4]="GraceTime",d[d.ShortGraceTime=6e3]="ShortGraceTime"})(y=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var r;(function(d){d[d.HighWatermarkChars=1e5]="HighWatermarkChars",d[d.LowWatermarkChars=5e3]="LowWatermarkChars",d[d.CharCountAckSize=5e3]="CharCountAckSize"})(r=e.FlowControlConstants||(e.FlowControlConstants={}));var k;(function(d){d.GitBash="Git Bash",d.Pwsh="PowerShell"})(k=e.ProfileSource||(e.ProfileSource={}))}),define(le[201],ce([0,1,24,3,23,15,11,19,5]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findExecutable=e.getWindowsBuildNumber=void 0;function y(){const k=/(\d+)\.(\d+)\.(\d+)/g.exec(E.release());let d=0;return k&&k.length===4&&(d=parseInt(k[3])),d}e.getWindowsBuildNumber=y;async function r(k,d,b,f=p.env,c=D.exists){if(P.isAbsolute(k))return await c(k)?k:void 0;if(d===void 0&&(d=p.cwd()),P.dirname(k)!=="."){const h=P.join(d,k);return await c(h)?h:void 0}const w=_.getCaseInsensitive(f,"PATH");if(b===void 0&&I.isString(w)&&(b=w.split(P.delimiter)),b===void 0||b.length===0){const h=P.join(d,k);return await c(h)?h:void 0}for(let h of b){let l;if(P.isAbsolute(h)?l=P.join(h,k):l=P.join(d,h,k),await c(l))return l;if(m.isWindows){let a=l+".com";if(await c(a)||(a=l+".exe",await c(a)))return a}}const C=P.join(d,k);return await c(C)?C:void 0}e.findExecutable=r}),define(le[202],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var E;(function(P){P.DARK="dark",P.LIGHT="light",P.HIGH_CONTRAST="hc"})(E=e.ColorScheme||(e.ColorScheme={}))}),define(le[100],ce([0,1,6,2,28,7,202,41]),function(x,e,E,P,p,D,I,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=E.createDecorator("themeService");var m;(function(S){function w(C){return C&&typeof C=="object"&&typeof C.id=="string"}S.isThemeColor=w})(m=e.ThemeColor||(e.ThemeColor={}));function y(S){return{id:S}}e.themeColorFromId=y;var r;(function(S){function w(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||m.isThemeColor(i.color))}S.isThemeIcon=w;const C=new RegExp(`^\\$\\((${_.CSSIcon.iconNameExpression}(?:${_.CSSIcon.iconModifierExpression})?)\\)$`);function h(i){const n=C.exec(i);if(!n)return;let[,s]=n;return{id:s}}S.fromString=h;function l(i,n){let s=i.id;const u=s.lastIndexOf("~");return u!==-1&&(s=s.substring(0,u)),n&&(s=`${s}~${n}`),{id:s}}S.modify=l;function a(i,n){var s,u;return i.id===n.id&&((s=i.color)===null||s===void 0?void 0:s.id)===((u=n.color)===null||u===void 0?void 0:u.id)}S.isEqual=a;function t(i){return{id:i.id}}S.asThemeIcon=t,S.asClassNameArray=_.CSSIcon.asClassNameArray,S.asClassName=_.CSSIcon.asClassName,S.asCSSSelector=_.CSSIcon.asCSSSelector})(r=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=_.Codicon.file,e.FolderThemeIcon=_.Codicon.folder;function k(S){switch(S){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=k,e.Extensions={ThemingContribution:"base.contributions.theming"};class d{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new D.Emitter}onColorThemeChange(w){return this.themingParticipants.push(w),this.onThemingParticipantAddedEmitter.fire(w),P.toDisposable(()=>{const C=this.themingParticipants.indexOf(w);this.themingParticipants.splice(C,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let b=new d;p.Registry.add(e.Extensions.ThemingContribution,b);function f(S){return b.onColorThemeChange(S)}e.registerThemingParticipant=f;class c extends P.Disposable{constructor(w){super();this.themeService=w,this.theme=w.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(C=>this.onThemeChange(C)))}onThemeChange(w){this.theme=w,this.updateStyles()}updateStyles(){}getColor(w,C){let h=this.theme.getColor(w);return h&&C&&(h=C(h,this.theme)),h?h.toString():null}}e.Themable=c}),define(le[203],ce([0,1,38,154,28,41,100]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=void 0;const _={args:{description:P.localize(0,null),type:"array",items:{type:"string"}},overrideName:{description:P.localize(1,null),type:"boolean"},icon:{description:P.localize(2,null),type:"string",enum:Array.from(D.iconRegistry.all,w=>w.id),markdownEnumDescriptions:Array.from(D.iconRegistry.all,w=>`$(${w.id})`)},color:{description:P.localize(3,null),type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},env:{markdownDescription:P.localize(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},m={type:"object",required:["path"],properties:Object.assign({path:{description:P.localize(5,null),type:["string","array"],items:{type:"string"}}},_)},y=P.localize(6,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),r=P.localize(7,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),k=P.localize(8,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),d={id:"terminal",order:100,title:P.localize(9,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:P.localize(10,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:P.localize(11,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:P.localize(12,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:P.localize(13,null),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:P.localize(14,null),type:["string","null"],default:null,markdownDeprecationMessage:r},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:P.localize(15,null),type:["string","null"],default:null,markdownDeprecationMessage:k},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:P.localize(16,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:y},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:P.localize(17,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:r},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:P.localize(18,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:P.localize(19,null)}},{type:"string",markdownDescription:P.localize(20,null)}],default:[],markdownDeprecationMessage:k},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:P.localize(21,null,"`source`","`path`","`args`."),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:Object.assign({source:{description:P.localize(22,null),enum:["PowerShell","Git Bash"]}},_)},{type:"null"},m]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:P.localize(23,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},m]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:P.localize(24,null,"`path`","`args`."),type:"object",default:{bash:{path:"bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"null"},m]}},["terminal.integrated.useWslProfiles"]:{description:P.localize(25,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:P.localize(26,null),type:"boolean",default:!0}}};function b(){p.Registry.as(E.Extensions.Configuration).registerConfiguration(d),c()}e.registerTerminalPlatformConfiguration=b;let f;function c(w){const C=p.Registry.as(E.Extensions.Configuration);f&&C.deregisterConfigurations([f]);let h,l;if(w){const a=w.profiles.map(t=>({name:t.profileName,description:S(t)}));h=a.map(t=>t.name),l=a.map(t=>t.description)}f={id:"terminal",order:100,title:P.localize(27,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:P.localize(28,null,"`#terminal.integrated.shell.linux#`","`#terminal.integrated.shellArgs.linux#`"),type:["string","null"],default:null,enum:(w==null?void 0:w.os)===3?h:void 0,markdownEnumDescriptions:(w==null?void 0:w.os)===3?l:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:P.localize(29,null,"`#terminal.integrated.shell.osx#`","`#terminal.integrated.shellArgs.osx#`"),type:["string","null"],default:null,enum:(w==null?void 0:w.os)===2?h:void 0,markdownEnumDescriptions:(w==null?void 0:w.os)===2?l:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:P.localize(30,null,"`#terminal.integrated.shell.windows#`","`#terminal.integrated.shellArgs.windows#`"),type:["string","null"],default:null,enum:(w==null?void 0:w.os)===1?h:void 0,markdownEnumDescriptions:(w==null?void 0:w.os)===1?l:void 0}}},C.registerConfiguration(f)}e.registerTerminalDefaultProfileConfiguration=c;function S(w){let C=`$(${I.ThemeIcon.isThemeIcon(w.icon)?w.icon.id:w.icon?w.icon:D.Codicon.terminal.id}) ${w.profileName}
- path: ${w.path}`;return w.args&&(typeof w.args=="string"?C+=`
- args: "${w.args}"`:C+=`
- args: [${w.args.length===0?"":w.args.join("','")}]`),w.overrideName!==void 0&&(C+=`
- overrideName: ${w.overrideName}`),w.color&&(C+=`
- color: ${w.color}`),w.env&&(C+=`
- env: ${JSON.stringify(w.env)}`),C}});var Ct=this&&this.__asyncValues||function(x){if(!Symbol.asyncIterator)throw new TypeError("Symbol.asyncIterator is not defined.");var e=x[Symbol.asyncIterator],E;return e?e.call(x):(x=typeof __values=="function"?__values(x):x[Symbol.iterator](),E={},P("next"),P("throw"),P("return"),E[Symbol.asyncIterator]=function(){return this},E);function P(D){E[D]=x[D]&&function(I){return new Promise(function(_,m){I=x[D](I),p(_,m,I.done,I.value)})}}function p(D,I,_,m){Promise.resolve(m).then(function(y){D({value:y,done:_})},I)}};define(le[204],ce([0,1,3,81,201,35,15,41,5,100]),function(x,e,E,P,p,D,I,_,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let r;function k(a,t,i,n,s,u,g,v){return s=s||{existsFile:I.SymlinkSupport.existsFile,readFile:I.Promises.readFile},m.isWindows?d(i,s,u,n.getValue("terminal.integrated.useWslProfiles")!==!1,a&&typeof a=="object"?Object.assign({},a):n.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:n.getValue("terminal.integrated.defaultProfile.windows"),v,g):C(s,u,i,a&&typeof a=="object"?Object.assign({},a):n.getValue(m.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:n.getValue(m.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),v,g)}e.detectAvailableProfiles=k;async function d(a,t,i,n,s,u,g,v){const T=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),R=`${process.env.windir}\\${T?"Sysnative":"System32"}`;let o=!1;p.getWindowsBuildNumber()>=16299&&(o=!0),await f(g);const F=new Map;a&&(F.set("PowerShell",{source:"PowerShell",icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Windows PowerShell",{path:`${R}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:_.Codicon.terminalPowershell,isAutoDetected:!0}),F.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),F.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),F.set("Command Prompt",{path:`${R}\\cmd.exe`,icon:_.Codicon.terminalCmd,isAutoDetected:!0})),h(s,F);const B=await b(F.entries(),u,t,i,v);if(a||!a&&n)try{const Z=await S(`${R}\\${o?"wsl":"bash"}.exe`,u);for(const ie of Z)(!s||!(ie.profileName in s))&&B.push(ie)}catch(Z){i==null||i.info("WSL is not installed, so could not detect WSL profiles")}return B}async function b(a,t,i,n,s){const u=[];for(const[g,v]of a){if(v===null)continue;let T,R,o;if("source"in v){const Z=r==null?void 0:r.get(v.source);if(!Z)continue;T=Z.paths,R=v.args||Z.args,v.icon?o=v.icon:Z.icon&&(o=Z.icon)}else T=Array.isArray(v.path)?v.path:[v.path],R=m.isWindows||Array.isArray(v.args)?v.args:void 0,o=v.icon||void 0;const F=await(s==null?void 0:s(T))||T.slice(),B=await l(g,t,F,i,R,v.env,v.overrideName,v.isAutoDetected,n);B?(B.isAutoDetected=v.isAutoDetected,B.icon=o,B.color=v.color,u.push(B)):n==null||n.trace("profile not validated",g,T)}return u}async function f(a){r||(r=new Map,r.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),r.set("PowerShell",{profileName:"PowerShell",paths:a||await c(),icon:y.ThemeIcon.asThemeIcon(_.Codicon.terminalPowershell)}))}async function c(){var a,t;const i=[];try{for(var n=Ct(P.enumeratePowerShellInstallations()),s;s=await n.next(),!s.done;){const u=s.value;i.push(u.exePath)}}catch(u){a={error:u}}finally{try{s&&!s.done&&(t=n.return)&&await t.call(n)}finally{if(a)throw a.error}}return i}async function S(a,t){const i=[],n=await new Promise((g,v)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le"},(T,R)=>{if(T)return v("Problem occurred when getting wsl distros");g(R)})});if(!n)return[];const s=new RegExp(/[\r?\n]/),u=n.split(s).filter(g=>g.trim().length>0&&g!=="");for(const g of u){if(g===""||g.startsWith("docker-desktop"))continue;const v=`${g} (WSL)`,T={profileName:v,path:a,args:["-d",`${g}`],isDefault:v===t,icon:w(g)};i.push(T)}return i}function w(a){return a.includes("Ubuntu")?y.ThemeIcon.asThemeIcon(_.Codicon.terminalUbuntu):a.includes("Debian")?y.ThemeIcon.asThemeIcon(_.Codicon.terminalDebian):y.ThemeIcon.asThemeIcon(_.Codicon.terminalLinux)}async function C(a,t,i,n,s,u,g){const v=new Map;if(i){const T=(await a.readFile("/etc/shells")).toString(),R=u||T.split(`
`).filter(F=>F.trim().indexOf("#")!==0&&F.trim().length>0),o=new Map;for(const F of R){let B=E.basename(F),Z=o.get(B)||0;Z++,Z>1&&(B=`${B} (${Z})`),o.set(B,Z),v.set(B,{path:F,isAutoDetected:!0})}}return h(n,v),await b(v.entries(),s,a,t,g)}function h(a,t){if(!!a)for(const[i,n]of Object.entries(a))n===null||!("path"in n)&&!("source"in n)?t.delete(i):t.set(i,n)}async function l(a,t,i,n,s,u,g,v,T){if(i.length===0)return Promise.resolve(void 0);const R=i.shift();if(R==="")return l(a,t,i,n,s,u,g,v);const o={profileName:a,path:R,args:s,env:u,overrideName:g,isAutoDetected:v,isDefault:a===t};if(E.basename(R)===R){const B=process.env.PATH?process.env.PATH.split(E.delimiter):void 0;return await p.findExecutable(R,void 0,B,void 0,n.existsFile)?o:l(a,t,i,n,s)}return await n.existsFile(E.normalize(R))?o:l(a,t,i,n,s,u,g,v)}}),define(le[205],ce([0,1,2,16,99,55,8,36,7,92,39,204,32,203]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var f;(function(C){C[C.MaxRestarts=5]="MaxRestarts"})(f||(f={}));let c=0,S=0,w=class extends E.Disposable{constructor(h,l,a,t){super();this._reconnectConstants=h,this._configurationService=l,this._logService=a,this._telemetryService=t,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new m.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new m.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new m.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new m.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new m.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new m.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessExit=this._register(new m.Emitter),this.onProcessExit=this._onProcessExit.event,this._onProcessReady=this._register(new m.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new m.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessTitleChanged=this._register(new m.Emitter),this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessShellTypeChanged=this._register(new m.Emitter),this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event,this._onProcessOverrideDimensions=this._register(new m.Emitter),this.onProcessOverrideDimensions=this._onProcessOverrideDimensions.event,this._onProcessResolvedShellLaunchConfig=this._register(new m.Emitter),this.onProcessResolvedShellLaunchConfig=this._onProcessResolvedShellLaunchConfig.event,this._onProcessOrphanQuestion=this._register(new m.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._pendingResolveVariablesRequests=new Map,b.registerTerminalPlatformConfiguration(),this._register(E.toDisposable(()=>this._disposePtyHost())),[this._client,this._proxy]=this._startPtyHost()}_startPtyHost(){const h=new D.Client(I.FileAccess.asFileUri("bootstrap-fork",x).fsPath,{serverName:"Pty Host",args:["--type=ptyHost"],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.GraceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.ShortGraceTime}});this._onPtyHostStart.fire(),_.ProxyChannel.toService(h.getChannel(p.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(h.onDidProcessExit(i=>{this._telemetryService.publicLog("ptyHost/exit"),this._onPtyHostExit.fire(i.code),this._isDisposed||(this._restartCount<=f.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${i.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${i.code}, giving up`))}));const a=h.getChannel(p.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(a,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(a,this._logService.getLevel())}));const t=_.ProxyChannel.toService(h.getChannel(p.TerminalIpcChannels.PtyHost));return this._register(t.onProcessData(i=>this._onProcessData.fire(i))),this._register(t.onProcessExit(i=>this._onProcessExit.fire(i))),this._register(t.onProcessReady(i=>this._onProcessReady.fire(i))),this._register(t.onProcessTitleChanged(i=>this._onProcessTitleChanged.fire(i))),this._register(t.onProcessShellTypeChanged(i=>this._onProcessShellTypeChanged.fire(i))),this._register(t.onProcessOverrideDimensions(i=>this._onProcessOverrideDimensions.fire(i))),this._register(t.onProcessResolvedShellLaunchConfig(i=>this._onProcessResolvedShellLaunchConfig.fire(i))),this._register(t.onProcessReplay(i=>this._onProcessReplay.fire(i))),this._register(t.onProcessOrphanQuestion(i=>this._onProcessOrphanQuestion.fire(i))),[h,t]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(h,l,a,t,i,n,s,u,g,v){const T=setTimeout(()=>this._handleUnresponsiveCreateProcess(),p.HeartbeatConstants.CreateProcessTimeout),R=await this._proxy.createProcess(h,l,a,t,i,n,s,u,g,v);return clearTimeout(T),c=Math.max(c,R),R}updateTitle(h,l,a){return this._proxy.updateTitle(h,l,a)}updateIcon(h,l,a){return this._proxy.updateIcon(h,l,a)}attachToProcess(h){return this._proxy.attachToProcess(h)}detachFromProcess(h){return this._proxy.detachFromProcess(h)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(h){return this._proxy.start(h)}shutdown(h,l){return this._proxy.shutdown(h,l)}input(h,l){return this._proxy.input(h,l)}processBinary(h,l){return this._proxy.processBinary(h,l)}resize(h,l,a){return this._proxy.resize(h,l,a)}acknowledgeDataEvent(h,l){return this._proxy.acknowledgeDataEvent(h,l)}getInitialCwd(h){return this._proxy.getInitialCwd(h)}getCwd(h){return this._proxy.getCwd(h)}getLatency(h){return this._proxy.getLatency(h)}orphanQuestionReply(h){return this._proxy.orphanQuestionReply(h)}getDefaultSystemShell(h){return this._proxy.getDefaultSystemShell(h)}async getProfiles(h,l,a=!1){return k.detectAvailableProfiles(h,l,a,this._configurationService,void 0,this._logService,this._resolveVariables.bind(this))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(h){return this._proxy.getWslPath(h)}setTerminalLayoutInfo(h){return this._proxy.setTerminalLayoutInfo(h)}async getTerminalLayoutInfo(h){return await this._proxy.getTerminalLayoutInfo(h)}async restartPtyHost(){this._telemetryService.publicLog("ptyHost/restart"),this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll&&this._proxy.shutdownAll(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._telemetryService.publicLog("ptyHost/responsive"),this._isResponsive=!0),this._onPtyHostResponsive.fire()}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier+p.HeartbeatConstants.BeatInterval*p.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._telemetryService.publicLog("ptyHost/unresponsive"),this._isResponsive=!1),this._onPtyHostUnresponsive.fire()}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${p.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._telemetryService.publicLog("ptyHost/responsive"),this._onPtyHostUnresponsive.fire()}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(h){return new Promise(l=>{const a=++S;this._pendingResolveVariablesRequests.set(a,l),this._onPtyHostRequestResolveVariables.fire({id:a,originalText:h})})}async acceptPtyHostResolvedVariables(h,l){const a=this._pendingResolveVariablesRequests.get(h);a?(a(l),this._pendingResolveVariablesRequests.delete(h)):this._logService.warn(`Resolved variables received without matching request ${h}`)}};w=Ne([Ke(1,d.IConfigurationService),Ke(2,P.ILogService),Ke(3,r.ITelemetryService)],w),e.PtyHostService=w}),define(le[101],ce([0,1,4,17,6,26]),function(x,e,E,P,p,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=p.createDecorator("contextService");var I;(function(d){d[d.EMPTY=1]="EMPTY",d[d.FOLDER=2]="FOLDER",d[d.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function _(d){const b=d;return!!(b&&typeof b=="object"&&typeof b.id=="string"&&Array.isArray(b.folders))}e.isWorkspace=_;function m(d){const b=d;return!!(b&&typeof b=="object"&&E.URI.isUri(b.uri)&&typeof b.name=="string"&&typeof b.toResource=="function")}e.isWorkspaceFolder=m;class y{constructor(b,f,c,S){this._id=b,this._configuration=c,this._ignorePathCasing=S,this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=f}update(b){this._id=b.id,this._configuration=b.configuration,this._ignorePathCasing=b._ignorePathCasing,this.folders=b.folders}get folders(){return this._folders}set folders(b){this._folders=b,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(b){this._configuration=b}getFolder(b){return b&&this._foldersMap.findSubstr(b.with({scheme:b.scheme,authority:b.authority,path:b.path}))||null}updateFoldersMap(){this._foldersMap=D.TernarySearchTree.forUris(this._ignorePathCasing);for(const b of this.folders)this._foldersMap.set(b.uri,b)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=y;class r{constructor(b,f){this.raw=f,this.uri=b.uri,this.index=b.index,this.name=b.name}toResource(b){return P.joinPath(this.uri,b)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=r;function k(d){return new r({uri:d,index:0,name:P.basenameOrAuthority(d)},{uri:d.toString()})}e.toWorkspaceFolder=k}),define(le[206],ce([0,1,6,155,101,4,5,3,17,113,37,8,52,30,190]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const c=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:P.localize(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function S(q){return(typeof q=="string"?_.extname(q):m.extname(q))===c}e.hasWorkspaceFileExtension=S,e.IWorkspacesService=E.createDecorator("workspacesService");function w(q){return q.hasOwnProperty("workspace")}e.isRecentWorkspace=w;function C(q){return q.hasOwnProperty("folderUri")}e.isRecentFolder=C;function h(q){return q.hasOwnProperty("fileUri")}e.isRecentFile=h;function l(q){const ee=q;return typeof(ee==null?void 0:ee.id)=="string"&&D.URI.isUri(ee.uri)}e.isSingleFolderWorkspaceIdentifier=l;function a(q){if(q.configuration)return{id:q.id,configPath:q.configuration};if(q.folders.length===1)return{id:q.id,uri:q.folders[0].uri}}e.toWorkspaceIdentifier=a;function t(q){const ee=q;return typeof(ee==null?void 0:ee.id)=="string"&&D.URI.isUri(ee.configPath)}e.isWorkspaceIdentifier=t;function i(q){const ee=q;if(ee==null?void 0:ee.uri)return{id:ee.id,uri:D.URI.revive(ee.uri)};const G=q;if(G==null?void 0:G.configPath)return{id:G.id,configPath:D.URI.revive(G.configPath)};if(q==null?void 0:q.id)return{id:q.id}}e.reviveIdentifier=i;function n(q,ee){return m.extUriBiasedIgnorePathCase.isEqualOrParent(q,ee.untitledWorkspacesHome)}e.isUntitledWorkspace=n;function s(q){return u(q)||g(q)}e.isStoredWorkspaceFolder=s;function u(q){const ee=q;return typeof(ee==null?void 0:ee.path)=="string"&&(!ee.name||typeof ee.name=="string")}e.isRawFileWorkspaceFolder=u;function g(q){const ee=q;return typeof(ee==null?void 0:ee.uri)=="string"&&(!ee.name||typeof ee.name=="string")}e.isRawUriWorkspaceFolder=g;function v(q,ee,G,z,L=!I.isWindows,A){if(q.scheme!==z.scheme)return{name:G,uri:q.toString(!0)};let N=ee?void 0:A.relativePath(z,q);if(N!==void 0)N.length===0?N=".":I.isWindows&&q.scheme===k.Schemas.file&&!L&&(N=N.replace(/\//g,"\\"));else if(q.scheme===k.Schemas.file)N=q.fsPath,I.isWindows&&(N=d.normalizeDriveLetter(N),L&&(N=b.toSlashes(N)));else{if(!A.isEqualAuthority(q.authority,z.authority))return{name:G,uri:q.toString(!0)};N=q.path}return{name:G,path:N}}e.getStoredWorkspaceFolder=v;function T(q,ee,G){let z=[],L=new Set;const A=G.dirname(ee);for(let N of q){let M;if(u(N))N.path&&(M=G.resolvePath(A,N.path));else if(g(N))try{M=D.URI.parse(N.uri),M.path[0]!=="/"&&(M=M.with({path:"/"+M.path}))}catch(W){console.warn(W)}if(M){let W=G.getComparisonKey(M);if(!L.has(W)){L.add(W);const X=N.name||G.basenameOrAuthority(M);z.push(new p.WorkspaceFolder({uri:M,name:X,index:z.length},N))}}}return z}e.toWorkspaceFolders=T;function R(q,ee,G,z,L){let A=o(ee,q);const N=L.dirname(ee),M=L.dirname(z),W=[],X=F(A.folders);for(const ke of A.folders){const Te=u(ke)?L.resolvePath(N,ke.path):D.URI.parse(ke.uri);let Le;G?Le=!1:Le=!u(ke)||_.isAbsolute(ke.path),W.push(v(Te,Le,ke.name,M,X,L))}const ae={insertSpaces:!1,tabSize:4,eol:I.isLinux||I.isMacintosh?`
`:`\r
`},se=y.setProperty(q,["folders"],W,ae);let be=y.applyEdits(q,se);return A.remoteAuthority===f.getRemoteAuthority(z)&&(be=y.applyEdits(be,y.removeProperty(be,["remoteAuthority"],ae))),be}e.rewriteWorkspaceFileForNewLocation=R;function o(q,ee){let G=r.parse(ee);if(G&&Array.isArray(G.folders))G.folders=G.folders.filter(z=>s(z));else throw new Error(`${q} looks like an invalid workspace file.`);return G}function F(q){return I.isWindows?q.some(ee=>u(ee)&&ee.path.indexOf("/")>=0):!0}e.useSlashForPath=F;function B(q){return q.workspace&&typeof q.workspace=="object"&&typeof q.workspace.id=="string"&&typeof q.workspace.configPath=="string"}function Z(q){return typeof q.folderUri=="string"}function ie(q){return typeof q.fileUri=="string"}function Se(q,ee){const G={workspaces:[],files:[]};if(q){const z=function(A,N){for(let M=0;M<A.length;M++)try{N(A[M],M)}catch(W){ee.warn(`Error restoring recent entry ${JSON.stringify(A[M])}: ${W.toString()}. Skip entry.`)}},L=q;if(Array.isArray(L.entries))z(L.entries,A=>{const N=A.label,M=A.remoteAuthority;B(A)?G.workspaces.push({label:N,remoteAuthority:M,workspace:{id:A.workspace.id,configPath:D.URI.parse(A.workspace.configPath)}}):Z(A)?G.workspaces.push({label:N,remoteAuthority:M,folderUri:D.URI.parse(A.folderUri)}):ie(A)&&G.files.push({label:N,remoteAuthority:M,fileUri:D.URI.parse(A.fileUri)})});else{const A=q;Array.isArray(A.workspaces3)&&z(A.workspaces3,(N,M)=>{const W=Array.isArray(A.workspaceLabels)&&A.workspaceLabels[M]||void 0;typeof N=="object"&&typeof N.id=="string"&&typeof N.configURIPath=="string"?G.workspaces.push({label:W,workspace:{id:N.id,configPath:D.URI.parse(N.configURIPath)}}):typeof N=="string"&&G.workspaces.push({label:W,folderUri:D.URI.parse(N)})}),Array.isArray(A.files2)&&z(A.files2,(N,M)=>{const W=Array.isArray(A.fileLabels)&&A.fileLabels[M]||void 0;typeof N=="string"&&G.files.push({label:W,fileUri:D.URI.parse(N)})})}}return G}e.restoreRecentlyOpened=Se;function oe(q){const ee={entries:[]};for(const G of q.workspaces)C(G)?ee.entries.push({folderUri:G.folderUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority}):ee.entries.push({workspace:{id:G.workspace.id,configPath:G.workspace.configPath.toString()},label:G.label,remoteAuthority:G.remoteAuthority});for(const G of q.files)ee.entries.push({fileUri:G.fileUri.toString(),label:G.label,remoteAuthority:G.remoteAuthority});return ee}e.toStoreData=oe}),define(le[207],ce([0,1,7,14]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ManagementConnection=e.printTime=void 0;function p(I){let _=0,m=0,y=0;I>=1e3&&(y=Math.floor(I/1e3),I-=y*1e3),y>=60&&(m=Math.floor(y/60),y-=m*60),m>=60&&(_=Math.floor(m/60),m-=_*60);const r=_?`${_}h`:"",k=m?`${m}m`:"",d=y?`${y}s`:"",b=I?`${I}ms`:"";return`${r}${k}${d}${b}`}e.printTime=p;class D{constructor(_,m,y,r){this._logService=_,this._reconnectionToken=m,this._onClose=new E.Emitter,this.onClose=this._onClose.event,this._reconnectionGraceTime=108e5,this._reconnectionShortGraceTime=3e5,this._remoteAddress=y,this.protocol=r,this._disposed=!1,this._disconnectRunner1=new P.RunOnceScheduler(()=>{this._log(`The reconnection grace time of ${p(this._reconnectionGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionGraceTime),this._disconnectRunner2=new P.RunOnceScheduler(()=>{this._log(`The reconnection short grace time of ${p(this._reconnectionShortGraceTime)} has expired, so the connection will be disposed.`),this._cleanResources()},this._reconnectionShortGraceTime),this.protocol.onDidDispose(()=>{this._log("The client has disconnected gracefully, so the connection will be disposed."),this._cleanResources()}),this.protocol.onSocketClose(()=>{this._log(`The client has disconnected, will wait for reconnection ${p(this._reconnectionGraceTime)} before disposing...`),this._disconnectRunner1.schedule()}),this._log("New connection established.")}_log(_){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ManagementConnection] ${_}`)}shortenReconnectionGraceTimeIfNecessary(){this._disconnectRunner2.isScheduled()||this._disconnectRunner1.isScheduled()&&(this._log(`Another client has connected, will shorten the wait for reconnection ${p(this._reconnectionShortGraceTime)} before disposing...`),this._disconnectRunner2.schedule())}_cleanResources(){if(this._disposed)return;this._disposed=!0,this._disconnectRunner1.dispose(),this._disconnectRunner2.dispose();const _=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),_.end(),this._onClose.fire(void 0)}acceptReconnection(_,m,y){this._remoteAddress=_,this._log("The client has reconnected."),this._disconnectRunner1.cancel(),this._disconnectRunner2.cancel(),this.protocol.beginAcceptReconnection(m,y),this.protocol.endAcceptReconnection()}}e.ManagementConnection=D}),define(le[102],ce([0,1,25,8,3,121,31]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InternalNLSConfiguration=e.getNLSConfiguration=void 0;const _=p.join(P.FileAccess.asFileUri("",x).fsPath,"nls.metadata.json"),m=new Map;function y(d){return new Promise(b=>E.exists(d,b))}function r(d,b){return y(_).then(f=>{if(!f||!I.default.commit)return Promise.resolve({locale:"en",availableLanguages:{}});let c=`${d}||${b}`,S=m.get(c);return S||(S=D.getNLSConfiguration(I.default.commit,b,_,d).then(w=>(k.is(w)&&(w._languagePackSupport=!0),w)),m.set(c,S)),S})}e.getNLSConfiguration=r;var k;(function(d){function b(f){let c=f;return c&&typeof c._languagePackId=="string"}d.is=b})(k=e.InternalNLSConfiguration||(e.InternalNLSConfiguration={}))}),define(le[40],ce([0,1,53,8]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createRemoteURITransformer=e.uriTransformerPath=void 0,e.uriTransformerPath=P.FileAccess.asFileUri("vs/server/uriTransformer.js",x).fsPath;function p(D){const _=x.__$__nodeRequire(e.uriTransformerPath)(D);return new E.URITransformer(_)}e.createRemoteURITransformer=p}),define(le[208],ce([0,1,7,2,4,40,63,18,3,42,29]),function(x,e,E,P,p,D,I,_,m,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentFileSystemChannel=void 0;class k extends P.Disposable{constructor(f,c,S,w){super();this.logService=f,this.environmentService=c,this.uriTransformer=S,this.watcherRequests=new Map,this.fileWatcher=this._register(new I.DiskFileSystemProvider(this.logService,{watcher:this.getWatcherOptions()})),this.registerListeners(w)}registerListeners(f){const c=this._register(new E.Emitter);this._register(c.event(S=>{f.fire(S.map(w=>({resource:this.uriTransformer.transformOutgoingURI(w.resource),type:w.type})))})),this._register(this.fileWatcher.onDidChangeFile(S=>c.fire(S))),this._register(this.fileWatcher.onDidErrorOccur(S=>f.fire(S)))}getWatcherOptions(){const f=this.environmentService.args.fileWatcherPolling;if(f){const c=f.split(m.delimiter),S=Number(c[0]);if(S>0)return{usePolling:c.length>1?c.slice(1):!0,pollingInterval:S}}}watch(f,c,S){const w=p.URI.revive(this.uriTransformer.transformIncoming(c));return this.environmentService.extensionsPath&&(S.excludes=[...S.excludes||[],m.posix.join(this.environmentService.extensionsPath,"**")]),this.watcherRequests.set(f,this.fileWatcher.watch(w,S)),P.toDisposable(()=>{P.dispose(this.watcherRequests.get(f)),this.watcherRequests.delete(f)})}dispose(){super.dispose(),this.watcherRequests.forEach(f=>P.dispose(f)),this.watcherRequests.clear()}}class d extends P.Disposable{constructor(f,c){super();this.logService=f,this.environmentService=c,this.BUFFER_SIZE=256*1024,this.uriTransformerCache=new Map,this.fileWatchers=new Map,this.fsProvider=this._register(new I.DiskFileSystemProvider(this.logService,{bufferSize:this.BUFFER_SIZE})),this.watchRequests=new Map}call(f,c,S){const w=this.getUriTransformer(f.remoteAuthority);switch(c){case"stat":return this.stat(w,S[0]);case"readdir":return this.readdir(w,S[0]);case"open":return this.open(w,S[0],S[1]);case"close":return this.close(S[0]);case"read":return this.read(S[0],S[1],S[2]);case"readFile":return this.readFile(w,S[0]);case"write":return this.write(S[0],S[1],S[2],S[3],S[4]);case"writeFile":return this.writeFile(w,S[0],S[1],S[2]);case"rename":return this.rename(w,S[0],S[1],S[2]);case"copy":return this.copy(w,S[0],S[1],S[2]);case"mkdir":return this.mkdir(w,S[0]);case"delete":return this.delete(w,S[0],S[1]);case"watch":return Promise.resolve(this.watch(S[0],S[1],S[2],S[3]));case"unwatch":return Promise.resolve(this.unwatch(S[0],S[1]))}throw new Error(`IPC Command ${c} not found`)}listen(f,c,S){const w=this.getUriTransformer(f.remoteAuthority);switch(c){case"filechange":return this.onFileChange(w,S[0]);case"readFileStream":return this.onReadFileStream(w,S[0],S[1])}throw new Error(`Unknown event ${c}`)}onFileChange(f,c){const S=new E.Emitter({onFirstListenerAdd:()=>{this.fileWatchers.set(c,new k(this.logService,this.environmentService,f,S))},onLastListenerRemove:()=>{P.dispose(this.fileWatchers.get(c)),this.fileWatchers.delete(c)}});return S.event}onReadFileStream(f,c,S){const w=this.transformIncoming(f,c,!0),C=new r.CancellationTokenSource,h=new E.Emitter({onLastListenerRemove:()=>{C.cancel()}}),l=this.fsProvider.readFileStream(w,S,C.token);return y.listenStream(l,{onData:a=>h.fire(_.VSBuffer.wrap(a)),onError:a=>h.fire(a),onEnd:()=>{h.fire("end"),h.dispose(),C.dispose()}}),h.event}getUriTransformer(f){let c=this.uriTransformerCache.get(f);return c||(c=D.createRemoteURITransformer(f),this.uriTransformerCache.set(f,c)),c}stat(f,c){const S=this.transformIncoming(f,c,!0);return this.fsProvider.stat(S)}readdir(f,c){const S=this.transformIncoming(f,c);return this.fsProvider.readdir(S)}open(f,c,S){const w=this.transformIncoming(f,c,!0);return this.fsProvider.open(w,S)}close(f){return this.fsProvider.close(f)}async read(f,c,S){const w=_.VSBuffer.alloc(S),C=0,h=await this.fsProvider.read(f,c,w.buffer,C,S);return[w,h]}async readFile(f,c){const S=this.transformIncoming(f,c,!0),w=await this.fsProvider.readFile(S);return _.VSBuffer.wrap(w)}write(f,c,S,w,C){return this.fsProvider.write(f,c,S.buffer,w,C)}writeFile(f,c,S,w){const C=this.transformIncoming(f,c);return this.fsProvider.writeFile(C,S.buffer,w)}rename(f,c,S,w){const C=p.URI.revive(f.transformIncoming(c)),h=p.URI.revive(f.transformIncoming(S));return this.fsProvider.rename(C,h,w)}copy(f,c,S,w){const C=this.transformIncoming(f,c),h=this.transformIncoming(f,S);return this.fsProvider.copy(C,h,w)}mkdir(f,c){const S=this.transformIncoming(f,c);return this.fsProvider.mkdir(S)}delete(f,c,S){const w=this.transformIncoming(f,c);return this.fsProvider.delete(w,S)}transformIncoming(f,c,S=!1){if(S&&c.path==="/vscode-resource"&&c.query){const w=JSON.parse(c.query).requestResourcePath;return p.URI.from({scheme:"file",path:w})}return p.URI.revive(f.transformIncoming(c))}watch(f,c,S,w){const C=f+c,h=this.fileWatchers.get(f);if(h){const l=h.watch(c,S,w);this.watchRequests.set(C,l)}}unwatch(f,c){const S=f+c,w=this.watchRequests.get(S);w&&(P.dispose(w),this.watchRequests.delete(S))}dispose(){super.dispose(),this.watchRequests.forEach(f=>P.dispose(f)),this.watchRequests.clear(),this.fileWatchers.forEach(f=>P.dispose(f)),this.fileWatchers.clear()}}e.RemoteAgentFileSystemChannel=d}),define(le[67],ce([0,1,157,166,56,6,27]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServerEnvironmentService=e.IServerEnvironmentService=e.serverOptions=void 0,e.serverOptions={port:{type:"string"},connectionToken:{type:"string"},"connection-secret":{type:"string",description:E.localize(0,null)},host:{type:"string"},"socket-path":{type:"string"},driver:{type:"string"},"start-server":{type:"boolean"},"print-startup-performance":{type:"boolean"},"print-ip-address":{type:"boolean"},fileWatcherPolling:{type:"string"},"enable-remote-auto-shutdown":{type:"boolean"},"remote-auto-shutdown-without-delay":{type:"boolean"},"without-browser-env-var":{type:"boolean"},"disable-telemetry":p.OPTIONS["disable-telemetry"],"extensions-dir":p.OPTIONS["extensions-dir"],"extensions-download-dir":p.OPTIONS["extensions-download-dir"],"install-extension":p.OPTIONS["install-extension"],"install-builtin-extension":p.OPTIONS["install-builtin-extension"],"uninstall-extension":p.OPTIONS["uninstall-extension"],"locate-extension":p.OPTIONS["locate-extension"],"list-extensions":p.OPTIONS["list-extensions"],force:p.OPTIONS.force,"show-versions":p.OPTIONS["show-versions"],category:p.OPTIONS.category,"do-not-sync":p.OPTIONS["do-not-sync"],"force-disable-user-env":p.OPTIONS["force-disable-user-env"],folder:{type:"string"},workspace:{type:"string"},"web-user-data-dir":{type:"string"},"use-host-proxy":{type:"string"},"enable-sync":{type:"boolean"},"github-auth":{type:"string"},log:{type:"string"},_:p.OPTIONS._},e.IServerEnvironmentService=D.refineServiceDecorator(I.IEnvironmentService);class _ extends P.NativeEnvironmentService{get args(){return super.args}}e.ServerEnvironmentService=_}),define(le[209],ce([0,1,25,65,123,239,62,30,76,5,4,40,31,3,8,22,23]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebClientServer=e.serveFile=e.serveError=void 0;const w={".html":"text/html",".js":"text/javascript",".json":"application/json",".css":"text/css",".svg":"image/svg+xml"};async function C(t,i,n,s){i.writeHead(n,{"Content-Type":"text/plain"}),i.end(s)}e.serveError=C;async function h(t,i,n,s,u=Object.create(null)){try{const g=await p.promisify(E.stat)(s),v=`W/"${[g.ino,g.size,g.mtime.getTime()].join("-")}"`;if(i.headers["if-none-match"]===v)return n.writeHead(304),n.end();u["Content-Type"]=w[b.extname(s)]||m.getMediaMime(s)||"text/plain",u.Etag=v,n.writeHead(200,u),E.createReadStream(s).pipe(n)}catch(g){return g.code!=="ENOENT"&&(t.error(g),console.error(g.toString())),n.writeHead(404,{"Content-Type":"text/plain"}),n.end("Not found")}}e.serveFile=h;const l=b.dirname(f.FileAccess.asFileUri("",x).fsPath);class a{constructor(i,n,s){this._connectionToken=i,this._environmentService=n,this._logService=s,this._webviewEndpoint="https://{{uuid}}.vscode-webview-test.com/{{commit}}",this._mapCallbackUriToRequestId=new Map}async handle(i,n,s){try{const u=s.pathname;return u==="/favicon.ico"||u==="/manifest.json"||u==="/code-192.png"||u==="/code-512.png"?h(this._logService,i,n,b.join(l,"resources","server",u.substr(1))):/^\/static\//.test(u)?this._handleStatic(i,n,s):u==="/"?this._handleRoot(i,n,s):u==="/callback"?this._handleCallback(i,n,s):u==="/fetch-callback"?this._handleFetchCallback(i,n,s):C(i,n,404,"Not found.")}catch(u){return this._logService.error(u),console.error(u.toString()),C(i,n,500,"Internal Server Error.")}}_hasCorrectTokenCookie(i){return D.parse(i.headers.cookie||"")["vscode-tkn"]===this._connectionToken}async _handleStatic(i,n,s){const u=Object.create(null),g=decodeURIComponent(s.pathname),v=b.normalize(g.substr("/static/".length)),T=b.join(l,v);return _.isEqualOrParent(T,l,!y.isLinux)?h(this._logService,i,n,T,u):C(i,n,400,"Bad request.")}async _handleRoot(i,n,s){if(!i.headers.host)return C(i,n,400,"Bad request.");const u=s.query.tkn;if(typeof u=="string"){const oe=Object.create(null);oe["Set-Cookie"]=D.serialize("vscode-tkn",u,{sameSite:"strict",maxAge:60*60*24*7});const q=Object.create(null);for(let G in s.query)G!=="tkn"&&(q[G]=s.query[G]);const ee=P.format({pathname:"/",query:q});return oe.Location=ee,n.writeHead(302,oe),n.end()}if(this._environmentService.isBuilt&&!this._hasCorrectTokenCookie(i))return C(i,n,403,"Forbidden.");const g=i.headers.host,v=k.createRemoteURITransformer(g),{workspacePath:T,isFolder:R}=await this._getWorkspaceFromCLI();function o(oe){return oe.replace(/"/g,"&quot;")}let F;this._environmentService.driverHandle&&(F=!1);const B=f.FileAccess.asFileUri(this._environmentService.isBuilt?"vs/code/browser/workbench/workbench.html":"vs/code/browser/workbench/workbench-dev.html",x).fsPath,Z=!this._environmentService.isBuilt&&this._environmentService.args["github-auth"]?{id:c.generateUuid(),providerId:"github",accessToken:this._environmentService.args["github-auth"],scopes:[["user:email"],["repo"]]}:void 0,ie=(await p.promisify(E.readFile)(B)).toString().replace("{{WORKBENCH_WEB_CONFIGURATION}}",o(JSON.stringify({folderUri:T&&R?v.transformOutgoing(r.URI.file(T)):void 0,workspaceUri:T&&!R?v.transformOutgoing(r.URI.file(T)):void 0,remoteAuthority:g,webviewEndpoint:this._webviewEndpoint,_wrapWebWorkerExtHostInIframe:F,developmentOptions:{enableSmokeTestDriver:this._environmentService.driverHandle==="web"?!0:void 0},settingsSyncOptions:!this._environmentService.isBuilt&&this._environmentService.args["enable-sync"]?{enabled:!0}:void 0}))).replace("{{WORKBENCH_AUTH_SESSION}}",()=>Z?o(JSON.stringify(Z)):""),Se=["default-src 'self';","img-src 'self' https: data: blob:;","media-src 'none';",`script-src 'self' 'unsafe-eval' https://az416426.vo.msecnd.net ${this._getScriptCspHashes(ie).join(" ")} 'sha256-O98pkmgtvUCQGVoddaGy891K52PVRnySDRxRszVLPNQ=' http://${g};`,"child-src 'self';","frame-src 'self' https://*.vscode-webview-test.com https://vscodeweb.azureedge.net data:;","worker-src 'self' data:;","style-src 'self' 'unsafe-inline';","connect-src 'self' ws: wss: https:;","font-src 'self' blob:;","manifest-src 'self';"].join(" ");return n.writeHead(200,{"Content-Type":"text/html","Set-Cookie":D.serialize("vscode-tkn",this._connectionToken,{sameSite:"strict",maxAge:60*60*24*7}),"Content-Security-Policy":Se}),n.end(ie)}_getScriptCspHashes(i){const n=/<script>([\s\S]+?)<\/script>/img,s=[];let u;for(;u=n.exec(i);){const g=I.createHash("sha256"),v=u[1].replace(/\r\n/g,`
`),T=g.update(Buffer.from(v)).digest().toString("base64");s.push(`'sha256-${T}'`)}return s}async _getWorkspaceFromCLI(){const i=this._environmentService.args.workspace;if(i&&i.length>0){const s=_.sanitizeFilePath(i,S.cwd());if(await p.promisify(E.exists)(s))return{workspacePath:s}}const n=this._environmentService.args.folder;if(n&&n.length>0){const s=_.sanitizeFilePath(n,S.cwd());if(await p.promisify(E.exists)(s))return{workspacePath:s,isFolder:!0}}return{}}_getFirstQueryValue(i,n){const s=i.query[n];return Array.isArray(s)?s[0]:s}_getFirstQueryValues(i,n){const s=new Map;for(const u in i.query){if(n&&n.indexOf(u)>=0)continue;const g=this._getFirstQueryValue(i,u);typeof g=="string"&&s.set(u,g)}return s}async _handleCallback(i,n,s){const u=["vscode-requestId","vscode-scheme","vscode-authority","vscode-path","vscode-query","vscode-fragment"],[g,v,T,R,o,F]=u.map(ie=>{const Se=this._getFirstQueryValue(s,ie);return Se&&decodeURIComponent(Se)});if(!g)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");let B=o,Z=0;return this._getFirstQueryValues(s,u).forEach((ie,Se)=>{B||(B=""),B+=`${Z++==0?"":"&"}${Se}=${ie}`}),this._mapCallbackUriToRequestId.set(g,r.URI.from({scheme:v||d.default.urlProtocol,authority:T,path:R,query:B,fragment:F}).toJSON()),h(this._logService,i,n,f.FileAccess.asFileUri("vs/code/browser/workbench/callback.html",x).fsPath,{"Content-Type":"text/html"})}async _handleFetchCallback(i,n,s){const u=this._getFirstQueryValue(s,"vscode-requestId");if(!u)return n.writeHead(400,{"Content-Type":"text/plain"}),n.end("Bad request.");const g=this._mapCallbackUriToRequestId.get(u);return g&&this._mapCallbackUriToRequestId.delete(u),n.writeHead(200,{"Content-Type":"text/json"}),n.end(JSON.stringify(g))}}e.WebClientServer=a}),define(le[210],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=E.createDecorator("IExtHostRpcService");class P{constructor(D){this.getProxy=D.getProxy.bind(D),this.set=D.set.bind(D),this.assertRegistered=D.assertRegistered.bind(D),this.drain=D.drain.bind(D)}}e.ExtHostRpcService=P}),define(le[211],ce([0,1,7]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.ExtHostTestItemEventType=void 0;var P;(function(I){I[I.NewChild=0]="NewChild",I[I.Disposed=1]="Disposed",I[I.Invalidated=2]="Invalidated",I[I.SetProp=3]="SetProp"})(P=e.ExtHostTestItemEventType||(e.ExtHostTestItemEventType={}));const p=new WeakMap,D=I=>{let _=p.get(I);return _||(_={children:new Map,bus:new E.Emitter},p.set(I,_)),_};e.getPrivateApiFor=D});var wt=this&&this.__classPrivateFieldSet||function(x,e,E,P,p){if(P==="m")throw new TypeError("Private method is not writable");if(P==="a"&&!p)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?x!==e||!p:!e.has(x))throw new TypeError("Cannot write private member to an object whose class did not declare it");return P==="a"?p.call(x,E):p?p.value=E:e.set(x,E),E},ot=this&&this.__classPrivateFieldGet||function(x,e,E,P){if(E==="a"&&!P)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?x!==e||!P:!e.has(x))throw new TypeError("Cannot read private member from an object whose class did not declare it");return E==="m"?P:E==="a"?P.call(x):P?P.value:e.get(x)};define(le[103],ce([0,1,21,12,74,26,76,11,4,22,20,97,211]),function(x,e,E,P,p,D,I,_,m,y,r,k,d){"use strict";var b,f,c,S,w,C,h,l,a,t,i,n,s,u,g,v,T,R;Object.defineProperty(e,"__esModule",{value:!0}),e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.TestMessage=e.TestItemImpl=e.TestItemStatus=e.TestMessageSeverity=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function o(j){function O(){return Reflect.construct(j,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(j,"name")),Object.setPrototypeOf(O,j),Object.setPrototypeOf(O.prototype,j.prototype),O}let F=w=class{constructor(O){b.set(this,void 0),wt(this,b,O,"f")}static from(...O){let K=O;return new w(function(){if(K){for(const we of K)we&&typeof we.dispose=="function"&&we.dispose();K=void 0}})}dispose(){typeof ot(this,b,"f")=="function"&&(ot(this,b,"f").call(this),wt(this,b,void 0,"f"))}};b=new WeakMap,F=w=Ne([o],F),e.Disposable=F;let B=C=class{constructor(O,K){if(O<0)throw P.illegalArgument("line must be non-negative");if(K<0)throw P.illegalArgument("character must be non-negative");this._line=O,this._character=K}static Min(...O){if(O.length===0)throw new TypeError;let K=O[0];for(let we=1;we<O.length;we++){const Be=O[we];Be.isBefore(K)&&(K=Be)}return K}static Max(...O){if(O.length===0)throw new TypeError;let K=O[0];for(let we=1;we<O.length;we++){const Be=O[we];Be.isAfter(K)&&(K=Be)}return K}static isPosition(O){if(!O)return!1;if(O instanceof C)return!0;let{line:K,character:we}=O;return typeof K=="number"&&typeof we=="number"}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,K=0){if(O===null||K===null)throw P.illegalArgument();let we;return typeof O=="undefined"?we=0:typeof O=="number"?we=O:(we=typeof O.lineDelta=="number"?O.lineDelta:0,K=typeof O.characterDelta=="number"?O.characterDelta:0),we===0&&K===0?this:new C(this.line+we,this.character+K)}with(O,K=this.character){if(O===null||K===null)throw P.illegalArgument();let we;return typeof O=="undefined"?we=this.line:typeof O=="number"?we=O:(we=typeof O.line=="number"?O.line:this.line,K=typeof O.character=="number"?O.character:this.character),we===this.line&&K===this.character?this:new C(we,K)}toJSON(){return{line:this.line,character:this.character}}};B=C=Ne([o],B),e.Position=B;let Z=h=class{constructor(O,K,we,Be){let qe,Qe;if(typeof O=="number"&&typeof K=="number"&&typeof we=="number"&&typeof Be=="number"?(qe=new B(O,K),Qe=new B(we,Be)):O instanceof B&&K instanceof B&&(qe=O,Qe=K),!qe||!Qe)throw new Error("Invalid arguments");qe.isBefore(Qe)?(this._start=qe,this._end=Qe):(this._start=Qe,this._end=qe)}static isRange(O){return O instanceof h?!0:O?B.isPosition(O.start)&&B.isPosition(O.end):!1}get start(){return this._start}get end(){return this._end}contains(O){return O instanceof h?this.contains(O._start)&&this.contains(O._end):O instanceof B?!(O.isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const K=B.Max(O.start,this._start),we=B.Min(O.end,this._end);if(!K.isAfter(we))return new h(K,we)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const K=B.Min(O.start,this._start),we=B.Max(O.end,this.end);return new h(K,we)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,K=this.end){if(O===null||K===null)throw P.illegalArgument();let we;return O?B.isPosition(O)?we=O:(we=O.start||this.start,K=O.end||this.end):we=this.start,we.isEqual(this._start)&&K.isEqual(this.end)?this:new h(we,K)}toJSON(){return[this.start,this.end]}};Z=h=Ne([o],Z),e.Range=Z;let ie=l=class extends Z{constructor(O,K,we,Be){let qe,Qe;if(typeof O=="number"&&typeof K=="number"&&typeof we=="number"&&typeof Be=="number"?(qe=new B(O,K),Qe=new B(we,Be)):O instanceof B&&K instanceof B&&(qe=O,Qe=K),!qe||!Qe)throw new Error("Invalid arguments");super(qe,Qe);this._anchor=qe,this._active=Qe}static isSelection(O){return O instanceof l?!0:O?Z.isRange(O)&&B.isPosition(O.anchor)&&B.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};ie=l=Ne([o],ie),e.Selection=ie;class Se{constructor(O,K,we){if(typeof O!="string"||O.length===0)throw P.illegalArgument("host");if(typeof K!="number"||K===0||Math.round(K)!==K)throw P.illegalArgument("port");if(typeof we!="undefined"&&(typeof we!="string"||we.length===0||!/^[0-9A-Za-z\-]+$/.test(we)))throw P.illegalArgument("connectionToken");this.host=O,this.port=Math.round(K),this.connectionToken=we}}e.ResolvedAuthority=Se;class oe extends Error{constructor(O,K=k.RemoteAuthorityResolverErrorCode.Unknown,we){super(O);this._message=O,this._code=K,this._detail=we,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,oe.prototype)}static NotAvailable(O,K){return new oe(O,k.RemoteAuthorityResolverErrorCode.NotAvailable,K)}static TemporarilyNotAvailable(O){return new oe(O,k.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=oe;var q;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(q=e.EndOfLine||(e.EndOfLine={}));var ee;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(ee=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let G=a=class{constructor(O,K){this._range=O,this._newText=K}static isTextEdit(O){return O instanceof a?!0:O?Z.isRange(O)&&typeof O.newText=="string":!1}static replace(O,K){return new a(O,K)}static insert(O,K){return a.replace(new Z(O,O),K)}static delete(O){return a.replace(O,"")}static setEndOfLine(O){const K=new a(new Z(new B(0,0),new B(0,0)),"");return K.newEol=O,K}get range(){return this._range}set range(O){if(O&&!Z.isRange(O))throw P.illegalArgument("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw P.illegalArgument("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw P.illegalArgument("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};G=a=Ne([o],G),e.TextEdit=G;var z;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellOutput=4]="CellOutput",j[j.CellReplace=5]="CellReplace",j[j.CellOutputItem=6]="CellOutputItem"})(z=e.FileEditType||(e.FileEditType={}));let L=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,K,we,Be){this._edits.push({_type:1,from:O,to:K,options:we,metadata:Be})}createFile(O,K,we){this._edits.push({_type:1,from:void 0,to:O,options:K,metadata:we})}deleteFile(O,K,we){this._edits.push({_type:1,from:O,to:void 0,options:K,metadata:we})}replaceNotebookMetadata(O,K,we){this._edits.push({_type:3,metadata:we,uri:O,edit:{editType:5,metadata:K},notebookMetadata:K})}replaceNotebookCells(O,K,we,Be,qe){let Qe,nt,at=[],lt;if(Et.isNotebookRange(K)&&vt.isNotebookCellDataArray(we)&&!vt.isNotebookCellDataArray(Be)?(Qe=K.start,nt=K.end,at=we,lt=Be):typeof K=="number"&&typeof we=="number"&&vt.isNotebookCellDataArray(Be)&&(Qe=K,nt=we,at=Be,lt=qe),Qe===void 0||nt===void 0)throw new Error("Invalid arguments");(Qe!==nt||at.length>0)&&this._edits.push({_type:5,uri:O,index:Qe,count:nt-Qe,cells:at,metadata:lt})}replaceNotebookCellMetadata(O,K,we,Be){this._edits.push({_type:3,metadata:Be,uri:O,edit:{editType:8,index:K,metadata:we}})}replace(O,K,we,Be){this._edits.push({_type:2,uri:O,edit:new G(K,we),metadata:Be})}insert(O,K,we,Be){this.replace(O,new Z(K,K),we,Be)}delete(O,K,we){this.replace(O,K,"",we)}has(O){return this._edits.some(K=>K._type===2&&K.uri.toString()===O.toString())}set(O,K){if(K)for(const we of K)we&&this._edits.push({_type:2,uri:O,edit:we});else{for(let we=0;we<this._edits.length;we++){const Be=this._edits[we];Be._type===2&&Be.uri.toString()===O.toString()&&(this._edits[we]=void 0)}E.coalesceInPlace(this._edits)}}get(O){const K=[];for(let we of this._edits)we._type===2&&we.uri.toString()===O.toString()&&K.push(we.edit);return K}entries(){const O=new D.ResourceMap;for(let K of this._edits)if(K._type===2){let we=O.get(K.uri);we||(we=[K.uri,[]],O.set(K.uri,we)),we[1].push(K.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};L=Ne([o],L),e.WorkspaceEdit=L;let A=t=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof t?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=t._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,K=this._tabstop++){if(typeof O=="function"){const we=new t;we._tabstop=this._tabstop,O(we),this._tabstop=we._tabstop,O=we.value}else O=t._escape(O);return this.value+="${",this.value+=K,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,K=this._tabstop++){const we=O.map(Be=>Be.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=K,this.value+="|",this.value+=we,this.value+="|}",this}appendVariable(O,K){if(typeof K=="function"){const we=new t;we._tabstop=this._tabstop,K(we),this._tabstop=we._tabstop,K=we.value}else typeof K=="string"&&(K=K.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,K&&(this.value+=":",this.value+=K),this.value+="}",this}};A=t=Ne([o],A),e.SnippetString=A;var N;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(N=e.DiagnosticTag||(e.DiagnosticTag={}));var M;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(M=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let W=i=class{constructor(O,K){if(this.uri=O,K)if(K instanceof Z)this.range=K;else if(K instanceof B)this.range=new Z(K,K);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?Z.isRange(O.range)&&m.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};W=i=Ne([o],W),e.Location=W;let X=class{constructor(O,K){this.location=O,this.message=K}static is(O){return O?typeof O.message=="string"&&O.location&&Z.isRange(O.location.range)&&m.URI.isUri(O.location.uri):!1}static isEqual(O,K){return O===K?!0:!O||!K?!1:O.message===K.message&&O.location.range.isEqual(K.location.range)&&O.location.uri.toString()===K.location.uri.toString()}};X=Ne([o],X),e.DiagnosticRelatedInformation=X;let ae=class{constructor(O,K,we=M.Error){if(!Z.isRange(O))throw new TypeError("range must be set");if(!K)throw new TypeError("message must be set");this.range=O,this.message=K,this.severity=we}toJSON(){return{severity:M[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,K){return O===K?!0:!O||!K?!1:O.message===K.message&&O.severity===K.severity&&O.code===K.code&&O.severity===K.severity&&O.source===K.source&&O.range.isEqual(K.range)&&E.equals(O.tags,K.tags)&&E.equals(O.relatedInformation,K.relatedInformation,X.isEqual)}};ae=Ne([o],ae),e.Diagnostic=ae;let se=class{constructor(O,K){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:p.isMarkdownString(O)?this.contents=[O]:this.contents=[O],this.range=K}};se=Ne([o],se),e.Hover=se;var be;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(be=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let ke=class{constructor(O,K=be.Text){this.range=O,this.kind=K}toJSON(){return{range:this.range,kind:be[this.kind]}}};ke=Ne([o],ke),e.DocumentHighlight=ke;var Te;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Te=e.SymbolKind||(e.SymbolKind={}));var Le;(function(j){j[j.Deprecated=1]="Deprecated"})(Le=e.SymbolTag||(e.SymbolTag={}));let je=n=class{constructor(O,K,we,Be,qe){this.name=O,this.kind=K,this.containerName=qe,typeof we=="string"&&(this.containerName=we),Be instanceof W?this.location=Be:we instanceof Z&&(this.location=new W(Be,we)),n.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};je=n=Ne([o],je),e.SymbolInformation=je;let Xe=s=class{constructor(O,K,we,Be,qe){this.name=O,this.detail=K,this.kind=we,this.range=Be,this.selectionRange=qe,this.children=[],s.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children&&O.children.forEach(s.validate)}};Xe=s=Ne([o],Xe),e.DocumentSymbol=Xe;var Ze;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(Ze=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let it=class{constructor(O,K){this.title=O,this.kind=K}};it=Ne([o],it),e.CodeAction=it;let Ye=u=class{constructor(O){this.value=O}append(O){return new u(this.value?this.value+u.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+u.sep)}};Ye.sep=".",Ye=u=Ne([o],Ye),e.CodeActionKind=Ye,Ye.Empty=new Ye(""),Ye.QuickFix=Ye.Empty.append("quickfix"),Ye.Refactor=Ye.Empty.append("refactor"),Ye.RefactorExtract=Ye.Refactor.append("extract"),Ye.RefactorInline=Ye.Refactor.append("inline"),Ye.RefactorRewrite=Ye.Refactor.append("rewrite"),Ye.Source=Ye.Empty.append("source"),Ye.SourceOrganizeImports=Ye.Source.append("organizeImports"),Ye.SourceFixAll=Ye.Source.append("fixAll");let ge=class{constructor(O,K){if(this.range=O,this.parent=K,K&&!K.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ge=Ne([o],ge),e.SelectionRange=ge;class Ie{constructor(O,K,we,Be,qe,Qe){this.kind=O,this.name=K,this.detail=we,this.uri=Be,this.range=qe,this.selectionRange=Qe}}e.CallHierarchyItem=Ie;class _e{constructor(O,K){this.fromRanges=K,this.from=O}}e.CallHierarchyIncomingCall=_e;class Re{constructor(O,K){this.fromRanges=K,this.to=O}}e.CallHierarchyOutgoingCall=Re;let Me=class{constructor(O,K){this.range=O,this.command=K}get isResolved(){return!!this.command}};Me=Ne([o],Me),e.CodeLens=Me;let ze=g=class{constructor(O,K=!1){f.set(this,void 0),wt(this,f,new p.MarkdownString(O,{supportThemeIcons:K}),"f")}static isMarkdownString(O){return O instanceof g?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return ot(this,f,"f").value}set value(O){ot(this,f,"f").value=O}get isTrusted(){return ot(this,f,"f").isTrusted}set isTrusted(O){ot(this,f,"f").isTrusted=O}get supportThemeIcons(){return ot(this,f,"f").supportThemeIcons}appendText(O){return ot(this,f,"f").appendText(O),this}appendMarkdown(O){return ot(this,f,"f").appendMarkdown(O),this}appendCodeblock(O,K){return ot(this,f,"f").appendCodeblock(K??"",O),this}};f=new WeakMap,ze=g=Ne([o],ze),e.MarkdownString=ze;let He=class{constructor(O,K){this.label=O,this.documentation=K}};He=Ne([o],He),e.ParameterInformation=He;let xe=class{constructor(O,K){this.label=O,this.documentation=K,this.parameters=[]}};xe=Ne([o],xe),e.SignatureInformation=xe;let tt=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};tt=Ne([o],tt),e.SignatureHelp=tt;var te;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(te=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var ve;(function(j){j[j.Other=0]="Other",j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(ve=e.InlayHintKind||(e.InlayHintKind={}));let de=class{constructor(O,K,we){this.text=O,this.position=K,this.kind=we}};de=Ne([o],de),e.InlayHint=de;var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var he;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(he=e.CompletionItemKind||(e.CompletionItemKind={}));var me;(function(j){j[j.Deprecated=1]="Deprecated"})(me=e.CompletionItemTag||(e.CompletionItemTag={}));let fe=class{constructor(O,K){this.label=O,this.kind=K}toJSON(){return{label:this.label,label2:this.label2,kind:this.kind&&he[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};fe=Ne([o],fe),e.CompletionItem=fe;let V=class{constructor(O=[],K=!1){this.items=O,this.isIncomplete=K}};V=Ne([o],V),e.CompletionList=V;let Q=class{constructor(O,K,we){this.text=O,this.range=K,this.command=we}};Q=Ne([o],Q),e.InlineSuggestion=Q;let U=class{constructor(O){this.items=O}};U=Ne([o],U),e.InlineSuggestions=U;var H;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(H=e.ViewColumn||(e.ViewColumn={}));var Y;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Y=e.StatusBarAlignment||(e.StatusBarAlignment={}));var pe;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative"})(pe=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ee;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(Ee=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ce;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Ce=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ne;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var De;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(De=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(j){function O(K){switch(K){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=O}(ne=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Ae=class{constructor(O,K){if(K&&!m.URI.isUri(K))throw P.illegalArgument("target");if(!Z.isRange(O)||O.isEmpty)throw P.illegalArgument("range");this.range=O,this.target=K}};Ae=Ne([o],Ae),e.DocumentLink=Ae;let Fe=class{constructor(O,K,we,Be){this.red=O,this.green=K,this.blue=we,this.alpha=Be}};Fe=Ne([o],Fe),e.Color=Fe;let Oe=class{constructor(O,K){if(K&&!(K instanceof Fe))throw P.illegalArgument("color");if(!Z.isRange(O)||O.isEmpty)throw P.illegalArgument("range");this.range=O,this.color=K}};Oe=Ne([o],Oe),e.ColorInformation=Oe;let Ge=class{constructor(O){if(!O||typeof O!="string")throw P.illegalArgument("label");this.label=O}};Ge=Ne([o],Ge),e.ColorPresentation=Ge;var re;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(re=e.ColorFormat||(e.ColorFormat={}));var ue;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(ue=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var J;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(J=e.TaskRevealKind||(e.TaskRevealKind={}));var $;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})($=e.TaskPanelKind||(e.TaskPanelKind={}));let Pe=v=class{constructor(O,K){if(typeof O!="string"||typeof K!="string")throw P.illegalArgument("name");this._id=O}static from(O){switch(O){case"clean":return v.Clean;case"build":return v.Build;case"rebuild":return v.Rebuild;case"test":return v.Test;default:return}}get id(){return this._id}};Pe.Clean=new v("clean","Clean"),Pe.Build=new v("build","Build"),Pe.Rebuild=new v("rebuild","Rebuild"),Pe.Test=new v("test","Test"),Pe=v=Ne([o],Pe),e.TaskGroup=Pe;function ye(j){let O="";for(let K=0;K<j.length;K++)O+=j[K].replace(/,/g,",,")+",";return O}let $e=class{constructor(O,K,we){if(typeof O!="string")throw P.illegalArgument("process");this._args=[],this._process=O,K!==void 0&&(Array.isArray(K)?(this._args=K,this._options=we):this._options=K)}get process(){return this._process}set process(O){if(typeof O!="string")throw P.illegalArgument("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(let K of this._args)O.push(K);return ye(O)}};$e=Ne([o],$e),e.ProcessExecution=$e;let We=class{constructor(O,K,we){if(this._args=[],Array.isArray(K)){if(!O)throw P.illegalArgument("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw P.illegalArgument("command");this._command=O,this._args=K,this._options=we}else{if(typeof O!="string")throw P.illegalArgument("commandLine");this._commandLine=O,this._options=K}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw P.illegalArgument("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw P.illegalArgument("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let K of this._args)O.push(typeof K=="string"?K:K.value);return ye(O)}};We=Ne([o],We),e.ShellExecution=We;var et;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(et=e.ShellQuoting||(e.ShellQuoting={}));var Je;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Je=e.TaskScope||(e.TaskScope={}));class Ve{constructor(O){this._callback=O}computeId(){return"customExecution"+y.generateUuid()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=Ve;let rt=T=class{constructor(O,K,we,Be,qe,Qe){this.__deprecated=!1,this._definition=this.definition=O;let nt;typeof K=="string"?(this._name=this.name=K,this._source=this.source=we,this.execution=Be,nt=qe,this.__deprecated=!0):K===Je.Global||K===Je.Workspace?(this.target=K,this._name=this.name=we,this._source=this.source=Be,this.execution=qe,nt=Qe):(this.target=K,this._name=this.name=we,this._source=this.source=Be,this.execution=qe,nt=Qe),typeof nt=="string"?(this._problemMatchers=[nt],this._hasDefinedMatchers=!0):Array.isArray(nt)?(this._problemMatchers=nt,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof $e?this._definition={type:T.ProcessType,id:this._execution.computeId()}:this._execution instanceof We?this._definition={type:T.ShellType,id:this._execution.computeId()}:this._execution instanceof Ve?this._definition={type:T.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:T.EmptyType,id:y.generateUuid()}}get definition(){return this._definition}set definition(O){if(O==null)throw P.illegalArgument("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw P.illegalArgument("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const K=this._definition.type;(T.EmptyType===K||T.ProcessType===K||T.ShellType===K||T.ExtensionCallbackType===K)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw P.illegalArgument("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};rt.ExtensionCallbackType="customExecution",rt.ProcessType="process",rt.ShellType="shell",rt.EmptyType="$empty",rt=T=Ne([o],rt),e.Task=rt;var ct;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(ct=e.ProgressLocation||(e.ProgressLocation={}));let ut=class{constructor(O,K=Yt.None){this.collapsibleState=K,m.URI.isUri(O)?this.resourceUri=O:this.label=O}};ut=Ne([o],ut),e.TreeItem=ut;var Yt;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})(Yt=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let gt=class{constructor(O,K){this.id=O,this.color=K}};gt=Ne([o],gt),e.ThemeIcon=gt,gt.File=new gt("file"),gt.Folder=new gt("folder");let _t=class{constructor(O){this.id=O}};_t=Ne([o],_t),e.ThemeColor=_t;var en;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(en=e.ConfigurationTarget||(e.ConfigurationTarget={}));let kt=class{constructor(O,K){if(typeof O!="string"&&(!O||!m.URI.isUri(O)&&!m.URI.isUri(O.uri)))throw P.illegalArgument("base");if(typeof K!="string")throw P.illegalArgument("pattern");typeof O=="string"?(this.baseFolder=m.URI.file(O),this.base=O):m.URI.isUri(O)?(this.baseFolder=O,this.base=O.fsPath):(this.baseFolder=O.uri,this.base=O.uri.fsPath),this.pattern=K}};kt=Ne([o],kt),e.RelativePattern=kt;let pt=class{constructor(O,K,we,Be){this.enabled=typeof O=="boolean"?O:!0,typeof K=="string"&&(this.condition=K),typeof we=="string"&&(this.hitCondition=we),typeof Be=="string"&&(this.logMessage=Be)}get id(){return this._id||(this._id=y.generateUuid()),this._id}};pt=Ne([o],pt),e.Breakpoint=pt;let At=class extends pt{constructor(O,K,we,Be,qe){super(K,we,Be,qe);if(O===null)throw P.illegalArgument("location");this.location=O}};At=Ne([o],At),e.SourceBreakpoint=At;let Rt=class extends pt{constructor(O,K,we,Be,qe){super(K,we,Be,qe);this.functionName=O}};Rt=Ne([o],Rt),e.FunctionBreakpoint=Rt;let Tt=class extends pt{constructor(O,K,we,Be,qe,Qe,nt){super(Be,qe,Qe,nt);if(!K)throw P.illegalArgument("dataId");this.label=O,this.dataId=K,this.canPersist=we}};Tt=Ne([o],Tt),e.DataBreakpoint=Tt;let Ft=class{constructor(O,K,we){this.command=O,this.args=K||[],this.options=we}};Ft=Ne([o],Ft),e.DebugAdapterExecutable=Ft;let Lt=class{constructor(O,K){this.port=O,this.host=K}};Lt=Ne([o],Lt),e.DebugAdapterServer=Lt;let Ot=class{constructor(O){this.path=O}};Ot=Ne([o],Ot),e.DebugAdapterNamedPipeServer=Ot;let Nt=class{constructor(O){this.implementation=O}};Nt=Ne([o],Nt),e.DebugAdapterInlineImplementation=Nt;let Mt=class{constructor(O,K){this.range=O,this.expression=K}};Mt=Ne([o],Mt),e.EvaluatableExpression=Mt;var tn;(function(j){j[j.Automatic=0]="Automatic",j[j.Explicit=1]="Explicit"})(tn=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let Ut=class{constructor(O,K){this.range=O,this.text=K}};Ut=Ne([o],Ut),e.InlineValueText=Ut;let Bt=class{constructor(O,K,we=!0){this.range=O,this.variableName=K,this.caseSensitiveLookup=we}};Bt=Ne([o],Bt),e.InlineValueVariableLookup=Bt;let zt=class{constructor(O,K){this.range=O,this.expression=K}};zt=Ne([o],zt),e.InlineValueEvaluatableExpression=zt;let jt=class{constructor(O,K){this.frameId=O,this.stoppedLocation=K}};jt=Ne([o],jt),e.InlineValueContext=jt;var nn;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(nn=e.FileChangeType||(e.FileChangeType={}));let $t=R=class extends Error{constructor(O,K=r.FileSystemProviderErrorCode.Unknown,we){var Be;super(m.URI.isUri(O)?O.toString(!0):O);this.code=(Be=we==null?void 0:we.name)!==null&&Be!==void 0?Be:"Unknown",r.markAsFileSystemProviderError(this,K),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,R.prototype),typeof Error.captureStackTrace=="function"&&typeof we=="function"&&Error.captureStackTrace(this,we)}static FileExists(O){return new R(O,r.FileSystemProviderErrorCode.FileExists,R.FileExists)}static FileNotFound(O){return new R(O,r.FileSystemProviderErrorCode.FileNotFound,R.FileNotFound)}static FileNotADirectory(O){return new R(O,r.FileSystemProviderErrorCode.FileNotADirectory,R.FileNotADirectory)}static FileIsADirectory(O){return new R(O,r.FileSystemProviderErrorCode.FileIsADirectory,R.FileIsADirectory)}static NoPermissions(O){return new R(O,r.FileSystemProviderErrorCode.NoPermissions,R.NoPermissions)}static Unavailable(O){return new R(O,r.FileSystemProviderErrorCode.Unavailable,R.Unavailable)}};$t=R=Ne([o],$t),e.FileSystemError=$t;let Wt=class{constructor(O,K,we){this.start=O,this.end=K,this.kind=we}};Wt=Ne([o],Wt),e.FoldingRange=Wt;var rn;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(rn=e.FoldingRangeKind||(e.FoldingRangeKind={}));var sn;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(sn=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var on;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(on=e.CommentMode||(e.CommentMode={}));class an{constructor(O,K=[]){this.tokenTypes=O,this.tokenModifiers=K}}e.SemanticTokensLegend=an;function ln(j){return typeof j=="undefined"||_.isStringArray(j)}class Ht{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let K=0,we=O.tokenTypes.length;K<we;K++)this._tokenTypeStrToInt.set(O.tokenTypes[K],K);for(let K=0,we=O.tokenModifiers.length;K<we;K++)this._tokenModifierStrToInt.set(O.tokenModifiers[K],K)}}push(O,K,we,Be,qe){if(typeof O=="number"&&typeof K=="number"&&typeof we=="number"&&typeof Be=="number"&&(typeof qe=="number"||typeof qe=="undefined"))return typeof qe=="undefined"&&(qe=0),this._pushEncoded(O,K,we,Be,qe);if(Z.isRange(O)&&typeof K=="string"&&ln(we))return this._push(O,K,we);throw P.illegalArgument()}_push(O,K,we){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(K))throw new Error("`tokenType` is not in the provided legend");const Be=O.start.line,qe=O.start.character,Qe=O.end.character-O.start.character,nt=this._tokenTypeStrToInt.get(K);let at=0;if(we)for(const lt of we){if(!this._tokenModifierStrToInt.has(lt))throw new Error("`tokenModifier` is not in the provided legend");const ht=this._tokenModifierStrToInt.get(lt);at|=1<<ht>>>0}this._pushEncoded(Be,qe,Qe,nt,at)}_pushEncoded(O,K,we,Be,qe){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&K<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const at=this._data.length/5|0;let lt=0,ht=0;for(let dt=0;dt<at;dt++){let mt=this._data[5*dt],St=this._data[5*dt+1];mt===0?(mt=lt,St+=ht):mt+=lt,this._data[5*dt]=mt,this._data[5*dt+1]=St,lt=mt,ht=St}}let Qe=O,nt=K;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(Qe-=this._prevLine,Qe===0&&(nt-=this._prevChar)),this._data[this._dataLen++]=Qe,this._data[this._dataLen++]=nt,this._data[this._dataLen++]=we,this._data[this._dataLen++]=Be,this._data[this._dataLen++]=qe,this._prevLine=O,this._prevChar=K}static _sortAndDeltaEncode(O){let K=[];const we=O.length/5|0;for(let nt=0;nt<we;nt++)K[nt]=nt;K.sort((nt,at)=>{const lt=O[5*nt],ht=O[5*at];if(lt===ht){const dt=O[5*nt+1],mt=O[5*at+1];return dt-mt}return lt-ht});const Be=new Uint32Array(O.length);let qe=0,Qe=0;for(let nt=0;nt<we;nt++){const at=5*K[nt],lt=O[at+0],ht=O[at+1],dt=O[at+2],mt=O[at+3],St=O[at+4],Zt=lt-qe,On=Zt===0?ht-Qe:ht,Dt=5*nt;Be[Dt+0]=Zt,Be[Dt+1]=On,Be[Dt+2]=dt,Be[Dt+3]=mt,Be[Dt+4]=St,qe=lt,Qe=ht}return Be}build(O){return this._dataIsSortedAndDeltaEncoded?new qt(new Uint32Array(this._data),O):new qt(Ht._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=Ht;class qt{constructor(O,K){this.resultId=K,this.data=O}}e.SemanticTokens=qt;class cn{constructor(O,K,we){this.start=O,this.deleteCount=K,this.data=we}}e.SemanticTokensEdit=cn;class un{constructor(O,K){this.resultId=K,this.edits=O}}e.SemanticTokensEdits=un;var fn;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(fn=e.DebugConsoleMode||(e.DebugConsoleMode={}));var hn;(function(j){j[j.Initial=1]="Initial",j[j.Dynamic=2]="Dynamic"})(hn=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let It=class{constructor(){}};It.Back={iconPath:new gt("arrow-left")},It=Ne([o],It),e.QuickInputButtons=It;var dn;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(dn=e.ExtensionKind||(e.ExtensionKind={}));class mn{constructor(O,K,we){this.badge=O,this.tooltip=K,this.color=we}static validate(O){if(O.badge&&O.badge.length!==1&&O.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=mn;let Vt=class{constructor(O){this.kind=O}};Vt=Ne([o],Vt),e.ColorTheme=Vt;var gn;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast"})(gn=e.ColorThemeKind||(e.ColorThemeKind={}));class Et{constructor(O,K){if(O<0)throw P.illegalArgument("start must be positive");if(K<0)throw P.illegalArgument("end must be positive");O<=K?(this._start=O,this._end=K):(this._start=K,this._end=O)}static isNotebookRange(O){return O instanceof Et?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let K=this._start,we=this._end;return O.start!==void 0&&(K=O.start),O.end!==void 0&&(we=O.end),K===this._start&&we===this._end?this:new Et(K,we)}}e.NotebookRange=Et;class vt{constructor(O,K,we,Be,qe,Qe){this.kind=O,this.value=K,this.languageId=we,this.outputs=Be??[],this.metadata=qe,this.executionSummary=Qe,vt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(K=>vt.isNotebookCellData(K))}static isNotebookCellData(O){return!0}}e.NotebookCellData=vt;class vn{constructor(O){this.cells=O}}e.NotebookData=vn;class ft{constructor(O,K){this.data=O,this.mime=K;const we=I.normalizeMimeType(K,!0);if(!we)throw new Error("INVALID mime type, must not be empty or falsy: "+K);this.mime=we}static isNotebookCellOutputItem(O){return O instanceof ft?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const K={name:O.name,message:O.message,stack:O.stack};return ft.json(K,"application/vnd.code.notebook.error")}static stdout(O){return ft.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return ft.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,K="application/octet-stream"){return new ft(O,K)}static text(O,K="text/plain"){const we=ot(ft,c,"f",S).encode(String(O));return new ft(we,K)}static json(O,K="application/json"){const we=JSON.stringify(O,void 0,"	");return ft.text(we,K)}}e.NotebookCellOutputItem=ft,c=ft,S={value:new TextEncoder};class Pt{constructor(O,K,we){this.items=Pt.ensureUniqueMimeTypes(O,!0),typeof K=="string"?(this.id=K,this.metadata=we):(this.id=y.generateUuid(),this.metadata=K??we)}static isNotebookCellOutput(O){return O instanceof Pt?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&_.isArray(O.items)}static ensureUniqueMimeTypes(O,K=!1){const we=new Set,Be=new Set;for(let qe=0;qe<O.length;qe++){const Qe=O[qe],nt=I.normalizeMimeType(Qe.mime);if(!we.has(nt)){we.add(nt);continue}Be.add(qe),K&&console.warn(`DUPLICATED mime type '${Qe.mime}' will be dropped`)}return Be.size===0?O:O.filter((qe,Qe)=>!Be.has(Qe))}}e.NotebookCellOutput=Pt;var pn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(pn=e.NotebookCellKind||(e.NotebookCellKind={}));var yn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(yn=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var wn;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(wn=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var En;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(En=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class bn{constructor(O,K){this.text=O,this.alignment=K}}e.NotebookCellStatusBarItem=bn;var Sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(Sn=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Dn{constructor(O,K=[]){this.uri=O,this.provides=E.asArray(K)}}e.NotebookRendererScript=Dn;let xt=class{constructor(O,K){this.label=O,this.timestamp=K}};xt=Ne([o],xt),e.TimelineItem=xt;var Cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(Cn=e.ExtensionMode||(e.ExtensionMode={}));var In;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(In=e.ExtensionRuntime||(e.ExtensionRuntime={}));var Pn;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=4]="RegEx"})(Pn=e.StandardTokenType||(e.StandardTokenType={}));class _n{constructor(O,K){this.ranges=O,this.wordPattern=K}}e.LinkedEditingRanges=_n;class kn{constructor(O,K){this._port=O,this._autoForwardAction=K}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=kn;var An;(function(j){j[j.Unset=0]="Unset",j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(An=e.TestResultState||(e.TestResultState={}));var Jt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information",j[j.Hint=3]="Hint"})(Jt=e.TestMessageSeverity||(e.TestMessageSeverity={}));var Qt;(function(j){j[j.Pending=0]="Pending",j[j.Resolved=1]="Resolved"})(Qt=e.TestItemStatus||(e.TestItemStatus={}));const yt=(j,O,K,we)=>{let Be=K;return{enumerable:!0,configurable:!1,get(){return Be},set(qe){we(Be,qe)||(Be=qe,j.bus.fire([3,O,qe]))}}},bt=(j,O)=>j===O,Rn=(j,O)=>j===O?!0:!j||!O?!1:j.isEqual(O);class Gt{constructor(O,K,we,Be){this.label=K,this.data=Be;const qe=d.getPrivateApiFor(this);Object.defineProperties(this,{id:{value:O,enumerable:!0,writable:!1},uri:{value:we,enumerable:!0,writable:!1},parent:{enumerable:!1,get:()=>qe.parent},children:{value:new D.ReadonlyMapView(qe.children),enumerable:!0,writable:!1},range:yt(qe,"range",void 0,Rn),description:yt(qe,"description",void 0,bt),runnable:yt(qe,"runnable",!0,bt),debuggable:yt(qe,"debuggable",!1,bt),status:yt(qe,"status",Qt.Resolved,bt),error:yt(qe,"error",void 0,bt)})}invalidate(){d.getPrivateApiFor(this).bus.fire([2])}dispose(){const O=d.getPrivateApiFor(this);O.parent&&d.getPrivateApiFor(O.parent).children.delete(this.id),O.bus.fire([1])}addChild(O){if(!(O instanceof Gt))throw new Error("Test child must be created through vscode.test.createTestItem()");const K=d.getPrivateApiFor(this);if(K.children.has(O.id))throw new Error(`Attempted to insert a duplicate test item ID ${O.id}`);K.children.set(O.id,O),K.bus.fire([0,O])}}e.TestItemImpl=Gt;class Kt{constructor(O){this.message=O,this.severity=Jt.Error}static diff(O,K,we){const Be=new Kt(O);return Be.expectedOutput=K,Be.actualOutput=we,Be}}e.TestMessage=Kt;var Tn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Tn=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var Fn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(Fn=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Ln;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore"})(Ln=e.PortAutoForwardAction||(e.PortAutoForwardAction={}))}),define(le[212],ce([0,1,47,8,3,5,59]),function(x,e,E,P,p,D,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.ExperimentalUseMarkdownRenderer=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.getCellUndoRedoComparisonKey=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.AnyRendererApi=e.NotebookCellExecutionState=e.notebookDocumentMetadataDefaults=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var _;(function(o){o[o.Markup=1]="Markup",o[o.Code=2]="Code"})(_=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml","text/markdown","image/png","image/jpeg","text/plain"],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=["text/markdown","application/json","text/plain","text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var m;(function(o){o[o.Running=1]="Running",o[o.Idle=2]="Idle"})(m=e.NotebookRunState||(e.NotebookRunState={})),e.notebookDocumentMetadataDefaults={custom:{}};var y;(function(o){o[o.Pending=2]="Pending",o[o.Executing=3]="Executing"})(y=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={})),e.AnyRendererApi=Symbol("AnyRendererApi");var r;(function(o){o[o.WithHardKernelDependency=0]="WithHardKernelDependency",o[o.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",o[o.Pure=2]="Pure",o[o.Never=3]="Never"})(r=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var k;(function(o){o.Always="always",o.Never="never",o.Optional="optional"})(k=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(o){o[o.ModelChange=1]="ModelChange",o[o.Move=2]="Move",o[o.CellClearOutput=3]="CellClearOutput",o[o.CellsClearOutput=4]="CellsClearOutput",o[o.ChangeLanguage=5]="ChangeLanguage",o[o.Initialize=6]="Initialize",o[o.ChangeCellMetadata=7]="ChangeCellMetadata",o[o.Output=8]="Output",o[o.OutputItem=9]="OutputItem",o[o.ChangeCellContent=10]="ChangeCellContent",o[o.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",o[o.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",o[o.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var b;(function(o){o[o.Handle=0]="Handle",o[o.Index=1]="Index"})(b=e.SelectionStateType||(e.SelectionStateType={}));var f;(function(o){o[o.Replace=1]="Replace",o[o.Output=2]="Output",o[o.Metadata=3]="Metadata",o[o.CellLanguage=4]="CellLanguage",o[o.DocumentMetadata=5]="DocumentMetadata",o[o.Move=6]="Move",o[o.OutputItems=7]="OutputItems",o[o.PartialMetadata=8]="PartialMetadata",o[o.PartialInternalMetadata=9]="PartialInternalMetadata"})(f=e.CellEditType||(e.CellEditType={}));function c(o,F){if(F)return o.toString();const B=S.parse(o);return B?B.notebook.toString():o.toString()}e.getCellUndoRedoComparisonKey=c;var S;(function(o){o.scheme=P.Schemas.vscodeNotebookCell;const F=/^ch(\d{7,})/;function B(q,ee){return q.with({scheme:o.scheme,fragment:`ch${ee.toString().padStart(7,"0")}${q.scheme!==P.Schemas.file?q.scheme:""}`})}o.generate=B;function Z(q){if(q.scheme!==o.scheme)return;const ee=F.exec(q.fragment);return ee?{handle:Number(ee[1]),notebook:q.with({scheme:q.fragment.substr(ee[0].length)||P.Schemas.file,fragment:null})}:void 0}o.parse=Z;function ie(q){if(q.scheme!==P.Schemas.vscodeNotebookCellMetadata)return;const ee=F.exec(q.fragment);return ee?{handle:Number(ee[1]),notebook:q.with({scheme:q.fragment.substr(ee[0].length)||P.Schemas.file,fragment:null})}:void 0}o.parseCellMetadataUri=ie;function Se(q,ee,G){return q.with({scheme:G,fragment:`ch${ee.toString().padStart(7,"0")}${q.scheme!==P.Schemas.file?q.scheme:""}`})}o.generateCellUri=Se;function oe(q,ee){if(q.scheme!==ee)return;const G=F.exec(q.fragment);return G?{handle:Number(G[1]),notebook:q.with({scheme:q.fragment.substr(G[0].length)||P.Schemas.file,fragment:null})}:void 0}o.parseCellUri=oe})(S=e.CellUri||(e.CellUri={}));const w=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],["text/markdown",{alwaysSecure:!0,supportedByCore:!0}],["text/plain",{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/x.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/x.notebook.stream",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function C(o){var F,B;return(B=(F=w.get(o))===null||F===void 0?void 0:F.alwaysSecure)!==null&&B!==void 0?B:!1}e.mimeTypeIsAlwaysSecure=C;function h(o){var F,B;return(B=(F=w.get(o))===null||F===void 0?void 0:F.supportedByCore)!==null&&B!==void 0?B:!1}e.mimeTypeSupportedByCore=h;function l(o){var F,B;return(B=(F=w.get(o))===null||F===void 0?void 0:F.mergeable)!==null&&B!==void 0?B:!1}e.mimeTypeIsMergeable=l;function a(o,F){return D.isWindows&&(o=o.replace(/\//g,"\\"),F=F.replace(/\//g,"\\")),E.match(o,F)}function t(o,F,B){let Z=0;for(let ie=0;ie<F.length;ie++){if(a(F[ie],o))return Z;Z++}for(let ie=0;ie<B.length;ie++){if(a(B[ie],o))return Z;Z++}return Z}function i(o,F,B){return o.sort((Z,ie)=>t(Z,F,B)-t(ie,F,B))}e.sortMimeTypes=i;function n(o,F,B,Z=(ie,Se)=>ie===Se){const ie=[];function Se(ee,G,z){if(G===0&&z.length===0)return;const L=ie[ie.length-1];L&&L.start+L.deleteCount===ee?(L.deleteCount+=G,L.toInsert.push(...z)):ie.push({start:ee,deleteCount:G,toInsert:z})}let oe=0,q=0;for(;;){if(oe===o.length){Se(oe,0,F.slice(q));break}if(q===F.length){Se(oe,o.length-oe,[]);break}const ee=o[oe],G=F[q];if(Z(ee,G)){oe+=1,q+=1;continue}B(G)?(Se(oe,1,[]),oe+=1):(Se(oe,0,[G]),q+=1)}return ie}e.diff=n,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(o){o.default="default",o.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(o){const F=o;return!!((typeof F.include=="string"||E.isRelativePattern(F.include))&&(typeof F.exclude=="string"||E.isRelativePattern(F.exclude)))}e.isDocumentExcludePattern=u;function g(o,F,B){if(Array.isArray(o.viewType)&&o.viewType.indexOf(F)>=0||o.viewType===F)return!0;if(o.filenamePattern){let Z=u(o.filenamePattern)?o.filenamePattern.include:o.filenamePattern,ie=u(o.filenamePattern)?o.filenamePattern.exclude:void 0;if(E.match(Z,p.basename(B.fsPath).toLowerCase()))return!(ie&&E.match(ie,p.basename(B.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=g;class v{constructor(F){this.textModel=F}getElements(){const F=new Int32Array(this.textModel.cells.length);for(let B=0;B<this.textModel.cells.length;B++)F[B]=this.textModel.cells[B].getHashValue();return F}}e.CellSequence=v,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalUseMarkdownRenderer="notebook.experimental.useMarkdownRenderer",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted";var T;(function(o){o[o.Left=1]="Left",o[o.Right=2]="Right"})(T=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class R{static create(F){return`${R._prefix}${F}`}static parse(F){if(F.startsWith(R._prefix))return F.substr(R._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=R,R._prefix="notebook/"}),define(le[104],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentVariableMutatorType=e.IEnvironmentVariableService=void 0,e.IEnvironmentVariableService=E.createDecorator("environmentVariableService");var P;(function(p){p[p.Replace=1]="Replace",p[p.Append=2]="Append",p[p.Prepend=3]="Prepend"})(P=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}))}),define(le[213],ce([0,1,5,104]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MergedEnvironmentVariableCollection=void 0;class p{constructor(m){this.map=new Map,m.forEach((y,r)=>{const k=y.map.entries();let d=k.next();for(;!d.done;){const b=d.value[0];let f=this.map.get(b);if(f||(f=[],this.map.set(b,f)),f.length>0&&f[0].type===P.EnvironmentVariableMutatorType.Replace){d=k.next();continue}const c=d.value[1];f.unshift({extensionIdentifier:r,value:c.value,type:c.type}),d=k.next()}})}applyToProcessEnvironment(m,y){let r;E.isWindows&&(r={},Object.keys(m).forEach(k=>r[k.toLowerCase()]=k)),this.map.forEach((k,d)=>{const b=E.isWindows&&r[d.toLowerCase()]||d;k.forEach(f=>{const c=y?y(f.value):f.value;switch(f.type){case P.EnvironmentVariableMutatorType.Append:m[b]=(m[b]||"")+c;break;case P.EnvironmentVariableMutatorType.Prepend:m[b]=c+(m[b]||"");break;case P.EnvironmentVariableMutatorType.Replace:m[b]=c;break}})})}diff(m){const y=new Map,r=new Map,k=new Map;if(m.map.forEach((d,b)=>{const f=this.map.get(b),c=D(d,f);c&&y.set(b,c)}),this.map.forEach((d,b)=>{const f=m.map.get(b),c=D(d,f);c&&k.set(b,c)}),this.map.forEach((d,b)=>{const f=m.map.get(b),c=I(d,f);c&&r.set(b,c)}),!(y.size===0&&r.size===0&&k.size===0))return{added:y,changed:r,removed:k}}}e.MergedEnvironmentVariableCollection=p;function D(_,m){if(!m)return _;const y=new Set;m.forEach(k=>y.add(k.extensionIdentifier));const r=[];return _.forEach(k=>{y.has(k.extensionIdentifier)||r.push(k)}),r.length===0?void 0:r}function I(_,m){if(!m)return;const y=new Map;m.forEach(k=>y.set(k.extensionIdentifier,k));const r=[];return _.forEach(k=>{const d=y.get(k.extensionIdentifier);d&&(k.type!==d.type||k.value!==d.value)&&r.push(d)}),r.length===0?void 0:r}}),define(le[105],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function E(p){return[...p.entries()]}e.serializeEnvironmentVariableCollection=E;function P(p){return new Map(p)}e.deserializeEnvironmentVariableCollection=P}),define(le[214],ce([0,1,3,115,5]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTerminalEnvironment=e.getDefaultShellArgs=e.getDefaultShell=e.createVariableResolver=e.getCwd=e.getLangEnvVariable=e.shouldSetLangEnvVariable=e.addTerminalEnvironmentKeys=e.mergeEnvironments=void 0;function D(l,a){if(!!a)if(p.isWindows)for(const t in a){let i=t;for(const s in l)if(t.toLowerCase()===s.toLowerCase()){i=s;break}const n=a[t];n!==void 0&&I(l,i,n)}else Object.keys(a).forEach(t=>{const i=a[t];i!==void 0&&I(l,t,i)})}e.mergeEnvironments=D;function I(l,a,t){typeof t=="string"?l[a]=t:delete l[a]}function _(l,a,t,i){l.TERM_PROGRAM="vscode",a&&(l.TERM_PROGRAM_VERSION=a),r(l,i)&&(l.LANG=k(t)),l.COLORTERM="truecolor"}e.addTerminalEnvironmentKeys=_;function m(l,a){if(!!a)for(const t of Object.keys(a)){const i=a[t];i&&(l[t]=i)}}function y(l,a){return Object.keys(a).forEach(t=>{const i=a[t];if(typeof i=="string")try{a[t]=l(i)}catch(n){a[t]=i}}),a}function r(l,a){if(a==="on")return!0;if(a==="auto"){const t=l.LANG;return!t||t.search(/\.UTF\-8$/)===-1&&t.search(/\.utf8$/)===-1&&t.search(/\.euc.+/)===-1}return!1}e.shouldSetLangEnvVariable=r;function k(l){const a=l?l.split("-"):[],t=a.length;if(t===0)return"en_US.UTF-8";if(t===1){const i={af:"ZA",am:"ET",be:"BY",bg:"BG",ca:"ES",cs:"CZ",da:"DK",de:"DE",el:"GR",en:"US",es:"ES",et:"EE",eu:"ES",fi:"FI",fr:"FR",he:"IL",hr:"HR",hu:"HU",hy:"AM",is:"IS",it:"IT",ja:"JP",kk:"KZ",ko:"KR",lt:"LT",nl:"NL",no:"NO",pl:"PL",pt:"BR",ro:"RO",ru:"RU",sk:"SK",sl:"SI",sr:"YU",sv:"SE",tr:"TR",uk:"UA",zh:"CN"};a[0]in i&&a.push(i[a[0]])}else a[1]=a[1].toUpperCase();return a.join("_")+".UTF-8"}e.getLangEnvVariable=k;function d(l,a,t,i,n,s){if(l.cwd){const g=typeof l.cwd=="object"?l.cwd.fsPath:l.cwd,v=b(g,t);return f(v||g)}let u;return!l.ignoreConfigurationCwd&&n&&(t&&(n=b(n,t,s)),n&&(E.isAbsolute(n)?u=n:i&&(u=E.join(i.fsPath,n)))),u||(u=i?i.fsPath:a||""),f(u)}e.getCwd=d;function b(l,a,t){if(a)try{return a(l)}catch(i){t==null||t.error("Could not resolve terminal cwd",i);return}return l}function f(l){return p.OS===1&&l&&l[1]===":"?l[0].toUpperCase()+l.substr(1):l}function c(l,a,t){if(!!t)return i=>t.resolveWithEnvironment(a,l,i)}e.createVariableResolver=c;function S(l,a,t,i,n,s,u,g=p.platform){let v;u&&(v=C(l,"automationShell",g)),v||(v=C(l,"shell",g));let T=v||a;if(g===3&&!t&&i){const R=E.join(i,"Sysnative").replace(/\//g,"\\").toLowerCase();T&&T.toLowerCase().indexOf(R)===0&&(T=E.join(i,"System32",T.substr(R.length+1)))}if(T&&g===3&&(T=T.replace(/\//g,"\\")),n)try{T=n(T)}catch(R){s.error("Could not resolve shell",R)}return T}e.getDefaultShell=S;function w(l,a,t,i,n=p.platform){if(a&&C(l,"automationShell",n))return[];const s=n===3?"windows":n===1?"osx":"linux";let u=l(`terminal.integrated.shellArgs.${s}`);if(!u)return[];if(typeof u=="string"&&n===3)return t?t(u):u;if(t){const g=[];for(const v of u)try{g.push(t(v))}catch(T){i.error(`Could not resolve terminal.integrated.shellArgs.${s}`,T),g.push(v)}u=g}return u}e.getDefaultShellArgs=w;function C(l,a,t=p.platform){return l(`terminal.integrated.${a}.${t===3?"windows":t===1?"osx":"linux"}`)}function h(l,a,t,i,n,s){const u={};if(l.strictEnv)m(u,l.env);else{m(u,s);const g=Object.assign({},a);t&&(g&&y(t,g),l.env&&y(t,l.env)),P.sanitizeProcessEnvironment(u,"VSCODE_IPC_HOOK_CLI"),D(u,g),D(u,l.env),_(u,i,p.locale,n)}return u}e.createTerminalEnvironment=h}),define(le[215],ce([0,1,32,6]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TASKS_DEFAULT=e.IWorkbenchConfigurationService=e.USER_STANDALONE_CONFIGURATIONS=e.WORKSPACE_STANDALONE_CONFIGURATIONS=e.LAUNCH_CONFIGURATION_KEY=e.TASKS_CONFIGURATION_KEY=e.FOLDER_SCOPES=e.WORKSPACE_SCOPES=e.REMOTE_MACHINE_SCOPES=e.LOCAL_MACHINE_SCOPES=e.tasksSchemaId=e.launchSchemaId=e.folderSettingsSchemaId=e.workspaceSettingsSchemaId=e.machineSettingsSchemaId=e.userSettingsSchemaId=e.defaultSettingsSchemaId=e.FOLDER_SETTINGS_PATH=e.FOLDER_SETTINGS_NAME=e.FOLDER_CONFIG_FOLDER_NAME=void 0,e.FOLDER_CONFIG_FOLDER_NAME=".vscode",e.FOLDER_SETTINGS_NAME="settings",e.FOLDER_SETTINGS_PATH=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.FOLDER_SETTINGS_NAME}.json`,e.defaultSettingsSchemaId="vscode://schemas/settings/default",e.userSettingsSchemaId="vscode://schemas/settings/user",e.machineSettingsSchemaId="vscode://schemas/settings/machine",e.workspaceSettingsSchemaId="vscode://schemas/settings/workspace",e.folderSettingsSchemaId="vscode://schemas/settings/folder",e.launchSchemaId="vscode://schemas/launch",e.tasksSchemaId="vscode://schemas/tasks",e.LOCAL_MACHINE_SCOPES=[1,3,4,5],e.REMOTE_MACHINE_SCOPES=[2,3,4,5,6],e.WORKSPACE_SCOPES=[3,4,5,6],e.FOLDER_SCOPES=[4,5,6],e.TASKS_CONFIGURATION_KEY="tasks",e.LAUNCH_CONFIGURATION_KEY="launch",e.WORKSPACE_STANDALONE_CONFIGURATIONS=Object.create(null),e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.TASKS_CONFIGURATION_KEY}.json`,e.WORKSPACE_STANDALONE_CONFIGURATIONS[e.LAUNCH_CONFIGURATION_KEY]=`${e.FOLDER_CONFIG_FOLDER_NAME}/${e.LAUNCH_CONFIGURATION_KEY}.json`,e.USER_STANDALONE_CONFIGURATIONS=Object.create(null),e.USER_STANDALONE_CONFIGURATIONS[e.TASKS_CONFIGURATION_KEY]=`${e.TASKS_CONFIGURATION_KEY}.json`,e.IWorkbenchConfigurationService=P.refineServiceDecorator(E.IConfigurationService),e.TASKS_DEFAULT=`{
	"version": "2.0.0",
	"tasks": []
}`}),define(le[216],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IConfigurationResolverService=void 0,e.IConfigurationResolverService=E.createDecorator("configurationResolverService")}),define(le[217],ce([0,1,3,23,11,19,5,52,159]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class y{constructor(k,d,b){this._contributedVariables=new Map,this._context=k,this._labelService=d,b&&(this._envVariablesPromise=b.then(f=>this.prepareEnv(f)))}prepareEnv(k){if(I.isWindows){const d=Object.create(null);return Object.keys(k).forEach(b=>{d[b.toLowerCase()]=k[b]}),d}return k}resolveWithEnvironment(k,d,b){return this.recursiveResolve(this.prepareEnv(k),d?d.uri:void 0,b)}async resolveAsync(k,d){return this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,d)}async resolveAnyBase(k,d,b,f){const c=D.deepClone(d);return I.isWindows&&c.windows?Object.keys(c.windows).forEach(S=>c[S]=c.windows[S]):I.isMacintosh&&c.osx?Object.keys(c.osx).forEach(S=>c[S]=c.osx[S]):I.isLinux&&c.linux&&Object.keys(c.linux).forEach(S=>c[S]=c.linux[S]),delete c.windows,delete c.osx,delete c.linux,this.recursiveResolve(await this._envVariablesPromise,k?k.uri:void 0,c,b,f)}async resolveAnyAsync(k,d,b){return this.resolveAnyBase(k,d,b)}async resolveAnyMap(k,d,b){const f=new Map;return{newConfig:await this.resolveAnyBase(k,d,b,f),resolvedVariables:f}}resolveWithInteractionReplace(k,d,b,f){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(k,d,b,f){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(k,d){if(this._contributedVariables.has(k))throw new Error("Variable "+k+" is contributed twice.");this._contributedVariables.set(k,d)}recursiveResolve(k,d,b,f,c){if(p.isString(b))return this.resolveString(k,d,b,f,c);if(p.isArray(b))return b.map(S=>this.recursiveResolve(k,d,S,f,c));if(p.isObject(b)){let S=Object.create(null);return Object.keys(b).forEach(w=>{const C=this.resolveString(k,d,w,f,c);S[C]=this.recursiveResolve(k,d,b[w],f,c)}),S}return b}resolveString(k,d,b,f,c){return b.replace(y.VARIABLE_REGEXP,(w,C)=>{if(C.includes(y.VARIABLE_LHS))return w;let h=this.evaluateSingleVariable(k,w,C,d,f);return c&&c.set(C,h),h!==w&&p.isString(h)&&h.match(y.VARIABLE_REGEXP)&&(h=this.resolveString(k,d,h,f,c)),h})}fsPath(k){return this._labelService?this._labelService.getUriLabel(k,{noPrefix:!0}):k.fsPath}evaluateSingleVariable(k,d,b,f,c){let S;const w=b.split(":");w.length>1&&(b=w[0],S=w[1]);const C=()=>{const a=this._context.getFilePath();if(a)return a;throw new Error(m.localize(0,null,d))},h=()=>{const a=C();if(this._context.getWorkspaceFolderPathForFile){const t=this._context.getWorkspaceFolderPathForFile();if(t)return t}throw new Error(m.localize(1,null,d,E.basename(a)))},l=()=>{if(S){const a=this._context.getFolderUri(S);if(a)return a;throw new Error(m.localize(2,null,d,S))}if(f)return f;throw this._context.getWorkspaceFolderCount()>1?new Error(m.localize(3,null,d)):new Error(m.localize(4,null,d))};switch(b){case"env":if(S){if(k){const a=k[I.isWindows?S.toLowerCase():S];if(p.isString(a))return a}return""}throw new Error(m.localize(5,null,d));case"config":if(S){const a=this._context.getConfigurationValue(f,S);if(p.isUndefinedOrNull(a))throw new Error(m.localize(6,null,d,S));if(p.isObject(a))throw new Error(m.localize(7,null,d,S));return a}throw new Error(m.localize(8,null,d));case"command":return this.resolveFromMap(d,S,c,"command");case"input":return this.resolveFromMap(d,S,c,"input");default:switch(b){case"workspaceRoot":case"workspaceFolder":return _.normalizeDriveLetter(this.fsPath(l()));case"cwd":return f||S?_.normalizeDriveLetter(this.fsPath(l())):P.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return E.basename(this.fsPath(l()));case"lineNumber":const a=this._context.getLineNumber();if(a)return a;throw new Error(m.localize(9,null,d));case"selectedText":const t=this._context.getSelectedText();if(t)return t;throw new Error(m.localize(10,null,d));case"file":return C();case"fileWorkspaceFolder":return h();case"relativeFile":return f||S?E.relative(this.fsPath(l()),C()):C();case"relativeFileDirname":const i=E.dirname(C());if(f||S){const g=E.relative(this.fsPath(l()),i);return g.length===0?".":g}return i;case"fileDirname":return E.dirname(C());case"fileExtname":return E.extname(C());case"fileBasename":return E.basename(C());case"fileBasenameNoExtension":const n=E.basename(C());return n.slice(0,n.length-E.extname(n).length);case"fileDirnameBasename":return E.basename(E.dirname(C()));case"execPath":const s=this._context.getExecPath();return s||d;case"execInstallFolder":const u=this._context.getAppRoot();return u||d;case"pathSeparator":return E.sep;default:try{const g=S?`${b}:${S}`:b;return this.resolveFromMap(d,g,c,void 0)}catch(g){return d}}}}resolveFromMap(k,d,b,f){if(d&&b){const c=f===void 0?b[d]:b[f+":"+d];if(typeof c=="string")return c;throw new Error(m.localize(11,null,k))}return k}}e.AbstractVariableResolverService=y,y.VARIABLE_LHS="${",y.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(le[68],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=E.createDecorator("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2}),define(le[218],ce([0,1,21,74,240,46,19,11,4,54,177,163,186,212,68,103]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeActionTriggerKind=e.TestResults=e.TestItem=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var S;(function(re){function ue($){const{selectionStartLineNumber:Pe,selectionStartColumn:ye,positionLineNumber:$e,positionColumn:We}=$,et=new c.Position(Pe-1,ye-1),Je=new c.Position($e-1,We-1);return new c.Selection(et,Je)}re.to=ue;function J($){const{anchor:Pe,active:ye}=$;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:ye.line+1,positionColumn:ye.character+1}}re.from=J})(S=e.Selection||(e.Selection={}));var w;(function(re){function ue($){if(!$)return;const{start:Pe,end:ye}=$;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:ye.line+1,endColumn:ye.character+1}}re.from=ue;function J($){if(!$)return;const{startLineNumber:Pe,startColumn:ye,endLineNumber:$e,endColumn:We}=$;return new c.Range(Pe-1,ye-1,$e-1,We-1)}re.to=J})(w=e.Range||(e.Range={}));var C;(function(re){function ue(J){switch(J){case 1:return c.StandardTokenType.Comment;case 0:return c.StandardTokenType.Other;case 4:return c.StandardTokenType.RegEx;case 2:return c.StandardTokenType.String}}re.to=ue})(C=e.TokenType||(e.TokenType={}));var h;(function(re){function ue($){return new c.Position($.lineNumber-1,$.column-1)}re.to=ue;function J($){return{lineNumber:$.line+1,column:$.character+1}}re.from=J})(h=e.Position||(e.Position={}));var l;(function(re){function ue($){switch($){case c.DiagnosticTag.Unnecessary:return 1;case c.DiagnosticTag.Deprecated:return 2}}re.from=ue;function J($){switch($){case 1:return c.DiagnosticTag.Unnecessary;case 2:return c.DiagnosticTag.Deprecated;default:return}}re.to=J})(l=e.DiagnosticTag||(e.DiagnosticTag={}));var a;(function(re){function ue($){let Pe;return $.code&&(_.isString($.code)||_.isNumber($.code)?Pe=String($.code):Pe={value:String($.code.value),target:$.code.target}),Object.assign(Object.assign({},w.from($.range)),{message:$.message,source:$.source,code:Pe,severity:i.from($.severity),relatedInformation:$.relatedInformation&&$.relatedInformation.map(t.from),tags:Array.isArray($.tags)?E.coalesce($.tags.map(l.from)):void 0})}re.from=ue;function J($){var Pe;const ye=new c.Diagnostic(w.to($),$.message,i.to($.severity));return ye.source=$.source,ye.code=_.isString($.code)?$.code:(Pe=$.code)===null||Pe===void 0?void 0:Pe.value,ye.relatedInformation=$.relatedInformation&&$.relatedInformation.map(t.to),ye.tags=$.tags&&E.coalesce($.tags.map(l.to)),ye}re.to=J})(a=e.Diagnostic||(e.Diagnostic={}));var t;(function(re){function ue($){return Object.assign(Object.assign({},w.from($.location.range)),{message:$.message,resource:$.location.uri})}re.from=ue;function J($){return new c.DiagnosticRelatedInformation(new c.Location($.resource,w.to($)),$.message)}re.to=J})(t=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var i;(function(re){function ue($){switch($){case c.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case c.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case c.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case c.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}re.from=ue;function J($){switch($){case d.MarkerSeverity.Info:return c.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return c.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return c.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return c.DiagnosticSeverity.Hint;default:return c.DiagnosticSeverity.Error}}re.to=J})(i=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var n;(function(re){function ue($){return typeof $=="number"&&$>=c.ViewColumn.One?$-1:$===c.ViewColumn.Beside?f.SIDE_GROUP:f.ACTIVE_GROUP}re.from=ue;function J($){if(typeof $=="number"&&$>=0)return $+1;throw new Error("invalid 'EditorGroupColumn'")}re.to=J})(n=e.ViewColumn||(e.ViewColumn={}));function s(re){return typeof re.range!="undefined"}function u(re){return re.length===0?!0:!!s(re[0])}e.isDecorationOptionsArr=u;var g;(function(re){function ue(We){return We.map(re.from)}re.fromMany=ue;function J(We){return We&&typeof We=="object"&&typeof We.language=="string"&&typeof We.value=="string"}function $(We){let et;if(J(We)){const{language:ct,value:ut}=We;et={value:"```"+ct+`
`+ut+"\n```\n"}}else c.MarkdownString.isMarkdownString(We)?et={value:We.value,isTrusted:We.isTrusted,supportThemeIcons:We.supportThemeIcons}:typeof We=="string"?et={value:We}:et={value:""};const Je=Object.create(null);et.uris=Je;const Ve=ct=>{try{let ut=m.URI.parse(ct,!0);ut=ut.with({query:Pe(ut.query,Je)}),Je[ct]=ut}catch(ut){}return""},rt=new p.Renderer;return rt.link=Ve,rt.image=ct=>Ve(P.parseHrefAndDimensions(ct).href),p(et.value,{renderer:rt}),et}re.from=$;function Pe(We,et){if(!We)return We;let Je;try{Je=D.parse(We)}catch(rt){}if(!Je)return We;let Ve=!1;return Je=I.cloneAndChange(Je,rt=>{if(m.URI.isUri(rt)){const ct=`__uri_${Math.random().toString(16).slice(2,8)}`;return et[ct]=rt,Ve=!0,ct}else return}),Ve?JSON.stringify(Je):We}function ye(We){const et=new c.MarkdownString(We.value,We.supportThemeIcons);return et.isTrusted=We.isTrusted,et}re.to=ye;function $e(We){if(!!We)return typeof We=="string"?We:re.from(We)}re.fromStrict=$e})(g=e.MarkdownString||(e.MarkdownString={}));function v(re){return u(re)?re.map(ue=>({range:w.from(ue.range),hoverMessage:Array.isArray(ue.hoverMessage)?g.fromMany(ue.hoverMessage):ue.hoverMessage?g.from(ue.hoverMessage):void 0,renderOptions:ue.renderOptions})):re.map(ue=>({range:w.from(ue)}))}e.fromRangeOrRangeWithMessage=v;function T(re){return typeof re=="undefined"?re:typeof re=="string"?m.URI.file(re):re}e.pathOrURIToURI=T;var R;(function(re){function ue(J){return typeof J=="undefined"?J:{contentText:J.contentText,contentIconPath:J.contentIconPath?T(J.contentIconPath):void 0,border:J.border,borderColor:J.borderColor,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,color:J.color,backgroundColor:J.backgroundColor,margin:J.margin,width:J.width,height:J.height}}re.from=ue})(R=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var o;(function(re){function ue(J){return typeof J=="undefined"?J:{backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?T(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?R.from(J.before):void 0,after:J.after?R.from(J.after):void 0}}re.from=ue})(o=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var F;(function(re){function ue(J){if(typeof J=="undefined")return J;switch(J){case c.DecorationRangeBehavior.OpenOpen:return 0;case c.DecorationRangeBehavior.ClosedClosed:return 1;case c.DecorationRangeBehavior.OpenClosed:return 2;case c.DecorationRangeBehavior.ClosedOpen:return 3}}re.from=ue})(F=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var B;(function(re){function ue(J){return{isWholeLine:J.isWholeLine,rangeBehavior:J.rangeBehavior?F.from(J.rangeBehavior):void 0,overviewRulerLane:J.overviewRulerLane,light:J.light?o.from(J.light):void 0,dark:J.dark?o.from(J.dark):void 0,backgroundColor:J.backgroundColor,outline:J.outline,outlineColor:J.outlineColor,outlineStyle:J.outlineStyle,outlineWidth:J.outlineWidth,border:J.border,borderColor:J.borderColor,borderRadius:J.borderRadius,borderSpacing:J.borderSpacing,borderStyle:J.borderStyle,borderWidth:J.borderWidth,fontStyle:J.fontStyle,fontWeight:J.fontWeight,textDecoration:J.textDecoration,cursor:J.cursor,color:J.color,opacity:J.opacity,letterSpacing:J.letterSpacing,gutterIconPath:J.gutterIconPath?T(J.gutterIconPath):void 0,gutterIconSize:J.gutterIconSize,overviewRulerColor:J.overviewRulerColor,before:J.before?R.from(J.before):void 0,after:J.after?R.from(J.after):void 0}}re.from=ue})(B=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var Z;(function(re){function ue($){return{text:$.newText,eol:$.newEol&&xe.from($.newEol),range:w.from($.range)}}re.from=ue;function J($){const Pe=new c.TextEdit(w.to($.range),$.text);return Pe.newEol=typeof $.eol=="undefined"?void 0:xe.to($.eol),Pe}re.to=J})(Z=e.TextEdit||(e.TextEdit={}));var ie;(function(re){function ue($,Pe,ye){var $e,We,et;const Je={edits:[]};if($ instanceof c.WorkspaceEdit)for(let Ve of $._allEntries())if(Ve._type===1)Je.edits.push({_type:1,oldUri:Ve.from,newUri:Ve.to,options:Ve.options,metadata:Ve.metadata});else if(Ve._type===2){const rt=Pe==null?void 0:Pe.getDocument(Ve.uri);Je.edits.push({_type:2,resource:Ve.uri,edit:Z.from(Ve.edit),modelVersionId:rt==null?void 0:rt.version,metadata:Ve.metadata})}else Ve._type===3?Je.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:Ve.edit,notebookMetadata:Ve.notebookMetadata,notebookVersionId:($e=ye==null?void 0:ye.getNotebookDocument(Ve.uri,!0))===null||$e===void 0?void 0:$e.apiNotebook.version}):Ve._type===4?(Ve.newOutputs&&Je.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:{editType:2,index:Ve.index,append:Ve.append,outputs:Ve.newOutputs.map(Y.from)}}),Ve.newMetadata&&Je.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:{editType:8,index:Ve.index,metadata:Ve.newMetadata}})):Ve._type===5?Je.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,notebookVersionId:(We=ye==null?void 0:ye.getNotebookDocument(Ve.uri,!0))===null||We===void 0?void 0:We.apiNotebook.version,edit:{editType:1,index:Ve.index,count:Ve.count,cells:Ve.cells.map(U.from)}}):Ve._type===6&&Je.edits.push({_type:3,metadata:Ve.metadata,resource:Ve.uri,edit:{editType:7,outputId:Ve.outputId,items:((et=Ve.newOutputItems)===null||et===void 0?void 0:et.map(H.from))||[],append:Ve.append}});return Je}re.from=ue;function J($){const Pe=new c.WorkspaceEdit;for(const ye of $.edits)ye.edit?Pe.replace(m.URI.revive(ye.resource),w.to(ye.edit.range),ye.edit.text):Pe.renameFile(m.URI.revive(ye.oldUri),m.URI.revive(ye.newUri),ye.options);return Pe}re.to=J})(ie=e.WorkspaceEdit||(e.WorkspaceEdit={}));var Se;(function(re){const ue=Object.create(null);ue[c.SymbolKind.File]=0,ue[c.SymbolKind.Module]=1,ue[c.SymbolKind.Namespace]=2,ue[c.SymbolKind.Package]=3,ue[c.SymbolKind.Class]=4,ue[c.SymbolKind.Method]=5,ue[c.SymbolKind.Property]=6,ue[c.SymbolKind.Field]=7,ue[c.SymbolKind.Constructor]=8,ue[c.SymbolKind.Enum]=9,ue[c.SymbolKind.Interface]=10,ue[c.SymbolKind.Function]=11,ue[c.SymbolKind.Variable]=12,ue[c.SymbolKind.Constant]=13,ue[c.SymbolKind.String]=14,ue[c.SymbolKind.Number]=15,ue[c.SymbolKind.Boolean]=16,ue[c.SymbolKind.Array]=17,ue[c.SymbolKind.Object]=18,ue[c.SymbolKind.Key]=19,ue[c.SymbolKind.Null]=20,ue[c.SymbolKind.EnumMember]=21,ue[c.SymbolKind.Struct]=22,ue[c.SymbolKind.Event]=23,ue[c.SymbolKind.Operator]=24,ue[c.SymbolKind.TypeParameter]=25;function J(Pe){return typeof ue[Pe]=="number"?ue[Pe]:6}re.from=J;function $(Pe){for(const ye in ue)if(ue[ye]===Pe)return Number(ye);return c.SymbolKind.Property}re.to=$})(Se=e.SymbolKind||(e.SymbolKind={}));var oe;(function(re){function ue($){switch($){case c.SymbolTag.Deprecated:return 1}}re.from=ue;function J($){switch($){case 1:return c.SymbolTag.Deprecated}}re.to=J})(oe=e.SymbolTag||(e.SymbolTag={}));var q;(function(re){function ue($){return{name:$.name,kind:Se.from($.kind),tags:$.tags&&$.tags.map(oe.from),containerName:$.containerName,location:A.from($.location)}}re.from=ue;function J($){const Pe=new c.SymbolInformation($.name,Se.to($.kind),$.containerName,A.to($.location));return Pe.tags=$.tags&&$.tags.map(oe.to),Pe}re.to=J})(q=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ee;(function(re){function ue($){var Pe,ye;const $e={name:$.name||"!!MISSING: name!!",detail:$.detail,range:w.from($.range),selectionRange:w.from($.selectionRange),kind:Se.from($.kind),tags:(ye=(Pe=$.tags)===null||Pe===void 0?void 0:Pe.map(oe.from))!==null&&ye!==void 0?ye:[]};return $.children&&($e.children=$.children.map(ue)),$e}re.from=ue;function J($){const Pe=new c.DocumentSymbol($.name,$.detail,Se.to($.kind),w.to($.range),w.to($.selectionRange));return E.isNonEmptyArray($.tags)&&(Pe.tags=$.tags.map(oe.to)),$.children&&(Pe.children=$.children.map(J)),Pe}re.to=J})(ee=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(re){function ue(J){const $=new c.CallHierarchyItem(Se.to(J.kind),J.name,J.detail||"",m.URI.revive(J.uri),w.to(J.range),w.to(J.selectionRange));return $._sessionId=J._sessionId,$._itemId=J._itemId,$}re.to=ue})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var z;(function(re){function ue(J){return new c.CallHierarchyIncomingCall(G.to(J.from),J.fromRanges.map($=>w.to($)))}re.to=ue})(z=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var L;(function(re){function ue(J){return new c.CallHierarchyOutgoingCall(G.to(J.to),J.fromRanges.map($=>w.to($)))}re.to=ue})(L=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var A;(function(re){function ue($){return{range:$.range&&w.from($.range),uri:$.uri}}re.from=ue;function J($){return new c.Location(m.URI.revive($.uri),w.to($.range))}re.to=J})(A=e.location||(e.location={}));var N;(function(re){function ue($){const Pe=$,ye=$;return{originSelectionRange:Pe.originSelectionRange?w.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:ye.uri,range:w.from(Pe.targetRange?Pe.targetRange:ye.range),targetSelectionRange:Pe.targetSelectionRange?w.from(Pe.targetSelectionRange):void 0}}re.from=ue;function J($){return{targetUri:m.URI.revive($.uri),targetRange:w.to($.range),targetSelectionRange:$.targetSelectionRange?w.to($.targetSelectionRange):void 0,originSelectionRange:$.originSelectionRange?w.to($.originSelectionRange):void 0}}re.to=J})(N=e.DefinitionLink||(e.DefinitionLink={}));var M;(function(re){function ue($){return{range:w.from($.range),contents:g.fromMany($.contents)}}re.from=ue;function J($){return new c.Hover($.contents.map(g.to),w.to($.range))}re.to=J})(M=e.Hover||(e.Hover={}));var W;(function(re){function ue($){return{range:w.from($.range),expression:$.expression}}re.from=ue;function J($){return new c.EvaluatableExpression(w.to($.range),$.expression)}re.to=J})(W=e.EvaluatableExpression||(e.EvaluatableExpression={}));var X;(function(re){function ue($){if($ instanceof c.InlineValueText)return{type:"text",range:w.from($.range),text:$.text};if($ instanceof c.InlineValueVariableLookup)return{type:"variable",range:w.from($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};if($ instanceof c.InlineValueEvaluatableExpression)return{type:"expression",range:w.from($.range),expression:$.expression};throw new Error("Unknown 'InlineValue' type")}re.from=ue;function J($){switch($.type){case"text":return{range:w.to($.range),text:$.text};case"variable":return{range:w.to($.range),variableName:$.variableName,caseSensitiveLookup:$.caseSensitiveLookup};case"expression":return{range:w.to($.range),expression:$.expression}}}re.to=J})(X=e.InlineValue||(e.InlineValue={}));var ae;(function(re){function ue($){return{frameId:$.frameId,stoppedLocation:w.from($.stoppedLocation)}}re.from=ue;function J($){return new c.InlineValueContext($.frameId,w.to($.stoppedLocation))}re.to=J})(ae=e.InlineValueContext||(e.InlineValueContext={}));var se;(function(re){function ue($){return{range:w.from($.range),kind:$.kind}}re.from=ue;function J($){return new c.DocumentHighlight(w.to($.range),$.kind)}re.to=J})(se=e.DocumentHighlight||(e.DocumentHighlight={}));var be;(function(re){function ue(J){switch(J){case 1:return c.CompletionTriggerKind.TriggerCharacter;case 2:return c.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return c.CompletionTriggerKind.Invoke}}re.to=ue})(be=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ke;(function(re){function ue(J){return{triggerKind:be.to(J.triggerKind),triggerCharacter:J.triggerCharacter}}re.to=ue})(ke=e.CompletionContext||(e.CompletionContext={}));var Te;(function(re){function ue($){switch($){case c.CompletionItemTag.Deprecated:return 1}}re.from=ue;function J($){switch($){case 1:return c.CompletionItemTag.Deprecated}}re.to=J})(Te=e.CompletionItemTag||(e.CompletionItemTag={}));var Le;(function(re){const ue=new Map([[c.CompletionItemKind.Method,0],[c.CompletionItemKind.Function,1],[c.CompletionItemKind.Constructor,2],[c.CompletionItemKind.Field,3],[c.CompletionItemKind.Variable,4],[c.CompletionItemKind.Class,5],[c.CompletionItemKind.Interface,7],[c.CompletionItemKind.Struct,6],[c.CompletionItemKind.Module,8],[c.CompletionItemKind.Property,9],[c.CompletionItemKind.Unit,12],[c.CompletionItemKind.Value,13],[c.CompletionItemKind.Constant,14],[c.CompletionItemKind.Enum,15],[c.CompletionItemKind.EnumMember,16],[c.CompletionItemKind.Keyword,17],[c.CompletionItemKind.Snippet,27],[c.CompletionItemKind.Text,18],[c.CompletionItemKind.Color,19],[c.CompletionItemKind.File,20],[c.CompletionItemKind.Reference,21],[c.CompletionItemKind.Folder,23],[c.CompletionItemKind.Event,10],[c.CompletionItemKind.Operator,11],[c.CompletionItemKind.TypeParameter,24],[c.CompletionItemKind.Issue,26],[c.CompletionItemKind.User,25]]);function J(ye){var $e;return($e=ue.get(ye))!==null&&$e!==void 0?$e:9}re.from=J;const $=new Map([[0,c.CompletionItemKind.Method],[1,c.CompletionItemKind.Function],[2,c.CompletionItemKind.Constructor],[3,c.CompletionItemKind.Field],[4,c.CompletionItemKind.Variable],[5,c.CompletionItemKind.Class],[7,c.CompletionItemKind.Interface],[6,c.CompletionItemKind.Struct],[8,c.CompletionItemKind.Module],[9,c.CompletionItemKind.Property],[12,c.CompletionItemKind.Unit],[13,c.CompletionItemKind.Value],[14,c.CompletionItemKind.Constant],[15,c.CompletionItemKind.Enum],[16,c.CompletionItemKind.EnumMember],[17,c.CompletionItemKind.Keyword],[27,c.CompletionItemKind.Snippet],[18,c.CompletionItemKind.Text],[19,c.CompletionItemKind.Color],[20,c.CompletionItemKind.File],[21,c.CompletionItemKind.Reference],[23,c.CompletionItemKind.Folder],[10,c.CompletionItemKind.Event],[11,c.CompletionItemKind.Operator],[24,c.CompletionItemKind.TypeParameter],[25,c.CompletionItemKind.User],[26,c.CompletionItemKind.Issue]]);function Pe(ye){var $e;return($e=$.get(ye))!==null&&$e!==void 0?$e:c.CompletionItemKind.Property}re.to=Pe})(Le=e.CompletionItemKind||(e.CompletionItemKind={}));var je;(function(re){function ue(J,$){var Pe;const ye=new c.CompletionItem(typeof J.label=="string"?J.label:J.label.name);return typeof J.label!="string"&&(ye.label2=J.label),ye.insertText=J.insertText,ye.kind=Le.to(J.kind),ye.tags=(Pe=J.tags)===null||Pe===void 0?void 0:Pe.map(Te.to),ye.detail=J.detail,ye.documentation=P.isMarkdownString(J.documentation)?g.to(J.documentation):J.documentation,ye.sortText=J.sortText,ye.filterText=J.filterText,ye.preselect=J.preselect,ye.commitCharacters=J.commitCharacters,y.Range.isIRange(J.range)?ye.range=w.to(J.range):typeof J.range=="object"&&(ye.range={inserting:w.to(J.range.insert),replacing:w.to(J.range.replace)}),ye.keepWhitespace=typeof J.insertTextRules=="undefined"?!1:Boolean(J.insertTextRules&1),typeof J.insertTextRules!="undefined"&&J.insertTextRules&4?ye.insertText=new c.SnippetString(J.insertText):(ye.insertText=J.insertText,ye.textEdit=ye.range instanceof c.Range?new c.TextEdit(ye.range,ye.insertText):void 0),J.additionalTextEdits&&J.additionalTextEdits.length>0&&(ye.additionalTextEdits=J.additionalTextEdits.map($e=>Z.to($e))),ye.command=$&&J.command?$.fromInternal(J.command):void 0,ye}re.to=ue})(je=e.CompletionItem||(e.CompletionItem={}));var Xe;(function(re){function ue($){return{label:$.label,documentation:$.documentation?g.fromStrict($.documentation):void 0}}re.from=ue;function J($){return{label:$.label,documentation:P.isMarkdownString($.documentation)?g.to($.documentation):$.documentation}}re.to=J})(Xe=e.ParameterInformation||(e.ParameterInformation={}));var Ze;(function(re){function ue($){return{label:$.label,documentation:$.documentation?g.fromStrict($.documentation):void 0,parameters:Array.isArray($.parameters)?$.parameters.map(Xe.from):[],activeParameter:$.activeParameter}}re.from=ue;function J($){return{label:$.label,documentation:P.isMarkdownString($.documentation)?g.to($.documentation):$.documentation,parameters:Array.isArray($.parameters)?$.parameters.map(Xe.to):[],activeParameter:$.activeParameter}}re.to=J})(Ze=e.SignatureInformation||(e.SignatureInformation={}));var it;(function(re){function ue($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(Ze.from):[]}}re.from=ue;function J($){return{activeSignature:$.activeSignature,activeParameter:$.activeParameter,signatures:Array.isArray($.signatures)?$.signatures.map(Ze.to):[]}}re.to=J})(it=e.SignatureHelp||(e.SignatureHelp={}));var Ye;(function(re){function ue($){var Pe;return{text:$.text,position:h.from($.position),kind:ge.from((Pe=$.kind)!==null&&Pe!==void 0?Pe:c.InlayHintKind.Other),whitespaceBefore:$.whitespaceBefore,whitespaceAfter:$.whitespaceAfter}}re.from=ue;function J($){const Pe=new c.InlayHint($.text,h.to($.position),ge.to($.kind));return Pe.whitespaceAfter=$.whitespaceAfter,Pe.whitespaceBefore=$.whitespaceBefore,Pe}re.to=J})(Ye=e.InlayHint||(e.InlayHint={}));var ge;(function(re){function ue($){return $}re.from=ue;function J($){return $}re.to=J})(ge=e.InlayHintKind||(e.InlayHintKind={}));var Ie;(function(re){function ue($){return{range:w.from($.range),url:$.target,tooltip:$.tooltip}}re.from=ue;function J($){let Pe;if($.url)try{Pe=typeof $.url=="string"?m.URI.parse($.url,!0):m.URI.revive($.url)}catch(ye){}return new c.DocumentLink(w.to($.range),Pe)}re.to=J})(Ie=e.DocumentLink||(e.DocumentLink={}));var _e;(function(re){function ue($){const Pe=new c.ColorPresentation($.label);return $.textEdit&&(Pe.textEdit=Z.to($.textEdit)),$.additionalTextEdits&&(Pe.additionalTextEdits=$.additionalTextEdits.map(ye=>Z.to(ye))),Pe}re.to=ue;function J($){return{label:$.label,textEdit:$.textEdit?Z.from($.textEdit):void 0,additionalTextEdits:$.additionalTextEdits?$.additionalTextEdits.map(Pe=>Z.from(Pe)):void 0}}re.from=J})(_e=e.ColorPresentation||(e.ColorPresentation={}));var Re;(function(re){function ue($){return new c.Color($[0],$[1],$[2],$[3])}re.to=ue;function J($){return[$.red,$.green,$.blue,$.alpha]}re.from=J})(Re=e.Color||(e.Color={}));var Me;(function(re){function ue($){return{range:w.from($.range)}}re.from=ue;function J($){return new c.SelectionRange(w.to($.range))}re.to=J})(Me=e.SelectionRange||(e.SelectionRange={}));var ze;(function(re){function ue(J){switch(J){case 2:return c.TextDocumentSaveReason.AfterDelay;case 1:return c.TextDocumentSaveReason.Manual;case 3:case 4:return c.TextDocumentSaveReason.FocusOut}}re.to=ue})(ze=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var He;(function(re){function ue($){switch($){case c.TextEditorLineNumbersStyle.Off:return 0;case c.TextEditorLineNumbersStyle.Relative:return 2;case c.TextEditorLineNumbersStyle.On:default:return 1}}re.from=ue;function J($){switch($){case 0:return c.TextEditorLineNumbersStyle.Off;case 2:return c.TextEditorLineNumbersStyle.Relative;case 1:default:return c.TextEditorLineNumbersStyle.On}}re.to=J})(He=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var xe;(function(re){function ue($){if($===c.EndOfLine.CRLF)return 1;if($===c.EndOfLine.LF)return 0}re.from=ue;function J($){if($===1)return c.EndOfLine.CRLF;if($===0)return c.EndOfLine.LF}re.to=J})(xe=e.EndOfLine||(e.EndOfLine={}));var tt;(function(re){function ue(J){if(typeof J=="object")return J.viewId;switch(J){case c.ProgressLocation.SourceControl:return 3;case c.ProgressLocation.Window:return 10;case c.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}re.from=ue})(tt=e.ProgressLocation||(e.ProgressLocation={}));var te;(function(re){function ue(J){const $={start:J.start+1,end:J.end+1};return J.kind&&($.kind=ve.from(J.kind)),$}re.from=ue})(te=e.FoldingRange||(e.FoldingRange={}));var ve;(function(re){function ue(J){if(J)switch(J){case c.FoldingRangeKind.Comment:return r.FoldingRangeKind.Comment;case c.FoldingRangeKind.Imports:return r.FoldingRangeKind.Imports;case c.FoldingRangeKind.Region:return r.FoldingRangeKind.Region}}re.from=ue})(ve=e.FoldingRangeKind||(e.FoldingRangeKind={}));var de;(function(re){function ue(J){if(J)return{pinned:typeof J.preview=="boolean"?!J.preview:void 0,inactive:J.background,preserveFocus:J.preserveFocus,selection:typeof J.selection=="object"?w.from(J.selection):void 0,override:typeof J.override=="boolean"?k.EditorOverride.DISABLED:void 0}}re.from=ue})(de=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var Ue;(function(re){function ue($){return $ instanceof c.RelativePattern||typeof $=="string"?$:J($)?new c.RelativePattern($.base,$.pattern):$}re.from=ue;function J($){const Pe=$;return Pe&&typeof Pe.base=="string"&&typeof Pe.pattern=="string"}})(Ue=e.GlobPattern||(e.GlobPattern={}));var he;(function(re){function ue(J){if(J){if(Array.isArray(J))return J.map(ue);if(typeof J=="string")return J;{const $=J;return{language:$.language,scheme:$.scheme,pattern:typeof $.pattern=="undefined"?void 0:Ue.from($.pattern),exclusive:$.exclusive}}}else return}re.from=ue})(he=e.LanguageSelector||(e.LanguageSelector={}));var me;(function(re){function ue($){return{start:$.start,end:$.end}}re.from=ue;function J($){return new c.NotebookRange($.start,$.end)}re.to=J})(me=e.NotebookRange||(e.NotebookRange={}));var fe;(function(re){function ue($){return{timing:typeof $.runStartTime=="number"&&typeof $.runEndTime=="number"?{startTime:$.runStartTime,endTime:$.runEndTime}:void 0,executionOrder:$.executionOrder,success:$.lastRunSuccess}}re.to=ue;function J($){var Pe,ye;return{lastRunSuccess:$.success,runStartTime:(Pe=$.timing)===null||Pe===void 0?void 0:Pe.startTime,runEndTime:(ye=$.timing)===null||ye===void 0?void 0:ye.endTime,executionOrder:$.executionOrder}}re.from=J})(fe=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var V;(function(re){function ue($){switch($){case c.NotebookCellKind.Markup:return b.CellKind.Markup;case c.NotebookCellKind.Code:default:return b.CellKind.Code}}re.from=ue;function J($){switch($){case b.CellKind.Markup:return c.NotebookCellKind.Markup;case b.CellKind.Code:default:return c.NotebookCellKind.Code}}re.to=J})(V=e.NotebookCellKind||(e.NotebookCellKind={}));var Q;(function(re){function ue($){var Pe;const ye={metadata:(Pe=$.metadata)!==null&&Pe!==void 0?Pe:Object.create(null),cells:[]};for(let $e of $.cells)c.NotebookCellData.validate($e),ye.cells.push(U.from($e));return ye}re.from=ue;function J($){const Pe=new c.NotebookData($.cells.map(U.to));return _.isEmptyObject($.metadata)||(Pe.metadata=$.metadata),Pe}re.to=J})(Q=e.NotebookData||(e.NotebookData={}));var U;(function(re){function ue($){var Pe;return{cellKind:V.from($.kind),language:$.languageId,source:$.value,metadata:$.metadata,internalMetadata:fe.from((Pe=$.executionSummary)!==null&&Pe!==void 0?Pe:{}),outputs:$.outputs?$.outputs.map(Y.from):[]}}re.from=ue;function J($){return new c.NotebookCellData(V.to($.cellKind),$.source,$.language,$.outputs?$.outputs.map(Y.to):void 0,$.metadata,$.internalMetadata?fe.to($.internalMetadata):void 0)}re.to=J})(U=e.NotebookCellData||(e.NotebookCellData={}));var H;(function(re){function ue($){return{mime:$.mime,valueBytes:Array.from($.data)}}re.from=ue;function J($){return new c.NotebookCellOutputItem(new Uint8Array($.valueBytes),$.mime)}re.to=J})(H=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Y;(function(re){function ue($){return{outputId:$.id,outputs:$.items.map(H.from),metadata:$.metadata}}re.from=ue;function J($){const Pe=$.outputs.map(H.to);return new c.NotebookCellOutput(Pe,$.outputId,$.metadata)}re.to=J})(Y=e.NotebookCellOutput||(e.NotebookCellOutput={}));var pe;(function(re){function ue(ye){if(ye!=null){if(ye instanceof c.RelativePattern||typeof ye=="string")return ye;if(Pe(ye))return new c.RelativePattern(ye.base,ye.pattern);if($(ye))return{include:Ue.from(ye.include)||void 0,exclude:Ue.from(ye.exclude)||void 0}}}re.from=ue;function J(ye){return typeof ye=="string"?ye:Pe(ye)?{base:ye.base,pattern:ye.pattern}:{include:ye.include,exclude:ye.exclude}}re.to=J;function $(ye){const $e=ye,We=Ue.from($e.include);if(!(We&&We instanceof c.RelativePattern||typeof We=="string"))return!1;const et=Ue.from($e.exclude);return!!(et&&et instanceof c.RelativePattern||typeof et=="string")}function Pe(ye){const $e=ye;return $e&&typeof $e.base=="string"&&typeof $e.pattern=="string"}})(pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var Ee;(function(re){function ue(J){return{backgroundColor:J.backgroundColor,borderColor:J.borderColor,top:J.top?R.from(J.top):void 0}}re.from=ue})(Ee=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var Ce;(function(re){function ue(J,$,Pe){const ye=typeof J.command=="string"?{title:"",command:J.command}:J.command;return{alignment:J.alignment===c.NotebookCellStatusBarAlignment.Left?1:2,command:$.toInternal(ye,Pe),text:J.text,tooltip:J.tooltip,accessibilityInformation:J.accessibilityInformation,priority:J.priority}}re.from=ue})(Ce=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var ne;(function(re){function ue(J){var $,Pe,ye;return{transientOutputs:($=J==null?void 0:J.transientOutputs)!==null&&$!==void 0?$:!1,transientCellMetadata:(Pe=J==null?void 0:J.transientCellMetadata)!==null&&Pe!==void 0?Pe:{},transientDocumentMetadata:(ye=J==null?void 0:J.transientDocumentMetadata)!==null&&ye!==void 0?ye:{}}}re.from=ue})(ne=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var De;(function(re){function ue($){return{uri:$.uri,provides:$.provides}}re.from=ue;function J($){return new c.NotebookRendererScript(m.URI.revive($.uri),$.provides)}re.to=J})(De=e.NotebookRendererScript||(e.NotebookRendererScript={}));var Ae;(function(re){function ue($){return{message:g.fromStrict($.message)||"",severity:$.severity,expectedOutput:$.expectedOutput,actualOutput:$.actualOutput,location:$.location?A.from($.location):void 0}}re.from=ue;function J($){const Pe=new c.TestMessage(typeof $.message=="string"?$.message:g.to($.message));return Pe.severity=$.severity,Pe.actualOutput=$.actualOutput,Pe.expectedOutput=$.expectedOutput,Pe}re.to=J})(Ae=e.TestMessage||(e.TestMessage={}));var Fe;(function(re){function ue(ye){var $e,We;return{extId:ye.id,label:ye.label,uri:ye.uri,range:w.from(ye.range)||null,debuggable:($e=ye.debuggable)!==null&&$e!==void 0?$e:!1,description:ye.description||null,runnable:(We=ye.runnable)!==null&&We!==void 0?We:!0,error:ye.error&&g.fromStrict(ye.error)||null}}re.from=ue;function J(ye){return{extId:ye.id,label:ye.label,uri:ye.uri,range:w.from(ye.range)||null,debuggable:!1,description:ye.description||null,error:null,runnable:!0}}re.fromResultSnapshot=J;function $(ye){return{id:ye.extId,label:ye.label,uri:m.URI.revive(ye.uri),range:w.to(ye.range||void 0),addChild:()=>{},dispose:()=>{},status:c.TestItemStatus.Pending,data:void 0,debuggable:ye.debuggable,description:ye.description||void 0,runnable:ye.runnable}}re.toPlain=$;function Pe(ye){const $e=new c.TestItemImpl(ye.extId,ye.label,m.URI.revive(ye.uri),void 0);return $e.range=w.to(ye.range||void 0),$e.debuggable=ye.debuggable,$e.description=ye.description||void 0,$e.runnable=ye.runnable,$e}re.to=Pe})(Fe=e.TestItem||(e.TestItem={}));var Oe;(function(re){const ue=($,Pe)=>Object.assign(Object.assign({},Fe.toPlain($.item)),{taskStates:$.tasks.map(ye=>({state:ye.state,duration:ye.duration,messages:ye.messages.map(Ae.to)})),children:$.children.map(ye=>Pe.get(ye)).filter(_.isDefined).map(ye=>ue(ye,Pe))});function J($){const Pe=[],ye=new Map;for(const $e of $.items)ye.set($e.item.extId,$e),$e.direct&&Pe.push($e);return{completedAt:$.completedAt,results:Pe.map($e=>ue($e,ye))}}re.to=J})(Oe=e.TestResults||(e.TestResults={}));var Ge;(function(re){function ue(J){switch(J){case 1:return c.CodeActionTriggerKind.Invoke;case 2:return c.CodeActionTriggerKind.Automatic}}re.to=ue})(Ge=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}))}),define(le[219],ce([0,1,158,11,4,2,6,59,28,21,68]),function(x,e,E,P,p,D,I,_,m,y,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.editorGroupToViewColumn=e.viewColumnToEditorGroup=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptions=e.isEditorInputWithPreferredResource=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.EditorExtensions=void 0,e.EditorExtensions={Editors:"workbench.contributions.editors",Associations:"workbench.editors.associations",EditorInputFactories:"workbench.contributions.editor.inputFactories"},e.ActiveEditorDirtyContext=new _.RawContextKey("activeEditorIsDirty",!1,E.localize(0,null)),e.ActiveEditorPinnedContext=new _.RawContextKey("activeEditorIsNotPreview",!1,E.localize(1,null)),e.ActiveEditorStickyContext=new _.RawContextKey("activeEditorIsPinned",!1,E.localize(2,null)),e.ActiveEditorReadonlyContext=new _.RawContextKey("activeEditorIsReadonly",!1,E.localize(3,null)),e.ActiveEditorContext=new _.RawContextKey("activeEditor",null,{type:"string",description:E.localize(4,null)}),e.ActiveEditorAvailableEditorIdsContext=new _.RawContextKey("activeEditorAvailableEditorIds","",E.localize(5,null)),e.TextCompareEditorVisibleContext=new _.RawContextKey("textCompareEditorVisible",!1,E.localize(6,null)),e.TextCompareEditorActiveContext=new _.RawContextKey("textCompareEditorActive",!1,E.localize(7,null)),e.EditorGroupEditorsCountContext=new _.RawContextKey("groupEditorsCount",0,E.localize(8,null)),e.ActiveEditorGroupEmptyContext=new _.RawContextKey("activeEditorGroupEmpty",!1,E.localize(9,null)),e.ActiveEditorGroupIndexContext=new _.RawContextKey("activeEditorGroupIndex",0,E.localize(10,null)),e.ActiveEditorGroupLastContext=new _.RawContextKey("activeEditorGroupLast",!1,E.localize(11,null)),e.MultipleEditorGroupsContext=new _.RawContextKey("multipleEditorGroups",!1,E.localize(12,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new _.RawContextKey("editorIsOpen",!1,E.localize(13,null)),e.InEditorZenModeContext=new _.RawContextKey("inZenMode",!1,E.localize(14,null)),e.IsCenteredLayoutContext=new _.RawContextKey("isCenteredLayout",!1,E.localize(15,null)),e.SplitEditorsVertically=new _.RawContextKey("splitEditorsVertically",!1,E.localize(16,null)),e.EditorAreaVisibleContext=new _.RawContextKey("editorAreaVisible",!0,E.localize(17,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function k(g){const v=g;return typeof(v==null?void 0:v.getViewState)=="function"}e.isTextEditorPane=k;var d;(function(g){g[g.SHORT=0]="SHORT",g[g.MEDIUM=1]="MEDIUM",g[g.LONG=2]="LONG"})(d=e.Verbosity||(e.Verbosity={}));var b;(function(g){g[g.EXPLICIT=1]="EXPLICIT",g[g.AUTO=2]="AUTO",g[g.FOCUS_CHANGE=3]="FOCUS_CHANGE",g[g.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(b=e.SaveReason||(e.SaveReason={}));var f;(function(g){g[g.None=0]="None",g[g.Readonly=2]="Readonly",g[g.Untitled=4]="Untitled",g[g.Singleton=8]="Singleton",g[g.RequiresTrust=16]="RequiresTrust"})(f=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));function c(g){const v=g;return v?p.URI.isUri(v.preferredResource):!1}e.isEditorInputWithPreferredResource=c;function S(g){const v=g;return v?!!v.primary&&!!v.secondary:!1}function w(g){const v=g;return!!v&&!!v.editor}e.isEditorInputWithOptions=w;function C(g){const v=g;return v?typeof v.groupId=="number"&&!P.isUndefinedOrNull(v.editor):!1}e.isEditorIdentifier=C;var h;(function(g){g[g.PRIMARY=1]="PRIMARY",g[g.SECONDARY=2]="SECONDARY",g[g.BOTH=3]="BOTH"})(h=e.SideBySideEditor||(e.SideBySideEditor={}));class l{getOriginalUri(v,T){if(!v)return;if((T==null?void 0:T.supportSideBySide)&&S(v)){if((T==null?void 0:T.supportSideBySide)===h.BOTH)return{primary:this.getOriginalUri(v.primary,{filterByScheme:T.filterByScheme}),secondary:this.getOriginalUri(v.secondary,{filterByScheme:T.filterByScheme})};v=T.supportSideBySide===h.PRIMARY?v.primary:v.secondary}const R=c(v)?v.preferredResource:v.resource;return!R||!T||!T.filterByScheme?R:this.filterUri(R,T.filterByScheme)}getCanonicalUri(v,T){if(!v)return;if((T==null?void 0:T.supportSideBySide)&&S(v)){if((T==null?void 0:T.supportSideBySide)===h.BOTH)return{primary:this.getCanonicalUri(v.primary,{filterByScheme:T.filterByScheme}),secondary:this.getCanonicalUri(v.secondary,{filterByScheme:T.filterByScheme})};v=T.supportSideBySide===h.PRIMARY?v.primary:v.secondary}const R=v.resource;return!R||!T||!T.filterByScheme?R:this.filterUri(R,T.filterByScheme)}filterUri(v,T){if(Array.isArray(T)){if(T.some(R=>v.scheme===R))return v}else if(T===v.scheme)return v}}e.EditorResourceAccessor=new l;var a;(function(g){g[g.LEFT=0]="LEFT",g[g.RIGHT=1]="RIGHT"})(a=e.CloseDirection||(e.CloseDirection={}));class t{constructor(){this.editorInputSerializerConstructors=new Map,this.editorInputSerializerInstances=new Map}start(v){const T=this.instantiationService=v.get(I.IInstantiationService);for(const[R,o]of this.editorInputSerializerConstructors)this.createEditorInputSerializer(R,o,T);this.editorInputSerializerConstructors.clear()}createEditorInputSerializer(v,T,R){const o=R.createInstance(T);this.editorInputSerializerInstances.set(v,o)}registerFileEditorInputFactory(v){if(this.fileEditorInputFactory)throw new Error("Can only register one file editor input factory.");this.fileEditorInputFactory=v}getFileEditorInputFactory(){return P.assertIsDefined(this.fileEditorInputFactory)}registerEditorInputSerializer(v,T){if(this.editorInputSerializerConstructors.has(v)||this.editorInputSerializerInstances.has(v))throw new Error(`A editor input serializer with type ID '${v}' was already registered.`);return this.instantiationService?this.createEditorInputSerializer(v,T,this.instantiationService):this.editorInputSerializerConstructors.set(v,T),D.toDisposable(()=>{this.editorInputSerializerConstructors.delete(v),this.editorInputSerializerInstances.delete(v)})}getEditorInputSerializer(v){return this.editorInputSerializerInstances.get(typeof v=="string"?v:v.typeId)}}m.Registry.add(e.EditorExtensions.EditorInputFactories,new t);async function i(g,v){if(!g||!g.length)return[];const T=await Promise.all(g.map(async R=>{const o=p.URI.revive(R.fileUri);if(!o||!v.canHandleResource(o))return;const F=typeof R.exists=="boolean"?R.exists:await v.exists(o);if(!F&&R.openOnlyIfExists)return;const B=F&&typeof R.lineNumber=="number"?{selection:{startLineNumber:R.lineNumber,startColumn:R.columnNumber||1},pinned:!0,override:R.editorOverrideId}:{pinned:!0,override:R.editorOverrideId};let Z;return F?Z={resource:o,options:B,forceFile:!0}:Z={resource:o,options:B,forceUntitled:!0},Z}));return y.coalesce(T)}e.pathsToEditors=i;var n;(function(g){g[g.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",g[g.SEQUENTIAL=1]="SEQUENTIAL"})(n=e.EditorsOrder||(e.EditorsOrder={}));function s(g,v){if(typeof v!="number"||v===r.ACTIVE_GROUP)return r.ACTIVE_GROUP;const T=g.getGroups(2);let R=T[v];if(R)return R.id;let o=T[0];return T.length===1&&o.count===0?o.id:r.SIDE_GROUP}e.viewColumnToEditorGroup=s;function u(g,v){let T=typeof v=="number"?g.getGroup(v):v;return T=T??g.activeGroup,g.getGroups(2).indexOf(T)}e.editorGroupToViewColumn=u}),define(le[220],ce([0,1,11,215,16,97,101,105,216,219,68,8,182,104]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannelClient=e.REMOTE_TERMINAL_CHANNEL_NAME=void 0,e.REMOTE_TERMINAL_CHANNEL_NAME="remoteterminal";let f=class{constructor(S,w,C,h,l,a,t,i,n,s){this._remoteAuthority=S,this._channel=w,this._configurationService=C,this._workspaceContextService=h,this._resolverService=l,this._environmentVariableService=a,this._remoteAuthorityResolverService=t,this._logService=i,this._editorService=n,this._labelService=s}get onPtyHostExit(){return this._channel.listen("$onPtyHostExitEvent")}get onPtyHostStart(){return this._channel.listen("$onPtyHostStartEvent")}get onPtyHostUnresponsive(){return this._channel.listen("$onPtyHostUnresponsiveEvent")}get onPtyHostResponsive(){return this._channel.listen("$onPtyHostResponsiveEvent")}get onPtyHostRequestResolveVariables(){return this._channel.listen("$onPtyHostRequestResolveVariablesEvent")}get onProcessData(){return this._channel.listen("$onProcessDataEvent")}get onProcessExit(){return this._channel.listen("$onProcessExitEvent")}get onProcessReady(){return this._channel.listen("$onProcessReadyEvent")}get onProcessReplay(){return this._channel.listen("$onProcessReplayEvent")}get onProcessTitleChanged(){return this._channel.listen("$onProcessTitleChangedEvent")}get onProcessShellTypeChanged(){return this._channel.listen("$onProcessShellTypeChangedEvent")}get onProcessOverrideDimensions(){return this._channel.listen("$onProcessOverrideDimensionsEvent")}get onProcessResolvedShellLaunchConfig(){return this._channel.listen("$onProcessResolvedShellLaunchConfigEvent")}get onProcessOrphanQuestion(){return this._channel.listen("$onProcessOrphanQuestion")}get onExecuteCommand(){return this._channel.listen("$onExecuteCommand")}restartPtyHost(){return this._channel.call("$restartPtyHost",[])}async createProcess(S,w,C,h,l,a){await this._configurationService.whenRemoteConfigurationLoaded();const t=Object.create(null),i=C?E.withNullAsUndefined(this._workspaceContextService.getWorkspaceFolder(C)):void 0;let n;try{n=(await this._resolverService.resolveAnyMap(i,{shellLaunchConfig:S,configuration:w})).resolvedVariables}catch(B){this._logService.error(B)}if(n)for(const[B,Z]of n.entries())(/^config:/.test(B)||B==="selectedText"||B==="lineNumber")&&(t[B]=Z);const s=[];for(const[B,Z]of this._environmentVariableService.collections.entries())s.push([B,_.serializeEnvironmentVariableCollection(Z.map)]);const u=await this._remoteAuthorityResolverService.resolveAuthority(this._remoteAuthority),g=u.options&&u.options.extensionHostEnv,v=this._workspaceContextService.getWorkspace(),T=v.folders,R=C?this._workspaceContextService.getWorkspaceFolder(C):null,o=y.EditorResourceAccessor.getOriginalUri(this._editorService.activeEditor,{supportSideBySide:y.SideBySideEditor.PRIMARY,filterByScheme:[k.Schemas.file,k.Schemas.userData,k.Schemas.vscodeRemote]}),F={configuration:w,resolvedVariables:t,envVariableCollections:s,shellLaunchConfig:S,workspaceId:v.id,workspaceName:this._labelService.getWorkspaceLabel(v),workspaceFolders:T,activeWorkspaceFolder:R,activeFileResource:o,shouldPersistTerminal:h,cols:l,rows:a,resolverEnv:g};return await this._channel.call("$createProcess",F)}attachToProcess(S){return this._channel.call("$attachToProcess",[S])}listProcesses(){return this._channel.call("$listProcesses")}reduceConnectionGraceTime(){return this._channel.call("$reduceConnectionGraceTime")}processBinary(S,w){return this._channel.call("$processBinary",[S,w])}start(S){return this._channel.call("$start",[S])}input(S,w){return this._channel.call("$input",[S,w])}acknowledgeDataEvent(S,w){return this._channel.call("$acknowledgeDataEvent",[S,w])}shutdown(S,w){return this._channel.call("$shutdown",[S,w])}resize(S,w,C){return this._channel.call("$resize",[S,w,C])}getInitialCwd(S){return this._channel.call("$getInitialCwd",[S])}getCwd(S){return this._channel.call("$getCwd",[S])}orphanQuestionReply(S){return this._channel.call("$orphanQuestionReply",[S])}sendCommandResult(S,w,C){return this._channel.call("$sendCommandResult",[S,w,C])}getDefaultSystemShell(S){return this._channel.call("$getDefaultSystemShell",[S])}getProfiles(S,w,C){return this._channel.call("$getProfiles",[S,w,C])}acceptPtyHostResolvedVariables(S,w){return this._channel.call("$acceptPtyHostResolvedVariables",[S,w])}getEnvironment(){return this._channel.call("$getEnvironment")}getWslPath(S){return this._channel.call("$getWslPath",[S])}setTerminalLayoutInfo(S){const C={workspaceId:this._workspaceContextService.getWorkspace().id,tabs:S.tabs};return this._channel.call("$setTerminalLayoutInfo",C)}updateTitle(S,w){return this._channel.call("$updateTitle",[S,w])}updateIcon(S,w,C){return this._channel.call("$updateIcon",[S,w,C])}getTerminalLayoutInfo(){const w={workspaceId:this._workspaceContextService.getWorkspace().id};return this._channel.call("$getTerminalLayoutInfo",w)}};f=Ne([Ke(2,P.IWorkbenchConfigurationService),Ke(3,I.IWorkspaceContextService),Ke(4,m.IConfigurationResolverService),Ke(5,b.IEnvironmentVariableService),Ke(6,D.IRemoteAuthorityResolverService),Ke(7,p.ILogService),Ke(8,r.IEditorService),Ke(9,d.ILabelService)],f),e.RemoteTerminalChannelClient=f}),define(le[221],ce([0,1,187]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Logger=e.Translations=void 0;var P;(function(D){function I(_,m){if(_===m)return!0;let y=Object.keys(_),r=new Set;for(let k of Object.keys(m))r.add(k);if(y.length!==r.size)return!1;for(let k of y){if(_[k]!==m[k])return!1;r.delete(k)}return r.size===0}D.equals=I})(P=e.Translations||(e.Translations={}));class p{constructor(I){this._messageHandler=I}error(I,_){this._messageHandler(E.Severity.Error,I,_)}warn(I,_){this._messageHandler(E.Severity.Warning,I,_)}info(I,_){this._messageHandler(E.Severity.Info,I,_)}}e.Logger=p}),define(le[222],ce([0,1]),function(x,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class E{constructor(m,y){this.isMain=m,this.sid=y,this.nid=++E.count}}e.ProxyIdentifier=E,E.count=0;const P=[];function p(_){const m=new E(!0,_);return P[m.nid]=m,m}e.createMainContextProxyIdentifier=p;function D(_){const m=new E(!1,_);return P[m.nid]=m,m}e.createExtHostContextProxyIdentifier=D;function I(_){return P[_].sid}e.getStringIdentifierForProxy=I}),define(le[223],ce([0,1,46,4,222]),function(x,e,E,P,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var D;(function(h){h[h.Desktop=1]="Desktop",h[h.Web=2]="Web"})(D=e.UIKind||(e.UIKind={}));var I;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(I=e.TextEditorRevealType||(e.TextEditorRevealType={}));var _;(function(h){h[h.Editable=0]="Editable",h[h.SupportsHotExit=1]="SupportsHotExit"})(_=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var m;(function(h){h[h.Int8Array=1]="Int8Array",h[h.Uint8Array=2]="Uint8Array",h[h.Uint8ClampedArray=3]="Uint8ClampedArray",h[h.Int16Array=4]="Int16Array",h[h.Uint16Array=5]="Uint16Array",h[h.Int32Array=6]="Int32Array",h[h.Uint32Array=7]="Uint32Array",h[h.Float32Array=8]="Float32Array",h[h.Float64Array=9]="Float64Array",h[h.BigInt64Array=10]="BigInt64Array",h[h.BigUint64Array=11]="BigUint64Array"})(m=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var y;(function(h){h[h.Text=1]="Text",h[h.Error=2]="Error",h[h.Rich=3]="Rich"})(y=e.CellOutputKind||(e.CellOutputKind={}));var r;(function(h){h[h.Default=0]="Default",h[h.InCenter=1]="InCenter",h[h.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",h[h.AtTop=3]="AtTop"})(r=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var k;(function(h){h[h.None=0]="None",h[h.Process=1]="Process",h[h.Output=2]="Output"})(k=e.CandidatePortSource||(e.CandidatePortSource={}));var d;(function(h){h.name="$ident";function l(t,i){return Object.defineProperty(t,h.name,{value:i,enumerable:!0}),t}h.mixin=l;function a(t){return t[h.name]}h.of=a})(d=e.ObjectIdentifier||(e.ObjectIdentifier={}));class b{static mixin(l){return l._id=b._n++,l}}e.IdObject=b,b._n=0;var f;(function(h){h.label="a",h.kind="b",h.detail="c",h.documentation="d",h.sortText="e",h.filterText="f",h.preselect="g",h.insertText="h",h.insertTextRules="i",h.range="j",h.commitCharacters="k",h.additionalTextEdits="l",h.command="m",h.kindModifier="n",h.label2="o"})(f=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var c;(function(h){h.defaultRanges="a",h.completions="b",h.isIncomplete="c",h.duration="d"})(c=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var S;(function(h){h[h.File=1]="File",h[h.Text=2]="Text",h[h.Cell=3]="Cell"})(S=e.WorkspaceEditType||(e.WorkspaceEditType={}));function w(h){if(h&&h.edits)for(const l of h.edits)typeof l.resource=="object"?l.resource=P.URI.revive(l.resource):(l.newUri=P.URI.revive(l.newUri),l.oldUri=P.URI.revive(l.oldUri)),l.metadata&&l.metadata.iconPath&&(l.metadata=E.revive(l.metadata));return h}e.reviveWorkspaceEditDto=w;var C;(function(h){h[h.Workspace=0]="Workspace",h[h.TextDocument=1]="TextDocument"})(C=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:p.createMainContextProxyIdentifier("MainThreadAuthentication"),MainThreadBulkEdits:p.createMainContextProxyIdentifier("MainThreadBulkEdits"),MainThreadClipboard:p.createMainContextProxyIdentifier("MainThreadClipboard"),MainThreadCommands:p.createMainContextProxyIdentifier("MainThreadCommands"),MainThreadComments:p.createMainContextProxyIdentifier("MainThreadComments"),MainThreadConfiguration:p.createMainContextProxyIdentifier("MainThreadConfiguration"),MainThreadConsole:p.createMainContextProxyIdentifier("MainThreadConsole"),MainThreadDebugService:p.createMainContextProxyIdentifier("MainThreadDebugService"),MainThreadDecorations:p.createMainContextProxyIdentifier("MainThreadDecorations"),MainThreadDiagnostics:p.createMainContextProxyIdentifier("MainThreadDiagnostics"),MainThreadDialogs:p.createMainContextProxyIdentifier("MainThreadDiaglogs"),MainThreadDocuments:p.createMainContextProxyIdentifier("MainThreadDocuments"),MainThreadDocumentContentProviders:p.createMainContextProxyIdentifier("MainThreadDocumentContentProviders"),MainThreadTextEditors:p.createMainContextProxyIdentifier("MainThreadTextEditors"),MainThreadEditorInsets:p.createMainContextProxyIdentifier("MainThreadEditorInsets"),MainThreadEditorTabs:p.createMainContextProxyIdentifier("MainThreadEditorTabs"),MainThreadErrors:p.createMainContextProxyIdentifier("MainThreadErrors"),MainThreadTreeViews:p.createMainContextProxyIdentifier("MainThreadTreeViews"),MainThreadDownloadService:p.createMainContextProxyIdentifier("MainThreadDownloadService"),MainThreadKeytar:p.createMainContextProxyIdentifier("MainThreadKeytar"),MainThreadLanguageFeatures:p.createMainContextProxyIdentifier("MainThreadLanguageFeatures"),MainThreadLanguages:p.createMainContextProxyIdentifier("MainThreadLanguages"),MainThreadLog:p.createMainContextProxyIdentifier("MainThread"),MainThreadMessageService:p.createMainContextProxyIdentifier("MainThreadMessageService"),MainThreadOutputService:p.createMainContextProxyIdentifier("MainThreadOutputService"),MainThreadProgress:p.createMainContextProxyIdentifier("MainThreadProgress"),MainThreadQuickOpen:p.createMainContextProxyIdentifier("MainThreadQuickOpen"),MainThreadStatusBar:p.createMainContextProxyIdentifier("MainThreadStatusBar"),MainThreadSecretState:p.createMainContextProxyIdentifier("MainThreadSecretState"),MainThreadStorage:p.createMainContextProxyIdentifier("MainThreadStorage"),MainThreadTelemetry:p.createMainContextProxyIdentifier("MainThreadTelemetry"),MainThreadTerminalService:p.createMainContextProxyIdentifier("MainThreadTerminalService"),MainThreadWebviews:p.createMainContextProxyIdentifier("MainThreadWebviews"),MainThreadWebviewPanels:p.createMainContextProxyIdentifier("MainThreadWebviewPanels"),MainThreadWebviewViews:p.createMainContextProxyIdentifier("MainThreadWebviewViews"),MainThreadCustomEditors:p.createMainContextProxyIdentifier("MainThreadCustomEditors"),MainThreadUrls:p.createMainContextProxyIdentifier("MainThreadUrls"),MainThreadUriOpeners:p.createMainContextProxyIdentifier("MainThreadUriOpeners"),MainThreadWorkspace:p.createMainContextProxyIdentifier("MainThreadWorkspace"),MainThreadFileSystem:p.createMainContextProxyIdentifier("MainThreadFileSystem"),MainThreadExtensionService:p.createMainContextProxyIdentifier("MainThreadExtensionService"),MainThreadSCM:p.createMainContextProxyIdentifier("MainThreadSCM"),MainThreadSearch:p.createMainContextProxyIdentifier("MainThreadSearch"),MainThreadTask:p.createMainContextProxyIdentifier("MainThreadTask"),MainThreadWindow:p.createMainContextProxyIdentifier("MainThreadWindow"),MainThreadLabelService:p.createMainContextProxyIdentifier("MainThreadLabelService"),MainThreadNotebook:p.createMainContextProxyIdentifier("MainThreadNotebook"),MainThreadNotebookDocuments:p.createMainContextProxyIdentifier("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:p.createMainContextProxyIdentifier("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:p.createMainContextProxyIdentifier("MainThreadNotebookKernels"),MainThreadNotebookRenderers:p.createMainContextProxyIdentifier("MainThreadNotebookRenderers"),MainThreadTheming:p.createMainContextProxyIdentifier("MainThreadTheming"),MainThreadTunnelService:p.createMainContextProxyIdentifier("MainThreadTunnelService"),MainThreadTimeline:p.createMainContextProxyIdentifier("MainThreadTimeline"),MainThreadTesting:p.createMainContextProxyIdentifier("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:p.createExtHostContextProxyIdentifier("ExtHostCommands"),ExtHostConfiguration:p.createExtHostContextProxyIdentifier("ExtHostConfiguration"),ExtHostDiagnostics:p.createExtHostContextProxyIdentifier("ExtHostDiagnostics"),ExtHostDebugService:p.createExtHostContextProxyIdentifier("ExtHostDebugService"),ExtHostDecorations:p.createExtHostContextProxyIdentifier("ExtHostDecorations"),ExtHostDocumentsAndEditors:p.createExtHostContextProxyIdentifier("ExtHostDocumentsAndEditors"),ExtHostDocuments:p.createExtHostContextProxyIdentifier("ExtHostDocuments"),ExtHostDocumentContentProviders:p.createExtHostContextProxyIdentifier("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:p.createExtHostContextProxyIdentifier("ExtHostDocumentSaveParticipant"),ExtHostEditors:p.createExtHostContextProxyIdentifier("ExtHostEditors"),ExtHostTreeViews:p.createExtHostContextProxyIdentifier("ExtHostTreeViews"),ExtHostFileSystem:p.createExtHostContextProxyIdentifier("ExtHostFileSystem"),ExtHostFileSystemInfo:p.createExtHostContextProxyIdentifier("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:p.createExtHostContextProxyIdentifier("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:p.createExtHostContextProxyIdentifier("ExtHostLanguageFeatures"),ExtHostQuickOpen:p.createExtHostContextProxyIdentifier("ExtHostQuickOpen"),ExtHostExtensionService:p.createExtHostContextProxyIdentifier("ExtHostExtensionService"),ExtHostLogService:p.createExtHostContextProxyIdentifier("ExtHostLogService"),ExtHostTerminalService:p.createExtHostContextProxyIdentifier("ExtHostTerminalService"),ExtHostSCM:p.createExtHostContextProxyIdentifier("ExtHostSCM"),ExtHostSearch:p.createExtHostContextProxyIdentifier("ExtHostSearch"),ExtHostTask:p.createExtHostContextProxyIdentifier("ExtHostTask"),ExtHostWorkspace:p.createExtHostContextProxyIdentifier("ExtHostWorkspace"),ExtHostWindow:p.createExtHostContextProxyIdentifier("ExtHostWindow"),ExtHostWebviews:p.createExtHostContextProxyIdentifier("ExtHostWebviews"),ExtHostWebviewPanels:p.createExtHostContextProxyIdentifier("ExtHostWebviewPanels"),ExtHostCustomEditors:p.createExtHostContextProxyIdentifier("ExtHostCustomEditors"),ExtHostWebviewViews:p.createExtHostContextProxyIdentifier("ExtHostWebviewViews"),ExtHostEditorInsets:p.createExtHostContextProxyIdentifier("ExtHostEditorInsets"),ExtHostEditorTabs:p.createExtHostContextProxyIdentifier("ExtHostEditorTabs"),ExtHostProgress:p.createMainContextProxyIdentifier("ExtHostProgress"),ExtHostComments:p.createMainContextProxyIdentifier("ExtHostComments"),ExtHostSecretState:p.createMainContextProxyIdentifier("ExtHostSecretState"),ExtHostStorage:p.createMainContextProxyIdentifier("ExtHostStorage"),ExtHostUrls:p.createExtHostContextProxyIdentifier("ExtHostUrls"),ExtHostUriOpeners:p.createExtHostContextProxyIdentifier("ExtHostUriOpeners"),ExtHostOutputService:p.createMainContextProxyIdentifier("ExtHostOutputService"),ExtHosLabelService:p.createMainContextProxyIdentifier("ExtHostLabelService"),ExtHostNotebook:p.createMainContextProxyIdentifier("ExtHostNotebook"),ExtHostNotebookKernels:p.createMainContextProxyIdentifier("ExtHostNotebookKernels"),ExtHostNotebookRenderers:p.createMainContextProxyIdentifier("ExtHostNotebookRenderers"),ExtHostTheming:p.createMainContextProxyIdentifier("ExtHostTheming"),ExtHostTunnelService:p.createMainContextProxyIdentifier("ExtHostTunnelService"),ExtHostAuthentication:p.createMainContextProxyIdentifier("ExtHostAuthentication"),ExtHostTimeline:p.createMainContextProxyIdentifier("ExtHostTimeline"),ExtHostTesting:p.createMainContextProxyIdentifier("ExtHostTesting"),ExtHostTelemetry:p.createMainContextProxyIdentifier("ExtHostTelemetry")}}),define(le[224],ce([0,1,11,103,218,19,223,21,16,46,54,84,4,2,6,210]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let S=class{constructor(t,i){this._commands=new Map,this._apiCommands=new Map,this._proxy=t.getProxy(I.MainContext.MainThreadCommands),this._logService=i,this.converter=new w(this,n=>{const s=this._apiCommands.get(n);return(s==null?void 0:s.result)===h.Void?s:void 0},i),this._argumentProcessors=[{processArgument(n){return y.revive(n)}},{processArgument(n){return D.cloneAndChange(n,function(s){if(r.Range.isIRange(s))return p.Range.to(s);if(k.Position.isIPosition(s))return p.Position.to(s);if(r.Range.isIRange(s.range)&&d.URI.isUri(s.uri))return p.location.to(s);if(!Array.isArray(s))return s})}}]}registerArgumentProcessor(t){this._argumentProcessors.push(t)}registerApiCommand(t){const i=this.registerCommand(!1,t.id,async(...n)=>{const s=t.args.map((g,v)=>{if(!g.validate(n[v]))throw new Error(`Invalid argument '${g.name}' when running '${t.id}', received: ${n[v]}`);return g.convert(n[v])}),u=await this.executeCommand(t.internalId,...s);return t.result.convert(u,n,this.converter)},void 0,{description:t.description,args:t.args,returns:t.result.description});return this._apiCommands.set(t.id,t),new P.Disposable(()=>{i.dispose(),this._apiCommands.delete(t.id)})}registerCommand(t,i,n,s,u){if(this._logService.trace("ExtHostCommands#registerCommand",i),!i.trim().length)throw new Error("invalid id");if(this._commands.has(i))throw new Error(`command '${i}' already exists`);return this._commands.set(i,{callback:n,thisArg:s,description:u}),t&&this._proxy.$registerCommand(i),new P.Disposable(()=>{this._commands.delete(i)&&t&&this._proxy.$unregisterCommand(i)})}executeCommand(t,...i){return this._logService.trace("ExtHostCommands#executeCommand",t),this._doExecuteCommand(t,i,!0)}async _doExecuteCommand(t,i,n){if(this._commands.has(t))return this._executeContributedCommand(t,i);{const s=D.cloneAndChange(i,function(u){if(u instanceof P.Position)return p.Position.from(u);if(u instanceof P.Range)return p.Range.from(u);if(u instanceof P.Location)return p.location.from(u);if(P.NotebookRange.isNotebookRange(u))return p.NotebookRange.from(u);if(!Array.isArray(u))return u});try{const u=await this._proxy.$executeCommand(t,s,n);return y.revive(u)}catch(u){if(u instanceof Error&&u.message==="$executeCommand:retry")return this._doExecuteCommand(t,i,!1);throw u}}}async _executeContributedCommand(t,i){const n=this._commands.get(t);if(!n)throw new Error("Unknown command");let{callback:s,thisArg:u,description:g}=n;if(g)for(let v=0;v<g.args.length;v++)try{E.validateConstraint(i[v],g.args[v].constraint)}catch(T){throw new Error(`Running the contributed command: '${t}' failed. Illegal argument '${g.args[v].name}' - ${g.args[v].description}`)}try{return await s.apply(u,i)}catch(v){if(t===this.converter.delegatingCommandId){const T=this.converter.getActualCommand(...i);T&&(t=T.command)}throw this._logService.error(v,t),new Error(`Running the contributed command: '${t}' failed.`)}}$executeContributedCommand(t,...i){return this._logService.trace("ExtHostCommands#$executeContributedCommand",t),this._commands.has(t)?(i=i.map(n=>this._argumentProcessors.reduce((s,u)=>u.processArgument(s),n)),this._executeContributedCommand(t,i)):Promise.reject(new Error(`Contributed command '${t}' does not exist.`))}getCommands(t=!1){return this._logService.trace("ExtHostCommands#getCommands",t),this._proxy.$getCommands().then(i=>(t&&(i=i.filter(n=>n[0]!=="_")),i))}$getContributedCommandHandlerDescriptions(){const t=Object.create(null);for(let[i,n]of this._commands){let{description:s}=n;s&&(t[i]=s)}return Promise.resolve(t)}};S=Ne([Ke(0,c.IExtHostRpcService),Ke(1,m.ILogService)],S),e.ExtHostCommands=S,e.IExtHostCommands=f.createDecorator("IExtHostCommands");class w{constructor(t,i,n){this._commands=t,this._lookupApiCommand=i,this._logService=n,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(t,i){if(!t)return;const n={$ident:void 0,id:t.command,title:t.title,tooltip:t.tooltip};if(!t.command)return n;const s=this._lookupApiCommand(t.command);if(s)n.id=s.internalId,n.arguments=s.args.map((u,g)=>u.convert(t.arguments&&t.arguments[g]));else if(_.isNonEmptyArray(t.arguments)){const u=++this._cachIdPool;this._cache.set(u,t),i.add(b.toDisposable(()=>{this._cache.delete(u),this._logService.trace("CommandsConverter#DISPOSE",u)})),n.$ident=u,n.id=this.delegatingCommandId,n.arguments=[u],this._logService.trace("CommandsConverter#CREATE",t.command,u)}return n}fromInternal(t){const i=I.ObjectIdentifier.of(t);return typeof i=="number"?this._cache.get(i):{command:t.id,title:t.title,arguments:t.arguments}}getActualCommand(...t){return this._cache.get(t[0])}_executeConvertedCommand(...t){const i=this.getActualCommand(...t);return this._logService.trace("CommandsConverter#EXECUTE",t[0],i?i.command:"MISSING"),i?this._commands.executeCommand(i.command,...i.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=w;class C{constructor(t,i,n,s){this.name=t,this.description=i,this.validate=n,this.convert=s}optional(){return new C(this.name,`(optional) ${this.description}`,t=>t==null||this.validate(t),t=>t===void 0?void 0:t===null?null:this.convert(t))}with(t,i){return new C(t??this.name,i??this.description,this.validate,this.convert)}}e.ApiCommandArgument=C,C.Uri=new C("uri","Uri of a text document",a=>d.URI.isUri(a),a=>a),C.Position=new C("position","A position in a text document",a=>P.Position.isPosition(a),p.Position.from),C.Range=new C("range","A range in a text document",a=>P.Range.isRange(a),p.Range.from),C.Selection=new C("selection","A selection in a text document",a=>P.Selection.isSelection(a),p.Selection.from),C.Number=new C("number","",a=>typeof a=="number",a=>a),C.String=new C("string","",a=>typeof a=="string",a=>a),C.CallHierarchyItem=new C("item","A call hierarchy item",a=>a instanceof P.CallHierarchyItem,p.CallHierarchyItem.to);class h{constructor(t,i){this.description=t,this.convert=i}}e.ApiCommandResult=h,h.Void=new h("no result",a=>a);class l{constructor(t,i,n,s,u){this.id=t,this.internalId=i,this.description=n,this.args=s,this.result=u}}e.ApiCommand=l}),define(le[225],ce([0,1,160,3,49,37,21,134,11,4,15,34,57,44,221]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionScanner=e.ExtensionScannerInput=void 0;const c="package.json";class S{constructor(n,s,u,g,v,T){this._ourVersion=n,this._ourProductDate=s,this._log=u,this._absoluteFolderPath=g,this._isBuiltin=v,this._isUnderDevelopment=T,this._absoluteManifestPath=P.join(g,c)}}class w extends S{static _fastParseJSON(n,s){try{return JSON.parse(n)}catch(u){return D.parse(n,s)}}parse(){return r.Promises.readFile(this._absoluteManifestPath).then(n=>{var s;const u=[],g=w._fastParseJSON(n.toString(),u);if(D.getNodeType(g)!=="object")this._log.error(this._absoluteFolderPath,E.localize(0,null,this._absoluteManifestPath));else{if(u.length===0)return g.__metadata&&(g.uuid=g.__metadata.id),g.isUserBuiltin=!!((s=g.__metadata)===null||s===void 0?void 0:s.isBuiltin),delete g.__metadata,g;u.forEach(v=>{this._log.error(this._absoluteFolderPath,E.localize(1,null,this._absoluteManifestPath,v.offset,v.length,_.getParseErrorMessage(v.error)))})}return null},n=>(n.code==="ENOENT"||this._log.error(this._absoluteFolderPath,E.localize(2,null,this._absoluteManifestPath,n.message)),null))}}class C extends S{constructor(n,s,u,g,v,T,R){super(n,s,u,g,v,T);this._nlsConfig=R}replaceNLS(n){const s=(F,B)=>{B.forEach(Z=>{this._log.error(this._absoluteFolderPath,E.localize(3,null,F,_.getParseErrorMessage(Z.error)))})},u=F=>{this._log.error(this._absoluteFolderPath,E.localize(4,null,F))};let g=P.extname(this._absoluteManifestPath),v=this._absoluteManifestPath.substr(0,this._absoluteManifestPath.length-g.length);const T=`${n.publisher}.${n.name}`;let R=this._nlsConfig.translations[T],o;return R?o=r.Promises.readFile(R,"utf8").then(F=>{let B=[],Z=D.parse(F,B);return B.length>0?(s(R,B),{values:void 0,default:`${v}.nls.json`}):D.getNodeType(Z)!=="object"?(u(R),{values:void 0,default:`${v}.nls.json`}):{values:Z.contents?Z.contents.package:void 0,default:`${v}.nls.json`}},F=>({values:void 0,default:`${v}.nls.json`})):o=r.SymlinkSupport.existsFile(v+".nls"+g).then(F=>{if(!!F)return C.findMessageBundles(this._nlsConfig,v).then(B=>B.localized?r.Promises.readFile(B.localized,"utf8").then(Z=>{let ie=[],Se=D.parse(Z,ie);return ie.length>0?(s(B.localized,ie),{values:void 0,default:B.original}):D.getNodeType(Se)!=="object"?(u(B.localized),{values:void 0,default:B.original}):{values:Se,default:B.original}},Z=>({values:void 0,default:B.original})):{values:void 0,default:B.original},B=>{})}),o.then(F=>{if(F===void 0)return n;let B=[];return C.resolveOriginalMessageBundle(F.default,B).then(Z=>{if(B.length>0)return s(F.default,B),n;if(D.getNodeType(F)!=="object")return u(F.default),n;const ie=F.values||Object.create(null);return C._replaceNLStrings(this._nlsConfig,n,ie,Z,this._log,this._absoluteFolderPath),n})},F=>n)}static resolveOriginalMessageBundle(n,s){return new Promise((u,g)=>{n?r.Promises.readFile(n).then(v=>{u(D.parse(v.toString(),s))},v=>{u(null)}):u(null)})}static findMessageBundles(n,s){return new Promise((u,g)=>{function v(T,R){let o=`${T}.nls.${R}.json`;r.SymlinkSupport.existsFile(o).then(F=>{F&&u({localized:o,original:`${T}.nls.json`});let B=R.lastIndexOf("-");B===-1?u({localized:`${T}.nls.json`,original:null}):(R=R.substring(0,B),v(T,R))})}if(n.devMode||n.pseudo||!n.locale)return u({localized:s+".nls.json",original:null});v(s,n.locale)})}static _replaceNLStrings(n,s,u,g,v,T){function R(o,F,B){let Z=o[F];if(m.isString(Z)){let ie=Z,Se=ie.length;if(Se>1&&ie[0]==="%"&&ie[Se-1]==="%"){let oe=ie.substr(1,Se-2),q=u[oe];q===void 0&&g&&(q=g[oe]),q?(n.pseudo&&(q="\uFF3B"+q.replace(/[aouei]/g,"$&$&")+"\uFF3D"),o[F]=B&&(F==="title"||F==="category")&&g?{value:q,original:g[oe]}:q):v.warn(T,E.localize(5,null,oe))}}else if(m.isObject(Z))for(let ie in Z)Z.hasOwnProperty(ie)&&(ie==="commands"?R(Z,ie,!0):R(Z,ie,B));else if(m.isArray(Z))for(let ie=0;ie<Z.length;ie++)R(Z,ie,B)}for(let o in s)s.hasOwnProperty(o)&&R(s,o)}}class h extends S{validate(n){let s=n;s.isBuiltin=this._isBuiltin,s.isUserBuiltin=!this._isBuiltin&&!!s.isUserBuiltin,s.isUnderDevelopment=this._isUnderDevelopment;let u=[];return h.isValidExtensionDescription(this._ourVersion,this._ourProductDate,this._absoluteFolderPath,s,u)?(u.forEach(g=>{this._log.warn(this._absoluteFolderPath,g)}),s.publisher||(s.publisher="undefined_publisher"),s.id=k.getExtensionId(s.publisher,s.name),s.identifier=new b.ExtensionIdentifier(s.id),s.extensionLocation=y.URI.file(this._absoluteFolderPath),s):(u.forEach(g=>{this._log.error(this._absoluteFolderPath,g)}),null)}static isValidExtensionDescription(n,s,u,g,v){return h.baseIsValidExtensionDescription(u,g,v)?p.valid(g.version)?d.isValidExtensionVersion(n,s,g,v):(v.push(E.localize(6,null)),!1):!1}static baseIsValidExtensionDescription(n,s,u){if(!s)return u.push(E.localize(7,null)),!1;if(typeof s.publisher!="undefined"&&typeof s.publisher!="string")return u.push(E.localize(8,null)),!1;if(typeof s.name!="string")return u.push(E.localize(9,null,"name")),!1;if(typeof s.version!="string")return u.push(E.localize(10,null,"version")),!1;if(!s.engines)return u.push(E.localize(11,null,"engines")),!1;if(typeof s.engines.vscode!="string")return u.push(E.localize(12,null,"engines.vscode")),!1;if(typeof s.extensionDependencies!="undefined"&&!h._isStringArray(s.extensionDependencies))return u.push(E.localize(13,null,"extensionDependencies")),!1;if(typeof s.activationEvents!="undefined"){if(!h._isStringArray(s.activationEvents))return u.push(E.localize(14,null,"activationEvents")),!1;if(typeof s.main=="undefined"&&typeof s.browser=="undefined")return u.push(E.localize(15,null,"activationEvents","main")),!1}if(typeof s.main!="undefined"){if(typeof s.main!="string")return u.push(E.localize(16,null,"main")),!1;{const g=P.join(n,s.main);g.startsWith(n)||u.push(E.localize(17,null,g,n))}if(typeof s.activationEvents=="undefined")return u.push(E.localize(18,null,"activationEvents","main")),!1}if(typeof s.browser!="undefined"){if(typeof s.browser!="string")return u.push(E.localize(19,null,"browser")),!1;{const g=P.join(n,s.browser);g.startsWith(n)||u.push(E.localize(20,null,g,n))}if(typeof s.activationEvents=="undefined")return u.push(E.localize(21,null,"activationEvents","browser")),!1}return!0}static _isStringArray(n){if(!Array.isArray(n))return!1;for(let s=0,u=n.length;s<u;s++)if(typeof n[s]!="string")return!1;return!0}}class l{constructor(n,s,u,g,v,T,R,o,F){this.ourVersion=n,this.ourProductDate=s,this.commit=u,this.locale=g,this.devMode=v,this.absoluteFolderPath=T,this.isBuiltin=R,this.isUnderDevelopment=o,this.translations=F}static createNLSConfig(n){return{devMode:n.devMode,locale:n.locale,pseudo:n.locale==="pseudo",translations:n.translations}}static equals(n,s){return n.ourVersion===s.ourVersion&&n.ourProductDate===s.ourProductDate&&n.commit===s.commit&&n.locale===s.locale&&n.devMode===s.devMode&&n.absoluteFolderPath===s.absoluteFolderPath&&n.isBuiltin===s.isBuiltin&&n.isUnderDevelopment===s.isUnderDevelopment&&n.mtime===s.mtime&&f.Translations.equals(n.translations,s.translations)}}e.ExtensionScannerInput=l;class a{constructor(n){this.root=n}resolveExtensions(){return r.readDirsInDir(this.root).then(n=>n.map(s=>({name:s,path:P.join(this.root,s)})))}}class t{static scanExtension(n,s,u,g,v,T,R){return g=P.normalize(g),new w(n,s,u,g,v,T).parse().then(F=>F===null?null:new C(n,s,u,g,v,T,R).replaceNLS(F)).then(F=>F===null?null:new h(n,s,u,g,v,T).validate(F))}static async scanExtensions(n,s,u=null){const g=n.absoluteFolderPath,v=n.isBuiltin,T=n.isUnderDevelopment;u||(u=new a(g));try{let R={};if(!v)try{const ie=await r.Promises.readFile(P.join(g,".obsolete"),"utf8");R=JSON.parse(ie)}catch(ie){}let o=await u.resolveExtensions();o.sort((ie,Se)=>ie.name<Se.name?-1:1),v||(o=o.filter(ie=>ie.name.indexOf(".")!==0));const F=l.createNLSConfig(n);let B=await Promise.all(o.map(ie=>this.scanExtension(n.ourVersion,n.ourProductDate,s,ie.path,v,T,F))),Z=I.coalesce(B);return Z=Z.filter(ie=>ie!==null&&!R[new k.ExtensionIdentifierWithVersion({id:k.getGalleryExtensionId(ie.publisher,ie.name)},ie.version).key()]),v||(Z=k.groupByExtension(Z,Se=>({id:Se.identifier.value,uuid:Se.uuid})).map(Se=>Se.sort((oe,q)=>p.rcompare(oe.version,q.version))[0])),Z.sort((ie,Se)=>ie.extensionLocation.fsPath<Se.extensionLocation.fsPath?-1:1),Z}catch(R){return s.error(g,R),[]}}static scanOneOrMultipleExtensions(n,s){const u=n.absoluteFolderPath,g=n.isBuiltin,v=n.isUnderDevelopment;return r.SymlinkSupport.existsFile(P.join(u,c)).then(T=>{if(T){const R=l.createNLSConfig(n);return this.scanExtension(n.ourVersion,n.ourProductDate,s,u,g,v,R).then(o=>o===null?[]:[o])}return this.scanExtensions(n,s)},T=>(s.error(u,T),[]))}static scanSingleExtension(n,s){const u=n.absoluteFolderPath,g=n.isBuiltin,v=n.isUnderDevelopment,T=l.createNLSConfig(n);return this.scanExtension(n.ourVersion,n.ourProductDate,s,u,g,v,T)}static mergeBuiltinExtensions(n,s){return Promise.all([n,s]).then(([u,g])=>{let v=Object.create(null);for(let R=0,o=u.length;R<o;R++)v[b.ExtensionIdentifier.toKey(u[R].identifier)]=u[R];for(let R=0,o=g.length;R<o;R++)v[b.ExtensionIdentifier.toKey(g[R].identifier)]=g[R];let T=Object.keys(v).map(R=>v[R]);return T.sort((R,o)=>{const F=P.basename(R.extensionLocation.fsPath),B=P.basename(o.extensionLocation.fsPath);return F<B?-1:F>B?1:0}),T})}}e.ExtensionScanner=t}),define(le[226],ce([0,1,5,48,4,40,156,25,8,31,225,44,53,102,59,82,197,3,23]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAgentEnvironmentChannel=void 0;let h=null;function l(){return h||(h=w.normalize(w.join(m.FileAccess.asFileUri("",x).fsPath,"..","extensions"))),h}let a=null;function t(){return a||(a=w.normalize(w.join(m.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),a}class i{constructor(s,u,g,v,T,R){this._connectionToken=s,this.environmentService=u,this.logService=v,this.telemetryService=T,this.telemetryAppender=R,this._logger=new class{error(F,B){v.error(F,B)}warn(F,B){v.warn(F,B)}info(F,B){v.info(F,B)}},u.args["install-builtin-extension"]?this.whenExtensionsReady=g.installExtensions([],u.args["install-builtin-extension"],!!u.args["do-not-sync"],!!u.args.force).then(null,F=>{v.error(F)}):this.whenExtensionsReady=Promise.resolve();const o=u.args["install-extension"];if(o){const F=o.map(B=>/\.vsix$/i.test(B)?p.URI.file(w.isAbsolute(B)?B:w.join(C.cwd(),B)):B);this.whenExtensionsReady.then(()=>g.installExtensions(F,[],!!u.args["do-not-sync"],!!u.args.force)).then(null,B=>{v.error(B)})}}async call(s,u,g){switch(u){case"disableTelemetry":{this.telemetryService.setEnabled(!1);return}case"getEnvironmentData":{const v=g,T=D.createRemoteURITransformer(v.remoteAuthority);let R=await this._getEnvironmentData();return R=d.transformOutgoingURIs(R,T),R}case"whenExtensionsReady":{await this.whenExtensionsReady;return}case"scanExtensions":{await this.whenExtensionsReady;const v=g,T=v.language;this.logService.trace(`Scanning extensions using UI language: ${T}`);const R=D.createRemoteURITransformer(v.remoteAuthority),o=v.extensionDevelopmentPath&&v.extensionDevelopmentPath.map(Z=>p.URI.revive(R.transformIncoming(Z))),F=o?o.filter(Z=>Z.scheme===m.Schemas.file).map(Z=>Z.fsPath):void 0;let B=await this._scanExtensions(T,F);return B=d.transformOutgoingURIs(B,R),this.logService.trace("Scanned Extensions",B),i._massageWhenConditions(B),B}case"scanSingleExtension":{await this.whenExtensionsReady;const v=g,T=v.language,R=v.isBuiltin,o=D.createRemoteURITransformer(v.remoteAuthority),F=p.URI.revive(o.transformIncoming(v.extensionLocation)),B=F.scheme===m.Schemas.file?F.fsPath:null;if(!B)return null;const Z=await this._getTranslations(T);let ie=await this._scanSingleExtension(B,R,T,Z);return ie?(ie=d.transformOutgoingURIs(ie,o),i._massageWhenConditions([ie]),ie):null}case"getDiagnosticInfo":{const v=g,T={machineInfo:S.getMachineInfo()},R=v.includeProcesses?c.listProcesses(process.pid):Promise.resolve();let o=[];const F={};if(v.folders){const B=D.createRemoteURITransformer("");o=v.folders.map(ie=>p.URI.revive(B.transformIncoming(ie))).filter(ie=>ie.scheme==="file").map(ie=>S.collectWorkspaceStats(ie.fsPath,["node_modules",".git"]).then(Se=>{F[w.basename(ie.fsPath)]=Se}))}return Promise.all([R,...o]).then(([B,Z])=>(T.processes=B||void 0,T.workspaceMetadata=v.folders?F:void 0,T))}case"logTelemetry":{const{eventName:v,data:T}=g;return this.telemetryAppender?this.telemetryAppender.log(v,T):Promise.resolve()}case"flushTelemetry":return this.telemetryAppender?this.telemetryAppender.flush():Promise.resolve()}throw new Error(`IPC Command ${u} not found`)}listen(s,u,g){throw new Error("Not supported")}static _massageWhenConditions(s){const u=(F,B)=>F.replace(/file/g,"vscode-remote"),g=F=>{let B="";return B+=F.global?"g":"",B+=F.ignoreCase?"i":"",B+=F.multiline?"m":"",new RegExp(u(F.source,!0),B)},v=new class{mapDefined(F){return f.ContextKeyDefinedExpr.create(F)}mapNot(F){return f.ContextKeyNotExpr.create(F)}mapEquals(F,B){return F==="resourceScheme"&&typeof B=="string"?f.ContextKeyEqualsExpr.create(F,u(B,!1)):f.ContextKeyEqualsExpr.create(F,B)}mapNotEquals(F,B){return F==="resourceScheme"&&typeof B=="string"?f.ContextKeyNotEqualsExpr.create(F,u(B,!1)):f.ContextKeyNotEqualsExpr.create(F,B)}mapGreater(F,B){return f.ContextKeyGreaterExpr.create(F,B)}mapGreaterEquals(F,B){return f.ContextKeyGreaterEqualsExpr.create(F,B)}mapSmaller(F,B){return f.ContextKeySmallerExpr.create(F,B)}mapSmallerEquals(F,B){return f.ContextKeySmallerEqualsExpr.create(F,B)}mapRegex(F,B){return F==="resourceScheme"&&B?f.ContextKeyRegexExpr.create(F,g(B)):f.ContextKeyRegexExpr.create(F,B)}mapIn(F,B){return f.ContextKeyInExpr.create(F,B)}},T=F=>{if(!F||!F.when||!/resourceScheme/.test(F.when))return;const B=f.ContextKeyExpr.deserialize(F.when);if(!B)return;const Z=B.map(v);F.when=Z.serialize()},R=F=>{if(Array.isArray(F))for(let B of F)T(B);else T(F)},o=F=>{for(let B in F)R(F[B])};s.forEach(F=>{F.contributes&&(F.contributes.menus&&o(F.contributes.menus),F.contributes.keybindings&&R(F.contributes.keybindings),F.contributes.views&&o(F.contributes.views))})}async _getEnvironmentData(){return{pid:process.pid,connectionToken:this._connectionToken,appRoot:p.URI.file(this.environmentService.appRoot),settingsPath:this.environmentService.machineSettingsResource,logsPath:p.URI.file(this.environmentService.logsPath),extensionsPath:p.URI.file(this.environmentService.extensionsPath),extensionHostLogsPath:p.URI.file(w.join(this.environmentService.logsPath,`exthost${i._namePool++}`)),globalStorageHome:this.environmentService.globalStorageHome,workspaceStorageHome:this.environmentService.workspaceStorageHome,userHome:this.environmentService.userHome,os:E.OS,marks:P.getMarks(),useHostProxy:this.environmentService.args["use-host-proxy"]!==void 0}}async _getTranslations(s){const u=await b.getNLSConfiguration(s,this.environmentService.userDataPath);if(b.InternalNLSConfiguration.is(u))try{const g=await _.promises.readFile(u._translationsConfigFile,"utf8");return JSON.parse(g)}catch(g){return Object.create(null)}else return Object.create(null)}async _scanExtensions(s,u){const g=await this._getTranslations(s),[v,T,R]=await Promise.all([this._scanBuiltinExtensions(s,g),this._scanInstalledExtensions(s,g),this._scanDevelopedExtensions(s,g,u)]);let o=new Map;v.forEach(B=>{!B||o.set(k.ExtensionIdentifier.toKey(B.identifier),B)}),T.forEach(B=>{!B||(o.has(k.ExtensionIdentifier.toKey(B.identifier))&&console.warn(I.localize(0,null,o.get(k.ExtensionIdentifier.toKey(B.identifier)).extensionLocation.fsPath,B.extensionLocation.fsPath)),o.set(k.ExtensionIdentifier.toKey(B.identifier),B))}),R.forEach(B=>{!B||o.set(k.ExtensionIdentifier.toKey(B.identifier),B)});const F=[];return o.forEach(B=>F.push(B)),F}_scanDevelopedExtensions(s,u,g){if(g){const v=g.map(T=>r.ExtensionScanner.scanOneOrMultipleExtensions(new r.ExtensionScannerInput(y.default.version,y.default.date,y.default.commit,s,!0,T,!1,!0,u),this._logger));return Promise.all(v).then(T=>{let R=[];for(let o of T)R=R.concat(o);return R})}return Promise.resolve([])}_scanBuiltinExtensions(s,u){const g=y.default.version,v=y.default.commit,T=y.default.date,R=!!process.env.VSCODE_DEV,o=new r.ExtensionScannerInput(g,T,v,s,R,l(),!0,!1,u),F=r.ExtensionScanner.scanExtensions(o,this._logger);let B=F;if(R){class Z{constructor(ee){this.builtInExtensions=ee}resolveExtensions(){return Promise.resolve(this.builtInExtensions.map(ee=>({name:ee.name,path:w.join(t(),ee.name)})))}}const ie=Promise.resolve(y.default.builtInExtensions||[]),Se=new r.ExtensionScannerInput(g,T,v,s,R,t(),!0,!1,{}),oe=ie.then(q=>new Z(q)).then(q=>r.ExtensionScanner.scanExtensions(Se,this._logger,q));B=r.ExtensionScanner.mergeBuiltinExtensions(F,oe)}return B}_scanInstalledExtensions(s,u){const g=!!process.env.VSCODE_DEV,v=new r.ExtensionScannerInput(y.default.version,y.default.date,y.default.commit,s,g,this.environmentService.extensionsPath,!1,!1,u);return r.ExtensionScanner.scanExtensions(v,this._logger)}_scanSingleExtension(s,u,g,v){const T=!!process.env.VSCODE_DEV,R=new r.ExtensionScannerInput(y.default.version,y.default.date,y.default.commit,g,T,s,u,!1,v);return r.ExtensionScanner.scanSingleExtension(R,this._logger)}}e.RemoteAgentEnvironmentChannel=i,i._namePool=1}),define(le[227],ce([0,1,169]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteFileSystemProvider=e.REMOTE_FILE_SYSTEM_CHANNEL_NAME=void 0,e.REMOTE_FILE_SYSTEM_CHANNEL_NAME="remotefilesystem";class P extends E.IPCFileSystemProvider{constructor(D){super(D.getConnection().getChannel(e.REMOTE_FILE_SYSTEM_CHANNEL_NAME));this.setCaseSensitive(!0),(async()=>{const I=await D.getEnvironment();this.setCaseSensitive((I==null?void 0:I.os)===3)})()}}e.RemoteFileSystemProvider=P}),define(le[106],ce([0,1,6]),function(x,e,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=E.createDecorator("remoteAgentService")}),define(le[69],ce([0,1,137,3,25,14,15,241,242,11]),function(x,e,E,P,p,D,I,_,m,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class r extends Error{constructor(t,i){let n=i.message;switch(t){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=t,this.cause=i}}e.ExtractError=r;function k(a){const t=a.externalFileAttributes>>16||33188;return[448,56,7].map(i=>t&i).reduce((i,n)=>i+n,t&61440)}function d(a){if(a instanceof r)return a;let t;return/end of central directory record signature not found/.test(a.message)&&(t="CorruptZip"),new r(t,a)}function b(a,t,i,n,s,u){const g=P.dirname(t),v=P.join(n,g);if(!v.startsWith(n))return Promise.reject(new Error(E.localize(0,null,t)));const T=P.join(n,t);let R;return u.onCancellationRequested(()=>{R&&R.destroy()}),Promise.resolve(I.Promises.mkdir(v,{recursive:!0})).then(()=>new Promise((o,F)=>{if(!u.isCancellationRequested)try{R=p.createWriteStream(T,{mode:i}),R.once("close",()=>o()),R.once("error",F),a.once("error",F),a.pipe(R)}catch(B){F(B)}}))}function f(a,t,i,n){let s=D.createCancelablePromise(()=>Promise.resolve()),u=0;return n.onCancellationRequested(()=>{s.cancel(),a.close()}),new Promise((g,v)=>{const T=new D.Sequencer,R=o=>{o.isCancellationRequested||(u++,a.readEntry())};a.once("error",v),a.once("close",()=>s.then(()=>{n.isCancellationRequested||a.entryCount===u?g():v(new r("Incomplete",new Error(E.localize(1,null,u,a.entryCount))))},v)),a.readEntry(),a.on("entry",o=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(o.fileName)){R(n);return}const F=o.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(F)){const ie=P.join(t,F);s=D.createCancelablePromise(Se=>I.Promises.mkdir(ie,{recursive:!0}).then(()=>R(Se)).then(void 0,v));return}const B=S(a,o),Z=k(o);s=D.createCancelablePromise(ie=>T.queue(()=>B.then(Se=>b(Se,F,Z,t,i,ie).then(()=>R(ie)))).then(null,v))})})}function c(a,t=!1){return new Promise((i,n)=>{_.open(a,t?{lazyEntries:!0}:void 0,(s,u)=>{s?n(d(s)):i(y.assertIsDefined(u))})})}function S(a,t){return new Promise((i,n)=>{a.openReadStream(t,(s,u)=>{s?n(d(s)):i(y.assertIsDefined(u))})})}function w(a,t){return new Promise((i,n)=>{const s=new m.ZipFile;t.forEach(g=>{g.contents?s.addBuffer(typeof g.contents=="string"?Buffer.from(g.contents,"utf8"):g.contents,g.path):g.localPath&&s.addFile(g.localPath,g.path)}),s.end();const u=p.createWriteStream(a);s.outputStream.pipe(u),s.outputStream.once("error",n),u.once("error",n),u.once("finish",()=>i(a))})}e.zip=w;function C(a,t,i={},n){const s=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let u=c(a,!0);return i.overwrite&&(u=u.then(g=>I.rimraf(t).then(()=>g))),u.then(g=>f(g,t,{sourcePathRegex:s},n))}e.extract=C;function h(a,t){return c(a).then(i=>new Promise((n,s)=>{i.on("entry",u=>{u.fileName===t&&S(i,u).then(g=>n(g),g=>s(g))}),i.once("close",()=>s(new Error(E.localize(2,null,t))))}))}function l(a,t){return h(a,t).then(i=>new Promise((n,s)=>{const u=[];i.once("error",s),i.on("data",g=>u.push(g)),i.on("end",()=>n(Buffer.concat(u)))}))}e.buffer=l}),define(le[228],ce([0,1,69,144]),function(x,e,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function p(D){return E.buffer(D,"extension/package.json").then(I=>{try{return JSON.parse(I.toString("utf8"))}catch(_){throw new Error(P.localize(0,null))}})}e.getManifest=p}),define(le[229],ce([0,1,49,2,15,3,16,33,34,14,4,27,168,145,45,69,5,21,8,20,17,22,12]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w,C,h,l,a,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",s="extracting",u="deleting",g="renaming";let v=class extends P.Disposable{constructor(R,o,F,B,Z){super();this.beforeRemovingExtension=R,this.fileService=o,this.logService=F,this.environmentService=B,this.productService=Z,this._devSystemExtensionsPath=null,this.systemExtensionsPath=B.builtinExtensionsPath,this.extensionsPath=B.extensionsPath,this.uninstalledPath=D.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new y.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(R){const o=[];(R===null||R===0)&&o.push(this.scanSystemExtensions().then(null,F=>Promise.reject(new _.ExtensionManagementError(this.joinErrors(F).message,i)))),(R===null||R===1)&&o.push(this.scanUserExtensions(!0).then(null,F=>Promise.reject(new _.ExtensionManagementError(this.joinErrors(F).message,n))));try{const F=await Promise.all(o);return w.flatten(F)}catch(F){throw this.joinErrors(F)}}async scanUserExtensions(R){this.logService.trace("Started scanning user extensions");let[o,F]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return F=F.filter(B=>!o[new m.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).key()]),R&&(F=m.groupByExtension(F,Z=>Z.identifier).map(Z=>Z.sort((ie,Se)=>E.rcompare(ie.manifest.version,Se.manifest.version))[0])),this.logService.trace("Scanned user extensions:",F.length),F}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(R,o,F){const B=R.key(),Z=D.join(this.extensionsPath,`.${a.generateUuid()}`),ie=D.join(this.extensionsPath,B);try{await p.rimraf(ie)}catch(oe){try{await p.rimraf(ie)}catch(q){}throw new _.ExtensionManagementError(b.localize(0,null,ie,R.id),u)}await this.extractAtLocation(R,o,Z,F);let Se=await this.scanExtension(r.URI.file(Z),1);if(!Se)throw new Error(b.localize(1,null,Z));await this.storeMetadata(Se,{installedTimestamp:Date.now()});try{await this.rename(R,Z,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(oe){try{await p.rimraf(Z)}catch(q){}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",R.id);else throw this.logService.info(`Rename failed because of ${t.getErrorMessage(oe)}. Deleted from extracted location`,Z),oe}try{Se=await this.scanExtension(r.URI.file(ie),1)}catch(oe){}if(Se)return Se;throw new Error(b.localize(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(R,o){return this.setMetadata(R,o),await this.storeMetadata(R,Object.assign(Object.assign({},o),{installedTimestamp:R.installedTimestamp})),R}async storeMetadata(R,o){o.isMachineScoped=o.isMachineScoped||void 0,o.isBuiltin=o.isBuiltin||void 0,o.installedTimestamp=o.installedTimestamp||void 0;const F=D.join(R.location.fsPath,"package.json"),B=await p.Promises.readFile(F,"utf8"),{manifest:Z}=await this.parseManifest(B);return Z.__metadata=o,await p.writeFile(F,JSON.stringify(Z,null,"	")),R}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...R){const o=R.map(F=>new m.ExtensionIdentifierWithVersion(F.identifier,F.manifest.version));await this.withUninstalledExtensions(F=>{o.forEach(B=>F[B.key()]=!0)})}async setInstalled(R){await this.withUninstalledExtensions(B=>delete B[R.key()]);const F=(await this.scanExtensions(1)).find(B=>new m.ExtensionIdentifierWithVersion(B.identifier,B.manifest.version).equals(R))||null;return F?(await this.storeMetadata(F,{installedTimestamp:Date.now()}),this.scanExtension(F.location,1)):null}async withUninstalledExtensions(R){return this.uninstalledFileLimiter.queue(async()=>{let o;try{o=await p.Promises.readFile(this.uninstalledPath,"utf8")}catch(B){if(B.code!=="ENOENT")throw B}let F={};if(o)try{F=JSON.parse(o)}catch(B){}return R&&(R(F),Object.keys(F).length?await p.writeFile(this.uninstalledPath,JSON.stringify(F)):await p.rimraf(this.uninstalledPath)),F})}async removeExtension(R,o){this.logService.trace(`Deleting ${o} extension from disk`,R.identifier.id,R.location.fsPath),await p.rimraf(R.location.fsPath),this.logService.info("Deleted from disk",R.identifier.id,R.location.fsPath)}async removeUninstalledExtension(R){await this.removeExtension(R,"uninstalled"),await this.withUninstalledExtensions(o=>delete o[new m.ExtensionIdentifierWithVersion(R.identifier,R.manifest.version).key()])}async extractAtLocation(R,o,F,B){this.logService.trace(`Started extracting the extension from ${o} to ${F}`);try{await p.rimraf(F)}catch(Z){throw new _.ExtensionManagementError(this.joinErrors(Z).message,u)}try{await c.extract(o,F,{sourcePath:"extension",overwrite:!0},B),this.logService.info(`Extracted extension to ${F}:`,R.id)}catch(Z){try{await p.rimraf(F)}catch(ie){}throw new _.ExtensionManagementError(Z.message,Z instanceof c.ExtractError&&Z.type?Z.type:s)}}async rename(R,o,F,B){try{await p.Promises.rename(o,F)}catch(Z){if(S.isWindows&&Z&&Z.code==="EPERM"&&Date.now()<B)return this.logService.info(`Failed renaming ${o} to ${F} with 'EPERM' error. Trying again...`,R.id),this.rename(R,o,F,B);throw new _.ExtensionManagementError(Z.message||b.localize(3,null,o,F),Z.code||g)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const R=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return R;const o=this.scanDevSystemExtensions(),[F,B]=await Promise.all([R,o]);return[...F,...B]}async scanExtensionsInDir(R,o){const F=new y.Limiter(10),B=await this.fileService.resolve(r.URI.file(R));return B.children?(await Promise.all(B.children.filter(ie=>ie.isDirectory).map(ie=>F.queue(async()=>o===1&&l.basename(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,o))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(R,o){var F,B;try{const Z=await this.fileService.resolve(R);if(Z.children){const{manifest:ie,metadata:Se}=await this.readManifest(R.fsPath),oe=(F=Z.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z)))===null||F===void 0?void 0:F.resource,q=(B=Z.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z)))===null||B===void 0?void 0:B.resource,ee={id:m.getGalleryExtensionId(ie.publisher,ie.name)},G={type:o,identifier:ee,manifest:ie,location:R,readmeUrl:oe,changelogUrl:q,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:o===0};return Se&&(this.setMetadata(G,Se),G.installedTimestamp=Se.installedTimestamp),G}}catch(Z){o!==0&&this.logService.trace(Z)}return null}async scanDefaultSystemExtensions(){const R=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",R.length),R}async scanDevSystemExtensions(){const R=this.getDevSystemExtensionsList();if(R.length){const o=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",o.length),o.filter(F=>R.some(B=>m.areSameExtensions(F.identifier,{id:B})))}else return[]}setMetadata(R,o){R.publisherDisplayName=o.publisherDisplayName||null,R.publisherId=o.publisherId||null,R.identifier.uuid=o.id,R.isMachineScoped=!!o.isMachineScoped,R.isBuiltin=R.type===0||!!o.isBuiltin}async removeUninstalledExtensions(){const R=await this.getUninstalledExtensions(),o=await this.scanAllUserExtensions(),F=new Set;for(const ie of o)R[new m.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||F.add(ie.identifier.id.toLowerCase());const B=m.groupByExtension(o,ie=>ie.identifier);await y.Promises.settled(B.map(async ie=>{const Se=ie.sort((oe,q)=>E.rcompare(oe.manifest.version,q.manifest.version))[0];F.has(Se.identifier.id.toLowerCase())||await this.beforeRemovingExtension(Se)}));const Z=o.filter(ie=>R[new m.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await y.Promises.settled(Z.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const R=await this.scanAllUserExtensions(),o=[],F=m.groupByExtension(R,B=>B.identifier);o.push(...w.flatten(F.map(B=>B.sort((Z,ie)=>E.rcompare(Z.manifest.version,ie.manifest.version)).slice(1)))),await y.Promises.settled(o.map(B=>this.removeExtension(B,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(R=>R.name)}joinErrors(R){const o=Array.isArray(R)?R:[R];return o.length===1?o[0]instanceof Error?o[0]:new Error(o[0]):o.reduce((F,B)=>new Error(`${F.message}${F.message?",":""}${B instanceof Error?B.message:B}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=D.normalize(D.join(C.FileAccess.asFileUri("",x).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(R){const o=[p.Promises.readFile(D.join(R,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),p.Promises.readFile(D.join(R,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:F,metadata:B},Z]=await Promise.all(o);return{manifest:d.localizeManifest(F,Z),metadata:B}}parseManifest(R){return new Promise((o,F)=>{try{const B=JSON.parse(R),Z=B.__metadata||null;o({manifest:B,metadata:Z})}catch(B){F(new Error(b.localize(4,null)))}})}};v=Ne([Ke(1,h.IFileService),Ke(2,I.ILogService),Ke(3,k.INativeEnvironmentService),Ke(4,f.IProductService)],v),e.ExtensionsScanner=v}),define(le[107],ce([0,1,143,3,15,2,21,69,33,34,27,14,7,49,4,31,5,16,179,43,39,57,17,22,86,6,8,29,228,183,229,184,185,20]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w,C,h,l,a,t,i,n,s,u,g,v,T,R,o,F,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=void 0;const Z="unsetUninstalled",ie="downloading",Se="validating",oe="local",q="unknown";let ee=class extends D.Disposable{constructor(z,L,A,N,M,W,X){super();this.environmentService=z,this.galleryService=L,this.logService=A,this.downloadService=N,this.telemetryService=M,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new d.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtension=this._register(new d.Emitter),this.onDidInstallExtension=this._onDidInstallExtension.event,this._onUninstallExtension=this._register(new d.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new d.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event;const ae=this._register(W.createInstance(o.ExtensionsLifecycle));this.extensionsScanner=this._register(W.createInstance(R.ExtensionsScanner,be=>ae.postUninstall(be))),this.manifestCache=this._register(new C.ExtensionsManifestCache(z,this)),this.extensionsDownloader=this._register(W.createInstance(T.ExtensionsDownloader));const se=this._register(new F.ExtensionsWatcher(this,X,z,A));this._register(se.onDidChangeExtensionsByAnotherSource(({added:be,removed:ke})=>{be.forEach(Te=>this._onDidInstallExtension.fire({identifier:Te.identifier,operation:0,local:Te})),ke.forEach(Te=>this._onDidUninstallExtension.fire({identifier:Te}))})),this._register(D.toDisposable(()=>{this.installingExtensions.forEach(be=>be.cancel()),this.uninstallingExtensions.forEach(be=>be.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const L=await this.collectFiles(z),A=await _.zip(t.joinPath(this.environmentService.tmpDir,i.generateUuid()).fsPath,L);return f.URI.file(A)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const L=await this.downloadVsix(z),A=P.resolve(L.fsPath);return v.getManifest(A)}async collectFiles(z){const L=async N=>{let M=await p.readdir(N);M=M.map(ae=>P.join(N,ae));const W=await Promise.all(M.map(ae=>p.Promises.stat(ae)));let X=Promise.resolve([]);return W.forEach((ae,se)=>{const be=M[se];ae.isFile()&&(X=X.then(ke=>[...ke,be])),ae.isDirectory()&&(X=X.then(ke=>L(be).then(Te=>[...ke,...Te])))}),X};return(await L(z.location.fsPath)).map(N=>({path:`extension/${P.relative(z.location.fsPath,N)}`,localPath:N}))}async install(z,L={}){return this.logService.trace("ExtensionManagementService#install",z.toString()),k.createCancelablePromise(async A=>{const N=await this.downloadVsix(z),M=P.resolve(N.fsPath),W=await v.getManifest(M),X={id:y.getGalleryExtensionId(W.publisher,W.name)};let ae=1;if(W.engines&&W.engines.vscode&&!a.isEngineValid(W.engines.vscode,c.default.version,c.default.date))throw new Error(E.localize(0,null,X.id,c.default.version));const se=new y.ExtensionIdentifierWithVersion(X,W.version),ke=(await this.getInstalled(1)).find(Le=>y.areSameExtensions(X,Le.identifier));if(ke)if(L.isMachineScoped=L.isMachineScoped||ke.isMachineScoped,L.isBuiltin=L.isBuiltin||ke.isBuiltin,ae=2,se.equals(new y.ExtensionIdentifierWithVersion(ke.identifier,ke.manifest.version)))try{await this.extensionsScanner.removeExtension(ke,"existing")}catch(Le){throw new Error(E.localize(1,null,W.displayName||W.name))}else b.gt(ke.manifest.version,W.version)&&await this.uninstallExtension(ke);else{const Le=await this.unsetUninstalledAndGetLocal(se);if(Le)try{await this.extensionsScanner.removeExtension(Le,"existing")}catch(je){throw new Error(E.localize(2,null,W.displayName||W.name))}}this.logService.info("Installing the extension:",X.id),this._onInstallExtension.fire({identifier:X,zipPath:M});let Te;try{Te=await this.getGalleryMetadata(y.getGalleryExtensionId(W.publisher,W.name))}catch(Le){}try{const Le=await this.installFromZipPath(se,M,L.installOnlyNewlyAddedFromExtensionPack?ke:void 0,Object.assign(Object.assign({},Te||{}),L),L,ae,A);return this.logService.info("Successfully installed the extension:",X.id),Le}catch(Le){throw this.logService.error("Failed to install the extension:",X.id,Le.message),Le}})}async downloadVsix(z){if(z.scheme===u.Schemas.file)return z;if(!this.downloadService)throw new Error("Download service is not available");const L=t.joinPath(this.environmentService.tmpDir,i.generateUuid());return await this.downloadService.download(z,L),L}async installFromZipPath(z,L,A,N,M,W,X){try{const ae=await this.installExtension({zipPath:L,identifierWithVersion:z,metadata:N},X);try{M.donotIncludePackAndDependencies||await this.installDependenciesAndPackExtensions(ae,A,M)}catch(se){I.isNonEmptyArray(ae.manifest.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",ae.identifier.id,se.message),I.isNonEmptyArray(ae.manifest.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",ae.identifier.id,se.message)}return this._onDidInstallExtension.fire({identifier:z,zipPath:L,local:ae,operation:W}),ae}catch(ae){throw this._onDidInstallExtension.fire({identifier:z,zipPath:L,operation:W,error:ae}),ae}}async canInstall(z){return!0}async installFromGallery(z,L={}){if(!this.galleryService.isEnabled())throw new Error(E.localize(3,null));try{z=await this.checkAndGetCompatibleVersion(z)}catch(M){const W=M&&M.code?M.code:q;throw this.logService.error("Failed to install extension:",z.identifier.id,M?M.message:W),this.reportTelemetry(this.getTelemetryEvent(1),y.getGalleryExtensionTelemetryData(z),void 0,M),M instanceof Error&&(M.name=W),M}const A=new y.ExtensionIdentifierWithVersion(z.identifier,z.version).key();let N=this.installingExtensions.get(A);return N||(N=k.createCancelablePromise(M=>this.doInstallFromGallery(z,L,M)),this.installingExtensions.set(A,N),N.finally(()=>this.installingExtensions.delete(A))),N}async doInstallFromGallery(z,L,A){const N=new Date().getTime();let M=1;this.logService.info("Installing extension:",z.identifier.id),this._onInstallExtension.fire({identifier:z.identifier,gallery:z});try{const X=(await this.getInstalled(1)).find(be=>y.areSameExtensions(be.identifier,z.identifier));X&&(M=2);const ae=await this.downloadInstallableExtension(z,M);ae.metadata.isMachineScoped=L.isMachineScoped||(X==null?void 0:X.isMachineScoped),ae.metadata.isBuiltin=L.isBuiltin||(X==null?void 0:X.isBuiltin);const se=await this.installExtension(ae,A);try{await this.extensionsDownloader.delete(f.URI.file(ae.zipPath))}catch(be){}if(!L.donotIncludePackAndDependencies)try{await this.installDependenciesAndPackExtensions(se,X,L)}catch(be){try{await this.uninstall(se)}catch(ke){}throw be}return X&&b.neq(X.manifest.version,z.version)&&await this.extensionsScanner.setUninstalled(X),this.logService.info("Extensions installed successfully:",z.identifier.id),this._onDidInstallExtension.fire({identifier:z.identifier,gallery:z,local:se,operation:M}),this.reportTelemetry(this.getTelemetryEvent(M),y.getGalleryExtensionTelemetryData(z),new Date().getTime()-N,void 0),se}catch(W){const X=W&&W.code?W.code:q;throw this.logService.error("Failed to install extension:",z.identifier.id,W?W.message:X),this._onDidInstallExtension.fire({identifier:z.identifier,gallery:z,operation:M,error:X}),this.reportTelemetry(this.getTelemetryEvent(M),y.getGalleryExtensionTelemetryData(z),new Date().getTime()-N,W),W instanceof Error&&(W.name=X),W}}async checkAndGetCompatibleVersion(z){if(await this.isMalicious(z))throw new m.ExtensionManagementError(E.localize(4,null),m.INSTALL_ERROR_MALICIOUS);const L=await this.galleryService.getCompatibleExtension(z);if(!L)throw new m.ExtensionManagementError(E.localize(5,null,z.identifier.id,c.default.version),m.INSTALL_ERROR_INCOMPATIBLE);return L}async reinstallFromGallery(z){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",z.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(6,null));const L=await this.findGalleryExtension(z);if(!L)throw new Error(E.localize(7,null));await this.extensionsScanner.setUninstalled(z);try{await this.extensionsScanner.removeUninstalledExtension(z)}catch(A){throw new Error(E.localize(8,null,h.toErrorMessage(A)))}await this.installFromGallery(L)}getTelemetryEvent(z){return z===2?"extensionGallery:update":"extensionGallery:install"}async isMalicious(z){const L=await this.getExtensionsReport();return y.getMaliciousExtensionsSet(L).has(z.identifier.id)}async downloadInstallableExtension(z,L){const A={id:z.identifier.uuid,publisherId:z.publisherId,publisherDisplayName:z.publisherDisplayName};let N;try{this.logService.trace("Started downloading extension:",z.identifier.id),N=(await this.extensionsDownloader.downloadExtension(z,L)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,N)}catch(M){throw new m.ExtensionManagementError(this.joinErrors(M).message,ie)}try{const M=await v.getManifest(N);return{zipPath:N,identifierWithVersion:new y.ExtensionIdentifierWithVersion(z.identifier,M.version),metadata:A}}catch(M){throw new m.ExtensionManagementError(this.joinErrors(M).message,Se)}}async installExtension(z,L){try{const A=await this.unsetUninstalledAndGetLocal(z.identifierWithVersion);if(A)return z.metadata?this.extensionsScanner.saveMetadataForLocalExtension(A,z.metadata):A}catch(A){throw S.isMacintosh?new m.ExtensionManagementError(E.localize(9,null),Z):new m.ExtensionManagementError(E.localize(10,null),Z)}return this.extractAndInstall(z,L)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const A=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),A}async extractAndInstall({zipPath:z,identifierWithVersion:L,metadata:A},N){let M=await this.extensionsScanner.extractUserExtension(L,z,N);return this.logService.info("Installation completed.",L.id),A&&(M=await this.extensionsScanner.saveMetadataForLocalExtension(M,A)),M}async installDependenciesAndPackExtensions(z,L,A){if(!this.galleryService.isEnabled())return;const N=z.manifest.extensionDependencies||[];if(z.manifest.extensionPack)for(const M of z.manifest.extensionPack)L&&L.manifest.extensionPack&&L.manifest.extensionPack.some(W=>y.areSameExtensions({id:W},{id:M}))||N.every(W=>!y.areSameExtensions({id:W},{id:M}))&&N.push(M);if(N.length){const M=await this.getInstalled(),W=N.filter(X=>M.every(({identifier:ae})=>!y.areSameExtensions(ae,{id:X})));if(W.length){const ae=(await this.galleryService.query({names:W,pageSize:N.length},g.CancellationToken.None)).firstPage;try{await k.Promises.settled(ae.map(se=>this.installFromGallery(se,A)))}catch(se){try{await this.rollback(ae)}catch(be){}throw se}}}}async rollback(z){const A=(await this.getInstalled(1)).filter(N=>z.some(M=>new y.ExtensionIdentifierWithVersion(N.identifier,N.manifest.version).equals(new y.ExtensionIdentifierWithVersion(M.identifier,M.version))));await k.Promises.settled(A.map(N=>this.uninstall(N)))}async uninstall(z,L={}){this.logService.trace("ExtensionManagementService#uninstall",z.identifier.id);const A=await this.getInstalled(1),N=A.find(M=>y.areSameExtensions(M.identifier,z.identifier));if(!N)throw new Error(E.localize(11,null,z.manifest.displayName||z.manifest.name));try{await this.checkForDependenciesAndUninstall(N,A,L)}catch(M){throw this.joinErrors(M)}}async updateMetadata(z,L){return this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,Object.assign(Object.assign({},z.manifest.__metadata||{}),L)),this.manifestCache.invalidate(),z}async updateExtensionScope(z,L){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.saveMetadataForLocalExtension(z,Object.assign(Object.assign({},z.manifest.__metadata||{}),{isMachineScoped:L})),this.manifestCache.invalidate(),z}async getGalleryMetadata(z){const L=await this.findGalleryExtensionByName(z);return L?{id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId}:void 0}async findGalleryExtension(z){if(z.identifier.uuid){const L=await this.findGalleryExtensionById(z.identifier.uuid);return L||this.findGalleryExtensionByName(z.identifier.id)}return this.findGalleryExtensionByName(z.identifier.id)}async findGalleryExtensionById(z){return(await this.galleryService.query({ids:[z],pageSize:1},g.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(z){return(await this.galleryService.query({names:[z],pageSize:1},g.CancellationToken.None)).firstPage[0]}joinErrors(z){const L=Array.isArray(z)?z:[z];return L.length===1?L[0]instanceof Error?L[0]:new Error(L[0]):L.reduce((A,N)=>new Error(`${A.message}${A.message?",":""}${N instanceof Error?N.message:N}`),new Error(""))}async checkForDependenciesAndUninstall(z,L,A){try{await this.preUninstallExtension(z);const N=A.donotIncludePack?[]:this.getAllPackExtensionsToUninstall(z,L);await this.uninstallExtensions(z,N,L,A)}catch(N){throw await this.postUninstallExtension(z,new m.ExtensionManagementError(N instanceof Error?N.message:N,oe)),N}await this.postUninstallExtension(z)}async uninstallExtensions(z,L,A,N){const M=[z,...L];if(!N.donotCheckDependents)for(const W of M)this.checkForDependents(W,M,A,z);await k.Promises.settled([this.uninstallExtension(z),...L.map(W=>this.doUninstall(W))])}checkForDependents(z,L,A,N){const M=this.getDependents(z,A);if(M.length){const W=M.filter(X=>L.indexOf(X)===-1);if(W.length)throw new Error(this.getDependentsErrorMessage(z,W,N))}}getDependentsErrorMessage(z,L,A){return A===z?L.length===1?E.localize(12,null,A.manifest.displayName||A.manifest.name,L[0].manifest.displayName||L[0].manifest.name):L.length===2?E.localize(13,null,A.manifest.displayName||A.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):E.localize(14,null,A.manifest.displayName||A.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):L.length===1?E.localize(15,null,A.manifest.displayName||A.manifest.name,z.manifest.displayName||z.manifest.name,L[0].manifest.displayName||L[0].manifest.name):L.length===2?E.localize(16,null,A.manifest.displayName||A.manifest.name,z.manifest.displayName||z.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name):E.localize(17,null,A.manifest.displayName||A.manifest.name,z.manifest.displayName||z.manifest.name,L[0].manifest.displayName||L[0].manifest.name,L[1].manifest.displayName||L[1].manifest.name)}getAllPackExtensionsToUninstall(z,L,A=[]){if(A.indexOf(z)!==-1)return[];A.push(z);const N=z.manifest.extensionPack?z.manifest.extensionPack:[];if(N.length){const M=L.filter(X=>!X.isBuiltin&&N.some(ae=>y.areSameExtensions({id:ae},X.identifier))),W=[];for(const X of M)W.push(...this.getAllPackExtensionsToUninstall(X,L,A));return[...M,...W]}return[]}getDependents(z,L){return L.filter(A=>A.manifest.extensionDependencies&&A.manifest.extensionDependencies.some(N=>y.areSameExtensions({id:N},z.identifier)))}async doUninstall(z){try{await this.preUninstallExtension(z),await this.uninstallExtension(z)}catch(L){throw await this.postUninstallExtension(z,new m.ExtensionManagementError(L instanceof Error?L.message:L,oe)),L}await this.postUninstallExtension(z)}async preUninstallExtension(z){if(!await p.exists(z.location.fsPath))throw new Error(E.localize(18,null));this.logService.info("Uninstalling extension:",z.identifier.id),this._onUninstallExtension.fire(z.identifier)}async uninstallExtension(z){let L=this.uninstallingExtensions.get(z.identifier.id);return L||(L=k.createCancelablePromise(async()=>{const A=await this.extensionsScanner.scanUserExtensions(!1);await this.extensionsScanner.setUninstalled(...A.filter(N=>y.areSameExtensions(N.identifier,z.identifier)))}),this.uninstallingExtensions.set(z.identifier.id,L),L.finally(()=>this.uninstallingExtensions.delete(z.identifier.id))),L}async postUninstallExtension(z,L){if(L)this.logService.error("Failed to uninstall extension:",z.identifier.id,L.message);else if(this.logService.info("Successfully uninstalled extension:",z.identifier.id),z.identifier.uuid)try{await this.galleryService.reportStatistic(z.manifest.publisher,z.manifest.name,z.manifest.version,"uninstall")}catch(N){}this.reportTelemetry("extensionGallery:uninstall",y.getLocalExtensionTelemetryData(z),void 0,L);const A=L?L instanceof m.ExtensionManagementError?L.code:q:void 0;this._onDidUninstallExtension.fire({identifier:z.identifier,error:A})}getInstalled(z=null){return this.extensionsScanner.scanExtensions(z)}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async isUninstalled(z){return(await this.filterUninstalled(z)).length===1}async filterUninstalled(...z){const L=[],A=await this.extensionsScanner.getUninstalledExtensions();for(const N of z)A[N.key()]&&L.push(N.key());return L}getExtensionsReport(){const z=new Date().getTime();return(!this.reportedExtensions||z-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=z),this.reportedExtensions}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const z=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${z.length} reported extensions from service`),z}catch(z){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}reportTelemetry(z,L,A,N){const M=N?N instanceof m.ExtensionManagementError?N.code:q:void 0;this.telemetryService.publicLogError(z,Object.assign(Object.assign({},L),{success:!N,duration:A,errorcode:M}))}};ee=Ne([Ke(0,r.INativeEnvironmentService),Ke(1,m.IExtensionGalleryService),Ke(2,w.ILogService),Ke(3,s.optional(n.IDownloadService)),Ke(4,l.ITelemetryService),Ke(5,s.IInstantiationService),Ke(6,B.IFileService)],ee),e.ExtensionManagementService=ee}),define(le[50],ce([0,1,62,80,230,7,36,3,24,22,2,18,83,12,5]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class c{constructor(v){this.socket=v,this._errorListener=T=>{if(T){if(T.code==="EPIPE")return;b.onUnexpectedError(T)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(v){const T=R=>v(k.VSBuffer.wrap(R));return this.socket.on("data",T),{dispose:()=>this.socket.off("data",T)}}onClose(v){return this.socket.on("close",v),{dispose:()=>this.socket.off("close",v)}}onEnd(v){return this.socket.on("end",v),{dispose:()=>this.socket.off("end",v)}}write(v){if(!this.socket.destroyed)try{this.socket.write(v.buffer,T=>{if(T){if(T.code==="EPIPE")return;b.onUnexpectedError(T)}})}catch(T){if(T.code==="EPIPE")return;b.onUnexpectedError(T)}}end(){this.socket.end()}drain(){return new Promise((v,T)=>{if(this.socket.bufferSize===0){v();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),v()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=c;var S;(function(g){g[g.MinHeaderByteSize=2]="MinHeaderByteSize"})(S||(S={}));var w;(function(g){g[g.PeekHeader=1]="PeekHeader",g[g.ReadHeader=2]="ReadHeader",g[g.ReadBody=3]="ReadBody",g[g.Fin=4]="Fin"})(w||(w={}));class C extends r.Disposable{constructor(v,T,R,o){super();this._onDidZlibFlush=this._register(new D.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new D.Emitter),this._onClose=this._register(new D.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,mask:0},this.socket=v,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=T,this._recordInflateBytes=o,T?(this._zlibInflate=p.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",F=>{console.error(F),b.onUnexpectedError(F),this._onClose.fire()}),this._zlibInflate.on("data",F=>{this._pendingInflateData.push(F)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=p.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",F=>{console.error(F),b.onUnexpectedError(F),this._onClose.fire()}),this._zlibDeflate.on("data",F=>{this._pendingDeflateData.push(F)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new d.ChunkStream,this._register(this.socket.onData(F=>this._acceptChunk(F))),this._register(this.socket.onClose(()=>this._onClose.fire()))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?k.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):k.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(v){return this._onData.event(v)}onClose(v){return this._onClose.event(v)}onEnd(v){return this.socket.onEnd(v)}write(v){this._totalOutgoingDataBytes+=v.byteLength,this._zlibDeflate?(this._zlibDeflate.write(v.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let T=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,T=T.slice(0,T.length-4),this._isEnded||this._write(k.VSBuffer.wrap(T),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(v,!1)}_write(v,T){let R=2;v.byteLength<126?R+=0:v.byteLength<2**16?R+=2:R+=8;const o=k.VSBuffer.alloc(R);if(T?o.writeUInt8(194,0):o.writeUInt8(130,0),v.byteLength<126)o.writeUInt8(v.byteLength,1);else if(v.byteLength<2**16){o.writeUInt8(126,1);let F=1;o.writeUInt8(v.byteLength>>>8&255,++F),o.writeUInt8(v.byteLength>>>0&255,++F)}else{o.writeUInt8(127,1);let F=1;o.writeUInt8(0,++F),o.writeUInt8(0,++F),o.writeUInt8(0,++F),o.writeUInt8(0,++F),o.writeUInt8(v.byteLength>>>24&255,++F),o.writeUInt8(v.byteLength>>>16&255,++F),o.writeUInt8(v.byteLength>>>8&255,++F),o.writeUInt8(v.byteLength>>>0&255,++F)}this._totalOutgoingWireBytes+=o.byteLength+v.byteLength,this.socket.write(k.VSBuffer.concat([o,v]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(v){if(v.byteLength!==0){for(this._totalIncomingWireBytes+=v.byteLength,this._incomingData.acceptChunk(v);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const T=this._incomingData.peek(this._state.readLen),o=(T.readUInt8(0)&128)>>>7,F=T.readUInt8(1),B=(F&128)>>>7,Z=F&127;this._state.state=2,this._state.readLen=2+(B?4:0)+(Z===126?2:0)+(Z===127?8:0),this._state.fin=o,this._state.mask=0}else if(this._state.state===2){const T=this._incomingData.read(this._state.readLen),R=T.readUInt8(1),o=(R&128)>>>7;let F=R&127,B=1;F===126?F=T.readUInt8(++B)*2**8+T.readUInt8(++B):F===127&&(F=T.readUInt8(++B)*0+T.readUInt8(++B)*0+T.readUInt8(++B)*0+T.readUInt8(++B)*0+T.readUInt8(++B)*2**24+T.readUInt8(++B)*2**16+T.readUInt8(++B)*2**8+T.readUInt8(++B));let Z=0;o&&(Z=T.readUInt8(++B)*2**24+T.readUInt8(++B)*2**16+T.readUInt8(++B)*2**8+T.readUInt8(++B)),this._state.state=3,this._state.readLen=F,this._state.mask=Z}else if(this._state.state===3){const T=this._incomingData.read(this._state.readLen);h(T,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(T.buffer)),this._zlibInflate.write(T.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(k.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=T.byteLength,this._onData.fire(T))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await D.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=C;function h(g,v){if(v===0)return;let T=g.byteLength>>>2;for(let ie=0;ie<T;ie++){const Se=g.readUInt32BE(ie*4);g.writeUInt32BE(Se^v,ie*4)}let R=T*4,o=g.byteLength-R;const F=v>>>24&255,B=v>>>16&255,Z=v>>>8&255;o>=1&&g.writeUInt8(g.readUInt8(R)^F,R),o>=2&&g.writeUInt8(g.readUInt8(R+1)^B,R+1),o>=3&&g.writeUInt8(g.readUInt8(R+2)^Z,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function a(){const g=y.generateUuid();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${g}-sock`;let v;return e.XDG_RUNTIME_DIR?v=_.join(e.XDG_RUNTIME_DIR,`vscode-ipc-${g}.sock`):v=_.join(m.tmpdir(),`vscode-ipc-${g}.sock`),i(v),v}e.createRandomIPCHandle=a;function t(g,v,T){const R=E.createHash("md5").update(g).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${T}-${v}-sock`;let o;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?o=_.join(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${T}-${v}.sock`):o=_.join(g,`${T}-${v}.sock`),i(o),o}e.createStaticIPCHandle=t;function i(g){const v=l[f.platform];typeof v=="number"&&g.length>=v&&console.warn(`WARNING: IPC handle "${g}" is longer than ${v} chars, try a shorter --user-data-dir`)}class n extends I.IPCServer{constructor(v){super(n.toClientConnectionEvent(v));this.server=v}static toClientConnectionEvent(v){const T=D.Event.fromNodeEventEmitter(v,"connection");return D.Event.map(T,R=>({protocol:new d.Protocol(new c(R)),onDidClientDisconnect:D.Event.once(D.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=n;function s(g){return new Promise((v,T)=>{const R=P.createServer();R.on("error",T),R.listen(g,()=>{R.removeListener("error",T),v(new n(R))})})}e.serve=s;function u(g,v){return new Promise((T,R)=>{const o=P.createConnection(g,()=>{o.removeListener("error",R),T(d.Client.fromSocket(new c(o),v))});o.once("error",R)})}e.connect=u}),define(le[108],ce([0,1,230,65,2,11,12,192,32,16,18,27,88]),function(x,e,E,P,p,D,I,_,m,y,r,k,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let b=class extends p.Disposable{constructor(c,S,w){super();this.environmentService=S,this.logService=w,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,S){this.logService.trace("RequestService#request",c.url);const{proxyUrl:w,strictSSL:C}=this,h=Object.assign(Object.assign({},process.env),await d.resolveShellEnv(this.logService,this.environmentService.args,process.env)),l=c.agent?c.agent:await _.getProxyAgent(c.url||"",h,{proxyUrl:w,strictSSL:C});return c.agent=l,c.strictSSL=C,this.authorization&&(c.headers=Object.assign(Object.assign({},c.headers||{}),{"Proxy-Authorization":this.authorization})),this._request(c,S)}async getNodeRequest(c){return(P.parse(c.url).protocol==="https:"?await new Promise((C,h)=>{x(["https"],C,h)}):await new Promise((C,h)=>{x(["http"],C,h)})).request}_request(c,S){return new Promise(async(w,C)=>{let h;const l=P.parse(c.url),a=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),t={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:D.isBoolean(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(t.auth=c.user+":"+c.password),h=a(t,i=>{const n=D.isNumber(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request(Object.assign(Object.assign({},c),{url:i.headers.location,followRedirects:n-1}),S).then(w,C);else{let s=i;i.headers["content-encoding"]==="gzip"&&(s=i.pipe(E.createGunzip())),w({res:i,stream:r.streamToBufferReadableStream(s)})}}),h.on("error",C),c.timeout&&h.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&h.write(c.data),h.end(),S.onCancellationRequested(()=>{h.abort(),C(I.canceled())})})}async resolveProxy(c){}};b=Ne([Ke(0,m.IConfigurationService),Ke(1,k.INativeEnvironmentService),Ke(2,y.ILogService)],b),e.RequestService=b}),define(le[109],ce([0,1,35,102,40,8,3,18,7,50,88,5]),function(x,e,E,P,p,D,I,_,m,y,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostConnection=e.buildUserEnvironment=void 0;async function d(w={},C,h,l,a){const t=await P.getNLSConfiguration(C,l.userDataPath),i=await r.resolveShellEnv(a,l.args,process.env),n=l.isBuilt?I.join(l.appRoot,"bin"):I.join(l.appRoot,"resources","server","bin-dev"),s=process.env;let u=w.PATH||i.PATH||s.PATH;u?u=n+I.delimiter+u:u=n;const g=Object.assign(Object.assign(Object.assign(Object.assign({},s),i),{VSCODE_LOG_NATIVE:String(h),VSCODE_AMD_ENTRYPOINT:"vs/server/remoteExtensionHostProcess",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_EXTHOST_WILL_SEND_SOCKET:"true",VSCODE_HANDLES_UNCAUGHT_ERRORS:"true",VSCODE_LOG_STACK:"false",VSCODE_NLS_CONFIG:JSON.stringify(t,void 0,0)}),w);return l.args["without-browser-env-var"]||(g.BROWSER=I.join(n,"helpers",k.isWindows?"browser.cmd":"browser.sh")),c(g,"PATH",u),S(g),g}e.buildUserEnvironment=d;class b{constructor(C,h,l,a,t,i){this.socket=C,this.socketDrain=h,this.initialDataChunk=l,this.skipWebSocketFrames=a,this.permessageDeflate=t,this.inflateBytes=i}toIExtHostSocketMessage(){return{type:"VSCODE_EXTHOST_IPC_SOCKET",initialDataChunk:this.initialDataChunk.buffer.toString("base64"),skipWebSocketFrames:this.skipWebSocketFrames,permessageDeflate:this.permessageDeflate,inflateBytes:this.inflateBytes.buffer.toString("base64")}}}class f{constructor(C,h,l,a,t,i){this._environmentService=C,this._logService=h,this._reconnectionToken=l,this._onClose=new m.Emitter,this.onClose=this._onClose.event,this._disposed=!1,this._remoteAddress=a,this._extensionHostProcess=null,this._connectionData=f._toConnectionData(t,i),this._connectionData.socket.pause(),this._log("New connection established.")}_log(C){this._logService.info(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${C}`)}_logError(C){this._logService.error(`[${this._remoteAddress}][${this._reconnectionToken.substr(0,8)}][ExtensionHostConnection] ${C}`)}static _toConnectionData(C,h){return C instanceof y.NodeSocket?new b(C.socket,C.drain(),h,!0,!1,_.VSBuffer.alloc(0)):new b(C.socket.socket,C.drain(),h,!1,C.permessageDeflate,C.recordedInflateBytes)}async _sendSocketToExtensionHost(C,h){await h.socketDrain;const l=h.toIExtHostSocketMessage();C.send(l,h.socket)}shortenReconnectionGraceTimeIfNecessary(){if(!this._extensionHostProcess)return;const C={type:"VSCODE_EXTHOST_IPC_REDUCE_GRACE_TIME"};this._extensionHostProcess.send(C)}acceptReconnection(C,h,l){this._remoteAddress=C,this._log("The client has reconnected.");const a=f._toConnectionData(h,l);if(a.socket.pause(),!this._extensionHostProcess){this._connectionData=a;return}this._sendSocketToExtensionHost(this._extensionHostProcess,a)}_cleanResources(){this._disposed||(this._disposed=!0,this._connectionData&&(this._connectionData.socket.end(),this._connectionData=null),this._extensionHostProcess&&(this._extensionHostProcess.kill(),this._extensionHostProcess=null),this._onClose.fire(void 0))}async start(C){try{let h=[];C.port&&!process.pkg&&(h=[`--inspect${C.break?"-brk":""}=0.0.0.0:${C.port}`]);const a={env:await d(C.env,C.language,!!C.debugId,this._environmentService,this._logService),execArgv:h,silent:!0},t=["--type=extensionHost",`--uriTransformerPath=${p.uriTransformerPath}`],i=this._environmentService.args["use-host-proxy"];i!==void 0&&t.push(`--useHostProxy=${i}`),this._extensionHostProcess=E.fork(D.FileAccess.asFileUri("bootstrap-fork",x).fsPath,t,a);const n=this._extensionHostProcess.pid;this._log(`<${n}> Launched Extension Host Process.`),this._extensionHostProcess.stdout.setEncoding("utf8"),this._extensionHostProcess.stderr.setEncoding("utf8");const s=m.Event.fromNodeEventEmitter(this._extensionHostProcess.stdout,"data"),u=m.Event.fromNodeEventEmitter(this._extensionHostProcess.stderr,"data");s(v=>console.log("EXTHOST-STDOUT::::::::"+v)),u(v=>console.log("EXTHOST-STDERR::::::::"+v)),this._extensionHostProcess.on("message",v=>{v&&v.type==="__$console"&&(console.log("EXTHOST-LOG:::::"),console.log(v.arguments))}),this._extensionHostProcess.on("error",v=>{this._logError(`<${n}> Extension Host Process had an error`),this._logService.error(v),this._cleanResources()}),this._extensionHostProcess.on("exit",(v,T)=>{this._log(`<${n}> Extension Host Process exited with code: ${v}, signal: ${T}.`),this._cleanResources()});const g=v=>{v.type==="VSCODE_EXTHOST_IPC_READY"&&(this._extensionHostProcess.removeListener("message",g),this._sendSocketToExtensionHost(this._extensionHostProcess,this._connectionData),this._connectionData=null)};this._extensionHostProcess.on("message",g)}catch(h){console.error("ExtensionHostConnection errored"),h&&console.error(h)}}}e.ExtensionHostConnection=f;function c(w,C,h){const l=Object.keys(w).filter(t=>t.toLowerCase()===C.toLowerCase()),a=l.length>0?l[0]:C;w[a]=h}function S(w){for(let C of Object.keys(w))w[C]===null&&delete w[C]}}),define(le[231],ce([0,1,60,16,58,96,32,64,108,66,39,33,98,107,90,31,2,95,63,8,20,45,93,106,67,87,61,91,12,4,3,23]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w,C,h,l,a,t,i,n,s,u,g,v,T,R,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.run=void 0;class F extends S.Disposable{constructor(Se,oe){super();this.args=Se,this.remoteDataFolder=oe,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){await(await this.initServices()).invokeFunction(async oe=>{const q=oe.get(P.ILogService),ee=oe.get(k.IExtensionManagementCLIService);try{await this.doRun(ee)}catch(G){throw q.error(G),console.error(v.getErrorMessage(G)),G}})}async initServices(){const Se=new E.ServiceCollection,oe=Object.assign({_serviceBrand:void 0},c.default);Se.set(a.IProductService,oe);const q=new n.ServerEnvironmentService(this.args,oe);Se.set(n.IServerEnvironmentService,q);const ee=new P.LogService(new t.SpdLogLogger(i.RemoteExtensionLogFileName,R.join(q.logsPath,`${i.RemoteExtensionLogFileName}.log`),!0,P.getLogLevel(q)));Se.set(P.ILogService,ee),ee.trace(`Remote configuration data at ${this.remoteDataFolder}`),ee.trace("process arguments:",this.args);const G=this._register(new w.FileService(ee));Se.set(l.IFileService,G),G.registerProvider(h.Schemas.file,this._register(new C.DiskFileSystemProvider(ee)));const z=this._register(new D.ConfigurationService(q.settingsResource,G));return await z.initialize(),Se.set(I.IConfigurationService,z),Se.set(_.IRequestService,new p.SyncDescriptor(m.RequestService)),Se.set(r.ITelemetryService,y.NullTelemetryService),Se.set(k.IExtensionGalleryService,new p.SyncDescriptor(d.ExtensionGalleryService)),Se.set(k.IExtensionManagementService,new p.SyncDescriptor(b.ExtensionManagementService)),Se.set(k.IExtensionManagementCLIService,new p.SyncDescriptor(s.ExtensionManagementCLIService)),Se.set(u.ILocalizationsService,new p.SyncDescriptor(g.LocalizationsService)),new f.InstantiationService(Se)}async doRun(Se){if(this.args["list-extensions"])return Se.listExtensions(!!this.args["show-versions"],this.args.category);if(this.args["install-extension"]||this.args["install-builtin-extension"])return Se.installExtensions(this.asExtensionIdOrVSIX(this.args["install-extension"]||[]),this.args["install-builtin-extension"]||[],!!this.args["do-not-sync"],!!this.args.force);if(this.args["uninstall-extension"])return Se.uninstallExtensions(this.asExtensionIdOrVSIX(this.args["uninstall-extension"]),!!this.args.force);if(this.args["locate-extension"])return Se.locateExtension(this.args["locate-extension"])}asExtensionIdOrVSIX(Se){return Se.map(oe=>/\.vsix$/i.test(oe)?T.URI.file(R.isAbsolute(oe)?oe:R.join(o.cwd(),oe)):oe)}}function B(ie){setTimeout(()=>process.exit(ie),0)}async function Z(ie,Se){const oe=new F(ie,Se);try{await oe.run(),B(0)}catch(q){B(1)}finally{oe.dispose()}}e.run=Z}),define(le[232],ce([0,1,50,243,25,224,4,206,16]),function(x,e,E,P,p,D,I,_,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CLIServer=e.CLIServerBase=void 0;class y{constructor(d,b,f){this._commands=d,this.logService=b,this._ipcHandlePath=f,this._server=P.createServer((c,S)=>this.onRequest(c,S)),this.setup().catch(c=>(b.error(c),""))}get ipcHandlePath(){return this._ipcHandlePath}async setup(){try{this._server.listen(this.ipcHandlePath),this._server.on("error",d=>this.logService.error(d))}catch(d){this.logService.error("Could not start open from terminal server.")}return this._ipcHandlePath}onRequest(d,b){const f=[];d.setEncoding("utf8"),d.on("data",c=>f.push(c)),d.on("end",()=>{const c=JSON.parse(f.join(""));switch(c.type){case"open":this.open(c,b);break;case"openExternal":this.openExternal(c,b);break;case"status":this.getStatus(c,b);break;case"extensionManagement":this.manageExtensions(c,b).catch(this.logService.error);break;default:b.writeHead(404),b.write(`Unknown message type: ${c.type}`,S=>{S&&this.logService.error(S)}),b.end();break}})}open(d,b){let{fileURIs:f,folderURIs:c,forceNewWindow:S,diffMode:w,addMode:C,forceReuseWindow:h,gotoLineMode:l,waitMarkerFilePath:a}=d;const t=[];if(Array.isArray(c))for(const i of c)try{t.push({folderUri:I.URI.parse(i)})}catch(n){}if(Array.isArray(f))for(const i of f)try{_.hasWorkspaceFileExtension(i)?t.push({workspaceUri:I.URI.parse(i)}):t.push({fileUri:I.URI.parse(i)})}catch(n){}if(t.length){const i=a?I.URI.file(a):void 0,s={forceNewWindow:S,diffMode:w,addMode:C,gotoLineMode:l,forceReuseWindow:h,preferNewWindow:!h&&!i&&!C,waitMarkerFileURI:i};this._commands.executeCommand("_remoteCLI.windowOpen",t,s)}b.writeHead(200),b.end()}async openExternal(d,b){for(const f of d.uris){const c=I.URI.parse(f),S=c.scheme==="file"?c:f;await this._commands.executeCommand("_remoteCLI.openExternal",S)}b.writeHead(200),b.end()}async manageExtensions(d,b){try{const f=w=>w==null?void 0:w.map(C=>/\.vsix$/i.test(C)?I.URI.parse(C):C),c={list:d.list,install:f(d.install),uninstall:f(d.uninstall),force:d.force},S=await this._commands.executeCommand("_remoteCLI.manageExtensions",c);b.writeHead(200),b.write(S)}catch(f){b.writeHead(500),b.write(String(f),c=>{c&&this.logService.error(c)})}b.end()}async getStatus(d,b){try{const f=await this._commands.executeCommand("_remoteCLI.getSystemStatus");b.writeHead(200),b.write(f),b.end()}catch(f){b.writeHead(500),b.write(String(f),c=>{c&&this.logService.error(c)}),b.end()}}dispose(){this._server.close(),this._ipcHandlePath&&process.platform!=="win32"&&p.existsSync(this._ipcHandlePath)&&p.unlinkSync(this._ipcHandlePath)}}e.CLIServerBase=y;let r=class extends y{constructor(d,b){super(d,b,E.createRandomIPCHandle())}};r=Ne([Ke(0,D.IExtHostCommands),Ke(1,m.ILogService)],r),e.CLIServer=r}),define(le[233],ce([0,1,24,7,19,2,3,5,4,50,31,40,232,213,105,214,217,109]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteTerminalChannel=void 0;class C extends S.AbstractVariableResolverService{constructor(a,t,i,n){super({getFolderUri:s=>{const u=t.filter(g=>g.name===s);if(u&&u.length>0)return u[0].uri},getWorkspaceFolderCount:()=>t.length,getConfigurationValue:(s,u)=>n[`config:${u}`],getExecPath:()=>a.VSCODE_EXEC_PATH,getAppRoot:()=>a.VSCODE_CWD,getFilePath:()=>{if(i)return I.normalize(i.fsPath)},getSelectedText:()=>n.selectedText,getLineNumber:()=>n.lineNumber},void 0,Promise.resolve(a))}}class h extends D.Disposable{constructor(a,t,i){super();this._environmentService=a,this._logService=t,this._ptyService=i,this._lastReqId=0,this._pendingCommands=new Map,this._onExecuteCommand=this._register(new P.Emitter),this.onExecuteCommand=this._onExecuteCommand.event}async call(a,t,i){var n,s;switch(t){case"$restartPtyHost":return(n=this._ptyService.restartPtyHost)===null||n===void 0?void 0:n.apply(this._ptyService,i);case"$createProcess":{const u=k.createRemoteURITransformer(a.remoteAuthority);return this._createProcess(u,i)}case"$attachToProcess":return this._ptyService.attachToProcess.apply(this._ptyService,i);case"$listProcesses":return this._ptyService.listProcesses.apply(this._ptyService,i);case"$orphanQuestionReply":return this._ptyService.orphanQuestionReply.apply(this._ptyService,i);case"$acceptPtyHostResolvedVariables":return(s=this._ptyService.acceptPtyHostResolvedVariables)===null||s===void 0?void 0:s.apply(this._ptyService,i);case"$start":return this._ptyService.start.apply(this._ptyService,i);case"$input":return this._ptyService.input.apply(this._ptyService,i);case"$acknowledgeDataEvent":return this._ptyService.acknowledgeDataEvent.apply(this._ptyService,i);case"$shutdown":return this._ptyService.shutdown.apply(this._ptyService,i);case"$resize":return this._ptyService.resize.apply(this._ptyService,i);case"$getInitialCwd":return this._ptyService.getInitialCwd.apply(this._ptyService,i);case"$getCwd":return this._ptyService.getCwd.apply(this._ptyService,i);case"$processBinary":return this._ptyService.processBinary.apply(this._ptyService,i);case"$sendCommandResult":return this._sendCommandResult(i[0],i[1],i[2]);case"$getDefaultSystemShell":return this._getDefaultSystemShell.apply(this,i);case"$getProfiles":return this._getProfiles.apply(this,i);case"$getEnvironment":return this._getEnvironment();case"$getWslPath":return this._getWslPath(i[0]);case"$getTerminalLayoutInfo":return this._getTerminalLayoutInfo(i);case"$setTerminalLayoutInfo":return this._setTerminalLayoutInfo(i);case"$reduceConnectionGraceTime":return this._reduceConnectionGraceTime();case"$updateIcon":return this._ptyService.updateIcon.apply(this._ptyService,i);case"$updateTitle":return this._ptyService.updateTitle.apply(this._ptyService,i)}throw new Error(`IPC Command ${t} not found`)}listen(a,t,i){switch(t){case"$onPtyHostExitEvent":return this._ptyService.onPtyHostExit||P.Event.None;case"$onPtyHostStartEvent":return this._ptyService.onPtyHostStart||P.Event.None;case"$onPtyHostUnresponsiveEvent":return this._ptyService.onPtyHostUnresponsive||P.Event.None;case"$onPtyHostResponsiveEvent":return this._ptyService.onPtyHostResponsive||P.Event.None;case"$onPtyHostRequestResolveVariablesEvent":return this._ptyService.onPtyHostRequestResolveVariables||P.Event.None;case"$onProcessDataEvent":return this._ptyService.onProcessData;case"$onProcessExitEvent":return this._ptyService.onProcessExit;case"$onProcessReadyEvent":return this._ptyService.onProcessReady;case"$onProcessReplayEvent":return this._ptyService.onProcessReplay;case"$onProcessTitleChangedEvent":return this._ptyService.onProcessTitleChanged;case"$onProcessShellTypeChangedEvent":return this._ptyService.onProcessShellTypeChanged;case"$onProcessOverrideDimensionsEvent":return this._ptyService.onProcessOverrideDimensions;case"$onProcessResolvedShellLaunchConfigEvent":return this._ptyService.onProcessResolvedShellLaunchConfig;case"$onProcessOrphanQuestion":return this._ptyService.onProcessOrphanQuestion;case"$onExecuteCommand":return this.onExecuteCommand;default:break}throw new Error("Not supported")}async _createProcess(a,t){const i={name:t.shellLaunchConfig.name,executable:t.shellLaunchConfig.executable,args:t.shellLaunchConfig.args,cwd:typeof t.shellLaunchConfig.cwd=="string"||typeof t.shellLaunchConfig.cwd=="undefined"?t.shellLaunchConfig.cwd:m.URI.revive(a.transformIncoming(t.shellLaunchConfig.cwd)),env:t.shellLaunchConfig.env,useShellEnvironment:t.shellLaunchConfig.useShellEnvironment};let n;t.shellLaunchConfig.useShellEnvironment?(this._logService.info("*"),n=await w.buildUserEnvironment(t.resolverEnv,_.language,!1,this._environmentService,this._logService)):n=this._getEnvironment(),this._logService.info("baseEnv",n);const s=ee=>({uri:m.URI.revive(a.transformIncoming(ee.uri)),name:ee.name,index:ee.index,toResource:()=>{throw new Error("Not implemented")}}),u=t.workspaceFolders.map(s),g=t.activeWorkspaceFolder?s(t.activeWorkspaceFolder):void 0,v=t.activeFileResource?m.URI.revive(a.transformIncoming(t.activeFileResource)):void 0,T=new C(n,u,v,t.resolvedVariables),R=c.createVariableResolver(g,process.env,T),o=c.getCwd(i,E.homedir(),R,g==null?void 0:g.uri,t.configuration["terminal.integrated.cwd"],this._logService);i.cwd=o;const F=_.isWindows?"terminal.integrated.env.windows":_.isMacintosh?"terminal.integrated.env.osx":"terminal.integrated.env.linux",B=t.configuration[F],Z=c.createTerminalEnvironment(i,B,R,r.default.version,t.configuration["terminal.integrated.detectLocale"],n);if(!i.strictEnv){const ee=[];for(const[L,A]of t.envVariableCollections)ee.push([L,{map:f.deserializeEnvironmentVariableCollection(A)}]);const G=new Map(ee);new b.MergedEnvironmentVariableCollection(G).applyToProcessEnvironment(Z)}this._logService.debug("Terminal process launching on remote agent",{shellLaunchConfig:i,initialCwd:o,cols:t.cols,rows:t.rows,env:Z});const ie=y.createRandomIPCHandle();Z.VSCODE_IPC_HOOK_CLI=ie;const Se={executeCommand:(ee,...G)=>this._executeCommand(ee,G,a)},oe=new d.CLIServerBase(Se,this._logService,ie),q=await this._ptyService.createProcess(i,o,t.cols,t.rows,Z,n,!1,t.shouldPersistTerminal,t.workspaceId,t.workspaceName);return this._ptyService.onProcessExit(ee=>ee.id===q&&oe.dispose()),{persistentTerminalId:q,resolvedShellLaunchConfig:i}}_executeCommand(a,t,i){let n,s;const u=new Promise((T,R)=>{n=T,s=R}),g=++this._lastReqId;this._pendingCommands.set(g,{resolve:n,reject:s,uriTransformer:i});const v=p.cloneAndChange(t,T=>{if(T&&T.$mid===1)return i.transformOutgoing(T);if(T&&T instanceof m.URI)return i.transformOutgoingURI(T)});return this._onExecuteCommand.fire({reqId:g,commandId:a,commandArgs:v}),u}_sendCommandResult(a,t,i){const n=this._pendingCommands.get(a);if(!n)return;this._pendingCommands.delete(a);const s=p.cloneAndChange(i,u=>{if(u&&u.$mid===1)return n.uriTransformer.transformIncoming(u)});t?n.reject(s):n.resolve(s)}_getDefaultSystemShell(a){return this._ptyService.getDefaultSystemShell(a)}async _getProfiles(a,t,i){var n,s;return((s=(n=this._ptyService).getProfiles)===null||s===void 0?void 0:s.call(n,a,t,i))||[]}_getEnvironment(){return Object.assign({},process.env)}_getWslPath(a){return this._ptyService.getWslPath(a)}_setTerminalLayoutInfo(a){this._ptyService.setTerminalLayoutInfo(a)}async _getTerminalLayoutInfo(a){return this._ptyService.getTerminalLayoutInfo(a)}_reduceConnectionGraceTime(){return this._ptyService.reduceConnectionGraceTime()}}e.RemoteTerminalChannel=h}),define(le[234],ce([0,1,62,25,80,65,24,48,235,18,2,22,15,125,5,83,50,109,207,40,16,8,31,27,60,58,96,32,64,108,66,39,33,98,107,90,86,162,61,91,199,198,195,79,95,63,20,45,36,7,226,208,227,191,167,200,161,92,209,4,30,67,3,220,233,110,106,87,93,99,205]),function(x,e,E,P,p,D,I,_,m,y,r,k,d,b,f,c,S,w,C,h,l,a,t,i,n,s,u,g,v,T,R,o,F,B,Z,ie,Se,oe,q,ee,G,z,L,A,N,M,W,X,ae,se,be,ke,Te,Le,je,Xe,Ze,it,Ye,ge,Ie,_e,Re,Me,ze,He,xe,tt,te,ve,de){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.RemoteExtensionHostAgentServer=void 0;const Ue=5*60*1e3,he=`

*
* Visual Studio Code Server
*
* Reminder: You may only use this software with Visual Studio family products,
* as described in the license https://aka.ms/vscode-remote/license
*

`,me="monacoworkbench";class fe extends ae.IPCServer{constructor(){const ne=new se.Emitter;super(ne.event);this._onDidConnectEmitter=ne}acceptConnection(ne,De){this._onDidConnectEmitter.fire({protocol:ne,onDidClientDisconnect:De})}}function V(Ce){return Ce<10?`0${Ce}`:String(Ce)}function Q(){const Ce=new Date;return`${V(Ce.getHours())}:${V(Ce.getMinutes())}:${V(Ce.getSeconds())}`}class U extends l.AbstractLogger{constructor(ne=l.DEFAULT_LOG_LEVEL){super();this.setLevel(ne),this.useColors=Boolean(process.stdout.isTTY)}trace(ne,...De){this.getLevel()<=l.LogLevel.Trace&&(this.useColors?console.log(`[90m[${Q()}][0m`,ne,...De):console.log(`[${Q()}]`,ne,...De))}debug(ne,...De){this.getLevel()<=l.LogLevel.Debug&&(this.useColors?console.log(`[90m[${Q()}][0m`,ne,...De):console.log(`[${Q()}]`,ne,...De))}info(ne,...De){this.getLevel()<=l.LogLevel.Info&&(this.useColors?console.log(`[90m[${Q()}][0m`,ne,...De):console.log(`[${Q()}]`,ne,...De))}warn(ne,...De){this.getLevel()<=l.LogLevel.Warning&&(this.useColors?console.warn(`[93m[${Q()}][0m`,ne,...De):console.warn(`[${Q()}]`,ne,...De))}error(ne,...De){this.getLevel()<=l.LogLevel.Error&&(this.useColors?console.error(`[91m[${Q()}][0m`,ne,...De):console.error(`[${Q()}]`,ne,...De))}critical(ne,...De){this.getLevel()<=l.LogLevel.Critical&&(this.useColors?console.error(`[90m[${Q()}][0m`,ne,...De):console.error(`[${Q()}]`,ne,...De))}dispose(){}flush(){}}class H extends r.Disposable{constructor(ne,De,Ae,Fe,Oe,Ge){super();this._environmentService=ne,this._productService=De,this._connectionToken=Ae,this._connectionTokenIsMandatory=Fe;const re=Ee(this._environmentService);re.trace(`Remote configuration data at ${Ge}`),re.trace("process arguments:",this._environmentService.args),re.info(he),this._logService=new l.MultiplexLogService([new U(l.getLogLevel(this._environmentService)),re]),this._socketServer=new fe,this._uriTransformerCache=Object.create(null),this._extHostConnections=Object.create(null),this._managementConnections=Object.create(null),Oe?this._webClientServer=new Ye.WebClientServer(this._connectionToken,this._environmentService,this._logService):this._webClientServer=null,this._logService.info("Extension host agent started.")}async initialize(){const ne=await this._createServices();return setTimeout(()=>this._cleanupOlderLogs(this._environmentService.logsPath).then(null,De=>this._logService.error(De)),1e4),ne}async _createServices(){const ne=new n.ServiceCollection;this._socketServer.registerChannel(Ze.ExtensionHostDebugBroadcastChannel.ChannelName,new Ze.ExtensionHostDebugBroadcastChannel);const De=new ae.StaticRouter(J=>J.clientId==="renderer");this._socketServer.registerChannel("logger",new it.LogLevelChannel(this._logService)),ne.set(i.IEnvironmentService,this._environmentService),ne.set(i.INativeEnvironmentService,this._environmentService),ne.set(l.ILogService,this._logService),ne.set(X.IProductService,this._productService);const Ae=this._register(new N.FileService(this._logService));ne.set(W.IFileService,Ae),Ae.registerProvider(a.Schemas.file,this._register(new M.DiskFileSystemProvider(this._logService))),ne.set(g.IConfigurationService,new s.SyncDescriptor(u.ConfigurationService,[this._environmentService.machineSettingsResource,Ae])),ne.set(v.IRequestService,new s.SyncDescriptor(T.RequestService));let Fe=R.NullAppender;if(!this._environmentService.args["disable-telemetry"]&&t.default.enableTelemetry){t.default.aiConfig&&t.default.aiConfig.asimovKey&&(Fe=new G.AppInsightsAppender(me,null,t.default.aiConfig.asimovKey),this._register(r.toDisposable(()=>Fe.flush())));const J=await A.getMachineId(),$={appender:Fe,commonProperties:L.resolveCommonProperties(Ae,I.release(),I.hostname(),process.arch,t.default.commit,t.default.version+"-remote",J,t.default.msftInternalDomains,this._environmentService.installSourcePath,"remoteAgent"),piiPaths:[this._environmentService.appRoot]};ne.set(o.ITelemetryService,new s.SyncDescriptor(z.TelemetryService,[$]))}else ne.set(o.ITelemetryService,R.NullTelemetryService);ne.set(F.IExtensionGalleryService,new s.SyncDescriptor(B.ExtensionGalleryService));const Oe=this._socketServer.getChannel("download",De);ne.set(Se.IDownloadService,new oe.DownloadServiceChannelClient(Oe,()=>this._getUriTransformer("renderer"))),ne.set(F.IExtensionManagementService,new s.SyncDescriptor(Z.ExtensionManagementService));const Ge=new ie.InstantiationService(ne);ne.set(q.ILocalizationsService,Ge.createInstance(ee.LocalizationsService));const re=Ge.createInstance(tt.ExtensionManagementCLIService);ne.set(F.IExtensionManagementCLIService,re);const ue=Ge.createInstance(de.PtyHostService,{GraceTime:108e5,ShortGraceTime:3e5});return ne.set(ve.IPtyService,ue),Ge.invokeFunction(J=>{const $=new be.RemoteAgentEnvironmentChannel(this._connectionToken,this._environmentService,re,this._logService,J.get(o.ITelemetryService),Fe);this._socketServer.registerChannel("remoteextensionsenvironment",$),this._socketServer.registerChannel(Me.REMOTE_TERMINAL_CHANNEL_NAME,new ze.RemoteTerminalChannel(this._environmentService,this._logService,ue));const Pe=new ke.RemoteAgentFileSystemChannel(this._logService,this._environmentService);this._socketServer.registerChannel(Te.REMOTE_FILE_SYSTEM_CHANNEL_NAME,Pe),this._socketServer.registerChannel("request",new Le.RequestChannel(J.get(v.IRequestService)));const ye=J.get(F.IExtensionManagementService),$e=new je.ExtensionManagementChannel(ye,We=>this._getUriTransformer(We.remoteAuthority));return this._socketServer.registerChannel("extensions",$e),ye.removeDeprecatedExtensions(),this._register(new Xe.default(J.get(o.ITelemetryService))),{telemetryService:J.get(o.ITelemetryService)}})}_getUriTransformer(ne){return this._uriTransformerCache[ne]||(this._uriTransformerCache[ne]=h.createRemoteURITransformer(ne)),this._uriTransformerCache[ne]}async handleRequest(ne,De){if(ne.method!=="GET")return Ye.serveError(ne,De,405,`Unsupported method ${ne.method}`);if(!ne.url)return Ye.serveError(ne,De,400,"Bad request.");const Ae=D.parse(ne.url,!0),Fe=Ae.pathname;if(!Fe)return Ye.serveError(ne,De,400,"Bad request.");if(Fe==="/version")return De.writeHead(200,{"Content-Type":"text/plain"}),De.end(t.default.commit||"");if(Fe==="/delay-shutdown")return this._delayShutdown(),De.writeHead(200),De.end("OK");if(Fe==="/vscode-remote-resource"){if(Ae.query.tkn!==this._connectionToken)return Ye.serveError(ne,De,403,"Forbidden.");const Oe=Ae.query.path;if(typeof Oe!="string")return Ye.serveError(ne,De,400,"Bad request.");let Ge;try{Ge=ge.URI.from({scheme:a.Schemas.file,path:Oe}).fsPath}catch(ue){return Ye.serveError(ne,De,400,"Bad request.")}const re=Object.create(null);return this._environmentService.isBuilt&&(Ie.isEqualOrParent(Ge,this._environmentService.builtinExtensionsPath,!f.isLinux)||Ie.isEqualOrParent(Ge,this._environmentService.extensionsPath,!f.isLinux))&&(re["Cache-Control"]="public, max-age=31536000"),Ye.serveFile(this._logService,ne,De,Ge,re)}if(this._webClientServer){this._webClientServer.handle(ne,De,Ae);return}return De.writeHead(404,{"Content-Type":"text/plain"}),De.end("Not found")}handleUpgrade(ne,De){let Ae=k.generateUuid(),Fe=!1,Oe=!1;if(ne.url){const Pe=D.parse(ne.url,!0).query;typeof Pe.reconnectionToken=="string"&&(Ae=Pe.reconnectionToken),Pe.reconnection==="true"&&(Fe=!0),Pe.skipWebSocketFrames==="true"&&(Oe=!0)}if(ne.headers.upgrade!=="websocket"){De.end("HTTP/1.1 400 Bad Request");return}const Ge=ne.headers["sec-websocket-key"],re=E.createHash("sha1");re.update(Ge+"258EAFA5-E914-47DA-95CA-C5AB0DC85B11");const ue=re.digest("base64"),J=["HTTP/1.1 101 Switching Protocols","Upgrade: websocket","Connection: Upgrade",`Sec-WebSocket-Accept: ${ue}`];let $=!1;if(!Oe&&ne.headers["sec-websocket-extensions"]){const Pe=Array.isArray(ne.headers["sec-websocket-extensions"])?ne.headers["sec-websocket-extensions"]:[ne.headers["sec-websocket-extensions"]];for(const ye of Pe)if(!/\b((server_max_window_bits)|(server_no_context_takeover)|(client_no_context_takeover))\b/.test(ye)){if(/\b(permessage-deflate)\b/.test(ye)){$=!0,J.push("Sec-WebSocket-Extensions: permessage-deflate");break}if(/\b(x-webkit-deflate-frame)\b/.test(ye)){$=!0,J.push("Sec-WebSocket-Extensions: x-webkit-deflate-frame");break}}}De.write(J.join(`\r
`)+`\r
\r
`),De.setTimeout(0),Oe?this._handleWebSocketConnection(new S.NodeSocket(De),Fe,Ae):this._handleWebSocketConnection(new S.WebSocketNodeSocket(new S.NodeSocket(De),$,null,!0),Fe,Ae)}handleServerError(ne){this._logService.error("Error occurred in server"),this._logService.error(ne)}async _cleanupOlderLogs(ne){const De=Re.basename(ne),Ae=Re.dirname(ne),Ge=(await d.readdir(Ae)).filter(ue=>/^\d{8}T\d{6}$/.test(ue)).sort().filter(ue=>ue!==De),re=Ge.slice(0,Math.max(0,Ge.length-9));await Promise.all(re.map(ue=>d.rimraf(Re.join(Ae,ue))))}_getRemoteAddress(ne){let De;return ne instanceof S.NodeSocket?De=ne.socket:De=ne.socket.socket,De.remoteAddress||"<unknown>"}async _rejectWebSocketConnection(ne,De,Ae){const Fe=De.getSocket();this._logService.error(`${ne} ${Ae}.`);const Oe={type:"error",reason:Ae};De.sendControl(y.VSBuffer.fromString(JSON.stringify(Oe))),De.dispose(),await Fe.drain(),Fe.dispose()}_handleWebSocketConnection(ne,De,Ae){const Fe=this._getRemoteAddress(ne),Oe=`[${Fe}][${Ae.substr(0,8)}]`,Ge=new c.PersistentProtocol(ne);let re;try{const ye=x.__$__nodeRequire("vsda");re=new ye.validator}catch(ye){}let ue;(function(ye){ye[ye.WaitingForAuth=0]="WaitingForAuth",ye[ye.WaitingForConnectionType=1]="WaitingForConnectionType",ye[ye.Done=2]="Done",ye[ye.Error=3]="Error"})(ue||(ue={}));let J=0;const $=ye=>{J=3,Pe.dispose(),this._rejectWebSocketConnection(Oe,Ge,ye)},Pe=Ge.onControlMessage(ye=>{if(J===0){let $e;try{$e=JSON.parse(ye.toString())}catch(Je){return $("Malformed first message")}if($e.type!=="auth")return $("Invalid first message");if(this._connectionTokenIsMandatory&&$e.auth!==this._connectionToken)return $("Unauthorized client refused: auth mismatch");let We="VS Code Headless is cool";if(re)try{We=re.createNewMessage(We)}catch(Je){}const et={type:"sign",data:We};Ge.sendControl(y.VSBuffer.fromString(JSON.stringify(et))),J=1}else if(J===1){let $e;try{$e=JSON.parse(ye.toString())}catch(Ve){return $("Malformed second message")}if($e.type!=="connectionType")return $("Invalid second message");if(typeof $e.signedData!="string")return $("Invalid second message field type");const We=$e.commit,et=t.default.commit;if(We&&et&&We!==et)return $("Client refused: version mismatch");let Je=!1;if($e.signedData===this._connectionToken)Je=!0;else if(re)try{Je=re.validate($e.signedData)==="ok"}catch(Ve){}if(!Je){if(this._environmentService.isBuilt)return $("Unauthorized client refused");this._logService.error(`${Oe} Unauthorized client handshake failed but we proceed because of dev mode.`)}for(let Ve in this._managementConnections)this._managementConnections[Ve].shortenReconnectionGraceTimeIfNecessary();for(let Ve in this._extHostConnections)this._extHostConnections[Ve].shortenReconnectionGraceTimeIfNecessary();J=2,Pe.dispose(),this._handleConnectionType(Fe,Oe,Ge,ne,De,Ae,$e)}})}async _handleConnectionType(ne,De,Ae,Fe,Oe,Ge,re){const ue=re.desiredConnectionType===1?`${De}[ManagementConnection]`:re.desiredConnectionType===2?`${De}[ExtensionHostConnection]`:De;if(re.desiredConnectionType===1)if(Oe){if(!this._managementConnections[Ge])return this._rejectWebSocketConnection(ue,Ae,"Unknown reconnection token");Ae.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const J=Ae.readEntireBuffer();Ae.dispose(),this._managementConnections[Ge].acceptReconnection(ne,Fe,J)}else{if(this._managementConnections[Ge])return this._rejectWebSocketConnection(ue,Ae,"Duplicate reconnection token");Ae.sendControl(y.VSBuffer.fromString(JSON.stringify({type:"ok"})));const J=new C.ManagementConnection(this._logService,Ge,ne,Ae);this._socketServer.acceptConnection(J.protocol,J.onClose),this._managementConnections[Ge]=J,J.onClose(()=>{delete this._managementConnections[Ge]})}else if(re.desiredConnectionType===2){const J=re.args||{language:"en"},$=await this._updateWithFreeDebugPort(J);if($.port&&this._logService.trace(`${ue} - startParams debug port ${$.port}`),this._logService.trace(`${ue} - startParams language: ${$.language}`),this._logService.trace(`${ue} - startParams env: ${JSON.stringify($.env)}`),Oe){if(!this._extHostConnections[Ge])return this._rejectWebSocketConnection(ue,Ae,"Unknown reconnection token");Ae.sendControl(y.VSBuffer.fromString(JSON.stringify($.port?{debugPort:$.port}:{})));const Pe=Ae.readEntireBuffer();Ae.dispose(),this._extHostConnections[Ge].acceptReconnection(ne,Fe,Pe)}else{if(this._extHostConnections[Ge])return this._rejectWebSocketConnection(ue,Ae,"Duplicate reconnection token");Ae.sendControl(y.VSBuffer.fromString(JSON.stringify($.port?{debugPort:$.port}:{})));const Pe=Ae.readEntireBuffer();Ae.dispose();const ye=new w.ExtensionHostConnection(this._environmentService,this._logService,Ge,ne,Fe,Pe);this._extHostConnections[Ge]=ye,ye.onClose(()=>{delete this._extHostConnections[Ge],this._onDidCloseExtHostConnection()}),ye.start($)}}else if(re.desiredConnectionType===3){const J=re.args;this._createTunnel(Ae,J)}else return this._rejectWebSocketConnection(ue,Ae,"Unknown initial data received")}async _createTunnel(ne,De){const Ae=ne.getSocket().socket,Fe=ne.readEntireBuffer();ne.dispose(),Ae.pause();const Oe=await this._connectTunnelSocket(De.port);Fe.byteLength>0&&Oe.write(Fe.buffer),Oe.on("end",()=>Ae.end()),Oe.on("close",()=>Ae.end()),Oe.on("error",()=>Ae.destroy()),Ae.on("end",()=>Oe.end()),Ae.on("close",()=>Oe.end()),Ae.on("error",()=>Oe.destroy()),Oe.pipe(Ae),Ae.pipe(Oe)}_connectTunnelSocket(ne){return new Promise((De,Ae)=>{const Fe=p.createConnection({port:ne},()=>{Fe.removeListener("error",Ae),Fe.pause(),De(Fe)});Fe.once("error",Ae)})}_updateWithFreeDebugPort(ne){return typeof ne.port=="number"?b.findFreePort(ne.port,10,5e3).then(De=>(ne.port=De,ne)):(ne.debugId=void 0,ne.port=void 0,ne.break=void 0,Promise.resolve(ne))}async _onDidCloseExtHostConnection(){if(!this._environmentService.args["enable-remote-auto-shutdown"])return;this._cancelShutdown(),!!Object.keys(this._extHostConnections).length||(console.log("Last EH closed, waiting before shutting down"),this._logService.info("Last EH closed, waiting before shutting down"),this._waitThenShutdown())}_waitThenShutdown(){!this._environmentService.args["enable-remote-auto-shutdown"]||(this._environmentService.args["remote-auto-shutdown-without-delay"]?this._shutdown():this.shutdownTimer=setTimeout(()=>{this.shutdownTimer=void 0,this._shutdown()},Ue))}_shutdown(){if(!!Object.keys(this._extHostConnections).length){console.log("New EH opened, aborting shutdown"),this._logService.info("New EH opened, aborting shutdown");return}else console.log("Last EH closed, shutting down"),this._logService.info("Last EH closed, shutting down"),this.dispose(),process.exit(0)}_delayShutdown(){this.shutdownTimer&&(console.log("Got delay-shutdown request while in shutdown timeout, delaying"),this._logService.info("Got delay-shutdown request while in shutdown timeout, delaying"),this._cancelShutdown(),this._waitThenShutdown())}_cancelShutdown(){this.shutdownTimer&&(console.log("Cancelling previous shutdown timeout"),this._logService.info("Cancelling previous shutdown timeout"),clearTimeout(this.shutdownTimer),this.shutdownTimer=void 0)}}e.RemoteExtensionHostAgentServer=H;function Y(Ce){if(Ce["connection-secret"]){Ce.connectionToken&&(console.warn("Please do not use the argument connectionToken at the same time as connection-secret."),process.exit(1));let ne=P.readFileSync(Ce["connection-secret"]).toString();return ne=ne.replace(/\r?\n$/,""),/^[0-9A-Za-z\-]+$/.test(ne)||(console.warn(`The secret defined in ${Ce["connection-secret"]} does not adhere to the characters 0-9, a-z, A-Z or -.`),process.exit(1)),{connectionToken:ne,connectionTokenIsMandatory:!0}}else return{connectionToken:Ce.connectionToken||k.generateUuid(),connectionTokenIsMandatory:!1}}async function pe(Ce,ne,De){const Ae=Object.assign({_serviceBrand:void 0},t.default),Fe=new _e.ServerEnvironmentService(ne,Ae);if(process.platform==="win32"&&process.env.HOMEDRIVE&&process.env.HOMEPATH){const et=Re.join(process.env.HOMEDRIVE,"node_modules"),Je=Re.dirname(Re.join(process.env.HOMEDRIVE,process.env.HOMEPATH)),Ve=Re.join(Je,"node_modules");if(P.existsSync(et)||P.existsSync(Ve)){const rt=`

*
* !!!! Server terminated due to presence of CVE-2020-1416 !!!!
*
* Please remove the following directories and re-try
* ${et}
* ${Ve}
*
* For more information on the vulnerability https://cve.mitre.org/cgi-bin/cvename.cgi?name=CVE-2020-1416
*

`;Ee(Fe).warn(rt),console.warn(rt),process.exit(0)}}const{connectionToken:Oe,connectionTokenIsMandatory:Ge}=Y(ne),re=P.existsSync(a.FileAccess.asFileUri("vs/code/browser/workbench/workbench.html",x).fsPath);re&&Ce&&typeof Ce!="string"&&console.log(`Web UI available at http://localhost${Ce.port===80?"":`:${Ce.port}`}/?tkn=${Oe}`);const ue=new H(Fe,Ae,Oe,Ge,re,De),J=await ue.initialize(),{telemetryService:$}=J;_.mark("code/server/ready");const Pe=m.performance.now(),ye=global.vscodeServerStartTime,$e=global.vscodeServerListenTime,We=global.vscodeServerCodeLoadedTime;if($.publicLog2("serverStart",{startTime:ye,startedTime:$e,codeLoadedTime:We,readyTime:Pe}),ne["print-startup-performance"]){const et=He.LoaderStats.get();let Je="";Je+=`

### Load AMD-module
`,Je+=He.LoaderStats.toMarkdownTable(["Module","Duration"],et.amdLoad),Je+=`

### Load commonjs-module
`,Je+=He.LoaderStats.toMarkdownTable(["Module","Duration"],et.nodeRequire),Je+=`

### Invoke AMD-module factory
`,Je+=He.LoaderStats.toMarkdownTable(["Module","Duration"],et.amdInvoke),Je+=`

### Invoke commonjs-module
`,Je+=He.LoaderStats.toMarkdownTable(["Module","Duration"],et.nodeEval),Je+=`Start-up time: ${$e-ye}
`,Je+=`Code loading time: ${We-ye}
`,Je+=`Initialized time: ${Pe-ye}
`,Je+=`
`,console.log(Je)}return ue}e.createServer=pe;const Ee=function(){let Ce;return function(De){return Ce||(Ce=new l.LogService(new te.SpdLogLogger(xe.RemoteExtensionLogFileName,Re.join(De.logsPath,`${xe.RemoteExtensionLogFileName}.log`),!0,l.getLogLevel(De)))),Ce}}()}),define(le[244],ce([0,1,24,25,8,231,234,56,3,235,67,48]),function(x,e,E,P,p,D,I,_,m,y,r,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createServer=e.spawnCli=void 0,k.mark("code/server/codeLoaded"),global.vscodeServerCodeLoadedTime=y.performance.now();const d={onMultipleValues:(i,n)=>{console.error(`Option ${i} can only be defined once. Using value ${n}.`)},onUnknownOption:i=>{console.error(`Ignoring option ${i}: not supported for server.`)}},b=_.parseArgs(process.argv.slice(2),r.serverOptions,d),f=process.env.VSCODE_AGENT_FOLDER||m.join(E.homedir(),".vscode-remote"),c=m.join(f,"data"),S=m.join(c,"User"),w=m.join(S,"globalStorage"),C=m.join(c,"Machine");b["user-data-dir"]=c;const h=m.dirname(p.FileAccess.asFileUri("",x).fsPath),l=m.join(h,"extensions");b["builtin-extensions-dir"]=l,b["extensions-dir"]=b["extensions-dir"]||m.join(f,"extensions"),[f,b["extensions-dir"],c,S,C,w].forEach(i=>{try{P.existsSync(i)||P.mkdirSync(i)}catch(n){console.error(n)}});function a(){D.run(b,f)}e.spawnCli=a;function t(i){return I.createServer(i,b,f)}e.createServer=t})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/507ce72a4466fbb27b715c3722558bb15afa9f48/core/vs/server/remoteExtensionHostAgent.js.map
